(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     89410,       2339]
NotebookOptionsPosition[     73117,       2113]
NotebookOutlinePosition[     73507,       2130]
CellTagsIndexPosition[     73464,       2127]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Tensor Differential Operators", "Title",
 CellChangeTimes->{{3.657706933735057*^9, 3.657706952591447*^9}},
 TextAlignment->Center,ExpressionUUID->"f3a6fca7-7d0e-4a86-8265-aef7c2673e6c"],

Cell[CellGroupData[{

Cell[TextData[{
 "A Test Notebook\n",
 StyleBox["by Rolf Sulanke", "Text"]
}], "Chapter",
 CellChangeTimes->{{3.657706964495186*^9, 3.657707004398857*^9}},
 TextAlignment->Center,ExpressionUUID->"a8fcb921-ab92-48d9-9535-dd966253c9c5"],

Cell["\<\
This is a subnotebook of the notebook RGv3.nb. First load RGv3.nb and the \
needed Packages, then evaluate the initialization cells of RGv3.nb.
It is recommended to vary the parameters of the examples or to consider  new \
ones.\
\>", "Text",
 CellChangeTimes->{{3.657707087390325*^9, 3.657707221781746*^9}, {
   3.657707291501483*^9, 3.657707315845174*^9}, {3.657707359413041*^9, 
   3.657707374404682*^9}, {3.657707458052128*^9, 3.6577075025561457`*^9}, {
   3.70857602488842*^9, 3.708576051879575*^9}, {3.72528593610318*^9, 
   3.7252859553104763`*^9}, 3.725286005045644*^9, {3.725458165650158*^9, 
   3.7254581856497517`*^9}},ExpressionUUID->"1e799130-ae06-4f89-9cf9-\
f3959a2c9b14"],

Cell[CellGroupData[{

Cell["The Absolute Differential", "Section",
 CellChangeTimes->{{3.657705690231291*^9, 
  3.6577057023352013`*^9}},ExpressionUUID->"81d6a10c-c16d-4abb-a429-\
ba8a14a08dba"],

Cell[CellGroupData[{

Cell["The product rule, a Simple Case", "Subsubsection",
 CellChangeTimes->{{3.656513455320837*^9, 3.656513462816564*^9}, {
  3.657268547021241*^9, 
  3.6572685559249573`*^9}},ExpressionUUID->"d1bad5ca-fba8-45f0-a5d7-\
d0f6d0d8f051"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
  3.656343881485649*^9, 
  3.656344060278912*^9}},ExpressionUUID->"a5b27434-766f-43b1-a6da-\
25b9bfce99c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"2014edec-8cb7-4f39-be3d-\
8557cb969836"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 
  3.656396611524116*^9}},ExpressionUUID->"c9060884-c956-4fd5-b2ec-\
ba2918173556"],

Cell[BoxData[
 RowBox[{"vx", "=", 
  RowBox[{"vec", "[", "\[Xi]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6563441819913282`*^9, 3.656344255018395*^9}, {
  3.656402779185873*^9, 3.656402786313506*^9}, {3.7022044808249807`*^9, 
  3.702204487114913*^9}, {3.702204520519833*^9, 
  3.7022045286476603`*^9}},ExpressionUUID->"4a1e7197-d8c5-4f18-9f8c-\
f88559b6ebd5"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, 
   3.6572645882297373`*^9, 
   3.657267637365982*^9},ExpressionUUID->"6815f789-da58-4858-a5cc-\
87591b8f8a33"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], ")"}], 
   "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, 
   3.657264588230474*^9, 
   3.657267638974288*^9},ExpressionUUID->"6b60ed1d-bf42-484c-9e7c-\
8680a4e5c071"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, 
   3.657264588231209*^9, 
   3.657267641654131*^9},ExpressionUUID->"d8ef2f79-50ca-45bb-ac98-\
c9c5cbcf0a1a"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"b0261506-00fe-4620-9f2e-\
4fe3a4a53d10"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"809dab47-7f1c-4658-b70d-\
ff8cbe49fa56"],

Cell[BoxData[
 RowBox[{"dtc", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702204810071938*^9, 
  3.702204829100892*^9}},ExpressionUUID->"d32d6a59-b1ad-4735-836d-\
deb1ab094c0e"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 
  3.6564883909065437`*^9}},ExpressionUUID->"318f4393-4e01-448d-92ca-\
31e414b61a8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"th", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], " ", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ",", "0", ",", "2", ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.656409851247612*^9, 
  3.656409974154014*^9}},ExpressionUUID->"9fe2f2f9-9d3c-4421-af70-\
f01465842304"],

Cell[BoxData[
 RowBox[{
  RowBox[{"th", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656409990192245*^9, 
  3.6564100195936413`*^9}},ExpressionUUID->"e484a351-eac1-4eea-aec4-\
5169eced3921"],

Cell[BoxData[
 RowBox[{"dth", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656410044274021*^9, 3.656410052393404*^9}, {
   3.656410098298154*^9, 3.6564101080970097`*^9}, 3.657264588231941*^9, 
   3.65726764365377*^9},ExpressionUUID->"2f953755-75dc-4fee-a67a-\
59c784fd05c8"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"dth", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656410127171617*^9, 
  3.65641018145623*^9}},ExpressionUUID->"c8762378-6fb6-44a6-93a9-\
e15c942bdc75"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"absD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656410851069168*^9, 3.656410940634248*^9}, {
   3.656410983866839*^9, 3.6564109844258537`*^9}, 3.657264503398987*^9, 
   3.657267448967368*^9},ExpressionUUID->"17b09bfc-9c8c-405d-a357-\
85aea52d97c9"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "%%"}]], "Input",
 CellChangeTimes->{{3.656411003119673*^9, 
  3.656411006025104*^9}},ExpressionUUID->"a9e99ace-4474-44c3-8450-\
46c66ba1dd68"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488884534676*^9, 
  3.656488887078676*^9}},ExpressionUUID->"2557026c-ca74-47f7-abd3-\
508fbaa9f415"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule, Tensors of Higher Degree", "Subsubsection",
 CellChangeTimes->{{3.656513455320837*^9, 3.656513462816564*^9}, {
  3.657268547021241*^9, 3.6572685559249573`*^9}, {3.657268591229002*^9, 
  3.6572686529004307`*^9}},ExpressionUUID->"f04e0899-2261-4b77-b8b1-\
1521e61a37e3"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"ta", ",", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.657268670060849*^9, 
   3.6572687057723846`*^9}, 3.657270928587624*^9, {3.725342708601933*^9, 
   3.725342717177906*^9}, {3.7253429692948437`*^9, 
   3.725342987643935*^9}},ExpressionUUID->"142ef103-6a20-4da2-941a-\
628d6f53151c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "3"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "2", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "2", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.657268670060849*^9, 
   3.6572687057723846`*^9}, 3.657270928587624*^9, {3.725342708601933*^9, 
   3.725342717177906*^9}, 3.7253429692948437`*^9, 
   3.725343000239328*^9},ExpressionUUID->"474d550c-a3f6-4539-b24f-\
e4e69c21c261"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tb", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702205190841815*^9, 3.7022052311611967`*^9}, {
   3.7253427464733*^9, 3.725342758681559*^9}, 3.725342864243957*^9, {
   3.725342897056258*^9, 
   3.725342914920166*^9}},ExpressionUUID->"8b25ea1d-746a-4fd4-a16b-\
2d08cf7cbafe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"44797b5f-c7bc-4d30-ac04-\
05bd43cb4b42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 3.656396611524116*^9}, {3.657268729884376*^9, 
  3.657268733628224*^9}, {3.657270956490694*^9, 3.657270962258533*^9}, {
  3.725286444600821*^9, 3.725286456849697*^9}, {3.725286519767158*^9, 
  3.72528653222484*^9}},ExpressionUUID->"a8dc9006-ea40-4ceb-bb69-\
0b4155071a5a"],

Cell[BoxData[
 RowBox[{"vx", "=", 
  RowBox[{"vec", "[", "\[Xi]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6563441819913282`*^9, 3.656344255018395*^9}, {
  3.656402779185873*^9, 3.656402786313506*^9}, {3.702205379057104*^9, 
  3.702205407079815*^9}},ExpressionUUID->"79dee728-e320-4a2b-9dff-\
902868967365"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, 
   3.6572645882297373`*^9, 3.657267637365982*^9, {3.725343092422689*^9, 
   3.725343097091527*^9}},ExpressionUUID->"79a2381c-725e-4233-9e21-\
f1ea15204e70"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], ")"}], 
   "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, 
   3.657264588230474*^9, 
   3.657267638974288*^9},ExpressionUUID->"31725c44-7648-4c9b-9ee7-\
c404fb822270"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"tensorD", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, 
   3.657264588231209*^9, 
   3.657267641654131*^9},ExpressionUUID->"52b93c1b-305e-42e4-a0b9-\
571691529fd8"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"67eb5283-1630-470c-8cc8-\
ed778d7d6a81"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"dtc", ",", 
    RowBox[{"dta", " ", "+", "dtb"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}, {3.657270995298828*^9, 
  3.6572710031541433`*^9}},ExpressionUUID->"5253ae7d-81c7-42f1-b376-\
d86bee6fd3b8"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " v. 9.0.1 needed 518.292 s, v. 11.2 needed 898.684 s, to confirm the \
equivalence. \nChoose other parameters for further tests.\nOK!"
}], "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.657272028530201*^9, 3.6572721171214027`*^9}, 3.702206978202754*^9, {
   3.708576735179893*^9, 3.708576784107448*^9}, 3.708583692753265*^9, {
   3.725287780886318*^9, 3.7252878208059483`*^9}, 
   3.7253441503432293`*^9},ExpressionUUID->"60a85169-e2ca-4bb3-8aca-\
9f485253f55d"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Gradient Tensor", "Section",
 CellChangeTimes->{{3.656491371298958*^9, 3.656491381498766*^9}, {
  3.6577060545483913`*^9, 
  3.657706060524276*^9}},ExpressionUUID->"6b91c0f0-7d9a-4234-b76f-\
b0e84f0b1af7"],

Cell[CellGroupData[{

Cell["A simple example", "Subsubsection",
 CellChangeTimes->{{3.657706561409265*^9, 
  3.657706569672962*^9}},ExpressionUUID->"fabdc4a9-5db4-4ed1-babb-\
0ec51c76d67d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"th", "[", "x__", "]"}], " ", ":=", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"h", "[", "x", "]"}], ",", "0", ",", "2", ",", "2"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656409851247612*^9, 3.656409974154014*^9}, {
  3.6565129026476107`*^9, 3.6565129069665937`*^9}, {3.725344217606474*^9, 
  3.7253442896344767`*^9}},ExpressionUUID->"a8a1b072-b68f-438e-bdf8-\
a4e79c7a6cf3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"th", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.702207023665339*^9, 3.70220704364228*^9}, {
  3.72534430966136*^9, 3.725344318653213*^9}, {3.725344348925116*^9, 
  3.7253443679247313`*^9}},ExpressionUUID->"fa62b22d-bcdf-4226-aac9-\
23c26973f616"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nabla", "[", 
   RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
  RowBox[{"var", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6565131337678547`*^9, 3.656513156372128*^9}, 
   3.657706477578019*^9, {3.7085774564683037`*^9, 
   3.7085774590239058`*^9}},ExpressionUUID->"872e807a-25e3-415a-a9a7-\
9870a9cb956b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "th"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656512765396839*^9, 3.656512832935441*^9}, {
   3.656512867407143*^9, 3.656512881758539*^9}, 3.657706281706274*^9, {
   3.7085774019873953`*^9, 
   3.7085774061614656`*^9}},ExpressionUUID->"a1da00d6-3fe1-493a-b152-\
42b03bbfa220"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", 
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "1", ",", "1", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65649163067452*^9, 3.656491686816806*^9}, {
  3.72534444023645*^9, 
  3.725344477308112*^9}},ExpressionUUID->"6078e43e-5962-4157-aa2f-\
e2b324f0f826"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nabla", "[", 
   RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
  RowBox[{"var", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656491697937336*^9, 3.656491718632066*^9}, {
   3.656491759233148*^9, 3.656491788183885*^9}, 3.6577062858193808`*^9, 
   3.708577560333941*^9, 3.708577809174765*^9, 
   3.725344518908654*^9},ExpressionUUID->"89b69fb0-5cdb-4a47-ba97-\
6cd0628a5595"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7253445276725073`*^9, 
  3.7253445309831247`*^9}},ExpressionUUID->"9ca2f4b9-9348-4c17-9f35-\
70f416a94928"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 1", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, {3.7085781482731543`*^9, 
   3.708578150792781*^9}},ExpressionUUID->"1d386383-487d-41fd-98f5-\
5efe7bd0209a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "0", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{"ta", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
  3.656343881485649*^9, 3.656344060278912*^9}, {3.725336661399838*^9, 
  3.725336710302499*^9}, {3.725344752981386*^9, 
  3.725344759617708*^9}},ExpressionUUID->"138d6761-397e-4126-aff7-\
0d3b525d50cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"e3acb00e-7c92-4a6d-91ce-\
f79abd00f229"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344155876411*^9, 3.6563441628832293`*^9}, {
  3.656396589788447*^9, 
  3.656396611524116*^9}},ExpressionUUID->"70047adb-9030-4ad4-98b8-\
8e37660819a6"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706479441453*^9, 
   3.708577684414433*^9},ExpressionUUID->"b70d9527-220a-4048-9ee2-\
5928da2d718d"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.65770648027463*^9, 
   3.7085776844190187`*^9},ExpressionUUID->"63175e5d-f7fc-4f8f-bf61-\
f5c89da3079d"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706481138563*^9, 
   3.708577684422521*^9},ExpressionUUID->"ef05791e-d676-4538-8ad4-\
0ed6092e4b5a"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"d17198eb-5772-4c7d-a77a-\
e53a6bf43aea"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"56d3846c-cd9a-4dfb-8af6-\
544cfa0b8445"],

Cell["OK!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 
  3.6564883909065437`*^9}},ExpressionUUID->"dd39d006-10e8-4cd1-8ff9-\
bbacf6557190"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 2", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, {3.70857826568954*^9, 
   3.708578267841106*^9}},ExpressionUUID->"d725f788-5c80-4201-84c9-\
89415a0e7ac2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], "  ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "1", ",", "1", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", "[", "x__", "]"}], "  ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "0", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.708578773412945*^9, 3.708578808371447*^9, {3.708579246979186*^9, 
   3.7085792876523457`*^9}, {3.7253449742886057`*^9, 
   3.7253450982395077`*^9}},ExpressionUUID->"b95c85a3-f448-45ee-b332-\
9a72aa910264"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "tc", "]"}], ";", 
  RowBox[{
   RowBox[{"tc", "[", "x__", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"ta", "[", "x", "]"}], "\[CircleTimes]", 
    RowBox[{"tb", "[", "x", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 3.6563973322866383`*^9}, {
   3.708578829730301*^9, 3.7085788457540207`*^9}, {3.708579067750903*^9, 
   3.708579107406444*^9}, {3.708579313535179*^9, 
   3.7085793430542803`*^9}},ExpressionUUID->"fffd1fe0-d2f6-4adb-8e45-\
579cbd3e5120"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{"var", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.708579132115157*^9, 3.708579155158023*^9}, 
   3.725345166279887*^9},ExpressionUUID->"5611bc41-56a6-4143-ab12-\
a21f3447e04c"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7253452019526253`*^9, 
  3.725345204543127*^9}},ExpressionUUID->"02fda76b-2f58-4f96-81b6-\
ca403ffd1a19"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706481992667*^9, 
   3.7085776844284067`*^9, 3.7085789393292627`*^9, {3.708579010705134*^9, 
   3.708579023552812*^9}, {3.708579388582595*^9, 
   3.708579411757415*^9}},ExpressionUUID->"0a9eb9a0-98f7-42c3-b28d-\
77f443f90dbd"],

Cell[BoxData[
 RowBox[{"dtc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.708579431040156*^9, 
  3.7085794509490433`*^9}},ExpressionUUID->"f6f7f730-4d9c-499d-8b20-\
985c1435a19e"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706482818408*^9, 
   3.708577684434054*^9, {3.708578972785952*^9, 3.7085789856497507`*^9}, {
   3.708579215703829*^9, 3.708579222521091*^9}, {3.708579488006474*^9, 
   3.7085794954065638`*^9}},ExpressionUUID->"a2f8b185-5ebe-4d9a-9668-\
05591424d573"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706483552514*^9, 
   3.708577684439376*^9},ExpressionUUID->"30efbd99-35f6-47ee-9d5e-\
290f9b7c0b65"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"404b0059-c2ca-4c20-9752-\
e699fecbfe74"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"ff3f9177-4033-4608-a98d-\
6373ae7f935a"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
  3.6565145076063423`*^9, 
  3.656514530414145*^9}},ExpressionUUID->"d57be9ca-8822-4bff-8300-\
163907fbeb0e"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},ExpressionUUID->"8a54803d-ae31-42e6-b5a9-\
53df48b042e8"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7085795988528013`*^9, 
  3.708579612291287*^9}},ExpressionUUID->"a2fc1306-5509-4022-818f-\
3fcc23b63023"],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 
  3.656514740277762*^9}},ExpressionUUID->"983f8e62-eaf2-4525-be2c-\
a8819976134a"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 
  3.656514878171894*^9}},ExpressionUUID->"3fb524e4-d64d-49d1-8681-\
9a60dcb9e4c7"],

Cell[BoxData[
 RowBox[{"[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",ExpressionUUID->"9ffd542c-ab9a-\
4d1b-aee9-267e48ad4684"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 3", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, {
   3.708579653878467*^9, 
   3.7085796564468412`*^9}},ExpressionUUID->"8577e29a-bdf6-405f-9b91-\
ab7a040ca122"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "1", ",", "0", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "0", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, {3.725346895632956*^9, 
   3.725346982771734*^9}},ExpressionUUID->"87929b81-5d50-4821-9c38-\
f3af9ac2e3c3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"ba38c149-e4a2-46c0-ab21-\
bed6a76625c5"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "0", ",", 
       "2"}], "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "1", ",", "0", ",", 
       "2"}], "]"}]}], "]"}], ",", "2", ",", "0", ",", "2"}], "]"}]], "Output",\

 CellChangeTimes->{
  3.725807311716907*^9},ExpressionUUID->"d09471c2-ebf3-4e95-bdc9-\
7cefb3e0ac28"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.65770648430613*^9, 
   3.708577684443774*^9},ExpressionUUID->"0d59b217-6195-460a-aed5-\
de4306574cff"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706485041752*^9, 
   3.708577684447927*^9},ExpressionUUID->"256d16a3-ef17-4a6e-99b5-\
e5c6f7cdf203"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706485712727*^9, 
   3.708577684452478*^9},ExpressionUUID->"399d7294-0692-426b-96c8-\
08b98a0cefd8"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"0a18299e-9f3a-4895-a5b7-\
23f31991020f"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"f68cfd10-cbb7-45a7-93ed-\
b52cab39ddf7"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
  3.6565145076063423`*^9, 
  3.656514530414145*^9}},ExpressionUUID->"cacc6a59-32d8-4dd9-9619-\
bd80606772ae"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9},ExpressionUUID->"e0e73618-785a-42ab-86fd-\
10f74608374c"],

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 
  3.656514740277762*^9}},ExpressionUUID->"d2df96d0-d727-4479-a1ab-\
7d8ecb78f6dd"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}, 
   3.656515122953247*^9},ExpressionUUID->"2287ca22-b680-472d-9c77-\
e3c8c1d91a71"],

Cell["\<\
For the absolute differential tensorD the Product rule is valid:\
\>", "Text",
 CellChangeTimes->{{3.725807731410863*^9, 
  3.7258077664265842`*^9}},ExpressionUUID->"8a857090-ab06-4b7a-bbde-\
7e46c26588c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vx", "=", " ", 
  RowBox[{"vec", "[", "\[Xi]", "]"}]}]], "Input",ExpressionUUID->"aec84463-\
36c1-4a3d-be74-e475456f3097"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[Xi]", "[", "1", "]"}], ",", 
   RowBox[{"\[Xi]", "[", "2", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7258073957648983`*^9},ExpressionUUID->"48a2e39b-8544-4f63-b5da-\
573367c1493e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tcc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"tensorD", "[", 
     RowBox[{"\[CapitalGamma]", ",", "tc"}], "]"}], "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]], "Input",
 CellChangeTimes->{{3.725807429621006*^9, 3.725807443523946*^9}, {
  3.725807480077004*^9, 
  3.7258075428927794`*^9}},ExpressionUUID->"93fc974a-0024-4322-ab76-\
7302b69ea516"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"absD", "[", 
      RowBox[{"\[CapitalGamma]", ",", "tc"}], "]"}], "[", 
     RowBox[{
      RowBox[{"x", "[", "1", "]"}], ",", 
      RowBox[{"x", "[", "2", "]"}]}], "]"}], "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Xi]", "[", "1", "]"}], ",", 
      RowBox[{"\[Xi]", "[", "2", "]"}]}], "}"}], "]"}], ",", "2", ",", "0", 
   ",", "2"}], "]"}]], "Output",
 CellChangeTimes->{{3.725807523752178*^9, 
  3.725807544646339*^9}},ExpressionUUID->"d577fcf3-4c4e-4896-a6e6-\
98848bc524e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tcc", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"tensorD", "[", 
         RowBox[{"\[CapitalGamma]", ",", "ta"}], "]"}], "[", 
        RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}], ")"}], 
     "\[CircleTimes]", 
     RowBox[{"tb", "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"ta", "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
     RowBox[{
      RowBox[{
       RowBox[{"tensorD", "[", 
        RowBox[{"\[CapitalGamma]", ",", "tb"}], "]"}], "[", 
       RowBox[{"var", "[", "x", "]"}], "]"}], "[", "vx", "]"}]}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.725807557570277*^9, 
  3.7258077069639463`*^9}},ExpressionUUID->"2a1a3d5a-2446-49c7-96d0-\
7a938a1a22b2"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.72580770957169*^9},ExpressionUUID->"d77d1d1d-a0f4-4c9f-a619-a5e89194f57e"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["A Concrete Example ", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, {
   3.708579653878467*^9, 3.7085796564468412`*^9}, {3.7257828294307127`*^9, 
   3.725782847982357*^9}, 3.725784496240386*^9, 
   3.72579029016476*^9},ExpressionUUID->"cacf44a0-5a18-4a02-97e3-\
26b69d15feca"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"covecTotensor", "[", 
    RowBox[{"stb", "[", "1", "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", "  ", 
   RowBox[{"covecTotensor", "[", 
    RowBox[{"stb", "[", "2", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, {3.725346895632956*^9, 3.725346982771734*^9}, {
   3.725784585540875*^9, 3.725784662063493*^9}, {3.725784692863017*^9, 
   3.725784705127219*^9}},ExpressionUUID->"1e1f8c7e-01c3-4e04-a030-\
6c96233ce3fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"d2931c30-70a0-4d38-9521-\
5642b4138eda"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"tensalgv3`Private`xx$17587", ",", "1", ",", "0", ",", "2"}], 
      "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{"tensalgv3`Private`xx$17588", ",", "1", ",", "0", ",", "2"}], 
      "]"}]}], "]"}], ",", "2", ",", "0", ",", "2"}], "]"}]], "Output",
 CellChangeTimes->{
  3.7257847332590218`*^9},ExpressionUUID->"49804724-7d83-4418-beae-\
eb0ce7936aff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.65770648430613*^9, 
   3.708577684443774*^9},ExpressionUUID->"d73c6265-35d8-4c77-ab26-\
f8fc285c12b1"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"nab", "[", 
     RowBox[{"\[CapitalGamma]", ",", "tc"}], "]"}], "[", 
    RowBox[{
     RowBox[{"x", "[", "1", "]"}], ",", 
     RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "3", ",", "0", ",", "2"}], 
  "]"}]], "Output",
 CellChangeTimes->{
  3.7257847563075037`*^9},ExpressionUUID->"7b2a2aac-e17d-4bd7-aaf8-\
9d112c8110b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706485041752*^9, 
   3.708577684447927*^9},ExpressionUUID->"12a5c128-fae6-45c3-83ab-\
1fe21736a178"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"nab", "[", 
         RowBox[{"\[CapitalGamma]", ",", "ta"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
       "2"}], "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{"tensalgv3`Private`xx$17617", ",", "1", ",", "0", ",", "2"}], 
      "]"}]}], "]"}], ",", "3", ",", "0", ",", "2"}], "]"}]], "Output",
 CellChangeTimes->{
  3.725784764054901*^9},ExpressionUUID->"80ce2ab7-ae02-49df-98ad-\
c666d6c980aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706485712727*^9, 
   3.708577684452478*^9},ExpressionUUID->"a0fbd0da-e139-470f-afff-\
6426dfa3acea"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"tp", "[", 
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"tensalgv3`Private`xx$17631", ",", "1", ",", "0", ",", "2"}], 
      "]"}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"nab", "[", 
         RowBox[{"\[CapitalGamma]", ",", "tb"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
       "2"}], "]"}]}], "]"}], ",", "3", ",", "0", ",", "2"}], "]"}]], "Output",\

 CellChangeTimes->{
  3.72578477070437*^9},ExpressionUUID->"5d24f78f-27dd-477f-a7fe-3c13a52f8469"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"e3593a12-8623-44f4-9c74-\
cf18ce47a00a"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"plus", "[", 
    RowBox[{
     RowBox[{"tp", "[", 
      RowBox[{
       RowBox[{"tensor", "[", 
        RowBox[{"tensalgv3`Private`xx$17631", ",", "1", ",", "0", ",", "2"}], 
        "]"}], ",", 
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"nab", "[", 
           RowBox[{"\[CapitalGamma]", ",", "tb"}], "]"}], "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
         "2"}], "]"}]}], "]"}], ",", 
     RowBox[{"tp", "[", 
      RowBox[{
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"nab", "[", 
           RowBox[{"\[CapitalGamma]", ",", "ta"}], "]"}], "[", 
          RowBox[{
           RowBox[{"x", "[", "1", "]"}], ",", 
           RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
         "2"}], "]"}], ",", 
       RowBox[{"tensor", "[", 
        RowBox[{"tensalgv3`Private`xx$17617", ",", "1", ",", "0", ",", "2"}], 
        "]"}]}], "]"}]}], "]"}], ",", "3", ",", "0", ",", "2"}], 
  "]"}]], "Output",
 CellChangeTimes->{
  3.7257847786760597`*^9},ExpressionUUID->"eb6b9c8f-85cb-48a3-8bfd-\
cb36f0f3b641"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"c99656db-5637-4ce1-b9c0-\
1028144ca569"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Investigate \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "[", 
      RowBox[{"2", ",", "2", ",", "1"}], "]"}], "[", 
     RowBox[{
      RowBox[{"x", "[", "1", "]"}], ",", 
      RowBox[{"x", "[", "2", "]"}]}], "]"}]}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}], "[", 
      RowBox[{
       RowBox[{"x", "[", "1", "]"}], ",", 
       RowBox[{"x", "[", "2", "]"}]}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "[", 
      RowBox[{"2", ",", "2", ",", "1"}], "]"}], "[", 
     RowBox[{
      RowBox[{"x", "[", "1", "]"}], ",", 
      RowBox[{"x", "[", "2", "]"}]}], "]"}]}], 
   "\[InvisibleSpace]", "\<\" ?\"\>"}],
  SequenceForm["Investigate ", -eudiffgeov4`\[CapitalGamma][2, 2, 1][
     $CellContext`x[1], 
     $CellContext`x[2]], " = ", -eudiffgeov4`\[CapitalGamma][1, 1, 1][
      $CellContext`x[1], 
      $CellContext`x[2]] - eudiffgeov4`\[CapitalGamma][2, 2, 1][
    $CellContext`x[1], 
    $CellContext`x[2]], " ?"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7257848249667*^9},ExpressionUUID->"4f27d521-2d21-4734-a56a-9ab4fda8f45a"]
}, Open  ]],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed!", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
  3.6565145076063423`*^9, 
  3.656514530414145*^9}},ExpressionUUID->"f0f7cb84-15a5-441a-9cdf-\
0512e07519e0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"tensorToArray", "[", 
   RowBox[{"dtc", "-", "dta", "-", "dtb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9, {3.7257848435659437`*^9, 
   3.725784852245723*^9}},ExpressionUUID->"88406dcf-568d-40c6-87cd-\
97952c688564"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"1", ",", "1", ",", "1"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"1", ",", "1", ",", "1"}], "]"}], "[", 
         RowBox[{
          RowBox[{"x", "[", "1", "]"}], ",", 
          RowBox[{"x", "[", "2", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"1", ",", "1", ",", "2"}], "]"}], "[", 
        RowBox[{
         RowBox[{"x", "[", "1", "]"}], ",", 
         RowBox[{"x", "[", "2", "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"1", ",", "1", ",", "2"}], "]"}], "[", 
         RowBox[{
          RowBox[{"x", "[", "1", "]"}], ",", 
          RowBox[{"x", "[", "2", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7257848620379457`*^9},ExpressionUUID->"f22ad599-5cd9-47cc-904e-\
5c4eca0bedc4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"diff", "=", " ", 
  RowBox[{"dtc", "-", "dta", "-", "dtb"}]}]], "Input",
 CellChangeTimes->{{3.656514730285493*^9, 
  3.656514740277762*^9}},ExpressionUUID->"4541d6c2-347a-4ab0-b679-\
0341546642b1"],

Cell[BoxData[
 RowBox[{"tensor", "[", 
  RowBox[{
   RowBox[{"plus", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"tp", "[", 
       RowBox[{
        RowBox[{"tensor", "[", 
         RowBox[{"tensalgv3`Private`xx$17631", ",", "1", ",", "0", ",", "2"}],
          "]"}], ",", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"nab", "[", 
            RowBox[{"\[CapitalGamma]", ",", "tb"}], "]"}], "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
          "2"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"tp", "[", 
       RowBox[{
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"nab", "[", 
            RowBox[{"\[CapitalGamma]", ",", "ta"}], "]"}], "[", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], ",", 
            RowBox[{"x", "[", "2", "]"}]}], "]"}], ",", "2", ",", "0", ",", 
          "2"}], "]"}], ",", 
        RowBox[{"tensor", "[", 
         RowBox[{"tensalgv3`Private`xx$17617", ",", "1", ",", "0", ",", "2"}],
          "]"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"nab", "[", 
       RowBox[{"\[CapitalGamma]", ",", "tc"}], "]"}], "[", 
      RowBox[{
       RowBox[{"x", "[", "1", "]"}], ",", 
       RowBox[{"x", "[", "2", "]"}]}], "]"}]}], "]"}], ",", "3", ",", "0", 
   ",", "2"}], "]"}]], "Output",
 CellChangeTimes->{
  3.725784875225745*^9},ExpressionUUID->"8ea9efd4-039c-4d17-8cad-\
b5439affe0c2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"diff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514752369658*^9, 3.656514878171894*^9}, 
   3.656515122953247*^9},ExpressionUUID->"4fdc017f-1aa2-44bc-b041-\
a127e3f056e7"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   RowBox[{"\[CapitalGamma]", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x", "[", "1", "]"}], ",", 
    RowBox[{"x", "[", "2", "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7257848798785057`*^9},ExpressionUUID->"64e14b2f-2b36-44e6-9ca9-\
926c4c0dc9b1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 4", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, {3.70857970597388*^9, 
   3.708579708102652*^9}},ExpressionUUID->"c96ad5bf-0af6-40b2-9734-\
7b12909e53ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb", ",", "dta", ",", "dtb", ",", "dtc"}], "]"}], ";", 
  " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "1", ",", "0", ",", "dim"}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "0", ",", "0", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.725347304569121*^9, 
   3.7253473750646973`*^9}, {3.725351952441309*^9, 
   3.725351961518757*^9}},ExpressionUUID->"057320c2-c4c8-4af6-bf78-\
ad20bdac0baf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"cd119653-ed32-4395-b2e7-\
95e1c46e1500"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"tc", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"tb", "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
    RowBox[{"ta", "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.725347420706204*^9, 
  3.7253474883311977`*^9}},ExpressionUUID->"888b5a11-40a1-4862-91cc-\
d9ebc7167dfb"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706486490097*^9, 
   3.708577684457518*^9},ExpressionUUID->"be240fb3-63b8-4474-8d27-\
33187182fe0c"],

Cell[BoxData[
 RowBox[{"dtc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.725351656971713*^9, 
  3.72535167364835*^9}},ExpressionUUID->"8b25707d-ded4-4793-9a9f-\
11afbaf33c81"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706487234462*^9, 
   3.7085776844613743`*^9},ExpressionUUID->"ccb3e72a-f977-4ccb-9e1d-\
2afeae2c21e2"],

Cell[BoxData[
 RowBox[{"dta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.725351105441555*^9, 
  3.725351137389655*^9}},ExpressionUUID->"59e2f08f-9294-4d74-9e0a-\
e67647661c42"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706487946682*^9, 
   3.708577684465144*^9},ExpressionUUID->"ffa6746b-6a97-43ad-ba17-\
3c4e7018f39a"],

Cell[BoxData[
 RowBox[{"dtb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.725351865056438*^9, 
  3.7253518812472057`*^9}},ExpressionUUID->"1a6d78e6-fc9d-4f89-b3e5-\
f0e2b0917c79"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"54a5159a-365a-4ff6-87ee-\
8cdd2070b21e"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"66b236dc-ec83-49ce-b6d8-\
25c16028ad39"],

Cell["Product rule is confirmed!  ", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.7253503215886393`*^9, 3.725350414683403*^9}, 3.725350862191997*^9, 
   3.7253521435649023`*^9},ExpressionUUID->"6997348e-b067-44cc-b2ce-\
c8016e317a9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["The product rule for nabla 5", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, 3.656515382127493*^9, {3.708579776886148*^9, 
   3.708579779221105*^9}, {3.7252899824665213`*^9, 3.725289985362*^9}, 
   3.7253556936811857`*^9},ExpressionUUID->"5e4c78fb-c5e4-42bb-9127-\
1c29ebdf94ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb", ",", "tc", ",", "dta", ",", "dtb"}], "]"}], ";", 
  " ", 
  RowBox[{"dim", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "0", ",", "0", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.656515407831373*^9, 
   3.656515426952744*^9}, 3.725288696428554*^9, 3.725288750390222*^9, 
   3.72528880680005*^9, {3.725289456181279*^9, 3.725289490727621*^9}, {
   3.725349043553113*^9, 3.7253490823196297`*^9}, {3.725349129695554*^9, 
   3.725349145967475*^9}, {3.725352196591525*^9, 
   3.725352206548583*^9}},ExpressionUUID->"a775cf17-e4e6-425c-a09c-\
394ff779ff96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pb", "=", "1"}], ";", 
  RowBox[{"qb", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "1", ",", "0", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.656515407831373*^9, 
   3.656515426952744*^9}, 3.725288696428554*^9, 3.725288750390222*^9, 
   3.72528880680005*^9, {3.7252895163513737`*^9, 3.725289544758946*^9}, {
   3.7253491776954203`*^9, 
   3.7253492072387*^9}},ExpressionUUID->"26575267-5a76-40e7-913a-\
bf5f5dc1f1b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"bc661ef8-b6d0-4804-afbf-\
0b7c71a7f3bc"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706488681872*^9, 
   3.708577684478401*^9},ExpressionUUID->"06f84df1-f4e5-4a47-bc8b-\
edf65cff43c4"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.657706489330159*^9, 
   3.708577684490494*^9},ExpressionUUID->"8241247b-1966-4359-98b7-\
91dbf035b49d"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.6577064901262417`*^9, 
   3.708577684501904*^9},ExpressionUUID->"c6b61053-1db3-4e4b-8cc2-\
93f3011b10b7"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"f0df06b9-6a4b-45fa-aeef-\
853e1bb4ef35"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}},ExpressionUUID->"70d2f52c-1cf5-42df-aefa-\
0623a4bcee73"],

Cell["Product rule isn\[CloseCurlyQuote]t confirmed! Replacing dta by dta1:", \
"Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 3.6565155153100653`*^9}, {3.7253523812828913`*^9, 
   3.725352397970652*^9}, {3.725355032461815*^9, 
   3.7253550365977287`*^9}},ExpressionUUID->"3879f509-6d82-4eb1-9011-\
bd852be4c95b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "dta1", "]"}], ";", 
  RowBox[{"dta1", "=", 
   RowBox[{
    RowBox[{"tb", "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"nabla", "[", 
       RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
      RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.725352401885998*^9, 3.7253524046028*^9}, {
  3.72535474741623*^9, 
  3.7253548431910152`*^9}},ExpressionUUID->"2c9aadda-6e5a-4b51-b9ea-\
1493c075b80a"],

Cell["\<\
One obtains a product rule in the form 
\[Del](ta\[CircleTimes]tb) =tb  \[CircleTimes]\[Del]ta + ta\[Del]tb\
\>", "Text",
 CellChangeTimes->{{3.7253550683412113`*^9, 3.725355125916832*^9}, {
  3.7253553835707493`*^9, 
  3.725355522561677*^9}},ExpressionUUID->"96104d65-a51c-4945-8f3e-\
f8556af69636"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"dtc", ",", 
   RowBox[{"dta1", " ", "+", "dtb"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.725354880263089*^9},ExpressionUUID->"d582b986-9d73-45ad-b4b7-\
aaffc12cdc0d"],

Cell["The reason is that the tensor product isn\[CloseCurlyQuote]t \
commutative.", "Text",
 CellChangeTimes->{{3.7253555470773067`*^9, 3.725355577673234*^9}, {
  3.72535561302479*^9, 
  3.725355659936391*^9}},ExpressionUUID->"d67d4a4b-50e8-4229-80b4-\
d2b2a07e31e2"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"dta1", "-", "dta"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656514538895512*^9, 3.656514589149849*^9}, 
   3.656514624694223*^9, {3.725354901756617*^9, 
   3.725354909903036*^9}},ExpressionUUID->"fa8634d7-c9b4-4d5e-8f79-\
28fbc4dc36b0"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The Product Rule for the Gradient Tensor of Contravariant Factors\
\>", "Subsubsection",
 CellChangeTimes->{{3.6565133329699793`*^9, 3.656513352826008*^9}, 
   3.656513980371511*^9, 3.656514039474928*^9, 3.656515000794417*^9, 
   3.656515253256382*^9, 3.656515382127493*^9, {3.656515649764855*^9, 
   3.656515661788837*^9}, {3.656601628188283*^9, 3.656601628812388*^9}, {
   3.708579881749504*^9, 
   3.708579930716969*^9}},ExpressionUUID->"e82824d8-2fdc-4276-b067-\
2942a38bf698"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", "4"}], ";", 
  RowBox[{"pa", "=", "0"}], ";", 
  RowBox[{"qa", "=", "2"}], " ", ";", 
  RowBox[{
   RowBox[{"ta", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "0"}], ";", 
  RowBox[{"qb", "=", "3"}], ";", 
  RowBox[{
   RowBox[{"tb", " ", "[", "x__", "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.65633716286384*^9, 3.656337178383067*^9}, {
   3.656343881485649*^9, 3.656344060278912*^9}, {3.656514084011107*^9, 
   3.656514153602344*^9}, {3.6565141909062634`*^9, 3.656514240371709*^9}, 
   3.656515035699079*^9, 3.6565152780806026`*^9, {3.656515407831373*^9, 
   3.656515426952744*^9}, {3.6565156988133583`*^9, 3.6565157178534117`*^9}, {
   3.656515835845417*^9, 3.6565158645163517`*^9}, 3.656515897882958*^9, 
   3.656565374592641*^9, 3.6565655833209248`*^9, 3.656587448877404*^9, 
   3.656587980713725*^9, {3.6565899538816767`*^9, 3.656589961241885*^9}, 
   3.656595591727523*^9, {3.656598153297915*^9, 3.656598166345847*^9}, 
   3.65659936882414*^9, {3.7253701407496777`*^9, 
   3.725370171821143*^9}},ExpressionUUID->"973d820f-d9d4-4cb6-bbde-\
ad82536e119b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"1b48f3e0-8d36-46da-8dbc-\
49eb1607b24c"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706490770233*^9, 
   3.708577684513154*^9},ExpressionUUID->"3e15eb84-2147-47e8-9d8c-\
db6ed346ba7f"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.6577064914260187`*^9, 
   3.7085776845249233`*^9},ExpressionUUID->"54d36b85-af96-48e4-b753-\
653d867bf937"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706492194504*^9, 
   3.70857768453636*^9},ExpressionUUID->"1c2cbbc5-d4b3-4991-acad-\
6660bf51548c"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"14f2db35-0126-4203-8dd8-\
b4ce5328a567"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"equi", "[", 
    RowBox[{"dtc", ",", 
     RowBox[{"dta", " ", "+", "dtb"}]}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}, {3.656565409384877*^9, 
  3.6565654391120768`*^9}},ExpressionUUID->"bb140edf-00c0-43ac-b8c4-\
cc1f4a24d624"],

Cell["\<\
needed 1423.14 s = 24 min with Mathematica 11.2.
Product rule for the tensor product of contravariant tensors is confirmed for \
many examples. The last example with \
\>", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 3.6565155153100653`*^9}, 3.656515811172065*^9, {
   3.656516042625375*^9, 3.6565161170169*^9}, {3.656521092264647*^9, 
   3.656521126048506*^9}, {3.656598093617725*^9, 3.65659813411277*^9}, {
   3.6566010406643353`*^9, 3.656601172658983*^9}, {3.725371789484123*^9, 
   3.725371838163501*^9}},ExpressionUUID->"5ce71f58-5f44-4e8d-8124-\
dc4845ed2464"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", 
  RowBox[{"dim", "=", "4"}], ";", 
  RowBox[{"pa", "=", "0"}], ";", 
  RowBox[{"qa", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ta", "[", "x__", "]"}], ":=", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"a", "[", "x", "]"}], ",", "pa", ",", "qa", ",", "dim"}], 
    "]"}]}], ";", 
  RowBox[{"pb", "=", "0"}], ";", 
  RowBox[{"qb", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"tb", "[", "x__", "]"}], ":=", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"b", "[", "x", "]"}], ",", "pb", ",", "qb", ",", "dim"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6566014199974337`*^9, 3.656601419999034*^9}, {
  3.725371863515966*^9, 
  3.725371870859421*^9}},ExpressionUUID->"98fea9c6-bf4e-4c95-bb49-\
cc3e00f51916"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tc", "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}], "=", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656344081775806*^9, 3.65634414600423*^9}, 
   3.65639663721973*^9, {3.6563973153428926`*^9, 
   3.6563973322866383`*^9}},ExpressionUUID->"42574e00-cfa2-4caf-86b3-\
cd40668dc3a6"],

Cell[BoxData[
 RowBox[{"dtc", "=", 
  RowBox[{
   RowBox[{"nabla", "[", 
    RowBox[{"\[CapitalGamma]", ",", " ", "tc"}], "]"}], "[", 
   RowBox[{"var", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.656397420965878*^9, 3.656397426853724*^9}, {
   3.656513721230363*^9, 3.656513740902547*^9}, 3.657706490770233*^9, 
   3.708577684513154*^9},ExpressionUUID->"d0101be2-2cda-48d1-80b0-\
6950624d3ae5"],

Cell[BoxData[
 RowBox[{"dta", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "ta"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}], "\[CircleTimes]", 
   RowBox[{"tb", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.656397464084487*^9, 3.656397502837014*^9}, {
   3.656513779366226*^9, 3.656513793669793*^9}, 3.6577064914260187`*^9, 
   3.7085776845249233`*^9},ExpressionUUID->"d9e5d69b-a105-4947-b455-\
c02e8ead00e9"],

Cell[BoxData[
 RowBox[{"dtb", "=", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"var", "[", "x", "]"}], "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"nabla", "[", 
      RowBox[{"\[CapitalGamma]", ",", " ", "tb"}], "]"}], "[", 
     RowBox[{"var", "[", "x", "]"}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.65639754129055*^9, 3.6563975711252537`*^9}, {
   3.6565138267978354`*^9, 3.656513852269517*^9}, 3.657706492194504*^9, 
   3.70857768453636*^9},ExpressionUUID->"e97da90b-5260-4adb-9377-\
4f5775fb67f9"],

Cell[BoxData[
 RowBox[{"dta", " ", "+", "dtb"}]], "Input",
 CellChangeTimes->{{3.6563976597402143`*^9, 
  3.656397670151092*^9}},ExpressionUUID->"2415da94-5a3a-4015-9ac4-\
03de56cdac97"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"equi", "[", 
    RowBox[{"dtc", ",", 
     RowBox[{"dta", " ", "+", "dtb"}]}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.656344276663093*^9, 3.6563443268813667`*^9}, {
  3.656344360489628*^9, 3.656344552424081*^9}, {3.656397617749176*^9, 
  3.6563976423557987`*^9}, {3.656565409384877*^9, 
  3.6565654391120768`*^9}},ExpressionUUID->"95bd2cab-4045-43c3-896f-\
274104cac558"],

Cell["\<\
needed 1407.91 s = 23.5 min on my workstation, with Mathematica 11.2.
Choose arbitrary parameters dim, qa, qb and repeat evaluating this subsection.\
\>", "Text",
 CellChangeTimes->{{3.656488388330553*^9, 3.6564883909065437`*^9}, {
   3.6565145076063423`*^9, 3.656514530414145*^9}, 3.6565153296395206`*^9, {
   3.656515512150305*^9, 3.6565155153100653`*^9}, 3.656515811172065*^9, {
   3.656516042625375*^9, 3.6565161170169*^9}, {3.656521092264647*^9, 
   3.656521126048506*^9}, {3.656598093617725*^9, 3.65659813411277*^9}, {
   3.6566010406643353`*^9, 3.656601172658983*^9}, {3.656601439693842*^9, 
   3.65660144758989*^9}, {3.656601538477417*^9, 3.65660155666113*^9}, {
   3.725373592069491*^9, 3.725373640381235*^9}, {3.725373692308964*^9, 
   3.7253736962607603`*^9}},ExpressionUUID->"405c738c-86fd-422a-a79a-\
73b33ca06f94"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{841, 645},
WindowMargins->{{38, Automatic}, {Automatic, 37}},
ShowSelection->True,
Magnification:>1.5 Inherited,
FrontEndVersion->"11.2 for Linux x86 (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 191, 2, 240, "Title",ExpressionUUID->"f3a6fca7-7d0e-4a86-8265-aef7c2673e6c"],
Cell[CellGroupData[{
Cell[796, 28, 234, 5, 139, "Chapter",ExpressionUUID->"a8fcb921-ab92-48d9-9535-dd966253c9c5"],
Cell[1033, 35, 697, 12, 196, "Text",ExpressionUUID->"1e799130-ae06-4f89-9cf9-f3959a2c9b14"],
Cell[CellGroupData[{
Cell[1755, 51, 172, 3, 101, "Section",ExpressionUUID->"81d6a10c-c16d-4abb-a429-ba8a14a08dba"],
Cell[CellGroupData[{
Cell[1952, 58, 233, 4, 68, "Subsubsection",ExpressionUUID->"d1bad5ca-fba8-45f0-a5d7-d0f6d0d8f051"],
Cell[2188, 64, 708, 20, 414, "Input",ExpressionUUID->"a5b27434-766f-43b1-a6da-25b9bfce99c1"],
Cell[2899, 86, 475, 12, 235, "Input",ExpressionUUID->"2014edec-8cb7-4f39-be3d-8557cb969836"],
Cell[3377, 100, 382, 11, 235, "Input",ExpressionUUID->"c9060884-c956-4fd5-b2ec-ba2918173556"],
Cell[3762, 113, 360, 7, 235, "Input",ExpressionUUID->"4a1e7197-d8c5-4f18-9f8c-f88559b6ebd5"],
Cell[4125, 122, 400, 10, 235, "Input",ExpressionUUID->"6815f789-da58-4858-a5cc-87591b8f8a33"],
Cell[4528, 134, 534, 15, 235, "Input",ExpressionUUID->"6b60ed1d-bf42-484c-9e7c-8680a4e5c071"],
Cell[5065, 151, 536, 15, 235, "Input",ExpressionUUID->"d8ef2f79-50ca-45bb-ac98-c9c5cbcf0a1a"],
Cell[5604, 168, 186, 4, 235, "Input",ExpressionUUID->"b0261506-00fe-4620-9f2e-4fe3a4a53d10"],
Cell[5793, 174, 340, 7, 235, "Input",ExpressionUUID->"809dab47-7f1c-4658-b70d-ff8cbe49fa56"],
Cell[6136, 183, 273, 8, 235, "Input",ExpressionUUID->"d32d6a59-b1ad-4735-836d-deb1ab094c0e"],
Cell[6412, 193, 147, 3, 271, "Text",ExpressionUUID->"318f4393-4e01-448d-92ca-31e414b61a8e"],
Cell[6562, 198, 384, 11, 235, "Input",ExpressionUUID->"9fe2f2f9-9d3c-4421-af70-f01465842304"],
Cell[6949, 211, 333, 10, 235, "Input",ExpressionUUID->"e484a351-eac1-4eea-aec4-5169eced3921"],
Cell[7285, 223, 455, 10, 235, "Input",ExpressionUUID->"2f953755-75dc-4fee-a67a-59c784fd05c8"],
Cell[7743, 235, 315, 9, 235, "Input",ExpressionUUID->"c8762378-6fb6-44a6-93a9-e15c942bdc75"],
Cell[8061, 246, 537, 14, 235, "Input",ExpressionUUID->"17b09bfc-9c8c-405d-a357-85aea52d97c9"],
Cell[8601, 262, 183, 4, 235, "Input",ExpressionUUID->"a9e99ace-4474-44c3-8450-46c66ba1dd68"],
Cell[8787, 268, 145, 3, 271, "Text",ExpressionUUID->"2557026c-ca74-47f7-abd3-508fbaa9f415"]
}, Closed]],
Cell[CellGroupData[{
Cell[8969, 276, 292, 4, 54, "Subsubsection",ExpressionUUID->"f04e0899-2261-4b77-b8b1-1521e61a37e3"],
Cell[9264, 282, 431, 8, 157, "Input",ExpressionUUID->"142ef103-6a20-4da2-941a-628d6f53151c"],
Cell[9698, 292, 809, 20, 276, "Input",ExpressionUUID->"474d550c-a3f6-4539-b24f-e4e69c21c261"],
Cell[10510, 314, 459, 12, 157, "Input",ExpressionUUID->"8b25ea1d-746a-4fd4-a16b-2d08cf7cbafe"],
Cell[10972, 328, 475, 12, 157, "Input",ExpressionUUID->"44797b5f-c7bc-4d30-ac04-05bd43cb4b42"],
Cell[11450, 342, 621, 14, 157, "Input",ExpressionUUID->"a8dc9006-ea40-4ceb-bb69-0b4155071a5a"],
Cell[12074, 358, 307, 6, 157, "Input",ExpressionUUID->"79dee728-e320-4a2b-9dff-902868967365"],
Cell[12384, 366, 446, 10, 157, "Input",ExpressionUUID->"79a2381c-725e-4233-9e21-f1ea15204e70"],
Cell[12833, 378, 534, 15, 157, "Input",ExpressionUUID->"31725c44-7648-4c9b-9ee7-c404fb822270"],
Cell[13370, 395, 536, 15, 157, "Input",ExpressionUUID->"52b93c1b-305e-42e4-a0b9-571691529fd8"],
Cell[13909, 412, 186, 4, 157, "Input",ExpressionUUID->"67eb5283-1630-470c-8cc8-ed778d7d6a81"],
Cell[14098, 418, 426, 9, 157, "Input",ExpressionUUID->"5253ae7d-81c7-42f1-b376-d86bee6fd3b8"],
Cell[14527, 429, 564, 11, 420, "Text",ExpressionUUID->"60a85169-e2ca-4bb3-8aca-9f485253f55d"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15140, 446, 215, 4, 101, "Section",ExpressionUUID->"6b91c0f0-7d9a-4234-b76f-b0e84f0b1af7"],
Cell[CellGroupData[{
Cell[15380, 454, 167, 3, 68, "Subsubsection",ExpressionUUID->"fabdc4a9-5db4-4ed1-babb-0ec51c76d67d"],
Cell[15550, 459, 477, 12, 157, "Input",ExpressionUUID->"a8a1b072-b68f-438e-bdf8-a4e79c7a6cf3"],
Cell[16030, 473, 426, 11, 157, "Input",ExpressionUUID->"fa62b22d-bcdf-4226-aac9-23c26973f616"],
Cell[16459, 486, 365, 8, 157, "Input",ExpressionUUID->"872e807a-25e3-415a-a9a7-9870a9cb956b"],
Cell[16827, 496, 540, 14, 157, "Input",ExpressionUUID->"a1da00d6-3fe1-493a-b152-42b03bbfa220"],
Cell[17370, 512, 433, 12, 157, "Input",ExpressionUUID->"6078e43e-5962-4157-aa2f-e2b324f0f826"],
Cell[17806, 526, 431, 9, 157, "Input",ExpressionUUID->"89b69fb0-5cdb-4a47-ba97-6cd0628a5595"],
Cell[18240, 537, 280, 8, 157, "Input",ExpressionUUID->"9ca2f4b9-9348-4c17-9f35-70f416a94928"]
}, Closed]],
Cell[CellGroupData[{
Cell[18557, 550, 256, 4, 54, "Subsubsection",ExpressionUUID->"1d386383-487d-41fd-98f5-5efe7bd0209a"],
Cell[18816, 556, 873, 23, 391, "Input",ExpressionUUID->"138d6761-397e-4126-aff7-0d3b525d50cf"],
Cell[19692, 581, 475, 12, 157, "Input",ExpressionUUID->"e3acb00e-7c92-4a6d-91ce-f79abd00f229"],
Cell[20170, 595, 382, 11, 157, "Input",ExpressionUUID->"70047adb-9030-4ad4-98b8-8e37660819a6"],
Cell[20555, 608, 409, 9, 157, "Input",ExpressionUUID->"b70d9527-220a-4048-9ee2-5928da2d718d"],
Cell[20967, 619, 540, 13, 157, "Input",ExpressionUUID->"63175e5d-f7fc-4f8f-bf61-f5c89da3079d"],
Cell[21510, 634, 542, 13, 157, "Input",ExpressionUUID->"ef05791e-d676-4538-8ad4-0ed6092e4b5a"],
Cell[22055, 649, 186, 4, 157, "Input",ExpressionUUID->"d17198eb-5772-4c7d-a77a-e53a6bf43aea"],
Cell[22244, 655, 340, 7, 157, "Input",ExpressionUUID->"56d3846c-cd9a-4dfb-8af6-544cfa0b8445"],
Cell[22587, 664, 147, 3, 181, "Text",ExpressionUUID->"dd39d006-10e8-4cd1-8ff9-bbacf6557190"]
}, Closed]],
Cell[CellGroupData[{
Cell[22771, 672, 275, 4, 54, "Subsubsection",ExpressionUUID->"d725f788-5c80-4201-84c9-89415a0e7ac2"],
Cell[23049, 678, 947, 23, 391, "Input",ExpressionUUID->"b95c85a3-f448-45ee-b332-9a72aa910264"],
Cell[23999, 703, 593, 13, 157, "Input",ExpressionUUID->"fffd1fe0-d2f6-4adb-8e45-579cbd3e5120"],
Cell[24595, 718, 234, 5, 157, "Input",ExpressionUUID->"5611bc41-56a6-4143-ab12-a21f3447e04c"],
Cell[24832, 725, 278, 8, 157, "Input",ExpressionUUID->"02fda76b-2f58-4f96-81b6-ca403ffd1a19"],
Cell[25113, 735, 535, 11, 157, "Input",ExpressionUUID->"0a9eb9a0-98f7-42c3-b28d-77f443f90dbd"],
Cell[25651, 748, 290, 8, 157, "Input",ExpressionUUID->"f6f7f730-4d9c-499d-8b20-985c1435a19e"],
Cell[25944, 758, 689, 15, 157, "Input",ExpressionUUID->"a2f8b185-5ebe-4d9a-9668-05591424d573"],
Cell[26636, 775, 542, 13, 157, "Input",ExpressionUUID->"30efbd99-35f6-47ee-9d5e-290f9b7c0b65"],
Cell[27181, 790, 186, 4, 157, "Input",ExpressionUUID->"404b0059-c2ca-4c20-9752-e699fecbfe74"],
Cell[27370, 796, 340, 7, 157, "Input",ExpressionUUID->"ff3f9177-4033-4608-a98d-6373ae7f935a"],
Cell[27713, 805, 241, 4, 181, "Text",ExpressionUUID->"d57be9ca-8822-4bff-8300-163907fbeb0e"],
Cell[27957, 811, 287, 6, 157, "Input",ExpressionUUID->"8a54803d-ae31-42e6-b5a9-53df48b042e8"],
Cell[28247, 819, 193, 4, 157, "Input",ExpressionUUID->"a2fc1306-5509-4022-818f-3fcc23b63023"],
Cell[28443, 825, 222, 5, 157, "Input",ExpressionUUID->"983f8e62-eaf2-4525-be2c-a8819976134a"],
Cell[28668, 832, 332, 9, 157, "Input",ExpressionUUID->"3fb524e4-d64d-49d1-8681-9a60dcb9e4c7"],
Cell[29003, 843, 202, 6, 130, "Input",ExpressionUUID->"9ffd542c-ab9a-4d1b-aee9-267e48ad4684"]
}, Closed]],
Cell[CellGroupData[{
Cell[29242, 854, 304, 5, 54, "Subsubsection",ExpressionUUID->"8577e29a-bdf6-405f-9b91-ab7a040ca122"],
Cell[29549, 861, 877, 22, 116, "Input",ExpressionUUID->"87929b81-5d50-4821-9c38-f3af9ac2e3c3"],
Cell[CellGroupData[{
Cell[30451, 887, 475, 12, 47, "Input",ExpressionUUID->"ba38c149-e4a2-46c0-ab21-bed6a76625c5"],
Cell[30929, 901, 708, 22, 93, "Output",ExpressionUUID->"d09471c2-ebf3-4e95-bdc9-7cefb3e0ac28"]
}, Open  ]],
Cell[31652, 926, 408, 9, 47, "Input",ExpressionUUID->"0d59b217-6195-460a-aed5-de4306574cff"],
Cell[32063, 937, 539, 13, 47, "Input",ExpressionUUID->"256d16a3-ef17-4a6e-99b5-e5c6f7cdf203"],
Cell[32605, 952, 542, 13, 47, "Input",ExpressionUUID->"399d7294-0692-426b-96c8-08b98a0cefd8"],
Cell[33150, 967, 186, 4, 47, "Input",ExpressionUUID->"0a18299e-9f3a-4895-a5b7-23f31991020f"],
Cell[33339, 973, 340, 7, 47, "Input",ExpressionUUID->"f68cfd10-cbb7-45a7-93ed-b52cab39ddf7"],
Cell[33682, 982, 241, 4, 54, "Text",ExpressionUUID->"cacc6a59-32d8-4dd9-9619-bd80606772ae"],
Cell[33926, 988, 287, 6, 47, "Input",ExpressionUUID->"e0e73618-785a-42ab-86fd-10f74608374c"],
Cell[34216, 996, 222, 5, 47, "Input",ExpressionUUID->"d2df96d0-d727-4479-a1ab-7d8ecb78f6dd"],
Cell[34441, 1003, 350, 9, 47, "Input",ExpressionUUID->"2287ca22-b680-472d-9c77-e3c8c1d91a71"],
Cell[34794, 1014, 216, 5, 54, "Text",ExpressionUUID->"8a857090-ab06-4b7a-bbde-7e46c26588c9"],
Cell[CellGroupData[{
Cell[35035, 1023, 146, 3, 47, "Input",ExpressionUUID->"aec84463-36c1-4a3d-be74-e475456f3097"],
Cell[35184, 1028, 243, 7, 53, "Output",ExpressionUUID->"48a2e39b-8544-4f63-b5da-573367c1493e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35464, 1040, 395, 10, 47, "Input",ExpressionUUID->"93fc974a-0024-4322-ab76-7302b69ea516"],
Cell[35862, 1052, 581, 17, 93, "Output",ExpressionUUID->"d577fcf3-4c4e-4896-a6e6-98848bc524e4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36480, 1074, 851, 25, 82, "Input",ExpressionUUID->"2a1a3d5a-2446-49c7-96d0-7a938a1a22b2"],
Cell[37334, 1101, 130, 2, 53, "Output",ExpressionUUID->"d77d1d1d-a0f4-4c9f-a619-a5e89194f57e"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[37513, 1109, 390, 6, 54, "Subsubsection",ExpressionUUID->"cacf44a0-5a18-4a02-97e3-26b69d15feca"],
Cell[37906, 1117, 883, 19, 116, "Input",ExpressionUUID->"1e1f8c7e-01c3-4e04-a030-6c96233ce3fb"],
Cell[CellGroupData[{
Cell[38814, 1140, 475, 12, 47, "Input",ExpressionUUID->"d2931c30-70a0-4d38-9521-5642b4138eda"],
Cell[39292, 1154, 492, 13, 167, "Output",ExpressionUUID->"49804724-7d83-4418-beae-eb0ce7936aff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39821, 1172, 408, 9, 47, "Input",ExpressionUUID->"d73c6265-35d8-4c77-ab26-f8fc285c12b1"],
Cell[40232, 1183, 399, 12, 56, "Output",ExpressionUUID->"7b2a2aac-e17d-4bd7-aaf8-9d112c8110b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40668, 1200, 539, 13, 47, "Input",ExpressionUUID->"12a5c128-fae6-45c3-83ab-1fe21736a178"],
Cell[41210, 1215, 679, 19, 130, "Output",ExpressionUUID->"80ce2ab7-ae02-49df-98ad-c666d6c980aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41926, 1239, 542, 13, 47, "Input",ExpressionUUID->"a0fbd0da-e139-470f-afff-6426dfa3acea"],
Cell[42471, 1254, 678, 19, 130, "Output",ExpressionUUID->"5d24f78f-27dd-477f-a7fe-3c13a52f8469"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43186, 1278, 186, 4, 47, "Input",ExpressionUUID->"e3593a12-8623-44f4-9c74-cf18ce47a00a"],
Cell[43375, 1284, 1271, 36, 204, "Output",ExpressionUUID->"eb6b9c8f-85cb-48a3-8bfd-cb36f0f3b641"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44683, 1325, 340, 7, 47, "Input",ExpressionUUID->"c99656db-5637-4ce1-b9c0-1028144ca569"],
Cell[45026, 1334, 1315, 35, 67, "Print",ExpressionUUID->"4f27d521-2d21-4734-a56a-9ab4fda8f45a"]
}, Open  ]],
Cell[46356, 1372, 241, 4, 54, "Text",ExpressionUUID->"f0f7cb84-15a5-441a-9cdf-0512e07519e0"],
Cell[CellGroupData[{
Cell[46622, 1380, 346, 7, 47, "Input",ExpressionUUID->"88406dcf-568d-40c6-87cd-97952c688564"],
Cell[46971, 1389, 1434, 45, 234, "Output",ExpressionUUID->"f22ad599-5cd9-47cc-904e-5c4eca0bedc4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48442, 1439, 222, 5, 70, "Input",ExpressionUUID->"4541d6c2-347a-4ab0-b679-0341546642b1"],
Cell[48667, 1446, 1551, 44, 361, "Output",ExpressionUUID->"8ea9efd4-039c-4d17-8cad-b5439affe0c2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50255, 1495, 350, 9, 70, "Input",ExpressionUUID->"4fdc017f-1aa2-44bc-b041-a127e3f056e7"],
Cell[50608, 1506, 339, 10, 79, "Output",ExpressionUUID->"64e14b2f-2b36-44e6-9ca9-926c4c0dc9b1"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[50996, 1522, 323, 5, 54, "Subsubsection",ExpressionUUID->"c96ad5bf-0af6-40b2-9734-7b12909e53ad"],
Cell[51322, 1529, 992, 24, 116, "Input",ExpressionUUID->"057320c2-c4c8-4af6-bf78-ad20bdac0baf"],
Cell[52317, 1555, 475, 12, 47, "Input",ExpressionUUID->"cd119653-ed32-4395-b2e7-95e1c46e1500"],
Cell[52795, 1569, 435, 12, 47, "Input",ExpressionUUID->"888b5a11-40a1-4862-91cc-d9ebc7167dfb"],
Cell[53233, 1583, 409, 9, 47, "Input",ExpressionUUID->"be240fb3-63b8-4474-8d27-33187182fe0c"],
Cell[53645, 1594, 272, 8, 47, "Input",ExpressionUUID->"8b25707d-ded4-4793-9a9f-11afbaf33c81"],
Cell[53920, 1604, 541, 13, 47, "Input",ExpressionUUID->"ccb3e72a-f977-4ccb-9e1d-2afeae2c21e2"],
Cell[54464, 1619, 273, 8, 47, "Input",ExpressionUUID->"59e2f08f-9294-4d74-9e0a-e67647661c42"],
Cell[54740, 1629, 542, 13, 47, "Input",ExpressionUUID->"ffa6746b-6a97-43ad-ba17-3c4e7018f39a"],
Cell[55285, 1644, 275, 8, 47, "Input",ExpressionUUID->"1a6d78e6-fc9d-4f89-b3e5-f0e2b0917c79"],
Cell[55563, 1654, 186, 4, 47, "Input",ExpressionUUID->"54a5159a-365a-4ff6-87ee-8cdd2070b21e"],
Cell[55752, 1660, 340, 7, 70, "Input",ExpressionUUID->"66b236dc-ec83-49ce-b6d8-25c16028ad39"],
Cell[56095, 1669, 347, 5, 81, "Text",ExpressionUUID->"6997348e-b067-44cc-b2ce-c8016e317a9d"]
}, Closed]],
Cell[CellGroupData[{
Cell[56479, 1679, 419, 6, 54, "Subsubsection",ExpressionUUID->"5e4c78fb-c5e4-42bb-9127-1c29ebdf94ec"],
Cell[56901, 1687, 1010, 21, 123, "Input",ExpressionUUID->"a775cf17-e4e6-425c-a09c-394ff779ff96"],
Cell[57914, 1710, 836, 18, 174, "Input",ExpressionUUID->"26575267-5a76-40e7-913a-bf5f5dc1f1b1"],
Cell[58753, 1730, 475, 12, 70, "Input",ExpressionUUID->"bc661ef8-b6d0-4804-afbf-0b7c71a7f3bc"],
Cell[59231, 1744, 409, 9, 70, "Input",ExpressionUUID->"06f84df1-f4e5-4a47-bc8b-edf65cff43c4"],
Cell[59643, 1755, 539, 13, 70, "Input",ExpressionUUID->"8241247b-1966-4359-98b7-91dbf035b49d"],
Cell[60185, 1770, 544, 13, 70, "Input",ExpressionUUID->"c6b61053-1db3-4e4b-8cc2-93f3011b10b7"],
Cell[60732, 1785, 186, 4, 70, "Input",ExpressionUUID->"f0df06b9-6a4b-45fa-aeef-853e1bb4ef35"],
Cell[60921, 1791, 340, 7, 70, "Input",ExpressionUUID->"70d2f52c-1cf5-42df-aefa-0623a4bcee73"],
Cell[61264, 1800, 444, 7, 81, "Text",ExpressionUUID->"3879f509-6d82-4eb1-9011-bd852be4c95b"],
Cell[61711, 1809, 559, 15, 123, "Input",ExpressionUUID->"2c9aadda-6e5a-4b51-b9ea-1493c075b80a"],
Cell[62273, 1826, 310, 7, 135, "Text",ExpressionUUID->"96104d65-a51c-4945-8f3e-f8556af69636"],
Cell[62586, 1835, 218, 6, 70, "Input",ExpressionUUID->"d582b986-9d73-45ad-b4b7-aaffc12cdc0d"],
Cell[62807, 1843, 267, 5, 81, "Text",ExpressionUUID->"d67d4a4b-50e8-4229-80b4-d2b2a07e31e2"],
Cell[63077, 1850, 326, 7, 70, "Input",ExpressionUUID->"fa8634d7-c9b4-4d5e-8f79-28fbc4dc36b0"]
}, Closed]],
Cell[CellGroupData[{
Cell[63440, 1862, 491, 9, 94, "Subsubsection",ExpressionUUID->"e82824d8-2fdc-4276-b067-2942a38bf698"],
Cell[63934, 1873, 1467, 32, 850, "Input",ExpressionUUID->"973d820f-d9d4-4cb6-bbde-ad82536e119b"],
Cell[65404, 1907, 475, 12, 157, "Input",ExpressionUUID->"1b48f3e0-8d36-46da-8dbc-49eb1607b24c"],
Cell[65882, 1921, 409, 9, 157, "Input",ExpressionUUID->"3e15eb84-2147-47e8-9d8c-db6ed346ba7f"],
Cell[66294, 1932, 543, 13, 157, "Input",ExpressionUUID->"54d36b85-af96-48e4-b753-653d867bf937"],
Cell[66840, 1947, 541, 13, 157, "Input",ExpressionUUID->"1c2cbbc5-d4b3-4991-acad-6660bf51548c"],
Cell[67384, 1962, 186, 4, 157, "Input",ExpressionUUID->"14f2db35-0126-4203-8dd8-b4ce5328a567"],
Cell[67573, 1968, 464, 10, 157, "Input",ExpressionUUID->"bb140edf-00c0-43ac-b8c4-cc1f4a24d624"],
Cell[68040, 1980, 710, 12, 420, "Text",ExpressionUUID->"5ce71f58-5f44-4e8d-8124-dc4845ed2464"],
Cell[68753, 1994, 835, 25, 621, "Input",ExpressionUUID->"98fea9c6-bf4e-4c95-bb49-cc3e00f51916"],
Cell[69591, 2021, 475, 12, 157, "Input",ExpressionUUID->"42574e00-cfa2-4caf-86b3-cd40668dc3a6"],
Cell[70069, 2035, 409, 9, 157, "Input",ExpressionUUID->"d0101be2-2cda-48d1-80b0-6950624d3ae5"],
Cell[70481, 2046, 543, 13, 157, "Input",ExpressionUUID->"d9e5d69b-a105-4947-b455-c02e8ead00e9"],
Cell[71027, 2061, 541, 13, 157, "Input",ExpressionUUID->"e97da90b-5260-4adb-9377-4f5775fb67f9"],
Cell[71571, 2076, 186, 4, 157, "Input",ExpressionUUID->"2415da94-5a3a-4015-9ac4-03de56cdac97"],
Cell[71760, 2082, 464, 10, 157, "Input",ExpressionUUID->"95bd2cab-4045-43c3-896f-274104cac558"],
Cell[72227, 2094, 838, 13, 541, "Text",ExpressionUUID->"405c738c-86fd-422a-a79a-73b33ca06f94"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

