(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1076874,      25989]
NotebookOptionsPosition[    878617,      23642]
NotebookOutlinePosition[    883076,      23763]
CellTagsIndexPosition[    882454,      23737]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Vector and Tensor Algebra", "Title",
 CellChangeTimes->{{3.5584178762917657`*^9, 3.5584178826877766`*^9}},
 TextAlignment->Center,ExpressionUUID->"7a3cb9c1-fbd8-4cef-a882-4d48fed85a74"],

Cell["by", "Subsubtitle",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center,
 FontFamily->"Courier",
 FontSize->14,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[
  1],ExpressionUUID->"9d7f4dc2-c5a8-4185-ab99-98657cf078b1"],

Cell["Rolf Sulanke", "Text",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center,
 FontSize->24,ExpressionUUID->"a1ff6cb3-d013-4986-a8ba-ad202b9a8b70"],

Cell[TextData[{
 "Started June 26,  2012\nVersion 3,  May 14, 2015\nFinished May 26, 2017\n\
Created with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " v. 8.0.1, ..., 11.1.1"
}], "Text",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 CellChangeTimes->{{3.558417894808998*^9, 3.558417930673461*^9}, {
   3.563199901027878*^9, 3.563199939403945*^9}, {3.56985672528528*^9, 
   3.569856730588583*^9}, {3.5706907471198235`*^9, 3.5706907921103964`*^9}, {
   3.570708759443985*^9, 3.57070877561191*^9}, 3.570807674859434*^9, {
   3.57320361576565*^9, 3.5732036340368814`*^9}, 3.5734692026904864`*^9, {
   3.573819997663384*^9, 3.573820006278877*^9}, {3.603721027167802*^9, 
   3.6037210776386886`*^9}, {3.642500235608714*^9, 3.642500271114376*^9}, {
   3.642500319256061*^9, 3.6425003246068707`*^9}, {3.642500356321726*^9, 
   3.6425003672885456`*^9}, {3.64475861500676*^9, 3.644758686810087*^9}, {
   3.644758724910354*^9, 3.644758737833177*^9}, 3.6469182566338015`*^9, {
   3.673923898488579*^9, 3.673923939695668*^9}, 3.673931147816498*^9, {
   3.706256512970871*^9, 3.706256587231885*^9}},
 TextAlignment->Center,
 FontSize->14,ExpressionUUID->"f23c755f-87fc-48c1-8b91-3ffbc94f9f7f"],

Cell[CellGroupData[{

Cell["Introduction", "Section",
 CellChangeTimes->{{3.569397045427995*^9, 3.56939704813915*^9}, {
  3.5706941125583153`*^9, 
  3.570694117374591*^9}},ExpressionUUID->"c6bf7fdf-6fa8-4d2f-a6df-\
4e7fbf42d1c6"],

Cell[TextData[{
 "This notebook and the package tensalgv3.m contain besides of elementary \
vector algebra  a complete tensor algebra as a part of affine geometry. In ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " there doesn\[CloseCurlyQuote]t exist a built-in Tensor definition, but \
some tensor operations, like e.g. TensorProduct are built-in. In the notebook \
I define a symbolic  tensor   object which admits  to introduce covariant, \
contravariant and mixed type tensors. The concept can be used  for symbolic \
calculations as well as for calculations with tensors whose coordinates are \
numerically or functionally specified.  Tensor products, the wedge product as \
the base of exterior algebra, and contraction of tensors are introduced. \
Their properties are deduced and compared with the corresponding ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " built-in tensor functions. Since also in the commercial packages of  ",
 ButtonBox["Harald H. Soleng",
  BaseStyle->"Hyperlink",
  ButtonData->"Soleng"],
 ", Tensors in Physics, and Steven M. Christensen,",
 ButtonBox[" MathTensor",
  BaseStyle->"Hyperlink",
  ButtonData->"Christ"],
 ",  an abstract tensor concept is missing I hope that the notebook and the \
package presented here deliver useful tools for applications of ",
 StyleBox["Mathematica to problems in algebra,  geometry and physics needing \
tensor calculus",
  FontSlant->"Italic"],
 ". The analytic part of tensor calculus will be treated in connection with \
differential geometric applications in future notebooks. "
}], "Text",
 CellChangeTimes->{{3.568438134319354*^9, 3.5684381806982355`*^9}, {
   3.5684382634963627`*^9, 3.568438335688492*^9}, {3.5684383814721107`*^9, 
   3.5684383988001013`*^9}, {3.5684384312079554`*^9, 
   3.5684385201280413`*^9}, {3.5684386423920345`*^9, 3.568438716432269*^9}, {
   3.5684387492401457`*^9, 3.5684389197678995`*^9}, {3.568438958976142*^9, 
   3.56843903307238*^9}, {3.5684390862964244`*^9, 3.568439220248086*^9}, {
   3.5684392696509113`*^9, 3.5684392919451866`*^9}, {3.5684393322084894`*^9, 
   3.568439338895872*^9}, {3.5684394301840935`*^9, 3.568439523744445*^9}, {
   3.5684395881201267`*^9, 3.568439646504466*^9}, 3.568439676576186*^9, {
   3.5684398734484468`*^9, 3.5684399654077063`*^9}, {3.5684401583197403`*^9, 
   3.5684403031490245`*^9}, 3.568440446419219*^9, {3.5684458955106754`*^9, 
   3.5684459846197724`*^9}, {3.568447670207962*^9, 3.5684476702189627`*^9}, {
   3.5684477091911917`*^9, 3.5684477092021923`*^9}, {3.570691203638935*^9, 
   3.570691270782775*^9}, {3.5706913604629045`*^9, 3.570691482358876*^9}, {
   3.5706915373500223`*^9, 3.570691588230932*^9}, {3.570691624719019*^9, 
   3.570691717646334*^9}, 3.5706922133776884`*^9, 3.6011841309693975`*^9, {
   3.6425747762195597`*^9, 3.642574777280362*^9}, 
   3.706253535701*^9},ExpressionUUID->"584f472a-9774-4eab-af29-4033def96335"],

Cell[TextData[{
 "This notebook starts with  basic concepts of vector and matrix calculus as \
far as they are independent of scalar products, developed and used in  affine \
or projective geometry. These concepts are contained and treated more \
detailed in the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notebook vectoralgebra.nb.  The present  notebook is a revision and \
enlargement of  the notebook vectoralgebra.nb now completed with basic \
concepts of tensor algebra.  The  new defined  ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " functions are collected in the package tensalgv3.m which contains the \
package vectorcalc.m.   The theoretical background can be found in  textbooks \
of  linear algebra, e.g. in [",
 ButtonBox["Mal",
  BaseStyle->"Hyperlink",
  ButtonData->"Mal"],
 "], [",
 ButtonBox["OSI] and [OSII].",
  BaseStyle->"Hyperlink",
  ButtonData:>"OSI"]
}], "Text",
 CellChangeTimes->{
  3.5584180081587973`*^9, {3.5584180385320506`*^9, 3.5584180912601433`*^9}, {
   3.558418143738635*^9, 3.558418162926669*^9}, {3.5584181966227283`*^9, 
   3.558418222300373*^9}, {3.5584182941384993`*^9, 3.5584182975705056`*^9}, {
   3.558418365586625*^9, 3.5584183758046427`*^9}, {3.558418492546014*^9, 
   3.558418617903184*^9}, 3.558418654971304*^9, {3.558418710518481*^9, 
   3.5584187788463893`*^9}, {3.55841919444716*^9, 3.5584192029266453`*^9}, {
   3.558419233063369*^9, 3.558419313887992*^9}, {3.5584193500030575`*^9, 
   3.558419380054776*^9}, {3.5584194478176517`*^9, 3.558419455318081*^9}, {
   3.5584194965694404`*^9, 3.558419521494866*^9}, {3.558419556982896*^9, 
   3.558419587510642*^9}, {3.558429626089975*^9, 3.5584296590372324`*^9}, {
   3.558429705353714*^9, 3.5584297482225895`*^9}, 3.559817400292266*^9, 
   3.5684404742468104`*^9, 3.568447962697692*^9, {3.5706918029192114`*^9, 
   3.5706918155899363`*^9}, {3.5706918567302895`*^9, 
   3.5706918567442904`*^9}, {3.5706942056066375`*^9, 3.570694206190671*^9}, {
   3.5706943038632574`*^9, 3.570694306743422*^9}, {3.570694759438315*^9, 
   3.570694809912202*^9}, {3.5707051807092934`*^9, 3.5707051935800295`*^9}, {
   3.570705225317845*^9, 3.5707052268839345`*^9}, 3.570705259428796*^9, {
   3.642500054383196*^9, 3.6425000565048*^9}, 
   3.706253585205575*^9},ExpressionUUID->"ae4c4844-789c-480e-af08-\
28cc0440ce3c"],

Cell[TextData[{
 "For all comments, in particular for hints about possible failures or \
deficiencies, the author will be very grateful. Please send all comments to \
the ",
 ButtonBox["address",
  BaseStyle->"Hyperlink",
  ButtonData->"address"],
 " (see the end of the notebook)."
}], "Text",
 CellChangeTimes->{{3.5706948165665827`*^9, 3.5706948246860466`*^9}, {
   3.570694870934692*^9, 3.5706948953580885`*^9}, {3.5706951095503397`*^9, 
   3.5706952357425575`*^9}, {3.5707054544999533`*^9, 3.570705457227109*^9}, {
   3.642500159901781*^9, 3.642500212723474*^9}, 3.6425748819253454`*^9, 
   3.673924266774289*^9, {3.72629196000937*^9, 3.7262920214479637`*^9}, {
   3.72629206666383*^9, 
   3.726292093463274*^9}},ExpressionUUID->"b3d00bc6-4770-4252-b13e-\
def52d24b8e3"],

Cell[CellGroupData[{

Cell["Keywords", "Subsection",ExpressionUUID->"e0029f8f-a176-4c6b-bb8c-7182f2cfefb9"],

Cell["\<\
vector objects, null vector, basis vectors, covector, random vector,  linear \
forms, matrix, random matrix, rank, transposed matrix, tensor,  symmetric, \
antisymmetric, covariant, contravariant, mixed type, symmetrize, alternate, \
tensor product, p-forms, p-vectors,  contraction, epsilon tensor, basis \
tensors, tensor coordinates, wedge product,  strict coordinates, Array.\
\>", "Text",
 CellChangeTimes->{{3.5706930146305175`*^9, 3.570693032014512*^9}, 
   3.5706931463500514`*^9, 3.570693186262334*^9, {3.5706933008228865`*^9, 
   3.5706935521822634`*^9}, {3.5706947060142593`*^9, 
   3.5706947097424726`*^9}, {3.6038784713640223`*^9, 3.603878486636449*^9}, {
   3.6038785352773347`*^9, 3.6038785402537436`*^9}, {3.603878573497402*^9, 
   3.603878619845083*^9}, 3.6038786518719397`*^9, {3.6425749250906215`*^9, 
   3.6425749536698713`*^9}},ExpressionUUID->"e2f041e7-3e84-4589-b71a-\
744adcbec5ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hints", "Subsection",ExpressionUUID->"3a616cd7-2ed9-4988-be74-503cc954fe7f"],

Cell[TextData[{
 StyleBox["Initialization:",
  FontColor->RGBColor[1, 0, 0]],
 " Before starting interactive work with this notebook,  read the next \
section carefully and follow the instructions given there!"
}], "Text",ExpressionUUID->"630460a9-65ba-42b6-bfa9-755038eec217"],

Cell[TextData[{
 StyleBox["Hyperlinks",
  FontColor->RGBColor[1, 0, 0]],
 " to other places of this notebook are marked by colored text, e.g.  ",
 ButtonBox["address",
  BaseStyle->"Hyperlink",
  ButtonData:>"address"],
 ". A mouse click on such text brings you to the linked place, and by the \
toolbar  button ",
 "\[LeftPointer] (\[OpenCurlyDoubleQuote]Go Back\[CloseCurlyDoubleQuote])",
 " you return to the subsection containing the link."
}], "Text",
 CellChangeTimes->{{3.5662745973460584`*^9, 3.56627461552009*^9}, {
  3.570693648534775*^9, 3.570693661670526*^9}, {3.570693868726369*^9, 
  3.5706939521661415`*^9}, {3.570693987247148*^9, 
  3.5706940123825855`*^9}},ExpressionUUID->"628bcc96-d3b6-4f6f-b555-\
b1877d2468cc"],

Cell[TextData[{
 StyleBox["Blue text",
  FontColor->RGBColor[1, 0, 0]],
 " marks places at which the marked concepts are defined or emphasized."
}], "Text",ExpressionUUID->"0cb6d1b4-1b55-479d-976e-7ba6f0b3f10a"],

Cell[TextData[{
 StyleBox["Warnings",
  FontColor->RGBColor[1, 0, 0]],
 " are contained in subsection 1.1; read it!"
}], "Text",
 CellChangeTimes->{{3.570708326692233*^9, 
  3.5707083961712074`*^9}},ExpressionUUID->"4a015890-a465-4471-afa7-\
e0909e6077c8"],

Cell[TextData[{
 StyleBox["New versions",
  FontColor->RGBColor[1, 0, 0]],
 "  of the present notebook and the package tensalgv3.m may appear on my ",
 ButtonBox["homepage",
  BaseStyle->"Hyperlink",
  ButtonData->"hp"],
 ", control it!"
}], "Text",
 CellChangeTimes->{{3.5707085254506016`*^9, 3.570708609235394*^9}, {
   3.570708692246142*^9, 3.5707086922541423`*^9}, 3.6425750350864143`*^9, 
   3.7062535972070713`*^9},ExpressionUUID->"f5f95a54-842b-4912-8b5d-\
3c5b1bc53803"]
}, Closed]],

Cell[CellGroupData[{

Cell["Copyright", "Subsection",
 CellTags->"copyrigt",ExpressionUUID->"d9995966-16d3-4b32-9aa3-2ebe9dfb5607"],

Cell["\<\
This notebook, the linked notebooks, and the accompanying packages are  \
public. Authors who intend to publish a changed or completed version of them \
should do it under their own names, and under the condition that they cite \
the original notebook with the Internet address or other source where they \
got it. I am not responsible for errors or damages originated by the use of \
the procedures contained in my notebooks or packages; anybody who applies \
them should test carefully whether they are appropriate for his purposes.\
\>", "Text",ExpressionUUID->"ab65e885-a2fa-4ce7-a829-9bd7bff18708"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Initialization ", "Section",
 CellChangeTimes->{
  3.6020844120258913`*^9},ExpressionUUID->"b8220ee8-69d5-4891-82d8-\
45fa6a0bdb59"],

Cell[CellGroupData[{

Cell["A Needed Package", "Subsection",
 CellChangeTimes->{{3.570705586860524*^9, 3.5707055929228706`*^9}, 
   3.570717133816311*^9},ExpressionUUID->"b2ed37fb-c22f-4ebe-8982-\
5b2b6b9f8ee4"],

Cell[TextData[{
 "In the notebook we apply many constructs of  linear algebra, defined in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", or in our new developed package tensalgv3.m.  Before initializing the \
notebook ensure that this package is in your working directory. "
}], "Text",
 CellChangeTimes->{{3.5584298903405323`*^9, 3.5584298945213394`*^9}, {
   3.558429931633805*^9, 3.5584299353778114`*^9}, {3.570705623203603*^9, 
   3.570705643403758*^9}, {3.5707056824029884`*^9, 3.5707057487877855`*^9}, {
   3.570705813451484*^9, 3.5707058151955843`*^9}, 3.6425750430580287`*^9, 
   3.706253599778221*^9},ExpressionUUID->"93e8246f-3e75-4d8f-800c-\
4a10529f444e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Preparation: Path of the Working Directory", "Subsection",
 CellChangeTimes->{{3.570717143031838*^9, 
  3.5707171500472393`*^9}},ExpressionUUID->"5c59c3f8-e23d-4936-a5d5-\
87a1a352405f"],

Cell["\<\
Enter the path of your working directory before first using this notebook on \
your computer.  If this is done once, and if the package  \"tensalgv3.m\"  is \
in this directory,   you may start calling the initialization as described in \
the next subsection. \
\>", "Text",
 CellChangeTimes->{{3.5707058621882715`*^9, 3.5707059246198425`*^9}, {
   3.5707059823641453`*^9, 3.570706002795314*^9}, {3.5707060375483017`*^9, 
   3.57070604031546*^9}, {3.6425750475040364`*^9, 3.6425750534788465`*^9}, {
   3.6739244958925447`*^9, 3.673924507700356*^9}, 
   3.706253603073251*^9},ExpressionUUID->"5afebb0b-cf51-42b6-90b2-\
374ba495b2aa"],

Cell[TextData[StyleBox["At the moment, DO NOT CONFIRM THE EVALUATION OF THE \
INITIALIZATION CELLS !",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0, 0]]], "Text",ExpressionUUID->"0a4b15d6-0ca2-4d98-\
9f6c-04c192a2688b"],

Cell["If the result of the following command ", "Text",ExpressionUUID->"9b811685-72c3-417b-a270-ca7ecddeabeb"],

Cell[BoxData[
 RowBox[{"Directory", "[", "]"}]], "Input",
 FontFamily->"Times",ExpressionUUID->"4065e14c-0e9d-400f-a301-5660b31d3932"],

Cell["\<\
does not coincide with the working directory, e.g. \"C:\\Eigene \
Dateien\\mymath\", containing the needed packages, insert the Path of your \
working directory in the next command line (corresponding to your  operating \
system) and activate it first, without calling the initialization:\
\>", "Text",
 CellChangeTimes->{
  3.5584299656106644`*^9},ExpressionUUID->"1a2e2e1c-fe07-4537-afc3-\
498b481972d5"],

Cell[TextData[StyleBox["For Windows:",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 FontSize->18,ExpressionUUID->"e0d0ad97-e2f6-4285-8b53-c847b1c974f6"],

Cell[BoxData[
 RowBox[{"SetDirectory", "[", "\"\<E:\\\\mymath\\\\diffgeo\\\\riemann\>\"", 
  "]"}]], "Input",
 Evaluatable->False,
 InitializationCell->True,
 CellChangeTimes->{{3.5543528910469513`*^9, 3.554352936708232*^9}, {
   3.554352966863085*^9, 3.554352997485938*^9}, {3.5600552135423*^9, 
   3.560055215351904*^9}, 3.5600799593896356`*^9, 3.561870189072383*^9, 
   3.5619003467929087`*^9, 3.5624268666400847`*^9, 3.562574179058276*^9, 
   3.5630773271399536`*^9, 3.563116685108138*^9, 3.567313038263877*^9, 
   3.5674928384579225`*^9, 3.567916372074399*^9, 3.567954790405074*^9, 
   3.568521924996272*^9, 3.5686158274674397`*^9, 3.5691245501437407`*^9, {
   3.5691620740284*^9, 3.5691620922804317`*^9}, 3.569163077986909*^9, 
   3.5707215735829573`*^9, 3.5708096224404593`*^9, 3.570942886973011*^9, 
   3.571041195931925*^9, {3.59982028038885*^9, 3.599820283618056*^9}, 
   3.6038781114401903`*^9, {3.6093119898974123`*^9, 3.6093120092245173`*^9}, {
   3.6397395072978*^9, 3.639739540666259*^9}, {3.673924597179748*^9, 
   3.673924608011682*^9}, {3.7061660086519012`*^9, 3.706166013267489*^9}},
 FontFamily->"Times",ExpressionUUID->"2d5526e8-878a-44f8-af7c-7f731f59d617"],

Cell[BoxData["$Path"], "Input",
 CellChangeTimes->{{3.5998203348953457`*^9, 
  3.5998203389669533`*^9}},ExpressionUUID->"2d72d54b-241a-49a9-b359-\
4af3f62722ce"],

Cell[TextData[StyleBox["For Linux:",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 FontSize->18,ExpressionUUID->"aa8fc821-b67d-4231-ba8a-8cb3ec27bbcc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", "\"\<~/mymath/diffgeo/DiffGeoCourse\>\"", 
  "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.673924671420732*^9, 3.673924684387515*^9}},
 FontFamily->"Times",ExpressionUUID->"d0f08dd3-fe76-406d-8def-b1c3d6a1764a"],

Cell[BoxData[
 TemplateBox[{
  "SetDirectory","cdir",
   "\"Cannot set current directory to \
\\!\\(\\*RowBox[{\\\"\\\\\\\"/home/rolf/mymath/diffgeo/DiffGeoCourse\\\\\\\"\\\
\"}]\\).\"",2,5,2,30212879271806068125,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.7061660217081957`*^9},ExpressionUUID->"61840f20-4b1b-46af-98fd-\
c5828f976d16"],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{
  3.706166021714285*^9},ExpressionUUID->"d3737406-a808-42c8-b4bf-\
f93fc841cad1"]
}, Open  ]],

Cell[BoxData["\"\</home/rolf/mymath/diffgeo/riemann\>\""], "Input",
 CellChangeTimes->{{3.706165986267591*^9, 
  3.706165989155684*^9}},ExpressionUUID->"0a3b7508-0bef-413d-a97f-\
3f25614d0574"],

Cell["\<\
Now give the cell corresponding to your  operating system the properties \
\"Cell Evaluatable\" and \"Initialization cell\" (Menu Cell/Cell Properties), \
and inactivate these properties for the corresponding cells of the other \
operating system. If this is done, save the notebook. Next time you may start \
the notebook directly with the evaluation of the initialization, as follows:\
\>", "Text",
 CellChangeTimes->{
  3.6425750868629055`*^9},ExpressionUUID->"f7ec43d0-55c0-4228-8056-\
2b9793602032"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Initialization", "Subsection",ExpressionUUID->"fe372fbd-799b-428c-a373-5c0c6f61f252"],

Cell["IMPORTANT!", "Text",
 FontSize->18,
 FontWeight->"Bold",
 FontColor->RGBColor[
  1, 0, 0],ExpressionUUID->"fb076f96-9fe0-413b-95d8-add0a98d0b74"],

Cell["\<\
Before starting to work interactively with the notebook, first do the \
following three steps:\
\>", "Text",
 CellChangeTimes->{{3.6033504979359365`*^9, 3.603350503005945*^9}, 
   3.700364920699733*^9},ExpressionUUID->"51153376-9fa3-4e9f-b276-\
41cfc213195c"],

Cell["\<\
1. Activate Kernel/Evaluation/Evaluate Initialization from the menu.\
\>", "Text",
 Evaluatable->False,
 CellChangeTimes->{3.6033505179195714`*^9, 3.6035230904343643`*^9, 
  3.6425751723426824`*^9},
 FontSize->16,
 FontWeight->"Bold",
 FontColor->RGBColor[
  1, 0, 0],ExpressionUUID->"b853e6cd-3401-4f7b-b3df-62009c60cb84"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<tensalgv3`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5584299969043193`*^9, 3.558429999993125*^9}, {
   3.6397394726189394`*^9, 3.639739474116542*^9}, 
   3.700364941855115*^9},ExpressionUUID->"773bcb6c-6811-4976-ad17-\
0fe9792c172e"],

Cell["\<\
2. Inactivate the Menu item \[OpenCurlyDoubleQuote]Evaluation/Dynamic \
Updating Enabled \[OpenCurlyDoubleQuote]\
\>", "Text",
 Evaluatable->False,
 CellChangeTimes->{
  3.6033505179195714`*^9, 3.603350569025261*^9, {3.6033506072765284`*^9, 
   3.6033506392409844`*^9}, {3.603350700876693*^9, 3.6033507059779015`*^9}, 
   3.6035230952079725`*^9},
 FontSize->16,
 FontWeight->"Bold",
 FontColor->RGBColor[
  1, 0, 0],ExpressionUUID->"6855cf15-f613-4c97-8ab4-ae8b7d0077af"],

Cell["\<\
If this property is enabled, some functions, e.g. TensorRank, don\
\[CloseCurlyQuote]t work.\
\>", "Text",
 CellChangeTimes->{{3.6033507881359043`*^9, 
  3.6033508948880105`*^9}},ExpressionUUID->"a2f0ea75-968d-4739-b46a-\
b77476921ed0"],

Cell[TextData[StyleBox["3. Set the dimension:",
 FontSize->18,
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{
  3.60335052295838*^9},ExpressionUUID->"d40829f9-654c-486f-b786-412baba5ba74"],

Cell["\<\
In most applications of  vectors and tensors an underlying space or a \
manifold is given. Its dimension dim is set in the next cell:\
\>", "Text",
 CellChangeTimes->{{3.570706319276416*^9, 3.5707064133877983`*^9}, {
   3.570706457403316*^9, 3.57070651674771*^9}, {3.600576538834751*^9, 
   3.6005768261092553`*^9}, {3.60057690278339*^9, 3.6005769354810476`*^9}, 
   3.6035231463916626`*^9, 3.642575191111515*^9, {3.673927644851192*^9, 
   3.673927664354907*^9}},ExpressionUUID->"40d86e48-99d3-4f5b-9b94-\
d025a60b87b9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dim", " ", "=", " ", "3"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.6004023609115477`*^9},ExpressionUUID->"b6bbc1cf-9200-4008-a078-\
4ced2c8afa78"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{3.673924916042416*^9, 3.673927702930722*^9, 
  3.673931272345868*^9, 
  3.706166021755986*^9},ExpressionUUID->"0303cbc5-160b-4430-88a0-\
bac495742186"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Remark \n",
  FontSize->16,
  FontColor->RGBColor[0, 0, 1]],
 "The global constant ",
 StyleBox["dim",
  FontColor->RGBColor[0, 0, 1]],
 " appears in many functions as default argument of the dimension; without \
fixing it as a positive integer many error messages will be created, and they \
will not work. The order in which the two steps are carried out is deciding: \
In case you fixed the dimension dim already before evaluating the \
initialization cells, it will be fixed for all the concepts as the default \
value of this variable.  Fixing it after the Initialization makes it possible \
to change the value of dim any time, if wanted."
}], "Text",ExpressionUUID->"103256ad-ac0f-437f-a569-1fb59269b765"],

Cell[CellGroupData[{

Cell["Test: dim", "Subsubsection",ExpressionUUID->"6ca11b69-3e0b-4d52-95ba-6b3e032f7990"],

Cell[BoxData[
 RowBox[{"?", "dim"}]], "Input",ExpressionUUID->"28e2ff33-5709-4f3c-a735-c44437e968ac"],

Cell[BoxData[
 RowBox[{"Context", "[", "dim", "]"}]], "Input",ExpressionUUID->"9f1510b1-e4dd-4ce0-8ef9-748efe10083f"],

Cell[BoxData[
 RowBox[{"vec", "[", "x", "]"}]], "Input",ExpressionUUID->"b12c6e7f-d8b9-42a5-9f0d-439be3566a1c"],

Cell[BoxData[
 RowBox[{"dim", " ", "=", " ", "6"}]], "Input",ExpressionUUID->"fd1d6458-615a-482d-a6b7-719b4cedb327"],

Cell[BoxData[
 RowBox[{"?", "randomv"}]], "Input",
 CellChangeTimes->{{3.570706647800206*^9, 
  3.570706652201458*^9}},ExpressionUUID->"6f15352d-09f6-44e2-b685-\
82a0173e1402"],

Cell[BoxData[
 RowBox[{"randomv", "[", "]"}]], "Input",ExpressionUUID->"aabb718e-7f86-444a-868e-0e0b8db5afa1"],

Cell["We reset the dimension;", "Text",
 CellChangeTimes->{{3.5707067232115197`*^9, 
  3.5707067324430475`*^9}},ExpressionUUID->"7a86c35e-afc0-41b3-ab55-\
9ece487dced8"],

Cell[BoxData[
 RowBox[{"dim", " ", "=", " ", "3"}]], "Input",
 CellChangeTimes->{
  3.6005770036375675`*^9},ExpressionUUID->"b64b2f1e-361d-445b-93e5-\
ac9aa0b6df8c"]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1.  List of Symbols and their Usages", "Section",
 CellChangeTimes->{{3.561616362624016*^9, 
  3.561616369285228*^9}},ExpressionUUID->"076ec018-b557-4135-b673-\
898e146969ee"],

Cell[TextData[{
 StyleBox["Remark \n",
  FontSize->16,
  FontColor->RGBColor[0, 0, 1]],
 "For the notations  ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " commonly uses the convention that the names of built-in functions or \
objects start with a capital letter. In my notebooks and packages I name all \
the newly introduced functions starting with small letters."
}], "Text",
 CellChangeTimes->{{3.600674062874694*^9, 3.600674077857551*^9}, {
  3.60067411665677*^9, 3.6006741671046553`*^9}, {3.6006742244249344`*^9, 
  3.600674258920907*^9}, {3.6006745671855392`*^9, 3.6006746624809895`*^9}, {
  3.600674727817727*^9, 
  3.6006747417215223`*^9}},ExpressionUUID->"63bb9b42-e478-4595-ab1d-\
ee0e586ff56f"],

Cell[CellGroupData[{

Cell["1.1.  Algebraic Operations for Functions", "Subsection",
 CellChangeTimes->{{3.561271609148735*^9, 3.561271666541236*^9}, {
   3.561296309489132*^9, 3.5612963106631994`*^9}, 3.5612963929689074`*^9, {
   3.5998845057368946`*^9, 3.5998845328029423`*^9}, 3.599884577809021*^9, {
   3.6005770584716635`*^9, 3.6005770751792927`*^9}, {3.600610129547908*^9, 
   3.6006101490011425`*^9}},ExpressionUUID->"69d3cc24-4270-4bad-86da-\
2a079c0b56ff"],

Cell[CellGroupData[{

Cell["1.1.1 Addition of Functions", "Subsubsection",
 CellChangeTimes->{{3.5612716842316675`*^9, 3.5612716981780915`*^9}, {
  3.5614504961583567`*^9, 3.5614505069409733`*^9}, {3.566915203024149*^9, 
  3.5669152095185204`*^9}},ExpressionUUID->"d91a70bb-400f-4a2d-b6e8-\
559f4ce353e4"],

Cell["\<\
The built-in function Plus acts on the values; it makes no sense to apply it \
to the functions:\
\>", "Text",
 CellChangeTimes->{{3.6001519706154785`*^9, 3.600152018304762*^9}, 
   3.600577095178528*^9, 
   3.6424259834655647`*^9},ExpressionUUID->"35997699-af44-4535-a0ac-\
12317f71e64a"],

Cell[BoxData[
 RowBox[{"h", " ", "=", 
  RowBox[{"Plus", "[", 
   RowBox[{"f", ",", "Cos", ",", "Sin", ",", "Pi"}], " ", "]"}]}]], "Input",
 CellChangeTimes->{{3.6001516865545793`*^9, 3.6001516980673995`*^9}, {
  3.6002357781235027`*^9, 
  3.6002357860015163`*^9}},ExpressionUUID->"4dddc099-7c85-4faa-a15a-\
3f752a138126"],

Cell[BoxData[
 RowBox[{"h", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.6001517104226213`*^9, 3.6001517139014273`*^9}, 
   3.6002357957671337`*^9},ExpressionUUID->"b1230c31-d48b-44e2-924b-\
ec8461ad9a51"],

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"x", "\[Rule]", " ", "Pi"}]}]], "Input",
 CellChangeTimes->{{3.6001517305934567`*^9, 
  3.600151739064272*^9}},ExpressionUUID->"41446a46-d984-4997-b3bc-\
ceadf3c66eda"],

Cell["\<\
Of course, one may define the sum of the functions for any given family of \
summands using the values for the argument pattern x:\
\>", "Text",
 CellChangeTimes->{{3.6001520386003976`*^9, 
  3.60015216549102*^9}},ExpressionUUID->"2660d817-cf71-4fda-b8f7-\
fbd13c0724e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "h", "]"}], ";", 
  RowBox[{
   RowBox[{"h", "[", "x_", "]"}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{"Cos", "[", "x", "]"}], ",", 
     RowBox[{"Sin", "[", "x", "]"}], ",", "Pi"}], " ", "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6001518549880753`*^9, 3.600151903800561*^9}, {
  3.600235830945195*^9, 3.600235848822827*^9}, {3.6002358884468966`*^9, 
  3.6002358942501063`*^9}},ExpressionUUID->"b9dd1ca7-8e85-4a27-b15d-\
3dfd633ae28b"],

Cell[TextData[{
 "In ",
 StyleBox["mathemati",
  FontSlant->"Italic"],
 "cs, in particular, in defining tensors, one needs operations with functions \
as objects, not only with their evaluations. Therefore we added in \
tensalgv3.m an operation plus  for the addition of  functions:"
}], "Text",
 CellChangeTimes->{{3.559817601682785*^9, 3.5598176404990053`*^9}, {
   3.5612719936894107`*^9, 3.56127205011471*^9}, {3.561296427952908*^9, 
   3.561296513255787*^9}, {3.5613610267046576`*^9, 3.5613610336622696`*^9}, {
   3.56145052734114*^9, 3.5614505351175847`*^9}, {3.5669143557906895`*^9, 
   3.5669144966387453`*^9}, {3.5670743580281096`*^9, 
   3.5670743697437305`*^9}, {3.569295713014851*^9, 3.5692957975357995`*^9}, {
   3.599836113577875*^9, 3.599836130051504*^9}, {3.60001030094491*^9, 
   3.6000103478645935`*^9}, {3.6424260389392614`*^9, 
   3.6424260585952964`*^9}, {3.642576193533174*^9, 3.642576210291604*^9}, 
   3.7062536052969313`*^9},ExpressionUUID->"9daf1114-b743-4d2f-b95d-\
ab768644bbdb"],

Cell[BoxData[
 RowBox[{"h", "[", "Pi", "]"}]], "Input",
 CellChangeTimes->{{3.599977325209493*^9, 3.5999773291875*^9}, {
  3.599981239880369*^9, 
  3.599981248897185*^9}},ExpressionUUID->"0d8e290d-6dda-4309-b62f-\
358ec0f04d35"],

Cell[BoxData[
 RowBox[{"?", "plus"}]], "Input",
 CellChangeTimes->{{3.6000080922823534`*^9, 3.600008167271685*^9}, 
   3.6000081982221394`*^9, {3.600009333935334*^9, 3.600009500403227*^9}, {
   3.6000095366108904`*^9, 3.600009571866952*^9}, {3.6000096803394136`*^9, 
   3.6000097933078747`*^9}, {3.6000098434217415`*^9, 3.600009958037297*^9}, 
   3.600010224980565*^9, {3.60032348211814*^9, 3.600323503536978*^9}, {
   3.600518856541731*^9, 
   3.600518865137346*^9}},ExpressionUUID->"65732ff2-8480-4593-9a56-\
536ac58128a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"plus", "[", "f___", "]"}], "[", "x__", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ff", ",", "n", ",", "i", ",", 
      RowBox[{"hh", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"ff", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", "f", "}"}], "]"}]}], ";", 
     RowBox[{"n", "=", 
      RowBox[{"Length", "[", "ff", "]"}]}], ";", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "<", 
        RowBox[{"n", "+", "1"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"NumberQ", "[", 
          RowBox[{"ff", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"hh", ",", 
           RowBox[{"ff", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"hh", ",", 
           RowBox[{
            RowBox[{"ff", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", "x", "]"}]}], "]"}]}], 
        "]"}]}], "]"}], ";", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"hh", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.59997615055863*^9, {3.599976202818722*^9, 3.599976209277133*^9}, {
   3.5999771264027443`*^9, 3.5999771638116093`*^9}, {3.5999772819194174`*^9, 
   3.5999773037594557`*^9}, {3.599977471990151*^9, 3.5999774931437883`*^9}, {
   3.5999775645763135`*^9, 3.599977622561616*^9}, {3.5999776544480715`*^9, 
   3.599977664369689*^9}, {3.599978062497988*^9, 3.599978071436804*^9}, {
   3.5999787588988113`*^9, 3.5999788889094396`*^9}, {3.5999790114944553`*^9, 
   3.599979099041809*^9}, {3.5999791734071393`*^9, 3.599979187556364*^9}, {
   3.5999792934493504`*^9, 3.5999793073489747`*^9}, {3.599979340655033*^9, 
   3.5999794107771564`*^9}, {3.5999794526476297`*^9, 3.599979562799423*^9}, {
   3.5999795956842813`*^9, 3.599979650190777*^9}, {3.599979979959756*^9, 
   3.599979989054572*^9}, {3.5999803550312147`*^9, 3.5999804376645603`*^9}, {
   3.5999804961802626`*^9, 3.5999805306095233`*^9}, {3.599980576567204*^9, 
   3.5999806825693903`*^9}, {3.5999807196506553`*^9, 3.599980803079602*^9}, {
   3.599980843265272*^9, 3.5999810180479794`*^9}, 3.5999951552629623`*^9, {
   3.5999952079754543`*^9, 3.5999952103310585`*^9}, {3.599995240797912*^9, 
   3.59999534215129*^9}, {3.599995405237801*^9, 3.599995479837132*^9}, {
   3.5999955860421185`*^9, 3.599995593077731*^9}, {3.599995657053443*^9, 
   3.599995659299847*^9}, {3.5999956993139176`*^9, 3.5999957791236577`*^9}, {
   3.5999958276709433`*^9, 3.599995857763396*^9}, {3.599995893175458*^9, 
   3.5999958939710593`*^9}, {3.5999961404046926`*^9, 3.599996164537935*^9}, {
   3.599996354140668*^9, 3.5999963614882803`*^9}, 3.5999965360369873`*^9, 
   3.599997002212606*^9, 3.5999970420550756`*^9, {3.5999970822407465`*^9, 
   3.599997137839244*^9}, {3.599997173516507*^9, 3.599997177634914*^9}, {
   3.59999737467886*^9, 3.5999973755836616`*^9}, {3.59999741431853*^9, 
   3.599997415051731*^9}, {3.599997450385793*^9, 3.5999974740354347`*^9}, {
   3.5999975275123286`*^9, 3.5999975291971316`*^9}, {3.599997895423375*^9, 
   3.5999978960941763`*^9}, 3.599998160686241*^9, {3.5999981907162933`*^9, 
   3.599998192307496*^9}, {3.599998246907592*^9, 3.5999982507451987`*^9}, {
   3.599998648701898*^9, 3.5999987191828213`*^9}, {3.5999987714897137`*^9, 
   3.599998806355775*^9}, {3.5999988905179224`*^9, 3.5999989372400045`*^9}, {
   3.5999989743524694`*^9, 3.5999990539126096`*^9}, {3.5999990879362693`*^9, 
   3.599999119136324*^9}, 3.5999991722700176`*^9, 3.5999992041564736`*^9, {
   3.5999992544197617`*^9, 3.599999266244582*^9}, {3.600006957832761*^9, 
   3.600006977114395*^9}, {3.600145016232464*^9, 3.6001450189000683`*^9}, {
   3.600145062439745*^9, 3.6001451575219116`*^9}, {3.600145252073678*^9, 
   3.600145271105711*^9}, {3.6001453048797703`*^9, 3.6001453687462826`*^9}, 
   3.60014550398292*^9, {3.600149590160497*^9, 3.600149659674219*^9}, {
   3.600149693089478*^9, 3.6001497221367292`*^9}, {3.600149763742002*^9, 
   3.6001497776416264`*^9}, {3.6001500676461363`*^9, 
   3.6001500687693377`*^9}, {3.600150837850689*^9, 3.600150839332691*^9}, {
   3.600236668214266*^9, 3.600236678494684*^9}, {3.6002367884748774`*^9, 
   3.600236799800497*^9}, {3.600265200716505*^9, 3.600265227688952*^9}, {
   3.6002652603866096`*^9, 3.6002653968868494`*^9}, {3.600265884247305*^9, 
   3.6002658974761286`*^9}, 3.6002659448846116`*^9, {3.6002661635189953`*^9, 
   3.60026618311263*^9}, 3.600266510838006*^9, {3.6002665504776754`*^9, 
   3.6002665772941227`*^9}, {3.6002670859174156`*^9, 3.6002672079564304`*^9}, 
   3.600267245053295*^9, 3.6002672910577765`*^9, {3.600267409430784*^9, 
   3.6002674383844347`*^9}, {3.600267471409693*^9, 3.600267494154533*^9}, {
   3.6002675328894005`*^9, 3.60026759505551*^9}, {3.600267778277832*^9, 
   3.600267795250662*^9}, {3.6002678713631954`*^9, 3.600267887072423*^9}, 
   3.6002680349450827`*^9, {3.6002681932073607`*^9, 3.600268196124566*^9}, {
   3.60026851160392*^9, 3.6002685488567853`*^9}, {3.6002687469459333`*^9, 
   3.600268782279995*^9}, {3.60032156905558*^9, 3.600321575794792*^9}, 
   3.6003216262608805`*^9, 3.6005188864625835`*^9, 3.642426110278187*^9, {
   3.6424261686690893`*^9, 3.6424261899163265`*^9}, 3.6424780508325615`*^9, 
   3.642478097471044*^9, 
   3.6424803231047754`*^9},ExpressionUUID->"f59bba3d-0a03-448b-99d8-\
75a8b34e37c6"],

Cell["The Attributes of plus and of Plus:", "Text",
 CellChangeTimes->{{3.642426428565546*^9, 3.6424264581899977`*^9}, {
  3.6424803480844193`*^9, 
  3.6424803493500214`*^9}},ExpressionUUID->"b5ca4239-e698-4788-b926-\
3279807ab1de"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "plus", "]"}]], "Input",
 CellChangeTimes->{{3.6424262703188677`*^9, 3.6424262820188885`*^9}, 
   3.642480361988044*^9},ExpressionUUID->"d880de32-fed9-420b-905d-\
3f921192c8b3"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "Plus", "]"}]], "Input",
 CellChangeTimes->{3.642426208199559*^9, 
  3.6424803727364626`*^9},ExpressionUUID->"1566462c-5a56-4da9-a717-\
0d062b4c4458"],

Cell[BoxData[""], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.59997615055863*^9, {3.599976202818722*^9, 3.599976209277133*^9}, {
   3.5999771264027443`*^9, 3.5999771638116093`*^9}, {3.5999772819194174`*^9, 
   3.5999773037594557`*^9}, {3.599977471990151*^9, 3.5999774931437883`*^9}, {
   3.5999775645763135`*^9, 3.599977622561616*^9}, {3.5999776544480715`*^9, 
   3.599977664369689*^9}, {3.599978062497988*^9, 3.599978071436804*^9}, {
   3.5999787588988113`*^9, 3.5999788889094396`*^9}, {3.5999790114944553`*^9, 
   3.599979099041809*^9}, {3.5999791734071393`*^9, 3.599979187556364*^9}, {
   3.5999792934493504`*^9, 3.5999793073489747`*^9}, {3.599979340655033*^9, 
   3.5999794107771564`*^9}, {3.5999794526476297`*^9, 3.599979562799423*^9}, {
   3.5999795956842813`*^9, 3.599979650190777*^9}, {3.599979979959756*^9, 
   3.599979989054572*^9}, {3.5999803550312147`*^9, 3.5999804376645603`*^9}, {
   3.5999804961802626`*^9, 3.5999805306095233`*^9}, {3.599980576567204*^9, 
   3.5999806825693903`*^9}, {3.5999807196506553`*^9, 3.599980803079602*^9}, {
   3.599980843265272*^9, 3.5999810180479794`*^9}, 3.5999951552629623`*^9, {
   3.5999952079754543`*^9, 3.5999952103310585`*^9}, {3.599995240797912*^9, 
   3.59999534215129*^9}, {3.599995405237801*^9, 3.599995479837132*^9}, {
   3.5999955860421185`*^9, 3.599995593077731*^9}, {3.599995657053443*^9, 
   3.599995659299847*^9}, {3.5999956993139176`*^9, 3.5999957791236577`*^9}, {
   3.5999958276709433`*^9, 3.599995857763396*^9}, {3.599995893175458*^9, 
   3.5999958939710593`*^9}, {3.5999961404046926`*^9, 3.599996164537935*^9}, {
   3.599996354140668*^9, 3.5999963614882803`*^9}, 3.5999965360369873`*^9, 
   3.599997002212606*^9, 3.5999970420550756`*^9, {3.5999970822407465`*^9, 
   3.599997137839244*^9}, {3.599997173516507*^9, 3.599997177634914*^9}, {
   3.59999737467886*^9, 3.5999973755836616`*^9}, {3.59999741431853*^9, 
   3.599997415051731*^9}, {3.599997450385793*^9, 3.5999974740354347`*^9}, {
   3.5999975275123286`*^9, 3.5999975291971316`*^9}, {3.599997895423375*^9, 
   3.5999978960941763`*^9}, 3.599998160686241*^9, {3.5999981907162933`*^9, 
   3.599998192307496*^9}, {3.599998246907592*^9, 3.5999982507451987`*^9}, {
   3.599998648701898*^9, 3.5999987191828213`*^9}, {3.5999987714897137`*^9, 
   3.599998806355775*^9}, {3.5999988905179224`*^9, 3.5999989372400045`*^9}, {
   3.5999989743524694`*^9, 3.5999990539126096`*^9}, {3.5999990879362693`*^9, 
   3.599999119136324*^9}, 3.5999991722700176`*^9, 3.5999992041564736`*^9, {
   3.5999992544197617`*^9, 3.599999266244582*^9}, {3.600006957832761*^9, 
   3.600006977114395*^9}, {3.600145016232464*^9, 3.6001450189000683`*^9}, {
   3.600145062439745*^9, 3.6001451575219116`*^9}, {3.600145252073678*^9, 
   3.600145271105711*^9}, {3.6001453048797703`*^9, 3.6001453687462826`*^9}, 
   3.60014550398292*^9, {3.600149590160497*^9, 3.600149659674219*^9}, {
   3.600149693089478*^9, 3.6001497221367292`*^9}, {3.600149763742002*^9, 
   3.6001497776416264`*^9}, {3.6001500676461363`*^9, 
   3.6001500687693377`*^9}, {3.600150837850689*^9, 3.600150839332691*^9}, {
   3.600236668214266*^9, 3.600236678494684*^9}, {3.6002367884748774`*^9, 
   3.600236799800497*^9}, {3.600265200716505*^9, 3.600265227688952*^9}, {
   3.6002652603866096`*^9, 3.6002653968868494`*^9}, {3.600265884247305*^9, 
   3.6002658974761286`*^9}, 3.6002659448846116`*^9, {3.6003200443713017`*^9, 
   3.6003200549013205`*^9}, {3.6003214060040936`*^9, 3.6003214096545*^9}, 
   3.600321488153838*^9, {3.6003215535647526`*^9, 3.6003215588999624`*^9}, 
   3.6003216697537565`*^9, 3.6005189724031343`*^9, 3.6005191496194453`*^9, 
   3.6424260966593633`*^9},ExpressionUUID->"408dddc6-9e2f-4b68-910c-\
527f24f37a9e"],

Cell["\<\
plus yields a function with arbitrary many variables; expressions defined by \
plus are functions only if each summand can be evaluated for the same entered \
variables and has values in the same Abelian domain, in which the commutative \
operation + (Plus) is defined.\
\>", "Text",
 CellChangeTimes->{{3.6002360728704205`*^9, 3.6002362243934865`*^9}, {
  3.600236259306348*^9, 3.600236282456788*^9}, {3.6003298356652994`*^9, 
  3.600329896177806*^9}, {3.600329936597477*^9, 3.6003299689987335`*^9}, {
  3.6003300928941517`*^9, 3.6003301396630335`*^9}, {3.60057739239025*^9, 
  3.600577393482252*^9}, {3.642426483337242*^9, 3.642426524630515*^9}, {
  3.642478124117891*^9, 
  3.6424781261624947`*^9}},ExpressionUUID->"8bbd0f4e-d9be-42d3-b61a-\
a10fe2c30412"],

Cell[TextData[{
 "For  details of this problem and analogous problems concerning the \
multiplication of functions see the notebook [",
 ButtonBox["OpF",
  BaseStyle->"Hyperlink",
  ButtonData->"OpF"],
 "]. "
}], "Text",
 CellChangeTimes->{{3.567074649171421*^9, 3.5670747432083864`*^9}, {
   3.567075226475115*^9, 3.5670752584551706`*^9}, {3.5670752953180356`*^9, 
   3.5670752953336353`*^9}, 
   3.600148066365421*^9},ExpressionUUID->"a5541907-bbcd-4c3e-93c8-\
1e54d777239b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests of plus ", "Subsubsection",
 CellChangeTimes->{{3.600151506452263*^9, 3.6001515472619348`*^9}, 
   3.60032072092889*^9},ExpressionUUID->"2865f7b0-0eb1-46d7-a05f-\
a15fce31fe53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{"f", ",", "7", ",", "g", ",", "Cos"}], "]"}], "[", "x", 
  "]"}]], "Input",
 CellChangeTimes->{{3.6002690284484277`*^9, 3.600269077042513*^9}, 
   3.64242875351563*^9, {3.642428786182087*^9, 3.642428855446209*^9}, {
   3.6424782639181376`*^9, 
   3.6424782667105427`*^9}},ExpressionUUID->"e936cfc2-af5f-407e-8333-\
9a93a1cb0420"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{"{", 
    RowBox[{"f", ",", "7", ",", "g", ",", "Cos"}], "}"}], "]"}], "[", "x", 
  "]"}]], "Input",
 CellChangeTimes->{{3.6002690284484277`*^9, 3.600269077042513*^9}, 
   3.64242875351563*^9, {3.642428786182087*^9, 3.642428855446209*^9}, {
   3.6424782639181376`*^9, 3.6424782667105427`*^9}, {3.6424798783619905`*^9, 
   3.642479891202813*^9}},ExpressionUUID->"40e70472-acef-4710-8f23-\
12567d1b6652"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"Pi", "&"}]}], ";", 
  RowBox[{"g", "[", "y", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002662477279434`*^9, 3.600266268928381*^9}, 
   3.6002663051360445`*^9},ExpressionUUID->"89483b6c-96f4-41f3-8b69-\
956f5e4d85ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "=", " ", 
   RowBox[{"plus", "[", "Pi", "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002438663321085`*^9, 3.6002438763941264`*^9}, 
   3.600243923631009*^9, 3.600244295426462*^9, {3.6002443263613167`*^9, 
   3.6002443266421175`*^9}, 3.6002443695265923`*^9, {3.600265628734456*^9, 
   3.6002657178574133`*^9}},ExpressionUUID->"a00b8e56-120b-41fc-b9bb-\
74919ec1c485"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "=", " ", 
   RowBox[{"plus", "[", " ", "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002438663321085`*^9, 3.6002438763941264`*^9}, 
   3.600243923631009*^9, 3.600244295426462*^9, {3.6002443263613167`*^9, 
   3.6002443266421175`*^9}, 3.6002443695265923`*^9, {3.600265628734456*^9, 
   3.6002657178574133`*^9}, {3.600266022057947*^9, 
   3.6002660301387615`*^9}},ExpressionUUID->"45c49b30-b967-4c6f-a939-\
1b5236b5581a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "h", "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", 
    RowBox[{"3", ",", "Pi"}], "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.600243929231419*^9, 3.6002439327258253`*^9}, 
   3.6002656434296823`*^9, {3.6002660566588078`*^9, 3.6002660643340216`*^9}, 
   3.600268003557828*^9},ExpressionUUID->"c277ff4b-1ffc-42da-8b58-\
b46e5b96bd5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"h", ",", "f", ",", "g"}], "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", 
    RowBox[{"f", ",", "g"}], "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002433989396877`*^9, 3.6002434471281724`*^9}, {
   3.6002435798220053`*^9, 3.6002435978712373`*^9}, 3.6002437681611366`*^9, {
   3.6002680746159525`*^9, 
   3.600268076784356*^9}},ExpressionUUID->"9e7476f1-67ad-4c60-a6f3-\
9e620816360a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"h", ",", "f", ",", "g"}], "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", 
    RowBox[{"f", ",", "Pi"}], "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002433989396877`*^9, 3.6002434471281724`*^9}, {
   3.6002435798220053`*^9, 3.6002435978712373`*^9}, 3.6002437681611366`*^9, {
   3.6002680746159525`*^9, 
   3.600268110823616*^9}},ExpressionUUID->"0b65c47f-0fed-49fe-94d4-\
b17b9778bf7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"h", ",", "f", ",", "g"}], "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", 
    RowBox[{"Pi", ",", "g"}], "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6002433989396877`*^9, 3.6002434471281724`*^9}, {
   3.6002435798220053`*^9, 3.6002435978712373`*^9}, 3.6002437681611366`*^9, {
   3.6002680746159525`*^9, 
   3.6002681355496597`*^9}},ExpressionUUID->"9ef5912f-b005-40f2-9194-\
73fa1724f3d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "h", "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", "]"}]}], ";", 
  RowBox[{"h", "[", 
   RowBox[{"x", ",", "y"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599996594973891*^9, 3.599996601931503*^9}, {
   3.599997761122739*^9, 3.59999779016999*^9}, 
   3.600235956634616*^9},ExpressionUUID->"6ea1f0b6-f54e-4541-9477-\
c383d552fb23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "h", "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", "f", "]"}]}], ";", 
  RowBox[{"h", "[", 
   RowBox[{"x", ",", "y"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599977325209493*^9, 3.5999773291875*^9}, {
   3.599996720959712*^9, 3.599996767276193*^9}, 3.599996842078325*^9, {
   3.5999978056764174`*^9, 3.5999978279376564`*^9}, 3.6002359704718404`*^9, {
   3.6424802210977955`*^9, 
   3.6424802239234004`*^9}},ExpressionUUID->"6576b586-ed64-4bf7-9398-\
4d3e53324cf6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "h", "]"}], ";", 
  RowBox[{"h", "=", 
   RowBox[{"plus", "[", " ", "Cos", "]"}]}], ";", 
  RowBox[{"h", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.599977325209493*^9, 3.5999773291875*^9}, {
   3.599996720959712*^9, 3.599996767276193*^9}, {3.599996842078325*^9, 
   3.5999968783639884`*^9}, 
   3.6002359789270554`*^9},ExpressionUUID->"6aa6bcaa-a7da-4ece-8aa2-\
ba99a9e86bd1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Properties and Applications", "Subsubsection",
 CellChangeTimes->{{3.6003294496114216`*^9, 
  3.60032946566385*^9}},ExpressionUUID->"8e0e3fab-203f-4f05-a1d3-\
4b3daa3f70f6"],

Cell["\<\
The addition of vectors corresponds to the addition of the coordinate \
functions defined by plus:\
\>", "Text",
 CellChangeTimes->{{3.6001477342096376`*^9, 
  3.600147799043351*^9}},ExpressionUUID->"8a4cb506-bef1-4fe2-aa71-\
7c6b5dce6008"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";", 
  RowBox[{
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], ",", 
     RowBox[{"vec", "[", "y", "]"}]}], "]"}], "\[Equal]", 
   RowBox[{"vec", "[", 
    RowBox[{"plus", "[", 
     RowBox[{"x", ",", "y"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.599822538446019*^9, 3.599822587289705*^9}, {
   3.5998226823562717`*^9, 3.5998227083771176`*^9}, {3.599823848166319*^9, 
   3.5998238498043222`*^9}, 3.5998239231868505`*^9, {3.599823959987315*^9, 
   3.5998240035893917`*^9}, 3.5998240377534523`*^9, 3.599834343676767*^9, 
   3.599880853273974*^9, 3.5999985106416554`*^9, {3.600147537571292*^9, 
   3.6001475547781224`*^9}, 3.642480520679924*^9, 3.6424826309666595`*^9, 
   3.642482743817258*^9},ExpressionUUID->"61f61c86-8242-4e17-bacb-\
3dae43507840"],

Cell[BoxData[
 RowBox[{"?", "vec"}]], "Input",
 CellChangeTimes->{{3.600328168170371*^9, 
  3.6003281701203737`*^9}},ExpressionUUID->"51b8af4b-5ca5-4eff-a7a3-\
76b54f78bec7"],

Cell[BoxData[
 RowBox[{"vec", "[", 
  RowBox[{"plus", "[", 
   RowBox[{"z", ",", 
    RowBox[{"-", "x"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6003282264208727`*^9, 
  3.600328256840926*^9}},ExpressionUUID->"52d31c79-4709-4a96-aa78-\
ea8943a715a2"],

Cell[BoxData[
 RowBox[{"vec", "[", 
  RowBox[{"plus", "[", 
   RowBox[{"z", ",", 
    RowBox[{"-", "5"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6003282264208727`*^9, 3.600328256840926*^9}, {
  3.600328298165399*^9, 
  3.600328308289817*^9}},ExpressionUUID->"6d4bb4e3-d374-4f6e-8ec3-\
66804860eb97"],

Cell["The same for the addition of matrices:", "Text",
 CellChangeTimes->{{3.6001477342096376`*^9, 3.600147799043351*^9}, {
  3.600329358335661*^9, 
  3.6003294005961356`*^9}},ExpressionUUID->"57aaacff-1c6a-453b-8cca-\
17e0b76cc039"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "[", 
   RowBox[{
    RowBox[{"matrix", "[", "x", "]"}], ",", 
    RowBox[{"matrix", "[", "y", "]"}]}], "]"}], "\[Equal]", 
  RowBox[{"matrix", "[", 
   RowBox[{"plus", "[", 
    RowBox[{"x", ",", "y"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599822538446019*^9, 3.599822587289705*^9}, {
   3.5998226823562717`*^9, 3.5998227083771176`*^9}, {3.599823848166319*^9, 
   3.5998238498043222`*^9}, 3.5998239231868505`*^9, {3.599823959987315*^9, 
   3.5998240035893917`*^9}, 3.5998240377534523`*^9, 3.599834343676767*^9, 
   3.599880853273974*^9, 3.5999985106416554`*^9, {3.600147537571292*^9, 
   3.6001475547781224`*^9}, {3.600329256935483*^9, 
   3.60032927796432*^9}},ExpressionUUID->"a0b5f5c7-15d7-4756-a9f4-\
086a49ea5c0e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"matrix", "[", 
   RowBox[{"plus", "[", 
    RowBox[{"z", ",", "Pi"}], "]"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6003282264208727`*^9, 3.600328256840926*^9}, {
  3.600328298165399*^9, 3.600328308289817*^9}, {3.6003293071207714`*^9, 
  3.600329330068412*^9}},ExpressionUUID->"7bc6cb61-07e5-4d69-86f7-\
c322308097ac"],

Cell["The commutativity of plus is confirmed:", "Text",
 CellChangeTimes->{{3.6001473259413204`*^9, 3.600147416109479*^9}, {
  3.600237294399366*^9, 
  3.6002373085485907`*^9}},ExpressionUUID->"917a736d-e016-4170-880c-\
49f133201176"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{"f", ",", "g"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"plus", "[", 
   RowBox[{"g", ",", "f"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6000071165942397`*^9, 
  3.6000071602119164`*^9}},ExpressionUUID->"797966e5-5770-4faa-b719-\
80376d5d464a"],

Cell["The associativity of plus is  confirmed too:", "Text",
 CellChangeTimes->{{3.6003223792274027`*^9, 3.6003224068706512`*^9}, {
  3.6424828795374966`*^9, 3.6424828841707044`*^9}, {3.6424829367115965`*^9, 
  3.642482939379202*^9}},ExpressionUUID->"440c874b-7d5b-445a-be59-\
751fae45e35a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"g", ",", "f", ",", "h"}], "]"}], ";", 
  RowBox[{"Simplify", "[", " ", 
   RowBox[{
    RowBox[{"plus", "[", " ", 
     RowBox[{
      RowBox[{"plus", "[", 
       RowBox[{"f", ",", "g"}], "]"}], ",", "h"}], "]"}], "\[Equal]", " ", 
    RowBox[{"plus", "[", 
     RowBox[{"g", ",", 
      RowBox[{"plus", "[", 
       RowBox[{"f", ",", "h"}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.600322079301276*^9, 3.600322086414889*^9}, {
  3.600322150453001*^9, 3.6003221548054085`*^9}, {3.6003222748164196`*^9, 
  3.6003222809160304`*^9}},ExpressionUUID->"2360dbad-e987-4722-87c9-\
2e3dce9c63ef"],

Cell["\<\
The associativity for  explicit functions plus[...][x] is  valid:\
\>", "Text",
 CellChangeTimes->{{3.600322419896674*^9, 3.6003225378172817`*^9}, {
   3.6003240056774597`*^9, 3.6003240060362606`*^9}, 3.6003294949451013`*^9, 
   3.600329722674301*^9, 3.642482931469988*^9, 
   3.6425762346452465`*^9},ExpressionUUID->"d36db242-2425-4c50-941f-\
457184847ae5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"g", ",", "f", ",", "h"}], "]"}], ";", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"plus", "[", " ", 
      RowBox[{
       RowBox[{"plus", "[", 
        RowBox[{"f", ",", "g"}], "]"}], ",", "h"}], "]"}], "[", "x", "]"}], 
    " ", "\[Equal]", " ", 
    RowBox[{
     RowBox[{"plus", "[", 
      RowBox[{"g", ",", 
       RowBox[{"plus", "[", 
        RowBox[{"f", ",", "h"}], "]"}]}], "]"}], "[", "x", "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6000071165942397`*^9, 3.6000071602119164`*^9}, {
  3.600237354350271*^9, 3.60023750172373*^9}, {3.6003213090967236`*^9, 
  3.6003213575660086`*^9}, {3.6003218177356167`*^9, 3.600321841634859*^9}, {
  3.6003218964845552`*^9, 3.6003220459172173`*^9}, {3.6003221346813736`*^9, 
  3.6003221424345875`*^9}, {3.6003222192491217`*^9, 
  3.6003222331019464`*^9}},ExpressionUUID->"eafa67a7-88a0-49fc-84f2-\
daa04e587f97"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.2. Multiplication of Functions with Numeric Quantities", \
"Subsubsection",
 CellChangeTimes->{{3.569251829169143*^9, 3.569251878980031*^9}, {
   3.600330680406783*^9, 3.6003306817171855`*^9}, 
   3.600404592105467*^9},ExpressionUUID->"3c77c791-9896-423c-8869-\
9ab0e4db67de"],

Cell["The package tensalgv3.m contains the cell", "Text",
 CellChangeTimes->{{3.56925211209124*^9, 3.5692521502801075`*^9}, {
   3.6425005011211805`*^9, 3.642500503102384*^9}, 3.6425762814543953`*^9, 
   3.706253611906847*^9},ExpressionUUID->"ac979669-d1ca-4048-b751-\
9e816a17823d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "Times", "]"}], ";", 
  RowBox[{
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"h_", "?", "NumericQ"}], ",", "f_"}], "]"}], "[", "x___", "]"}],
    ":=", 
   RowBox[{"Times", "[", 
    RowBox[{"h", ",", 
     RowBox[{"f", "[", "x", "]"}]}], "]"}]}], ";", 
  RowBox[{"Protect", "[", "Times", "]"}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5692519919710293`*^9, 3.569252090235602*^9}, {
   3.569299667680523*^9, 3.5692997130411177`*^9}, {3.5692997522333593`*^9, 
   3.5692997570946374`*^9}, {3.5692997941137547`*^9, 3.569299914203624*^9}, 
   3.5693038159247894`*^9, 3.56930828000912*^9, 
   3.5693083255447245`*^9},ExpressionUUID->"35ea307c-83f6-4586-9312-\
f41342e19258"],

Cell["\<\
which admits the multiplication of a function with a scalar. This useful \
property we need for the multiplication for tensors with scalars. More \
general, we defined to this purpose an auxiliary function times;\
\>", "Text",
 CellChangeTimes->{{3.5692521759109526`*^9, 3.569252297622366*^9}, {
  3.6005785752935276`*^9, 3.600578742993822*^9}, {3.6005787733358755`*^9, 
  3.6005787853634963`*^9}, {3.600579653271021*^9, 3.6005796582942295`*^9}, {
  3.6005979826040373`*^9, 
  3.600598025301312*^9}},ExpressionUUID->"838e0837-af0a-4973-9fa6-\
10146762cddf"],

Cell[BoxData[
 RowBox[{"?", "times"}]], "Input",
 CellChangeTimes->{{3.600579667045845*^9, 
  3.60057966982265*^9}},ExpressionUUID->"5845367c-af86-46ba-8a90-\
d008af2d1c20"],

Cell["times[a,f][x] is a function evaluating always to a *f[x]:", "Text",
 CellChangeTimes->{{3.6005980511817575`*^9, 3.60059808099341*^9}, {
  3.6005981196190777`*^9, 
  3.6005981569343433`*^9}},ExpressionUUID->"127bc2a2-c11f-4e38-bd0f-\
adc176bbb011"],

Cell[BoxData[
 RowBox[{"fc", " ", "=", " ", 
  RowBox[{"times", "[", 
   RowBox[{"a", ",", "Cos"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.642500920621517*^9, 
  3.6425009371107464`*^9}},ExpressionUUID->"58948a0d-c88b-415a-8b0a-\
bc7bcfaf6867"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fc", "[", "x", "]"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6005797154683304`*^9, 3.6005797276363516`*^9}, 
   3.6005968190915937`*^9, 3.6425007045299377`*^9, {3.6425009542707767`*^9, 
   3.642500954582777*^9}},ExpressionUUID->"474b7cda-161a-42bd-bebf-\
d00682f09849"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fc", "[", 
   RowBox[{"Pi", "/", "5"}], "]"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6005968260804057`*^9, 3.600596868980481*^9}, {
  3.642500677027089*^9, 3.642500680100295*^9}, {3.6425007181799617`*^9, 
  3.6425007272903776`*^9}, {3.6425009692000027`*^9, 
  3.6425009704480047`*^9}},ExpressionUUID->"93ef863d-436b-478a-a199-\
da3cdd1aef6a"],

Cell["Times[a, Cos] isn't t a function :", "Text",
 CellChangeTimes->{{3.6005982807361603`*^9, 3.600598322388234*^9}, 
   3.6425762891764092`*^9},ExpressionUUID->"9dfa15d0-ecd0-4def-b66b-\
2cecef278564"],

Cell[BoxData[
 RowBox[{"fcc", "=", 
  RowBox[{"Times", "[", 
   RowBox[{"a", ",", "Cos"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.600596805316769*^9, {3.600598191769204*^9, 3.60059822339046*^9}, {
   3.600598258974122*^9, 3.6005982601441245`*^9}, {3.6425009929276443`*^9, 
   3.642501002381261*^9}},ExpressionUUID->"34172d2f-2a2e-4cc2-9ce8-\
156a1361c793"],

Cell[BoxData[
 RowBox[{"fcc", "[", 
  RowBox[{"Pi", "/", "5"}], "]"}]], "Input",
 CellChangeTimes->{{3.6425007641688423`*^9, 3.6425007755412626`*^9}, {
  3.6425010147208824`*^9, 
  3.642501015173283*^9}},ExpressionUUID->"76f90c8f-5e83-4a32-8f1a-\
36e1c65173c9"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"fc", ",", "fcc", ",", "f", ",", "g", ",", "H", ",", "h"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6006072621068716`*^9, 3.600607273775692*^9}, {
  3.600607821508254*^9, 3.6006078542683115`*^9}, {3.64250103036771*^9, 
  3.6425010544385524`*^9}},ExpressionUUID->"66639ec2-df2f-4289-a88d-\
3bdeed515b57"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example. Fields", "Subsubsection",
 CellChangeTimes->{{3.600401996245307*^9, 
  3.600402009489731*^9}},ExpressionUUID->"2b47e938-e55a-417d-ba75-\
a40b5d745f6a"],

Cell[TextData[{
 "In differential geometry and physics the name \[OpenCurlyDoubleQuote]field\
\[CloseCurlyDoubleQuote] means a quantity depending on coordinates; this \
concept has nothing to do with the fields used in algebra.  Here is an \
example of a general vector field defined on the Euclidean space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["E", "3"], TraditionalForm]],ExpressionUUID->
  "71d99a60-0df7-4a06-96ea-b0b16ffe258e"],
 "  with coordinates {x,y,z}:"
}], "Text",
 CellChangeTimes->{{3.6006082205569553`*^9, 3.600608345591175*^9}, {
   3.6006084366173344`*^9, 3.6006086079212356`*^9}, {3.6006089256157937`*^9, 
   3.6006089300306015`*^9}, 
   3.64257629551202*^9},ExpressionUUID->"23361e49-1407-4734-8247-\
a54fe1c4950e"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"vfield", "[", 
    RowBox[{"x_", ",", " ", "y_", ",", "z_"}], "]"}], " ", ":=", " ", 
   RowBox[{"vec", "[", 
    RowBox[{"f", "[", 
     RowBox[{"x", ",", "y", ",", "z"}], "]"}], "]"}]}]}]], "Input",
 Evaluatable->True,
 CellChangeTimes->{{3.600401771823313*^9, 3.6004017843969355`*^9}, {
   3.600401875719496*^9, 3.600401931083993*^9}, 3.6006079965405617`*^9, {
   3.6006082060021296`*^9, 3.6006082060021296`*^9}, {3.600608633832881*^9, 
   3.6006086967633915`*^9}},ExpressionUUID->"37fe1b13-0b6e-43b9-9c75-\
491d4dcc53bf"],

Cell[BoxData[
 RowBox[{"vfield", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Input",
 Evaluatable->True,
 CellChangeTimes->{{3.6004010062675686`*^9, 3.6004010171407876`*^9}, 
   3.600401144343411*^9, {3.600401256975609*^9, 3.6004012602984147`*^9}, 
   3.600607996556162*^9, {3.6006082060021296`*^9, 3.6006082060021296`*^9}, {
   3.6006087097426147`*^9, 
   3.6006087454354773`*^9}},ExpressionUUID->"f6797cad-f720-4f5a-8b6c-\
1c8549e78403"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ww", "[", 
   RowBox[{"x_", ",", " ", "y_", ",", "z_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"vec", "[", 
    RowBox[{"f", "[", 
     RowBox[{"x", ",", "y", ",", "z"}], "]"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"x", ",", "y", ",", "z"}], "]"}], "[", "1", "]"}], "->", 
      RowBox[{
       RowBox[{"x", "^", "2"}], "+", 
       RowBox[{"y", "^", "2"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"x", ",", "y", ",", "z"}], "]"}], "[", "2", "]"}], "\[Rule]", 
      " ", 
      RowBox[{"x", "*", "y", "*", "z"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"x", ",", "y", ",", "z"}], "]"}], "[", "3", "]"}], "\[Rule]", 
      "0"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.600608949234235*^9, 3.6006089494214354`*^9}, {
  3.600608989607106*^9, 
  3.600609154795796*^9}},ExpressionUUID->"368a2a6f-dc6b-44cb-8d86-\
fa25ddf3ea79"],

Cell[BoxData[
 RowBox[{"ww", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Input",
 CellChangeTimes->{{3.6006091668702173`*^9, 
  3.600609182813445*^9}},ExpressionUUID->"72d211e8-23bb-43f4-b634-\
1abb3450025e"],

Cell[BoxData[
 RowBox[{"z", "*", 
  RowBox[{"ww", "[", 
   RowBox[{"x", ",", "y", ",", "z"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6006092403775463`*^9, 
  3.6006092491447616`*^9}},ExpressionUUID->"e4ac707d-1271-49aa-be57-\
9d522824f730"],

Cell["The next cell gives nonsense:", "Text",
 CellChangeTimes->{{3.600609549180089*^9, 
  3.6006095622841115`*^9}},ExpressionUUID->"7e1738f4-51ba-40fe-8e64-\
868237b37463"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"z", "*", "ww"}], ")"}], "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Input",
 CellChangeTimes->{{3.6006092403775463`*^9, 
  3.600609291888837*^9}},ExpressionUUID->"62475ebe-eef1-4825-a05c-\
df50bd00ae61"],

Cell["We want", "Text",
 CellChangeTimes->{{3.6006095779777393`*^9, 
  3.6006095935621667`*^9}},ExpressionUUID->"79952a18-ebec-4e2b-8bd9-\
4c3f96ae512c"],

Cell[BoxData[
 RowBox[{"wwz", "=", " ", 
  RowBox[{"times", "[", 
   RowBox[{"z", ",", "ww"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.642501195993201*^9, 
  3.6425012169128375`*^9}},ExpressionUUID->"da1932e9-b885-48fd-a052-\
9fd18bf3de05"],

Cell[BoxData[
 RowBox[{"wwz", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Input",
 CellChangeTimes->{{3.6006093136664753`*^9, 3.600609361542959*^9}, {
  3.6425012304068613`*^9, 
  3.642501231904464*^9}},ExpressionUUID->"c91ffefb-a277-4d98-984f-\
25806bed12b7"],

Cell["Also matrices or  Arrays can serve to define fields:", "Text",
 CellChangeTimes->{{3.6006099090103207`*^9, 
  3.6006099413959775`*^9}},ExpressionUUID->"edf263bd-a8bf-4fbe-8b23-\
5fd4cb914584"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tff", "[", 
   RowBox[{"u_", ",", " ", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"matrix", "[", 
   RowBox[{"f", "[", 
    RowBox[{"u", ",", " ", "v"}], "]"}], "]"}]}]], "Input",
 Evaluatable->True,
 CellChangeTimes->{{3.6004020236077557`*^9, 3.6004020973334846`*^9}, 
   3.600607996556162*^9, {3.6006082060177298`*^9, 
   3.6006082060177298`*^9}},ExpressionUUID->"419ddc1b-50fc-4f23-b4f0-\
768908dab5c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tff", "[", 
   RowBox[{"u", ",", " ", "v"}], "]"}], " ", "//", " ", 
  "MatrixForm"}]], "Input",
 Evaluatable->True,
 CellChangeTimes->{{3.6004021059135*^9, 3.6004021232763305`*^9}, 
   3.600607996556162*^9, {3.6006082060177298`*^9, 
   3.6006082060177298`*^9}},ExpressionUUID->"38dde32a-e04e-4e37-b18a-\
0515c3bccd18"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"vfield", ",", "ww", ",", "wwz", ",", "tff"}], "]"}]], "Input",
 CellChangeTimes->{{3.6425012885949636`*^9, 
  3.6425013339442434`*^9}},ExpressionUUID->"bb12a45e-152a-4937-bc94-\
07ac54242f4d"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.3. Introducing Null[ ]", "Subsubsection",
 CellChangeTimes->{{3.561361697973836*^9, 3.5613617259134855`*^9}, 
   3.561362683424775*^9, 3.566915401241486*^9, 3.566975775349353*^9, {
   3.566976121669161*^9, 3.5669761274524918`*^9}, 3.567075501550398*^9, {
   3.567075727501195*^9, 3.5670757333044047`*^9}, 3.5675746659145193`*^9, 
   3.5692518077191057`*^9},ExpressionUUID->"a7e9782a-c547-485e-808f-\
42609e7b36d4"],

Cell[BoxData[
 RowBox[{"?", "Null"}]], "Input",
 CellChangeTimes->{{3.561362256724369*^9, 
  3.5613622592265124`*^9}},ExpressionUUID->"c9ce5f5b-5531-451f-a6f9-\
6b20504108d9"],

Cell["\<\
Applying the tensor functions there  may appear  undefined expressions like \
Null[ ]. Thus we entered in tensalgv3.m  the following enhancement of Null:\
\>", "Text",
 CellChangeTimes->{{3.5613619099314084`*^9, 3.5613620893005238`*^9}, {
   3.5613622240164986`*^9, 3.5613622489289236`*^9}, {3.561362713529497*^9, 
   3.5613627438012285`*^9}, {3.5613629069215584`*^9, 3.5613629315299664`*^9}, 
   3.566975430369294*^9, {3.5670755284760447`*^9, 3.567075560502901*^9}, 
   3.642501433378818*^9, 
   3.7062536174591722`*^9},ExpressionUUID->"e6ce0626-bbcd-4d2c-a419-\
e89686db1c33"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "Null", "]"}], ";", " ", 
  RowBox[{
   RowBox[{"Null", "[", "___", "]"}], " ", ":=", " ", "Null"}], ";", "  ", 
  RowBox[{"Protect", "[", "Null", "]"}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.561362131202197*^9},ExpressionUUID->"6e0e9ec8-0aa0-49d4-a4e9-\
0a16abc55231"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Null", "[", 
   RowBox[{"1", ",", "2"}], "]"}], "[", "3", "]"}]], "Input",
 CellChangeTimes->{{3.5613627718638334`*^9, 
  3.561362783090476*^9}},ExpressionUUID->"036a6afc-ee02-4468-b651-\
4d2156350004"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", "Null"}]], "Input",
 CellChangeTimes->{{3.5613627902878876`*^9, 
  3.561362793746085*^9}},ExpressionUUID->"ee975b17-f2f8-4075-bf88-\
cb488842af94"],

Cell[BoxData[
 RowBox[{"Null", " ", "\[Equal]", " ", 
  RowBox[{"Null", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.5669755063882275`*^9, 
  3.566975515888644*^9}},ExpressionUUID->"55de6458-10f0-4a82-a335-\
5b503f2e2c05"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.2.  Symbols in the Package tensalgv3.m", "Subsection",
 CellChangeTimes->{{3.55842982654103*^9, 3.558429829746213*^9}, 
   3.5612715200101786`*^9, 3.5669766165604672`*^9, {3.6397496603307586`*^9, 
   3.639749664433566*^9}, 
   3.70616605963519*^9},ExpressionUUID->"0fa43257-e927-4f01-bdf3-\
30a9e2b86004"],

Cell["To see the usages click on the name!", "Text",
 CellChangeTimes->{{3.570690731742944*^9, 
  3.5706907322219715`*^9}},ExpressionUUID->"8c9bfbc9-1e67-4238-9334-\
ee58963262ca"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "tensalgv3`*"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5584298475964575`*^9, 3.558429851012863*^9}, 
   3.5613758784786205`*^9, 3.5613759356868925`*^9, {3.6397496865076046`*^9, 
   3.6397496877244067`*^9}, 
   3.706166075732101*^9},ExpressionUUID->"56f8b7fe-0a85-4cdd-9940-\
cc9de6da9171"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["tensalgv3`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["tensalgv3`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["afftr",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"afftr", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["cova",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cova", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["null",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"null", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tensorproduct",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"tensorproduct", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["altform",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"altform", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covalt",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"covalt", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["nullmatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"nullmatrix", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tensorToArray",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"tensorToArray", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["andtest",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"andtest", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covec",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"covec", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["nulltensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"nulltensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["times",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"times", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["ArrayTotensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"ArrayTotensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covector",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"covector", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["one",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"one", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tp",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"tp", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["basis",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"basis", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covecTotensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"covecTotensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["ortest",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"ortest", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tpl",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"tpl", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["blf",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"blf", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covpermute",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"covpermute", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["outzero",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"outzero", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["trace",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"trace", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["cbary",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cbary", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covs",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"covs", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["plus",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"plus", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tradf",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"tradf", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["cc",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cc", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["covsym",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"covsym", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["point",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"point", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["transpose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"transpose", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["cc$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cc$", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["cr",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cr", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["projpt",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"projpt", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["trp",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"trp", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["cgeo",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"cgeo", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["dotnorme",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"dotnorme", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["projpt3D",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"projpt3D", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tstb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"tstb", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["coalttensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"coalttensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["eps",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"eps", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["ptind",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"ptind", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["type",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"type", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contra",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"contra", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["epst",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"epst", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["randommatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"randommatrix", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["vec",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"vec", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contraalttensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"contraalttensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["eps$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"eps$", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["randomv",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"randomv", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["vector",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"vector", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contraction",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"contraction", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["equi",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"equi", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["rank",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"rank", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["vecTotensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"vecTotensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contralt",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"contralt", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["extprod",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"extprod", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["renorm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"renorm", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["vtstb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"vtstb", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contrapermute",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"contrapermute", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["lf",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"lf", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["smoothing",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"smoothing", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["wedge",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"wedge", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contras",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"contras", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["linform",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"linform", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["stb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"stb", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["wedgeform",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"wedgeform", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contrasym",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"contrasym", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["lts",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"lts", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["strictcoords",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"strictcoords", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["wedgevector",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"wedgevector", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["contrasymtensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"contrasymtensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["mathff",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"mathff", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["symform",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"symform", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["wtstb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"wtstb", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["coords",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"coords", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["matrix",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"matrix", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tensor",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"tensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["zero",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"zero", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"]},
        {
         ButtonBox["cosymtensor",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"cosymtensor", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], 
         ButtonBox["noprops",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info123706173277-8250988", {"noprops", "tensalgv3`"}},
          
          ButtonNote->"tensalgv3`"], 
         ButtonBox["tensorbasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info123706173277-8250988", {"tensorbasis", "tensalgv3`"}},
          ButtonNote->"tensalgv3`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.2375]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{
  3.706166077375291*^9},ExpressionUUID->"ecda513b-78cb-4062-b582-\
092d210f4474"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Remark.",
  FontColor->RGBColor[0, 0, 1]],
 " Wedge is built - in as a symbol name only; we gave it a mathematical \
meaning identifying it with wedge"
}], "Text",
 CellChangeTimes->{{3.573818925101037*^9, 
  3.573819013527095*^9}},ExpressionUUID->"a0ce3342-cdfc-4467-8333-\
786dea1c5fe3"],

Cell[BoxData[
 RowBox[{"??", "Wedge"}]], "Input",
 CellChangeTimes->{{3.573818828276499*^9, 
  3.5738188321327195`*^9}},ExpressionUUID->"7fd23495-e699-4c40-9468-\
600fa4f3eade"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "Wedge", "]"}]], "Input",
 CellChangeTimes->{{3.6037779745419254`*^9, 
  3.603778027457218*^9}},ExpressionUUID->"ebbb6bde-ec89-45c0-9501-\
75703b830f84"],

Cell[BoxData[
 RowBox[{"Context", "[", "Wedge", "]"}]], "Input",
 CellChangeTimes->{{3.6037779745419254`*^9, 
  3.6037780777673063`*^9}},ExpressionUUID->"c8281aee-545d-4238-8073-\
a80bfe7a9d99"],

Cell[BoxData[
 RowBox[{"?", "wedge"}]], "Input",
 CellChangeTimes->{{3.573819026924861*^9, 
  3.5738190313131123`*^9}},ExpressionUUID->"04c1de12-c89c-40be-b489-\
f2a238b1c1a7"],

Cell["See details in the next subsection; first read Section 4.3.", "Text",
 CellChangeTimes->{{3.573819212527477*^9, 3.573819237318895*^9}, {
   3.573819275471077*^9, 3.5738192884708204`*^9}, 
   3.6006111402892838`*^9},ExpressionUUID->"3ede3122-962f-44bc-87ee-\
af3de461c4e0"],

Cell[BoxData[
 RowBox[{"??", "Tensor"}]], "Input",
 CellChangeTimes->{{3.5699954057311125`*^9, 3.5699954104267206`*^9}, 
   3.6006117811852093`*^9},ExpressionUUID->"63e4f156-aad7-4041-a88f-\
432006e6e3e7"],

Cell[TextData[{
 "But mark Tensor and press F1: Read a lot about the properties and \
operations of objects not being defined in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "!"
}], "Text",
 CellChangeTimes->{{3.600611790670026*^9, 
  3.600611897124613*^9}},ExpressionUUID->"216cf1fd-1b8b-44f5-9339-\
072d45b86194"],

Cell[CellGroupData[{

Cell["1.2.1. Wedge Products", "Subsubsection",
 CellChangeTimes->{{3.5699953241897697`*^9, 
  3.569995346185808*^9}},ExpressionUUID->"edca438c-df94-4f08-a9fc-\
e22c849f7a1c"],

Cell[TextData[{
 StyleBox["Attention!",
  FontColor->RGBColor[1, 0, 0]],
 " In the notebook appear several functions defining a wedge product:"
}], "Text",
 CellChangeTimes->{{3.566570413640396*^9, 3.5665704208476086`*^9}, {
  3.569993112119084*^9, 
  3.569993125191907*^9}},ExpressionUUID->"dab99923-92c6-4f44-b4a6-\
1e71523e6668"],

Cell[BoxData[
 RowBox[{"?", "wedge"}]], "Input",
 CellChangeTimes->{{3.5665697546484385`*^9, 3.566569757144443*^9}, 
   3.566569789966901*^9},ExpressionUUID->"96257e21-724c-421f-a5d8-\
d3498ccc613e"],

Cell[BoxData[
 RowBox[{"Context", "[", "wedge", "]"}]], "Input",
 CellChangeTimes->{{3.566569768095662*^9, 3.5665697772060785`*^9}, {
   3.5665702015736237`*^9, 3.5665702094516373`*^9}, 3.5665702823973656`*^9, {
   3.5699940765619783`*^9, 
   3.5699940808831854`*^9}},ExpressionUUID->"1fe46e91-b34b-4927-a2ed-\
748d8ded1aaa"],

Cell[TextData[{
 "The symbol Wedge doesn\[CloseCurlyQuote]t have any mathematical meaning in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ":"
}], "Text",
 CellChangeTimes->{{3.566570303691403*^9, 3.566570376652731*^9}, {
   3.5665704864613237`*^9, 3.5665706142879486`*^9}, {3.5697584654420795`*^9, 
   3.569758467906884*^9}, {3.5697585188877735`*^9, 3.569758558511843*^9}, 
   3.5697586801140566`*^9},ExpressionUUID->"7e051f09-af77-4800-8044-\
cd06293cd9d7"],

Cell[BoxData[
 RowBox[{"?", "Wedge"}]], "Input",
 CellChangeTimes->{{3.5665704441228495`*^9, 
  3.5665704468528547`*^9}},ExpressionUUID->"4688bbc9-caed-40d6-95ed-\
b46666865f06"],

Cell[BoxData[
 RowBox[{"Context", "[", "Wedge", "]"}]], "Input",
 CellChangeTimes->{{3.566569768095662*^9, 3.5665697772060785`*^9}, {
   3.5665702015736237`*^9, 3.5665702094516373`*^9}, 3.56657027386415*^9, {
   3.5699941735941486`*^9, 
   3.569994181940163*^9}},ExpressionUUID->"1caa435e-25da-4912-9741-\
6f0179c3f9a6"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "Wedge", "]"}]], "Input",
 CellChangeTimes->{{3.5699942142322197`*^9, 
  3.5699942303314486`*^9}},ExpressionUUID->"95194825-46a9-40dd-9b37-\
a87431debfbe"],

Cell["\<\
We give Wedge the meaning of the wedge product defined in tensalgv3.m:\
\>", "Text",
 CellChangeTimes->{{3.5699944501358347`*^9, 3.5699945260455675`*^9}, {
   3.573819098126933*^9, 3.573819106439409*^9}, 3.600612116070997*^9, {
   3.6406995321124744`*^9, 3.640699537993685*^9}, 
   3.7062536192020283`*^9},ExpressionUUID->"ea00cb8b-b263-4a30-9ef3-\
621067c1d284"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Attributes", "[", "Wedge", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{"Flat", ",", " ", "OneIdentity", ",", "Protected"}], 
   "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.569992687143138*^9, 3.5699927040847673`*^9}, {
   3.5699932096504555`*^9, 3.569993225375283*^9}, {3.56999335488671*^9, 
   3.5699933656819296`*^9}, 3.5699934517316804`*^9, {3.640699594372184*^9, 
   3.64069962062703*^9}},ExpressionUUID->"e9c3f355-8def-46bb-9d70-\
23921cb26dfe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Flat", ",", "OneIdentity", ",", "Protected"}], "}"}]], "Output",
 CellChangeTimes->{3.673924916199924*^9, 3.6739312725098*^9, 
  3.706166021818612*^9},ExpressionUUID->"92c73b3f-5c18-4580-985c-\
b3a5572ddd30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Wedge", "[", "x___", "]"}], " ", ":=", " ", 
  RowBox[{"wedge", "[", "x", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.56999275681286*^9, 
  3.5699927929893236`*^9}},ExpressionUUID->"02fd4b65-6499-48ac-af7a-\
3ce75160ec81"],

Cell[BoxData[
 TemplateBox[{
  "SetDelayed","write",
   "\"Tag \\!\\(\\*RowBox[{\\\"Wedge\\\"}]\\) in \\!\\(\\*RowBox[{\\\"Wedge\\\
\", \\\"[\\\", \\\"x___\\\", \\\"]\\\"}]\\) is Protected.\"",2,10,4,
   30212879271806068125,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.673924916326963*^9, 3.6739312726280823`*^9, 
  3.706166021841002*^9},ExpressionUUID->"d468f792-49de-4d96-91a4-\
ac80ff72ab62"],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.673924916329381*^9, 3.67393127263028*^9, 
  3.7061660218427067`*^9},ExpressionUUID->"b33d6420-4d08-4886-9eb4-\
af92b2772f24"]
}, Open  ]],

Cell["The context remains System`", "Text",
 CellChangeTimes->{{3.5699945556232195`*^9, 3.5699945947480884`*^9}, 
   3.642576316230857*^9},ExpressionUUID->"bc969a9a-9717-4e6c-a974-\
d5c675ea3d00"],

Cell[BoxData[
 RowBox[{"Context", "[", "Wedge", "]"}]], "Input",
 CellChangeTimes->{{3.569993153053556*^9, 
  3.5699931659235783`*^9}},ExpressionUUID->"7ac62197-9b9e-44c0-8d1d-\
4a57481f125d"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "Wedge", "]"}]], "Input",ExpressionUUID->"55bbca8b-19ca-422c-b2df-54c264a77cc6"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "wedge", "]"}]], "Input",
 CellChangeTimes->{{3.5699935766567*^9, 
  3.569993586266317*^9}},ExpressionUUID->"db932a91-12ea-4a3a-a2d3-\
a2116194b12f"],

Cell[BoxData[
 RowBox[{"Wedge", "[", 
  RowBox[{
   RowBox[{"tstb", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ",", 
   RowBox[{"tstb", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ",", 
   RowBox[{"tstb", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56999281941577*^9, 3.569992899833911*^9}, {
  3.5699946899706554`*^9, 
  3.5699947133706965`*^9}},ExpressionUUID->"490ff0ba-1cba-4274-8bfc-\
db00cfbe1dc2"],

Cell[BoxData[
 RowBox[{"coords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.600612172933097*^9, 
  3.6006121784867067`*^9}},ExpressionUUID->"7cbcac0c-4e4c-4fb8-83c6-\
ff9da51aca22"],

Cell["\<\
The only advantage is that we may use now the traditional notation\
\>", "Text",
 CellChangeTimes->{{3.569994645338977*^9, 
  3.5699946797214375`*^9}},ExpressionUUID->"c939bf6f-2a00-4f04-a802-\
afd818f1e5fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tstb", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  StyleBox["\[Wedge]", "OperatorCharacter"], 
  RowBox[{"tstb", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  StyleBox["\[Wedge]", "OperatorCharacter"], 
  RowBox[{"tstb", "[", 
   RowBox[{
    RowBox[{"{", "3", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569992970361635*^9, 3.569993006522498*^9}, {
  3.569994736068736*^9, 
  3.569994741715946*^9}},ExpressionUUID->"6921a9b7-5949-4fcf-82ab-\
722b43c43539"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", 
  RowBox[{"wedge", "[", 
   RowBox[{
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}], ",", 
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}], ",", 
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56999476648879*^9, 
  3.569994787533227*^9}},ExpressionUUID->"7bc4b4c5-b3ac-4f58-8b6d-\
bd8934975ba8"],

Cell["\<\
Other more special wedge products are wedgeform[w1,w2,...] of linear forms \
and wedgevector[x1,x2,...] of vectors x1,x2,.. .returning the corresponding \
antisymmetric covariant or contravariant tensors. Built-in is the function\
\>", "Text",
 CellChangeTimes->{{3.5699948645817623`*^9, 3.5699950952593675`*^9}, {
  3.5707089963165336`*^9, 
  3.570709027411312*^9}},ExpressionUUID->"9c530048-3ba9-48b3-a3eb-\
eed06e8e53c3"],

Cell[BoxData[
 RowBox[{"?", "TensorWedge"}]], "Input",
 CellChangeTimes->{{3.5707090314785447`*^9, 
  3.5707090408340797`*^9}},ExpressionUUID->"bdf99a3b-702e-457e-9a6f-\
398d474aba5a"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "TensorWedge", "]"}]], "Input",
 CellChangeTimes->{{3.570709133406375*^9, 
  3.570709145626074*^9}},ExpressionUUID->"d6eae6c2-24f3-43e8-99c2-\
efc5f3ca1cb6"],

Cell["\<\
We wanted to see how TensorWedge has been defined  as a built-in function. We \
try\
\>", "Text",
 CellChangeTimes->{{3.570710098707587*^9, 
  3.570710142572096*^9}},ExpressionUUID->"ce05b1e9-c625-45cc-8d56-\
3de0ab63c1c1"],

Cell[BoxData[
 RowBox[{"ClearAttributes", "[", 
  RowBox[{"TensorWedge", ",", " ", "ReadProtected"}], "]"}]], "Input",
 CellChangeTimes->{{3.570709133406375*^9, 3.570709145626074*^9}, {
  3.570709760048217*^9, 
  3.5707097894258966`*^9}},ExpressionUUID->"fc523fb5-a0bf-41a9-b1c7-\
5ff28f28b561"],

Cell[BoxData[
 RowBox[{"??", "TensorWedge"}]], "Input",
 CellChangeTimes->{{3.5707098019276123`*^9, 
  3.5707098079539566`*^9}},ExpressionUUID->"f1bf8a92-e286-424f-bd43-\
c41ad5d0207d"],

Cell["\<\
Unfortunately, this Output remains unclear for a user not being an insider \
\>", "Text",
 CellChangeTimes->{{3.570710245908006*^9, 
  3.570710346979787*^9}},ExpressionUUID->"78823f86-f85f-423b-8f6d-\
e661a5dbaff9"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "TensorWedge", "]"}]], "Input",ExpressionUUID->"5b8a0cde-1b10-41b9-b168-0ce40150398d"],

Cell[BoxData[
 RowBox[{"TensorWedge", "[", 
  RowBox[{
   RowBox[{"stb", "[", "1", "]"}], ",", 
   RowBox[{"stb", "[", "2", "]"}], ",", 
   RowBox[{"stb", "[", "3", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6406999138627453`*^9, 3.6406999687596416`*^9}, {
  3.640700021284934*^9, 
  3.6407000284297466`*^9}},ExpressionUUID->"c00323c4-3e4f-4e3b-b1c0-\
a59557c8767c"],

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6406999817388644`*^9, 
  3.640699991036481*^9}},ExpressionUUID->"89150f2e-0f2b-4aab-8d5b-\
b03b2ea945f3"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.640700065760612*^9, 
  3.6407000826398416`*^9}},ExpressionUUID->"8b2c6f49-1004-4664-bcd0-\
80a3094aee36"]
}, Open  ]],

Cell[CellGroupData[{

Cell["1.2.2.  Further Examples", "Subsubsection",
 CellChangeTimes->{{3.5655962491405764`*^9, 3.5655962522277527`*^9}, {
   3.5655962852116394`*^9, 3.5655962908909645`*^9}, 3.5699953662630434`*^9, {
   3.570709260204627*^9, 
   3.570709296059678*^9}},ExpressionUUID->"e869ba47-61fa-47ac-ae1d-\
3a805e7c5b48"],

Cell["Test other examples of the table in 1.2 above!", "Text",
 CellChangeTimes->{{3.5707104648435287`*^9, 
  3.570710491236038*^9}},ExpressionUUID->"2d0afa3d-504b-4986-9696-\
d23ac8006818"],

Cell[BoxData[
 RowBox[{"vector", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.559281132156657*^9, 3.559281136433902*^9}, {
  3.5613737553351836`*^9, 
  3.5613737561102276`*^9}},ExpressionUUID->"53c51078-e46c-4f7c-a822-\
537ae4708c47"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "i", "]"}], "*", 
     RowBox[{"stb", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5592811892279215`*^9, 
  3.5592812391227756`*^9}},ExpressionUUID->"dd079e65-9b11-4cdb-94c4-\
f866b2d5eb13"],

Cell[BoxData[
 RowBox[{"stb", "[", "3", "]"}]], "Input",
 CellChangeTimes->{{3.5618707049340887`*^9, 3.5618707133269033`*^9}, 
   3.570709484158437*^9, {3.570709675974408*^9, 
   3.570709683893861*^9}},ExpressionUUID->"7ef2ccb7-4758-4030-aa32-\
74ce760875a2"],

Cell[BoxData[
 RowBox[{"?", "noprops"}]], "Input",
 CellChangeTimes->{{3.565596190691233*^9, 3.565596193942419*^9}, 
   3.569997325267684*^9, 
   3.570709709453323*^9},ExpressionUUID->"73b8ff74-183d-4c4e-9271-\
4142aa2d58f7"],

Cell["noprops acts on matrices (= List of Lists ) only:", "Text",
 CellChangeTimes->{{3.5699959536664753`*^9, 
  3.569995990108139*^9}},ExpressionUUID->"a6cf4a3c-72ec-40f3-b659-\
0dda9b2a7e70"],

Cell[BoxData[
 RowBox[{"noprops", "[", 
  RowBox[{"x", ",", "y", ",", 
   RowBox[{"2", "*", "x"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569995678700392*^9, 
  3.5699957184960623`*^9}},ExpressionUUID->"4ab82750-c986-4ab6-9909-\
d0f0d4bd7d93"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{"{", "y", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", "*", "x"}], "}"}]}], "}"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6424848542357645`*^9, 
  3.6424848597425747`*^9}},ExpressionUUID->"ee1b2ff4-cc8a-414e-855c-\
bbb71516eec6"],

Cell[BoxData[
 RowBox[{"noprops", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{"{", "y", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", "*", "x"}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.569995678700392*^9, 
  3.569995806339816*^9}},ExpressionUUID->"34c689c1-b54d-44e6-94d6-\
f4f82e5f619a"],

Cell["Indeed,", "Text",
 CellChangeTimes->{{3.5699958549807014`*^9, 
  3.5699958611427126`*^9}},ExpressionUUID->"26735296-390f-465c-9d71-\
772b1d3751a3"],

Cell[BoxData[
 RowBox[{"y", "\[Equal]", 
  RowBox[{"x", "*", 
   RowBox[{"(", 
    RowBox[{"y", "/", "x"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5699958663375216`*^9, 
  3.569995891469166*^9}},ExpressionUUID->"e6fc1424-e927-4e8f-8e56-\
8f364beaff47"],

Cell[BoxData[
 RowBox[{"wl", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], ",", " ", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "+", " ", 
     RowBox[{"vec", "[", "y", "]"}]}], ",", " ", 
    RowBox[{"null", "[", "]"}], ",", 
    RowBox[{"2", "*", " ", 
     RowBox[{"vec", "[", "z", "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5655958574901752`*^9, 3.565595925711077*^9}, {
  3.5699955808102202`*^9, 
  3.569995583540225*^9}},ExpressionUUID->"0e39a20d-c839-40d2-a751-\
7b3a5b7e9dcd"],

Cell[BoxData[
 RowBox[{"noprops", "[", "wl", "]"}]], "Input",
 CellChangeTimes->{{3.56559593432857*^9, 
  3.565595942510038*^9}},ExpressionUUID->"a4c545ac-109f-4ce9-a61c-\
a4b91408ba4a"],

Cell[BoxData[
 RowBox[{"wl", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], ",", " ", 
    RowBox[{"3", "*", 
     RowBox[{"vec", "[", "x", "]"}]}], ",", " ", 
    RowBox[{"vec", "[", "y", "]"}], ",", " ", 
    RowBox[{"null", "[", "]"}], ",", " ", 
    RowBox[{"vec", "[", "z", "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5655958574901752`*^9, 3.565595925711077*^9}, {
  3.565595999032271*^9, 
  3.5655960223986073`*^9}},ExpressionUUID->"02a99e0a-787b-4eaf-9342-\
92e9d6913819"],

Cell[BoxData[
 RowBox[{"noprops", "[", "wl", "]"}]], "Input",
 CellChangeTimes->{{3.5655960328122025`*^9, 
  3.565596041381693*^9}},ExpressionUUID->"8feb5375-e018-421b-b1b9-\
72e929a30e1b"],

Cell[BoxData[
 RowBox[{"Clear", "[", "wl", "]"}]], "Input",
 CellChangeTimes->{{3.565596135317066*^9, 
  3.5655961428054943`*^9}},ExpressionUUID->"6ae6829a-23b2-4002-8cd8-\
6299cc183546"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.  Symbols in the Global Context", "Subsection",
 CellChangeTimes->{
  3.5612715312109985`*^9},ExpressionUUID->"a04d6ea6-3ad0-4051-a5fd-\
e4e2a3f1957c"],

Cell["\<\
Here is the List of all symbols currently valid in the Global context; one \
may renew it at any time:\
\>", "Text",
 CellChangeTimes->{{3.570711993659972*^9, 3.5707120261958327`*^9}, {
   3.5707121517960167`*^9, 3.5707121746113214`*^9}, {3.5707122216280107`*^9, 
   3.5707122390920095`*^9}, 3.642501809526678*^9, {3.642501950333563*^9, 
   3.642501955933973*^9}},ExpressionUUID->"827070e3-1abb-4d27-adf1-\
3e50de051cdf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Global`*"}]], "Input",ExpressionUUID->"ead8097c-2e80-44ec-af31-204efb2b057a"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Global`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Global`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["dim",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"dim", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["i",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"i", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["i$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"i$", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["j",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"j", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["j$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"j$", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["keylist",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"keylist", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["x",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"x", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["\[Delta]",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info133706173309-8250988", {"\[Delta]", "Global`"}},
          ButtonNote->"Global`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.11875]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{
  3.706166109741185*^9},ExpressionUUID->"c543f945-3a82-4e94-8060-\
b3ebbe533e4e"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2. Vectors and Linear Forms", "Section",
 CellChangeTimes->{{3.5605189133197308`*^9, 3.5605189330537653`*^9}, {
  3.5706945612569795`*^9, 3.57069457018349*^9}, {3.6324595887826633`*^9, 
  3.632459595428275*^9}, {3.6324596974368544`*^9, 
  3.6324597005100603`*^9}},ExpressionUUID->"6bc49477-dc52-409d-923a-\
1f70c0e85579"],

Cell[CellGroupData[{

Cell["2.1. Vectors, Bases, Coordinates", "Subsection",
 CellChangeTimes->{{3.560519084327231*^9, 3.5605191029692636`*^9}, {
  3.5605824200510626`*^9, 
  3.560582432720787*^9}},ExpressionUUID->"f7b383df-f687-4b97-8eab-\
884b3d87387a"],

Cell[TextData[{
 "We consider finite-dimensional vector spaces over an arbitrary field, \
mostly the field of real or complex numbers.  For the mathematical concepts \
used here see any textbook about linear algebra or analytic geometry, e.g.  [",
 ButtonBox["OSI",
  BaseStyle->"Hyperlink",
  ButtonData->"OSI"],
 "]."
}], "Text",
 CellChangeTimes->{{3.5605192002510347`*^9, 3.5605193047244177`*^9}, 
   3.5605193350976715`*^9, {3.5605824842837367`*^9, 3.5605825681615343`*^9}, {
   3.560582630034073*^9, 3.5605826385215583`*^9}, {3.5605826757676888`*^9, 
   3.5605826757696886`*^9}, 3.560844720220897*^9, 3.5707700008069124`*^9, 
   3.6425763539441233`*^9},ExpressionUUID->"5529cd72-fc3d-4a1e-94bc-\
4a5bfcdd43fa"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["2.1.1. The Definition", "Subsubsection"]], \
"Subsubsection",
 CellChangeTimes->{{3.5605192002510347`*^9, 3.5605193047244177`*^9}, 
   3.5605193350976715`*^9, {3.5605824842837367`*^9, 3.5605825681615343`*^9}, {
   3.560582630034073*^9, 3.5605826385215583`*^9}, {3.5605826757676888`*^9, 
   3.5605826757696886`*^9}, 3.560844720220897*^9, {3.5707700008069124`*^9, 
   3.5707700142686825`*^9}, 3.570770132796462*^9, {3.570772653778654*^9, 
   3.570772662544155*^9}, 3.5707727076097326`*^9, {3.6005021231853824`*^9, 
   3.6005021236689835`*^9}, 
   3.601304536908106*^9},ExpressionUUID->"adc8241f-7caf-455e-adb6-\
acfa79bccf4e"],

Cell["\<\

First we set the dimension of the vector space:\
\>", "Text",
 CellChangeTimes->{{3.5605192002510347`*^9, 3.5605193047244177`*^9}, 
   3.5605193350976715`*^9, {3.5605824842837367`*^9, 3.5605825681615343`*^9}, {
   3.560582630034073*^9, 3.5605826385215583`*^9}, {3.5605826757676888`*^9, 
   3.5605826757696886`*^9}, 3.560844720220897*^9, {3.5707700008069124`*^9, 
   3.5707700142686825`*^9}, 
   3.570770132796462*^9},ExpressionUUID->"6630100c-70b9-4558-8cd3-\
0f1f44cf9fcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.560519341868083*^9, 
  3.5605193431472855`*^9}},ExpressionUUID->"c9f4f98b-3069-4591-9fa2-\
52bc96b60131"],

Cell["\<\
Our first definition of a vector is very simple, namely  an Array with a \
predefined dimension\
\>", "Text",
 CellChangeTimes->{{3.5608447626061716`*^9, 3.5608448108414564`*^9}, {
   3.6425020152064776`*^9, 3.642502046615333*^9}, 
   3.6425021458061094`*^9},ExpressionUUID->"d224d689-c5a6-44fa-ab89-\
8d5d4b7cf46a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", 
    RowBox[{"x_", ",", 
     RowBox[{"n_:", "dim"}]}], "]"}], ":=", 
   RowBox[{"Array", "[", 
    RowBox[{"x", ",", "n"}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.5608449036616197`*^9},ExpressionUUID->"b55b1459-1047-4bf6-8b51-\
078b9dba1161"],

Cell[BoxData[
 RowBox[{"?", "vec"}]], "Input",
 CellChangeTimes->{{3.560519370416134*^9, 
  3.560519371851336*^9}},ExpressionUUID->"07699850-2be2-4e8c-90ce-\
6bfd431fac84"],

Cell[BoxData[
 RowBox[{"vec", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.560519411725006*^9, 
  3.5605194161086135`*^9}},ExpressionUUID->"def1be80-eac3-453e-9c23-\
950a6be16d8f"],

Cell[TextData[{
 "The coordinates x[i] are supposed to be elements of  the given field. We \
remark that this isn\[CloseCurlyQuote]t a mandatory property of  vec \
following from its definition in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ";  it is an additional convention. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " has an object Vector allowing to specify the basic field  as a domain, see \
below."
}], "Text",
 CellChangeTimes->{{3.560519446294667*^9, 3.560519569971684*^9}, {
   3.560520517361348*^9, 3.560520571493443*^9}, {3.560520698468257*^9, 
   3.5605207845081778`*^9}, {3.5605208478358*^9, 3.560520870407091*^9}, 
   3.5605212432124147`*^9, 3.5606617641747046`*^9, 3.5608449679805326`*^9, {
   3.560845198392937*^9, 3.5608452185325727`*^9}, 3.560864036677905*^9, 
   3.6011841418582163`*^9, {3.601299235148863*^9, 3.601299306883966*^9}, 
   3.6425021401588993`*^9, {3.642502207001417*^9, 
   3.642502207937419*^9}},ExpressionUUID->"6ba9bf87-4ccd-41ef-805e-\
7991822c4d5e"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.560519574542492*^9, 3.560519574542492*^9}, {
  3.560845028025038*^9, 
  3.5608450508322783`*^9}},ExpressionUUID->"3cd4a3a8-7bc5-4c90-93bb-\
f7e5c8136764"],

Cell["\<\
In Mathematica a tensor is usually defined by its Array of coordinates :\
\>", "Text",
 CellChangeTimes->{{3.6425022983273787`*^9, 
  3.642502387468336*^9}},ExpressionUUID->"6ae53fe3-950c-4767-b077-\
f0018b2096c2"],

Cell[BoxData[
 RowBox[{"?", "Array"}]], "Input",
 CellChangeTimes->{{3.560520960879266*^9, 
  3.5605209632204*^9}},ExpressionUUID->"c0c8fcdf-c8e2-4b7c-bdcb-efcee07d710d"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"Array", "[", 
   RowBox[{"a", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6012993983331966`*^9, 3.601299410767908*^9}, 
   3.601299449350115*^9, {3.601299511670679*^9, 
   3.6012995232533417`*^9}},ExpressionUUID->"76eb8d46-4cd7-45dc-9a11-\
dbbebe885cba"],

Cell["\<\
The evaluation of the next cell yields an unsatisfactory result since \
(a+b)[i] isn\[CloseCurlyQuote]t defined\
\>", "Text",
 CellChangeTimes->{{3.570768318308679*^9, 3.570768365066354*^9}, {
   3.570768408852858*^9, 3.5707684243367434`*^9}, {3.5707684776607933`*^9, 
   3.5707685152609444`*^9}, {3.6004051250274954`*^9, 3.600405134659046*^9}, {
   3.6012996311005096`*^9, 3.6012996573400106`*^9}, 
   3.6425022522348976`*^9},ExpressionUUID->"3cf27cdc-9754-4972-94f1-\
ae1188976a50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], " ", "+", 
   RowBox[{"vec", "[", "b", "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{"vec", "[", 
   RowBox[{"a", "+", "b"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6012995691649675`*^9, 
  3.601299617229717*^9}},ExpressionUUID->"47fb547c-4422-4a40-8b7a-\
d8248a8d8175"],

Cell["Use plus to get the correct result", "Text",
 CellChangeTimes->{{3.5707685348290634`*^9, 3.5707685732692623`*^9}, {
  3.600405215019643*^9, 
  3.600405228859434*^9}},ExpressionUUID->"58e3f1e9-cee7-497d-84c4-\
a63b768d608f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], " ", "+", 
   RowBox[{"vec", "[", "b", "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{"vec", "[", 
   RowBox[{"plus", "[", 
    RowBox[{"a", ",", " ", "b"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570714586782629*^9, 3.570714629969099*^9}, {
   3.5707146913056073`*^9, 3.5707146994250717`*^9}, {3.5707637264816113`*^9, 
   3.570763774794375*^9}, {3.570768141829585*^9, 3.5707681816458626`*^9}, 
   3.570768448281113*^9, {3.600405061926886*^9, 3.6004050907985373`*^9}, {
   3.6012996828064675`*^9, 
   3.6012997296771483`*^9}},ExpressionUUID->"18ba1956-a053-49aa-86c2-\
bf5b353b6172"],

Cell["\<\
The reason is that plus, but not Plus, defines  the addition of functions, \
see Subsection 1.1.\
\>", "Text",
 CellChangeTimes->{{3.5605198626749983`*^9, 3.5605200213272767`*^9}, {
   3.560661827245615*^9, 3.560661838711635*^9}, 3.560866564724745*^9, {
   3.570768633063682*^9, 3.5707687486392927`*^9}, {3.5707689682008505`*^9, 
   3.5707689862068806`*^9}, {3.6004052716828833`*^9, 3.600405295507246*^9}, {
   3.6425024465732408`*^9, 3.6425024763898935`*^9}, {3.642502510029553*^9, 
   3.642502521372773*^9}},ExpressionUUID->"a6a67497-46ee-4a7f-93e7-\
bc05cdf143f6"],

Cell["\<\
The dimension must be a non-negative integer; it is the number of coordinates \
of the vector in dimension dim. The 0-dimensional vector space contains only \
one vector, the empty tuple:\
\>", "Text",
 CellChangeTimes->{{3.5605198626749983`*^9, 3.5605200213272767`*^9}, {
   3.560661827245615*^9, 3.560661838711635*^9}, 3.560866564724745*^9, {
   3.570768633063682*^9, 3.5707687486392927`*^9}, 3.57076878338428*^9, 
   3.601184145134222*^9},ExpressionUUID->"f6aecdea-23a4-4451-8e9a-\
8c4141eed182"],

Cell[BoxData[
 RowBox[{"vec", "[", 
  RowBox[{"x", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.560519654570633*^9, 
  3.5605196616998453`*^9}},ExpressionUUID->"64b54b6d-8651-430e-b36d-\
7b4d134bffd8"],

Cell["Vectors of the same vector space may be added:", "Text",
 CellChangeTimes->{{3.5605200533541327`*^9, 
  3.560520071606165*^9}},ExpressionUUID->"896eefbc-e96e-4943-ace4-\
5a3dd644cff3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "a", "]"}], "+", 
  RowBox[{"vec", "[", "b", "]"}]}]], "Input",
 CellChangeTimes->{{3.560520078485777*^9, 3.5605201028998203`*^9}, 
   3.6004053707425494`*^9},ExpressionUUID->"49699d79-aef6-4e7f-a699-\
de06eaea85df"],

Cell[TextData[{
 "With respect to the addition the vector space is an ",
 StyleBox["Abelian group",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.5605201918511763`*^9, 
  3.5605202289480414`*^9}},ExpressionUUID->"3839da26-b80f-4ff9-a691-\
70338d0695fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], " ", "+", 
   RowBox[{"vec", "[", "b", "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"vec", "[", "b", "]"}], " ", "+", " ", 
   RowBox[{"vec", "[", "a", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.560520242426465*^9, 
  3.560520294858157*^9}},ExpressionUUID->"95fde917-b6b1-4c27-97ad-\
57a511314665"],

Cell[TextData[{
 "Its neutral element is the ",
 StyleBox["null vector",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.5605212882189884`*^9, 3.560521302322795*^9}, 
   3.600405503819161*^9},ExpressionUUID->"31c6a920-292e-4d21-9407-\
7d0163830f84"],

Cell[BoxData[
 RowBox[{"?", "null"}]], "Input",
 CellChangeTimes->{{3.6012998172571573`*^9, 
  3.601299819237271*^9}},ExpressionUUID->"4adfa374-145e-4f82-a73e-\
d78753f96f6a"],

Cell[BoxData[
 RowBox[{"null", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5605213056979885`*^9, 
  3.560521308845168*^9}},ExpressionUUID->"7dddd2b0-1792-4d19-a6ab-\
d096faff490b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], " ", "+", 
   RowBox[{"vec", "[", 
    RowBox[{"-", "a"}], "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{"null", " ", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.560521334913659*^9, 
  3.5605213543087683`*^9}},ExpressionUUID->"afcbafc3-5b4d-4ad3-b43a-\
03ceb1d719ee"],

Cell[BoxData[
 RowBox[{"null", "[", "0", "]"}]], "Input",
 CellChangeTimes->{{3.57071474642776*^9, 
  3.5707147565853415`*^9}},ExpressionUUID->"df2cc59b-fa2e-4433-8f3f-\
39af2e8c469a"],

Cell["\<\
Vectors may be multiplied by scalars, assumed to be elements of the basis \
field:\
\>", "Text",
 CellChangeTimes->{{3.560521795595009*^9, 
  3.560521843498749*^9}},ExpressionUUID->"d512c18f-e4bf-425e-9f39-\
97150f32b464"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], "==", " ", 
  RowBox[{"vec", "[", 
   RowBox[{"3", "*", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5606108503786*^9, 3.560610858128043*^9}, {
  3.6004056709737215`*^9, 
  3.6004057116060457`*^9}},ExpressionUUID->"bf4b4927-da86-4ad7-9fdd-\
99cfa31f97ae"],

Cell[TextData[{
 StyleBox["Warning!",
  FontSize->14,
  FontWeight->"Bold",
  FontColor->RGBColor[1, 0, 0]],
 StyleBox[" Multiplication of arguments of vec using Times may generate \
nonsense! \nUse times instead.\n\n",
  FontSize->14,
  FontColor->GrayLevel[0]],
 StyleBox["Example:",
  FontSize->14,
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.5606110571544275`*^9, 3.560611172750039*^9}, {
   3.560611252448597*^9, 3.5606112528546205`*^9}, {3.6004080103005238`*^9, 
   3.6004080193230395`*^9}, 3.6004082087798758`*^9, {3.601300109900896*^9, 
   3.601300115547219*^9}, 
   3.6425038090588484`*^9},ExpressionUUID->"d6e401c5-b125-474d-b73d-\
3dd2e192ae8f"],

Cell["Replace 3 by the unspecified factor y:", "Text",
 CellChangeTimes->{{3.6004065144439654`*^9, 3.6004065368432465`*^9}, {
  3.601300249547883*^9, 
  3.6013002808276725`*^9}},ExpressionUUID->"51784b06-4c2d-4ca1-9f01-\
3849332ae509"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], " ", "\[Equal]", 
  RowBox[{"vec", "[", 
   RowBox[{"y", "*", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5606108503786*^9, 3.560610858128043*^9}, {
  3.6004056709737215`*^9, 3.6004057116060457`*^9}, {3.6012998695161467`*^9, 
  3.601299958230221*^9}, {3.6013001692472906`*^9, 
  3.60130020630241*^9}},ExpressionUUID->"5eaf9632-05cd-4e4d-9df5-\
23be6df8a9b8"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"y", "*", 
    RowBox[{"vec", "[", "x", "]"}]}], "==", " ", 
   RowBox[{"vec", "[", 
    RowBox[{"y", "*", "x"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5606108503786*^9, 3.560610858128043*^9}, {
  3.6004056709737215`*^9, 3.6004057116060457`*^9}, {3.600406281083618*^9, 
  3.6004062952224264`*^9}, {3.6004065450387154`*^9, 
  3.6004065526941533`*^9}},ExpressionUUID->"c9a3873f-31df-4371-9500-\
a646b58800d2"],

Cell["This is a senseless expression since (xy)[i] isn\[CloseCurlyQuote]t \
defined. ", "Text",
 CellChangeTimes->{{3.600406582347849*^9, 3.60040660665924*^9}, {
   3.6013003094433093`*^9, 3.6013003603882227`*^9}, 
   3.601300391227987*^9},ExpressionUUID->"79724e69-0d1e-4730-8dd2-\
7c3b7860ac03"],

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"y", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.600406338256888*^9, 3.6004063475334187`*^9}, 
   3.6004064344133883`*^9},ExpressionUUID->"583a1062-5bcd-4879-98ac-\
734bf9cb37ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"0", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], "==", 
  RowBox[{"vec", "[", 
   RowBox[{"0", "*", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5606108691146717`*^9, 3.5606108789522343`*^9}, {
  3.600405732886263*^9, 
  3.6004057421657934`*^9}},ExpressionUUID->"7bbe5794-6e97-4c49-ae87-\
dc0dc1c0211e"],

Cell["\<\
is senseless too.

Applying times yields correct results:\
\>", "Text",
 CellChangeTimes->{{3.600406633644783*^9, 3.600406670594897*^9}, 
   3.6004075230036516`*^9, {3.6013004121641846`*^9, 3.6013004210196905`*^9}, 
   3.6013005303959465`*^9, 
   3.601304579771558*^9},ExpressionUUID->"1e1aa6fb-d5d7-4853-8596-\
3741d22d83f0"],

Cell[BoxData[
 RowBox[{"?", "times"}]], "Input",ExpressionUUID->"d4ecfef5-5dd7-4d58-8986-d0462f0ee69f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"0", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], "==", 
  RowBox[{"vec", "[", 
   RowBox[{"times", "[", 
    RowBox[{"0", ",", "x"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5606108691146717`*^9, 3.5606108789522343`*^9}, {
  3.600405732886263*^9, 3.6004057421657934`*^9}, {3.600405977308243*^9, 
  3.6004060033497324`*^9}},ExpressionUUID->"2971cc55-b4de-4ff7-9e10-\
77cd5db8d05e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], "==", 
  RowBox[{"vec", "[", 
   RowBox[{"times", "[", 
    RowBox[{"y", ",", "x"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5606108691146717`*^9, 3.5606108789522343`*^9}, {
  3.600405732886263*^9, 3.6004057421657934`*^9}, {3.600405977308243*^9, 
  3.6004060455181446`*^9}, {3.601300443022949*^9, 
  3.6013004512544203`*^9}},ExpressionUUID->"46a687f5-9293-41b8-97c9-\
edfa0ef6aa3b"],

Cell["Compare the Attributes:", "Text",
 CellChangeTimes->{{3.6013006877239456`*^9, 
  3.6013007000676517`*^9}},ExpressionUUID->"54d5ec4f-a8a0-4750-8b88-\
ceacd2cb53ca"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "times", "]"}]], "Input",
 CellChangeTimes->{{3.5708055819617276`*^9, 
  3.5708055985046735`*^9}},ExpressionUUID->"04ea8db1-29ac-439d-bed1-\
f672ebf79f5b"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "Times", "]"}]], "Input",
 CellChangeTimes->{{3.5708055819617276`*^9, 
  3.5708056120084457`*^9}},ExpressionUUID->"46c7d63d-9fd8-4723-b7e1-\
73fb1a62b6fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.1.2. Checking the Vector Space Axioms", "Subsubsection",
 CellChangeTimes->{{3.570769755763897*^9, 3.570769759773126*^9}, {
   3.5707698029755974`*^9, 3.5707698658841953`*^9}, {3.5707726677444525`*^9, 
   3.5707726733257723`*^9}, {3.570772713534072*^9, 3.5707727267568283`*^9}, {
   3.6013050094201326`*^9, 3.601305012460306*^9}, 
   3.6015609612920694`*^9},ExpressionUUID->"bca147d7-1653-407f-8cbe-\
aa4527e1cc4b"],

Cell["\<\
Vectors may be multiplied by scalars. The result is a vector of the same \
dimension, of course:\
\>", "Text",
 CellChangeTimes->{{3.560663622765173*^9, 3.5606636841416836`*^9}, {
  3.560663780078171*^9, 
  3.560663808421792*^9}},ExpressionUUID->"d9bd89b6-152f-4c1d-9bec-\
21d7dd39d542"],

Cell["Defining", "Text",
 CellChangeTimes->{{3.5606639620775805`*^9, 
  3.5606639646057253`*^9}},ExpressionUUID->"3f85f9ca-c344-4b9a-84be-\
52e31589c6e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"b", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{"a", "*", 
   RowBox[{"x", "[", "i", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5606638210445137`*^9, 
  3.5606638649860272`*^9}},ExpressionUUID->"f2f6e022-7d1f-4a46-b46e-\
2ef0502d71fb"],

Cell["we  obtain", "Text",
 CellChangeTimes->{{3.560663705341896*^9, 3.560663792533883*^9}, {
  3.560663888605378*^9, 
  3.5606638933496494`*^9}},ExpressionUUID->"54d3a152-59b0-4767-aa82-\
3ba2d73c0065"],

Cell[BoxData[
 RowBox[{"a", "*", 
  RowBox[{"vec", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.560868622165559*^9, 
  3.5608686305115733`*^9}},ExpressionUUID->"0913ba18-d2af-4f84-9769-\
17ddf88500c7"],

Cell["\<\
The result is a vector of the same dimension over the same field:\
\>", "Text",
 CellChangeTimes->{{3.6004088054360027`*^9, 
  3.6004088508275986`*^9}},ExpressionUUID->"cf580d62-d016-43e2-9d7c-\
32171efd42e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "b", "]"}], "\[Equal]", 
  RowBox[{"a", "*", 
   RowBox[{"vec", "[", "x", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5606638988509645`*^9, 3.5606639363681097`*^9}, 
   3.6015605931782227`*^9},ExpressionUUID->"8b606fc2-ce90-4842-acd2-\
623c572e9a30"],

Cell[TextData[{
 "Tacitly ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " assumes the field to be commutative and not skew:"
}], "Text",
 CellChangeTimes->{{3.560664000341769*^9, 3.56066403130154*^9}, {
  3.5606642483349533`*^9, 
  3.560664263957847*^9}},ExpressionUUID->"a81457a4-135d-4887-b8e1-\
e4ecbe13f748"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "*", 
   RowBox[{"vec", "[", "x", "]"}]}], "\[Equal]", " ", 
  RowBox[{
   RowBox[{"vec", "[", "x", "]"}], "*", "a"}]}]], "Input",
 CellChangeTimes->{{3.56052150853759*^9, 3.5605215392143445`*^9}, {
  3.5606589767306085`*^9, 3.5606589847646227`*^9}, {3.6015605941142244`*^9, 
  3.601560595315427*^9}},ExpressionUUID->"d11dc95b-6de3-446d-9d59-\
6bf8fb2e5fc1"],

Cell["\<\
Vectors of the same dimension may be added adding their coordinates:\
\>", "Text",
 CellChangeTimes->{{3.560664297916789*^9, 
  3.560664326965451*^9}},ExpressionUUID->"4f3c835e-54df-4ade-9d85-\
5726ff55c908"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"a", "[", "i", "]"}], " ", "+", 
   RowBox[{"b", "[", "i", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.560663503517352*^9, 
  3.5606635226814485`*^9}},ExpressionUUID->"bfa7a881-a75d-42d1-9369-\
555f00633a11"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "c", "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], " ", "+", " ", 
   RowBox[{"vec", "[", "b", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.560662917347825*^9, 3.5606629826585608`*^9}, {
   3.560663546674821*^9, 3.560663551041071*^9}, 3.5606643391451473`*^9, {
   3.6015605968130293`*^9, 
   3.601560599106233*^9}},ExpressionUUID->"fc28be37-2460-41c6-93d3-\
f574b10dc278"],

Cell[BoxData[
 RowBox[{"vec", "[", "c", "]"}]], "Input",
 CellChangeTimes->{{3.56066296953281*^9, 3.5606629754161468`*^9}, 
   3.601560600167035*^9},ExpressionUUID->"1530b790-6671-4058-8c72-\
9ef15d42f566"],

Cell[BoxData[
 RowBox[{"Clear", "[", "c", "]"}]], "Input",
 CellChangeTimes->{{3.560663274427249*^9, 
  3.560663314527543*^9}},ExpressionUUID->"2ef910a2-3d9a-4635-bba5-\
4bdba5be248e"],

Cell[BoxData[
 RowBox[{"vec", "[", "c", "]"}]], "Input",
 CellChangeTimes->{{3.560663319356819*^9, 3.560663325368163*^9}, {
   3.560666989552742*^9, 3.560666991871875*^9}, 
   3.601560601181037*^9},ExpressionUUID->"01e37817-4b8f-4c86-9b56-\
e8fa1e3caa86"],

Cell["The neutral element is the null vector", "Text",
 CellChangeTimes->{{3.560664526301852*^9, 
  3.5606645415737257`*^9}},ExpressionUUID->"ef40d2f0-54d5-4ed9-8f26-\
631049806ff9"],

Cell[BoxData[
 RowBox[{"null", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5606645484281178`*^9, 
  3.56066455108027*^9}},ExpressionUUID->"3ad1cf53-197f-46cb-a30d-\
205ab633d732"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "a", "]"}], " ", "-", 
  RowBox[{"vec", "[", "a", "]"}]}]], "Input",
 CellChangeTimes->{{3.560664559565755*^9, 3.560664577167762*^9}, {
  3.601560602195039*^9, 
  3.601560603318241*^9}},ExpressionUUID->"b86b4b95-bf6c-46df-85de-\
6fd092bd2b3a"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"vec", "[", "a", "]"}], "+", 
     RowBox[{"vec", "[", "x", "]"}]}], " ", "\[Equal]", " ", 
    RowBox[{"null", "[", "]"}]}], ",", " ", 
   RowBox[{"vec", "[", "x", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5606645923876324`*^9, 3.5606646484678397`*^9}, {
  3.601560604425843*^9, 
  3.601560608029449*^9}},ExpressionUUID->"a4b2e594-f7f5-40f7-ae5f-\
5bcd2158f83c"],

Cell["\<\
Thus the vectors of the same dimension form an Abelian group. Also the other \
axioms of  a vector space (see [OSI], \[Section] 4.2) are satisfied:\
\>", "Text",
 CellChangeTimes->{{3.560667034005285*^9, 
  3.5606671734942627`*^9}},ExpressionUUID->"846c8873-7003-4c6d-a86d-\
fef76fea801f"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"vec", "[", "x", "]"}], " ", "+", 
      RowBox[{"vec", "[", "y", "]"}]}], ")"}], "*", "a"}], " ", "\[Equal]", 
   " ", 
   RowBox[{
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "*", "a"}], " ", "+", 
    RowBox[{
     RowBox[{"vec", "[", "y", "]"}], "*", "a"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5606672139085746`*^9, 3.56066723061553*^9}, {
  3.5606678481598516`*^9, 3.5606679042530603`*^9}, {3.601560609152651*^9, 
  3.601560612381857*^9}},ExpressionUUID->"a273b57f-0fd5-404e-b1bd-\
b642b3636dd1"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"a", "+", "b"}], ")"}]}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "*", "a"}], "+", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "*", "b"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.560667932523677*^9, 3.560667977612256*^9}, {
  3.6015606134114585`*^9, 
  3.6015606157046623`*^9}},ExpressionUUID->"44579c21-3f31-46df-adcf-\
d9bdf97c600e"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"vec", "[", "x", "]"}], "*", "a"}], ")"}], "*", "b"}], " ", 
   "\[Equal]", " ", 
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"a", "*", "b"}], ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.560667932523677*^9, 3.560667977612256*^9}, {
  3.560668078542029*^9, 3.560668164433942*^9}, {3.601560616718664*^9, 
  3.601560617810666*^9}},ExpressionUUID->"50d7b2bd-0016-4624-a67d-\
23f0a00822bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vec", "[", "x", "]"}], "*", "1"}], " ", "\[Equal]", " ", 
  RowBox[{"vec", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.560668212812709*^9, 3.5606682277125607`*^9}, {
  3.6015606193862686`*^9, 
  3.6015606202910705`*^9}},ExpressionUUID->"bd1aa92f-6fe2-42ff-81b7-\
5b59559de3c6"],

Cell[TextData[{
 StyleBox["Lemma.",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox[" vec[x] *a== null[] if and only if a==0 or vec[x]== null[]:",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.560522167715293*^9, 3.560522213266898*^9}, {
  3.5605222845869775`*^9, 3.5605223177628756`*^9}, {3.5605665145133753`*^9, 
  3.560566515355777*^9}, {3.560668414158225*^9, 3.560668421661654*^9}, {
  3.5606734163491325`*^9, 3.5606734266047187`*^9}, {3.560673458636551*^9, 
  3.5606734642368712`*^9}, {3.6015606216482725`*^9, 
  3.601560628013084*^9}},ExpressionUUID->"19358331-3a47-4b13-bc88-\
2a03919c9dcf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "*", "a"}], "\[Equal]", " ", 
    RowBox[{"null", "[", "]"}]}], ",", " ", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], ",", "a"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56052232029902*^9, 3.5605223565260925`*^9}, {
   3.5606590373367147`*^9, 3.560659038007516*^9}, {3.5606684320512486`*^9, 
   3.560668438458615*^9}, {3.5707156608670635`*^9, 3.570715698610222*^9}, 
   3.570715770050308*^9, {3.5707693564610577`*^9, 3.570769359573236*^9}, 
   3.601560630758689*^9},ExpressionUUID->"9ce0d99d-6f0b-4cbb-9445-\
713527b1f474"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Solve", "::", "svars"}], "MessageName"], ":", 
  " ", "\<\"Equations may not give solutions for all \\\"solve\\\" variables. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Solve/svars\\\", \
ButtonNote -> \\\"Solve::svars\\\"]\\)\"\>"}]], "Message", "MSG",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5707157030224743`*^9, 3.5707157743095517`*^9, 
  3.5707693606102953`*^9, 3.5707694377837095`*^9, 3.600409164590545*^9, 
  3.601560721176448*^9, 
  3.6425041382106333`*^9},ExpressionUUID->"17c3cb44-5cdd-4021-8db1-\
729f0ba37094"]
}, Closed]],

Cell[TextData[{
 "In the next equation ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " silently assumes that a is not zero."
}], "Text",
 CellChangeTimes->{{3.5605226502438917`*^9, 3.5605226972355795`*^9}, {
  3.560522745219324*^9, 3.5605227947951593`*^9}, {3.570715875888362*^9, 
  3.5707158927433257`*^9}},ExpressionUUID->"fd22a000-bd46-49d5-9313-\
0d62e08607c3"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "*", 
     RowBox[{"vec", "[", "x", "]"}]}], "\[Equal]", " ", 
    RowBox[{"null", "[", "]"}]}], ",", " ", 
   RowBox[{"vec", "[", "x", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56052232029902*^9, 3.560522404926861*^9}, {
  3.5606590549023457`*^9, 3.560659061360757*^9}, {3.6015606332390933`*^9, 
  3.601560634565096*^9}},ExpressionUUID->"223ae093-15fa-459c-8988-\
a900d05d64c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], "/.", 
    RowBox[{"Flatten", "[", "%", "]"}]}], " ", ")"}], "==", " ", 
  RowBox[{"null", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.5605224249630065`*^9, 3.560522488590646*^9}, {
   3.560522549662139*^9, 3.560522554142395*^9}, {3.560659087459603*^9, 
   3.560659088255204*^9}, 
   3.6015606369518995`*^9},ExpressionUUID->"9a8f3f50-c42d-434d-82bc-\
3cc7485e26d4"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"z", "*", 
     RowBox[{"vec", "[", "x", "]"}]}], " ", "\[Equal]", " ", 
    RowBox[{"vec", "[", "x", "]"}]}], ",", " ", "z"}], "]"}]], "Input",
 CellChangeTimes->{{3.5605228238738227`*^9, 3.5605228499513144`*^9}, {
  3.560659105087634*^9, 3.5606591115460453`*^9}, {3.601560644970314*^9, 
  3.6015606480747194`*^9}},ExpressionUUID->"0d6a4ee2-dedf-45bc-a413-\
bc9ff89a7a98"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.1.3. Bases and Coordinates", "Subsubsection",
 CellChangeTimes->{{3.570770228304925*^9, 3.570770239621572*^9}, {
  3.5707726787740836`*^9, 
  3.570772701739397*^9}},ExpressionUUID->"1f7b20c7-28fa-4e6e-b7fd-\
fffb75853a23"],

Cell["\<\
The coordinates of vec[x] are assumed to be the coordinates  with respect to \
the standard basis, consisting of  unit vectors of the coordinate axes:\
\>", "Text",
 CellChangeTimes->{{3.560520357523467*^9, 3.560520397927538*^9}, {
   3.560523016547843*^9, 3.560523109252146*^9}, 3.560566856497176*^9, 
   3.6004093594206886`*^9, 3.601184147833027*^9, {3.6012976399646235`*^9, 
   3.601297688763415*^9}, 3.601561000744539*^9, 
   3.642504313632743*^9},ExpressionUUID->"c82e9a31-fbb2-42d9-a123-\
7308b2cd6024"],

Cell[BoxData[
 RowBox[{"?", "stb"}]], "Input",
 CellChangeTimes->{{3.560523190225777*^9, 
  3.5605231920528817`*^9}},ExpressionUUID->"0de3f937-6c3e-44d9-8748-\
b56a780e4e1c"],

Cell[BoxData[
 RowBox[{"stb", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.5606686119555387`*^9, 
  3.5606686162397833`*^9}},ExpressionUUID->"fcbe95ff-55d8-4326-b62b-\
d7ea2a1ff679"],

Cell["\<\
Each vector is a linear combination of the standard basis with its \
coordinates as uniquely defined  coordinates\
\>", "Text",
 CellChangeTimes->{{3.5606686415632315`*^9, 3.5606687336624994`*^9}, 
   3.601184150095031*^9},ExpressionUUID->"f73b3db4-3d47-42d4-bdd1-\
5e094ff60e1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], "*", 
     RowBox[{"x", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605671790433426`*^9, 3.5605672584162817`*^9}, {
   3.560668512107827*^9, 3.560668512785866*^9}, 
   3.6015606515691257`*^9},ExpressionUUID->"938e4736-2f6e-4624-913b-\
dc33fb5728c5"],

Cell["The uniqueness follows from", "Text",
 CellChangeTimes->{{3.5606688873092875`*^9, 
  3.560668898701939*^9}},ExpressionUUID->"8e40dbdd-9b97-458c-a813-\
fadd9ef2931a"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], " ", "\[Equal]", " ", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"stb", "[", "i", "]"}], "*", 
       RowBox[{"y", "[", "i", "]"}]}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ",", " ", 
   RowBox[{"vec", "[", "y", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5606687474182863`*^9, 3.560668815597186*^9}, 
   3.6015606532695284`*^9},ExpressionUUID->"0643937d-bcba-44a2-ad16-\
4078f3f2f727"],

Cell[BoxData[
 RowBox[{"?", "basis"}]], "Input",
 CellChangeTimes->{{3.5605233026092052`*^9, 
  3.560523304356305*^9}},ExpressionUUID->"8605180e-42f3-4b9e-a0bf-\
d805594a821e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"basis", "[", 
   RowBox[{"IdentityMatrix", "[", "dim", "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"IdentityMatrix", "[", "dim", "]"}]}]], "Input",ExpressionUUID->\
"1a347685-6e68-42b2-9a50-d35c1de7d448"],

Cell[BoxData[
 RowBox[{"basis", "[", 
  RowBox[{"IdentityMatrix", "[", "dim", "]"}], "]"}]], "Input",ExpressionUUID-\
>"d6e3c8d8-b311-416a-8583-bb7a1ebf4222"],

Cell[BoxData[
 RowBox[{"%", " ", "\[Equal]", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"stb", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605231459532447`*^9, 
  3.5605231691495714`*^9}},ExpressionUUID->"ae4c2924-4845-406e-afe0-\
4b0ef9e71f84"],

Cell[TextData[{
 StyleBox["Warning",
  FontColor->RGBColor[1, 0, 0]],
 ": In this case the result of basis[] coincides with the argument; \
eventually it may happen  that the order of the rows is changed. \nWe \
consider a sequence of 10 random vectors of dimension 3:"
}], "Text",
 CellChangeTimes->{{3.560523238149518*^9, 3.5605232595717435`*^9}, {
   3.560523343715556*^9, 3.56052339587554*^9}, {3.5605669289281034`*^9, 
   3.5605669679281716`*^9}, 
   3.5606690121684294`*^9},ExpressionUUID->"9832a0ca-d8de-4d69-867f-\
2744438d102b"],

Cell[BoxData[
 RowBox[{"?", "randomv"}]], "Input",
 CellChangeTimes->{{3.5605234045290346`*^9, 
  3.5605234077972217`*^9}},ExpressionUUID->"325f1aa2-2cb1-4b0e-9a10-\
e09f223650ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";", 
  RowBox[{"btn", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"randomv", "[", 
      RowBox[{"3", ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "5"}], ",", "5"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", "10", "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.5605234568860292`*^9, 3.5605234906709614`*^9, 3.5605237206861176`*^9, {
   3.56086884462875*^9, 3.560868849932759*^9}, {3.5707703985226603`*^9, 
   3.570770403899968*^9}, {3.5707704369108562`*^9, 
   3.570770453129784*^9}},ExpressionUUID->"09a76d27-6a5b-4e08-8349-\
6f6599660386"],

Cell[BoxData[
 RowBox[{"rank", "[", "btn", "]"}]], "Input",
 CellChangeTimes->{{3.5707714527959614`*^9, 
  3.5707714638065915`*^9}},ExpressionUUID->"f470bdc7-f9d8-476d-b38b-\
9be9d6b0eaf7"],

Cell["\<\
Here is a random basis of the 3-dimensional real vector space:
(Ignore the messages)\
\>", "Text",
 CellChangeTimes->{{3.5605670050874367`*^9, 3.5605670596251326`*^9}, {
   3.5618781271191225`*^9, 3.56187814561018*^9}, 
   3.6425763883541846`*^9},ExpressionUUID->"594e5f92-4e2b-4e15-8756-\
7b8ac4b394bd"],

Cell[BoxData[
 RowBox[{"bt", " ", "=", 
  RowBox[{"basis", "[", "btn", "]"}]}]], "Input",
 CellChangeTimes->{{3.5584313935176697`*^9, 3.5584313948047433`*^9}, {
  3.570771737996274*^9, 
  3.5707717432605753`*^9}},ExpressionUUID->"fe2acea7-7372-4350-bdb4-\
7f139ca041c7"],

Cell["\<\
Clearly, with probability 1 any dim of dim - dimensional random vectors form \
a basis of the vector space. Orthogonality is not required; the Euclidean or \
metric properties of  Euclidean vector spaces can be considered in another \
notebook. Here is the matrix of the Dot products of the random basis vectors:\
\
\>", "Text",
 CellChangeTimes->{{3.5606691199665947`*^9, 3.56066933458187*^9}, 
   3.560868875111203*^9, {3.6447571925295596`*^9, 
   3.644757217474004*^9}},ExpressionUUID->"e8bc1852-9c3f-487c-b82f-\
2d8e64d49daa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", "i", "]"}], "]"}], ".", 
     RowBox[{"bt", "[", 
      RowBox[{"[", "j", "]"}], "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.5605238228729625`*^9, 
  3.5605238438891644`*^9}},ExpressionUUID->"7991b552-03cc-4484-b554-\
50dd1b2a5615"],

Cell["Their determinant is", "Text",
 CellChangeTimes->{{3.560669348589671*^9, 
  3.5606693547180223`*^9}},ExpressionUUID->"13199836-56fb-4c82-bff8-\
eb72735cc247"],

Cell[BoxData[
 RowBox[{"Det", "[", "bt", "]"}]], "Input",
 CellChangeTimes->{{3.5584313313882585`*^9, 3.558431357922366*^9}, 
   3.558431406158116*^9},ExpressionUUID->"f632ed59-0644-4b38-940c-\
ca3e729233d5"],

Cell["\<\
The rows of the matrix bt form a basis of the 3-dimensional vector space,  \
they are the coordinates of the new basis vectors bt[[i]] with respect to the \
standard basis {stb[j]}\
\>", "Text",
 CellChangeTimes->{{3.5605241253072605`*^9, 3.560524200691572*^9}, {
   3.5605242771149435`*^9, 3.560524305955593*^9}, 3.5605244181340094`*^9, 
   3.560567377179291*^9, {3.5605676745782127`*^9, 
   3.5605677603627634`*^9}},ExpressionUUID->"b4b2614d-68ae-449a-9421-\
0e3fb50008a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "j"}], "]"}], "]"}], "*", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"bt", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605244474176846`*^9, 3.5605244612144737`*^9}, {
  3.5605245101262712`*^9, 3.5605245567819395`*^9}, {3.5605246086719074`*^9, 
  3.560524689335521*^9}, {3.5605247525441365`*^9, 3.560524753807209*^9}, {
  3.560567396897725*^9, 3.5605674118737516`*^9}, {3.5618778340133576`*^9, 
  3.5618778719325266`*^9}},ExpressionUUID->"9940eac2-a195-43a6-9973-\
33fc30318fde"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "j"}], "]"}], "]"}], "*", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"bt", "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605244474176846`*^9, 3.5605244612144737`*^9}, {
   3.5605245101262712`*^9, 3.5605245567819395`*^9}, {3.5605246086719074`*^9, 
   3.560524689335521*^9}, {3.5605247525441365`*^9, 3.560524753807209*^9}, {
   3.5605247905153084`*^9, 3.5605248015509396`*^9}, 3.560567452371423*^9, {
   3.5605675854708567`*^9, 3.5605675889808626`*^9}, {3.5618778888384933`*^9, 
   3.561877903727345*^9}},ExpressionUUID->"44371ed1-aafa-472d-b9b0-\
a27983c927d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"3", ",", "j"}], "]"}], "]"}], "*", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"bt", "[", 
   RowBox[{"[", "3", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605244474176846`*^9, 3.5605244612144737`*^9}, {
  3.5605245101262712`*^9, 3.5605245567819395`*^9}, {3.5605246086719074`*^9, 
  3.560524689335521*^9}, {3.5605247525441365`*^9, 3.560524753807209*^9}, {
  3.5605247905153084`*^9, 3.5605248262633533`*^9}, {3.560567601882085*^9, 
  3.560567617934513*^9}, {3.561877915780034*^9, 
  3.561877929286807*^9}},ExpressionUUID->"57ecb4ad-36fd-4d2f-8dcd-\
ec21f89b8139"],

Cell["\<\
The standard  basis may be expressed with respect to the basis bt[[i]] by the \
inverse matrix\
\>", "Text",
 CellChangeTimes->{{3.560525226595251*^9, 3.560525277723175*^9}, {
  3.5605262361889963`*^9, 3.5605262558361197`*^9}, {3.5608690099422398`*^9, 
  3.5608690140918474`*^9}},ExpressionUUID->"dab819e5-6dd2-42bf-8472-\
cd496672cd9c"],

Cell[BoxData[
 RowBox[{"?", "Inverse"}]], "Input",
 CellChangeTimes->{{3.5605252874637322`*^9, 
  3.5605253084459324`*^9}},ExpressionUUID->"4397e512-49ac-48d5-9a98-\
0ccc5391db0c"],

Cell[BoxData[
 RowBox[{"ct", " ", "=", " ", 
  RowBox[{"Inverse", "[", "bt", "]"}]}]], "Input",
 CellChangeTimes->{{3.560525314297267*^9, 3.56052531696542*^9}, {
  3.5605262628535213`*^9, 3.5605262776623683`*^9}, {3.5605263326545134`*^9, 
  3.560526332869526*^9}},ExpressionUUID->"7d7a237f-107a-4270-b35d-\
40329e65cc2d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"ct", ".", "bt"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.56052628765594*^9, 
  3.560526311485303*^9}},ExpressionUUID->"1091ee92-03f5-4e2a-80fa-\
8743a1e38d5c"],

Cell["\<\
The small numbers in this matrix are caused by the  numerical calculation; \
they can be smoothed to zero applying Chop:\
\>", "Text",
 CellChangeTimes->{{3.560669479238144*^9, 3.5606694865895643`*^9}, {
   3.5606695429337873`*^9, 3.560669637637204*^9}, 
   3.642504624349692*^9},ExpressionUUID->"e5ddd38a-9b81-4d71-979f-\
bb7763c79f9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Chop", "[", "%", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.5605740055260057`*^9, 
  3.56057401343522*^9}},ExpressionUUID->"d3f927a5-8115-428f-9be8-\
2a5bf9951f61"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Chop", "[", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"bt", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], "*", 
        RowBox[{"ct", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "k"}], "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "dim"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.560574388163478*^9, 3.5605745369877396`*^9}, {
  3.560574602414254*^9, 
  3.5605747050156345`*^9}},ExpressionUUID->"83b5f7f8-dc5c-48b8-9c7c-\
cee5431c5b6a"],

Cell["\<\
The coordinates of vec[x] with respect to the basis bt[[i]]  we denote by \
y[i]. We have two basis representations of vec[x], the standard one:\
\>", "Text",
 CellChangeTimes->{{3.5605241253072605`*^9, 3.560524200691572*^9}, {
   3.5605242771149435`*^9, 3.560524305955593*^9}, 3.5605244181340094`*^9, {
   3.560575420526491*^9, 3.5605755156398582`*^9}, {3.5606697386619825`*^9, 
   3.5606697596141806`*^9}, {3.560869070829147*^9, 3.5608690830595684`*^9}, 
   3.6015606571539354`*^9, {3.601561168226433*^9, 
   3.601561171330838*^9}},ExpressionUUID->"8d553dcc-0f10-4aec-8523-\
ca28751e5196"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], "\[Equal]", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], "*", 
     RowBox[{"x", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5605265243634787`*^9, 3.5605265689890313`*^9}, {
   3.5605756225468464`*^9, 3.560575661827715*^9}, {3.560869088987579*^9, 
   3.5608690894399796`*^9}, 
   3.601560658573538*^9},ExpressionUUID->"15feab42-a4e3-4a65-bede-\
d10779a86954"],

Cell["\<\
The coordinates y[j] of vec[x] with respect  to the basis {bt[[i]]} are \
uniquely defined as the solution of the following equation:\
\>", "Text",
 CellChangeTimes->{{3.56057600632312*^9, 3.5605761192049184`*^9}, 
   3.5608691087528133`*^9},ExpressionUUID->"7f0d650f-d53e-490a-8206-\
20509336c159"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vec", "[", "x", "]"}], "\[Equal]", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bt", "[", 
        RowBox[{"[", "j", "]"}], "]"}], "*", 
       RowBox[{"y", "[", "j", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"vec", "[", "y", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5605265243634787`*^9, 3.5605265689890313`*^9}, {
  3.5605756225468464`*^9, 3.560575661827715*^9}, {3.5605756936673713`*^9, 
  3.560575756566682*^9}, {3.560575796081551*^9, 3.5605758573272586`*^9}, {
  3.560669805973832*^9, 3.5606698065568657`*^9}, {3.5608691627913084`*^9, 
  3.5608691633061094`*^9}, {3.6015606596655397`*^9, 
  3.6015606619275436`*^9}},ExpressionUUID->"0bea8242-2a46-4a9d-99e1-\
eb622cace2d7"],

Cell[BoxData[
 RowBox[{"vy", " ", "=", 
  RowBox[{
   RowBox[{"vec", "[", "y", "]"}], "/.", 
   RowBox[{"Flatten", "[", "%", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5605758909609175`*^9, 3.5605759381510005`*^9}, {
   3.560869179046537*^9, 3.560869179670538*^9}, 
   3.601560663643547*^9},ExpressionUUID->"f890d5e2-0dd1-4df7-b277-\
c430323ed244"],

Cell["\<\
On the other hand, , we may insert the representations of bt[[j]] with \
respect to the standard basis \
\>", "Text",
 CellChangeTimes->{{3.560576321662074*^9, 3.5605763559197345`*^9}, {
   3.5605764049506207`*^9, 3.560576475571944*^9}, 3.560576847039797*^9, 
   3.56086924907506*^9, 3.6012981486597195`*^9, 
   3.6425764291582565`*^9},ExpressionUUID->"bc3cb0d7-79ab-4b4f-b32a-\
cb9b706f1855"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bt", "[", 
   RowBox[{"[", "j", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"j", ",", "i"}], "]"}], "]"}], "*", 
     RowBox[{"stb", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5605765854117374`*^9, 3.560576661290271*^9}, {
  3.5605767522384305`*^9, 3.5605767688368597`*^9}, {3.5605768023457184`*^9, 
  3.560576809537331*^9}, {3.5605797315752907`*^9, 3.5605797372616158`*^9}, {
  3.5618779755784545`*^9, 
  3.561878000044854*^9}},ExpressionUUID->"95a2ff60-70ef-4f4b-9b3d-\
b25ce0b6f8ea"],

Cell["into the equation", "Text",
 CellChangeTimes->{
  3.560576858989418*^9},ExpressionUUID->"db6cef00-5b37-48de-bc86-\
bd5060b679f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], "\[Equal]", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bt", "[", 
      RowBox[{"[", "j", "]"}], "]"}], "*", 
     RowBox[{"y", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "==", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"stb", "[", "i", "]"}], "*", 
        RowBox[{"bt", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "i"}], "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], "*", 
     RowBox[{"y", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.560576551200877*^9, 3.5605765638212996`*^9}, 
   3.5605769330271482`*^9, {3.5605769652724047`*^9, 3.560577071243391*^9}, 
   3.560577111928262*^9, {3.560869336872014*^9, 3.560869338541217*^9}, 
   3.60156066553115*^9},ExpressionUUID->"f3124ed3-9f0c-4741-b2b7-\
44f5eb6b4bbf"],

Cell["\<\
Interchanging the order of summation in the double sum at the right side of \
this equation\
\>", "Text",
 CellChangeTimes->{{3.5605773665370183`*^9, 3.5605774233052654`*^9}, {
  3.5605778364668965`*^9, 
  3.5605778370019274`*^9}},ExpressionUUID->"3640bff5-1fc9-477e-8b16-\
52f041c270f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "==", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"y", "[", "j", "]"}], 
        RowBox[{"bt", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "i"}], "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.560577427945531*^9, 3.560577434530907*^9}, 
   3.560577858649165*^9, {3.560577915489416*^9, 3.560577930833294*^9}, {
   3.5605779609850187`*^9, 3.5605779953769855`*^9}, {3.5605798257846794`*^9, 
   3.56057984380871*^9}, {3.5608693675728683`*^9, 3.5608693718472757`*^9}, 
   3.601560667371953*^9},ExpressionUUID->"3765272e-8d15-44e8-8be6-\
39cf0b8eaa94"],

Cell["\<\
and comparing the coordinates of this vector on both sides, we obtain\
\>", "Text",
 CellChangeTimes->{{3.560578081040886*^9, 
  3.560578127033516*^9}},ExpressionUUID->"0e08dc95-d32f-4a86-b4ce-\
79f12d0610c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "[", "i", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "[", "j", "]"}], "*", 
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"j", ",", "i"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.560578134547946*^9, 3.5605781467636447`*^9}, 
   3.560578192862281*^9, {3.5605785098704133`*^9, 
   3.560578519030937*^9}},ExpressionUUID->"a8e267e7-e32b-41ed-b294-\
2523a5cb0c76"],

Cell["Now apply the inverse transformation:", "Text",
 CellChangeTimes->{{3.560578309257939*^9, 3.560578333953351*^9}, 
   3.560578544481393*^9},ExpressionUUID->"d4b3e546-b32b-4daf-9b13-\
8f0c7402dcbc"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "[", "i", "]"}], "*", 
         RowBox[{"ct", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "k"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], "==", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"y", "[", "j", "]"}], "*", 
         RowBox[{"bt", "[", 
          RowBox[{"[", 
           RowBox[{"j", ",", "i"}], "]"}], "]"}], "*", 
         RowBox[{"ct", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "k"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "dim"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "dim"}], "}"}]}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5605785530658836`*^9, 3.5605786632891884`*^9}, {
  3.5605786988572226`*^9, 3.560578725607753*^9}, {3.5605787947477074`*^9, 
  3.560578820340171*^9}, {3.5605796009738207`*^9, 
  3.5605796280033665`*^9}},ExpressionUUID->"c27cff37-d4c8-49dd-9970-\
9fcfa5aece79"],

Cell["\<\
We obtain the vector vec[y] with respect to the basis {bt[[i]]} expressed by \
the coordinates of vec[x]  as linear functions of its standard coordinates:\
\>", "Text",
 CellChangeTimes->{{3.560579951824888*^9, 3.5605800803302383`*^9}, {
   3.560869633319335*^9, 3.5608696338341355`*^9}, {3.5619066334636693`*^9, 
   3.56190668520896*^9}, 
   3.6015606691191564`*^9},ExpressionUUID->"0827cf7c-9337-4279-8f2c-\
850f2e19a2af"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{"%", ",", 
   RowBox[{"vec", "[", "y", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5605791136359463`*^9, 3.5605791320279984`*^9}, {
   3.560869698480649*^9, 3.5608697000718517`*^9}, 
   3.601560670663559*^9},ExpressionUUID->"c487f3de-3c2f-45ad-9d77-\
e780b508216f"],

Cell["\<\
Clearly, it coincides up to numerical disturbances with the coordinate vector \
vy calculated above :\
\>", "Text",
 CellChangeTimes->{{3.560580115415245*^9, 
  3.560580199586059*^9}},ExpressionUUID->"bb2059d5-a00c-4eee-b028-\
5dfb871bc4aa"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"vy", "-", " ", 
     RowBox[{"vec", "[", "y", "]"}]}], "/.", 
    RowBox[{"Flatten", "[", "%", "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5605791581234913`*^9, 3.5605792000588894`*^9}, {
   3.5605794300560446`*^9, 3.5605794416617084`*^9}, {3.5605794825580473`*^9, 
   3.5605794881733685`*^9}, {3.5608697260302973`*^9, 3.5608697273251*^9}, 
   3.601560672285962*^9},ExpressionUUID->"e99e22d4-0f41-4a17-a062-\
68705a9d0086"],

Cell["\<\
Comparing the formulas for the transformation of the basis vectors and the \
corresponding coordinates:\
\>", "Text",
 CellChangeTimes->{{3.560580229440767*^9, 3.5605802880411186`*^9}, {
  3.5606733445910277`*^9, 
  3.560673352836499*^9}},ExpressionUUID->"221dcb0e-d04d-4e54-8b4b-\
67e1792bf290"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bt", "[", 
   RowBox[{"[", "j", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], "*", 
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"j", ",", "i"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"76c2f98b-c0b1-413c-bd0c-fa0292c5985e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "[", "j", "]"}], "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "i", "]"}], "*", 
     RowBox[{"ct", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.56058050259239*^9, 
  3.560580521327462*^9}},ExpressionUUID->"f83aa0bb-67a2-49fe-a6a4-\
1b573de30cf3"],

Cell[TextData[{
 "one recognizes the following \n\n",
 StyleBox["Rule. ",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox["Under a linear basis transformation the corresponding vector \
coordinates are transformed transposed inverse (also called contragredient) \
to the basis vectors.\n",
  FontColor->GrayLevel[0]],
 "\nUsing matrix multiplication as implemented in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " this rule can also be verified as follows:"
}], "Text",
 CellChangeTimes->{{3.5605806158498683`*^9, 3.5605806382261477`*^9}, {
   3.5605806887130356`*^9, 3.560580743105147*^9}, {3.560581047689568*^9, 
   3.5605811065929375`*^9}, {3.56058117132964*^9, 3.560581175576883*^9}, {
   3.560581966146101*^9, 3.560581994665732*^9}, {3.5605820881160774`*^9, 
   3.560582143521246*^9}, {3.560673544934487*^9, 3.560673569080868*^9}, 
   3.560673610775253*^9, 3.5608697955040197`*^9, {3.6425764792483454`*^9, 
   3.6425764898895645`*^9}},ExpressionUUID->"3cbff529-d1c0-4aa9-9c70-\
c15a98110186"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"bt", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"bt", "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"bt", "[", 
     RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "\[Equal]", " ", 
  RowBox[{"bt", ".", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"stb", "[", "1", "]"}], ",", 
     RowBox[{"stb", "[", "2", "]"}], ",", 
     RowBox[{"stb", "[", "3", "]"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.560581207803726*^9, 3.560581339430255*^9}, 
   3.5605817983775053`*^9, {3.5605818595250025`*^9, 
   3.560581891877853*^9}},ExpressionUUID->"f944bd1e-93d2-4431-be98-\
7bb641561ebc"],

Cell["We again apply Chop to smooth numerical disturbances:", "Text",
 CellChangeTimes->{{3.560582172600909*^9, 
  3.560582199129427*^9}},ExpressionUUID->"1ee1bfbe-4e53-4a4c-82d8-\
f95600971542"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"vy", " ", "==", " ", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"Inverse", "[", "bt", "]"}], "]"}], ".", 
     RowBox[{"vec", "[", "x", "]"}]}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.560581614451985*^9, 3.560581626267661*^9}, {
  3.5605817142206917`*^9, 3.56058172450128*^9}, {3.560581767293727*^9, 
  3.5605817743411303`*^9}},ExpressionUUID->"f37d878c-aa99-4810-8666-\
54722513bec5"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"vy", ",", "bt", ",", "btn", ",", "ct", ",", "y"}], "]"}]], "Input",\

 CellChangeTimes->{{3.5605822321513157`*^9, 3.5605822758598156`*^9}, 
   3.56058230688459*^9, {3.5606736476483617`*^9, 
   3.5606736575519285`*^9}},ExpressionUUID->"5544863d-b2f7-4564-8edd-\
e1852b9fb272"]
}, Closed]],

Cell["2.1.4. Appendix. Other Vector Definitions ", "Subsubsection",
 CellChangeTimes->{{3.5608457848603673`*^9, 3.560845802223198*^9}, {
  3.5608458360908575`*^9, 3.56084584323567*^9}, {3.570772689082673*^9, 
  3.570772693709938*^9}, {3.6013046828384533`*^9, 
  3.601304702403572*^9}},ExpressionUUID->"10462728-d931-4f76-9708-\
cced3395b20f"],

Cell[CellGroupData[{

Cell["The Obsolete Definition \[OpenCurlyDoubleQuote]vector\
\[CloseCurlyDoubleQuote]", "Subsubsection",
 CellChangeTimes->{{3.6013047332043333`*^9, 
  3.6013047606439033`*^9}},ExpressionUUID->"1fe14ea5-edf5-46f6-baa6-\
584fb5ab6304"],

Cell["In tensalgv3.m exists yet the object", "Text",
 CellChangeTimes->{3.6425050404494257`*^9, 
  3.706253627842396*^9},ExpressionUUID->"62527a4c-6f93-41ed-8ce0-\
4a14e09c47a3"],

Cell[BoxData[
 RowBox[{"?", "vector"}]], "Input",
 CellChangeTimes->{{3.6013051575636053`*^9, 3.6013051605457764`*^9}, 
   3.6013051927026157`*^9, 
   3.601305224214418*^9},ExpressionUUID->"d13950bf-2d70-4d12-b102-\
df7cf1359f83"],

Cell["\<\
vector is the same as vec; it is a long name for the same object only.\
\>", "Text",
 Evaluatable->False,
 CellChangeTimes->{{3.6018156915464106`*^9, 3.6018157198490295`*^9}, {
  3.6018157715849886`*^9, 
  3.6018157928812065`*^9}},ExpressionUUID->"b077ae38-d0d5-4820-bf0e-\
f9452d85e221"],

Cell[BoxData[
 RowBox[{"?", "vec"}]], "Input",
 CellChangeTimes->{{3.601815797623478*^9, 
  3.6018157994735837`*^9}},ExpressionUUID->"b074b4d8-345d-41eb-80a9-\
1d5ec1007408"],

Cell["\<\
After evaluating vector[x] with the symbol x one may replace x with a \
function. e.g.\
\>", "Text",
 CellChangeTimes->{{3.600408316659046*^9, 3.60040836813099*^9}, 
   3.6013015985320406`*^9, {3.6013053154206343`*^9, 
   3.6013053465724163`*^9}},ExpressionUUID->"a9138594-4527-429a-8948-\
f702ff44a333"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vector", "[", "x", "]"}], "/.", 
  RowBox[{"x", "\[Rule]", " ", "ff"}]}]], "Input",
 CellChangeTimes->{{3.600407721669015*^9, 3.6004077443033094`*^9}, {
  3.600407796092272*^9, 
  3.6004078356455336`*^9}},ExpressionUUID->"571058fe-b7a4-4974-ad89-\
77c67b34752a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b"}], "]"}], ";", 
  RowBox[{
   RowBox[{"vector", "[", 
    RowBox[{"plus", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}]}], "]"}], "]"}], "\[Equal]", " ", 
   RowBox[{
    RowBox[{"vector", "[", "a", "]"}], " ", "-", 
    RowBox[{"vector", "[", "b", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.6013053669785833`*^9, 3.6013053856856537`*^9}, {
  3.6018164519559035`*^9, 3.6018165017167497`*^9}, {3.6424853915555086`*^9, 
  3.6424853977643194`*^9}},ExpressionUUID->"24e6c883-889b-4064-9865-\
06d6ae7ccd2c"],

Cell["Also vector fields or vector functions) may be defined:", "Text",
 CellChangeTimes->{{3.601305435524504*^9, 3.6013054675963383`*^9}, 
   3.6018165649693675`*^9},ExpressionUUID->"08db3611-04f3-47c9-a6fa-\
d95740185d29"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vf", "[", 
   RowBox[{"u_", ",", "v_"}], "]"}], " ", ":=", 
  RowBox[{"vector", "[", 
   RowBox[{"f", "[", 
    RowBox[{"u", ",", "v"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.601305500518222*^9, 3.6013055361682606`*^9}, {
  3.601816588637721*^9, 
  3.601816597412223*^9}},ExpressionUUID->"ff2d5b2e-1e87-4c31-871c-\
3a402c4cac0a"],

Cell[BoxData[
 RowBox[{"vf", "[", 
  RowBox[{"u", ",", "v"}], "]"}]], "Input",
 CellChangeTimes->{{3.6013055431856623`*^9, 
  3.601305547709921*^9}},ExpressionUUID->"8d868dd2-11c9-4ce3-a21c-\
a7e636024ea3"],

Cell["Derivatives can be calculated:", "Text",
 CellChangeTimes->{{3.6013057556518145`*^9, 3.6013057735158362`*^9}, 
   3.6425051017031336`*^9, 3.64250522418635*^9, 
   3.642576508553198*^9},ExpressionUUID->"a84b01d1-ff15-49f6-af6a-\
7c1ead73c200"],

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"vf", "[", 
    RowBox[{"u", ",", "v"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"u", ",", "v"}], "}"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6013055930585146`*^9, 3.601305610718525*^9}, {
  3.601305702646783*^9, 
  3.6013057112462745`*^9}},ExpressionUUID->"ef378339-037e-43ca-9624-\
1e24ddb14745"],

Cell[BoxData[
 RowBox[{"Grad", "[", 
  RowBox[{
   RowBox[{"vf", "[", 
    RowBox[{"u", ",", "v"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "v"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6013055930585146`*^9, 3.601305610718525*^9}, {
  3.601305645884536*^9, 
  3.6013056548810506`*^9}},ExpressionUUID->"c399a236-b794-44b1-96f8-\
572875ceaee8"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "%%"}]], "Input",
 CellChangeTimes->{{3.6013057316524415`*^9, 
  3.601305734117583*^9}},ExpressionUUID->"c9029af1-f33e-46f7-9fbd-\
8ebab6016051"]
}, Closed]],

Cell[CellGroupData[{

Cell["Changing the Head of Arrows", "Subsubsection",
 CellChangeTimes->{{3.6013048822198567`*^9, 3.6013049001478825`*^9}, {
   3.601306139667779*^9, 3.6013061470201993`*^9}, 
   3.601562553250188*^9},ExpressionUUID->"1979fea6-03d1-4a44-9ad0-\
0ee5accc84e0"],

Cell["\<\
The built-in Array function offers the possibility to change the Head  We \
define a new vector function\
\>", "Text",
 CellChangeTimes->{{3.5608459962766404`*^9, 3.56084605571604*^9}, {
   3.5608699198830385`*^9, 3.560869961347911*^9}, 
   3.6013030370593195`*^9},ExpressionUUID->"a51662de-0667-4508-b536-\
d0e5e6f872ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "vvector", "]"}], ";", 
  RowBox[{
   RowBox[{"vvector", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], ":=", " ", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", " ", "d", ",", 
     RowBox[{"{", "1", "}"}], ",", "vector"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5608429327361574`*^9, 3.560842980097841*^9}, {
   3.560843028192725*^9, 3.5608430925740385`*^9}, {3.560843132666109*^9, 
   3.560843334078062*^9}, {3.5608434337934375`*^9, 3.5608434528878713`*^9}, {
   3.560843616532159*^9, 3.560843626516176*^9}, 3.560844609257902*^9, 
   3.5707165534601164`*^9, 3.570716598243678*^9, {3.6013020384272013`*^9, 
   3.601302057391286*^9}, {3.601302092446291*^9, 3.601302094269395*^9}, {
   3.6013023672630095`*^9, 3.6013023732703533`*^9}, 
   3.6013024165678296`*^9},ExpressionUUID->"1ad9523f-9b43-4711-9c08-\
bac00d88e538"],

Cell[BoxData[
 RowBox[{"vvector", "[", "a", "]"}]], "Input",
 CellChangeTimes->{{3.560843347384886*^9, 
  3.560843353047696*^9}},ExpressionUUID->"3db96b5d-01be-41a2-bfb1-\
91341b660aaa"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"vvector", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6013027295057287`*^9, 3.601302752574048*^9}, 
   3.601303277926097*^9},ExpressionUUID->"820a5992-220f-4713-8b3c-\
fdee0039d2cf"],

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"vvector", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.601303293054962*^9},ExpressionUUID->"0101e4d9-e3c0-484d-9dac-\
9e7e9315deac"],

Cell["\<\
Unfortunately, with this change of the Head, many functions or operations \
valid for Arrays are not valid for vvectors anymore:\
\>", "Text",
 CellChangeTimes->{{3.6013030602366457`*^9, 
  3.601303198315543*^9}},ExpressionUUID->"8c733b9c-f2fb-4e2d-8c97-\
1492d555b3e6"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", 
  RowBox[{"vvector", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5707164548514767`*^9, 
  3.5707164686492653`*^9}},ExpressionUUID->"7211830b-5581-4772-aeac-\
cafde1866314"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", 
  RowBox[{"vvector", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5707164548514767`*^9, 3.5707164686492653`*^9}, {
  3.6013033587477193`*^9, 
  3.601303367352212*^9}},ExpressionUUID->"762bb9d1-5e1c-4000-b400-\
632d73c14e37"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"a", ",", "dim", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5707164548514767`*^9, 3.5707164686492653`*^9}, {
  3.6013033587477193`*^9, 
  3.601303403535281*^9}},ExpressionUUID->"f442bab7-b104-4170-bf1b-\
2678bd695782"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", 
  RowBox[{"vvector", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570716394547027*^9, 
  3.57071642606583*^9}},ExpressionUUID->"dc4cf3e5-72d2-496c-a741-\
55d27c15642b"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"a", ",", "dim", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570716394547027*^9, 3.57071642606583*^9}, 
   3.6004113998203926`*^9, {3.600411435855454*^9, 
   3.600411464666102*^9}},ExpressionUUID->"98c30450-6ada-4f37-86b4-\
e62eed696592"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], ";", 
  RowBox[{
   RowBox[{"c", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"a", "[", "i", "]"}], "+", 
    RowBox[{"b", "[", "i", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5608435708396783`*^9, 3.5608435818376975`*^9}, {
  3.560843660181035*^9, 3.560843719195939*^9}, {3.600411510358715*^9, 
  3.600411519110216*^9}},ExpressionUUID->"aab529af-30fb-42d8-b733-\
b1a6ec586aba"],

Cell[BoxData[
 RowBox[{"vvector", "[", "c", "]"}]], "Input",
 CellChangeTimes->{{3.560843727105153*^9, 
  3.5608437330487633`*^9}},ExpressionUUID->"b507faa6-acd3-4764-adfa-\
da226b047802"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"vvector", "[", "c", "]"}], "\[Equal]", " ", 
   RowBox[{
    RowBox[{"vvector", "[", "a", "]"}], " ", "+", 
    RowBox[{"vvector", "[", "b", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6013018814772243`*^9, 
  3.601301934016229*^9}},ExpressionUUID->"c8cbbde1-60b4-47af-bbf8-\
c11b2110b8e4"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"vvector", "[", 
    RowBox[{"plus", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "]"}], "\[Equal]", " ", 
   RowBox[{
    RowBox[{"vvector", "[", "a", "]"}], " ", "+", 
    RowBox[{"vvector", "[", "b", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6013018814772243`*^9, 3.601301934016229*^9}, {
   3.601301968412197*^9, 3.6013019831510396`*^9}, 
   3.6013025175756073`*^9},ExpressionUUID->"54d67a59-f493-449d-9ddc-\
1417bb61b2b4"],

Cell[BoxData[
 RowBox[{"?", "Cross"}]], "Input",
 CellChangeTimes->{{3.560844286163335*^9, 
  3.5608442900321417`*^9}},ExpressionUUID->"37d4008d-b2f0-43af-98af-\
91885ecc45ae"],

Cell[BoxData[
 RowBox[{"Cross", "[", 
  RowBox[{
   RowBox[{"vvector", "[", "a", "]"}], ",", 
   RowBox[{"vvector", "[", "b", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5608443011705613`*^9, 
  3.5608443238530006`*^9}},ExpressionUUID->"7a0148af-1b7c-47a1-ae47-\
8868602b2c1c"],

Cell["With this definition Cross does not work, in difference to", "Text",
 CellChangeTimes->{{3.560870055322476*^9, 
  3.5608700827473245`*^9}},ExpressionUUID->"22de1a70-3bca-42ea-aa58-\
0e14374f2800"],

Cell[BoxData[
 RowBox[{"Cross", "[", 
  RowBox[{
   RowBox[{"vec", "[", "a", "]"}], ",", 
   RowBox[{"vec", "[", "b", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5608443011705613`*^9, 3.5608443238530006`*^9}, {
  3.5608443814351025`*^9, 3.5608443908887186`*^9}, {3.6013036067349033`*^9, 
  3.6013036129182568`*^9}},ExpressionUUID->"13912130-e62a-4fb9-8d20-\
48f1d56d229c"],

Cell["he same takes place with the determinant function:", "Text",
 CellChangeTimes->{{3.5608701567066545`*^9, 
  3.5608701798598948`*^9}},ExpressionUUID->"9c014235-8606-44bb-9605-\
b205b153e684"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], ";", 
  RowBox[{"Det", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vvector", "[", "a", "]"}], ",", 
     RowBox[{"vvector", "[", "b", "]"}], ",", 
     RowBox[{"vvector", "[", "c", "]"}]}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5608444207003713`*^9, 3.5608444629608455`*^9}, {
  3.6004116594632435`*^9, 3.6004116661036234`*^9}, {3.6004117034867616`*^9, 
  3.600411706549937*^9}},ExpressionUUID->"b8821200-ff7a-47d3-9952-\
774002de88f9"],

Cell[BoxData[
 RowBox[{"Det", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vec", "[", "a", "]"}], ",", 
    RowBox[{"vec", "[", "b", "]"}], ",", 
    RowBox[{"vec", "[", "c", "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5608444207003713`*^9, 3.560844508138525*^9}, {
  3.601303638983748*^9, 
  3.6013036527345343`*^9}},ExpressionUUID->"58e3b75a-5d6d-441e-8060-\
696b7c281b01"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vvector", "[", "a", "]"}], ",", 
    RowBox[{"vvector", "[", "b", "]"}], ",", 
    RowBox[{"vvector", "[", "c", "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.560870216129959*^9, 3.5608702330559883`*^9}, {
  3.5608702868224826`*^9, 
  3.560870301377308*^9}},ExpressionUUID->"a686d98b-1255-494a-b7a9-\
97d132c8649c"],

Cell[BoxData[
 RowBox[{"MatrixQ", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vvector", "[", "a", "]"}], ",", 
    RowBox[{"vvector", "[", "b", "]"}], ",", 
    RowBox[{"vvector", "[", "c", "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.560870242565605*^9, 3.5608702757464633`*^9}, {
  3.56087030811652*^9, 
  3.5608703137013297`*^9}},ExpressionUUID->"dcea3c7b-f219-41b2-9ec6-\
9a57998cb069"],

Cell["\<\
To avoid such errors problems we try to use instead of vec the elements of \
\>", "Text",
 CellChangeTimes->{{3.56066204080999*^9, 3.560662071776045*^9}, {
  3.56066217753351*^9, 3.560662202316928*^9}, {3.6004082627559633`*^9, 
  3.600408265115098*^9}, {3.60130082399574*^9, 3.6013008338993063`*^9}, {
  3.6015624515463705`*^9, 3.601562455329587*^9}, {3.6015624966979527`*^9, 
  3.6015625324019947`*^9}},ExpressionUUID->"1ac514c9-d684-416f-afb1-\
94a7aae6970c"]
}, Closed]],

Cell[CellGroupData[{

Cell["The domain Vectors", "Subsubsection",
 CellChangeTimes->{{3.6013049335877953`*^9, 
  3.6013049441323977`*^9}},ExpressionUUID->"0b03cde2-e3fd-4de1-875c-\
56d1afbcf673"],

Cell[BoxData[
 RowBox[{"?", "Vectors"}]], "Input",
 CellChangeTimes->{{3.56065666062334*^9, 3.5606566922133956`*^9}, {
  3.5606574020146427`*^9, 3.560657465569154*^9}, {3.5606579504024057`*^9, 
  3.560658181657212*^9}, {3.5606583590163236`*^9, 3.5606583663795366`*^9}, {
  3.560658430542449*^9, 3.5606585479638553`*^9}, {3.560658616884776*^9, 
  3.5606586346376076`*^9}, {3.5606622132375526`*^9, 3.560662234418764*^9}, {
  3.601300751725606*^9, 
  3.601300773245837*^9}},ExpressionUUID->"a54ddfe9-fac4-47ba-ab83-\
86ace637b8bd"],

Cell[TextData[{
 "is built-in ",
 StyleBox["Mathematica. ",
  FontSlant->"Italic"],
 "but the following  statement is not confirmed:"
}], "Text",
 CellChangeTimes->{{3.560662288995886*^9, 3.5606623315503197`*^9}, 
   3.5707770982008605`*^9, {3.6013008541154623`*^9, 3.6013008815800333`*^9}, {
   3.6015628697222886`*^9, 3.60156291992216*^9}, {3.601563055433911*^9, 
   3.601563066482543*^9}, 3.6015631345634365`*^9, 3.6015631757937946`*^9, {
   3.632461108365733*^9, 3.632461110783737*^9}, {3.642576559608488*^9, 
   3.642576562244892*^9}},ExpressionUUID->"28dfc634-ea45-43c8-a22c-\
d08523101604"],

Cell[BoxData["dim"], "Input",
 CellChangeTimes->{{3.632460838235658*^9, 
  3.6324608397020607`*^9}},ExpressionUUID->"7316ffd4-7a80-40c3-9dd6-\
10f2a5fc2747"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "\[Element]", " ", 
  RowBox[{"Vectors", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.6013011584008665`*^9, 
  3.6013011907177153`*^9}},ExpressionUUID->"76487026-d7ac-491b-9226-\
dfb7771b28bb"],

Cell["\<\
With an appropriate assumption the property will be confirmed:\
\>", "Text",
 CellChangeTimes->{{3.6324611581766205`*^9, 
  3.6324612243675365`*^9}},ExpressionUUID->"91b0fd14-be0d-4100-ada8-\
36d1c7c871f0"],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{"Element", "[", 
    RowBox[{
     RowBox[{"x", "[", "i_", "]"}], ",", "Reals"}], "]"}], ",", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], " ", "\[Element]", " ", 
     RowBox[{"Vectors", "[", "3", "]"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6015629938783903`*^9, 3.601563010637348*^9}, {
  3.6324608611364985`*^9, 3.63246096443988*^9}, {3.6324612352563553`*^9, 
  3.632461274786825*^9}},ExpressionUUID->"b58bca73-b254-4786-b368-\
360b4c59f98b"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"vvector", "[", "x", "]"}], " ", "\[Element]", " ", 
   RowBox[{"Vectors", "[", "3", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6015629938783903`*^9, 3.601563010637348*^9}, {
  3.601563220450349*^9, 
  3.601563255820372*^9}},ExpressionUUID->"64937c49-4154-48be-9322-\
be016aaf8225"],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Element]", " ", 
      RowBox[{"Vectors", "[", 
       RowBox[{"3", ",", "Reals"}], "]"}]}], ",", " ", 
     RowBox[{"y", "\[Element]", " ", 
      RowBox[{"Vectors", "[", 
       RowBox[{"3", ",", "Reals"}], "]"}]}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"x", "+", "y"}], "\[Element]", " ", 
    RowBox[{"Vectors", "[", 
     RowBox[{"3", ",", "Reals"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6013012415186205`*^9, 3.601301310822585*^9}, {
  3.6324613198553042`*^9, 
  3.632461365110984*^9}},ExpressionUUID->"4a72d5a3-c702-44fd-86e0-\
99ea67122c58"],

Cell["\<\
The triples must have complex numbers as members to be confirmed as vectors:\
\>", "Text",
 CellChangeTimes->{{3.6015634814342766`*^9, 3.60156352450574*^9}, 
   3.6425765756669164`*^9},ExpressionUUID->"283f194d-5fe5-4a0c-a272-\
e4d5f8c2285b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"null", "[", "]"}], "\[Element]", " ", 
  RowBox[{"Vectors", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.601563372346037*^9, 
  3.601563389060993*^9}},ExpressionUUID->"1fca5a26-945f-4ddc-8fd3-\
36e426f6b7f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"1.", ",", 
    RowBox[{"1", "+", "I"}], ",", 
    RowBox[{"1", "-", "I"}]}], "}"}], "\[Element]", " ", 
  RowBox[{"Vectors", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.601563372346037*^9, 
  3.6015634499084735`*^9}},ExpressionUUID->"543727b4-6d2b-42e1-9e58-\
00a0f2f85371"],

Cell["\<\
Working with symbolic objects like vector functions etc. one has to set the \
corresponding assumptions:\
\>", "Text",
 CellChangeTimes->{{3.560870388487861*^9, 3.5608704990296555`*^9}, {
   3.601563614066863*^9, 3.6015636818907423`*^9}, 3.6324615220940595`*^9, {
   3.6324619311735783`*^9, 
   3.632461995445691*^9}},ExpressionUUID->"aeda34c0-ac62-4f23-bfc7-\
306f331a54cf"],

Cell[BoxData[
 RowBox[{"vec", "[", 
  RowBox[{"f", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6324615781605577`*^9, 
  3.6324615911553807`*^9}},ExpressionUUID->"a01bd17f-d1bb-4587-ae26-\
54082bbb3f70"],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], "[", "i_", "]"}], " ", "\[Element]", " ", 
    "Reals"}], ",", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"vec", "[", 
      RowBox[{"f", "[", "x", "]"}], "]"}], " ", "\[Element]", " ", 
     RowBox[{"Vectors", "[", "3", "]"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6015629938783903`*^9, 3.601563010637348*^9}, {
   3.6324608611364985`*^9, 3.63246096443988*^9}, {3.6324612352563553`*^9, 
   3.632461274786825*^9}, {3.632461606661808*^9, 3.6324616320586524`*^9}, 
   3.6324617252220163`*^9, {3.6324620590782022`*^9, 
   3.6324620754426312`*^9}},ExpressionUUID->"4539909e-51d1-4b7f-a93a-\
5ea3a52bf218"],

Cell[TextData[{
 "Many functions for vectors in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " work only if the Head of the vectors is List; therefore we will not change \
this Head and"
}], "Text",
 CellChangeTimes->{{3.560870388487861*^9, 3.5608704990296555`*^9}, {
  3.601563614066863*^9, 3.6015636818907423`*^9}, {3.6324615220940595`*^9, 
  3.6324615367268853`*^9}},ExpressionUUID->"b1bc528e-485f-4fc7-84d0-\
1a006d6a3966"],

Cell[BoxData[
 RowBox[{"Remove", "[", "vvector", "]"}]], "Input",
 CellChangeTimes->{{3.5608705060964675`*^9, 
  3.560870515628084*^9}},ExpressionUUID->"b8547af3-1b6d-40dc-89a6-\
6510afe2d960"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[" 2.2. Covectors and Linear  Forms. The Dual Basis", "Subsection",
 CellChangeTimes->{{3.5545353455968313`*^9, 3.5545353783659077`*^9}, {
   3.559030522904004*^9, 3.559030548790485*^9}, 3.55961264620638*^9, {
   3.560603920326224*^9, 3.560603936973176*^9}, 3.5606741634778657`*^9, {
   3.560783520430111*^9, 3.560783527621723*^9}, 3.5608705436301336`*^9, 
   3.560928011052817*^9, {3.600502103591748*^9, 3.600502105900552*^9}, 
   3.6015625620526905`*^9, 
   3.602409958947406*^9},ExpressionUUID->"0e0cef3c-83a8-4924-9d86-\
c34aadb71afe"],

Cell[CellGroupData[{

Cell["2.2.1. Linear Maps. Linear Forms. Covectors", "Subsubsection",
 CellChangeTimes->{{3.6013049335877953`*^9, 3.6013049441323977`*^9}, {
  3.602058494154922*^9, 3.6020584981953287`*^9}, {3.6020586897324657`*^9, 
  3.6020586988116817`*^9}, {3.6023143484464073`*^9, 
  3.6023143785700607`*^9}},ExpressionUUID->"3898e447-7cdc-4b50-92c0-\
e4bf3624ee09"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.560609002091884*^9, 
  3.560609015791668*^9}},ExpressionUUID->"758eb07a-5783-4ecc-a35d-\
b5a5bf2d2b05"],

Cell[TextData[{
 " The reason for introducing the covectors is that they are the abstract \
concept of the linear forms on the vector space.  A function w: V \
\[RightTeeArrow] K on the vector space V with values in the field K (or, more \
general, a map into a vector space W over K) is said to be ",
 StyleBox["linear",
  FontColor->RGBColor[0, 0, 1]],
 " if it has the properties"
}], "Text",
 CellChangeTimes->{{3.5606851339465237`*^9, 3.5606854441732683`*^9}, {
   3.5606854772651606`*^9, 3.5606856192192802`*^9}, 3.560688023212781*^9, 
   3.560766158560783*^9, {3.560766414994033*^9, 3.5607664458664875`*^9}, 
   3.5609216969781284`*^9, {3.5732732393064146`*^9, 3.5732732410692177`*^9}, {
   3.6005008642007713`*^9, 3.6005008717355843`*^9}, 3.6018224562001743`*^9, 
   3.6020689191869516`*^9, 3.602138037339972*^9, {3.602314421142535*^9, 
   3.602314432764556*^9}},ExpressionUUID->"f53b3e91-4c1e-46d5-a39d-\
7a575d579ce6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"w", "[", 
    RowBox[{"x", "+", "y"}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"w", "[", "x", "]"}], "+", 
    RowBox[{"w", "[", "y", "]"}]}]}], ",", 
  RowBox[{
   RowBox[{"w", "[", 
    RowBox[{"x", "*", "\[Alpha]"}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"w", "[", "x", "]"}], "*", "\[Alpha]"}]}], ",", 
  "\[IndentingNewLine]", " ", "x", ",", 
  RowBox[{"y", " ", "\[Element]", " ", "V"}], ",", 
  RowBox[{"\[Alpha]", " ", "\[Element]", " ", 
   RowBox[{"K", ".", " "}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.560685635003183*^9, 3.56068585401571*^9}, 
   3.560688053311502*^9, {3.601822648185155*^9, 
   3.601822818606902*^9}},ExpressionUUID->"74b512bd-ef63-4877-84a1-\
b09e2b6f5fd1"],

Cell[TextData[{
 StyleBox["Linear functions with values in the field K of the vector space \
are named",
  FontColor->GrayLevel[0]],
 StyleBox[" linear forms",
  FontColor->RGBColor[0, 0, 1]],
 ".  One easily proves\n",
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 ". The set L[V, W] of all linear maps of the vector space V into the vector \
space W over the same field K is itself a vector space over K with respect to \
the argument-wise addition of functions and multiplication with scalars \
\[Alpha]\[Element]K. \nIf dim[V] = n and dim[W] = m, then dim[L[V, W]] = n*m.\
\n",
 StyleBox["Proof",
  FontColor->RGBColor[0, 0, 1]],
 ". In the package tensalgv3.m is introduced"
}], "Text",
 CellChangeTimes->{{3.560685967403195*^9, 3.5606860409314003`*^9}, {
   3.56068627572383*^9, 3.5606862949149275`*^9}, {3.5606866570366397`*^9, 
   3.560686715075959*^9}, 3.5606882689638367`*^9, {3.5606882995175843`*^9, 
   3.560688316486555*^9}, {3.5732045846665525`*^9, 3.5732046252422237`*^9}, {
   3.5732047705564795`*^9, 3.573204795407323*^9}, {3.5732048760594645`*^9, 
   3.5732048826426764`*^9}, 3.6020692366319094`*^9, 3.6020693643649335`*^9, {
   3.602069431070651*^9, 3.6020694400874667`*^9}, {3.602069488239348*^9, 
   3.6020698074636064`*^9}, {3.6020698385673857`*^9, 3.6020698746074467`*^9}, 
   3.6020699181759386`*^9, {3.60207001749562*^9, 3.6020700628082113`*^9}, {
   3.6020701667841587`*^9, 3.6020702507839627`*^9}, {3.602071366543781*^9, 
   3.6020714439522085`*^9}, 3.602138082112051*^9, 3.6021381132497053`*^9, 
   3.602314494852665*^9, 3.642501433550418*^9, 3.642505687109568*^9, {
   3.642505852564062*^9, 3.6425059410166187`*^9}, 3.6425059980115185`*^9, 
   3.706253630496827*^9},ExpressionUUID->"f782c9f8-fb72-4f73-834a-\
42da424b2095"],

Cell[BoxData[
 RowBox[{"?", "linform"}]], "Input",
 CellChangeTimes->{{3.5732048025521355`*^9, 
  3.5732048062337418`*^9}},ExpressionUUID->"af9d8efc-67c4-4724-bc46-\
091b000c8a32"],

Cell[BoxData[
 RowBox[{"?", "lf"}]], "Input",
 CellChangeTimes->{{3.6020704901566544`*^9, 
  3.6020704917447453`*^9}},ExpressionUUID->"94f3782b-603b-4ecc-bbc5-\
f6961aceae41"],

Cell["where the covectors are defined as", "Text",
 CellChangeTimes->{{3.6020702800696383`*^9, 
  3.602070327783367*^9}},ExpressionUUID->"17f654f9-a0d0-4299-ad2e-\
44da048a3790"],

Cell[BoxData[
 RowBox[{"?", "covector"}]], "Input",
 CellChangeTimes->{{3.602070336460863*^9, 
  3.602070341009124*^9}},ExpressionUUID->"ca7e767f-6fdf-4304-adac-\
4b33942ddc9f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"linform", "[", "a", "]"}], "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5732048233313723`*^9, 
  3.5732048361545944`*^9}},ExpressionUUID->"ca908c72-9ff7-4906-9976-\
af821194a83d"],

Cell["The relation between linear forms and covectors is", "Text",
 CellChangeTimes->{{3.642566388847432*^9, 
  3.6425664119354725`*^9}},ExpressionUUID->"b89f10ef-3859-4d6f-8398-\
70231d8f3901"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"linform", "[", "a", "]"}], "[", 
   RowBox[{"vec", "[", "x", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{
   RowBox[{"covec", "[", "a", "]"}], ".", 
   RowBox[{"vec", "[", "x", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5732048233313723`*^9, 3.5732048361545944`*^9}, {
  3.6425663111748953`*^9, 
  3.642566338802544*^9}},ExpressionUUID->"c8e19b31-f07d-4615-a437-\
0b8467f25d90"],

Cell[TextData[{
 StyleBox["covec[a] is the tuple of the coordinates of lf[a] with respect to \
the standard basis",
  FontColor->RGBColor[0, 0, 1]],
 ". \nThe algebraic operations of linear forms correspond to the vector \
operations of the covectors."
}], "Text",
 CellChangeTimes->{{3.642566449313138*^9, 
  3.6425666715199285`*^9}},ExpressionUUID->"cc1345f7-d588-4c77-8376-\
d2dddd2e67fe"],

Cell["Consider two linear forms lf[a], lf[b] and its sum", "Text",
 CellChangeTimes->{{3.6020704652322288`*^9, 3.6020705603276677`*^9}, 
   3.6425766694583817`*^9},ExpressionUUID->"28e5e9bd-2ff9-492d-96ff-\
f929b1b97a7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b", ",", "x"}], "]"}], ";", 
  RowBox[{"sab", " ", ":=", " ", 
   RowBox[{"plus", "[", 
    RowBox[{
     RowBox[{"lf", "[", "a", "]"}], ",", 
     RowBox[{"lf", "[", "b", "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6020705873202114`*^9, 3.6020706254093904`*^9}, {
  3.6020706656026893`*^9, 
  3.6020706826346636`*^9}},ExpressionUUID->"30b16764-60aa-44a9-afa4-\
be82f86f6168"],

Cell[BoxData[
 RowBox[{"sab", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6020706301346607`*^9, 
  3.602070643217409*^9}},ExpressionUUID->"fcfb6ae9-4833-420e-acd0-\
a6e93738ed6d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"sab", "[", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "+", " ", 
     RowBox[{"vec", "[", "y", "]"}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"sab", "[", 
     RowBox[{"vec", "[", "x", "]"}], "]"}], " ", "+", " ", 
    RowBox[{"sab", "[", 
     RowBox[{"vec", "[", "y", "]"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.602070714654495*^9, 
  3.6020708232597065`*^9}},ExpressionUUID->"d40251ad-1b88-4298-bd4d-\
9dc68aeb2734"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"sab", "[", 
    RowBox[{"\[Alpha]", "*", 
     RowBox[{"vec", "[", "x", "]"}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{"\[Alpha]", "*", 
    RowBox[{"sab", "[", 
     RowBox[{"vec", "[", "x", "]"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.602070714654495*^9, 
  3.602070929818802*^9}},ExpressionUUID->"e307592f-fca7-410d-b244-\
7c56cb507fde"],

Cell["\<\
Thus sab is linear too. Analogously for the product with a scalar:\
\>", "Text",
 CellChangeTimes->{{3.602070992784403*^9, 3.6020710367279167`*^9}, 
   3.602071079463361*^9, 
   3.6021382802479987`*^9},ExpressionUUID->"eed41599-98ec-49fc-a40f-\
434cc07124d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", " ", "=", " ", 
   RowBox[{"lf", "[", 
    RowBox[{"times", "[", 
     RowBox[{"u", ",", "a"}], "]"}], "]"}]}], ";", 
  RowBox[{"g", "[", 
   RowBox[{"vec", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6020710891659155`*^9, 3.6020712350122576`*^9}, {
  3.60213889590308*^9, 
  3.602138923920729*^9}},ExpressionUUID->"26882764-ce50-486e-a8f5-\
250d53d9c81b"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], "+", " ", 
     RowBox[{"vec", "[", "y", "]"}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"g", "[", 
     RowBox[{"vec", "[", "x", "]"}], "]"}], " ", "+", " ", 
    RowBox[{"g", "[", 
     RowBox[{"vec", "[", "y", "]"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6020710891659155`*^9, 3.6020712350122576`*^9}, 
   3.60213889590308*^9},ExpressionUUID->"4369d04b-71c8-4ca5-9a2a-\
2b8000d46dfb"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{"\[Alpha]", "*", 
     RowBox[{"vec", "[", "x", "]"}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{"\[Alpha]", "*", 
    RowBox[{"g", "[", 
     RowBox[{"vec", "[", "x", "]"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.602070714654495*^9, 3.602070929818802*^9}, {
  3.6020712943716526`*^9, 
  3.602071306635354*^9}},ExpressionUUID->"10513978-f2f2-4b40-bc6c-\
ad4fbe96c014"],

Cell["\<\
Thus on L[v,w] the structure of a vector space over the field K is well \
defined. We show\
\>", "Text",
 CellChangeTimes->{{3.602071679415676*^9, 3.6020717500397153`*^9}, {
   3.60231454900036*^9, 3.6023145548659706`*^9}, 
   3.632460289130294*^9},ExpressionUUID->"11fba2d3-ed31-470a-b33d-\
af50765defb7"],

Cell[TextData[{
 StyleBox["Lemma",
  FontColor->RGBColor[0, 0, 1]],
 ". A linear map on  w a finite dimensional vector space V is uniquely \
defined by its values on  a basis of V. \n",
 StyleBox["Proof.",
  FontColor->RGBColor[0, 0, 1]],
 "  The linearity implies"
}], "Text",
 CellChangeTimes->{{3.560685967403195*^9, 3.5606860409314003`*^9}, {
   3.56068627572383*^9, 3.5606862949149275`*^9}, {3.5606866570366397`*^9, 
   3.560686715075959*^9}, 3.5606882689638367`*^9, {3.5606882995175843`*^9, 
   3.560688316486555*^9}, 3.5732045846665525`*^9, {3.602071757856162*^9, 
   3.602071866327367*^9}, {3.602071907951748*^9, 3.6020719463039412`*^9}, 
   3.602072033687939*^9, {3.6021383195912676`*^9, 3.6021383426793084`*^9}, {
   3.6425061852146497`*^9, 
   3.6425061892082567`*^9}},ExpressionUUID->"3e938314-f77c-4231-85a9-\
30ec17e77944"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", 
   RowBox[{"\[Sum]", " ", 
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], "*", 
     RowBox[{"x", "[", "i", "]"}]}]}], "]"}], "  ", "\[Equal]", "  ", 
  RowBox[{"\[Sum]", 
   RowBox[{
    RowBox[{"w", "[", 
     RowBox[{"stb", "[", "i", "]"}], "]"}], "*", 
    RowBox[{
     RowBox[{"x", "[", "i", "]"}], ".", "                ", 
     RowBox[{"(", "1", ")"}]}], "\[FilledSquare]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5606860587074175`*^9, 3.5606860617815933`*^9}, {
   3.5606861040680113`*^9, 3.5606862630391045`*^9}, 3.5606863346552005`*^9, {
   3.6020721872267213`*^9, 3.602072194794154*^9}, 
   3.6023146077032633`*^9},ExpressionUUID->"ffbae288-8690-4e5f-ac13-\
f145b6d76920"],

Cell["\<\
We return to the case of the one-dimensional vector space W=K.\
\>", "Text",
 CellChangeTimes->{{3.6020722059037895`*^9, 
  3.6020722371355753`*^9}},ExpressionUUID->"5642c070-ed65-4b54-a158-\
61b58af74d9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "=", 
   RowBox[{"linform", "[", "a", "]"}]}], ";", 
  RowBox[{
   RowBox[{"w", "[", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"stb", "[", "i", "]"}], "*", 
       RowBox[{"x", "[", "i", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "]"}], " ", "\[Equal]",
    "  ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"w", "[", 
       RowBox[{"stb", "[", "i", "]"}], "]"}], "*", 
      RowBox[{"x", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5732048233313723`*^9, 3.5732048361545944`*^9}, {
  3.6018232543888273`*^9, 3.6018233574007196`*^9}, {3.601823391863691*^9, 
  3.6018234046164203`*^9}, {3.6018234862100873`*^9, 3.6018234949925895`*^9}, {
  3.6018235637215204`*^9, 
  3.6018235886809483`*^9}},ExpressionUUID->"b544f8ef-daa6-4274-b9bd-\
92959458013b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", 
   RowBox[{"vec", "[", "x", "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"w", "[", 
      RowBox[{"stb", "[", "i", "]"}], "]"}], "*", 
     RowBox[{"x", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5732736993980227`*^9, 3.573273713765648*^9}, {
   3.602072271074517*^9, 3.6020722949458823`*^9}, 
   3.6020724428593426`*^9},ExpressionUUID->"f057e9f7-4996-4b5a-aaee-\
90e733f6f831"],

Cell["\<\
Remember, x[i] are the coordinates of vec[x]; the formula shows again that \
w[vex[x] is uniquely defined by the values w[stb[i]].   \
\>", "Text",
 CellChangeTimes->{{3.602072485879803*^9, 3.602072511735282*^9}, 
   3.6020725959280977`*^9, {3.6021384833291554`*^9, 3.6021385453860645`*^9}, {
   3.6021385817341285`*^9, 3.6021386029969654`*^9}, {3.602314690165008*^9, 
   3.60231469160021*^9}},ExpressionUUID->"57f5c0af-b65b-49ea-bd0d-\
d017a1295222"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "b", "]"}], ";", 
  RowBox[{
   RowBox[{"wa", "[", "i_", "]"}], " ", ":=", " ", 
   RowBox[{"w", "[", 
    RowBox[{"stb", "[", "i", "]"}], "]"}]}], ";", 
  RowBox[{"covector", "[", "wa", "]"}]}]], "Input",
 CellChangeTimes->{{3.602138706393947*^9, 
  3.6021387162687645`*^9}},ExpressionUUID->"27db1041-75f4-42c3-9f13-\
5c7cc485760b"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", 
  RowBox[{"covec", "[", "a", "]"}]}]], "Input",
 CellChangeTimes->{{3.602138739310005*^9, 
  3.602138758700839*^9}},ExpressionUUID->"6f51aa7c-16c7-4e23-b33b-\
7fceaf3e5e3d"],

Cell["\<\
The formulas obtained above for sab[vec[x]] and g[vec[x]] show that the map 
lf[a] -> covec[a] is linear; its kernel is the null-form lf[0&]:\
\>", "Text",
 CellChangeTimes->{{3.6021390039332695`*^9, 3.602139161009946*^9}, {
   3.6021391940820036`*^9, 3.6021392076852274`*^9}, {3.6021393717039156`*^9, 
   3.6021393846207385`*^9}, 3.642566805274564*^9, 
   3.6425767057832456`*^9},ExpressionUUID->"ce2accaa-4ad1-4381-9d69-\
5262f1d4dc0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"lf", "[", 
   RowBox[{"0", "&"}], "]"}], "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.60213929989699*^9, 
  3.6021393346226506`*^9}},ExpressionUUID->"6fbed608-763f-4393-8718-\
b901d0630044"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"lf", "[", "a", "]"}], "[", 
       RowBox[{"stb", "[", "i", "]"}], "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], ",", 
   RowBox[{"vec", "[", "a", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6425063631911635`*^9, 3.642506425146873*^9}, {
  3.6425064617349377`*^9, 3.642506495746998*^9}, {3.642506639959052*^9, 
  3.642506654237077*^9}},ExpressionUUID->"5a50c16b-d1b1-41ac-9c39-\
043829263baa"],

Cell["\<\
Thus the set L[V,K] becomes a dim-dimensional vector space as stated in the \
proposition; remember that K can be considered as a 1-dimensional vector \
space over K. If w in formula (1) maps V into a d-dimensional vector space W, \
then w[stb[i]] is a d-dimensional vector; for simplicity take dim[W] = dim \
too, Thus\
\>", "Text",
 CellChangeTimes->{{3.6021395110589604`*^9, 3.6021396584480195`*^9}, {
   3.6021412187315598`*^9, 3.6021412259075727`*^9}, {3.6021413239381447`*^9, 
   3.602141346261784*^9}, {3.602141380394644*^9, 3.602141583678601*^9}, 
   3.602314754624321*^9},ExpressionUUID->"b69ba50e-c997-4b64-9f9a-\
ee8e7b595a2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"w", ",", "a"}], "]"}], ";", 
  RowBox[{"wa", " ", "=", 
   RowBox[{"matrix", "[", "a", "]"}]}], ";", " ", 
  RowBox[{
   RowBox[{"w", "[", "v_List", "]"}], " ", ":=", " ", 
   RowBox[{"wa", ".", "v"}]}], ";", 
  RowBox[{"w", "[", 
   RowBox[{"vec", "[", "x", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6021415893414106`*^9, 3.6021416742523603`*^9}, {
  3.6021417102884235`*^9, 3.6021418453222604`*^9}, {3.6021421721584344`*^9, 
  3.602142197352479*^9}},ExpressionUUID->"23e181b1-30a7-4c20-bb56-\
d45bea5eea4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"matrix", "[", "a", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6023147924231873`*^9, 
  3.6023148168840303`*^9}},ExpressionUUID->"6e8aa4bc-b8b3-43da-893c-\
0d047bd68925"],

Cell["Formula (1) is confirmed again: ", "Text",
 CellChangeTimes->{{3.602143419942226*^9, 3.6021434686143117`*^9}, {
  3.602314845572481*^9, 3.602314848411686*^9}, {3.642487067931254*^9, 
  3.642487074498865*^9}},ExpressionUUID->"5947a383-d259-4f09-b48d-\
a3b39881b0c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", 
   RowBox[{"vec", "[", "x", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"w", "[", 
      RowBox[{"stb", "[", "i", "]"}], "]"}], "*", 
     RowBox[{"x", "[", "i", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.602142236680148*^9, 
  3.6021423342115192`*^9}},ExpressionUUID->"4c5aac84-d8ff-47d3-a0cb-\
932e968f3c76"],

Cell[BoxData[
 RowBox[{"w", "[", 
  RowBox[{"stb", "[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.602314994973943*^9, 
  3.602315018904385*^9}},ExpressionUUID->"82e08c95-ef21-4f5d-ac5c-\
45d64c283fc3"],

Cell["\<\
These formulas show that L[V,W] with the operations defined above is  a \
vector space over K isomorphic to the vector space of matrices  with m= \
dim{W] rows and n = dim[v] columns; thus its dimension is n*m (== 9 in our \
case).\[FilledSquare] \
\>", "Text",
 CellChangeTimes->{{3.602143501249569*^9, 3.6021435027627716`*^9}, {
  3.6021435395788364`*^9, 3.6021437161867466`*^9}, {3.6021437528624105`*^9, 
  3.6021438734506226`*^9}, {3.602314901373779*^9, 3.602314952838269*^9}, {
  3.642576740394107*^9, 
  3.6425767603525424`*^9}},ExpressionUUID->"f29df10c-580a-4207-ac9b-\
d73cf8d09cb3"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.2.2. Transformations of Bases and Coordinates", "Subsubsection",
 CellChangeTimes->{{3.6013049335877953`*^9, 3.6013049441323977`*^9}, {
  3.602058494154922*^9, 3.6020584981953287`*^9}, {3.6020586897324657`*^9, 
  3.6020586988116817`*^9}, {3.6021439518251605`*^9, 3.6021439560839677`*^9}, {
  3.602315116108156*^9, 
  3.6023151659970436`*^9}},ExpressionUUID->"8aa3e990-87a6-46f6-b128-\
123acbe695cb"],

Cell[TextData[{
 " The essential difference between vectors and covectors is",
 StyleBox[" the transformation behavior",
  FontColor->RGBColor[0, 0, 1]],
 " of their coordinates which we will consider now. Since these objects are \
modelled in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " by formally identical functions, we distinguish  vectors and covectors \
giving them distinct names."
}], "Text",
 CellChangeTimes->{{3.5606864773383617`*^9, 3.560686497445512*^9}, {
   3.560686559804078*^9, 3.5606865930359793`*^9}, {3.560686734012042*^9, 
   3.560686741539473*^9}, {3.5606867765474753`*^9, 3.56068681141947*^9}, {
   3.5606871016270685`*^9, 3.560687277451125*^9}, {3.5606879085722237`*^9, 
   3.5606879460203657`*^9}, 3.6011841557110405`*^9, 3.601822559047056*^9, {
   3.602315286554055*^9, 3.6023153236665206`*^9}, {3.602315507421813*^9, 
   3.602315637158233*^9}, {3.6023157071452365`*^9, 3.6023157880778656`*^9}, {
   3.60231582313387*^9, 3.6023159666780806`*^9}, 
   3.6023160104495845`*^9},ExpressionUUID->"d3bce376-2dad-4cfc-bbdc-\
99c0f9b8280c"],

Cell["\<\
As in section 2.1 we take a second basis in the vector space V choosing a \
random basis 
{b[i]}:\
\>", "Text",
 CellChangeTimes->{{3.5606864773383617`*^9, 3.560686497445512*^9}, {
   3.560686559804078*^9, 3.5606865930359793`*^9}, {3.560686734012042*^9, 
   3.560686741539473*^9}, {3.5606867765474753`*^9, 3.56068681141947*^9}, {
   3.5606871016270685`*^9, 3.560687277451125*^9}, {3.5606879085722237`*^9, 
   3.5606879460203657`*^9}, 3.6011841557110405`*^9, 3.601822559047056*^9, {
   3.602315286554055*^9, 3.6023153236665206`*^9}, {3.602315507421813*^9, 
   3.602315637158233*^9}, {3.6023157071452365`*^9, 3.6023157880778656`*^9}, {
   3.60231582313387*^9, 3.6023159666780806`*^9}, {3.6023160104495845`*^9, 
   3.602316136117772*^9}, {3.6023161933340445`*^9, 3.602316300461172*^9}, {
   3.6023167012220945`*^9, 
   3.602316733013913*^9}},ExpressionUUID->"8cdf8a4a-7c1f-48af-b8f4-\
9a6794b5efe5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.560695576066507*^9, 3.560695576493531*^9}, {
  3.5609225988781123`*^9, 
  3.560922614992941*^9}},ExpressionUUID->"f61bd461-882e-4678-a6d1-\
44a77034c150"],

Cell[BoxData[
 RowBox[{"bt", " ", "=", " ", 
  RowBox[{"randommatrix", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.602316302556292*^9, 3.6023163383043365`*^9}, 
   3.602316404640131*^9},ExpressionUUID->"026bd251-d3e0-414d-bb41-\
32ba164d4e1b"],

Cell["\<\
We define the new basis vectors b[i] as the vectors whose coordinates with \
respect to the standard basis are the rows of bt:\
\>", "Text",
 CellChangeTimes->{{3.6024897112930093`*^9, 3.60248984829245*^9}, {
  3.602490846569403*^9, 
  3.602490848067006*^9}},ExpressionUUID->"8a4be422-5d8a-4de8-974c-\
f2f19e381066"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vb", "[", "i_Integer", "]"}], " ", ":=", " ", 
  RowBox[{"bt", "[", 
   RowBox[{"[", "i", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6425722656291504`*^9, 
  3.6425723085604258`*^9}},ExpressionUUID->"d00fef60-810b-436b-a694-\
91e84034c2c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"vb", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  "bt"}]], "Input",
 CellChangeTimes->{{3.6023166455709114`*^9, 3.6023166655670547`*^9}, {
   3.602489580268379*^9, 3.602489586835991*^9}, {3.6024909452707767`*^9, 
   3.6024909521191883`*^9}, 3.602511900202306*^9, 
   3.6025705893682876`*^9},ExpressionUUID->"1ebd1ff9-6c58-4f81-a91e-\
4955f5eb3cba"],

Cell["With probability 1 the matrix bt has rank 3:", "Text",
 CellChangeTimes->{{3.602316919125558*^9, 3.6023169543335714`*^9}, {
  3.642572441379059*^9, 
  3.642572448742272*^9}},ExpressionUUID->"faa1da51-de61-469a-a56a-\
b5d457604b26"],

Cell[BoxData[
 RowBox[{"MatrixRank", "[", 
  RowBox[{"Transpose", "[", "bt", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.602317026202682*^9, 3.602317033877121*^9}, {
  3.6024896373956795`*^9, 
  3.602489647691697*^9}},ExpressionUUID->"96890f3a-4a65-4d59-b623-\
3ce7a595a5d6"],

Cell["\<\
Therefore the vectors {vb[i]} form a basis of the vector space V. We get the \
transformation matrix mb by\
\>", "Text",
 CellChangeTimes->{{3.6023171275654793`*^9, 3.6023171622694645`*^9}, {
   3.60231720345382*^9, 3.6023172214938517`*^9}, {3.6023177700462275`*^9, 
   3.602317798341846*^9}, 3.602571090675168*^9, 3.6425124247328916`*^9, 
   3.642512456434148*^9},ExpressionUUID->"a313dd74-0283-4374-9522-\
320836c687ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "b", "]"}], ";", 
  RowBox[{"matrix", "[", "b", "]"}]}]], "Input",
 CellChangeTimes->{{3.6023174078245096`*^9, 3.6023174132958226`*^9}, {
  3.602318246144459*^9, 3.6023182526958337`*^9}, {3.6025706251235504`*^9, 
  3.602570628368356*^9}},ExpressionUUID->"d5715e87-7da5-4b05-b2ce-\
1514159cc13b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"b", "[", 
      RowBox[{"i", ",", "j"}], "]"}], " ", "=", " ", 
     RowBox[{"bt", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], ";", 
  RowBox[{"mb", "=", 
   RowBox[{"matrix", "[", "b", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6023172317334375`*^9, 3.6023172380708003`*^9}, {
   3.6023172914228516`*^9, 3.602317327090892*^9}, {3.6023173767537327`*^9, 
   3.602317391904599*^9}, {3.6023174353770857`*^9, 3.602317449321883*^9}, {
   3.6023174956415324`*^9, 3.602317537353918*^9}, {3.602317620498674*^9, 
   3.6023176778739557`*^9}, {3.6023177315370245`*^9, 
   3.6023177332561235`*^9}, {3.6023180778988357`*^9, 3.602318083250142*^9}, {
   3.602490280007608*^9, 3.6024902825816126`*^9}, 3.602490644798649*^9, {
   3.602511923835657*^9, 3.6025119266518183`*^9}, {3.602570639147975*^9, 
   3.6025706466203885`*^9}, {3.6025707483637667`*^9, 
   3.602570749003368*^9}},ExpressionUUID->"92169d42-0db3-4099-87da-\
e2b1cb0b893b"],

Cell[BoxData[
 RowBox[{"mb", "\[Equal]", " ", "bt"}]], "Input",
 CellChangeTimes->{{3.602490659837075*^9, 3.6024906908655295`*^9}, {
  3.6025707607813888`*^9, 
  3.6025707619045906`*^9}},ExpressionUUID->"88340c34-b751-4fb5-96ea-\
79f925fc2433"],

Cell[TextData[{
 "Thus the basis vectors are transformed according to \n",
 StyleBox["Formula (1):",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.6024912613429317`*^9, 
  3.602491320966236*^9}},ExpressionUUID->"ce5886ae-e334-4100-85cb-\
f24657b830ac"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vb", "[", "i", "]"}], " ", "\[Equal]", " ", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{"i", ",", "j"}], "]"}], "*", 
       RowBox[{"stb", "[", "j", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6023175609282665`*^9, 3.6023175650315013`*^9}, {
   3.602317827975541*^9, 3.602317857664239*^9}, {3.602317893415284*^9, 
   3.60231792744023*^9}, 3.602317967264508*^9, {3.6023179993283415`*^9, 
   3.602318020889575*^9}, {3.6024911598647537`*^9, 3.602491183467595*^9}, {
   3.602511930843058*^9, 3.602511932259139*^9}, {3.6025711365548487`*^9, 
   3.6025711437932615`*^9}},ExpressionUUID->"3df66013-d63b-4c43-a73d-\
f132b7dbc934"],

Cell["or", "Text",
 CellChangeTimes->{{3.602408817555122*^9, 3.6024088294508023`*^9}, 
   3.6024088837149057`*^9, 3.6024911990364223`*^9, {3.602491315490627*^9, 
   3.602491356066298*^9}},ExpressionUUID->"9a5bfa7b-15ae-4288-ba2d-\
f540e6c6ba0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"vb", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", 
  RowBox[{"mb", ".", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.602339631329421*^9, 3.602339788132389*^9}, {
  3.602339821956324*^9, 3.602339828058673*^9}, {3.6024912067584357`*^9, 
  3.602491217070054*^9}, {3.602512015651909*^9, 3.602512022539303*^9}, {
  3.6025711572092853`*^9, 
  3.6025711705473084`*^9}},ExpressionUUID->"f0583e86-fcf0-4e52-96b7-\
ccab6c9b367f"],

Cell["Now, any vector vx \[Element] V has two basis presentations: ", "Text",
 CellChangeTimes->{{3.602331091645977*^9, 3.6023311815571194`*^9}, {
   3.6025712219961987`*^9, 3.6025712224641995`*^9}, 
   3.602571465980627*^9},ExpressionUUID->"71198c59-8c80-4897-bc78-\
85e803d56c22"],

Cell[BoxData[
 RowBox[{"vx", " ", "\[Equal]", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "j", "]"}], "*", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "[", "i", "]"}], "*", 
     RowBox[{"vb", "[", "i", "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.602331190442628*^9, 3.6023312009272275`*^9}, {
   3.602331267711047*^9, 3.6023313312316804`*^9}, {3.6023379549475374`*^9, 
   3.602337962218953*^9}, {3.6024915012401533`*^9, 3.6024915175577817`*^9}, 
   3.602512025187454*^9, {3.602571240029831*^9, 3.602571261401868*^9}, {
   3.6025713009479375`*^9, 
   3.602571315580763*^9}},ExpressionUUID->"1355ee06-444e-4175-b2ad-\
a0740caa3f6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vx", " ", "=", " ", 
   RowBox[{"vec", "[", "x", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6425727705240374`*^9, 
  3.6425727821928577`*^9}},ExpressionUUID->"69e72d71-2b7b-40e9-9965-\
89f282d1e027"],

Cell["\<\
To calculate the y[i] as functions of the x[j] we insert the decomposition of \
vb[i] with respect to{ stb[j]} into the last formula: \
\>", "Text",
 CellChangeTimes->{{3.6023376419286337`*^9, 3.602337709296487*^9}, {
   3.6023952989199915`*^9, 3.602395317920825*^9}, 3.602508669888542*^9, 
   3.602571350961625*^9, {3.602571480473053*^9, 3.602571520565123*^9}, {
   3.6025715526855793`*^9, 3.6025715615619955`*^9}, {3.6425728093369055`*^9, 
   3.6425728405369596`*^9}},ExpressionUUID->"ffa599c5-2b8f-4e64-879a-\
a6eb87c40116"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "[", "i", "]"}], "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"b", "[", 
         RowBox[{"i", ",", "j"}], "]"}], "*", 
        RowBox[{"stb", "[", "j", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6023378129804173`*^9, 3.6023378325155344`*^9}, 
   3.6023378789401903`*^9, {3.602337909770953*^9, 3.60233791985153*^9}, {
   3.6024914415856485`*^9, 3.602491448792861*^9}, {3.6024918842364254`*^9, 
   3.6024918933312416`*^9}, {3.60249193194131*^9, 3.602491972641781*^9}, {
   3.60250872020442*^9, 3.602508731005038*^9}, {3.602512028627651*^9, 
   3.602512030027731*^9}, 
   3.6025714033465176`*^9},ExpressionUUID->"115bdc46-a4d8-4b49-819e-\
7b296b6c0e17"],

Cell["Interchanging the order of summation gives ", "Text",
 CellChangeTimes->{{3.602337998864049*^9, 
  3.6023380581684413`*^9}},ExpressionUUID->"d98f51cf-76ed-42fe-aca7-\
21adb6f44df5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], "\[Equal]", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"b", "[", 
         RowBox[{"i", ",", "j"}], "]"}], "*", 
        RowBox[{"y", "[", "i", "]"}]}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], "*", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.602338075740446*^9, 3.602338114156644*^9}, {
   3.602491991751815*^9, 3.602491993015417*^9}, {3.602508754100359*^9, 
   3.602508776811658*^9}, {3.6025120317238283`*^9, 3.6025120340749626`*^9}, {
   3.602571600125263*^9, 3.6025716155848904`*^9}, 
   3.602571646394944*^9},ExpressionUUID->"6747a924-e525-4b55-b0ab-\
0e9b6cb53f62"],

Cell["\<\
Comparing the components of stb[j] in this equation with the basis \
representation of vec[x] in the standard basis we obtain\
\>", "Text",
 CellChangeTimes->{{3.602338184040641*^9, 3.602338250024415*^9}, {
  3.6023954823599997`*^9, 
  3.6023955392232523`*^9}},ExpressionUUID->"15beb553-4a39-4673-b6dc-\
9fedbc8467fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "[", "j", "]"}], " ", "==", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"b", "[", 
      RowBox[{"i", ",", "j"}], "]"}], "*", 
     RowBox[{"y", "[", "i", "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.602338262553131*^9, 3.602338305243573*^9}, {
   3.60250887825146*^9, 3.602508883355752*^9}, 3.6025120380111876`*^9, 
   3.602571650918952*^9},ExpressionUUID->"1d1c3f68-01aa-4af5-94a5-\
bef9dfcea40d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"vec", "[", "y", "]"}], ".", "mb"}]}]], "Input",
 CellChangeTimes->{{3.602338334728259*^9, 3.6023383989789343`*^9}, {
  3.6025716673613815`*^9, 3.602571667969782*^9}, {3.6425732768853264`*^9, 
  3.642573291284152*^9}},ExpressionUUID->"491eb07d-3b71-44a9-97d9-\
95c43710f745"],

Cell["\<\
to calculate the coordinates {y[i]] = vec[y]  of the vector with respect to \
the basis {b[i]} we define\
\>", "Text",
 CellChangeTimes->{{3.6023384815206556`*^9, 3.602338483903792*^9}, {
  3.6025093901607394`*^9, 3.602509457984619*^9}, {3.6025095625526*^9, 
  3.602509587688037*^9}, {3.60250964490431*^9, 
  3.6025097610809546`*^9}},ExpressionUUID->"d4297808-3bcd-4bd5-8013-\
ae4e20f9da79"],

Cell[BoxData[
 RowBox[{"mc", " ", "=", 
  RowBox[{"Inverse", "[", "mb", "]"}]}]], "Input",
 CellChangeTimes->{{3.6023385514756565`*^9, 3.6023385694096823`*^9}, 
   3.602571757136339*^9, 
   3.6025720097475824`*^9},ExpressionUUID->"8d5b3e23-255c-41dd-8a56-\
5373d26819a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"i", ",", "j"}], "]"}], " ", "=", " ", 
     RowBox[{"mc", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], ";", 
  RowBox[{"mc", "==", 
   RowBox[{"matrix", "[", "c", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6023388628044634`*^9, 3.6023389584599347`*^9}, {
  3.6025120548441505`*^9, 3.6025120561162233`*^9}, {3.6025720118067865`*^9, 
  3.6025720142091904`*^9}},ExpressionUUID->"effa1211-a52f-41f0-99a7-\
a3605315c94e"],

Cell["\<\
 we obtain the corresponding  transformation of the coordinates:\
\>", "Text",
 CellChangeTimes->{{3.6023386136962156`*^9, 3.60233864384794*^9}, 
   3.6023403029448347`*^9},ExpressionUUID->"bd07abcd-feaa-4a5f-b179-\
98eb541d07a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "[", "j_", "]"}], " ", ":=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "k", "]"}], "*", 
     RowBox[{"c", "[", 
      RowBox[{"k", ",", "j"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6023387069705505`*^9, 3.6023387221604195`*^9}, {
   3.602339045411908*^9, 3.6023390781637816`*^9}, {3.602339402996361*^9, 
   3.602339416811151*^9}, {3.6025102538681407`*^9, 3.6025102607085323`*^9}, {
   3.602510351579729*^9, 3.6025103744840393`*^9}, 
   3.602512058019332*^9},ExpressionUUID->"25b25e56-8f4c-406a-8c63-\
7736a15d502e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "y", "]"}], " ", "-", " ", 
  RowBox[{"Table", "[", " ", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"k", ",", "j"}], "]"}], "*", 
       RowBox[{"x", "[", "k", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "dim"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.602338651306367*^9, 3.602338658193761*^9}, {
   3.6023391425944667`*^9, 3.6023392649084625`*^9}, 3.602339364045133*^9, {
   3.602510468916441*^9, 3.602510472076621*^9}, {3.6025120602994623`*^9, 
   3.6025120612595177`*^9}},ExpressionUUID->"5212eee5-820b-4101-b000-\
fd0103d551e8"],

Cell["or  expressed with matrix multiplication", "Text",
 CellChangeTimes->{{3.602340336847774*^9, 
  3.602340369600648*^9}},ExpressionUUID->"749f3ca8-b93f-42bd-8d38-\
5bef0fb3fc4e"],

Cell[TextData[StyleBox["Formula (2):",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.6024088984807506`*^9, 3.602408908309313*^9}, {
   3.6024884019359093`*^9, 3.6024884177699375`*^9}, 3.602489080412301*^9, 
   3.6025104951689425`*^9},ExpressionUUID->"f02dfd04-93a6-44a5-9751-\
121b06dc29aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "y", "]"}], "\[Equal]", " ", 
  RowBox[{
   RowBox[{"Transpose", "[", "mc", "]"}], ".", 
   RowBox[{"vec", "[", "x", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6023399121264815`*^9, 3.60233994373829*^9}, {
   3.6025105014423013`*^9, 3.6025105199463596`*^9}, 
   3.6025720222900047`*^9},ExpressionUUID->"028d1956-2396-420d-9258-\
afa2ed09e87c"],

Cell["\<\
Comparing this with the transformation (1) of the basis vectors\
\>", "Text",
 CellChangeTimes->{{3.6023404923046656`*^9, 3.602340512152801*^9}, 
   3.6023956344717007`*^9, {3.602510545608827*^9, 
   3.602510551920188*^9}},ExpressionUUID->"14e7a322-b4f0-4a2a-8932-\
5dc7579b7791"],

Cell[TextData[{
 "and remembering\n\n",
 StyleBox["Formula (3):",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.6023405554582777`*^9, 3.602340568169005*^9}, {
   3.602408964859547*^9, 3.6024089731310205`*^9}, 
   3.6025760988220234`*^9},ExpressionUUID->"7d170d9d-33aa-4720-8950-\
cce3b5582c44"],

Cell[BoxData[
 RowBox[{"mc", "==", " ", 
  RowBox[{"Inverse", "[", "mb", "]"}]}]], "Input",
 CellChangeTimes->{{3.6023399741390285`*^9, 3.602339999810497*^9}, {
   3.6023400421539183`*^9, 3.602340061283013*^9}, {3.602340216280878*^9, 
   3.6023402587613077`*^9}, {3.602510936603191*^9, 3.6025109461067343`*^9}, 
   3.602571767354357*^9, 
   3.602572029778018*^9},ExpressionUUID->"1c996c81-86ea-4b12-8312-\
56e3a8807d15"],

Cell[TextData[{
 " we see that the transformation matrix of the basis vectors is ",
 StyleBox["contragredient",
  FontColor->RGBColor[0, 0, 1]],
 " \n( transposed inverse) to the transformation matrix of the coordinates, \
or vice versa:"
}], "Text",
 CellChangeTimes->{{3.6023407030247183`*^9, 3.6023408075286956`*^9}, 
   3.6023409015610743`*^9, 3.602341042784151*^9, 
   3.642512677019736*^9},ExpressionUUID->"ee6c47eb-e885-4a13-a72e-\
e14fcf1c754c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "[", "mc", "]"}], "\[Equal]", " ", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Inverse", "[", "mb", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6023408545623856`*^9, 3.602340873973496*^9}, 
   3.6025107078441067`*^9, 3.6025109672849455`*^9, 3.6025717744211693`*^9, 
   3.602572031416021*^9},ExpressionUUID->"8c079905-76a5-49b7-908c-\
39ca06f913ef"],

Cell[TextData[{
 "Therefore the vectors are considered as ",
 StyleBox["contravariant",
  FontColor->RGBColor[0, 0, 1]],
 " objects, later we shall identify them as contravariant tensors of order 1.\
\n "
}], "Text",
 CellChangeTimes->{{3.6023411549445667`*^9, 3.6023412454167414`*^9}, {
  3.6023417512166715`*^9, 
  3.6023417579850583`*^9}},ExpressionUUID->"f13b94ef-73ee-4981-8117-\
7c1c7c8ca6d5"],

Cell["\<\
Often it is convenient to use the Kronecker delta in calculations with \
matrices or tensors:\
\>", "Text",
 CellChangeTimes->{{3.556010414416806*^9, 3.5560104778933177`*^9}, {
  3.5560105701355963`*^9, 3.5560106760146523`*^9}, {3.60234278796097*^9, 
  3.6023428676165257`*^9}},ExpressionUUID->"e48e70c1-2d4b-4ba1-917f-\
3845be6948d5"],

Cell[BoxData[
 RowBox[{"?", " ", "KroneckerDelta"}]], "Input",
 CellChangeTimes->{{3.5606943100170927`*^9, 
  3.5606943257749944`*^9}},ExpressionUUID->"cf22c63e-2cef-4b78-b8c2-\
c22f73c6fb6a"],

Cell["\<\
Usually the KroneckerDelta of two elements is abbreviated as \
\>", "Text",
 CellChangeTimes->{{3.5606943753078275`*^9, 
  3.5606944028994055`*^9}},ExpressionUUID->"b2230e0e-ce71-43ac-ab9b-\
5772b17c7dbe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Delta]", "[", 
   RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", " ", 
  RowBox[{"KroneckerDelta", "[", 
   RowBox[{"i", ",", "j"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.560694436262314*^9, 3.5606944584645834`*^9}, {
  3.560694567189802*^9, 3.5606946237960405`*^9}, {3.5606946562138944`*^9, 
  3.5606946654094205`*^9}},ExpressionUUID->"a5172773-c580-4264-8e6c-\
7b5bc7435f85"],

Cell["Examples:", "Text",
 CellChangeTimes->{{3.602342899088326*^9, 
  3.6023429035205793`*^9}},ExpressionUUID->"c2100639-6953-4cb4-b323-\
ff3dfee04aa9"],

Cell[BoxData[
 RowBox[{"\[Delta]", "[", 
  RowBox[{"1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.560694484223057*^9, 
  3.5606944881822834`*^9}},ExpressionUUID->"e089af95-633c-4f17-a710-\
13addea17814"],

Cell[BoxData[
 RowBox[{"\[Delta]", "[", 
  RowBox[{"x", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.560694484223057*^9, 
  3.560694511567621*^9}},ExpressionUUID->"f7c630c7-2c90-43a8-89dd-\
b5d404534260"],

Cell[BoxData[
 RowBox[{"\[Delta]", "[", 
  RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.560694484223057*^9, 3.560694511567621*^9}, {
  3.602395718775522*^9, 3.6023957347284346`*^9}, {3.602395810017741*^9, 
  3.6023958292568417`*^9}},ExpressionUUID->"25dd8d41-1ed7-4b80-a05a-\
5d6ef037ec64"],

Cell[BoxData[
 RowBox[{"\[Delta]", "[", 
  RowBox[{"1", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.560694484223057*^9, 3.560694511567621*^9}, {
  3.5606946915159135`*^9, 
  3.5606947017825007`*^9}},ExpressionUUID->"b5993add-e009-40a5-b904-\
c3554248122b"],

Cell["Two tests:", "Text",
 CellChangeTimes->{{3.60257230989211*^9, 
  3.6025723165221214`*^9}},ExpressionUUID->"36d21c3c-6da2-487c-adec-\
a612f7fb30d4"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"vec", "[", "x", "]"}], " ", "-", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"vb", "[", "i", "]"}], "*", 
      RowBox[{"y", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6025113993356576`*^9, 3.6025114648994074`*^9}, 
   3.602511505660739*^9, 
   3.602572269488039*^9},ExpressionUUID->"95a689ab-4042-49f6-9e19-\
0532a349e6c6"],

Cell[BoxData[
 RowBox[{"Chop", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.602511541548792*^9, 
  3.602511549498246*^9}},ExpressionUUID->"b3bc2c07-dd29-40d2-baa1-\
7977b9d18d45"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"vb", "[", "i", "]"}], "*", 
      RowBox[{"y", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "-", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"stb", "[", "i", "]"}], "*", 
      RowBox[{"x", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6025113993356576`*^9, 3.6025114648994074`*^9}, 
   3.602511505660739*^9, 3.6025116022842655`*^9, {3.60251164030044*^9, 
   3.6025116547252655`*^9}, {3.6025117611793537`*^9, 3.6025117764672284`*^9}, 
   3.6025723760674257`*^9},ExpressionUUID->"98065998-2868-41f6-b35d-\
156a7900082b"],

Cell[BoxData[
 RowBox[{"Chop", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6025117816075225`*^9, 
  3.6025117887289295`*^9}},ExpressionUUID->"ee89d66b-1c63-473a-970c-\
d73836cc7334"],

Cell["\<\
Thus, up to unavoidable small numerical disturbances, all is correct.\
\>", "Text",
 CellChangeTimes->{{3.602572602519047*^9, 3.602572655238062*^9}, {
  3.60257272967832*^9, 
  3.602572743342101*^9}},ExpressionUUID->"8d47e34b-13fa-4c28-8b59-\
0e9a994b46d7"],

Cell["\<\
We remember that the evaluation of a linear form corresponds to the Dot \
product of its coordinate covector with the coordinate vector of the argument:\
\>", "Text",
 CellChangeTimes->{{3.602343021824346*^9, 
  3.60234311648076*^9}},ExpressionUUID->"57aba73d-f2cc-4ee4-ac22-\
c9001168416d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "w", "]"}], ";", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"linform", "[", "w", "]"}], "[", 
    RowBox[{"vec", "[", "x", "]"}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"covec", "[", "w", "]"}], ".", 
    RowBox[{"vec", "[", "x", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.602343191174032*^9, 
  3.6023432451471195`*^9}},ExpressionUUID->"ca768d36-8581-4508-956b-\
e49990f12edd"],

Cell[TextData[{
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox[".",
  FontColor->RGBColor[1, 0, 0]],
 " ",
 StyleBox["Let {vb[i]}  be a basis of a finite dimensional vector space over \
the field K. Then there exists a uniquely defined basis {wb[i]} of the \
corresponding dual vector space, satisfying",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.5558524944124346`*^9, 3.5558525028919196`*^9}, {
   3.560693492140313*^9, 3.560693676171839*^9}, {3.560693707468629*^9, 
   3.5606937686851306`*^9}, {3.560922717765921*^9, 3.5609227249887342`*^9}, 
   3.6023429396246443`*^9, {3.60251116562529*^9, 3.602511175168836*^9}, {
   3.6025727939989986`*^9, 3.602572822310618*^9}},
 CellTags->"duba",ExpressionUUID->"3630d718-c07f-467b-8265-91551360476e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"wb", "[", "i", "]"}], ".", 
   RowBox[{"vb", "[", "j", "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{"\[Delta]", "[", 
   RowBox[{"i", ",", "j"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5606937985308375`*^9, 3.560693880015498*^9}, {
   3.560693939566904*^9, 3.5606939658584085`*^9}, 3.5606948602355633`*^9, {
   3.602053113587643*^9, 3.6020531460981007`*^9}, 3.602342968170277*^9, {
   3.60257283021607*^9, 
   3.6025728339682846`*^9}},ExpressionUUID->"df094126-872b-4f80-8cb8-\
858c501604c1"],

Cell[TextData[{
 StyleBox["Proof",
  FontColor->RGBColor[0, 0, 1]],
 ". Clearly, by proposition 2.2.1 the wb[i] are uniquely defined covectors \
via the corresponding linear forms whose values for a basis are given. \
Expressing the wb[i] and vb[j] in their coordinates with respect to a fixed \
basis in V,e.g. the standard basis, we see that the last equation implies"
}], "Text",
 CellChangeTimes->{{3.602343592288975*^9, 3.602343784456966*^9}, {
   3.6024004861623707`*^9, 3.6024004881534843`*^9}, 3.6025729747433367`*^9, {
   3.6025730542218823`*^9, 3.602573055596961*^9}, {3.6425128436312294`*^9, 
   3.642512847800437*^9}},ExpressionUUID->"d6a2d3e1-74f1-4e43-9aa3-\
9bf4ff6395d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"wb", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{"Inverse", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"vb", "[", "i", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6023437958806195`*^9, 3.60234387614721*^9}, 
   3.6024003071561317`*^9, 3.602572976343428*^9, 
   3.6025730573670626`*^9},ExpressionUUID->"1aec57dd-9b8e-41eb-b6f3-\
386f4b4c702c"],

Cell["\<\
Thus the covectors {wb[i]} are linearly independent and form a basis in the \
space of covectors. \[FilledSquare]\
\>", "Text",
 CellChangeTimes->{{3.5558524944124346`*^9, 3.5558525028919196`*^9}, {
   3.560693492140313*^9, 3.560693676171839*^9}, {3.560693707468629*^9, 
   3.5606937686851306`*^9}, {3.560694134323044*^9, 3.5606941435795736`*^9}, {
   3.560694895331571*^9, 3.5606948988117704`*^9}, {3.560695599235832*^9, 
   3.5606956263073807`*^9}, {3.560695671675976*^9, 3.560695757699896*^9}, {
   3.6023439039448004`*^9, 3.6023439969631205`*^9}, {3.6024005193692694`*^9, 
   3.6024005208893566`*^9}, 3.602573061117277*^9, 
   3.642576857749915*^9},ExpressionUUID->"60c38283-4f0e-42e1-ab7b-\
8d30d4e0f5c0"],

Cell[TextData[{
 "This basis is named the ",
 StyleBox["dual basis to the basis {",
  FontColor->RGBColor[0, 0, 1]],
 "vb[",
 StyleBox["i]}.  ",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox["We consider the standard basis of the vector space",
  FontColor->GrayLevel[0]],
 StyleBox[". ",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox[" The corresponding dual basis of the dual space is its standard \
basis, the covectors ",
  FontColor->GrayLevel[0]],
 "wb[",
 StyleBox["i] of which are defined by ",
  FontColor->GrayLevel[0]],
 "stb[i]",
 StyleBox[":",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.5558524944124346`*^9, 3.5558525028919196`*^9}, {
   3.560693492140313*^9, 3.560693676171839*^9}, {3.560693707468629*^9, 
   3.5606937686851306`*^9}, {3.560694134323044*^9, 3.5606941435795736`*^9}, {
   3.560694895331571*^9, 3.5606948988117704`*^9}, {3.560695599235832*^9, 
   3.5606956263073807`*^9}, {3.560695671675976*^9, 3.560695757699896*^9}, {
   3.6023439039448004`*^9, 3.602343980254165*^9}, {3.6023440277848835`*^9, 
   3.602344097240856*^9}, 3.6025729783495426`*^9, 3.6025730633644056`*^9, {
   3.6025733150067987`*^9, 
   3.6025733237903013`*^9}},ExpressionUUID->"79d644cd-c141-4b5b-9df4-\
e8eebe3793ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], ".", 
     RowBox[{"stb", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.5606953182277594`*^9, 3.5606953759590616`*^9}, 
   3.6020564732805724`*^9, 3.6025730673666344`*^9, {3.602573368065833*^9, 
   3.6025733683138475`*^9}},ExpressionUUID->"8ea32d8c-390a-4f5c-9530-\
aab41baecc7c"],

Cell[TextData[StyleBox["Thus, the dual basis of the standard basis is the \
standard basis of the dual space.",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.5609245482971077`*^9, 3.560924588732379*^9}, {
   3.560928196802343*^9, 3.5609282624160585`*^9}, {3.5733074624352856`*^9, 
   3.5733074720449023`*^9}, 
   3.602056565835535*^9},ExpressionUUID->"975a8805-9792-4846-910e-\
abf43febcc7f"],

Cell["\<\
Let {wb[i]} denote the dual basis to {vb}[i].   We define the covectors \
wb[i], i = 1,2,3, represented in the standard basis stb[i] as\
\>", "Text",
 CellChangeTimes->{{3.561882939957401*^9, 3.5618831025707016`*^9}, {
   3.561883428121322*^9, 3.5618834828844547`*^9}, {3.5684677514178023`*^9, 
   3.5684677521538444`*^9}, 3.5684687958015375`*^9, {3.573307935428116*^9, 
   3.573307935864917*^9}, 3.5734694460977135`*^9, {3.573470536617629*^9, 
   3.573470581342908*^9}, {3.602344154704143*^9, 3.6023442022328615`*^9}, 
   3.6025730692217407`*^9, 3.6025733830456905`*^9, 3.602573465474405*^9, {
   3.6025735828871202`*^9, 3.6025735847082243`*^9}, {3.6425738850991945`*^9, 
   3.642573996935791*^9}},ExpressionUUID->"12e92b9b-934b-4851-88ce-\
6b16bb6a56e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"wb", "[", "i_Integer", "]"}], " ", ":=", 
  RowBox[{"Sum", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"k", ",", "i"}], "]"}], "*", 
     RowBox[{"stb", "[", "k", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.642574022488636*^9, 
  3.6425740366690607`*^9}},ExpressionUUID->"46a9ddca-9862-41ba-bd88-\
73159bf43ed8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"wb", "[", "i", "]"}], ".", 
     RowBox[{"vb", "[", "j", "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.6023443949308834`*^9, 3.602344453114211*^9}, 
   3.6025729909582644`*^9, 
   3.6025735909035788`*^9},ExpressionUUID->"40261ff2-4d7b-48af-ba25-\
57eddab34ac8"],

Cell[BoxData[
 RowBox[{"Chop", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.602344537704049*^9, 
  3.6023445448344574`*^9}},ExpressionUUID->"c581b579-71ce-4356-8b17-\
174ab54f809d"],

Cell[TextData[{
 "Thus {",
 "wb[",
 "i]} is the dual basis to {vb[i]} up to small numerical disturbances, and \
the defining equation show the transformation rule \n\n",
 StyleBox["Formula (4):",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.5734706601698465`*^9, 3.5734707112599363`*^9}, {
   3.60050203635563*^9, 3.600502045122845*^9}, 3.6024007331454973`*^9, {
   3.6024007963131104`*^9, 3.6024008711853924`*^9}, {3.6024009186741085`*^9, 
   3.602400961298547*^9}, {3.602409034404525*^9, 3.6024090527635756`*^9}, {
   3.6024091025874248`*^9, 3.6024091137550635`*^9}, 3.6025729927083645`*^9, 
   3.602573592213654*^9, 
   3.602576079557922*^9},ExpressionUUID->"59b812f5-9d4f-4eac-ae4d-\
b5fe8a6d6ea2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"wb", "[", "i", "]"}], " ", "=", 
  RowBox[{"Sum", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"k", ",", "i"}], "]"}], "*", 
     RowBox[{"stb", "[", "k", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"31df21dd-c9aa-43c3-98cd-a163c8ba2fe5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"wb", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"Transpose", "[", "mc", "]"}], ".", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"stb", "[", "i", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6024009670498753`*^9, 3.6024010359478164`*^9}, 
   3.6025720438648424`*^9, 3.6025730779582405`*^9, 3.602573472015779*^9, 
   3.6025735937827435`*^9, {3.602573808569029*^9, 
   3.602573817097516*^9}},ExpressionUUID->"ddae4e2c-d0a7-4aa4-b2cb-\
d3b9edf330ca"],

Cell[TextData[{
 StyleBox["The cobases are transformed as the vector coordinates (see Formula \
(2)), that means contravariantly to the bases in V. It follows that the \
coordinates of covectors are transformed contravariantly to the cobases, and \
that means covariantly to the bases of the vector space V. Thi",
  FontColor->GrayLevel[0]],
 "s explains the name giving mentioned at the beginning of this subsection. "
}], "Text",
 CellChangeTimes->{{3.5734706601698465`*^9, 3.5734707112599363`*^9}, {
   3.60050203635563*^9, 3.600502045122845*^9}, 3.6024007331454973`*^9, {
   3.6024007963131104`*^9, 3.6024008711853924`*^9}, {3.6024009186741085`*^9, 
   3.602400961298547*^9}, {3.602401121601715*^9, 3.602401228609836*^9}, {
   3.60240126329782*^9, 3.6024013330978127`*^9}, {3.6024013669217467`*^9, 
   3.602401454705768*^9}, {3.602401544329894*^9, 3.6024015713774414`*^9}, {
   3.602401634162032*^9, 3.6024016957615557`*^9}, {3.602409133436189*^9, 
   3.6024091585566263`*^9}, 
   3.642574255599846*^9},ExpressionUUID->"8187822a-97bb-4ed8-be94-\
cdfac02fd1c0"],

Cell[TextData[StyleBox["The coordinates of covectors with respect to the dual \
bases are transformed according to the bases of the vector space V (see \
Formula (1)).",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.5618838706006308`*^9, 3.5618839737475305`*^9}, {
   3.5684726051944227`*^9, 3.568472606041471*^9}, {3.602409322460001*^9, 
   3.6024093359707737`*^9}, {3.6024095096677084`*^9, 3.602409514883007*^9}, {
   3.6024095516751113`*^9, 3.6024095909953604`*^9}, {3.6024096580521955`*^9, 
   3.6024096696118565`*^9}, {3.6024097150274544`*^9, 3.6024097229789095`*^9}, 
   3.6425744410217714`*^9},
 CellTags->"trdb",ExpressionUUID->"3dfb509c-b8ba-4ccc-afaf-9b702dcf7cfe"],

Cell[TextData[{
 "This transformation behavior  is called",
 StyleBox[" covariant",
  FontColor->RGBColor[0, 0, 1]],
 " since it coincides with the transformation of the basis vectors, \
contrarily to the transformation of the vector coordinates, which we have \
seen to be contravariant. We emphasize once more that the transformation \
behavior of the coordinates of vectors and covectors is not inherent in or a \
consequence of the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " definition of these objects; it is an additional information hinting to \
the context of their use, and this is the reason that we gave distinct names \
for objects having the same model in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.5606876823532844`*^9, 3.5606877322121363`*^9}, {
   3.56069061481974*^9, 3.5606906276524734`*^9}, 3.602409788851677*^9, 
   3.6024098192994184`*^9, {3.6024098787158165`*^9, 3.602409913059781*^9}, 
   3.642577146349002*^9},ExpressionUUID->"6ebc746c-2b74-449c-97e7-\
e93e0668554a"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{
  "ma", ",", "mb", ",", "bt", ",", "w", ",", "vb", ",", "a", ",", "b", ",", 
   "u", ",", "v", ",", "c", ",", "wu", ",", "wv", ",", "x", ",", "y"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6026669985533543`*^9, 
  3.6026671132759557`*^9}},ExpressionUUID->"87b08842-c036-4582-ad0a-\
f4963e27a4c4"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3. Tensors", "Section",
 CellChangeTimes->{{3.559030631158196*^9, 3.559030638798633*^9}, {
   3.5607695853720016`*^9, 3.560769594326418*^9}, {3.5610435828937473`*^9, 
   3.5610435908185606`*^9}, 3.561450213917213*^9, {3.6006127505865116`*^9, 
   3.600612752396115*^9}, 3.6036016848181477`*^9, {3.642574691261811*^9, 
   3.6425746937110147`*^9}, 
   3.64328512951448*^9},ExpressionUUID->"2a796df6-86d4-418c-93f8-\
de6d96649815"],

Cell[TextData[{
 "In this chapter we introduce a tensor object into ",
 StyleBox["Mathematica ",
  FontSlant->"Italic"],
 "as the basis for all applications of tensors in algebra, geometry and \
physics.  The tensor object allows to distinguish covariant, contravariant, \
and mixed type tensors. In ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " an explicit tensor object isn\[CloseCurlyQuote]t built-in, in spite of the \
fact that many useful tensor operations can be found, see below Chapter 5. \
They refer to Arrays of special type: the coordinate Arrays of the tensor. \
Tensors of mixed type aren\[CloseCurlyQuote]t considered. We assume that the \
user already knows the basic concepts of tensor algebra. A beginner should \
first read a textbook containing tensor concepts, e.g. [",
 ButtonBox["OSII",
  BaseStyle->"Hyperlink",
  ButtonData->"OSII"],
 "], \[Section]\[Section] 10,11, where one finds more hints to the literature."
}], "Text",
 CellChangeTimes->{{3.602918795007222*^9, 3.6029188329663935`*^9}, {
   3.602919139006898*^9, 3.602919208494872*^9}, {3.6029193366632032`*^9, 
   3.602919341990508*^9}, {3.602919373726323*^9, 3.6029194355748606`*^9}, {
   3.602919679878834*^9, 3.6029197455905924`*^9}, {3.6029197966095104`*^9, 
   3.6029197966145105`*^9}, 3.642577159301426*^9, {3.6426004832880344`*^9, 
   3.6426005077488775`*^9}, {3.642600542730139*^9, 3.642600584226612*^9}, {
   3.6426007032833724`*^9, 3.6426007063097773`*^9}, {3.6426007549410634`*^9, 
   3.6426007696402893`*^9}, {3.64260084345802*^9, 3.6426009520406117`*^9}, {
   3.642601041181569*^9, 3.6426010467663794`*^9}, {3.6426588271668344`*^9, 
   3.6426588373380523`*^9}, {3.642658898484028*^9, 3.642659039296276*^9}, {
   3.642659294371338*^9, 3.6426593897991066`*^9}, 3.6426594335515842`*^9, 
   3.6426628241807013`*^9},ExpressionUUID->"39c19b4f-de3b-40e3-ad90-\
ed16b31394af"],

Cell[CellGroupData[{

Cell["3..1.  Definition. Examples. Properties", "Subsection",
 CellChangeTimes->{{3.5559015526098194`*^9, 3.555901564013439*^9}, {
   3.5590306513273497`*^9, 3.559030672422556*^9}, {3.5596126223227377`*^9, 
   3.5596126259731445`*^9}, 3.5607696035772333`*^9, {3.563723256352163*^9, 
   3.563723258382279*^9}, 3.5637806402481623`*^9, {3.5643263046319685`*^9, 
   3.5643263415920825`*^9}},ExpressionUUID->"e818787f-f4c8-4ee1-ac9f-\
a635438a3fa1"],

Cell[TextData[{
 "We are going to introduce a tensor as a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " object with Head tensor. It is characterized by three non-negative \
integers, the covariant degree k, the contravariant degree h, and the \
dimension d:= dim of the underlying vector space V over the field K, usually \
the field of real or complex numbers; here degree means the number of \
covariant respectively contravariant indices. The main part of the definition \
is the function a yielding the coordinates of the tensor with respect to the \
standard basis {stb[i]} of the underlying vector space V. The function a \
depends on two Tuples of indices:"
}], "Text",
 CellChangeTimes->{{3.6427451013836837`*^9, 3.642745190043442*^9}, {
   3.6427486444208183`*^9, 3.6427489257971163`*^9}, {3.6427490142906747`*^9, 
   3.642749065854766*^9}, 3.6427493232428207`*^9, {3.64275108678307*^9, 
   3.6427512315511265`*^9}, 
   3.6434604488480587`*^9},ExpressionUUID->"1ba9c695-d5e2-494f-b7c7-\
e64e398bd5e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", "ii", "}"}], "\[Element]", " ", 
   RowBox[{"Tuples", "[", 
    RowBox[{"Range", "[", 
     RowBox[{"d", ",", "k"}], "]"}], "]"}]}], ",", " ", 
  RowBox[{
   RowBox[{"{", "jj", "}"}], "\[Element]", " ", 
   RowBox[{"Tuples", "[", 
    RowBox[{"Range", "[", 
     RowBox[{"d", ",", "h"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "ii", "}"}], ",", 
      RowBox[{"{", "jj", "}"}]}], "}"}], " ", "\[RightTeeArrow]", 
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"{", "ii", "}"}], ",", 
      RowBox[{"{", "jj", "}"}]}], "]"}]}], "\[Element]", " ", 
   RowBox[{"K", "."}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.64274907966479*^9, 3.642749146836909*^9}, {
   3.642749177666563*^9, 3.6427492967635736`*^9}, 3.6427493749503117`*^9, {
   3.6427497536163807`*^9, 3.642749851945754*^9}, {3.6427512479995556`*^9, 
   3.6427512557401695`*^9}},ExpressionUUID->"bd123ef1-e352-48da-ac4f-\
7aee43c4a9e4"],

Cell["\<\
In most applications the coordinates are functions with values in K depending \
on the points x of a manifold.  The traditional notation is (without the  \
parentheses { }) is \
\>", "Text",
 CellChangeTimes->{{3.642749453653851*^9, 3.6427495564136324`*^9}, {
  3.6427498695475855`*^9, 3.642749902935644*^9}, {3.6427500149327707`*^9, 
  3.642750071802871*^9}, {3.642751274948803*^9, 3.6427512757132044`*^9}, {
  3.642751324565891*^9, 
  3.642751352794341*^9}},ExpressionUUID->"bb5dd096-64cb-46f8-ac9f-\
ec39e6574486"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tradf", "[", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", "ii", "}"}], ",", " ", 
     RowBox[{"{", "jj", "}"}]}], "]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.642749631992166*^9, 
  3.642749741103159*^9}},ExpressionUUID->"1444bb6a-d700-48f1-a458-\
aaec08eb75c4"],

Cell[BoxData[
 RowBox[{
  TemplateBox[{SubscriptBox["a", 
     RowBox[{"{", "ii", "}"}]],RowBox[{"{", "jj", "}"}]},
   "Superscript"], "\[Equal]", " ", 
  SubsuperscriptBox["a", 
   SubscriptBox["i", 
    RowBox[{
     RowBox[{"1", "..."}], 
     SubscriptBox["i", "k"]}]], 
   RowBox[{"                  ", 
    SubscriptBox["j", 
     RowBox[{
      RowBox[{"1", "..."}], 
      SubscriptBox["j", "h"]}]], " "}]]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6427501483420067`*^9, 3.6427503457211576`*^9}, {
  3.6427503854010277`*^9, 3.642750458205756*^9}, {3.6427504908490143`*^9, 
  3.642750557882733*^9}},ExpressionUUID->"55709d3a-658a-4ecf-89fe-\
b947835b1251"],

Cell[TextData[{
 StyleBox["Example",
  FontColor->RGBColor[0, 0, 1]],
 "."
}], "Text",
 CellChangeTimes->{{3.6427505854061813`*^9, 
  3.6427506061602182`*^9}},ExpressionUUID->"cca1d2c2-563d-4051-8199-\
58d866feaa8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "3"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "3", ",", "2"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6427506398486776`*^9, 
  3.6427506860231595`*^9}},ExpressionUUID->"d15adb02-7449-4cd3-b2f6-\
e2b64c211c66"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6427506988015823`*^9, 
  3.6427507246880283`*^9}},ExpressionUUID->"5bfd5926-32cc-4a4e-99c2-\
6c63dd61ae7d"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6427508307040167`*^9, 
  3.642750836542427*^9}},ExpressionUUID->"6f43bbf4-a2b5-47f0-bf28-\
e72e1c99ec5b"],

Cell[BoxData[
 RowBox[{"Head", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.6427508174907937`*^9, 
  3.642750825025607*^9}},ExpressionUUID->"58b33426-963c-4f5b-a890-\
177c67ee5d65"],

Cell["\<\
The Array of the coordinates has a specific form obtained by the function \
tensorToArray\
\>", "Text",
 CellChangeTimes->{{3.6427514688407464`*^9, 
  3.6427515319734583`*^9}},ExpressionUUID->"ce62afbc-f6f0-406c-b623-\
5ffab5c0c0d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tensorToArray", "[", "ta", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.642750856966863*^9, 3.642750868454484*^9}, {
  3.6427509374850063`*^9, 
  3.642750943756217*^9}},ExpressionUUID->"4684e665-16b6-4d56-9739-\
a000f0680586"],

Cell["\<\
Vectors, covectors and matrices may be considered as special cases of \
tensors. \[FilledSmallSquare]\
\>", "Text",
 CellChangeTimes->{{3.6427515743189325`*^9, 
  3.6427516372960443`*^9}},ExpressionUUID->"ab0adcf0-34db-44b4-b9bd-\
ae2e909e7f0c"],

Cell[CellGroupData[{

Cell["3.1.1. The Definition", "Subsubsection",
 CellChangeTimes->{{3.564326365376443*^9, 
  3.5643263819433904`*^9}},ExpressionUUID->"bb37aa7f-c695-451b-a9b1-\
bfb0304468a7"],

Cell[BoxData[
 RowBox[{"?", "tensor"}]], "Input",
 CellChangeTimes->{{3.558704808110769*^9, 3.5587049199317656`*^9}, {
  3.558705067274024*^9, 3.558705085853657*^9}, {3.5587058323951435`*^9, 
  3.558706005534046*^9}, {3.5587060545588503`*^9, 3.5587063216191254`*^9}, {
  3.558706373347084*^9, 3.5587063961303873`*^9}, {3.5587066026011963`*^9, 
  3.558706611024678*^9}},ExpressionUUID->"6e68165d-f709-4afd-b3ea-\
281fba5929c8"],

Cell["\<\
Here is the definition contained in tensalgv3.m  (with dim -> dimm):\
\>", "Text",
 CellChangeTimes->{{3.5596298328281174`*^9, 3.559629858963612*^9}, {
   3.56274698207501*^9, 3.5627470419011145`*^9}, 3.5650038480723534`*^9, 
   3.568790495664544*^9, {3.600515632530868*^9, 3.6005156465084925`*^9}, 
   3.6425014335816183`*^9, 
   3.706253631728677*^9},ExpressionUUID->"b55f560c-1caf-4217-a2d2-\
cf0f837fa06a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", " ", "k_Integer", ",", " ", "h_Integer", ",", " ", 
       RowBox[{"d_:", "dim"}]}], "]"}], "[", 
     RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ii", ",", "jj"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"Tuples", "[", 
              RowBox[{
               RowBox[{"Range", "[", "d", "]"}], ",", "k"}], "]"}], ",", 
             "i"}], "]"}], "&&", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"Tuples", "[", 
              RowBox[{
               RowBox[{"Range", "[", "d", "]"}], ",", "h"}], "]"}], ",", 
             "j"}], "]"}]}], "]"}], ",", " ", "\n", "\t", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Incorrect indices!\>\"", "]"}], ";", 
          RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
       RowBox[{"a", "[", 
        RowBox[{"i", ",", "j"}], "]"}]}]}], "]"}]}], ";"}], " ", 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", " ", "k_Integer", ",", " ", "h_Integer", ",", " ", 
       RowBox[{"d_:", "dim"}]}], "]"}], "[", "i_", "]"}], " ", ":=", " ", 
    "\n", 
    RowBox[{
    "Print", "[", "\"\<A tensor needs two arguments being Lists!\>\"", 
     "]"}]}], ";", 
   RowBox[{"Return", "[", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"tensor", "[", 
     RowBox[{"a_", ",", " ", "k_Integer", ",", " ", "h_Integer", ",", " ", 
      RowBox[{"d_:", "dim"}]}], "]"}], "[", "]"}], " ", ":=", " ", "\n", 
   RowBox[{
   "Print", "[", "\"\<A tensor needs two arguments being Lists!\>\"", "]"}]}],
   ";", 
  RowBox[{"Return", "[", "]"}], ";"}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.5650033903551493`*^9, 3.565003440134837*^9, {3.56500348178691*^9, 
   3.5650036095199347`*^9}, {3.5650036634648294`*^9, 3.565003669970041*^9}, 
   3.56506785998645*^9, {3.568010111859505*^9, 3.5680101161651125`*^9}, {
   3.568010173027213*^9, 3.568010181888028*^9}, 3.56801021725329*^9, 
   3.5680102871102133`*^9, {3.568011487834322*^9, 3.568011510064361*^9}, {
   3.568014554881737*^9, 3.568014583847394*^9}, {3.5688116403100195`*^9, 
   3.5688116500625772`*^9}, 
   3.570777228255299*^9},ExpressionUUID->"ab1e1553-9224-40a2-8fe6-\
58ab1e679199"],

Cell["\<\
To operate with tensors the following rules and functions are defined in \
tensalgv2.m (for  products see subsections 3.2.3 and 3.3).\
\>", "Text",
 CellChangeTimes->{{3.5643179759110765`*^9, 3.564318015613147*^9}, {
   3.564318059776824*^9, 3.564318124610538*^9}, {3.564318312824869*^9, 
   3.5643183369581113`*^9}, 
   3.6425014336128187`*^9},ExpressionUUID->"0f833d6a-f45a-4959-9203-\
152cb13c7214"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Unprotect", "[", "Plus", "]"}], ";", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", "k_", ",", "l_"}], "]"}], "+", 
     RowBox[{"tensor", "[", 
      RowBox[{"b_", ",", "k_", ",", "l_"}], "]"}]}], ":=", " ", 
    RowBox[{"tensor", "[", 
     RowBox[{
      RowBox[{"plus", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "k", ",", "l"}], "]"}]}], ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", "k_", ",", "l_"}], "]"}], "+", 
     RowBox[{"tensor", "[", 
      RowBox[{"b_", ",", "k_", ",", "l_", ",", 
       RowBox[{"d_:", "dim"}]}], "]"}]}], ":=", " ", 
    RowBox[{"tensor", "[", 
     RowBox[{
      RowBox[{"plus", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "k", ",", "l", ",", "d"}], 
     "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", "k_", ",", "l_", ",", 
       RowBox[{"d_:", "dim"}]}], "]"}], "+", 
     RowBox[{"tensor", "[", 
      RowBox[{"b_", ",", "k_", ",", "l_", ",", 
       RowBox[{"d_:", "dim"}]}], "]"}]}], ":=", " ", 
    RowBox[{"tensor", "[", 
     RowBox[{
      RowBox[{"plus", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "k", ",", "l", ",", "d"}], 
     "]"}]}], ";", 
   RowBox[{"Protect", "[", "Plus", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Unprotect", "[", "Times", "]"}], ";", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"tensor", "[", 
      RowBox[{"b_", ",", "k_", ",", "l_"}], "]"}]}], ":=", " ", 
    RowBox[{"tensor", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", "k", ",", "l"}], "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"tensor", "[", 
     RowBox[{"b_", ",", "k_", ",", "l_", ",", 
      RowBox[{"d_:", "dim"}]}], "]"}]}], ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", "k", ",", "l", ",", "d"}], "]"}]}], ";", " ", 
  RowBox[{"Protect", "[", "Times", "]"}], ";"}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.5643182005514717`*^9, 3.5643182336703296`*^9, {3.5650038014438715`*^9, 
   3.56500380610828*^9}, {3.565003847011552*^9, 3.565003847058352*^9}, {
   3.600657927227146*^9, 3.60065794084597*^9}, 3.600662688045368*^9, {
   3.6006633551805396`*^9, 
   3.6006633806709843`*^9}},ExpressionUUID->"209d3d95-55cf-4b98-8a34-\
1efd1e97f3b3"],

Cell[TextData[{
 "The",
 StyleBox[" type",
  FontColor->RGBColor[0, 0, 1]],
 " of a tensor is defined as the list of its defining entities: the \
coordinate function a, the integers {k,h}, where k denotes the number of \
covariant and h the number of contravariant indices, and the dimension d of \
the underlying vector space. Often the ",
 StyleBox["type",
  FontColor->RGBColor[0, 0, 1]],
 " of a tensor is understood as the pair {k,h}. A tensor with k=0 is said to \
be ",
 StyleBox["contravariant",
  FontColor->RGBColor[0, 0, 1]],
 ", and with h=0 it is ",
 StyleBox["covariant",
  FontColor->RGBColor[0, 0, 1]],
 ". The ",
 StyleBox["order",
  FontColor->RGBColor[0, 0, 1]],
 " (or ",
 StyleBox["degree",
  FontColor->RGBColor[0, 0, 1]],
 ") of the tensor is defined to be k+h. The type as a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function of the tensor is defined in",
 " tensalgv2.m",
 " as"
}], "Text",
 CellChangeTimes->{{3.6006634060834293`*^9, 3.6006634192654524`*^9}, {
   3.600663583767741*^9, 3.600663675480302*^9}, {3.600664355017496*^9, 
   3.600664554510646*^9}, 3.60066490382646*^9, {3.600665122570044*^9, 
   3.6006652634382915`*^9}, {3.6006653293952074`*^9, 3.6006653819985*^9}, {
   3.6006654213261685`*^9, 3.6006654344301915`*^9}, {3.6029168783903046`*^9, 
   3.6029169374520082`*^9}, 
   3.6425014336752186`*^9},ExpressionUUID->"4bcec5fd-894b-4eb2-a76e-\
120c133176d9"],

Cell[BoxData[
 RowBox[{"?", "type"}]], "Input",
 CellChangeTimes->{{3.600665603066488*^9, 
  3.600665606108493*^9}},ExpressionUUID->"740b7c62-bf37-4b27-8252-\
186fdb3b55f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"type", "[", "tt_", "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "typ", ",", " ", "a", ",", "k", ",", "h", ",", "d", ",", "ty"}], "}"}],
       ",", "\n", 
      RowBox[{
       RowBox[{
        RowBox[{"typ", "[", 
         RowBox[{"tensor", "[", 
          RowBox[{"a_", ",", "k_", ",", "h_", ",", 
           RowBox[{"d_:", "dim"}]}], "]"}], "]"}], " ", ":=", " ", 
        RowBox[{"{", 
         RowBox[{"a", ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "h"}], "}"}], ",", "d"}], "}"}]}], ";", "\n", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Head", "[", "tt", "]"}], " ", "===", " ", "tensor"}], 
          ")"}], ",", " ", 
         RowBox[{"ty", "=", 
          RowBox[{"typ", "[", "tt", "]"}]}], ",", "  ", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Argument is not a tensor!\>\"", "]"}], 
          ";", 
          RowBox[{"ty", "=", "Null"}]}], ",", "\n", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Argument is not a tensor!\>\"", "]"}], 
          ";", 
          RowBox[{"ty", "=", "Null"}]}]}], "]"}], ";", "ty"}]}], "]"}]}], 
   ";"}], "\n"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.5643182005514717`*^9, 3.5643182336703296`*^9, {3.5650038014438715`*^9, 
   3.56500380610828*^9}, {3.565003847011552*^9, 3.565003847058352*^9}, {
   3.600657927227146*^9, 3.60065794084597*^9}, 3.600662688045368*^9, {
   3.6006633551805396`*^9, 
   3.6006633926830053`*^9}},ExpressionUUID->"8a74b31c-ecf7-4380-86bb-\
1caf9a758afd"],

Cell[TextData[{
 "The ",
 StyleBox["coordinates",
  FontColor->RGBColor[0, 0, 1]],
 " (or components) of a tensor are obtained by the function.:"
}], "Text",
 CellChangeTimes->{{3.568040854951756*^9, 3.568040907336648*^9}, 
   3.6011843577937956`*^9, {3.602917035841381*^9, 3.602917038259385*^9}, {
   3.602917125478731*^9, 
   3.602917126846809*^9}},ExpressionUUID->"c3ccbe0a-4d7c-4388-9b9a-\
b56755407cab"],

Cell[BoxData[
 RowBox[{"?", "coords"}]], "Input",
 CellChangeTimes->{{3.5680409113302555`*^9, 
  3.5680409211582727`*^9}},ExpressionUUID->"2d7b92c4-d1bc-441b-bf3d-\
dbb3ca7d5342"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"coords", "[", "tt_", "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ti", ",", "k", ",", "h", ",", "dd", ",", "rk", ",", "rh", ",", " ", 
       "i", ",", "j"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], "===", " ", "tensor"}], "]"}], 
        ",", 
        RowBox[{
         RowBox[{
         "Print", "[", "\"\<The argument must be a tensor!\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"ti", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", " ", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"rk", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"Range", "[", "dd", "]"}], ",", "k"}], "]"}]}], ";", 
      RowBox[{"rh", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"Range", "[", "dd", "]"}], ",", "h"}], "]"}]}], ";", "\n", 
      RowBox[{"Table", "[", " ", 
       RowBox[{
        RowBox[{"tt", "[", 
         RowBox[{
          RowBox[{"rk", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"rh", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"dd", "^", "k"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"dd", "^", "h"}]}], "}"}]}], "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.6427701318389783`*^9},ExpressionUUID->"7e55fa23-75d3-45b9-b4fc-\
47ea3606f2cf"],

Cell[BoxData[
 RowBox[{"coords", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.6427703029428806`*^9, 
  3.6427703095884924`*^9}},ExpressionUUID->"7324ecf3-5423-4784-943a-\
c08be2aadcc4"],

Cell["\<\
The following function yields the coordinates of the tensor as an Array r \
better reflecting the structure of the tensor:\
\>", "Text",
 CellChangeTimes->{{3.6427703536353703`*^9, 3.6427705451421084`*^9}, 
   3.6434604614568815`*^9},ExpressionUUID->"f2cf98dd-19d0-4264-87b5-\
d128efebd137"],

Cell[BoxData[
 RowBox[{"?", "tensorToArray"}]], "Input",
 CellChangeTimes->{{3.6427705536325235`*^9, 
  3.642770560622336*^9}},ExpressionUUID->"3ffbc0b2-e1eb-43a3-9684-\
c8d4e34cb78f"],

Cell["The definition in tensalgv2.m is", "Text",
 CellChangeTimes->{{3.6427707549722795`*^9, 
  3.6427707704163065`*^9}},ExpressionUUID->"d249e579-9cf6-427e-807e-\
22f2c31f4bd2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"tensorToArray", ",", "Listable"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"tensorToArray", "[", "tt_", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ti", ",", "aa", ",", "k", ",", "h", ",", "dd", ",", "bb", ",", "i"}], 
      "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], "===", " ", "tensor"}], "]"}], 
        ",", 
        RowBox[{
         RowBox[{
         "Print", "[", "\"\<The argument must be a tensor!\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"ti", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", 
      RowBox[{"aa", " ", "=", " ", 
       RowBox[{"ti", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", " ", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"k", "==", "0"}], "&&", 
         RowBox[{"h", "==", "0"}]}], ",", " ", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"coords", "[", "tt", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], "}"}], "]"}]}], "]"}], ";",
       "\n", 
      RowBox[{"Off", "[", 
       RowBox[{"Part", "::", "take"}], "]"}], ";", "\n", " ", 
      RowBox[{
       RowBox[{"bb", "[", "i___", "]"}], ":=", " ", 
       RowBox[{"aa", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "i", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", "k"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", "i", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"k", "+", "1"}], ";;", 
            RowBox[{"k", "+", "h"}]}], "]"}], "]"}]}], "]"}]}], ";", "\n", 
      RowBox[{"Array", "[", 
       RowBox[{"bb", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"dd", ",", 
          RowBox[{"{", 
           RowBox[{"k", "+", "h"}], "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
  ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"35ffc467-7e51-49c7-8644-826dbe29c794"],

Cell[BoxData[
 RowBox[{"cta", " ", "=", 
  RowBox[{"tensorToArray", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.6427707866443353`*^9, 3.642770816222987*^9}, {
  3.642771749554037*^9, 
  3.6427717516756406`*^9}},ExpressionUUID->"747bdaee-d295-4659-930c-\
2a20cbe7fc5c"],

Cell["\<\
The built-in function TensorQ confirms that this Array is considered to be a \
(not explicitly defined!) tensor in the  sense of Mathematica\
\>", "Text",
 CellChangeTimes->{{3.6427709995065107`*^9, 3.6427712368301315`*^9}, 
   3.643460465528488*^9},ExpressionUUID->"2d88e969-6750-44f0-8f85-\
edf1d8224d54"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.642770831438014*^9, 
  3.642770839442828*^9}},ExpressionUUID->"da4af52b-1546-4fb1-927b-\
c00ae4d2599f"],

Cell["TensorQ exists but isn\[CloseCurlyQuote]t explained:", "Text",
 CellChangeTimes->{{3.6427712728203945`*^9, 3.642771328917894*^9}, 
   3.642771792695113*^9, 
   3.6428246324566307`*^9},ExpressionUUID->"f57661d5-69ab-422b-be9f-\
5205f19675d3"],

Cell[BoxData[
 RowBox[{"?", "TensorQ"}]], "Input",
 CellChangeTimes->{{3.642771245581747*^9, 
  3.642771249715754*^9}},ExpressionUUID->"77de84c3-8d59-4cc1-88c3-\
3c455b75cdf5"],

Cell["An object Tensor isn\[CloseCurlyQuote]t built-in:", "Text",
 CellChangeTimes->{{3.642771364070756*^9, 
  3.642771380563985*^9}},ExpressionUUID->"eaf00254-7b90-42df-a3f7-\
8f0b3ff6776e"],

Cell[BoxData[
 RowBox[{"?", "Tensor"}]], "Input",
 CellChangeTimes->{{3.6427713443619213`*^9, 
  3.6427713478895273`*^9}},ExpressionUUID->"f45fbd7b-a3a2-4c99-905f-\
d1cf8db1e884"],

Cell["\<\
Constructing a tensor with a given Array of coordinates  use the function\
\>", "Text",
 CellChangeTimes->{{3.6427715307558503`*^9, 
  3.6427715892035537`*^9}},ExpressionUUID->"1b0ecb08-285e-4cf3-ad52-\
c9643db0b033"],

Cell[BoxData[
 RowBox[{"?", "ArrayTotensor"}]], "Input",
 CellChangeTimes->{{3.642771600921174*^9, 
  3.642771607396186*^9}},ExpressionUUID->"d1081431-1a72-44e9-875e-\
632d9acf41ae"],

Cell["\<\
The type {k,h} can\[CloseCurlyQuote]t be recognized from the given Array; it \
must be required explicitly:\
\>", "Text",
 CellChangeTimes->{{3.642771689763731*^9, 3.6427717104065676`*^9}, 
   3.6427718194083605`*^9, {3.6427718738604565`*^9, 
   3.6427719528085957`*^9}},ExpressionUUID->"3a7c84eb-9929-4baa-9c3e-\
ea74c2b8a3a4"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"ArrayTotensor", "[", "cta", "]"}]}]], "Input",
 CellChangeTimes->{{3.64277196093721*^9, 
  3.642771997336074*^9}},ExpressionUUID->"14765a5c-349a-42e2-b6b5-\
64a59966ca6b"],

Cell["without naming k we get per default a contravariant tensor:", "Text",
 CellChangeTimes->{{3.6427720389639473`*^9, 3.642772089285037*^9}, 
   3.642775227993579*^9},ExpressionUUID->"7ae07cb1-9949-41cc-af5e-\
d6d072f1d277"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.642772007996893*^9, 
  3.6427720145333047`*^9}},ExpressionUUID->"e3028bae-0cd6-4903-9488-\
3179c73def41"],

Cell["To get the tensor ta back we have to define", "Text",
 CellChangeTimes->{{3.6427721055734653`*^9, 
  3.6427721227364955`*^9}},ExpressionUUID->"eb2496a3-ef21-4114-aa69-\
93f0213da33d"],

Cell[BoxData[
 RowBox[{"taa", " ", "=", " ", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"cta", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6427721266365023`*^9, 3.642772172149783*^9}, 
   3.6427729729343987`*^9},ExpressionUUID->"a94dde0e-60d0-4eb6-80ab-\
893c6ebf92f2"],

Cell["\<\
Of  course, the tensors ta and taa aren\[CloseCurlyQuote]t  confirmed to be \
equal, since they have formally different coordinate functions:\
\>", "Text",
 CellChangeTimes->{{3.6427721836822033`*^9, 
  3.642772381331352*^9}},ExpressionUUID->"e2a2d2cf-c91b-4b6f-ae52-\
5104f00c308a"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"ta", " ", "\[Equal]", "taa"}], "]"}]], "Input",
 CellChangeTimes->{{3.6427723867757616`*^9, 
  3.642772397588581*^9}},ExpressionUUID->"4406fade-fc50-49ec-8742-\
0d9e3a72b0ec"],

Cell["\<\
But they are equivalent having the same coordinates. This can be controlled \
by the function\
\>", "Text",
 CellChangeTimes->{{3.6427724150022116`*^9, 3.6427724908655453`*^9}, 
   3.642773761932191*^9},ExpressionUUID->"49831805-d143-4870-adaa-\
bcd0623ef371"],

Cell[BoxData[
 RowBox[{"?", "equi"}]], "Input",
 CellChangeTimes->{{3.6427724934707503`*^9, 
  3.6427724957795544`*^9}},ExpressionUUID->"0514aff6-6c0b-46d8-833f-\
7bace47f4122"],

Cell["defined in tensalgv2.m.", "Text",
 CellChangeTimes->{{3.642773729368933*^9, 
  3.642773743820559*^9}},ExpressionUUID->"0000e2eb-96db-491d-a1b2-\
93056a5efcf5"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"ta", ",", " ", "taa"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.64277282101293*^9, 3.642772858755397*^9}, {
  3.6447281151796765`*^9, 3.6447281182996817`*^9}, {3.6447281705521746`*^9, 
  3.6447281790229893`*^9}},ExpressionUUID->"f7cb7024-4125-4a46-ae78-\
2413e0b3ec6e"],

Cell["Clearly we get", "Text",
 CellChangeTimes->{{3.6427731256182675`*^9, 
  3.6427731314994783`*^9}},ExpressionUUID->"5482d61b-abd9-4e26-b801-\
410462d3e68d"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"ta", ",", " ", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.64277282101293*^9, 3.642772858755397*^9}, {
  3.642773088156602*^9, 3.6427730968936167`*^9}, {3.6447286280697823`*^9, 
  3.644728636665397*^9}},ExpressionUUID->"b540eb03-0a63-4495-9c7b-\
ad97c903dcc0"],

Cell["since", "Text",
 CellChangeTimes->{{3.6427731401614933`*^9, 
  3.642773142267497*^9}},ExpressionUUID->"7acaaa96-7159-46f9-9311-\
3b2935cc9fc5"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.642772897589865*^9, 3.6427729032078753`*^9}, 
   3.64277307578578*^9},ExpressionUUID->"4a2f35f0-0ec8-45c1-8c11-\
4c49a7c6a109"],

Cell["differs from", "Text",
 CellChangeTimes->{{3.6427731555129204`*^9, 
  3.6427731786185613`*^9}},ExpressionUUID->"782a3091-b8df-4587-9d07-\
843b4205f961"],

Cell[BoxData[
 RowBox[{"type", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.642773189588381*^9, 3.642773205235208*^9}, 
   3.6427738724043865`*^9},ExpressionUUID->"f2f0c9ac-fff2-42d0-96f0-\
d97509e3eff2"],

Cell["\<\
already in the covariance degree. But the corresponding Arrays coincide:\
\>", "Text",
 CellChangeTimes->{{3.642773235303461*^9, 
  3.6427732751685314`*^9}},ExpressionUUID->"95271619-5203-471c-94f4-\
40c6d2d73fdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ctb", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "tb", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6427732842633476`*^9, 3.642773313237599*^9}, 
   3.6427733629598866`*^9},ExpressionUUID->"3a094e06-d2b3-4b31-9e30-\
42e0f955d80d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"cta", "\[Equal]", "ctb"}], "]"}]], "Input",
 CellChangeTimes->{{3.642773320601812*^9, 
  3.642773332130232*^9}},ExpressionUUID->"54f31d50-02b3-40a7-a46f-\
2d3cb7c166c9"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"ta", ",", "tb", ",", "cta", ",", "ctb", ",", "taa"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6427735822834735`*^9, 
  3.642773605949715*^9}},ExpressionUUID->"9d051e8d-b01b-4ee5-9511-\
3a9cc791c983"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3..2.  Tensors of the same Type Form a Vector Space", "Subsection",
 CellChangeTimes->{{3.5559015526098194`*^9, 3.555901564013439*^9}, {
   3.5590306513273497`*^9, 3.559030672422556*^9}, {3.5596126223227377`*^9, 
   3.5596126259731445`*^9}, 3.5607696035772333`*^9, {3.563723256352163*^9, 
   3.563723258382279*^9}, 3.5637806402481623`*^9, {3.5643263046319685`*^9, 
   3.5643263415920825`*^9}, {3.6011012670146875`*^9, 3.6011013180579767`*^9}, 
   3.6011014231397614`*^9, {3.602920903920845*^9, 3.602920905534938*^9}, 
   3.6030308541344123`*^9},ExpressionUUID->"4cfbf4b9-4082-491a-9c6b-\
6a604e765e5c"],

Cell[CellGroupData[{

Cell["3.2.1. Addition of Tensors", "Subsubsection",
 CellChangeTimes->{{3.600670520444725*^9, 3.600670520741125*^9}, {
   3.6006720500898113`*^9, 3.60067208367667*^9}, 3.6006763340495977`*^9, 
   3.6006850395350266`*^9, {3.601101329570797*^9, 3.6011013350308065`*^9}, 
   3.6011013776032815`*^9, 
   3.601101437834987*^9},ExpressionUUID->"6b8db047-3f81-4252-a5ff-\
9324f2ec5ed2"],

Cell["\<\
Tensors of the same type {k,l} and the same dimension d may be added. Here is \
a tensor of the same type as \
\>", "Text",
 CellChangeTimes->{{3.6006758655778027`*^9, 3.600675930481515*^9}, 
   3.6006982982103195`*^9},ExpressionUUID->"4e02c9cc-9b59-44a0-85db-\
1ec7c678b969"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.642936095812911*^9, 
  3.6429361011637206`*^9}},ExpressionUUID->"07b9caa6-173d-40e5-820c-\
cc5ff79b0a14"],

Cell[BoxData[
 RowBox[{"ta", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "3", ",", "2", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.600698302366557*^9, 
  3.600698321459649*^9}},ExpressionUUID->"0c46118e-534b-4271-ac7d-\
169370ebaf04"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "3", ",", "2", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.568040949425522*^9, 3.56804097107836*^9}, 
   3.5705441829232416`*^9, {3.6005162318059206`*^9, 3.600516315671668*^9}, {
   3.6005163486657257`*^9, 3.600516350568929*^9}, 3.600516635331829*^9, {
   3.600660458505052*^9, 3.6006604805322905`*^9}, 3.600663110041709*^9, {
   3.6006758379962254`*^9, 
   3.6006758401153464`*^9}},ExpressionUUID->"86cffdbc-9121-40da-bba8-\
b6562ff4c52c"],

Cell["\<\
The addition of tensors corresponds to the addition of their coordinate \
functions using plus:\
\>", "Text",
 CellChangeTimes->{{3.6006762457455473`*^9, 3.6006763046329155`*^9}, {
  3.64293374953519*^9, 
  3.642933755775201*^9}},ExpressionUUID->"8102740b-1b05-4960-8bc9-\
eb6f2d980544"],

Cell[BoxData[
 RowBox[{"?", "plus"}]], "Input",
 CellChangeTimes->{{3.642933765291218*^9, 
  3.642933768426823*^9}},ExpressionUUID->"5590bb67-4e01-4c61-ba6a-\
0eeff9a42413"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", " ", 
  RowBox[{"ta", "+", "tb"}]}]], "Input",
 CellChangeTimes->{{3.642933878563017*^9, 
  3.6429338911366386`*^9}},ExpressionUUID->"37072676-2980-4076-8710-\
bf6a0b6d1554"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"ta", "-", "tb"}], " ", "\[Equal]", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"plus", "[", 
      RowBox[{"a", ",", 
       RowBox[{"-", "b"}]}], "]"}], ",", "3", ",", "2", ",", "3"}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6006759962192755`*^9, 3.600676026187989*^9}, {
   3.6006760583238273`*^9, 3.600676064540183*^9}, 3.600676095996982*^9, {
   3.600676143900722*^9, 3.6006761475159287`*^9}, {3.60075969757119*^9, 
   3.6007597143581495`*^9}, {3.6007597805429354`*^9, 
   3.6007597821910295`*^9}},ExpressionUUID->"a6a41572-f9ba-4670-adcb-\
59364b80a803"],

Cell[BoxData[
 RowBox[{
  RowBox[{"taa", " ", "=", " ", 
   RowBox[{"-", "ta"}]}], ";", 
  RowBox[{"type", "[", "taa", "]"}]}]], "Input",
 CellChangeTimes->{{3.600662827431613*^9, 3.600662865012079*^9}, 
   3.600663062820426*^9, {3.6006755769242926`*^9, 
   3.6006756190917044`*^9}},ExpressionUUID->"0645d36b-83b6-4500-95a5-\
093bcedf2e0a"],

Cell[BoxData[
 RowBox[{"ta", "+", "taa"}]], "Input",
 CellChangeTimes->{{3.6006756355056434`*^9, 
  3.6006756390808477`*^9}},ExpressionUUID->"4c8c3ab0-089a-43ea-bd5b-\
2966215f6189"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6006756665904217`*^9, 
  3.6006756967711477`*^9}},ExpressionUUID->"7230622e-622c-4bcd-a9c4-\
3d30263f8884"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"ta", "+", "taa"}], ",", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.642933989900412*^9, 3.6429340058904405`*^9}, {
  3.642934038182497*^9, 
  3.6429340404133005`*^9}},ExpressionUUID->"2d15ad99-f7da-419a-afe6-\
2c317b8945a3"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.6007607575088143`*^9},ExpressionUUID->"13526949-6934-44fc-a267-\
c28d3dcc146b"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}], "\[Equal]", " ", 
   RowBox[{"-", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6007606503726864`*^9, 
  3.6007606813744597`*^9}},ExpressionUUID->"cae5ec70-68ac-4ace-a4c0-\
b46d6a796bed"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}], ",", 
   RowBox[{"-", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.642934283648928*^9, 
  3.64293431890499*^9}},ExpressionUUID->"9a0bdd96-5e54-48b0-a02e-\
eb510ca9da99"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"tc", "-", "ta"}], "]"}]], "Input",
 CellChangeTimes->{{3.600683105934431*^9, 3.6006831134668617`*^9}, {
  3.600775644650935*^9, 
  3.6007756528565497`*^9}},ExpressionUUID->"62b37d22-15df-47fd-9ddc-\
c6614eb1abf3"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"tc", "-", "ta"}], "\[Equal]", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.600683126302596*^9, 3.6006831350620966`*^9}, {
  3.6006834593446445`*^9, 3.600683471008312*^9}, {3.6007605679169703`*^9, 
  3.60076057420533*^9}, {3.601099189418638*^9, 
  3.6010991975930524`*^9}},ExpressionUUID->"995e47ab-0a0e-4207-aef5-\
b48ea9d055c9"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"tc", "-", "ta"}], ",", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.6429341281166553`*^9, 
  3.642934151220296*^9}},ExpressionUUID->"90388af8-15a3-4080-92e3-\
47986f9244a2"],

Cell["\<\
Two tensors whose definitions differ formally may have the same coordinates \
in the same underlying coordinate system; then they can be considered as \
equal and can be identified. To test this use the function\
\>", "Text",
 CellChangeTimes->{{3.6010999044770937`*^9, 
  3.6011000430209374`*^9}},ExpressionUUID->"8450770d-f7a3-46f8-a51e-\
72cf6aaebb7f"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"ta", ",", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.6011000895558195`*^9, 
  3.601100098588235*^9}},ExpressionUUID->"e3f3bf77-876e-4dfc-b877-\
fb077b24ee37"],

Cell["\<\
OK, the program can\[CloseCurlyQuote]t decide whether a== b is valid. Now \
consider\
\>", "Text",
 CellChangeTimes->{{3.6011001676339564`*^9, 3.6011002411724854`*^9}, {
  3.601100372571516*^9, 
  3.6011003813855314`*^9}},ExpressionUUID->"a9730c89-f639-445f-9e9e-\
fd917ec32d55"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"tc", "-", "ta"}], ",", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.6010989191481633`*^9, 3.6010989350757914`*^9}, {
  3.6010989663850465`*^9, 3.6010989869926825`*^9}, {3.601099217951088*^9, 
  3.6010992187934895`*^9}},ExpressionUUID->"2b20e400-2429-416c-ad82-\
0706ad3eb613"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"tc", "-", "ta", "-", "tb"}], ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6011002561173115`*^9, 
  3.6011002936041775`*^9}},ExpressionUUID->"af8f99fb-f86c-4575-92ac-\
6092903b3983"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"ta", ",", 
   RowBox[{"ta", "+", " ", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"3", ",", "2"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6011002561173115`*^9, 3.6011002936041775`*^9}, {
  3.6429361944206843`*^9, 
  3.642936247304777*^9}},ExpressionUUID->"cc20085b-4529-4f54-aed8-\
9448770239cb"],

Cell[TextData[{
 "Summarizing we have shown\n",
 StyleBox["Lemma.",
  FontColor->RGBColor[0, 0, 1]],
 " Tensors of the same type {k,h} over the same d-dimensional vector space V \
with coordinates in the same Abelian domain form an Abelian group with the \
addition as operation; the ",
 StyleBox["neutral element",
  FontColor->RGBColor[0, 0, 1]],
 " is the nulltensor of the same type and dimension.  \[FilledRectangle]\n\n\
We denote this tensor space by ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["T", 
    RowBox[{"(", 
     RowBox[{"k", ",", "h"}], ")"}]], TraditionalForm]],ExpressionUUID->
  "978385b4-af05-42b6-8d73-f58be21a212e"],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["V", "d"], TraditionalForm]],ExpressionUUID->
  "5c845e2b-1b56-4448-b7da-1fb84739cb8e"],
 "."
}], "Text",
 CellChangeTimes->{{3.6006843792632613`*^9, 3.6006845908063607`*^9}, {
   3.600684700782651*^9, 3.600684818934409*^9}, {3.600684855271487*^9, 
   3.600684868558247*^9}, {3.6006849060143895`*^9, 3.6006849131978006`*^9}, 
   3.600698415611034*^9, 3.6011842489836044`*^9, 3.6429362992060685`*^9, {
   3.6430242103736534`*^9, 3.643024355297908*^9}, {3.643024388291966*^9, 
   3.6430244023163905`*^9}, 
   3.643461115386963*^9},ExpressionUUID->"7c792f96-2125-4f3d-a2f0-\
a03264ddb9e4"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.2. Multiplication with a Scalar", "Subsubsection",
 CellChangeTimes->{{3.600684939663314*^9, 3.600684959742463*^9}, 
   3.6006850467834415`*^9, {3.600698024937689*^9, 3.6006980257697363`*^9}, 
   3.6011013517072363`*^9, 3.6011014401125913`*^9, {3.64293633992214*^9, 
   3.6429363423557444`*^9}, 
   3.6429991326273355`*^9},ExpressionUUID->"2186cd58-dc01-4479-af8b-\
17262aad5948"],

Cell["\<\
We remember that a scalar means  a function with values in the field \
underlying the vector space or an element of this field. The multiplication \
of a tensor with a scalar can be done using * or Times. This is possible only \
after loading the package tensalgv2.m, in which the following enhancement of \
the operation Times is contained:\
\>", "Text",
 CellChangeTimes->{{3.6006913605825095`*^9, 3.6006914840815735`*^9}, {
   3.6006915264659977`*^9, 3.600691632721075*^9}, {3.6006916989938655`*^9, 
   3.600691709689477*^9}, {3.6006917544020348`*^9, 3.60069178753793*^9}, {
   3.6006947217057548`*^9, 3.600694818401285*^9}, 
   3.6425014337220182`*^9},ExpressionUUID->"5def4532-1d97-4822-af15-\
b4d01cae91f5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Times", "]"}], ";", 
  RowBox[{"Times", "/:", " ", 
   RowBox[{"Times", "[", 
    RowBox[{"x_", ",", " ", 
     RowBox[{"tensor", "[", 
      RowBox[{"a_", ",", "k_", ",", "l_", ",", 
       RowBox[{"d_:", "dimm"}]}], "]"}]}], "]"}], ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"times", "[", 
      RowBox[{"x", ",", "a"}], "]"}], ",", "k", ",", "l", ",", "d"}], "]"}]}],
   ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Times", "/:", " ", 
    RowBox[{"Times", "[", 
     RowBox[{"x_", ",", " ", 
      RowBox[{"tensor", "[", 
       RowBox[{"a_", ",", "k_", ",", "l_"}], "]"}]}], "]"}], ":=", 
    RowBox[{"tensor", "[", 
     RowBox[{
      RowBox[{"times", "[", 
       RowBox[{"x", ",", "a"}], "]"}], ",", "k", ",", "l"}], "]"}]}], ";", 
   RowBox[{"Protect", "[", "Times", "]"}], ";"}], " "}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.600694835524265*^9},ExpressionUUID->"dbc11c4a-1b87-4e1a-8992-\
4204f5be79f6"],

Cell["\<\
and a collection of rules regulate the behavior of the new function times.\
\>", "Text",
 CellChangeTimes->{{3.600694840825568*^9, 3.600694856209448*^9}, {
  3.6006949460975895`*^9, 
  3.6006949793054886`*^9}},ExpressionUUID->"d2c9dad0-789f-496c-9cf9-\
f615f2c892c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tx", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"x", ",", "3", ",", "2", ",", "3"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.600691030781646*^9, 3.600691040082178*^9}, {
  3.6006911492604227`*^9, 
  3.600691163939262*^9}},ExpressionUUID->"750d2a2c-c861-470e-bb0f-\
9a53f6d06876"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"tfx", ",", "f"}], "]"}], ";", 
  RowBox[{"tfx", " ", "=", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{"u", ",", "v"}], "]"}], "tx"}]}]}]], "Input",
 CellChangeTimes->{{3.600522886528009*^9, 3.600522935356095*^9}, {
   3.6005229701597557`*^9, 3.600522974402963*^9}, {3.6005230349778695`*^9, 
   3.600523036179072*^9}, {3.600690594165673*^9, 3.6006906216362443`*^9}, {
   3.6006907346767097`*^9, 3.6006907355157576`*^9}, 3.6006910225241737`*^9, {
   3.6006910546910133`*^9, 3.600691075899226*^9}, {3.6006911785961003`*^9, 
   3.6006912017084227`*^9}, 3.6006916538452835`*^9, {3.6006918033558345`*^9, 
   3.6006918646463404`*^9}, {3.6006919258928432`*^9, 
   3.6006919476270866`*^9}},ExpressionUUID->"8368b70f-37f7-48ec-a5c2-\
a9584e690590"],

Cell[BoxData[
 RowBox[{"type", "[", "tfx", "]"}]], "Input",
 CellChangeTimes->{{3.600690771321806*^9, 3.6006907788692374`*^9}, {
  3.6006912147881703`*^9, 
  3.6006912159952393`*^9}},ExpressionUUID->"a5b8303f-c122-4182-aac1-\
c31f84eebf2b"],

Cell[BoxData[
 RowBox[{"tfx", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6006907962332306`*^9, 3.6006908224127283`*^9}, {
  3.6006912289809823`*^9, 
  3.6006912302860565`*^9}},ExpressionUUID->"6c134893-a359-4f7e-824e-\
95e5d1fbd262"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"coords", "[", "tfx", "]"}], "==", " ", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{"u", ",", "v"}], "]"}], "*", 
    RowBox[{"coords", "[", "tx", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568040981717579*^9, 3.568040987115188*^9}, {
   3.600516440939888*^9, 3.6005164871939692`*^9}, {3.600516520437628*^9, 
   3.6005165608260984`*^9}, 3.600516713534767*^9, {3.600522983404179*^9, 
   3.600522988848589*^9}, {3.600691257901636*^9, 
   3.6006912928846374`*^9}},ExpressionUUID->"9b706cf5-c19f-413c-bd77-\
0efd38560da1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"0", "*", "tx"}], " ", "\[Equal]", " ", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6006931861219244`*^9, 3.6006932095312634`*^9}, {
  3.6006932613392267`*^9, 
  3.600693276155074*^9}},ExpressionUUID->"44e7033b-2458-47b7-ba46-\
12028835fe85"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"0", "*", "tx"}], " ", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6429986726209216`*^9, 
  3.6429986933749585`*^9}},ExpressionUUID->"69a6f3a1-8921-492d-a87d-\
7cc963eedda2"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], " ", "\[Equal]", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6006931861219244`*^9, 3.6006932095312634`*^9}, {
  3.6006932613392267`*^9, 3.6006933144602647`*^9}, {3.642998715825398*^9, 
  3.642998726063016*^9}},ExpressionUUID->"24c6cea7-4c35-422f-b4e0-\
05bf84f734ff"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2", ",", "3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6429987336290293`*^9, 
  3.6429987624482803`*^9}},ExpressionUUID->"f2c39648-d9b2-4d11-a350-\
a1811ca8036a"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"coords", "[", 
      RowBox[{"y", "*", "tx"}], " ", "]"}], "]"}], "\[Equal]", 
    RowBox[{"Flatten", "[", 
     RowBox[{"coords", "[", " ", 
      RowBox[{"nulltensor", "[", 
       RowBox[{"3", ",", "2", ",", "3"}], "]"}], "]"}], "]"}]}], ",", " ", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"coords", "[", "tx", "]"}]}], "}"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6006927454707203`*^9, 3.6006929127322874`*^9}, {
   3.6006930081207433`*^9, 3.6006930615648003`*^9}, {3.600693096390792*^9, 
   3.600693109149522*^9}, 3.642998850856037*^9, {3.642998889035705*^9, 
   3.642998893575313*^9}, {3.642998961009632*^9, 3.6429989656000404`*^9}, {
   3.6429990297437534`*^9, 
   3.6429990645690155`*^9}},ExpressionUUID->"29b058f1-497b-4c55-bae6-\
7f3aad1a9fac"],

Cell[TextData[{
 "It follows\n",
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 ". The set of all tensors of type {k,l} over a vector space of dimension d \
with coordinates from the base field is a vector space of dimension ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["d", 
    RowBox[{"k", "+", "l"}]], TraditionalForm]],ExpressionUUID->
  "377a0ae5-4269-48e6-9aaf-83bb1602ffdd"],
 " over  this field with the above defined operations of addition and \
multiplication with scalars.\n\n",
 StyleBox["Proof",
  FontColor->RGBColor[0, 0, 1]],
 ". We have seen that the operations are accomplished coordinate wise as in \
the case of a standard vector space. The dimension  equals the number of ",
 "coordinate",
 "s, namely the stated ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["d", 
    RowBox[{"k", "+", "l"}]], TraditionalForm]],ExpressionUUID->
  "4c494345-4acf-4963-b27d-5ab2c592e8f1"],
 ".\nIn our case"
}], "Text",
 CellChangeTimes->{{3.600694600545825*^9, 3.6006946043290415`*^9}, {
   3.6006950948890996`*^9, 3.600695218737183*^9}, {3.6006953002978487`*^9, 
   3.600695441697936*^9}, {3.600695497858148*^9, 3.600695575153569*^9}, {
   3.600695737217839*^9, 3.6006957870416884`*^9}, {3.6006974552581053`*^9, 
   3.600697644177911*^9}, {3.6006978408181577`*^9, 3.6006978590101986`*^9}, {
   3.6011842499976063`*^9, 3.6011842519008093`*^9}, 
   3.6011843696342163`*^9},ExpressionUUID->"d7501b7b-b940-475e-aabd-\
295fde748679"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Length", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{"coords", "[", "tx", "]"}], "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"3", "^", 
   RowBox[{"(", 
    RowBox[{"3", "+", "2"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.600697659499787*^9, 3.6006977154759884`*^9}, {
  3.6006977481168556`*^9, 
  3.6006977658598704`*^9}},ExpressionUUID->"9f0a0f72-277a-4196-94e5-\
1e0d5f0e5afd"],

Cell[BoxData[
 RowBox[{"3", "^", 
  RowBox[{"(", 
   RowBox[{"3", "+", "2"}], ")"}]}]], "Input",ExpressionUUID->"4e6e6285-0fbf-\
4554-83ff-99edf358a478"],

Cell["\[FilledRectangle]", "Text",
 CellChangeTimes->{{3.6006979016236353`*^9, 
  3.600697901630636*^9}},ExpressionUUID->"9188a903-8ec5-4547-8abd-\
55107655a9f3"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.3. Tensor Basis", "Subsubsection",
 CellChangeTimes->{{3.563014548687614*^9, 3.5630145723179655`*^9}, {
   3.563031221411569*^9, 3.563031243470008*^9}, {3.5637829351752615`*^9, 
   3.5637829369093604`*^9}, 3.567091344165166*^9, 3.567091554000168*^9, {
   3.567092428759201*^9, 3.5670924303912945`*^9}, 3.5671628316482916`*^9, {
   3.601101125584839*^9, 3.601101127410042*^9}, 3.601101159156098*^9, {
   3.6011013577756467`*^9, 3.601101383468892*^9}, 3.601101442171795*^9, 
   3.642999142611353*^9, 
   3.6430006866822987`*^9},ExpressionUUID->"78c6c37d-864f-4ec5-91a8-\
cb90ac6f23d8"],

Cell[TextData[{
 "Now we will construct a tensor basis in the space of tensors of type (k, h) \
on a vector space of dimension dim over a field. To this aim we introduce an \
auxiliary function of four groups of variables, called ",
 StyleBox["double test",
  FontColor->RGBColor[0, 0, 1]],
 " and named cc:"
}], "Text",
 CellChangeTimes->{{3.5618188569952908`*^9, 3.561818878601328*^9}, {
   3.561818921298603*^9, 3.561819146625399*^9}, {3.5618712759094915`*^9, 
   3.561871286033909*^9}, {3.5635971511221385`*^9, 3.563597164148162*^9}, {
   3.5635972370314894`*^9, 3.5635972587779274`*^9}, 3.5675071917159452`*^9, 
   3.642999167840597*^9},ExpressionUUID->"37203bee-7962-4740-aef1-\
9f7bd2729bb3"],

Cell[BoxData[
 RowBox[{"?", "cc"}]], "Input",
 CellChangeTimes->{{3.5618191599634223`*^9, 3.561819183987465*^9}, 
   3.5635977316771584`*^9, 
   3.563597820706515*^9},ExpressionUUID->"a8f7ee08-adda-4ded-b777-\
a879ae861ed2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cc", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], "[", 
   RowBox[{"k_", ",", "l_"}], "]"}], ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"i", "\[Equal]", "k"}], ")"}], "&&", " ", 
     RowBox[{"(", 
      RowBox[{"j", "\[Equal]", "l"}], ")"}]}], ",", "1", ",", "0", ",", "0"}],
    "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.563078272938415*^9, 3.563078357365763*^9}, {
  3.5630793184334517`*^9, 3.56307932908827*^9}, {3.5671617611160603`*^9, 
  3.567161781708238*^9}},ExpressionUUID->"102d0915-d745-4700-ab13-\
0941dba654c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cc", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5618167061259127`*^9, 3.5618167442679796`*^9}, 
   3.561817048686914*^9, {3.563078375945396*^9, 3.5630784353971004`*^9}, {
   3.5630854479602575`*^9, 3.563085458410855*^9}, {3.567092511577938*^9, 
   3.5670925184743323`*^9}},ExpressionUUID->"775bef45-0a0f-497b-85f9-\
194a6f5bf12c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cc", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5618167061259127`*^9, 3.5618167442679796`*^9}, 
   3.561817048686914*^9, {3.563078375945396*^9, 3.563078461835947*^9}, {
   3.563085475938857*^9, 3.5630854864024563`*^9}, {3.5670925289059286`*^9, 
   3.56709253748942*^9}},ExpressionUUID->"0bcaea44-7a00-48cf-bcbb-\
cf443318c603"],

Cell["Now the standard basis consists of the tensors ", "Text",
 CellChangeTimes->{{3.5618210086290693`*^9, 
  3.561821032918312*^9}},ExpressionUUID->"22d7a354-4f3c-4f23-be06-\
f8fbfd436e95"],

Cell[BoxData[
 RowBox[{"?", "tstb"}]], "Input",
 CellChangeTimes->{{3.5618212602887115`*^9, 3.5618212623947153`*^9}, 
   3.561871117943614*^9, 3.563597919813489*^9, 
   3.563605390685734*^9},ExpressionUUID->"07cab35a-5654-45c0-9b98-\
97ab5405c174"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tstb", "[", 
   RowBox[{"i_", ",", "j_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"cc", "[", "i", "]"}], "[", "j", "]"}], ",", 
    RowBox[{"Length", "[", "i", "]"}], ",", 
    RowBox[{"Length", "[", "j", "]"}], ",", "d"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.561817131101859*^9, 3.5618172687409005`*^9}, 
   3.561871117959214*^9, 3.5626763669651585`*^9, 3.5626766521336594`*^9, 
   3.562683756187258*^9, {3.5630781877154655`*^9, 3.563078205608697*^9}, 
   3.5630786012065916`*^9, {3.563078663747102*^9, 3.5630787114831853`*^9}, {
   3.5630787427924404`*^9, 3.5630787789065037`*^9}, {3.5630793513963094`*^9, 
   3.5630793521763105`*^9}, {3.567315114822649*^9, 
   3.5673151327916765`*^9}},ExpressionUUID->"9aa95b6d-5fc4-4a6e-aa0b-\
9a6dac970a4d"],

Cell["\<\
where i runs over the k - Tuples and j over the h - Tuples of indices.\
\>", "Text",
 CellChangeTimes->{{3.561821058377557*^9, 3.561821172912958*^9}, {
  3.5636053573796754`*^9, 3.563605381731318*^9}, {3.5671620612822285`*^9, 
  3.5671621000644474`*^9}},ExpressionUUID->"528ffaa8-4719-47c6-9aea-\
e3cbbc8f43a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.5673153232385693`*^9, 
  3.5673153330331297`*^9}},ExpressionUUID->"e800c84a-3f8f-485b-98ea-\
8788a0c41f09"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"tstb", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563077533699917*^9, 3.563077577255193*^9}, {
  3.5630787972833357`*^9, 
  3.563078828686191*^9}},ExpressionUUID->"247dc143-2f71-441e-9727-\
b8d7635c8f07"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.5630776082680473`*^9, 
  3.5630776245544763`*^9}},ExpressionUUID->"d35159d9-14db-4860-9fe9-\
1711cb7f15a3"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.601108898817158*^9, 3.6011089052911696`*^9}, {
  3.6429993001684313`*^9, 
  3.6429993096220474`*^9}},ExpressionUUID->"274bc9fc-ba97-44ad-8095-\
b33e34dccee8"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5630776650053473`*^9, 3.563077727935858*^9}, {
   3.5630777651107235`*^9, 3.5630777924419713`*^9}, {3.5630788669218583`*^9, 
   3.563078889261098*^9}, {3.5630789567312164`*^9, 3.5630789573864174`*^9}, 
   3.5630792383741107`*^9},ExpressionUUID->"e9a8b219-6042-4cd1-9d96-\
c1736a9dbe06"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5630776650053473`*^9, 3.563077727935858*^9}, {
   3.5630777651107235`*^9, 3.5630777924419713`*^9}, {3.5630788669218583`*^9, 
   3.563078889261098*^9}, {3.5630789567312164`*^9, 3.5630789573864174`*^9}, 
   3.5630792383741107`*^9, {3.563079448038479*^9, 
   3.5630794555420923`*^9}},ExpressionUUID->"09d1c4cc-ea8c-43fe-b768-\
e9409ecbda88"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5630776650053473`*^9, 3.563077727935858*^9}, {
   3.5630777651107235`*^9, 3.5630777924419713`*^9}, {3.5630788669218583`*^9, 
   3.563078889261098*^9}, {3.5630789567312164`*^9, 3.5630789573864174`*^9}, 
   3.5630792383741107`*^9, {3.563079448038479*^9, 
   3.563079467959714*^9}},ExpressionUUID->"fd8d9cdc-75e1-4e34-80a4-\
193e41d6c9e1"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "2", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5618176844036307`*^9, 3.561817751514949*^9}, {
  3.603028982105338*^9, 
  3.60302901342513*^9}},ExpressionUUID->"786f5a30-3865-439d-980a-\
8370aad7bc58"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5630809263906755`*^9, 3.5630809333326883`*^9}, 
   3.567315454036051*^9},ExpressionUUID->"426d9e49-71c4-405d-b8e9-\
1a0cbe7d1496"],

Cell["\<\
A coordinate decomposition of the tensor ta with respect to the standard \
tensor basis tstb is defined by\
\>", "Text",
 CellChangeTimes->{{3.5673168168359985`*^9, 
  3.567316896023528*^9}},ExpressionUUID->"3b0cc5dc-5647-4594-b3b9-\
87e1fc2fafd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "taa", "]"}], ";", 
  RowBox[{"taa", " ", ":=", "   ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ta", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "j"}], "}"}], ",", 
        RowBox[{"{", "k", "}"}]}], "]"}], "*", 
      RowBox[{"tstb", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "j"}], "}"}], ",", 
        RowBox[{"{", "k", "}"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "dim"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.561793906233004*^9, 3.5617940919825306`*^9}, {
   3.5617942234751616`*^9, 3.56179423406758*^9}, 3.561794283753667*^9, 
   3.561794349538983*^9, 3.561871118006014*^9, {3.5630796344120064`*^9, 
   3.5630797351725836`*^9}, 3.5630797689154425`*^9, 3.563079827165945*^9, {
   3.5630798764464316`*^9, 3.563079889113654*^9}, {3.5630802527658925`*^9, 
   3.5630802887551556`*^9}, {3.563598662873994*^9, 3.5635986920616455`*^9}, {
   3.563598749875347*^9, 3.563598766660976*^9}, {3.5635990630458965`*^9, 
   3.5635990964143553`*^9}, {3.5635993118819337`*^9, 
   3.5635993220999517`*^9}, {3.563599357621214*^9, 3.563599365624028*^9}, {
   3.563599503996271*^9, 3.5635995428091393`*^9}, {3.5636003495333567`*^9, 
   3.5636003583785715`*^9}, {3.5636044867265463`*^9, 3.563604489409751*^9}, {
   3.566737354564108*^9, 3.566737368791333*^9}, 3.566737447571471*^9, {
   3.567162289169263*^9, 3.567162318628948*^9}},
 CellTags->"bpr",ExpressionUUID->"38b2354f-8f91-4f36-95fd-eafc0167c064"],

Cell[BoxData["taa"], "Input",
 CellChangeTimes->{{3.5630797956226892`*^9, 3.5630798009734993`*^9}, {
   3.563079841814371*^9, 3.563079871376423*^9}, {3.5630799207817097`*^9, 
   3.563079939205342*^9}, 3.563080978182767*^9, {3.5673169297234554`*^9, 
   3.567316933876693*^9}},ExpressionUUID->"64956dbe-cff8-4dce-ae74-\
99792ecdb3c5"],

Cell["\<\
The difference of taa and ta  is not evaluated to yield the nulltensor\
\>", "Text",
 CellChangeTimes->{{3.5636043646563315`*^9, 3.5636043998499937`*^9}, {
   3.567497968149324*^9, 3.5674979732136135`*^9}, 
   3.5674991577813673`*^9},ExpressionUUID->"6a2abd14-1c16-42ba-8cfa-\
5c915741c645"],

Cell[BoxData[
 RowBox[{"tadiff", "=", 
  RowBox[{"ta", "-", "taa"}]}]], "Input",
 CellChangeTimes->{{3.5630810219876437`*^9, 3.5630810258876505`*^9}, {
   3.5667172143397527`*^9, 3.5667172203613634`*^9}, 3.5667338200359*^9, 
   3.6011091603828173`*^9},ExpressionUUID->"45fb3260-aea0-4bd4-b808-\
22794a7d187d"],

Cell["The logical, but not formal equality is not confirmed:", "Text",
 CellChangeTimes->{{3.567507529668275*^9, 
  3.5675075716926785`*^9}},ExpressionUUID->"9ac1134f-93f2-4067-8468-\
6c75e789d7a4"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"taa", "\[Equal]", " ", "ta"}], "]"}]], "Input",
 CellChangeTimes->{{3.563085932605977*^9, 
  3.5630859645418043`*^9}},ExpressionUUID->"f7c5a274-d2ff-4c70-9e9c-\
ab6deeb7651f"],

Cell["\<\
The equality of the difference to the nulltensor is not recognized:\
\>", "Text",
 CellChangeTimes->{{3.5636041794372063`*^9, 
  3.563604258466945*^9}},ExpressionUUID->"dd495b39-cb6f-4aa4-ad39-\
97a7153374f2"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"taa", "-", "ta"}], "]"}]], "Input",
 CellChangeTimes->{{3.5630800978108206`*^9, 
  3.563080107950838*^9}},ExpressionUUID->"dcd2ad26-482e-4a13-9732-\
dde02749bc5f"],

Cell["\<\
The identity of the tensors ta,taa is confirmed by the function equi:\
\>", "Text",
 CellChangeTimes->{{3.6011092383673544`*^9, 
  3.6011092761350207`*^9}},ExpressionUUID->"97f5c71a-b26c-4e57-b0f8-\
92ad88b718c3"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"taa", ",", "ta"}], "]"}]], "Input",
 CellChangeTimes->{{3.6011091111179314`*^9, 
  3.601109118559144*^9}},ExpressionUUID->"d9a87bb4-c633-4b76-ac88-\
f4e5cf119d0f"],

Cell[BoxData[
 RowBox[{"?", "tensorbasis"}]], "Input",
 CellChangeTimes->{{3.5673218352310343`*^9, 
  3.567321839969305*^9}},ExpressionUUID->"97070e36-18bd-45d1-9efa-\
79467989c3a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tensorbasis", "[", 
   RowBox[{"bb_", ",", "k_", ",", "h_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{"rk", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"Range", "[", "d", "]"}], ",", "k"}], "]"}]}], ",", 
      RowBox[{"rh", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"Range", "[", "d", "]"}], ",", "h"}], "]"}]}], ",", "i", ",",
       "j"}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"bb", "[", 
        RowBox[{
         RowBox[{"rk", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"rh", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"d", "^", "k"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{"d", "^", "h"}]}], "}"}]}], "]"}], "]"}]}], "]"}]}]], "Input",\

 Evaluatable->False,
 CellChangeTimes->{{3.567318913416916*^9, 3.5673189640928144`*^9}, {
   3.567320020591243*^9, 3.5673200426305037`*^9}, {3.567320094239455*^9, 
   3.567320148740573*^9}, {3.5673202229208155`*^9, 3.567320280757124*^9}, {
   3.5673203559304233`*^9, 3.5673203896833534`*^9}, {3.5673204204481134`*^9, 
   3.567320425767418*^9}, {3.5673204562861633`*^9, 3.567320556119873*^9}, 
   3.567320677463814*^9, {3.5673247746521597`*^9, 3.567324775272195*^9}, {
   3.5673250010091066`*^9, 3.567325017394044*^9}, {3.567325148931567*^9, 
   3.5673251601602097`*^9}, {3.5673259214347515`*^9, 3.567325925861005*^9}, {
   3.5673260893393555`*^9, 3.567326101542053*^9}, {3.602921813793887*^9, 
   3.6029218254665546`*^9}},ExpressionUUID->"414983b6-9777-4f10-9fc5-\
7e1a14c12400"],

Cell[BoxData[
 RowBox[{"baa", "=", 
  RowBox[{"tensorbasis", "[", 
   RowBox[{"tstb", ",", "2", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5673205706557045`*^9, 3.567320600346403*^9}, {
   3.567320717153084*^9, 3.567320756691345*^9}, 3.5673248001216164`*^9, {
   3.5673250368611574`*^9, 3.5673250382502365`*^9}, {3.5673252302692194`*^9, 
   3.5673252340164337`*^9}, {3.603022953279667*^9, 3.6030229554787927`*^9}, 
   3.6030294710333033`*^9},ExpressionUUID->"322fc245-e1fa-455c-bb99-\
6d0181057488"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"tensorbasis", "[", 
   RowBox[{"tstb", ",", "2", ",", "1", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6030227433816614`*^9, 3.6030228168148613`*^9}, {
   3.603022966214407*^9, 3.6030229676954913`*^9}, {3.6430002491389246`*^9, 
   3.6430002794245777`*^9}, 
   3.6430003474098983`*^9},ExpressionUUID->"62f07f9f-53df-43f0-85e1-\
7ade907b09ea"],

Cell[BoxData[
 RowBox[{"type", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.643000424909636*^9, 
  3.6430004329612503`*^9}},ExpressionUUID->"55e4d82d-df20-40f8-a578-\
b3c7de2acefe"],

Cell[BoxData[
 RowBox[{"Length", "[", "\[IndentingNewLine]", 
  RowBox[{"Flatten", "[", 
   RowBox[{"coords", "[", "ta", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6030293454881225`*^9, 3.603029348776311*^9}, {
  3.603029379809086*^9, 
  3.603029383992325*^9}},ExpressionUUID->"1be04785-7bc6-458f-a0dc-\
3789f0bc1f72"],

Cell[BoxData[
 RowBox[{"Length", "[", "baa", "]"}]], "Input",
 CellChangeTimes->{{3.6030294048585186`*^9, 
  3.6030294144670677`*^9}},ExpressionUUID->"518481f1-8ae7-45e1-82d1-\
ec9131dc7035"],

Cell["The next simplification is confirmed", "Text",
 CellChangeTimes->{{3.601109587667568*^9, 3.6011096090552053`*^9}, 
   3.6430006300451984`*^9, 
   3.6434611442666135`*^9},ExpressionUUID->"b967945c-2a47-43be-81a1-\
be5718e35aeb"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"coords", "[", "ta", "]"}], "]"}], ".", "baa"}], "\[Equal]", 
   "taa"}], "]"}]], "Input",
 CellChangeTimes->{{3.567320765529851*^9, 3.5673207792966385`*^9}, 
   3.5673248136433897`*^9, {3.5673263224956913`*^9, 3.5673263250298357`*^9}, 
   3.567498267271433*^9, {3.6011094302164917`*^9, 3.6011094427745132`*^9}, {
   3.601109503021819*^9, 3.601109511991835*^9}, {3.6030288376970787`*^9, 
   3.603028865648677*^9}, {3.643000606779557*^9, 
   3.643000610071163*^9}},ExpressionUUID->"a2f6a858-87b2-4192-926e-\
72e78dc8cc22"],

Cell["and equi confirms the identity of the coordinates:", "Text",
 CellChangeTimes->{{3.6011096193200235`*^9, 3.6011096434220657`*^9}, {
   3.64300063639441*^9, 3.6430006374084115`*^9}, 
   3.643461226707159*^9},ExpressionUUID->"4828280c-66b8-4b38-a281-\
4784d9e13a6e"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"taa", ",", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"coords", "[", "ta", "]"}], "]"}], ".", "baa"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6011095266402607`*^9, 
  3.601109552801507*^9}},ExpressionUUID->"5badf96a-fb53-4609-84e2-\
ca069323641e"],

Cell[BoxData[
 RowBox[{"taa", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5673223609001007`*^9, 
  3.5673223866835756`*^9}},ExpressionUUID->"dfaadb2d-6b3f-4026-9cde-\
e50b0319d583"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.4. Traditional Notation", "Subsubsection",
 CellChangeTimes->{{3.562308002583559*^9, 3.5623080519633837`*^9}, 
   3.564120555198907*^9, {3.564129530297101*^9, 3.564129531997504*^9}, {
   3.5643267153044577`*^9, 3.5643267396398497`*^9}, 3.564326812536019*^9, 
   3.564395814501384*^9, {3.564469273171112*^9, 3.5644692766031184`*^9}, {
   3.5670924376397085`*^9, 3.56709244116691*^9}, 3.5671513892966523`*^9, {
   3.5671522429304776`*^9, 3.5671522446645765`*^9}, 3.567161146511907*^9, {
   3.5681977949625616`*^9, 3.568197808035384*^9}, {3.601110392160981*^9, 
   3.601110393892584*^9}, {3.6011159997553263`*^9, 3.6011160079609404`*^9}, 
   3.6430006934059105`*^9, 
   3.643005480069233*^9},ExpressionUUID->"5f327f55-bbfa-4083-89fd-\
d1a7542547b1"],

Cell["\<\
In tensor algebra a very simple, but effective notation for the coordinate \
transformation is used: covariant indices are written below as Subscripts, \
and contravariant indices as Superscripts of the coordinate functions. \
\>", "Text",
 CellChangeTimes->{{3.562217818730462*^9, 3.5622178760987434`*^9}, {
   3.5622179074505367`*^9, 3.5622180377789907`*^9}, {3.562218506165781*^9, 
   3.5622185332273293`*^9}, 3.5622186686770763`*^9, 3.56230024110531*^9, 
   3.5623006954312963`*^9, {3.564202446557588*^9, 3.5642025140589066`*^9}, 
   3.5643862007540817`*^9, {3.564469304199567*^9, 3.5644693101275773`*^9}, {
   3.60292202888719*^9, 
   3.602922042334959*^9}},ExpressionUUID->"4001036d-109b-43dd-a716-\
a39225041e53"],

Cell[TextData[{
 "One may enter expressions as  ",
 Cell[BoxData[
  SuperscriptBox[
   SubscriptBox["a", 
    RowBox[{"i2", " ", "j3"}]], 
   RowBox[{"j1", " ", "j2", " ", "j3"}]]],
  CellChangeTimes->{{3.5640659438642206`*^9, 3.564066006981931*^9}, {
   3.564066038852787*^9, 3.5640660448119974`*^9}, {3.564066087134872*^9, 
   3.5640661375073605`*^9}},ExpressionUUID->
  "76097ed2-c8da-4c40-9147-3611b54d0616"],
 " using the method found under"
}], "Text",
 CellChangeTimes->{{3.5640661940418596`*^9, 3.5640662375971365`*^9}, {
  3.5640662805128117`*^9, 3.5640662913236303`*^9}, {3.564396815197621*^9, 
  3.5643968403730607`*^9}},ExpressionUUID->"dbff3435-225b-4658-ac32-\
7f5da061aa2d"],

Cell[BoxData[
 RowBox[{"?", "Subsuperscript"}]], "Input",
 CellChangeTimes->{{3.5640663002624464`*^9, 
  3.5640663383421135`*^9}},ExpressionUUID->"b7b0239d-86b6-4297-9ddc-\
5e32a70e7152"],

Cell["click on >> and see the Details. ", "Text",
 CellChangeTimes->{{3.564066361164953*^9, 3.5640664424722958`*^9}, 
   3.5643964681087685`*^9, 
   3.6434612308723664`*^9},ExpressionUUID->"edf6ee35-2d96-4e01-b8d4-\
c87f82da08aa"],

Cell[TextData[StyleBox["Example.",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.564387697138468*^9, 3.564387709461173*^9}, 
   3.564387761637157*^9},ExpressionUUID->"d835274c-12ab-4d0b-8404-\
533b3a550284"],

Cell[BoxData["dim"], "Input",
 CellChangeTimes->{{3.6030296703817053`*^9, 
  3.603029671442766*^9}},ExpressionUUID->"97048213-7b26-46a5-8136-\
8c0371fcc4bf"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "2", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5643877833213973`*^9, 
  3.564387821150561*^9}},ExpressionUUID->"3ccd3bc0-6203-44a2-81c4-\
f4bfcec13ebc"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5643878433588314`*^9, 
  3.5643878842631707`*^9}},ExpressionUUID->"2edf89b0-0b24-4b4b-a521-\
f94fc97b0b03"],

Cell["The following direct setting leads to errors:", "Text",
 CellChangeTimes->{{3.5643958942689466`*^9, 
  3.564395913157027*^9}},ExpressionUUID->"05867481-dc13-4bb6-879c-\
d02921aa90c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "/.", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", "j_"}], "}"}], ",", 
     RowBox[{"{", "k_", "}"}]}], "]"}], "\[Rule]", " ", 
   SuperscriptBox[
    SubscriptBox["a", 
     RowBox[{"i", " ", "j"}]], "k"]}]}]], "Input",
 CellChangeTimes->{{3.564387914741914*^9, 3.564387935318091*^9}, {
   3.564387967615938*^9, 3.5643880488475847`*^9}, 3.5670882461939716`*^9, 
   3.600527527115548*^9, {3.602922134937255*^9, 
   3.6029221370013733`*^9}},ExpressionUUID->"6768af3e-d319-4f69-841e-\
4af98168d522"],

Cell[BoxData[
 RowBox[{"Subsuperscript", "[", 
  RowBox[{"a", ",", 
   RowBox[{"i", " ", "j"}], ",", 
   RowBox[{"k", " ", "h"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6430016300610847`*^9, 3.643001683362779*^9}, {
   3.6430020193995724`*^9, 3.6430020242531815`*^9}, 
   3.643002084855688*^9},ExpressionUUID->"9e424965-a33f-4c18-8605-\
3dad01936037"],

Cell["The order of the indices has been changed!", "Text",
 CellChangeTimes->{{3.6430021920648785`*^9, 
  3.6430022190267267`*^9}},ExpressionUUID->"9baaea62-5bbe-4d81-9d34-\
7575bd60e576"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Subsuperscript", "[", 
   RowBox[{"a", ",", 
    RowBox[{"i", " ", "j"}], ",", 
    RowBox[{"k", " ", "h"}]}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"i", "\[Rule]", "2"}], ",", 
    RowBox[{"j", "\[Rule]", "3"}], ",", 
    RowBox[{"k", "->", "2"}], ",", 
    RowBox[{"h", "\[Rule]", "3"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.6430016300610847`*^9, 3.643001683362779*^9}, {
  3.643001881672129*^9, 3.643001931493017*^9}, {3.6430020361580024`*^9, 
  3.643002048452824*^9}, {3.643002109523332*^9, 
  3.643002154728013*^9}},ExpressionUUID->"ecb7391a-81f0-44ea-81f2-\
d5d9ae964137"],

Cell["The  indices 2, 3  are multiplied.", "Text",
 CellChangeTimes->{{3.564388248188986*^9, 3.5643882648049364`*^9}, {
   3.564388309676503*^9, 3.5643883503808312`*^9}, {3.6030166209814796`*^9, 
   3.603016635564314*^9}, 3.6030166994529686`*^9, {3.6430022367503576`*^9, 
   3.643002265816209*^9}},ExpressionUUID->"f37fc9f9-2f80-429b-8fb8-\
9744841f2018"],

Cell[TextData[{
 "Unfortunately,  the ambiguity in the mathematical use of superscript as \
indices, and, at the same time, as powers, doesn\[CloseCurlyQuote]t admit the \
use  of superscript indices for symbolic calculations.  This problem \
encountered already  other authors, see the following quotation from the \
notebook cartan.nb from \[OpenCurlyDoubleQuote]Tensors in Physics\
\[CloseCurlyDoubleQuote] of ",
 ButtonBox["Harald H. Soleng",
  BaseStyle->"Hyperlink",
  ButtonData->"Soleng"],
 ", in which many special applications of tensors in physics may be found. \n\
\n",
 StyleBox["Quotation",
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],
 StyleBox[":",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.5643862260105257`*^9, 3.564386257460181*^9}, {
   3.564386344628109*^9, 3.5643864422686934`*^9}, {3.564386550486883*^9, 
   3.564386560028429*^9}, 3.5643865993246765`*^9, 3.5643866423811393`*^9, {
   3.5643867175964413`*^9, 3.5643867398767157`*^9}, {3.564387078925108*^9, 
   3.564387142716757*^9}, {3.564387199044978*^9, 3.564387209452574*^9}, {
   3.564387252589041*^9, 3.5643872819807224`*^9}, {3.5643873256612206`*^9, 
   3.5643873331806507`*^9}, {3.5643873685486736`*^9, 
   3.5643874197646027`*^9}, {3.5643883978695474`*^9, 3.5643883996046467`*^9}, 
   3.5643885147652335`*^9, {3.5643885552045465`*^9, 3.564388583341156*^9}, {
   3.5643959522942657`*^9, 3.564395953717347*^9}, {3.564395996741808*^9, 
   3.5643960070693984`*^9}, 
   3.567160841496461*^9},ExpressionUUID->"706ed78d-93a0-4a23-a689-\
99dc4ab6612c"],

Cell[TextData[{
 StyleBox[" Also in this program the Subsuperscript form of the tensor ",
  FontSlant->"Italic"],
 "coordinate",
 StyleBox["s may not be applied for symbolic calculations:",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.5623040771746006`*^9, 3.5623041383100977`*^9}, 
   3.601184371085019*^9},ExpressionUUID->"40da75cc-2717-4f01-a4c8-\
4d86fac6df36"],

Cell[CellGroupData[{

Cell[BoxData["SWeylInvariant"], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5623038358007946`*^9, 
  3.5623038613202543`*^9}},ExpressionUUID->"9603f165-bc15-41e2-8990-\
310b7b0e500c"],

Cell[CellGroupData[{

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.5623038625973277`*^9},ExpressionUUID->"3d956798-99f4-4501-94e0-\
937c4555f845"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\"\>", "\[InvisibleSpace]", 
   TemplateBox[{"\"C\"","\"ijkl\""},
    "Superscript"], "\[InvisibleSpace]", 
   SubscriptBox["\<\"C\"\>", "\<\"ijkl\"\>"], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["", 
   Superscript["C", "ijkl"], 
   Subscript["C", "ijkl"], " = ", 0],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5623038625993276`*^9},ExpressionUUID->"8958507c-c5ad-4d72-94d2-\
434f39feff58"]
}, Closed]]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     TemplateBox[{"\"C\"","\"ijkl\""},
      "Superscript"], "\[InvisibleSpace]", 
     SubscriptBox["\"\<C\>\"", "\"\<ijkl\>\""], "\[InvisibleSpace]", 
     "\"\< \>\""}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.562303969682452*^9, 3.5623039798390336`*^9}, {
  3.5623040186822553`*^9, 
  3.5623040398274646`*^9}},ExpressionUUID->"4186bd63-136a-4754-95ec-\
3cdc3cd2158e"],

Cell[TextData[StyleBox["End of the quotation.",
 FontSlant->"Italic",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{{3.562217818730462*^9, 3.5622178760987434`*^9}, {
   3.5622179074505367`*^9, 3.5622180377789907`*^9}, {3.562218506165781*^9, 
   3.5622185332273293`*^9}, 3.5622186686770763`*^9, 3.56230024110531*^9, 
   3.5623006954312963`*^9, {3.564202446557588*^9, 3.5642025140589066`*^9}, 
   3.5643862007540817`*^9, {3.564387430644225*^9, 3.5643874411248245`*^9}, 
   3.564388605140403*^9},ExpressionUUID->"6c8653be-ac37-441d-9dea-\
d830b60790c1"],

Cell[TextData[{
 "The problem of introducing the traditional  sub- superscript notation of \
tensor coordinates is discussed in Section 5 of the notebook [",
 ButtonBox["OpF",
  BaseStyle->"Hyperlink",
  ButtonData->"OpF"],
 "]. In the following we use this notation for a simple conceptual \
description of tensor operations, and for the adaption to the standard \
notation in differential geometry and relativity theory only.  To obtain \
expressions  calculable in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " one has to use the notation introduced in the definition of tensor[....].\n\
To get the  transition from the input form to the traditional form of the \
tensor coordinates and vice versa  two simple functions defined in \
tensalgv2.m are useful, tradf and mathff:"
}], "Text",
 CellChangeTimes->{{3.5623093399150505`*^9, 3.562309360787244*^9}, {
   3.5623094636121254`*^9, 3.562309474259734*^9}, {3.564395569709383*^9, 
   3.5643955882054405`*^9}, {3.5643956590294914`*^9, 
   3.5643956954855766`*^9}, {3.567160457769513*^9, 3.5671605709289856`*^9}, {
   3.567160646464306*^9, 3.5671606606091146`*^9}, {3.567160696681178*^9, 
   3.5671607236967235`*^9}, {3.567161226784498*^9, 3.567161258472311*^9}, {
   3.567161314270502*^9, 3.567161314280503*^9}, {3.5674930510780835`*^9, 
   3.567493055693348*^9}, {3.5674930933515015`*^9, 3.5674931052931843`*^9}, {
   3.5680380773512774`*^9, 3.5680380940745068`*^9}, {3.6011843726294217`*^9, 
   3.6011843752346263`*^9}, 3.603016899756425*^9, {3.60301858560485*^9, 
   3.603018598580592*^9}, 3.6425014338000183`*^9, 
   3.6434612576460133`*^9},ExpressionUUID->"e352d629-f1d2-456c-ab92-\
6e2c60dd2a77"],

Cell[BoxData[
 RowBox[{"?", "tradf"}]], "Input",
 CellChangeTimes->{{3.5674938941163025`*^9, 3.5674938975524993`*^9}, 
   3.6030169092379675`*^9, 
   3.603016950750342*^9},ExpressionUUID->"40bca598-f9db-4506-bcc3-\
d8b1f2a40f45"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"a", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.567584297563057*^9, 3.567584304239869*^9}, 
   3.600528721391246*^9},ExpressionUUID->"4aa35f3e-fabc-4c94-b770-\
2ba57940e9c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tradf", "[", "x___", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xx", "=", 
       RowBox[{"{", "x", "}"}]}], ",", "zz", ",", "i", ",", "j", ",", "a"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "xx", "]"}], " ", "\[Equal]", "  ", "0"}], ",", 
       RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Head", "[", "x", "]"}], "===", "Symbol"}], ")"}], "||", 
        " ", 
        RowBox[{"NumberQ", "[", "x", "]"}]}], ",", " ", 
       RowBox[{"Return", "[", "x", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"zz", "=", 
      RowBox[{"Cases", "[", 
       RowBox[{"xx", ",", 
        RowBox[{"a_", "[", 
         RowBox[{
          RowBox[{"{", "i___", "}"}], ",", 
          RowBox[{"{", "j___", "}"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "zz", "]"}], "\[Equal]", " ", "1"}], ",", " ", 
       
       RowBox[{"Return", "[", 
        TagBox[
         RowBox[{"trad", "[", 
          RowBox[{"zz", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}],
         FullForm], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5674277202016935`*^9, 3.567427904718817*^9}, 
   3.5674280871299376`*^9, {3.567428139374429*^9, 3.5674281829297056`*^9}, {
   3.5674282371710014`*^9, 3.567428310069929*^9}, {3.567429178835455*^9, 
   3.567429220456328*^9}, {3.567429300396468*^9, 3.567429303547674*^9}, {
   3.5674312061506166`*^9, 3.567431260657112*^9}, {3.568017112189007*^9, 
   3.5680171241076884`*^9}, 3.568017181235956*^9, {3.56801721941214*^9, 
   3.5680172851579*^9}, {3.568017321254965*^9, 3.568017406765856*^9}, {
   3.568017450014329*^9, 3.568017547248891*^9}, {3.568017580342784*^9, 
   3.568017681872591*^9}, 3.5680200380023537`*^9, 3.5680201035701036`*^9, {
   3.568020267553483*^9, 3.568020395721814*^9}, 3.5680225801907587`*^9, {
   3.5680226130346375`*^9, 3.5680226726640477`*^9}, {3.568022856945588*^9, 
   3.568022897769923*^9}, {3.568022930179777*^9, 3.5680229971706085`*^9}, 
   3.568023042235186*^9, {3.5680231509794064`*^9, 3.5680231889795794`*^9}, {
   3.5680232530272427`*^9, 3.568023357795235*^9}, {3.5680233911631436`*^9, 
   3.5680234088731565`*^9}, {3.5680234764180202`*^9, 3.5680234937140093`*^9}, 
   3.568023534540344*^9, {3.5680237775392427`*^9, 3.5680238149453826`*^9}, {
   3.5680240559471674`*^9, 
   3.5680240628585625`*^9}},ExpressionUUID->"f0d79da7-b871-4686-90c8-\
f32fe5ec1c6e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tradf", "/:", " ", 
    RowBox[{"tradf", "[", 
     RowBox[{"x_", "+", "y__"}], "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{"tradf", "[", "x", "]"}], "+", 
     RowBox[{"tradf", "[", "y", "]"}]}]}], ";"}], " ", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tradf", "/:", " ", 
    RowBox[{"tradf", "[", 
     RowBox[{"z_", "*", "x__"}], "]"}], ":=", " ", 
    RowBox[{
     RowBox[{"tradf", "[", "z", "]"}], "*", 
     RowBox[{"tradf", "[", "x", "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"tradf", "/:", " ", 
   RowBox[{"tradf", "[", 
    RowBox[{"z_", "/", "x__"}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"tradf", "[", "z", "]"}], "/", 
    RowBox[{"tradf", "[", "x", "]"}]}]}], ";"}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.568023982676976*^9, 3.568024014189779*^9, {3.6030910642097044`*^9, 
   3.603091118235794*^9}, {3.603091162449323*^9, 
   3.603091171624848*^9}},ExpressionUUID->"82b809fb-eca0-4a44-9e7c-\
e5b929436711"],

Cell["\<\
The function trad is not exported; it does the transformation work:\
\>", "Text",
 CellChangeTimes->{{3.568038655363493*^9, 3.568038699792371*^9}, 
   3.568038745531651*^9},ExpressionUUID->"e3d7dc83-1df3-4056-8336-\
35b274ddbd77"],

Cell[BoxData[
 RowBox[{"?", "trad"}]], "Input",
 CellChangeTimes->{
  3.5680376605965457`*^9},ExpressionUUID->"c47fd1a0-7435-4ea1-9f86-\
e74901d552ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"trad", "[", 
   RowBox[{"a_", "[", 
    RowBox[{
     RowBox[{"{", "i___", "}"}], ",", 
     RowBox[{"{", "j___", "}"}]}], "]"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ii", " ", "=", " ", 
       RowBox[{"ToString", "[", 
        RowBox[{"{", "i", "}"}], "]"}]}], ",", 
      RowBox[{"jj", " ", "=", " ", 
       RowBox[{"ToString", "[", 
        RowBox[{"{", "j", "}"}], "]"}]}]}], "}"}], ",", "\n", 
    RowBox[{"Superscript", "[", 
     RowBox[{
      RowBox[{"Subscript", "[", 
       RowBox[{"a", ",", "ii"}], "]"}], ",", "jj"}], "]"}]}], 
   "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568022291013219*^9, 3.568022367653602*^9}, 
   3.568022419342559*^9, 3.5680237564320354`*^9, {3.5680238225818195`*^9, 
   3.5680238247899456`*^9}, 3.5680249870064206`*^9, {3.568037597174034*^9, 
   3.5680375979468355`*^9}, {3.568037638132506*^9, 
   3.5680376429373145`*^9}},ExpressionUUID->"a7866021-42f7-4db5-8569-\
08264d91c4a7"],

Cell[BoxData[
 RowBox[{"?", "mathff"}]], "Input",
 CellChangeTimes->{{3.602923017077711*^9, 3.602923020012879*^9}, 
   3.6030082453648915`*^9},ExpressionUUID->"0d3d2cf6-2b6b-4251-9968-\
dbdc02c49152"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "mathff", "]"}], ";", 
  RowBox[{
   RowBox[{"mathff", "[", "x___", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"{", "x", "}"}], "]"}]}], ",", "xx"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"n", "\[Equal]", "0"}], ",", " ", 
        RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", "\n", 
      RowBox[{
       StyleBox[
        RowBox[{"I", 
         StyleBox["f",
          FontSlant->"Italic"]}]], 
       StyleBox["[",
        FontSlant->"Italic"], 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"x", ",", 
           RowBox[{"Superscript", "[", 
            RowBox[{
             RowBox[{"Subscript", "[", 
              RowBox[{"a_", ",", " ", "i_"}], "]"}], ",", "j_"}], "]"}]}], 
          "]"}], "]"}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", " ", "\"\<No\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "x", "]"}]}], ",", " ", 
        RowBox[{"xx", " ", "=", " ", 
         RowBox[{"mathf", "[", "x", "]"}]}], ",", 
        RowBox[{"xx", "=", 
         RowBox[{"mathf", "[", "x", "]"}]}]}], "]"}], ";", "\n", "xx"}]}], 
    "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.6030052751220036`*^9, 3.6030053216106625`*^9, {3.603005352146409*^9, 
   3.603005398746074*^9}, {3.6030073048360963`*^9, 
   3.6030074744167957`*^9}},ExpressionUUID->"5aae0e28-c078-4698-ae9a-\
6355767f2b10"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mathff", "/:", " ", 
    RowBox[{"mathff", "[", 
     RowBox[{"x_", "+", "y_"}], "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{"mathff", "[", "x", "]"}], "+", 
     RowBox[{"mathff", "[", "y", "]"}]}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mathff", "/:", " ", 
   RowBox[{"mathff", "[", 
    RowBox[{"x_", "*", "y_"}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"mathff", "[", "x", "]"}], "*", 
    RowBox[{"mathff", "[", "y", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mathff", "/:", " ", 
   RowBox[{"mathff", "[", 
    RowBox[{"z_", "*", "x__"}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"mathff", "[", "z", "]"}], "*", 
    RowBox[{"mathff", "[", "x", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mathff", "/:", " ", 
   RowBox[{"mathff", "[", 
    RowBox[{"z_", "/", "x__"}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"mathff", "[", "z", "]"}], "/", 
    RowBox[{"mathff", "[", "x", "]"}]}]}], ";"}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6030911871457357`*^9, 
  3.603091258601823*^9}},ExpressionUUID->"dfcfee08-6ad4-4b24-b164-\
96a754f0b510"],

Cell["\<\
The function mathf is not exported; it does the transformation work:\
\>", "Text",
 CellChangeTimes->{{3.568038655363493*^9, 3.568038699792371*^9}, 
   3.568038745531651*^9, {3.6030184476289587`*^9, 3.6030184497560797`*^9}, 
   3.6030186240210476`*^9},ExpressionUUID->"8da3e3cf-1374-4649-a585-\
06db3cfa2da0"],

Cell[BoxData[
 RowBox[{"?", "mathf"}]], "Input",
 CellChangeTimes->{{3.6030184600456686`*^9, 
  3.6030184628738303`*^9}},ExpressionUUID->"14c9cac8-d74f-49dd-88d9-\
f04d755491c7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", 
    RowBox[{"mathf", ",", " ", "Listable"}], "]"}], ";"}], " ", 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"mathf", "[", 
    RowBox[{"Superscript", "[", 
     RowBox[{
      RowBox[{"Subscript", "[", 
       RowBox[{"a_", ",", "i_"}], "]"}], ",", "j_"}], "]"}], "]"}], " ", ":=", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"i", ",", "InputForm"}], "]"}], ",", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"j", ",", "InputForm"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.6030185445445013`*^9},ExpressionUUID->"4ea478bd-5b49-4704-bd3b-\
b0e1c5e0271d"],

Cell[TextData[StyleBox["Examples",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.603018677604112*^9, 
  3.603018681460333*^9}},ExpressionUUID->"94008738-4697-4f1a-af57-\
0ff60bdde9a0"],

Cell[BoxData[
 RowBox[{"bij", " ", "=", 
  RowBox[{"tradf", "[", 
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "j"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5674279148120346`*^9, 3.567427956354908*^9}, {
   3.5674286559693365`*^9, 3.5674286708829627`*^9}, {3.567431284977555*^9, 
   3.5674312901255636`*^9}, {3.5680227296763086`*^9, 3.568022736011671*^9}, 
   3.5680241745799522`*^9},ExpressionUUID->"03625da7-dacf-4ede-9b5e-\
2de506e8fc79"],

Cell[BoxData[
 RowBox[{"FullForm", "[", "bij", "]"}]], "Input",
 CellChangeTimes->{{3.603003412943493*^9, 
  3.603003427497325*^9}},ExpressionUUID->"096a9a87-75e3-456e-96e0-\
076e465161c6"],

Cell[BoxData["bij"], "Input",
 CellChangeTimes->{{3.6030054143799686`*^9, 
  3.6030054156350403`*^9}},ExpressionUUID->"4a57d73d-34d5-4fba-9832-\
0e8f55b5994e"],

Cell[BoxData[
 RowBox[{"mathff", "[", "bij", " ", "]"}]], "Input",
 CellChangeTimes->{{3.5680246069366817`*^9, 3.568024614715127*^9}, 
   3.601115316988927*^9, 3.603005288732782*^9, 3.603005957397027*^9, 
   3.6030082691642528`*^9},ExpressionUUID->"4f3102ac-d751-4b88-9273-\
3a4ebba8ff08"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", " ", "]"}]], "Input",
 CellChangeTimes->{{3.5680246069366817`*^9, 3.568024614715127*^9}, 
   3.601115316988927*^9, 3.603005288732782*^9, 3.603005957397027*^9, {
   3.6030077153225746`*^9, 3.603007721284916*^9}, 
   3.6030195305028954`*^9},ExpressionUUID->"c0163b29-464f-47c8-8ab2-\
2a9aaca86fb6"],

Cell[BoxData[
 RowBox[{"tradf", "[", "]"}]], "Input",
 CellChangeTimes->{{3.603018766539199*^9, 
  3.603018770150406*^9}},ExpressionUUID->"333f6831-8893-47d1-8d52-\
3b2f42483d96"],

Cell[BoxData[
 RowBox[{"mathff", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6030022915773544`*^9, 3.6030023025489817`*^9}, 
   3.6030077492845173`*^9},ExpressionUUID->"f62f619a-bb8f-4f75-8690-\
de4c199af498"],

Cell[BoxData[
 RowBox[{"mathff", "[", 
  RowBox[{"x", "^", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6030023085623255`*^9, 3.603002317499837*^9}, 
   3.6030077590210743`*^9},ExpressionUUID->"8cebbb2b-2c2a-4bcc-9956-\
e7b085cb15b2"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"x", "^", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.5674279148120346`*^9, 3.567427956354908*^9}, {
   3.5674286559693365`*^9, 3.5674286708829627`*^9}, {3.567431284977555*^9, 
   3.5674312901255636`*^9}, {3.5680226860888157`*^9, 
   3.5680226995155835`*^9}, {3.5680227575799046`*^9, 3.5680227647473145`*^9}, 
   3.5680230810194044`*^9, 3.5680235698913665`*^9, 3.568024182683416*^9, 
   3.6030171791114035`*^9, {3.6430046774878235`*^9, 
   3.6430046826826324`*^9}},ExpressionUUID->"049a8d4f-3921-458b-a5c4-\
076b1178f349"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tradf", "[", 
   RowBox[{"x", "^", "2"}], "]"}], "/.", 
  RowBox[{"x", "\[Rule]", "4"}]}]], "Input",
 CellChangeTimes->{{3.5674279148120346`*^9, 3.567427956354908*^9}, {
   3.5674286559693365`*^9, 3.5674286708829627`*^9}, {3.567431284977555*^9, 
   3.5674312901255636`*^9}, {3.5680226860888157`*^9, 
   3.5680226995155835`*^9}, {3.5680227575799046`*^9, 3.5680227647473145`*^9}, 
   3.5680230810194044`*^9, 3.5680235698913665`*^9, 3.568024182683416*^9, 
   3.6030171791114035`*^9, {3.6430046774878235`*^9, 
   3.643004727439111*^9}},ExpressionUUID->"1b61e484-221c-4a4c-99c1-\
074841ef063f"],

Cell[BoxData[
 RowBox[{"mathff", "[", 
  RowBox[{"%", "/.", 
   RowBox[{"x", "->", " ", "4"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6030030092074003`*^9, 3.6030030160607924`*^9}, 
   3.603007787084679*^9, {3.6030188159350243`*^9, 
   3.603018836447198*^9}},ExpressionUUID->"47e2dfe0-e01b-441f-a724-\
06de61dd2539"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"Cos", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5674279148120346`*^9, 3.567427956354908*^9}, {
   3.5674286559693365`*^9, 3.5674286708829627`*^9}, {3.567431284977555*^9, 
   3.5674312901255636`*^9}, {3.5680226860888157`*^9, 
   3.5680226995155835`*^9}, {3.5680227575799046`*^9, 3.5680227647473145`*^9}, 
   3.5680230810194044`*^9, 3.5680235698913665`*^9, {3.5680236179291143`*^9, 
   3.5680236450926676`*^9}, {3.568023682932832*^9, 3.568023687147073*^9}, 
   3.568024198035294*^9, {3.603017209511142*^9, 
   3.6030172107042103`*^9}},ExpressionUUID->"7d42ae44-40bd-4336-939f-\
741c253524fb"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030172204647684`*^9, 
  3.603017228166209*^9}},ExpressionUUID->"1056d195-1b86-4dd8-bc59-\
c0efc62c3162"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"2", "*", "Pi"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5680227876946273`*^9, {3.568023059995202*^9, 3.568023062324335*^9}, {
   3.5680242222446785`*^9, 3.5680242473481145`*^9}, {3.568024673091466*^9, 
   3.568024673483488*^9}},ExpressionUUID->"8235d115-f1e4-4ee8-bbef-\
90b067f97ece"],

Cell[BoxData[
 RowBox[{"mathff", "[", 
  RowBox[{"2", "*", "Pi"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5680227876946273`*^9, {3.568023059995202*^9, 3.568023062324335*^9}, {
   3.5680242222446785`*^9, 3.5680242473481145`*^9}, {3.568024673091466*^9, 
   3.568024673483488*^9}, {3.6030030537709494`*^9, 3.603003064516564*^9}, 
   3.6030083323888693`*^9},ExpressionUUID->"db569258-3f63-4cbd-8ae7-\
5ec036e30912"],

Cell[BoxData[
 RowBox[{"N", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5680246848011355`*^9, 
  3.568024689515405*^9}},ExpressionUUID->"1009a5e8-9267-43e8-aa50-\
8e0a83a83a6a"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030303240270915`*^9, 
  3.6030303288403673`*^9}},ExpressionUUID->"4876def7-010e-4e63-9eac-\
df1886be0ef4"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "*", 
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", 
      RowBox[{"{", "5", "}"}]}], "]"}]}], "+", 
   RowBox[{"b", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.5680227876946273`*^9, {3.568023059995202*^9, 3.568023062324335*^9}, {
   3.5680242222446785`*^9, 3.5680243807327433`*^9}, {3.5680244140856514`*^9, 
   3.568024433101739*^9}, 
   3.5680245024787073`*^9},ExpressionUUID->"5f120a83-99b5-44c2-a5fe-\
f0812a11fff7"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.603003089331983*^9, 3.6030030950843124`*^9}, 
   3.60300834849279*^9},ExpressionUUID->"b3116ae9-4d96-43e3-8264-\
d13be7d6daca"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], "-", 
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.5680227876946273`*^9, {3.568023059995202*^9, 3.568023062324335*^9}, {
   3.5680242222446785`*^9, 3.5680243807327433`*^9}, {3.5680244140856514`*^9, 
   3.568024433101739*^9}, 3.5680245024787073`*^9, {3.568024534625546*^9, 
   3.5680245810211997`*^9}},ExpressionUUID->"66b57169-4c8d-4041-b361-\
61e8921b5c06"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5680246069366817`*^9, 3.568024614715127*^9}, 
   3.6030083884290743`*^9},ExpressionUUID->"9f5febed-7356-453a-afa5-\
f351879cda25"],

Cell[TextData[{
 StyleBox["Warning.",
  FontColor->RGBColor[1, 0, 0]],
 " The following command  doesn\[CloseCurlyQuote]t work correctly, we obtain"
}], "Text",
 CellChangeTimes->{{3.567494099957076*^9, 3.567494129852786*^9}, {
  3.5675844692101583`*^9, 3.5675844732349653`*^9}, {3.568039031870154*^9, 
  3.5680390496697855`*^9}},ExpressionUUID->"bf0beb1f-8078-4151-bea5-\
c0c7b30a2f23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "i", ",", "k"}], "}"}], ",", 
    RowBox[{"{", "10", "}"}]}], "]"}], "/.", 
  RowBox[{
   RowBox[{"a_", "[", 
    RowBox[{
     RowBox[{"{", "i___", "}"}], ",", 
     RowBox[{"{", "j___", "}"}]}], "]"}], "\[Rule]", 
   RowBox[{"tradf", "[", 
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"{", "i", "}"}], ",", 
      RowBox[{"{", "j", "}"}]}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.567437280395685*^9, 3.567437359409824*^9}, {
   3.5674374606852016`*^9, 3.5674374724164224`*^9}, 3.567437532460928*^9, {
   3.5674375956254387`*^9, 3.56743761930628*^9}, 3.5674376698503695`*^9, 
   3.5674377304564753`*^9, {3.567437775649755*^9, 3.567437787100175*^9}, 
   3.567437850607887*^9, {3.567438087135502*^9, 3.567438186164476*^9}, {
   3.567438263010211*^9, 3.567438289140257*^9}, {3.5674941428335285`*^9, 
   3.567494159904505*^9}, {3.56803881916378*^9, 3.568038889504304*^9}, {
   3.603008524103834*^9, 3.603008533759387*^9}, {3.60300856843237*^9, 
   3.603008578413941*^9}},ExpressionUUID->"4e6af67a-88f4-477d-bf2d-\
4fa92642a562"],

Cell["instead of", "Text",
 CellChangeTimes->{{3.5675844838273845`*^9, 
  3.5675844875245905`*^9}},ExpressionUUID->"3d74f8c9-b5a9-44c4-9df0-\
8bd09661908c"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"c", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "i", ",", "k"}], "}"}], ",", 
    RowBox[{"{", "10", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.567437280395685*^9, 3.567437359409824*^9}, {
   3.5674374606852016`*^9, 3.5674374724164224`*^9}, 3.567437532460928*^9, {
   3.5674375956254387`*^9, 3.56743761930628*^9}, 3.5674376698503695`*^9, 
   3.5674377304564753`*^9, {3.567437775649755*^9, 3.567437787100175*^9}, 
   3.567437850607887*^9, {3.567438087135502*^9, 3.567438186164476*^9}, {
   3.567438263010211*^9, 3.567438289140257*^9}, {3.5674941428335285`*^9, 
   3.567494159904505*^9}, {3.5675844234084783`*^9, 
   3.5675844509737263`*^9}},ExpressionUUID->"48b2579d-4ecb-4509-b497-\
be7c86da0169"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "1", ",", "2"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6030196191169634`*^9, 
  3.6030196527508874`*^9}},ExpressionUUID->"cc09c549-7902-4e0a-b64d-\
bc771e5e4a6f"],

Cell[BoxData[
 RowBox[{"?", "ta"}]], "Input",
 CellChangeTimes->{{3.601115433864332*^9, 
  3.6011154349719343`*^9}},ExpressionUUID->"315b51bf-cc26-4a32-b9a7-\
1b50f98c87e2"],

Cell["The coordinates of ta in traditional form are", "Text",
 CellChangeTimes->{{3.5675098647488337`*^9, 
  3.5675098799247017`*^9}},ExpressionUUID->"a21f09c5-be2e-4a72-83ed-\
cb77755f820d"],

Cell[BoxData[
 RowBox[{"tradtaacoo", "=", 
  RowBox[{"tradf", "[", 
   RowBox[{"coords", "[", "ta", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5674992561129913`*^9, 3.567499293735143*^9}, 
   3.5674993763678694`*^9, {3.567499431488022*^9, 3.5674994751915216`*^9}, 
   3.5675852975120115`*^9},ExpressionUUID->"7cd802c9-7a5d-4c4c-ab9c-\
62002d90581a"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030192166129417`*^9, 3.603019267741866*^9}, 
   3.6030196679587574`*^9},ExpressionUUID->"f0d20cf0-de18-48f7-ae39-\
358ec69ac771"],

Cell["Consider the formal tensor basis", "Text",
 CellChangeTimes->{{3.567508084829028*^9, 
  3.567508096188678*^9}},ExpressionUUID->"a8fa50d7-538a-40de-b26c-\
90ec6ffe26b8"],

Cell[BoxData[
 RowBox[{"bbb", "=", " ", 
  RowBox[{"tensorbasis", "[", 
   RowBox[{"bb", ",", "2", ",", "1", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5673208060871706`*^9, 3.567320861137319*^9}, {
   3.5673209006465793`*^9, 3.5673209104101377`*^9}, {3.5673219324945974`*^9, 
   3.5673219390359716`*^9}, {3.5673248258440876`*^9, 3.567324828022212*^9}, 
   3.567324864269285*^9, 3.567325197710357*^9, {3.56732626827859*^9, 
   3.567326284098495*^9}, {3.5674994987518697`*^9, 3.5674995031441207`*^9}, {
   3.5674997325142403`*^9, 3.5674997363914614`*^9}, {3.603019861046801*^9, 
   3.6030198625828896`*^9}, {3.6030221148407106`*^9, 
   3.6030221207830505`*^9}, {3.6030224845528574`*^9, 
   3.6030224870950027`*^9}},ExpressionUUID->"fee19c06-d4b7-4800-b52c-\
bdbe8b7cbe3b"],

Cell["\<\
To arrive the traditional tensor form we have to transpose the upper and \
lower index sets of the basis elements. In tensalgv2.m we defined the function\
\>", "Text",
 CellChangeTimes->{{3.567508147884635*^9, 3.567508236404698*^9}, 
   3.6011097690958867`*^9, {3.601115517745679*^9, 3.601115555216945*^9}, 
   3.6425014338156185`*^9},ExpressionUUID->"980fc010-5ae6-445e-887b-\
f9788da438bc"],

Cell[BoxData[
 RowBox[{"?", "ptind"}]], "Input",
 CellChangeTimes->{{3.567508388739411*^9, 3.567508392356618*^9}, {
  3.601115482598818*^9, 3.6011155060924587`*^9}, {3.601115568430168*^9, 
  3.6011155702865715`*^9}},ExpressionUUID->"6a615397-b267-4c66-b214-\
1d27cf477dd5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ptind", "[", 
   TemplateBox[{SubscriptBox["a_", "i_"],"j_"},
    "Superscript"], "]"}], ":=", " ", 
  TemplateBox[{SubscriptBox["a", "j"],"j"},
   "Superscript"]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5674999175728245`*^9, 3.567499926423331*^9}, {
  3.567499960254266*^9, 3.567500038215725*^9}, {3.5675847488306494`*^9, 
  3.5675847580658655`*^9}, {3.5675850925120516`*^9, 
  3.567585165098979*^9}},ExpressionUUID->"10d07c15-0f73-4c3f-9a36-\
c75413756a80"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ptind", "[", 
   TemplateBox[{SubscriptBox["a", "\"{3, 2}\""],"\"{2}\""},
    "Superscript"], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.567508388739411*^9, 3.567508392356618*^9}, {
  3.5675850454467688`*^9, 
  3.567585062669199*^9}},ExpressionUUID->"93d5bb4b-52dc-4fad-956e-\
803d1e107d3a"],

Cell["tradf applied to the formal tensor basis yields", "Text",
 CellChangeTimes->{{3.601115628459074*^9, 3.6011156533879175`*^9}, {
   3.601115724726843*^9, 3.6011157570968995`*^9}, 
   3.6430051166041946`*^9},ExpressionUUID->"d8f7d26b-22ab-458d-a253-\
ceb644f8f254"],

Cell[BoxData[
 RowBox[{"tradf", "[", "bbb", "]"}]], "Input",
 CellChangeTimes->{{3.5674995197600713`*^9, 
  3.5674995351679525`*^9}},ExpressionUUID->"c37863b8-9c59-4380-a226-\
a58542949959"],

Cell["Here is the formal tensor basis in traditional notation.", "Text",
 CellChangeTimes->{{3.601115628459074*^9, 
  3.6011156533879175`*^9}},ExpressionUUID->"cd7b277e-d873-4358-a153-\
521904adbe78"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"ptind", ",", "%"}], "]"}]], "Input",
 CellChangeTimes->{{3.567500096500059*^9, 
  3.567500109070778*^9}},ExpressionUUID->"251cb98d-16d6-499c-bd8b-\
112202252f26"],

Cell["The formal basis decomposition of the tensor ta is", "Text",
 CellChangeTimes->{{3.567508516260705*^9, 3.567508549316595*^9}, {
  3.5675086474202065`*^9, 3.567508648788285*^9}, {3.60111578004454*^9, 
  3.601115794334165*^9}},ExpressionUUID->"42837a59-3c01-4b0e-b434-\
2069f100b5a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", "tradtaacoo", "]"}], ".", "%"}]], "Input",
 CellChangeTimes->{{3.5674995512768736`*^9, 3.5674995771113515`*^9}, {
  3.601109878608079*^9, 
  3.6011098903861*^9}},ExpressionUUID->"91ce4238-290d-4174-aac2-89fe212e7cf3"],

Cell[TextData[{
 "The so-called ",
 StyleBox["Einstein sum convention",
  FontColor->RGBColor[0, 0, 1]],
 " says that, if in a tensor expression the same index say i, appears twice, \
once up and once down, then this means that the expression is the sum of the \
given one over the range of the index i, here Range{d], d:dim. Thus the \
formal basis representation of ta is in  traditional form with the sum \
convention"
}], "Text",
 CellChangeTimes->{{3.5675048086296406`*^9, 3.5675049365879593`*^9}, {
  3.567505010868208*^9, 3.5675051202604647`*^9}, {3.5675051515162525`*^9, 
  3.5675052570682898`*^9}, {3.5675063586442957`*^9, 3.56750639857258*^9}, {
  3.5675086866694517`*^9, 3.5675087314290113`*^9}, {3.602669120217048*^9, 
  3.602669163944549*^9}},
 CellTags->"1stein",ExpressionUUID->"0a01cff6-900a-44a9-b35b-1ca4f024d8dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TemplateBox[{SubscriptBox["a", "jk"],"i"},
    "Superscript"], " ", 
   TemplateBox[{SubscriptBox["bb", "i"],"jk"},
    "Superscript"]}], " ", "=", " ", 
  RowBox[{
   RowBox[{
    StyleBox[
     UnderscriptBox[
      StyleBox[
       OverscriptBox[
        StyleBox["\[CapitalSigma]",
         FontSize->16], "d"],
       FontSize->16], 
      StyleBox[
       RowBox[{"i", ",", "j", ",", 
        RowBox[{"k", "=", "1"}]}],
       FontSize->10]],
     FontSize->16], " ", 
    TemplateBox[{SubscriptBox["a", "jk"],"i"},
     "Superscript"], " ", 
    TemplateBox[{SubscriptBox["bb", "i"],"jk"},
     "Superscript"]}], "  ", "\[DotEqual]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5675052946064367`*^9, 3.5675053660455227`*^9}, {
   3.5675054828542037`*^9, 3.56750548384626*^9}, {3.5675055517321434`*^9, 
   3.567505615869812*^9}, {3.5675056484616756`*^9, 3.567505862414913*^9}, {
   3.56750875867957*^9, 3.567508800207946*^9}, 3.56758565514264*^9, 
   3.5675856868574953`*^9, 3.5675857352799807`*^9, {3.5675857894120755`*^9, 
   3.5675857984288917`*^9}, {3.5675858417189674`*^9, 
   3.5675858479901786`*^9}, {3.6430052606860476`*^9, 
   3.6430052778304777`*^9}},ExpressionUUID->"cb3d21d7-666a-4337-92c5-\
a346654d9567"],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"j", ",", "k"}], "}"}], ",", 
      RowBox[{"{", "i", "}"}]}], "]"}], "*", 
    RowBox[{"bb", "[", 
     RowBox[{
      RowBox[{"{", "i", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"i", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "2"}], "}"}]}], "]"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5675052946064367`*^9, 3.5675053660455227`*^9}, {
   3.5675054828542037`*^9, 3.56750548384626*^9}, {3.5675055517321434`*^9, 
   3.567505615869812*^9}, {3.5675056484616756`*^9, 3.567505862414913*^9}, {
   3.567506004466038*^9, 3.5675060398880644`*^9}, 3.567506075808119*^9, {
   3.567506125295949*^9, 3.567506197464077*^9}, {3.567506255416392*^9, 
   3.5675062602156663`*^9}, 3.5675066585444493`*^9, {3.5675067120805116`*^9, 
   3.5675068099761105`*^9}, 3.5675858580833964`*^9, {3.5675910618022537`*^9, 
   3.5675910721294727`*^9}, {3.6030199847528768`*^9, 3.603019993360369*^9}, {
   3.6030200334166603`*^9, 3.603020118584532*^9}, {3.6030222228558893`*^9, 
   3.6030222901767397`*^9}},ExpressionUUID->"0a69e32b-f6cc-474d-9b56-\
285767f85c60"],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"j", ",", "k"}], "}"}], ",", 
      RowBox[{"{", "i", "}"}]}], "]"}], "*", 
    RowBox[{"bb", "[", 
     RowBox[{
      RowBox[{"{", "i", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"i", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6030200372698803`*^9, 3.6030200404300613`*^9}, 
   3.6030201400167575`*^9, 
   3.6030223242506886`*^9},ExpressionUUID->"91e45af4-6791-4d07-8d13-\
d40d6fcf40df"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.603020209052706*^9, 
  3.6030202173661814`*^9}},ExpressionUUID->"6bc94a41-2719-4fcc-85ba-\
fd7106b1f130"],

Cell[" We remember the Input Form", "Text",
 CellChangeTimes->{{3.5675064899008036`*^9, 3.5675065877403994`*^9}, 
   3.567506852836562*^9, {3.567506952940288*^9, 3.567506960476719*^9}, 
   3.567508829788637*^9, {3.603020280092769*^9, 
   3.6030202880292234`*^9}},ExpressionUUID->"2f456c67-1904-4508-92a8-\
196703574c31"],

Cell[BoxData[
 RowBox[{"taa", " ", "=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", 
       RowBox[{"{", "k", "}"}]}], "]"}], "*", 
     RowBox[{"tstb", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", 
       RowBox[{"{", "k", "}"}], ",", "2"}], "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5675052946064367`*^9, 3.5675053660455227`*^9}, {
   3.5675054828542037`*^9, 3.56750548384626*^9}, {3.5675055517321434`*^9, 
   3.567505615869812*^9}, {3.5675056484616756`*^9, 3.567505862414913*^9}, {
   3.567506004466038*^9, 3.5675060398880644`*^9}, 3.567506075808119*^9, {
   3.567506125295949*^9, 3.567506197464077*^9}, {3.567506255416392*^9, 
   3.5675062602156663`*^9}, 3.5675066402564034`*^9, {3.567506869208499*^9, 
   3.5675068932408733`*^9}, {3.5675069272498183`*^9, 
   3.5675069362183313`*^9}, {3.6030203049531913`*^9, 3.603020312088599*^9}, 
   3.6030203676327763`*^9, {3.6030204942410183`*^9, 3.603020497008176*^9}, {
   3.603020676249428*^9, 3.603020704489043*^9}, {3.6030209644579124`*^9, 
   3.6030209662250137`*^9}, {3.603021183681452*^9, 
   3.6030211978242607`*^9}},ExpressionUUID->"f5ed4388-1049-4c9f-87a8-\
db854bffb170"],

Cell["tradf does not transform this expression :", "Text",
 CellChangeTimes->{{3.6030307039168205`*^9, 
  3.603030747135292*^9}},ExpressionUUID->"67586c51-c2bf-41d5-b0d4-\
b7b51999ea47"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", 
       RowBox[{"{", "k", "}"}]}], "]"}], "*", 
     RowBox[{"tstb", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", 
       RowBox[{"{", "k", "}"}], ",", "2"}], "]"}]}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "2"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6030210875089507`*^9, 3.603021096782481*^9}, 
   3.603021263347008*^9},ExpressionUUID->"68b21c80-0c22-47e5-bda4-\
e63551f9b0f0"],

Cell["The basis decomposition taa of ta is confirmed by equi:", "Text",
 CellChangeTimes->{{3.6030307878466206`*^9, 3.6030308331262107`*^9}, 
   3.6434612854492626`*^9},ExpressionUUID->"794c4887-1597-42d9-9cb7-\
e9b0afc52051"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"ta", ",", "taa"}], "]"}]], "Input",
 CellChangeTimes->{{3.603020451392567*^9, 
  3.603020463839279*^9}},ExpressionUUID->"dc7b0841-6754-4c2a-b9a7-\
99a66ebea0b6"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3.3. The Tensor Product", "Subsection",
 CellChangeTimes->{{3.5586058911697264`*^9, 3.558605905506151*^9}, {
   3.5587818471597633`*^9, 3.558781854431179*^9}, {3.558879858528432*^9, 
   3.558879866000845*^9}, {3.5590307253995867`*^9, 3.5590307378632994`*^9}, {
   3.5590331974995737`*^9, 3.5590331995066886`*^9}, {3.559612614007923*^9, 
   3.559612630091552*^9}, 3.5596392280529337`*^9, 3.560769613218051*^9, 
   3.561450220527591*^9, 3.561462394469845*^9, {3.5671628090980015`*^9, 
   3.567162810912105*^9}, 3.567171319404948*^9, {3.601117283653181*^9, 
   3.601117287631188*^9}, 3.6011950197643943`*^9, 3.60303086493603*^9, 
   3.6030841605316334`*^9, 3.6430054865432444`*^9, 
   3.6430250853323903`*^9},ExpressionUUID->"caa5dade-ccd5-47af-86d0-\
36da1db0d524"],

Cell[TextData[{
 "The tensor product ",
 Cell[BoxData[
  FormBox["\[CircleTimes]", TraditionalForm]],ExpressionUUID->
  "a9a46443-7901-47fb-ac95-1c14e8a4456f"],
 " is the most general bilinear map between tensor spaces:"
}], "Text",
 CellChangeTimes->{{3.6430240112861037`*^9, 3.6430240766190186`*^9}, 
   3.6430244499744744`*^9},ExpressionUUID->"5838cc8f-fc3b-4388-a5f7-\
562a41e4f9b7"],

Cell[BoxData[
 RowBox[{"\[CircleTimes]", 
  RowBox[{":", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Ta", ",", "Tb"}], ")"}], "\[Element]", 
    RowBox[{
     RowBox[{
      FormBox[
       SuperscriptBox["T", 
        RowBox[{"(", 
         RowBox[{"k", ",", "h"}], ")"}]],
       TraditionalForm], 
      FormBox[
       SuperscriptBox["V", "d"],
       TraditionalForm], "\[Times]", 
      FormBox[
       SuperscriptBox["T", 
        RowBox[{"(", 
         RowBox[{"m", ",", "n"}], ")"}]],
       TraditionalForm], 
      FormBox[
       SuperscriptBox["V", "d"],
       TraditionalForm]}], "  ", "\[RightTeeArrow]", " ", 
     RowBox[{"Ta", "\[CircleTimes]", "Tb"}]}], "\[Element]", " ", 
    RowBox[{
     FormBox[
      SuperscriptBox["T", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k", "+", "m"}], ",", 
         RowBox[{"h", "+", "n"}]}], ")"}]],
      TraditionalForm], 
     RowBox[{
      FormBox[
       SuperscriptBox["V", "d"],
       TraditionalForm], "."}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.643024467555705*^9, 3.643024643383614*^9}, {
  3.6430246737100673`*^9, 3.6430247874498672`*^9}, {3.6430248288367395`*^9, 
  3.6430249032956705`*^9}},ExpressionUUID->"bb4b1fc0-ade3-4459-a860-\
9d6bf167fb8e"],

Cell["\<\
It is the heart of tensor algebra. In this Section we explain  the definition \
given in tensalgv2.m and deduce its properties.\
\>", "Text",
 CellChangeTimes->{{3.643024929878117*^9, 
  3.6430250687651615`*^9}},ExpressionUUID->"7bc37e51-fb9d-4afa-826e-\
d2552e4aede9"],

Cell[CellGroupData[{

Cell["3.3.1. The Definition", "Subsubsection",
 CellChangeTimes->{{3.5678382003262234`*^9, 3.5678382237895656`*^9}, 
   3.6430250909016*^9, 
   3.6430254192977767`*^9},ExpressionUUID->"73126ec9-0c95-4da6-8ab1-\
209268ce1d5a"],

Cell["\<\
In the package tensalgv2.m the function tensorproduct is defined:\
\>", "Text",
 CellChangeTimes->{{3.5678382712462797`*^9, 3.567838318573987*^9}, 
   3.642501433846819*^9},ExpressionUUID->"b4dbd21c-4915-4b47-8352-\
644cd3f4c09f"],

Cell[BoxData[
 RowBox[{"?", "tensorproduct"}]], "Input",
 CellChangeTimes->{{3.559627571416275*^9, 3.55962766539084*^9}, {
   3.559627718883334*^9, 3.5596280118830485`*^9}, {3.559628088581352*^9, 
   3.559628140590327*^9}, 3.5596281847098503`*^9, 3.559628396063939*^9, 
   3.559628434031111*^9, 3.563683410953041*^9, {3.5636947854602194`*^9, 
   3.5636947880342236`*^9}},ExpressionUUID->"8ef01913-44ad-49f3-9b64-\
5f2731732464"],

Cell[TextData[{
 StyleBox["Warning!",
  FontColor->RGBColor[1, 0, 0]],
 " Since in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " the definition of tensors is missing the tensor product we have to define \
now differs from the built-in  function TensorProduct. See also  ",
 ButtonBox["Section 5.2",
  BaseStyle->"Hyperlink",
  ButtonData->"TP"],
 " below."
}], "Text",
 CellChangeTimes->{{3.563608229905651*^9, 3.5636083663774567`*^9}, {
   3.5678385217986107`*^9, 3.56783852546182*^9}, 3.567840594735176*^9, {
   3.5678407209103928`*^9, 3.5678407787587013`*^9}, {3.567840815224787*^9, 
   3.5678408486626997`*^9}, {3.5678409985272713`*^9, 
   3.5678410148382044`*^9}},ExpressionUUID->"66179016-8f26-47f5-b1c0-\
ec2dd0735810"],

Cell[BoxData[
 RowBox[{"?", "TensorProduct"}]], "Input",
 CellChangeTimes->{{3.567838534805355*^9, 
  3.5678385416967487`*^9}},ExpressionUUID->"4f8f0101-9d8f-4c84-a9ba-\
4b9bad8fba54"],

Cell["\<\
Here is the definition of the tensor product contained in tensalgv2.m:\
\>", "Text",
 CellChangeTimes->{{3.5596298328281174`*^9, 3.559629858963612*^9}, {
  3.563804125259917*^9, 3.563804159283577*^9}, {3.64171786753861*^9, 
  3.6417178687710123`*^9}},ExpressionUUID->"90f0f9a0-583b-410c-b52c-\
40e5082a1913"],

Cell["\<\
First we defined the coordinate function tp[ta,tb] of the tensor product of \
two tensors ta, tb serving as an auxiliary function in the definition of the \
tensor product:\
\>", "Text",
 CellChangeTimes->{{3.5636950177290273`*^9, 3.5636950953703637`*^9}, {
   3.5636951530124645`*^9, 3.563695186661724*^9}, 3.567574969927853*^9, 
   3.6011837802495813`*^9},ExpressionUUID->"63b6653d-46e8-47fc-9a9c-\
4abfedb613cf"],

Cell[BoxData[
 RowBox[{"?", "tp"}]], "Input",
 CellChangeTimes->{{3.56360711567192*^9, 3.563607130909792*^9}, {
   3.563607230115466*^9, 3.563607264331423*^9}, 3.563608514538931*^9, {
   3.5636948333523035`*^9, 
   3.5636948355363073`*^9}},ExpressionUUID->"a5a1853b-1e2d-453e-b219-\
ab9114e9a583"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"tp", "[", 
     RowBox[{"ta_tensor", ",", "tb_tensor"}], "]"}], "[", 
    RowBox[{"i_List", ",", " ", "j_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ka", ",", "kb", ",", "ha", ",", "hb"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"ka", " ", "=", 
       RowBox[{
        RowBox[{"type", "[", "ta", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"ha", " ", "=", 
       RowBox[{
        RowBox[{"type", "[", "ta", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"kb", " ", "=", 
       RowBox[{
        RowBox[{"type", "[", "tb", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"hb", " ", "=", 
       RowBox[{
        RowBox[{"type", "[", "tb", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"ta", "[", 
        RowBox[{
         RowBox[{"Part", "[", 
          RowBox[{"i", ",", 
           RowBox[{"1", ";;", "ka"}]}], "]"}], ",", 
         RowBox[{"Part", "[", 
          RowBox[{"j", ",", 
           RowBox[{"1", ";;", "ha"}]}], "]"}]}], "]"}], "*", 
       RowBox[{"tb", "[", 
        RowBox[{
         RowBox[{"Part", "[", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"ka", "+", "1"}], ";;", 
            RowBox[{"ka", "+", "kb"}]}]}], "]"}], ",", 
         RowBox[{"Part", "[", 
          RowBox[{"j", ",", 
           RowBox[{
            RowBox[{"ha", "+", "1"}], ";;", 
            RowBox[{"ha", "+", "hb"}]}]}], "]"}]}], "]"}]}]}]}], "]"}]}], 
  ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"597b2aef-925b-4e05-8e8b-cffe5d744705"],

Cell["\<\
This function and the not exported function tenpro are the kernel of the \
definition; tenpro is the tensor product of two tensors.\
\>", "Text",
 CellChangeTimes->{{3.5636953227407627`*^9, 3.5636954078701124`*^9}, 
   3.6011851948444653`*^9},ExpressionUUID->"d5d84459-d5b5-47fd-81eb-\
ab835b1bafe3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"tenpro", "[", 
    RowBox[{"ta_", ",", "tb_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ka", ",", "kb", ",", "ha", ",", "hb", ",", "dd"}], "}"}], ",", 
     "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Head", "[", "ta", "]"}], "===", "  ", "tensor"}], ")"}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Head", "[", "tb", "]"}], "===", "  ", "tensor"}], ")"}]}],
         "]"}], ",", " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Incorrect arguments!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}], ",", "\n", 
       RowBox[{
        RowBox[{"ka", "=", 
         RowBox[{
          RowBox[{"type", "[", "ta", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
        RowBox[{"ha", "=", 
         RowBox[{
          RowBox[{"type", "[", "ta", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", 
        RowBox[{"dd", "=", 
         RowBox[{
          RowBox[{"type", "[", "ta", "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"type", "[", "tb", "]"}], "[", 
             RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", " ", "dd"}], "]"}], 
          ",", 
          RowBox[{
           RowBox[{"Print", "[", "\"\<Different dimensions!\>\"", "]"}], ";", 
           
           RowBox[{"Return", "[", "]"}]}]}], "]"}], " ", ";", "\n", 
        RowBox[{"kb", "=", 
         RowBox[{
          RowBox[{"type", "[", "tb", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
        RowBox[{"hb", "=", 
         RowBox[{
          RowBox[{"type", "[", "tb", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ta", " ", "==", " ", 
           RowBox[{"nulltensor", "[", 
            RowBox[{"ka", ",", "ha", ",", "dd"}], "]"}]}], ",", " ", 
          RowBox[{"Return", "[", 
           RowBox[{"nulltensor", "[", 
            RowBox[{
             RowBox[{"ka", "+", "kb"}], ",", 
             RowBox[{"ha", "+", "hb"}], ",", "dd"}], "]"}], "]"}]}], "]"}], 
        ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"tb", " ", "==", " ", 
           RowBox[{"nulltensor", "[", 
            RowBox[{"kb", ",", "hb", ",", "dd"}], "]"}]}], ",", " ", 
          RowBox[{"Return", "[", 
           RowBox[{"nulltensor", "[", 
            RowBox[{
             RowBox[{"ka", "+", "kb"}], ",", 
             RowBox[{"ha", "+", "hb"}], ",", "dd"}], "]"}], "]"}]}], "]"}], 
        ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ka", "+", "kb"}], "==", "0"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ha", "+", "hb"}], "==", "0"}], ")"}]}], ",", " ", 
          RowBox[{"Return", "[", 
           RowBox[{"tensor", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"type", "[", "ta", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "*", 
              RowBox[{
               RowBox[{"type", "[", "tb", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ",", "0", ",", "0", ",", 
             "dd"}], "]"}], "]"}]}], "]"}], ";", "\n", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"tp", "[", 
           RowBox[{"ta", ",", "tb"}], "]"}], ",", 
          RowBox[{"ka", "+", "kb"}], ",", 
          RowBox[{"ha", "+", "hb"}], ",", "dd"}], "]"}]}]}], "]"}]}], "\n", 
    "]"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"70ab4757-f18b-41fa-a522-72ed0cb820c6"],

Cell["\<\
The definition of tp and thus also the tensorproduct assume that all the \
factors are tensors with the same underlying vector space of dimension d, \
with default value d : dim. The iteration of tenpro yields the tensor product:\
\>", "Text",
 CellChangeTimes->{{3.563695484419447*^9, 3.5636955162435026`*^9}, {
  3.5678410560865636`*^9, 3.5678411544861917`*^9}, {3.570806299617775*^9, 
  3.570806304563058*^9}},ExpressionUUID->"c6d44d6c-9b50-4fba-b9c3-\
005f7d15b51b"],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"tensorproduct", "[", "ta___", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ttt", ",", " ", "tt", ",", "k", ",", "i"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"ttt", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", "ta", "}"}], "]"}]}], ";", "    ", 
        RowBox[{"k", " ", "=", " ", 
         RowBox[{"Length", "[", "ttt", "]"}]}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"k", "==", "0"}], ",", " ", 
          RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"k", "==", " ", "1"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "ta", "]"}], "===", " ", "tensor"}], ",", 
            " ", 
            RowBox[{"Return", "[", "ta", "]"}], ",", 
            RowBox[{
             RowBox[{"Print", "[", "\"\<Incorrect arguments!\>\"", "]"}], ";", 
             RowBox[{"Return", "[", "]"}]}]}], "]"}], ",", "\n", 
          RowBox[{"tt", " ", "=", " ", 
           RowBox[{"ttt", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], ";", "\n", 
        RowBox[{"i", "=", "2"}], ";", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"i", "<", 
           RowBox[{"k", "+", "1"}]}], ",", 
          RowBox[{
           RowBox[{"tt", " ", "=", 
            RowBox[{"tenpro", "[", 
             RowBox[{"tt", ",", 
              RowBox[{"ttt", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";", 
           RowBox[{"i", "++"}]}]}], "]"}], ";", " ", "tt"}]}], "]"}]}], ";"}],
    "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Attributes", "[", "tensorproduct", "]"}], " ", "=", 
     RowBox[{"{", 
      RowBox[{"Flat", ",", "HoldAll"}], "}"}]}], ";"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6417179080406823`*^9, 3.641717952436761*^9}, {
  3.6417182476568823`*^9, 
  3.641718253132492*^9}},ExpressionUUID->"b9ed731f-dab7-4f9a-8370-\
8dbaac63108a"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "tensorproduct", "]"}]], "Input",
 CellChangeTimes->{{3.5640362140596685`*^9, 
  3.564036227787693*^9}},ExpressionUUID->"97c2742f-af1c-4c5e-b059-\
325a1b1f58a5"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3.2. Examples. Standard and Traditional Notation", "Subsubsection",
 CellChangeTimes->{{3.5678390286065984`*^9, 3.5678390383821573`*^9}, {
   3.5679303962902575`*^9, 3.5679304183085165`*^9}, 3.643025439983413*^9, 
   3.643098943422942*^9, 
   3.6432759946691628`*^9},ExpressionUUID->"1b24c48d-5ae7-4bfe-a650-\
07d5ece1659a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.558925901027793*^9, 3.558925905598601*^9}, 
   3.5596088884013796`*^9, {3.561459493972946*^9, 3.5614595010773525`*^9}, 
   3.5636947770050044`*^9, {3.567841195104515*^9, 
   3.567841198079685*^9}},ExpressionUUID->"b2b0e240-4d10-400a-9f29-\
9b94414c6926"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "1", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tb", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "2", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tc", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"c", ",", "2", ",", "1"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5636304365243855`*^9, 3.563630452093213*^9}, {
  3.563687352565164*^9, 
  3.563687397633643*^9}},ExpressionUUID->"8aeedd3f-3499-43a7-b9e6-\
ea3e93567d1a"],

Cell[BoxData[
 RowBox[{"tab", " ", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5636955605319805`*^9, 3.563695573152403*^9}, 
   3.5678630534341187`*^9, {3.567867090343609*^9, 
   3.5678670928084135`*^9}},ExpressionUUID->"c60fd4c3-01cb-41df-bf55-\
7335166e5567"],

Cell[BoxData[
 RowBox[{"tab", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.567867104648834*^9, 3.5678671333840847`*^9}, {
  3.56786716474014*^9, 
  3.567867179107765*^9}},ExpressionUUID->"ecfb3b3f-87fd-4a3c-b1c4-\
9c7d85ca1b8e"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5680391683235936`*^9, 
  3.568039174844405*^9}},ExpressionUUID->"8e01e644-6042-43e4-a778-\
7e779141bdaf"],

Cell["\<\
For two factors instead of tensorproduct also the infix notation may be used:\
\
\>", "Text",
 CellChangeTimes->{{3.6432760592376766`*^9, 
  3.643276176253482*^9}},ExpressionUUID->"f84cbd4c-1305-4f37-869a-\
a1f37188ae18"],

Cell[BoxData[
 RowBox[{"tab", " ", "==", " ", 
  RowBox[{"ta", "\[CircleTimes]", "tb"}]}]], "Input",
 CellChangeTimes->{{3.64327618071509*^9, 
  3.6432762591052275`*^9}},ExpressionUUID->"d9668817-c34f-4ece-a2fc-\
08c34c014b7d"],

Cell["The next cell  isn\[CloseCurlyQuote]t evaluated:", "Text",
 CellChangeTimes->{{3.643276513978475*^9, 
  3.643276553680545*^9}},ExpressionUUID->"0d9e6b98-8493-4a72-a9b3-\
2e09fe9c31e8"],

Cell[BoxData[
 RowBox[{"tab", "\[CircleTimes]", "ta", "\[CircleTimes]", "tb"}]], "Input",
 CellChangeTimes->{
  3.6432763198205338`*^9},ExpressionUUID->"840847cc-bafa-488b-b86d-\
99882ff8445d"],

Cell[BoxData[
 RowBox[{"type", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.643276561683359*^9, 
  3.6432765682197704`*^9}},ExpressionUUID->"79a2436f-478e-4ed1-a33d-\
d4d4f1446627"],

Cell["One has to set parentheses:", "Text",
 CellChangeTimes->{{3.6432766134130497`*^9, 
  3.6432766296370783`*^9}},ExpressionUUID->"1e33ad14-b9fb-4052-8abb-\
dd13755ff947"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"tab", "\[CircleTimes]", "ta"}], ")"}], "\[CircleTimes]", 
  "tb"}]], "Input",
 CellChangeTimes->{
  3.6432763198205338`*^9, {3.6432763592886033`*^9, 
   3.643276379350239*^9}},ExpressionUUID->"b7867aa3-bfcd-4218-8ed2-\
3cbece151b7f"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"tab", ",", " ", "ta", ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6432764146999006`*^9, 
  3.6432764706259985`*^9}},ExpressionUUID->"6651e445-0cf1-48c1-ab92-\
7e4fdb3d2aa0"],

Cell["\<\
tx is not yet  defined as a tensor, thus we get an error message:\
\>", "Text",
 CellChangeTimes->{{3.5678412131185455`*^9, 3.5678412300465136`*^9}, {
  3.567916543217188*^9, 3.567916546631383*^9}, {3.6011856885546646`*^9, 
  3.601185697986204*^9}, {3.6030810025331616`*^9, 3.6030810037031636`*^9}, {
  3.6432766576079273`*^9, 3.6432766691051474`*^9}, {3.6432767145792274`*^9, 
  3.643276726388448*^9}},ExpressionUUID->"7a50efa4-a8ae-490c-921f-\
77c460d20e88"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "tx", "]"}], ";", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tx"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.567867513213552*^9, {3.5680393062278357`*^9, 3.5680393260710707`*^9}, {
   3.6011242539873095`*^9, 
   3.6011242618809233`*^9}},ExpressionUUID->"e89f1c18-fa83-49ed-a77f-\
62c2c6825c2c"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "Null"}]], "Input",
 CellChangeTimes->{{3.5678677472763634`*^9, 
  3.567867752939173*^9}},ExpressionUUID->"04c8273e-237b-41fd-9dcd-\
da2082095641"],

Cell["\<\
Strange:  Output: invisible 0 instead of the programmed  Null!\
\>", "Text",
 CellChangeTimes->{{3.5680394711045256`*^9, 3.5680395073277893`*^9}, 
   3.568094751100765*^9, 3.6011865745873427`*^9, {3.6430951204754114`*^9, 
   3.64309513691784*^9}, {3.643095311201346*^9, 
   3.6430953238061686`*^9}},ExpressionUUID->"d61c301f-ce1e-439f-836e-\
30a5bceb2e02"],

Cell[BoxData[
 RowBox[{"tx", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"x", ",", "2", ",", "0", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.567867532229985*^9, 
  3.567867553711223*^9}},ExpressionUUID->"0592e206-6a93-448c-aad2-\
47975a09b41a"],

Cell["\<\
The factors of a tensor product must have the same underlying vector space, \
at least the same underlying d:dim:\
\>", "Text",
 CellChangeTimes->{{3.568039356179124*^9, 3.5680394473768835`*^9}, 
   3.568094734845536*^9, 
   3.643276756340501*^9},ExpressionUUID->"eead7c71-360a-47d8-84d9-\
109e8cca1402"],

Cell[BoxData[
 RowBox[{"tensorproduct", "[", 
  RowBox[{"ta", ",", "tx"}], "]"}]], "Input",
 CellChangeTimes->{
  3.567867513213552*^9},ExpressionUUID->"6f280478-4785-47e0-91b4-\
3e2408e29ffb"],

Cell[BoxData["%"], "Input",
 CellChangeTimes->{{3.5678677472763634`*^9, 3.567867752939173*^9}, 
   3.643095214824377*^9},ExpressionUUID->"3ab848b0-33ac-4721-b4b3-\
6a15da096565"],

Cell["\<\
Strange again: invisible  Output: {x,{2,0},4} is obtained instead of the \
programmed Null!\
\>", "Text",
 CellChangeTimes->{{3.5680394711045256`*^9, 3.5680395073277893`*^9}, 
   3.568094751100765*^9, 3.6011865745873427`*^9, {3.6430951204754114`*^9, 
   3.64309513691784*^9}, {3.643095235541213*^9, 3.6430952868185034`*^9}, {
   3.6432767966977715`*^9, 
   3.643276801970581*^9}},ExpressionUUID->"9f49c5bd-f25f-442d-bf5b-\
df29f4293bcb"],

Cell[BoxData[
 RowBox[{"tensorproduct", "[", 
  RowBox[{"{", "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5636955605319805`*^9, 3.563695573152403*^9}, 
   3.5678630534341187`*^9, {3.5678631857535515`*^9, 3.567863192570763*^9}, {
   3.5679173229207845`*^9, 3.567917324523876*^9}, 3.601124403482372*^9, {
   3.6011244806869073`*^9, 
   3.601124483884913*^9}},ExpressionUUID->"afc88e36-fc46-4e94-b4cf-\
6f83e1082ac3"],

Cell[BoxData[
 RowBox[{"tpr", " ", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"{", 
    RowBox[{"ta", ",", " ", "tb", ",", "tc"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563686215479167*^9, 3.563686231656395*^9}, {
  3.56368638244626*^9, 3.563686389793873*^9}, {3.563686909680386*^9, 
  3.563686966214885*^9}, {3.563687023950587*^9, 3.563687058223847*^9}, {
  3.563687454386543*^9, 3.563687470236171*^9}, {3.563687505601433*^9, 
  3.563687517254653*^9}, {3.5636886167913847`*^9, 3.563688655183052*^9}, {
  3.5636887153991575`*^9, 3.5636887225127697`*^9}, {3.563689393688349*^9, 
  3.563689413157183*^9}, {3.5636894679912796`*^9, 3.56368949678893*^9}, {
  3.5636913887290535`*^9, 3.563691446324354*^9}, {3.5636914774776087`*^9, 
  3.5636914959792414`*^9}, {3.5678681261230288`*^9, 
  3.5678681366686473`*^9}},ExpressionUUID->"2d530b64-0f90-4b0b-9077-\
a6bc244c36aa"],

Cell[BoxData[
 RowBox[{"type", "[", "tpr", "]"}]], "Input",
 CellChangeTimes->{{3.5636305355533595`*^9, 3.5636305432909727`*^9}, {
  3.5636915672401667`*^9, 
  3.5636915686909695`*^9}},ExpressionUUID->"5ff1cadc-fd6e-4eea-85f2-\
b3f2e261a57c"],

Cell[BoxData[
 RowBox[{"tpr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5636305934294615`*^9, 3.5636306579355745`*^9}, 
   3.563635482602848*^9, {3.5636916236498656`*^9, 3.5636916365978885`*^9}, 
   3.5678681684303026`*^9},ExpressionUUID->"765504d7-5fdb-4d21-8b13-\
cab55d97d0de"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5679231079703894`*^9, 
  3.5679231133216953`*^9}},ExpressionUUID->"d592f54e-2f51-4bed-9393-\
b7f63aabf776"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5679247862523813`*^9, 3.5679247942748404`*^9}, 
   3.6030811726046605`*^9},ExpressionUUID->"97e7a8df-d9dd-4f1e-a4a7-\
1bf84a524b3b"],

Cell[BoxData[
 RowBox[{"tpr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5636305934294615`*^9, 3.5636306579355745`*^9}, {
   3.563635482602848*^9, 3.5636355077344923`*^9}, {3.563691686424376*^9, 
   3.563691693179188*^9}, 
   3.5678682051995673`*^9},ExpressionUUID->"3fdfec0a-c25a-4f8a-bde0-\
ec262cc3026d"],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"tpr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "i"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563630781144591*^9, 3.563630851906315*^9}, {
   3.5636917140208244`*^9, 3.563691729059251*^9}, 
   3.567868238100025*^9},ExpressionUUID->"48ae67f3-d511-408c-a957-\
cbacd2f92f42"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5679242700238547`*^9, 
  3.5679242755991735`*^9}},ExpressionUUID->"33a4314f-af88-4bc8-a67d-\
800fc104312d"],

Cell[BoxData[
 RowBox[{"mathff", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5679248205383425`*^9, 3.5679248270227137`*^9}, 
   3.6030812478279924`*^9},ExpressionUUID->"ba0f1bb8-3ddb-4f60-88ad-\
01fc21516116"],

Cell[BoxData[
 RowBox[{"TB", " ", "=", 
  RowBox[{"coords", "[", "tb", "]"}]}]], "Input",
 CellChangeTimes->{{3.568040057384755*^9, 3.5680400742639847`*^9}, 
   3.5680401708593545`*^9, {3.568094926476273*^9, 
   3.5680949291750774`*^9}},ExpressionUUID->"8986f79f-0d12-4068-a0ff-\
bcf1c5fea902"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5680400894428115`*^9, 
  3.568040096852824*^9}},ExpressionUUID->"c51301f8-6a87-4e35-962d-\
a1d23fc376bb"],

Cell[BoxData[
 RowBox[{"tradf", "[", 
  RowBox[{"coords", "[", "tb", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5680401349480915`*^9, 3.5680401468353124`*^9}, 
   3.56804018536738*^9},ExpressionUUID->"3c27c397-e456-47d7-a0d0-\
13fb99730a43"],

Cell["\<\
Now we apply the built-in TensorProduct to the coordinates of ta, tb:\
\>", "Text",
 CellChangeTimes->{{3.568095056861302*^9, 3.5680950776561384`*^9}, {
   3.5680951313691216`*^9, 3.568095148321091*^9}, 
   3.6011843807102356`*^9},ExpressionUUID->"43943f70-5ca2-4b06-9c36-\
4db696991643"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TA", " ", "=", " ", 
   RowBox[{"coords", "[", "ta", "]"}]}], ";", 
  RowBox[{"TAB", " ", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{"TA", ",", "TB"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.568094957114727*^9, 3.5680950236332436`*^9}, 
   3.5707789232612476`*^9},ExpressionUUID->"9e77c030-4c45-454e-bde6-\
d697c589684d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TTab", " ", "=", " ", 
   RowBox[{"coords", "[", 
    RowBox[{"tensorproduct", "[", 
     RowBox[{"ta", ",", "tb"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.568095168392239*^9, 3.56809520354725*^9}, 
   3.6430991558753157`*^9, {3.643099193720982*^9, 
   3.643099193908182*^9}},ExpressionUUID->"e40c2099-1e36-4ad7-852b-\
956252c35ddb"],

Cell[TextData[{
 StyleBox["WARNING.",
  FontColor->RGBColor[1, 0, 0]],
 " The function coords of the tensorproduct doesn\[CloseCurlyQuote]t coincide \
with the TensorProduct of the coords of the factors!"
}], "Text",
 CellChangeTimes->{{3.5680952920743136`*^9, 3.5680953203139286`*^9}, {
   3.5680953519137363`*^9, 3.5680954090980067`*^9}, 
   3.568474165242652*^9},ExpressionUUID->"df3bd242-bcf2-4be4-b136-\
64287cbffad1"],

Cell[BoxData[
 RowBox[{"TTab", " ", "\[Equal]", " ", "TAB"}]], "Input",
 CellChangeTimes->{{3.5680952099046135`*^9, 3.568095220836239*^9}, {
  3.6430992127374153`*^9, 
  3.643099213018216*^9}},ExpressionUUID->"571e1547-187a-4ab6-9dda-\
c1f803bc4230"],

Cell["The order of the flattened Arrays differ:", "Text",
 CellChangeTimes->{{3.568095582953951*^9, 
  3.568095606921322*^9}},ExpressionUUID->"20342846-e022-462c-9991-\
03d6861e71d2"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", "TTab", "]"}], "===", "  ", 
   RowBox[{"Flatten", "[", "TAB", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56809544622013*^9, 3.568095483203245*^9}, {
   3.6430992393978624`*^9, 3.643099264981907*^9}, 3.643276984210101*^9, {
   3.643277035222191*^9, 
   3.643277037281394*^9}},ExpressionUUID->"1625fa87-07fd-446f-8d2e-\
94f96095be01"],

Cell["but the corresponding coordinates coincide:", "Text",
 CellChangeTimes->{{3.568095621961182*^9, 3.568095656105135*^9}, 
   3.601184389961052*^9},ExpressionUUID->"3b2edc80-5d6f-48f5-9e39-\
d2ffb2b0fc87"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sort", "[", 
   RowBox[{"Flatten", "[", "TTab", "]"}], "]"}], "===", 
  RowBox[{"Sort", "[", " ", 
   RowBox[{"Flatten", "[", "TAB", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56809544622013*^9, 3.5680955408045397`*^9}, {
  3.643099277352729*^9, 
  3.6430992776335297`*^9}},ExpressionUUID->"ea9b274a-d1e2-46e3-bb25-\
10cc45d7d5e4"],

Cell[TextData[{
 "We conclude\n",
 StyleBox["Lemma.",
  FontColor->RGBColor[0, 0, 1]],
 " The set of the coordinates of the TensorProduct of coords[ta],.... \
coincides with the set of the coordinates of tensorproduct[ta,...]."
}], "Text",
 CellChangeTimes->{{3.5680958332892694`*^9, 3.5680958454809666`*^9}, {
   3.568095886258299*^9, 3.5680959269056234`*^9}, {3.5680960599692345`*^9, 
   3.568096093145132*^9}, {3.568096323329298*^9, 3.5680963825216837`*^9}, {
   3.601184391131054*^9, 3.601184392316656*^9}, 
   3.643461358859392*^9},ExpressionUUID->"2411fe9d-9f38-44b4-b8a1-\
c681a13f23f2"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3.3. Properties of tensorproduct", "Subsubsection",
 CellChangeTimes->{{3.567930375430064*^9, 3.5679303832375107`*^9}, {
   3.5679304410418167`*^9, 3.5679304866634264`*^9}, {3.5679307544767447`*^9, 
   3.5679307561828423`*^9}, 3.5680986232498455`*^9, {3.6011867731717014`*^9, 
   3.6011867749948053`*^9}, 3.6011950079707737`*^9, 3.6430989547485623`*^9, 
   3.643284149926359*^9},ExpressionUUID->"055c35ee-0fd8-4515-a514-\
738eda30a706"],

Cell["Tensors of type (0,0) are treated as scalars:", "Text",
 CellChangeTimes->{{3.5596306735242023`*^9, 
  3.559630702267846*^9}},ExpressionUUID->"43232dc7-6f60-4277-bc9e-\
f25c1ecfb33f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "c", ",", "tc"}], "]"}], ";", 
  RowBox[{"dim", " ", "=", " ", "4"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "0"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.558936994264454*^9, 3.5589370216893015`*^9}, {
   3.558938567636417*^9, 3.55893856952402*^9}, 3.5591125598561897`*^9, {
   3.5592076267331944`*^9, 3.55920765826085*^9}, {3.5596075019645443`*^9, 
   3.5596075049753494`*^9}, {3.5596082575674715`*^9, 3.559608266958688*^9}, {
   3.563695931347032*^9, 3.5636959486162624`*^9}, 3.5636960039339595`*^9, 
   3.563713452685149*^9, {3.567930974082305*^9, 
   3.567930979575619*^9}},ExpressionUUID->"ef39e72d-be88-4639-953c-\
1f85e1fc18f3"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.558938579258437*^9, 3.5589385836732454`*^9}, {
   3.5596082792515097`*^9, 3.5596082870359235`*^9}, 3.5596083304508*^9, {
   3.5636960131067753`*^9, 
   3.5636960432148285`*^9}},ExpressionUUID->"27ca07d7-8c80-4761-88b7-\
c5d14cbb8f63"],

Cell[BoxData[
 RowBox[{"tb", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "2", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5637230859674177`*^9, 
  3.563723107447646*^9}},ExpressionUUID->"8db4df41-dc7f-4bb1-b4a1-\
e8025521104b"],

Cell[BoxData[
 RowBox[{"tc", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", " ", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.558936994264454*^9, 3.5589370216893015`*^9}, {
   3.558938567636417*^9, 3.55893856952402*^9}, 3.5591125598561897`*^9, {
   3.5592076267331944`*^9, 3.55920765826085*^9}, {3.5596075019645443`*^9, 
   3.5596075049753494`*^9}, {3.5596082575674715`*^9, 3.559608266958688*^9}, 
   3.559609266436844*^9, {3.5636959674454956`*^9, 3.5636959708151016`*^9}, 
   3.5636961051625376`*^9, 3.5637158029452777`*^9, {3.563715847576956*^9, 
   3.5637158496517596`*^9}},ExpressionUUID->"ba238018-79f3-477c-b209-\
65df2cb6eb80"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5596093016929054`*^9, 3.559609308026517*^9}, {
   3.563696134412589*^9, 3.5636961610886354`*^9}, {3.563696736542446*^9, 
   3.5636967412068543`*^9}, {3.5636968337150173`*^9, 
   3.5636968437302346`*^9}, {3.5637158297617245`*^9, 3.5637158656417875`*^9}, 
   3.563715914813074*^9, {3.563716025916469*^9, 3.5637160301596766`*^9}, 
   3.5637160622801332`*^9},ExpressionUUID->"4620f933-a90a-4469-9ce7-\
a5dc70c69ec2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"%", " ", "/", "a"}], "==", "  ", 
  RowBox[{"b", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5637135513085227`*^9, 3.5637136020866117`*^9}, 
   3.563715943345524*^9, {3.5637160730441523`*^9, 3.563716080781766*^9}, {
   3.563716123775441*^9, 3.5637161244774423`*^9}, 
   3.567168643200878*^9},ExpressionUUID->"0700052a-bb59-4fdb-b474-\
b933cb4107f5"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.5680972471491375`*^9, 
  3.568097252419439*^9}},ExpressionUUID->"87357814-7375-4f58-9574-\
757df50f1d95"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"tb", ",", "tc", ",", "b", ",", "c"}], "]"}], ";", 
  RowBox[{"tb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "0", ",", "0"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5637136254398527`*^9, 3.563713663113919*^9}, 
   3.5640364286068454`*^9},ExpressionUUID->"82569444-348b-40ff-9d9a-\
d6ce5b86ab07"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563713690554367*^9, 3.5637137116768045`*^9}, {
  3.563716822360268*^9, 3.563716831907485*^9}, {3.5637173030751123`*^9, 
  3.563717310890726*^9}},ExpressionUUID->"1df7b29e-faca-4bf2-9e78-\
3ab519d6c104"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5637163260297966`*^9, 3.5637163466218324`*^9}, {
  3.563716846758711*^9, 
  3.5637168686143494`*^9}},ExpressionUUID->"591b2efa-f178-4cc8-a1f6-\
fb4da91060c7"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5680972800170174`*^9, 
  3.5680972877314587`*^9}},ExpressionUUID->"22c01619-2fda-4488-8f5d-\
4f32904bfddf"],

Cell[BoxData[
 RowBox[{"type", "[", "tc", "]"}]], "Input",
 CellChangeTimes->{{3.563716261508083*^9, 
  3.563716268434495*^9}},ExpressionUUID->"65a8da64-d83d-4b44-9e9f-\
aa7c7097f92f"],

Cell["\<\
tensorproduct with a nulltensor yields the nulltensor of the corresponding \
type:\
\>", "Text",
 CellChangeTimes->{{3.564059042443299*^9, 3.564059104609408*^9}, 
   3.5679309012361383`*^9},ExpressionUUID->"560fca78-a25b-4f4a-aef8-\
9b93835d91ea"],

Cell[BoxData[
 RowBox[{"?", "nulltensor"}]], "Input",
 CellChangeTimes->{{3.564036464346508*^9, 
  3.5640364815221386`*^9}},ExpressionUUID->"aaeda8d4-ce15-41c2-b08a-\
8be327d7795b"],

Cell[BoxData[
 RowBox[{"nulltensor", "[", 
  RowBox[{"0", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.5640364903049536`*^9, 
  3.5640365325342283`*^9}},ExpressionUUID->"0eb4e90a-630d-4ec6-9e1c-\
40d8e76c2066"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569394183126281*^9, 
  3.569394189724658*^9}},ExpressionUUID->"f6e07b3c-969e-4b53-ad1c-\
8d4fe7eeebed"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "2", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56449972962327*^9, 
  3.564499742250992*^9}},ExpressionUUID->"9daf0e23-8910-405d-9586-\
0e244195d58f"],

Cell[BoxData[
 RowBox[{"tb0", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{
    RowBox[{"nulltensor", "[", 
     RowBox[{"0", ",", "0"}], "]"}], ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.564036553609865*^9, 
  3.5640366095515633`*^9}},ExpressionUUID->"8d6253c9-f3f1-471b-97a7-\
1bccb83575a2"],

Cell[BoxData[
 RowBox[{"tb0", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.564036619551181*^9, 3.564036639846816*^9}, {
  3.564499813524069*^9, 
  3.5644998227155943`*^9}},ExpressionUUID->"f3cfbc5f-4a94-469b-9b8c-\
ccde938c43ef"],

Cell[BoxData[
 RowBox[{"%%", "\[Equal]", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"2", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5640380506040945`*^9, 3.564038063536517*^9}, {
  3.5644997967071066`*^9, 
  3.564499802403433*^9}},ExpressionUUID->"a58493c4-de83-4d1d-a1b2-\
9c1557cab851"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.5680974458135004`*^9, 
  3.5680974520918593`*^9}},ExpressionUUID->"20985f82-3e86-4c0d-bca5-\
95e844a8194c"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "1", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.564036650454835*^9, 3.5640366650720606`*^9}, 
   3.5640374086473665`*^9},ExpressionUUID->"42643a54-19ab-41c4-ab18-\
6b38d8da77b7"],

Cell[BoxData[
 RowBox[{"ta0", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", " ", 
    RowBox[{"nulltensor", "[", 
     RowBox[{"2", ",", "0"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5640366717176723`*^9, 3.564036716786152*^9}, {
   3.564036748797408*^9, 3.5640367638670344`*^9}, 
   3.564038084690154*^9},ExpressionUUID->"8efeb5db-bf83-4e19-8c7b-\
2fc5e96d45b9"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"3", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5640381008205824`*^9, 
  3.5640381128794036`*^9}},ExpressionUUID->"490b3080-551f-4fd0-b77e-\
5ee8398c56a7"],

Cell[BoxData[
 RowBox[{"ta0", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{
    RowBox[{"nulltensor", "[", 
     RowBox[{"0", ",", "2"}], "]"}], ",", "ta"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5640366717176723`*^9, 3.564036716786152*^9}, {
   3.564036748797408*^9, 3.5640367638670344`*^9}, {3.564037311412396*^9, 
   3.564037335358438*^9}, 
   3.5640373777125125`*^9},ExpressionUUID->"804871bf-0406-459a-8fd3-\
232b87e322e7"],

Cell[BoxData[
 RowBox[{"type", "[", "ta0", "]"}]], "Input",
 CellChangeTimes->{{3.5640373439852533`*^9, 
  3.5640373532360697`*^9}},ExpressionUUID->"b6b86058-fd06-4dd3-af82-\
ca46cfc1297a"],

Cell[BoxData[
 RowBox[{"%%", "\[Equal]", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"1", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.564038160911888*^9, 
  3.564038181254324*^9}},ExpressionUUID->"e55a8252-94f4-4beb-b78e-\
c89819156ec7"],

Cell[BoxData[
 RowBox[{"ta0", "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.564037445775432*^9, 
  3.564037512496749*^9}},ExpressionUUID->"3e8a44d1-8732-4761-bae4-\
6b65c16a2a2b"],

Cell[BoxData[
 RowBox[{"tensorproduct", "[", 
  RowBox[{"ta0", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"2", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.601193292778961*^9, 
  3.601193331451429*^9}},ExpressionUUID->"dc65a4a4-0702-4dd6-9118-\
23e0bd0dd7e5"],

Cell["Clearly, the tensor product is associative, example:", "Text",
 CellChangeTimes->{{3.559611479690731*^9, 3.559611536724431*^9}, {
   3.559611687491096*^9, 3.559611690923102*^9}, 
   3.5596309502530303`*^9},ExpressionUUID->"a57baa05-6904-4fd7-9d9a-\
58502618b1fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";", 
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb", ",", "tc"}], "]"}], ";", 
  RowBox[{"ta", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "1", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tb", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "2", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tc", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"c", ",", "0", ",", "2"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5636304365243855`*^9, 3.563630452093213*^9}, {
   3.563687352565164*^9, 3.563687397633643*^9}, 3.5638065170607915`*^9, {
   3.563806573604026*^9, 3.5638066232118626`*^9}, {3.5638759382947426`*^9, 
   3.563875953411169*^9}, {3.5680977629646406`*^9, 
   3.5680977832688017`*^9}},ExpressionUUID->"ae0686a3-b1bd-4ca4-8e3c-\
d67dcb798ef8"],

Cell[BoxData[
 RowBox[{"tpr", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tb", ",", "tc"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5638759943768415`*^9, 
  3.5638760165912805`*^9}},ExpressionUUID->"a7604056-98be-4d1e-ac7e-\
c03cd7029f26"],

Cell[BoxData[
 RowBox[{"tab", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5596104484041195`*^9, 3.5596107865035133`*^9}, 
   3.559610823865579*^9, {3.5596108857976875`*^9, 3.5596110067447004`*^9}, {
   3.5596110444031663`*^9, 3.559611062857999*^9}, 3.5596111755837965`*^9, {
   3.5614620273048444`*^9, 3.561462029583975*^9}, 3.5638064918693504`*^9, {
   3.56380652718237*^9, 3.5638065347418027`*^9}, 3.5638065662056026`*^9, {
   3.5638066327334075`*^9, 
   3.563806659458936*^9}},ExpressionUUID->"9565f7b8-a0f5-4536-b310-\
d3172ab1c8e7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tabc", "=", 
   RowBox[{"tensorproduct", "[", 
    RowBox[{"tab", ",", " ", "tc"}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.5596104484041195`*^9, 3.5596107865035133`*^9}, 
   3.559610823865579*^9, {3.5596108857976875`*^9, 3.5596110067447004`*^9}, {
   3.5596110444031663`*^9, 3.559611062857999*^9}, {3.5596112136322637`*^9, 
   3.5596113458268957`*^9}, {3.5614622910649304`*^9, 3.5614622933360605`*^9}, 
   3.563806686237468*^9, {3.56380673715038*^9, 3.563806798795906*^9}, 
   3.563807361420086*^9},ExpressionUUID->"8def0e61-1a29-4c2f-a3a6-\
05c0538827da"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "tpr"}]], "Input",
 CellChangeTimes->{{3.563876218299635*^9, 
  3.5638762222620416`*^9}},ExpressionUUID->"6e4487be-fe65-46e3-8a74-\
4a1463dab667"],

Cell[BoxData[
 RowBox[{"tabc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563807840154468*^9, 3.563807865516919*^9}, 
   3.563883271691944*^9, 
   3.5680978678126373`*^9},ExpressionUUID->"0f7707f1-34c3-4726-93dc-\
d0d22f7bced2"],

Cell[BoxData[
 RowBox[{"tbc", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"tb", ",", "tc"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563806889631101*^9, 
  3.563806912700421*^9}},ExpressionUUID->"5fb9456d-a888-4e89-bb14-\
223dd09dd259"],

Cell[BoxData[
 RowBox[{"tabc1", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tbc"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5638069288173428`*^9, 3.563806983356462*^9}, {
  3.563807297716442*^9, 
  3.563807321875824*^9}},ExpressionUUID->"3d046aa4-1c9a-49a3-aa04-\
9341c91bc2ea"],

Cell["\<\
Obviously, the tensors tabc and tabc1 are formally different:\
\>", "Text",
 CellChangeTimes->{{3.563807015682311*^9, 3.5638070724495583`*^9}, {
   3.5638071630657406`*^9, 3.5638071696021147`*^9}, 3.563807334969573*^9, {
   3.563807383673359*^9, 3.563807389009664*^9}, 
   3.5638763092165947`*^9},ExpressionUUID->"8ddc1bfd-b4d2-44b8-86b5-\
19e966812800"],

Cell[BoxData[
 RowBox[{"type", "[", "tabc", "]"}]], "Input",
 CellChangeTimes->{{3.5638071736113443`*^9, 3.5638071836189165`*^9}, 
   3.5638072735570607`*^9, 
   3.563807394619985*^9},ExpressionUUID->"75004cb1-0895-4591-80da-\
c2efc1517a61"],

Cell[BoxData[
 RowBox[{"type", "[", "tabc1", "]"}]], "Input",
 CellChangeTimes->{{3.5638071736113443`*^9, 3.5638071836189165`*^9}, 
   3.5638072735570607`*^9, {3.563807394619985*^9, 
   3.5638074072517076`*^9}},ExpressionUUID->"d33d832a-d827-42e4-a1e0-\
18b7cf0756d7"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tabc", ",", "tabc1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6447339749349413`*^9, 
  3.6447339909717693`*^9}},ExpressionUUID->"1b1fc843-d7a9-4fc9-a699-\
93b8f88e1e96"],

Cell["\<\
The coordinate functions are calculated in another order, they differ:\
\>", "Text",
 CellChangeTimes->{{3.568098193106243*^9, 3.56809823868985*^9}, 
   3.6011837906391993`*^9},ExpressionUUID->"db01e468-6223-449b-911e-\
e60d79b77c0f"],

Cell[BoxData[
 RowBox[{"td", "=", 
  RowBox[{"tabc", "-", "tabc1"}]}]], "Input",
 CellChangeTimes->{{3.5638074548474298`*^9, 
  3.5638074800588717`*^9}},ExpressionUUID->"14f039b4-2f5a-4a42-b2fa-\
b967d64567a5"],

Cell["The coordinate Arrays coincide:", "Text",
 CellChangeTimes->{{3.5680982620491867`*^9, 3.5680982826253633`*^9}, 
   3.601184393424258*^9},ExpressionUUID->"f873fb00-c885-45d3-8691-\
78b7d52413de"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tabc", ",", "tabc1"}], "]"}]], "Input",
 CellChangeTimes->{{3.5680980606266656`*^9, 3.5680980917474456`*^9}, {
  3.601193433881209*^9, 
  3.6011934488884354`*^9}},ExpressionUUID->"45a3a9e4-d37d-4643-b81b-\
90a9107615ce"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"td", ",", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "4"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5680980606266656`*^9, 3.5680980917474456`*^9}, {
  3.601193433881209*^9, 3.6011934488884354`*^9}, {3.6447340796401258`*^9, 
  3.644734139299631*^9}},ExpressionUUID->"1a3f9c9d-91ce-4746-a980-\
eaa251421769"],

Cell["\<\
This has been tested without setting Attributes[tensorproduct] ={Flat}; thus \
we could set this Attribute in tensalgv2.m.\
\>", "Text",
 CellChangeTimes->{{3.5638824506937017`*^9, 3.5638825671635065`*^9}, {
   3.5638830268027143`*^9, 3.5638830300319195`*^9}, 
   3.642501433878019*^9},ExpressionUUID->"c6c22675-335e-4678-8215-\
b519b018548b"],

Cell[BoxData[
 RowBox[{"?", "Attributes"}]], "Input",
 CellChangeTimes->{{3.563879127018344*^9, 
  3.5638791319479523`*^9}},ExpressionUUID->"8650ef27-41d0-4bbc-b07f-\
882490c09a9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Attributes", "[", "tensorproduct", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5638821310959406`*^9, 3.563882174479617*^9}, {
   3.563882709201756*^9, 3.5638828130199385`*^9}, {3.563883139060511*^9, 
   3.5638831435065193`*^9}, 
   3.567931488285716*^9},ExpressionUUID->"4eac88b5-ff81-465d-a653-\
b603ddd88c78"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", 
    RowBox[{"tensorproduct", "[", 
     RowBox[{"tb", ",", "tc"}], "]"}]}], "]"}], "==", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{
    RowBox[{"tensorproduct", "[", 
     RowBox[{"ta", ",", "tb"}], "]"}], ",", "tc"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5638821862576375`*^9, 3.5638823574991384`*^9}, {
   3.5638828272315636`*^9, 3.563882875373248*^9}, {3.563882950846181*^9, 
   3.5638829657598066`*^9}, 
   3.563883203270224*^9},ExpressionUUID->"70b5293b-dbd3-4b52-9c18-\
8b80c1dc3b9a"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"tensorproduct", "[", 
    RowBox[{"ta", ",", 
     RowBox[{"tensorproduct", "[", 
      RowBox[{"tb", ",", "tc"}], "]"}]}], "]"}], "==", 
   RowBox[{"tensorproduct", "[", 
    RowBox[{"ta", ",", "tb", ",", "tc"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5638821862576375`*^9, 3.563882390539996*^9}, {
  3.5640423002500477`*^9, 3.564042381572991*^9}, {3.564042459370328*^9, 
  3.5640424642531357`*^9}, {3.5640425424404736`*^9, 
  3.5640425657469144`*^9}},ExpressionUUID->"2058575c-7656-465f-a393-\
62f54c4bc1b3"],

Cell["The tensor product is not commutative, example:", "Text",
 CellChangeTimes->{{3.559611647869027*^9, 3.559611674231073*^9}, 
   3.5596117225287576`*^9, 
   3.559630967012989*^9},ExpressionUUID->"4e9b1395-d200-4565-bf90-\
385173c0f83f"],

Cell[BoxData[
 RowBox[{"tbca", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"tbc", ",", "ta"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563876691120865*^9, 
  3.5638767180465126`*^9}},ExpressionUUID->"aaa3a16c-ea1c-4fdc-8a9a-\
a1f955012e8b"],

Cell[BoxData[
 RowBox[{"td1", " ", "=", 
  RowBox[{"tabc", "-", "tbca"}]}]], "Input",
 CellChangeTimes->{{3.563876738217348*^9, 
  3.5638767623661904`*^9}},ExpressionUUID->"5719e275-f46f-4ac1-a197-\
0eb57546e7b6"],

Cell[BoxData[
 RowBox[{"td1", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "3", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563876775969414*^9, 3.5638767910078406`*^9}, {
  3.5680983772127733`*^9, 
  3.5680983795959096`*^9}},ExpressionUUID->"28cb56b5-ae1a-4fbd-a45a-\
1c6df218412b"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.603082262625375*^9, 
  3.603082269473787*^9}},ExpressionUUID->"ead8512e-c06d-4586-9f02-\
1fab34201ed3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb", ",", "w"}], "]"}], ";", 
  RowBox[{"ta", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tb", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "0", ",", "1"}], "]"}]}], ";", 
  RowBox[{"tw", "=", 
   RowBox[{
    RowBox[{"tensorproduct", "[", 
     RowBox[{"ta", ",", "tb"}], "]"}], "-", " ", 
    RowBox[{"tensorproduct", "[", 
     RowBox[{"tb", ",", "ta"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.55961173510238*^9, 3.5596118636310053`*^9}, {
  3.5596119711619945`*^9, 3.5596120055444546`*^9}, {3.55961205396694*^9, 
  3.55961208251499*^9}, {3.5596122836149435`*^9, 3.5596123385894394`*^9}, {
  3.563876851535947*^9, 3.563876855030353*^9}, {3.5638768892100134`*^9, 
  3.563876957335333*^9}, {3.5638769987378054`*^9, 3.563877017957039*^9}, {
  3.563877052136699*^9, 3.563877083945155*^9}, {3.5638773893000917`*^9, 
  3.5638774116861305`*^9}},ExpressionUUID->"4ca7da3d-593d-4ae9-a4a6-\
a8d4e8fb9c29"],

Cell[BoxData[
 RowBox[{"tw", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563877123241624*^9, 3.563877147515267*^9}, {
  3.563877430655764*^9, 
  3.5638774521526017`*^9}},ExpressionUUID->"c28878c5-31a2-41b7-9f16-\
e64b0da1237d"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030823648679543`*^9, 
  3.6030823730267687`*^9}},ExpressionUUID->"35b2619b-8b4a-423d-a217-\
c568b0c330e8"],

Cell[BoxData[
 RowBox[{"ttw", " ", "=", " ", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"tw", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "//", 
   "MatrixForm"}]}]], "Input",
 CellChangeTimes->{{3.5596118758614273`*^9, 3.5596119389323378`*^9}, {
  3.563877646996944*^9, 3.5638776736573906`*^9}, {3.563877920309424*^9, 
  3.5638779446922665`*^9}, {3.568098440693404*^9, 3.56809844254351*^9}, {
  3.6432840108989153`*^9, 
  3.6432840144869213`*^9}},ExpressionUUID->"7d5dcb23-9990-4936-86c3-\
258256d4ad53"],

Cell["\<\
The result is the matrix of the wedge product(see  Section 4.3 below) of the \
tensors ta, tb, not the nullmatrix in general:\
\>", "Text",
 CellChangeTimes->{{3.559612398587145*^9, 3.559612500205724*^9}, {
  3.5638778493917*^9, 3.5638778593913174`*^9}, {3.563878547586526*^9, 
  3.5638785790985813`*^9}, {3.601194175943312*^9, 3.601194226534201*^9}, {
  3.601194302865135*^9, 
  3.6011943233011713`*^9}},ExpressionUUID->"00a10406-9a69-4837-930a-\
959d3c4ce1eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"wedge", "[", 
      RowBox[{"ta", ",", "tb"}], "]"}], "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "j"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.559612212463218*^9, 3.559612254598892*^9}, {
   3.5638778670665307`*^9, 3.5638778777837496`*^9}, {3.56716949817778*^9, 
   3.5671695404791994`*^9}, 3.567169574265132*^9, 3.567169639376856*^9, {
   3.567169681968292*^9, 3.567169780241913*^9}, {3.5671700132502403`*^9, 
   3.5671700269620247`*^9}, 3.6011937730102043`*^9, {3.601194013625027*^9, 
   3.6011940723279305`*^9}, {3.6011941073811917`*^9, 
   3.601194135835642*^9}},ExpressionUUID->"5e912347-5c68-439d-bfea-\
7d59f098f8a8"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "%%"}]], "Input",
 CellChangeTimes->{{3.643284032598553*^9, 
  3.6432840378089623`*^9}},ExpressionUUID->"4f0d2ff8-f8a7-436a-a4d5-\
13f51ad1c8b2"],

Cell[TextData[{
 " ",
 StyleBox["Example.",
  FontColor->RGBColor[0, 0, 1]],
 "\n",
 "As an exercise one  shows: ",
 StyleBox["The elements of the tensor basis are tensor products of vectors \
and covectors, more precisely:",
  FontColor->RGBColor[0, 0, 1]]
}], "Text",
 CellChangeTimes->{{3.5618763842614365`*^9, 3.561876409079856*^9}, {
   3.5638788853583193`*^9, 3.563878888353524*^9}, 3.5671705811977253`*^9, {
   3.567170636918912*^9, 3.5671706492856197`*^9}, 3.643352115340804*^9},
 CellTags->"tensbas",ExpressionUUID->"a30aaf79-656c-460e-952b-f179c07be5d2"],

Cell[BoxData[
 RowBox[{"?", "tstb"}]], "Input",
 CellChangeTimes->{{3.563878666692735*^9, 
  3.5638786688923388`*^9}},ExpressionUUID->"4db1803f-94c3-4772-9d63-\
cfa01a67e892"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tstb", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i1", ",", "...", ",", "ik"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j1", ",", "...", ",", "jh"}], "}"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a1", ",", "...", ",", "ak"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b1", ",", "...", ",", "bh"}], "}"}]}], "]"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"==", " ", 
      RowBox[{
       SubsuperscriptBox["\[Delta]", "a1", "i1"], "*"}]}], "..."}], "*", 
    SubsuperscriptBox["\[Delta]", "ak", "ik"], "*", 
    SubsuperscriptBox["\[Delta]", "j1", "b1"], "*"}], "..."}], "*", 
  SubsuperscriptBox["\[Delta]", "jh", "bh"]}]}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.567170417601368*^9, 
  3.567170427760949*^9}},ExpressionUUID->"df249cb7-f49d-4185-8ae6-\
8f0a91f06db8"],

Cell[TextData[{
 "where ",
 "the Kronecker symbol",
 " ",
 Cell[BoxData[
  RowBox[{" ", 
   SubsuperscriptBox["\[Delta]", "a", "i"], " "}]],
  CellChangeTimes->{{3.561873835763671*^9, 3.561873923938714*^9}, {
   3.5618740097396216`*^9, 3.5618740634116917`*^9}, {3.561874874356075*^9, 
   3.5618749334954576`*^9}, {3.561874994067922*^9, 3.561875004089495*^9}, {
   3.5618751623495474`*^9, 3.5618752776091394`*^9}},ExpressionUUID->
  "32367e95-90c9-4eca-a2ad-3b70793647fb"],
 " =",
 Cell[BoxData["\[Delta]"],
  CellChangeTimes->{{3.561873835763671*^9, 3.561873923938714*^9}, {
   3.5618740097396216`*^9, 3.5618740634116917`*^9}, {3.561874874356075*^9, 
   3.5618749334954576`*^9}, {3.561874994067922*^9, 3.561875004089495*^9}, {
   3.5618751623495474`*^9, 3.5618752776091394`*^9}},ExpressionUUID->
  "864cc255-b602-45ce-a740-0939699da220"],
 "[i,a] stands for"
}], "Text",
 CellChangeTimes->{{3.561875483705928*^9, 
  3.5618756482533393`*^9}},ExpressionUUID->"19763435-184f-4366-8998-\
df41637668d1"],

Cell[BoxData[
 RowBox[{"?", "KroneckerDelta"}]], "Input",
 CellChangeTimes->{{3.561875661221081*^9, 
  3.56187567239172*^9}},ExpressionUUID->"e2a33a7d-c83c-4a11-80dc-\
882918899f91"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.5671708345902185`*^9, 
  3.567170840823575*^9}},ExpressionUUID->"08845bf8-5b7d-4027-9b41-\
19a5e17a5a6f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pv", "[", 
   RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", "i", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}], ",", 
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", "j", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.567170655310964*^9, 3.567170675647127*^9}, {
  3.5671707057038465`*^9, 
  3.5671708251206765`*^9}},ExpressionUUID->"17020d7a-f6ad-4640-8068-\
2031f15baa5d"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"equi", "[", " ", 
    RowBox[{
     RowBox[{"pv", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"tstb", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "dim"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6011944221429443`*^9, 
  3.6011945521691732`*^9}},ExpressionUUID->"8fd81dc4-410a-418f-af9d-\
b21374799410"],

Cell["OK! Construct more examples! \[FilledSmallSquare]", "Text",
 CellChangeTimes->{{3.5671712237264757`*^9, 3.5671712467177906`*^9}, {
  3.6433521525780697`*^9, 
  3.643352160440483*^9}},ExpressionUUID->"3d94678d-732b-4662-a884-\
77bc4e6445af"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3.4. Functions as coordinates", "Subsubsection",
 CellChangeTimes->{{3.5679306639135647`*^9, 3.5679307067670155`*^9}, 
   3.568098628764161*^9, 3.568100556617428*^9, 3.601184397870266*^9, 
   3.643284157024372*^9, 
   3.643284914374502*^9},ExpressionUUID->"7fa06f8f-a0a5-42c4-93ab-\
3359b73e274e"],

Cell["\<\
To define a tensor with explicit coordinates, first define the symbolic \
tensor of the wanted type, and then specify the coordinates,  which can be \
arbitrary objects, e. g. functions.\
\>", "Text",
 CellChangeTimes->{{3.5596308988280888`*^9, 3.5596309293478346`*^9}, {
   3.561873024688163*^9, 3.5618730301637726`*^9}, {3.5680986641141834`*^9, 
   3.568098837042074*^9}, {3.6011844015830727`*^9, 3.6011844025814743`*^9}, 
   3.643461416304693*^9, 
   3.643461450521554*^9},ExpressionUUID->"6d853fcb-e2cb-4c94-b63b-\
e4e0dde95a45"],

Cell[TextData[{
 StyleBox["Example.",
  FontColor->RGBColor[0, 0, 1]],
 " The metric tensor of the unit sphere has the shape"
}], "Text",
 CellChangeTimes->{{3.5676622336290693`*^9, 
  3.567662261646719*^9}},ExpressionUUID->"67d542f7-138a-454e-8eb4-\
7fd5758b026a"],

Cell[BoxData[
 RowBox[{"tg", " ", ":=", 
  RowBox[{"tensor", "[", 
   RowBox[{"g", ",", "2", ",", "0", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5676604560233707`*^9, 3.567660495865841*^9}, 
   3.5676634659463787`*^9},ExpressionUUID->"e48097df-ac45-480f-830d-\
7e5c9074977a"],

Cell["The type of the tensor is ", "Text",
 CellChangeTimes->{{3.5676629162862687`*^9, 
  3.56766292850109*^9}},ExpressionUUID->"b037b2df-765d-418c-be7f-\
9d36d1896f0b"],

Cell[BoxData[
 RowBox[{"type", "[", "tg", "]"}]], "Input",
 CellChangeTimes->{{3.567662931262295*^9, 
  3.567662937112305*^9}},ExpressionUUID->"1cb5abb6-7952-4de2-8fe8-\
071430b6ea86"],

Cell["We specify the coordinates:", "Text",
 CellChangeTimes->{{3.567662986439592*^9, 3.5676630049100246`*^9}, 
   3.6011844362931337`*^9},ExpressionUUID->"e2986bd7-6907-4f08-a417-\
a0181addc7e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", " ", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
  3.5676606688971214`*^9, 
  3.5676606826875453`*^9}},ExpressionUUID->"ea42176f-ef26-4e6b-b95e-\
6fa70cfe8050"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", " ", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
  3.5676606688971214`*^9, 
  3.567660721422414*^9}},ExpressionUUID->"1cd0b8a9-1a83-4136-9037-\
43a7a285ec95"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", " ", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
  3.5676606688971214`*^9, 
  3.5676607515928664`*^9}},ExpressionUUID->"c032c9e9-d527-47fe-ac35-\
70a28de3f373"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", 
   RowBox[{
    RowBox[{"Cos", "[", "x", "]"}], "^", "2"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
  3.5676606688971214`*^9, 3.5676607515928664`*^9}, {3.567660783182922*^9, 
  3.567660818548184*^9}},ExpressionUUID->"081f77a7-e1df-46f5-9cb3-\
b65394d138ce"],

Cell[BoxData[
 RowBox[{"coords", "[", "tg", "]"}]], "Input",
 CellChangeTimes->{{3.5676608411838236`*^9, 
  3.5676608509338408`*^9}},ExpressionUUID->"82d9d9df-7972-4a99-a496-\
06173096c181"],

Cell["\<\
To deform the metric a bit, we define a second tensor th of the same type \
(2,0)\
\>", "Text",
 CellChangeTimes->{{3.567662414292987*^9, 
  3.567662489485119*^9}},ExpressionUUID->"03acb277-dbb3-4cc6-85c5-\
10d47f88e054"],

Cell[BoxData[
 RowBox[{"th", " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"h", ",", "2", ",", "0", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5676611182091103`*^9, 3.5676611466323605`*^9}, 
   3.5676634837543974`*^9},ExpressionUUID->"d4c0f4de-8185-4c92-afb4-\
64271749e93d"],

Cell[BoxData[
 RowBox[{"type", "[", "th", "]"}]], "Input",
 CellChangeTimes->{{3.5676633822225895`*^9, 
  3.5676633890109777`*^9}},ExpressionUUID->"3d004225-319d-4808-a589-\
1f317a0f72c9"],

Cell["with coordinates", "Text",
 CellChangeTimes->{{3.5676634055279226`*^9, 3.56766341107224*^9}, 
   3.6011844374631357`*^9},ExpressionUUID->"8d874fda-bdbd-48c3-abe8-\
5e80ed47328a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", " ", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
   3.5676606688971214`*^9, 3.5676606826875453`*^9}, 
   3.5676612401857243`*^9},ExpressionUUID->"bb844e17-1f45-49e6-a4e8-\
052ebb815e2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", " ", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
   3.5676606688971214`*^9, 3.567660721422414*^9}, 
   3.5676612447097325`*^9},ExpressionUUID->"b770890e-ae00-424f-907a-\
eb0766be62a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
   3.5676606688971214`*^9, 3.5676607515928664`*^9}, {3.567661304317437*^9, 
   3.5676613102766476`*^9}, 
   3.5676618719088345`*^9},ExpressionUUID->"08cf1922-0d1b-469d-ad6d-\
0008cf27afd7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "=", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.5676605247414913`*^9, 3.5676605782651854`*^9}, {
  3.5676606688971214`*^9, 3.5676607515928664`*^9}, {3.567660783182922*^9, 
  3.567660818548184*^9}, {3.567661286283806*^9, 
  3.5676613146134553`*^9}},ExpressionUUID->"92daa414-3485-4c96-83a4-\
4b5e719b9753"],

Cell["The deformed tensor  is", "Text",
 CellChangeTimes->{{3.5676634259600916`*^9, 
  3.567663448679391*^9}},ExpressionUUID->"82eb2885-27a7-40f1-94aa-\
082eafd78626"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tgdef", "[", "t_", "]"}], " ", ":=", " ", 
  RowBox[{"tg", " ", "+", " ", 
   RowBox[{
    RowBox[{"f", "[", "t", "]"}], "*", "th"}]}]}]], "Input",
 CellChangeTimes->{{3.5676613689171505`*^9, 3.567661443563282*^9}, 
   3.5676615659454966`*^9, 3.5676617583718348`*^9, 3.567661938567751*^9, {
   3.56766251279156*^9, 3.5676625159583654`*^9}, 3.567663509577874*^9, {
   3.5676636333869553`*^9, 
   3.567663639946331*^9}},ExpressionUUID->"140e037c-d2d7-41d5-b641-\
f681318ac608"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"tgdef", "[", "t", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.567663524992756*^9, 
  3.567663537673481*^9}},ExpressionUUID->"067fa764-8f62-4a07-8e24-\
64b70fad8d3a"],

Cell["\<\
Here times is a function defining the product of a tensor with a scalar.\
\>", "Text",
 CellChangeTimes->{{3.567662592008499*^9, 
  3.567662624316156*^9}},ExpressionUUID->"a851d8de-3ce3-4d66-bdcf-\
c8dbe09b2ebc"],

Cell[BoxData[
 RowBox[{"coords", "[", 
  RowBox[{"tgdef", "[", "t", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5676617844238806`*^9, 3.5676617913502927`*^9}, {
  3.5676635838751235`*^9, 
  3.5676635908655233`*^9}},ExpressionUUID->"dc313e33-64b3-466f-8306-\
3034d3ec853d"],

Cell["\<\
The explicitly defined coordinates may have arbitrary, may be distinct Heads:\
\
\>", "Text",
 CellChangeTimes->{{3.5693329847313128`*^9, 3.569333057099839*^9}, 
   3.6011844385551376`*^9, 3.603082951444585*^9, 
   3.643461472548793*^9},ExpressionUUID->"6be6ae34-0462-421a-aefb-\
756a17fc1fa3"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"tg", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5676609799616675`*^9, 3.5676610089465184`*^9}, 
   3.567662784544037*^9},ExpressionUUID->"30299522-cf00-4db7-accd-\
bc73758698e6"],

Cell[BoxData[
 RowBox[{"tg", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",ExpressionUUID->"159335ce-d43c-4151-\
bffa-ddb74485750f"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"th", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5676609799616675`*^9, 3.5676610089465184`*^9}, {
  3.567662758741592*^9, 
  3.567662794808855*^9}},ExpressionUUID->"d05e232d-7c27-4a3a-abed-\
0a92ba0fb974"],

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{
   RowBox[{"tgdef", "[", "t", "]"}], "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5676619894238405`*^9, 3.567662005710269*^9}, {
  3.5676628261025105`*^9, 
  3.5676628433093405`*^9}},ExpressionUUID->"41082c37-31f6-4fe7-aaaf-\
0a0d0c8b8882"],

Cell[BoxData[
 RowBox[{"coords", "[", 
  RowBox[{"tgdef", "[", ".5", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5676614820953493`*^9, 3.567661520159416*^9}, 
   3.5676638989381447`*^9},ExpressionUUID->"d5dff26b-811e-4d47-89da-\
2c87f4485791"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", "ta", ",", "tb", ",", "tc"}], "]"}], 
  ";", 
  RowBox[{"ta", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "2"}], "]"}]}], ";", 
  RowBox[{"tb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], ",", "0", ",", "0"}], "]"}]}], ";", 
  RowBox[{"tc", "=", 
   RowBox[{"tensorproduct", "[", 
    RowBox[{"ta", ",", "tb"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.558936994264454*^9, 3.5589370216893015`*^9}, {
   3.558938567636417*^9, 3.55893856952402*^9}, 3.5591125598561897`*^9, {
   3.5592076267331944`*^9, 3.55920765826085*^9}, {3.5596075019645443`*^9, 
   3.5596075049753494`*^9}, {3.5596082575674715`*^9, 3.559608266958688*^9}, 
   3.559609266436844*^9, {3.5596098573814816`*^9, 3.559609863808693*^9}, {
   3.5596100567186317`*^9, 3.5596100609306393`*^9}, {3.559630799450405*^9, 
   3.559630800425461*^9}, {3.5637174071272955`*^9, 3.5637174909618425`*^9}, {
   3.56371758651201*^9, 3.563717595513226*^9}, {3.56371771731824*^9, 
   3.5637177360850725`*^9}, {3.563719614281572*^9, 
   3.563719632986005*^9}},ExpressionUUID->"b6171b14-26f6-4bd9-ac3a-\
6de04c50819d"],

Cell[BoxData[
 RowBox[{"type", "[", "tc", "]"}]], "Input",
 CellChangeTimes->{{3.5693330926055017`*^9, 
  3.5693330985959125`*^9}},ExpressionUUID->"41cdbee6-7d2d-45e3-b895-\
46ed89f90d03"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5596100798222723`*^9, 3.5596100981991043`*^9}, {
   3.563717516265087*^9, 3.5637175292131095`*^9}, 3.563717677038969*^9, {
   3.5637177569579096`*^9, 
   3.563717777939946*^9}},ExpressionUUID->"41324e5e-0d70-4a13-8b5a-\
b700391501b3"],

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"x", "\[Rule]", 
   RowBox[{"Pi", "/", "3"}]}]}]], "Input",
 CellChangeTimes->{{3.5596308098740015`*^9, 3.5596308247258506`*^9}, {
   3.567929154274218*^9, 3.5679291603545656`*^9}, 3.569333191572076*^9, 
   3.569333300070266*^9},ExpressionUUID->"93dfff11-58d9-4136-a87b-\
cc1de3e87c58"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5681004816361394`*^9, 
  3.568100488627539*^9}},ExpressionUUID->"a5787cdc-953e-4025-aa25-\
e76f686de170"],

Cell[TextData[{
 StyleBox["Remark.",
  FontColor->RGBColor[0, 0, 1]],
 "\nTensors with functions as coordinates are named ",
 StyleBox["tensor fields",
  FontColor->RGBColor[0, 0, 1]],
 "; they are studied in  the ",
 StyleBox["Tensor Analysis",
  FontColor->RGBColor[0, 0, 1]],
 ". We intend to implement this into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " in a future notebook. For the algebraic operations of such tensor fields \
it must be assumed that  the tensor coordinates are functions defined in the \
same domain, mostly an open region in the space of variables, and have values \
in the field of real or complex numbers."
}], "Text",
 CellChangeTimes->{{3.603083340684741*^9, 3.6030833717075157`*^9}, {
   3.6030834388603563`*^9, 3.6030835650435734`*^9}, {3.6030836008116193`*^9, 
   3.603083818444067*^9}, {3.6030838497568583`*^9, 3.6030838511879396`*^9}, 
   3.6030838874200125`*^9, {3.6030839219719887`*^9, 3.6030839851316013`*^9}, 
   3.6030840921487226`*^9, 
   3.643284749700613*^9},ExpressionUUID->"9ef7f9ae-15b6-4517-b519-\
07f2589d89ac"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3.4. Basis Transformations. Tensor Invariants", "Subsection",
 CellChangeTimes->{{3.5586058911697264`*^9, 3.558605905506151*^9}, {
   3.5587818471597633`*^9, 3.558781854431179*^9}, {3.558879858528432*^9, 
   3.558879866000845*^9}, {3.5590307253995867`*^9, 3.5590307378632994`*^9}, {
   3.5590331974995737`*^9, 3.5590331995066886`*^9}, {3.559612614007923*^9, 
   3.559612630091552*^9}, 3.5596392280529337`*^9, 3.560769613218051*^9, 
   3.561450220527591*^9, 3.561462394469845*^9, {3.561877042434082*^9, 
   3.5618770781501245`*^9}, 3.561882692581252*^9, 3.567171333877776*^9, {
   3.567171452270548*^9, 3.5671714634691877`*^9}, 3.5681978303590236`*^9, 
   3.601195025271204*^9, 3.6030993662271643`*^9, 3.6432849228297167`*^9, 
   3.6433569763443947`*^9},ExpressionUUID->"c8e675b9-5679-438f-a4ee-\
02ab2bb2499d"],

Cell[CellGroupData[{

Cell["3.4.1. Basis and Coordinate Transformations", "Subsubsection",
 CellChangeTimes->{{3.562308002583559*^9, 3.5623080519633837`*^9}, {
   3.564120555198907*^9, 3.5641205945889764`*^9}, 3.568197837815837*^9, 
   3.5685335713739276`*^9, {3.6030915950960693`*^9, 
   3.6030916047266197`*^9}},ExpressionUUID->"7b61557b-d373-4003-9c8f-\
d1b91372f764"],

Cell["\<\
In Subsection 2.2.2 we considered a basis transformation, see formula (1) \
there, with  the transformation matrix mb\
\>", "Text",
 CellChangeTimes->{{3.5618773618513517`*^9, 3.5618774112801785`*^9}, 
   3.568197860669877*^9, {3.6011971555953455`*^9, 3.6011971920370097`*^9}, {
   3.6027438936381025`*^9, 3.60274394315259*^9}, {3.602744004289097*^9, 
   3.6027440730228176`*^9}},ExpressionUUID->"e81330cb-374e-4700-aad3-\
9ed905ed52c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.603088618848838*^9, 
  3.6030886230800796`*^9}},ExpressionUUID->"cd66826e-c240-4755-b678-\
e8094ad66056"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"mb", ",", "b", ",", "i", ",", "j"}], "]"}], ";", 
   RowBox[{"mb", " ", "=", 
    RowBox[{
     RowBox[{"matrix", "[", "b", "]"}], "/.", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"i_", ",", "j_"}], "]"}], "\[Rule]", " ", 
      RowBox[{"b", "[", 
       RowBox[{
        RowBox[{"{", "i", "}"}], ",", 
        RowBox[{"{", "j", "}"}]}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6011971988542213`*^9, 3.6011972051722326`*^9}, 
   3.60119724900831*^9, 3.6026671912448926`*^9, {3.6026676701189337`*^9, 
   3.6026676989165845`*^9}, {3.6026679284241877`*^9, 
   3.6026679296409893`*^9}, {3.6030884398646*^9, 3.6030884891624203`*^9}, {
   3.6030885832738028`*^9, 3.6030886548108945`*^9}, 3.6030892081235423`*^9, {
   3.603089425788992*^9, 3.603089452257506*^9}, {3.603089500010237*^9, 
   3.603089501930347*^9}, 3.603089546377889*^9, 
   3.6432851771725636`*^9},ExpressionUUID->"c07c7a60-d478-42f3-b9ea-\
24ff67b38f92"],

Cell[BoxData[
 RowBox[{"mb", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.643285183646575*^9, 
  3.643285191540189*^9}},ExpressionUUID->"e8468b5b-f757-4a9e-9886-\
c6fcf8824288"],

Cell["\<\
Now the coefficients b[i,j] remain symbolical, not explicitly defined \
elements assumed to belong to the field K. \
\>", "Text",
 CellChangeTimes->{{3.602668134328949*^9, 3.602668240752336*^9}, {
   3.602668276070798*^9, 3.6026682803140054`*^9}, {3.6026684003038716`*^9, 
   3.6026684499037085`*^9}, {3.6026684818485355`*^9, 
   3.6026685371686993`*^9}, {3.6027440998236647`*^9, 3.6027441036144714`*^9}, 
   3.643461480727207*^9},ExpressionUUID->"af88515a-b369-4bd6-8a72-\
f7a34b3db883"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "vb", "]"}], ";", " ", 
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", "1"}], ",", 
    RowBox[{"i", "<", 
     RowBox[{"dim", "+", "1"}]}], ",", 
    RowBox[{"i", "++"}], ",", 
    RowBox[{
     RowBox[{"vb", "[", "i", "]"}], " ", "=", " ", 
     RowBox[{"mb", "[", 
      RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5618774182305765`*^9, 3.5618774695365105`*^9}, 
   3.5618775281858654`*^9, {3.561878464838439*^9, 3.5618785278430424`*^9}, {
   3.562311405532197*^9, 3.562311414475708*^9}, {3.562311504243843*^9, 
   3.562311508811104*^9}, {3.562311680098901*^9, 3.5623116878503447`*^9}, {
   3.5640616290214415`*^9, 3.5640616380382576`*^9}, 3.5682098114486713`*^9, {
   3.6011970429163475`*^9, 3.6011971060340586`*^9}, {3.6011972178394547`*^9, 
   3.601197245311103*^9}, {3.6026672306661615`*^9, 3.6026672513829985`*^9}, {
   3.602667492216221*^9, 3.6026675053514442`*^9}, {3.6026675607315416`*^9, 
   3.602667608436425*^9}, 3.6026678773964977`*^9, {3.6026679581890397`*^9, 
   3.602667986440689*^9}, {3.603088876441571*^9, 3.603088877881654*^9}, {
   3.6030895876102476`*^9, 
   3.6030896024490967`*^9}},ExpressionUUID->"8a16baae-f823-468b-a7cc-\
6b4e4a63d7b1"],

Cell[BoxData[
 RowBox[{"vb", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.603088765716238*^9, 3.603088771119547*^9}, 
   3.6030889557681084`*^9, 
   3.6030891802169456`*^9},ExpressionUUID->"ec360b9a-60ec-4521-b77d-\
42ca52aabac0"],

Cell["\<\
The new basis vectors have the rows of mb as coordinates with respect to the \
standard basis:\
\>", "Text",
 CellChangeTimes->{{3.602668567560438*^9, 
  3.6026686526243033`*^9}},ExpressionUUID->"7ec8d0ee-30de-43d2-9164-\
be7269b5ed23"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"vb", "[", "i", "]"}], " ", "\[Equal]", " ", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{
         RowBox[{"{", "i", "}"}], ",", 
         RowBox[{"{", "j", "}"}]}], "]"}], "*", 
       RowBox[{"stb", "[", "j", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6026678879577165`*^9, 3.602667894634528*^9}, {
  3.6027441720049915`*^9, 3.602744264981155*^9}, {3.6027443340112762`*^9, 
  3.6027443419984903`*^9}, {3.602744400046192*^9, 3.602744406192603*^9}, {
  3.6030886992184343`*^9, 
  3.6030887225227675`*^9}},ExpressionUUID->"6dfa21ad-42a8-409c-8de7-\
ee2a5c14c21a"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " automatically, and we too, assume:"
}], "Text",
 CellChangeTimes->{{3.6027445109155865`*^9, 3.6027445592600718`*^9}, {
  3.643348876247915*^9, 
  3.6433488808031225`*^9}},ExpressionUUID->"d7ed59bd-721b-4b3b-9ccb-\
5e0ff1bce056"],

Cell[BoxData[
 RowBox[{"MatrixRank", "[", "mb", "]"}]], "Input",
 CellChangeTimes->{{3.602669030827935*^9, 
  3.6026690404644866`*^9}},ExpressionUUID->"79b21028-fb65-4697-b199-\
f3dd890c548c"],

Cell[TextData[{
 " Using the ",
 ButtonBox["Einstein sum convention",
  BaseStyle->"Hyperlink",
  ButtonData->"1stein"],
 " we can write the basis transformation in traditional form:"
}], "Text",
 CellChangeTimes->{{3.56187857098551*^9, 3.561878770701933*^9}, {
   3.562311436747982*^9, 3.5623114641965523`*^9}, 3.568197899279945*^9, {
   3.568207392892823*^9, 3.5682075210470486`*^9}, {3.5682080498155775`*^9, 
   3.568208059581194*^9}, {3.601197277057159*^9, 3.601197306744011*^9}, 
   3.6012144160788956`*^9, {3.602570883475604*^9, 3.602570902492038*^9}, 
   3.6027446001165433`*^9},ExpressionUUID->"f7710b2a-ce53-4bee-88c1-\
9f4f9e38e19c"],

Cell[BoxData[
 RowBox[{
  FormBox[
   SubscriptBox["vb", 
    RowBox[{
     RowBox[{"{", "i", "}"}], "  "}]],
   TraditionalForm], "  ", "\[DotEqual]", "  ", 
  RowBox[{
   TemplateBox[{SubscriptBox["b", 
      RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
    "Superscript"], 
   FormBox[
    SubscriptBox["va", 
     RowBox[{
      RowBox[{"{", "j", "}"}], "  "}]],
    TraditionalForm], "                                                      ", 
   RowBox[{"(", "1", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568207582916757*^9, 3.568207730779417*^9}, 
   3.568207852974431*^9, {3.568207883737685*^9, 3.5682079146569395`*^9}, 
   3.5682085169427977`*^9, {3.5682113378489523`*^9, 3.5682113598293905`*^9}, 
   3.5682114230719023`*^9, {3.568523542055912*^9, 3.5685235436159143`*^9}, {
   3.6026692517305703`*^9, 3.6026692525946198`*^9}, 3.6026693182183733`*^9, {
   3.602744629210594*^9, 3.6027446508634324`*^9}, 
   3.643348943655633*^9},ExpressionUUID->"7fe24a3a-121d-4d60-ac53-\
5730e7cae92e"],

Cell["with the notations", "Text",
 CellChangeTimes->{{3.5682080888468456`*^9, 
  3.5682080978792615`*^9}},ExpressionUUID->"cfb93983-52f1-43f5-884a-\
7ed7fd311ef6"],

Cell[BoxData[
 FormBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{
     SubscriptBox["vb", 
      RowBox[{
       RowBox[{"{", "i", "}"}], "  "}]], " ", "\[DotEqual]", " ", 
     RowBox[{"vb", "[", "i", "]"}]}], ";", "    ", 
    RowBox[{
     TemplateBox[{SubscriptBox["b", 
        RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
      "Superscript"], " ", "\[DotEqual]", " ", 
     RowBox[{"b", "[", 
      RowBox[{"i", ",", "j"}], "]"}]}], ";", " ", 
    RowBox[{
     SubscriptBox["va", 
      RowBox[{
       RowBox[{"{", "i", "}"}], "  "}]], "\[DotEqual]", 
     RowBox[{"stb", "[", "i", "]"}]}], " ", ";"}], 
   "                         "}], TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568207947744598*^9, 3.5682080350891514`*^9}, {
   3.568208130171318*^9, 3.568208172135392*^9}, {3.5682113752110176`*^9, 
   3.568211383167032*^9}, {3.5685235498403254`*^9, 3.568523560588744*^9}, {
   3.6026692686385374`*^9, 3.6026692844294405`*^9}, 3.6026693240427065`*^9, 
   3.6027453615226808`*^9, {3.603086865520553*^9, 3.6030868752491093`*^9}, {
   3.6433489654800715`*^9, 
   3.643348981095699*^9}},ExpressionUUID->"2dad2e54-ebf5-4019-804e-\
f41291358001"],

Cell["\<\
From formula 2.2.2.(2) it follows for the corresponding transformation of the \
coordinates of the vector vx:\
\>", "Text",
 CellChangeTimes->{{3.6027453818963165`*^9, 3.6027454370580134`*^9}, {
   3.6027455510318136`*^9, 3.6027455725442514`*^9}, 3.6030869176625357`*^9, {
   3.643349008972948*^9, 3.643349013184955*^9}, 3.6433508783710313`*^9, 
   3.6434615025516453`*^9},ExpressionUUID->"561d4037-f5ca-4630-bbe4-\
afd1a075907b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "[", "j", "]"}], " ", "=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "k", "]"}], "*", 
     RowBox[{"c", "[", 
      RowBox[{"k", ",", "j"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.602745607457113*^9, 
  3.6027457017904787`*^9}},ExpressionUUID->"40a2e3d4-3308-4133-8810-\
b4e98fc3f1b9"],

Cell["or in traditional form", "Text",
 CellChangeTimes->{{3.602745724862919*^9, 
  3.602745747046158*^9}},ExpressionUUID->"c4136ad2-ca78-4b09-85da-\
79658a5809a6"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["y", 
   RowBox[{"{", "j", "}"}]], " ", "=", " ", 
  RowBox[{
   SuperscriptBox["x", 
    RowBox[{
     RowBox[{"{", "k", "}"}], " "}]], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", "k", "}"}]],RowBox[{"{", "j", "}"}]},
    "Superscript"], "                                                                   ", 
   RowBox[{"(", "2", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6027457576229763`*^9, 3.6027459978945985`*^9}, {
  3.603086954017615*^9, 
  3.603086956824775*^9}},ExpressionUUID->"1b6b6942-aaef-4b43-a321-\
825fb10a2373"],

Cell[TextData[{
 "where the c[k,j] = ",
 Cell[BoxData[
  TemplateBox[{SubscriptBox["c", 
     RowBox[{"{", "k", "}"}]],RowBox[{"{", "j", "}"}]},
   "Superscript"]],
  Evaluatable->False,
  CellChangeTimes->{{3.6027457576229763`*^9, 3.6027459978945985`*^9}},
  ExpressionUUID->"3c3c68b8-1a15-4d52-aeda-e45f689fdb7a"],
 " are the elements of the inverse matrix"
}], "Text",
 CellChangeTimes->{{3.6027460858631525`*^9, 
  3.6027461304480314`*^9}},ExpressionUUID->"ec26a586-3671-43bb-b68a-\
ad70e7cc2594"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mc", "=", " ", 
   RowBox[{"Inverse", "[", "mb", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5682090377341123`*^9, 3.5682090851581955`*^9}, 
   3.568209356614272*^9, {3.5682093879703274`*^9, 3.568209388750329*^9}, {
   3.5682094246771917`*^9, 3.5682094398404183`*^9}, {3.6011975321332073`*^9, 
   3.601197552959244*^9}, {3.6011975855165005`*^9, 3.6011976303665795`*^9}, {
   3.6025709713505583`*^9, 3.6025709737997627`*^9}, 
   3.6030905723455715`*^9},ExpressionUUID->"a7b97435-9116-43b7-ab1c-\
b02e4039bf64"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", 
   RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", " ", 
  RowBox[{"mc", "[", 
   RowBox[{"[", 
    RowBox[{"i", ",", "j"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.643350963621981*^9, 
  3.643351024181288*^9}},ExpressionUUID->"245edeb2-df9a-40b7-b8fb-\
ee0257e00ff5"],

Cell[BoxData[
 RowBox[{"c", "[", 
  RowBox[{"1", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6026697680741034`*^9, 
  3.6026697739534397`*^9}},ExpressionUUID->"759631ce-d63f-4250-b2c8-\
dd9dd91625cc"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.603089755682861*^9, 
  3.6030897606641455`*^9}},ExpressionUUID->"f0771008-0eba-43e1-8fc2-\
e957a8410609"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"mc", ".", "mb"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6030906178891764`*^9, 3.6030906333640614`*^9}, {
  3.603090765569623*^9, 
  3.6030907843606977`*^9}},ExpressionUUID->"399f692d-8ab4-4b6e-8237-\
b2ede6d6cac6"],

Cell["In traditional form this equation is", "Text",
 CellChangeTimes->{{3.5682107791495705`*^9, 
  3.5682107949835987`*^9}},ExpressionUUID->"d3e21b3b-509c-41da-9368-\
3d133241a02d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TemplateBox[{SubscriptBox["b", 
      RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
    "Superscript"], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", "j", "}"}]],RowBox[{"{", "k", "}"}]},
    "Superscript"]}], " ", "\[Equal]", " ", 
  RowBox[{
   SuperscriptBox[
    SubscriptBox["\[Delta]", 
     RowBox[{"{", "i", "}"}]], 
    RowBox[{"{", "k", "}"}]], "                                                               ", 
   RowBox[{"(", "3", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.602746341110801*^9, {3.6027463754932613`*^9, 3.602746442089779*^9}, {
   3.6027465019470835`*^9, 
   3.602746525768326*^9}},ExpressionUUID->"f78ebc0e-0c0b-47d1-8ead-\
6335a59328c9"],

Cell[TextData[{
 "where \[Delta] stands for the Kronecker symbol. Clearly, the basis ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    SubscriptBox["va", 
     RowBox[{
      RowBox[{"{", "j", "}"}], "  "}]], "}"}], TraditionalForm]],
  CellChangeTimes->{{3.568207582916757*^9, 3.568207730779417*^9}, 
    3.568207852974431*^9, {3.568207883737685*^9, 3.5682079146569395`*^9}},
  ExpressionUUID->"f8f9d2df-6747-4ce9-acd7-1f0cc983486b"],
 " is decomposed with respect to the basis ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    SubscriptBox["vb", 
     RowBox[{"{", "i", "}"}]], "}"}], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.568207947744598*^9, 3.5682080350891514`*^9}, {
   3.568208130171318*^9, 3.568208172135392*^9}},ExpressionUUID->
  "e7271d47-4549-49bb-8393-1f2654f175e9"],
 " by the inverse Matrix mc=matrix[c] = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["mb", 
    RowBox[{"-", "1"}]], TraditionalForm]],ExpressionUUID->
  "60661aef-bf36-4004-81a6-d0fce40f9e9c"],
 ":"
}], "Text",
 CellChangeTimes->{{3.5682082540979357`*^9, 3.5682083413644896`*^9}, {
   3.568208373453746*^9, 3.568208447787876*^9}, {3.6011973546828957`*^9, 
   3.601197396069768*^9}, {3.6011974265366216`*^9, 3.601197456831875*^9}, {
   3.602570965562948*^9, 3.602570965562948*^9}, {3.6026693466229978`*^9, 
   3.6026693466229978`*^9}, {3.602669379126857*^9, 3.6026694864559956`*^9}, 
   3.602669560752245*^9, {3.6027453414922457`*^9, 3.602745344737051*^9}, {
   3.6027474796008005`*^9, 3.6027474911916213`*^9}, 3.6028330766233172`*^9, 
   3.6030908177906103`*^9},ExpressionUUID->"c833f876-5552-44d3-9133-\
b14383dcb00e"],

Cell[BoxData[
 RowBox[{
  FormBox[
   SubscriptBox["va", 
    RowBox[{
     RowBox[{"{", "i", "}"}], "  "}]],
   TraditionalForm], "  ", "=", "  ", 
  RowBox[{
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
    "Superscript"], " ", 
   FormBox[
    SubscriptBox["vb", 
     RowBox[{
      RowBox[{"{", "j", "}"}], "  "}]],
    TraditionalForm], 
   "                                              "}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.5682077751926947`*^9, 3.568208492669155*^9, {3.5682085913861284`*^9, 
   3.568208629855796*^9}, {3.568211389953044*^9, 3.568211419031495*^9}, {
   3.568523588169593*^9, 3.568523591102398*^9}, {3.6026705879869995`*^9, 
   3.6026705995066586`*^9}, 
   3.6027473854234357`*^9},ExpressionUUID->"4ebe651b-ec4c-4899-bd3d-\
f5d1e9d1755d"],

Cell[TextData[{
 "Now we consider covectors, see Section 2.2.2  Let ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["wa", 
    RowBox[{"{", "i", "}"}]], TraditionalForm]],ExpressionUUID->
  "25708519-8e62-408f-9336-5d7c7ed84fa3"],
 " denote the dual basis  of the standard basis ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["ba", 
    RowBox[{
     RowBox[{"[", "j"}], "}"}]], TraditionalForm]],ExpressionUUID->
  "7bad3239-01c4-4194-b7e7-e6fed8a9195c"],
 " of the underlying vector space; the defining equations of this  ",
 ButtonBox["uniquely defined dual basis",
  BaseStyle->"Hyperlink",
  ButtonData->"duba"],
 " is"
}], "Text",
 CellChangeTimes->{{3.56847024435339*^9, 3.5684703072739887`*^9}, {
   3.5684704140900984`*^9, 3.5684706851056*^9}, {3.568470905911229*^9, 
   3.56847090592023*^9}, 3.6028331034709644`*^9, {3.602833667630355*^9, 
   3.6028336958664045`*^9}, 
   3.6434615189044743`*^9},ExpressionUUID->"e7dccb1d-b934-4837-b76e-\
cdbadfd98edc"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["wa", 
     RowBox[{"{", "i", "}"}]], ".", 
    SubscriptBox["ba", 
     RowBox[{
      RowBox[{"[", "j"}], "}"}]]}], " ", "\[Equal]", " ", 
   SuperscriptBox[
    SubscriptBox["\[Delta]", 
     RowBox[{"{", "j", "}"}]], 
    RowBox[{"{", "i", "}"}]], 
   "                                                                          \
            "}], TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5684707395297127`*^9, 3.5684707664832544`*^9}, {
   3.568470803700383*^9, 3.5684708283237915`*^9}, {3.5684733597235794`*^9, 
   3.5684733855550566`*^9}, 3.6028331398658285`*^9, {3.6028337100312295`*^9, 
   3.6028337154132395`*^9}},ExpressionUUID->"ae70e959-da24-443d-86ba-\
913ce5c2c7a7"],

Cell[TextData[{
 "For the coordinate decomposition of the vector vx = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["x", 
    RowBox[{"{", "i", "}"}]], TraditionalForm]],ExpressionUUID->
  "ba0d2c6f-b02f-47d2-a179-d4ef1f528f25"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", 
    RowBox[{"{", " ", "i", "}"}]], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.5684707395297127`*^9, 3.5684707664832544`*^9}, {
   3.568470803700383*^9, 3.5684708283237915`*^9}},ExpressionUUID->
  "1c5c1cfe-9c02-4113-b47b-2b861a78c4cf"],
 " it follows"
}], "Text",
 CellChangeTimes->{{3.5684710865055585`*^9, 3.5684712461296883`*^9}, {
  3.602833152564251*^9, 
  3.602833171003483*^9}},ExpressionUUID->"5f63b091-f0a5-4a33-9a9f-\
ed55391b8957"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["wa", 
     RowBox[{"{", "i", "}"}]], "(", "vx", ")"}], " ", "\[Equal]", " ", 
   SuperscriptBox["x", 
    RowBox[{"{", "i", "}"}]]}], TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568471319251871*^9, 3.5684713468194475`*^9}, 
   3.6028331883195133`*^9, 
   3.6028337314500675`*^9},ExpressionUUID->"e6f8eddb-f2da-4679-9594-\
cb69efdabdb9"],

Cell[TextData[{
 " such that the dual basis is",
 ButtonBox[" transformed contragrediently",
  BaseStyle->"Hyperlink",
  ButtonData->"trdb"],
 " to the basis of the vector space"
}], "Text",
 CellChangeTimes->{{3.5684714497783365`*^9, 3.5684716340578766`*^9}, {
   3.5684717135454235`*^9, 3.5684717634332767`*^9}, {3.5684717946940646`*^9, 
   3.5684720245492115`*^9}, {3.568472529226077*^9, 3.5684725599158325`*^9}, {
   3.5684726660029006`*^9, 3.568472722906155*^9}, {3.5684727662336335`*^9, 
   3.568472844914134*^9}, {3.602833455033182*^9, 3.602833467653604*^9}, {
   3.6028335505677495`*^9, 3.60283356225217*^9}, 3.602833604684245*^9, {
   3.6028337481264963`*^9, 
   3.6028337515585027`*^9}},ExpressionUUID->"a79ed3b2-ae27-4b10-a12f-\
f5dc88f69f14"],

Cell[BoxData[
 FormBox[
  RowBox[{
   SuperscriptBox["wb", 
    RowBox[{"{", "j", "}"}]], " ", "\[Equal]", " ", 
   RowBox[{
    SuperscriptBox["wa", 
     RowBox[{"{", "k", "}"}]], 
    TemplateBox[{SubscriptBox["c", 
       RowBox[{"{", "k", "}"}]],RowBox[{"{", "j", "}"}]},
     "Superscript"], "                                                                                                       ", 
    RowBox[{"(", "4", ")"}]}]}], TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.60283392654401*^9, 3.6028339598188686`*^9}, {
   3.602834008537754*^9, 3.6028340792838783`*^9}, 3.60283413123197*^9, {
   3.60283429099185*^9, 
   3.6028343035498724`*^9}},ExpressionUUID->"031f8566-10ce-4674-b3d9-\
214f98155fb5"],

Cell[TextData[{
 " where ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["wb", 
    RowBox[{"{", "j", "}"}]], TraditionalForm]],
  CellChangeTimes->{{3.60283392654401*^9, 3.6028339598188686`*^9}, {
    3.602834008537754*^9, 3.6028340792838783`*^9}, 3.60283413123197*^9},
  ExpressionUUID->"7db441d0-9956-45ff-9746-ba00d9c2452d"],
 " denotes the dual basis to ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["vb", 
    RowBox[{
     RowBox[{"{", "i", "}"}], " "}]], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.568207582916757*^9, 3.568207730779417*^9}, 
    3.568207852974431*^9, {3.568207883737685*^9, 3.5682079146569395`*^9}, 
    3.5682085169427977`*^9, {3.5682113378489523`*^9, 3.5682113598293905`*^9}, 
    3.5682114230719023`*^9, {3.568523542055912*^9, 3.5685235436159143`*^9}, {
    3.6026692517305703`*^9, 3.6026692525946198`*^9}, 3.6026693182183733`*^9, {
    3.602744629210594*^9, 3.6027446508634324`*^9}},ExpressionUUID->
  "f907ab60-de0d-488f-a945-116a086d1b2a"],
 ". Furthermore  the coordinates ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["u", 
    RowBox[{"{", "i", "}"}]], TraditionalForm]],ExpressionUUID->
  "e8cbf6e3-2e1a-4a20-bfe2-c2101528cad9"],
 " of the dual vector \nwu  = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["wb", 
    RowBox[{"{", "j", "}"}]], TraditionalForm]],ExpressionUUID->
  "2359b457-4609-4c49-9cf7-1707adec17de"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", 
    RowBox[{"{", "j", "}"}]], TraditionalForm]],ExpressionUUID->
  "3cf20b4e-00dc-4e11-b7fa-21f97f62d0c9"],
 " ",
 "= w",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["a", 
    RowBox[{"{", "i", "}"}]], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.5684707395297127`*^9, 3.5684707664832544`*^9}, {
   3.568470803700383*^9, 3.5684708283237915`*^9}},ExpressionUUID->
  "9b465cfa-0c49-45de-891a-399d71a2de3d"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["u", 
    RowBox[{"{", "i", "}"}]], TraditionalForm]],ExpressionUUID->
  "a80f3de0-0f98-4cf6-a7b3-e9612596e63f"],
 "\nare transformed covariant to the basis vectors  according to"
}], "Text",
 CellChangeTimes->{{3.5684714497783365`*^9, 3.5684716340578766`*^9}, {
   3.5684717135454235`*^9, 3.5684717634332767`*^9}, {3.5684717946940646`*^9, 
   3.5684720245492115`*^9}, {3.568472529226077*^9, 3.5684725599158325`*^9}, {
   3.5684726660029006`*^9, 3.568472722906155*^9}, {3.5684727662336335`*^9, 
   3.568472844914134*^9}, {3.602833455033182*^9, 3.602833467653604*^9}, {
   3.6028335505677495`*^9, 3.60283356225217*^9}, 3.602833604684245*^9, {
   3.6028340956951075`*^9, 3.6028340968495092`*^9}, {3.6028341635864267`*^9, 
   3.6028341810116568`*^9}, {3.6028342576545916`*^9, 3.60283426816901*^9}, {
   3.602834349694753*^9, 3.602834439363711*^9}, {3.602834522777057*^9, 
   3.6028345768935523`*^9}, 3.6028347148105297`*^9, {3.602834750393565*^9, 
   3.602834783852479*^9}, {3.603090929703011*^9, 
   3.603090930054031*^9}},ExpressionUUID->"29a59f27-b381-4d99-ba47-\
e8e9230948c2"],

Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox["v", 
    RowBox[{"{", "j", "}"}]], "\[Equal]", " ", 
   RowBox[{
    TemplateBox[{SubscriptBox["b", 
       RowBox[{"{", "j", "}"}]],RowBox[{"{", "k", "}"}]},
     "Superscript"], " ", 
    SubscriptBox["u", 
     RowBox[{"{", "k", "}"}]], "                                                                                                            ", 
    RowBox[{"(", "5", ")"}]}]}], TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6028348117390738`*^9, 3.602834813091151*^9}, {
   3.602834904933404*^9, 3.602835021844091*^9}, 
   3.6028370397805104`*^9},ExpressionUUID->"0061cc20-8813-4c9a-8bb7-\
d575d937ea76"],

Cell[TextData[{
 StyleBox["Proposition.",
  FontColor->RGBColor[0, 0, 1]],
 " The transformation of the bases of a vector space and its dual and the \
coordinates of  vectors and covectors with respect to these bases obey the  \
rules (1) - (5)."
}], "Text",
 CellChangeTimes->{{3.568472863874218*^9, 3.568472971522375*^9}, {
   3.602835101442644*^9, 3.602835140074854*^9}, 
   3.602835238025456*^9},ExpressionUUID->"ed12697e-2db2-4ddc-af93-\
b5488b8c0492"],

Cell[TextData[{
 StyleBox["Proof.",
  FontColor->RGBColor[0, 0, 1]],
 " This is  only a transcription of the results described  in Subsection \
2.2.2, where mb = (",
 Cell[BoxData[
  TemplateBox[{SubscriptBox["b", 
     RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
   "Superscript"]],
  Evaluatable->False,
  CellChangeTimes->{{3.568207582916757*^9, 3.568207730779417*^9}, 
    3.568207852974431*^9, {3.568207883737685*^9, 3.5682079146569395`*^9}, 
    3.5682085169427977`*^9, {3.5682113378489523`*^9, 3.5682113598293905`*^9}, 
    3.5682114230719023`*^9, {3.5684730761013565`*^9, 3.5684730777554517`*^9}},
  ExpressionUUID->"a14f6a61-a440-41fc-ab67-bbf5b38cf456"],
 "), mc = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["mb", 
    RowBox[{"-", "1"}]], TraditionalForm]],ExpressionUUID->
  "92419e49-50d3-4fa8-bc82-ddfc060663c7"],
 " = (",
 Cell[BoxData[
  TemplateBox[{SubscriptBox["c", 
     RowBox[{"{", "i", "}"}]],RowBox[{"{", "j", "}"}]},
   "Superscript"]],
  Evaluatable->False,
  CellChangeTimes->{{3.5682126406072407`*^9, 3.5682126600292745`*^9}, {
    3.568215532386165*^9, 3.568215555115405*^9}, {3.5684730668848295`*^9, 
    3.5684730856599035`*^9}, 3.5684732842362614`*^9},ExpressionUUID->
  "1f52651e-845f-4059-9868-2ef1ab122b9b"],
 ") denote the transformation matrix and its inverse such that (3) is \
satisfied.   \[FilledRectangle]"
}], "Text",
 CellChangeTimes->{{3.568473661169821*^9, 3.5684738065061336`*^9}, {
   3.6028352713223605`*^9, 3.6028352755136003`*^9}, {3.602835316929969*^9, 
   3.6028353406183243`*^9}, {3.602835545946068*^9, 3.602835547882179*^9}, {
   3.6028356329070415`*^9, 3.6028356380663366`*^9}, {3.6028356860180798`*^9, 
   3.6028357466825495`*^9}, {3.60283578288262*^9, 3.6028357937032385`*^9}, {
   3.602851829451645*^9, 3.6028518739429226`*^9}, 3.6433518262722964`*^9, {
   3.6433518993896246`*^9, 3.6433519083128405`*^9}, 
   3.643461557222142*^9},ExpressionUUID->"fbe2767d-545e-47ec-8b3a-\
a188dcc4b40d"],

Cell[TextData[{
 "Now we remember that the chosen bases tensors in the space of tensors of \
given type (k ,h) are the tensor products of the basis vectors of the \
underlying vector space and its dual, see the ",
 ButtonBox["Example",
  BaseStyle->"Hyperlink",
  ButtonData->"tensbas"],
 " in Section 3.3. Thus, using the symbol ",
 Cell[BoxData[
  FormBox["\[CircleTimes]", TraditionalForm]],ExpressionUUID->
  "84be7c64-2310-44bf-83f8-e0abce6082f6"],
 " for the tensor product, we may write the basis representation  of a tensor \
of type (k,h) with respect to the standard basis  in the form"
}], "Text",
 CellChangeTimes->{{3.5684739159783955`*^9, 3.5684741162578506`*^9}, {
  3.5684743989710207`*^9, 3.5684744262455807`*^9}, {3.5684745181148357`*^9, 
  3.5684746254499745`*^9}, {3.5684747266577635`*^9, 3.568474752706253*^9}, {
  3.602851947855853*^9, 3.6028519563890676`*^9}, {3.6028520713300695`*^9, 
  3.602852073295673*^9}, {3.6028524925620093`*^9, 
  3.6028525114380426`*^9}},ExpressionUUID->"63b8f963-f410-4c93-bd44-\
cbe2ccf78286"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox[
         SubscriptBox["ta", 
          RowBox[{"{", 
           SubscriptBox["i", 
            RowBox[{"1", ",", "...", ",", 
             SubscriptBox["i", "k"]}]], "}"}]], 
         RowBox[{
          RowBox[{"{", 
           SubscriptBox["j", 
            RowBox[{"1", ",", "...", ",", 
             SubscriptBox["j", "h"], " "}]], "}"}], " "}]], 
        RowBox[{
         SuperscriptBox["wa", 
          RowBox[{"{", 
           SubscriptBox["i", "1"], "}"}]], " ", 
         StyleBox["\[CircleTimes]",
          FontColor->GrayLevel[0]]}]}], "..."}], 
      FormBox["\[CircleTimes]",
       TraditionalForm], 
      SuperscriptBox["wa", 
       RowBox[{"{", 
        SubscriptBox["i", "k"], "}"}]], 
      FormBox["\[CircleTimes]",
       TraditionalForm], 
      SubscriptBox["va", 
       RowBox[{"{", 
        SubscriptBox["j", "1"], "}"}]]}], "..."}], "\[CircleTimes]", 
    SubscriptBox["va", 
     RowBox[{"{", 
      SubscriptBox["j", "h"], "}"}]]}], "                  ", 
   RowBox[{"(", "6", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568474758757599*^9, 3.5684751415644946`*^9}, {
   3.5684751769975214`*^9, 3.568475192993436*^9}, {3.568475236749939*^9, 
   3.568475298813489*^9}, {3.5684753396688256`*^9, 3.5684754348052673`*^9}, 
   3.568523109872753*^9, {3.5685231683728557`*^9, 3.5685232389161797`*^9}, {
   3.5685232866990633`*^9, 3.5685232993974857`*^9}, {3.568523376992022*^9, 
   3.5685233921396484`*^9}, {3.568524136136155*^9, 3.568524142204566*^9}, 
   3.568524373412572*^9, 3.5685276142938643`*^9, {3.568529133415733*^9, 
   3.5685291469409566`*^9}, {3.5686212919368916`*^9, 3.568621292144903*^9}, {
   3.602852269044817*^9, 3.602852317077301*^9}, {3.6028535530518723`*^9, 
   3.602853568417899*^9}},ExpressionUUID->"e911e5df-fbb1-48c1-8b01-\
2c5ee4d7793b"],

Cell["\<\
The representation with respect to the transformed basis and its dual can be \
written as\
\>", "Text",
 CellChangeTimes->{{3.602852911594345*^9, 
  3.602852980842867*^9}},ExpressionUUID->"ba8d5e85-b50e-4795-9d44-\
771ebd581f79"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox[
         OverscriptBox["ta", "^"], 
         RowBox[{"{", 
          SubscriptBox["m", 
           RowBox[{"1", ",", "...", ",", 
            SubscriptBox["m", "k"]}]], "}"}]], 
        RowBox[{
         RowBox[{"{", 
          SubscriptBox["l", 
           RowBox[{"1", ",", "...", ",", 
            SubscriptBox["l", "h"], " "}]], "}"}], " "}]], 
       RowBox[{
        SuperscriptBox["wb", 
         RowBox[{"{", 
          SubscriptBox["m", "1"], "}"}]], " ", 
        StyleBox["\[CircleTimes]",
         FontColor->GrayLevel[0]]}]}], "..."}], 
     FormBox["\[CircleTimes]",
      TraditionalForm], 
     SuperscriptBox["wb", 
      RowBox[{"{", 
       SubscriptBox["m", "k"], "}"}]], 
     FormBox["\[CircleTimes]",
      TraditionalForm], 
     SubscriptBox["vb", 
      RowBox[{"{", 
       SubscriptBox["l", "1"], "}"}]]}], "..."}], "\[CircleTimes]", 
   SubscriptBox["vb", 
    RowBox[{"{", 
     SubscriptBox["l", "h"], "}"}]], "                  "}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568474758757599*^9, 3.5684751415644946`*^9}, {
   3.5684751769975214`*^9, 3.568475192993436*^9}, {3.568475236749939*^9, 
   3.568475298813489*^9}, {3.5684753396688256`*^9, 3.5684754348052673`*^9}, 
   3.568523109872753*^9, {3.5685231683728557`*^9, 3.5685232389161797`*^9}, {
   3.5685232866990633`*^9, 3.5685232993974857`*^9}, {3.568523376992022*^9, 
   3.5685233921396484`*^9}, {3.568524136136155*^9, 3.568524142204566*^9}, 
   3.568524373412572*^9, 3.5685276142938643`*^9, {3.568529133415733*^9, 
   3.5685291469409566`*^9}, {3.5686212919368916`*^9, 3.568621292144903*^9}, {
   3.602852269044817*^9, 3.602852317077301*^9}, {3.6028528437810264`*^9, 
   3.6028528787562876`*^9}, 3.6028532539837465`*^9, {3.602853581085121*^9, 
   3.6028535960455475`*^9}, {3.602855011482834*^9, 
   3.6028550820261574`*^9}},ExpressionUUID->"81d7b3ff-b043-493d-91b9-\
6cc7e352d242"],

Cell[TextData[{
 "To calculate the transformed coordinates ",
 Cell[BoxData[
  SuperscriptBox[
   SubscriptBox[
    OverscriptBox["ta", "^"], 
    RowBox[{"{", 
     SubscriptBox["i", 
      RowBox[{"1", ",", "...", ",", 
       SubscriptBox["i", "k"]}]], "}"}]], 
   RowBox[{
    RowBox[{"{", 
     SubscriptBox["j", 
      RowBox[{"1", ",", "...", ",", 
       SubscriptBox["j", "h"], " "}]], "}"}], " "}]]],
  Evaluatable->False,
  CellChangeTimes->{{3.568474758757599*^9, 3.5684751415644946`*^9}, {
    3.5684751769975214`*^9, 3.568475192993436*^9}, {3.568475236749939*^9, 
    3.568475298813489*^9}, {3.5684753396688256`*^9, 3.5684754348052673`*^9}, 
    3.568523109872753*^9, {3.5685231683728557`*^9, 3.5685232389161797`*^9}, {
    3.5685232866990633`*^9, 3.5685232993974857`*^9}, {3.568523376992022*^9, 
    3.5685233921396484`*^9}, {3.568524136136155*^9, 3.568524142204566*^9}, 
    3.568524373412572*^9, 3.5685276142938643`*^9, {3.568529133415733*^9, 
    3.5685291469409566`*^9}, {3.5686212919368916`*^9, 3.568621292144903*^9}, {
    3.602852269044817*^9, 3.602852317077301*^9}, {3.6028528437810264`*^9, 
    3.6028528787562876`*^9}},ExpressionUUID->
  "e3633f5c-93af-41bb-84b2-b434ec9a1570"],
 " we insert the inverse  transformations of the basis vectors (4) and (1):"
}], "Text",
 CellChangeTimes->{{3.568524045484396*^9, 3.5685241101621094`*^9}, 
   3.568524150831381*^9, {3.5686213439338655`*^9, 3.568621345708967*^9}, {
   3.602853047470584*^9, 3.6028532020044556`*^9}, 3.6028534683905234`*^9, 
   3.602853854740802*^9, {3.6028542240090504`*^9, 
   3.602854232308265*^9}},ExpressionUUID->"8093d98f-7cee-410b-8a7e-\
91245b3787ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["wa", 
    RowBox[{"{", "i", "}"}]], " ", "\[Equal]", 
   RowBox[{
    SuperscriptBox["wb", 
     RowBox[{"{", "n", "}"}]], 
    TemplateBox[{SubscriptBox["b", 
       RowBox[{"{", "n", "}"}]],RowBox[{"{", "i", "}"}]},
     "Superscript"]}]}], " ", ",", "                               ", 
  RowBox[{
   SubscriptBox["va", 
    RowBox[{"{", "j", "}"}]], "\[Equal]", " ", 
   RowBox[{
    SubsuperscriptBox["c", 
     RowBox[{"{", "j", "}"}], 
     RowBox[{"        ", 
      RowBox[{"{", "m", "}"}]}]], 
    SubscriptBox["vb", 
     RowBox[{"{", "m", "}"}]], "      ", 
    RowBox[{"(", "7", ")"}]}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568473252411441*^9, 3.568473310659773*^9}, 
   3.568473406036228*^9, {3.5685242437451444`*^9, 3.5685243224784822`*^9}, 
   3.5686212955911007`*^9, {3.60285360897797*^9, 3.602853685059304*^9}, {
   3.6028537251357746`*^9, 3.6028537595182347`*^9}, {3.602853952942974*^9, 
   3.6028539713666067`*^9}, {3.6028540062950683`*^9, 
   3.6028540405215282`*^9}, {3.602854071659183*^9, 3.602854125728878*^9}, {
   3.60285416649175*^9, 3.6028542068178205`*^9}, {3.602855512493314*^9, 
   3.6028555159097195`*^9}},ExpressionUUID->"9f422bfd-838e-4b15-8ff8-\
3c74857a10c4"],

Cell[TextData[{
 "into (6) and obtain, since the tensor product is multilinear, the ",
 StyleBox["transformation rule of the tensor coordinates",
  FontColor->RGBColor[0, 0, 1]],
 " ",
 StyleBox["comparing the components at the basis tensors ",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.5685244294790707`*^9, 3.568524522096433*^9}, {
   3.568621368909294*^9, 3.5686213691093054`*^9}, 3.6028535077961926`*^9, 
   3.602854376390118*^9, {3.602854489568317*^9, 3.6028545033275414`*^9}, {
   3.6028545523740273`*^9, 3.6028545625920453`*^9}, 3.60285526003807*^9, {
   3.6028554596872206`*^9, 3.6028554756616488`*^9}, {3.602856332976755*^9, 
   3.6028563680924163`*^9}},ExpressionUUID->"b9a8e14c-bd2c-4df9-97b0-\
f3eaf4cda70c"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox[
         OverscriptBox["ta", "^"], 
         RowBox[{"{", 
          SubscriptBox["m", 
           RowBox[{"1", ",", "...", ",", 
            SubscriptBox["m", "k"]}]], "}"}]], 
        RowBox[{
         RowBox[{"{", 
          SubscriptBox["n", 
           RowBox[{"1", ",", "...", ",", 
            SubscriptBox["n", "h"], " "}]], "}"}], " "}]], "\[Equal]", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        SuperscriptBox[
         SubscriptBox["ta", 
          RowBox[{"{", 
           SubscriptBox["i", 
            RowBox[{"1", ",", "...", ",", 
             SubscriptBox["i", "k"]}]], "}"}]], 
         RowBox[{
          RowBox[{"{", 
           SubscriptBox["j", 
            RowBox[{"1", ",", "...", ",", 
             SubscriptBox["j", "h"], " "}]], "}"}], " "}]], 
        TemplateBox[{SubscriptBox["b", 
           RowBox[{"{", 
             SubscriptBox["n", "1"], "}"}]],RowBox[{"{", 
            SubscriptBox["i", "1"], "}"}]},
         "Superscript"]}]}], "..."}], " ", 
     TemplateBox[{SubscriptBox["b", 
        RowBox[{"{", 
          SubscriptBox["n", "k"], "}"}]],RowBox[{"{", 
         SubscriptBox["i", "k"], "}"}]},
      "Superscript"], 
     TemplateBox[{SubscriptBox["c", 
        RowBox[{"{", 
          SubscriptBox["j", "1"], "}"}]],RowBox[{"{", 
         SubscriptBox["m", "1"], "}"}]},
      "Superscript"]}], "..."}], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", 
        SubscriptBox["j", "h"], "}"}]],RowBox[{"{", 
       SubscriptBox["m", "h"], "}"}]},
    "Superscript"], "    ", 
   RowBox[{"(", "8", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.602854586553687*^9, 3.6028546383457785`*^9}, 
   3.6028546755986433`*^9, {3.60285514038586*^9, 3.602855159667494*^9}, 
   3.60285532228218*^9, {3.6028553673662586`*^9, 3.602855371141465*^9}, {
   3.6028554087687316`*^9, 
   3.60285544177839*^9}},ExpressionUUID->"6ff88047-38ff-432a-bb95-\
e290eaae480a"],

Cell[TextData[{
 "This explains the notations covariant and contravariant used in tensor \
calculus:\n",
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 ". The coordinates of a tensor of type {k,h} are transformed according to \
the formula (8): k times covariantly to the basis transformation in the \
underlying vector space V, what means with the same matrix mb, and h times \
contravariantly, i. e. with the contravariant matrix Transpose{",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["mb", 
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}]], TraditionalForm]],ExpressionUUID->
  "f8a2b486-1e22-4df5-846f-ef9e51d5142a"],
 "].  \[FilledSquare]"
}], "Text",
 CellChangeTimes->{{3.643352366251645*^9, 3.6433524594306087`*^9}, {
  3.643352532079936*^9, 3.6433526094404716`*^9}, {3.643352650000543*^9, 
  3.6433528728157344`*^9}, {3.643352902892587*^9, 3.6433529616266904`*^9}, {
  3.643352994932749*^9, 
  3.6433531430862093`*^9}},ExpressionUUID->"2ead16c6-b2dc-477d-8b13-\
e8bb564e436f"],

Cell[TextData[{
 "Therefore the first group of the indices at the bottom are named ",
 StyleBox["covariant",
  FontColor->RGBColor[0, 0, 1]],
 ", and the upmarket indices of the second group are named ",
 StyleBox["contravariant",
  FontColor->RGBColor[0, 0, 1]],
 "."
}], "Text",
 CellChangeTimes->{{3.643353268650165*^9, 3.6433532798529854`*^9}, {
  3.643353345118273*^9, 3.6433533903135524`*^9}, {3.6433534307987375`*^9, 
  3.6433535066676707`*^9}, {3.643356916290884*^9, 
  3.643356932363917*^9}},ExpressionUUID->"fae6a6f7-596e-4f5d-a9e9-\
8cc07dea644a"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.4.2. Example. Linear Endomorphisms", "Subsubsection",
 CellChangeTimes->{{3.562326998178623*^9, 3.562327027466298*^9}, 
   3.5623270672755756`*^9, 3.5685331272879477`*^9, 3.5685335763815365`*^9, 
   3.568628296637471*^9, 3.6433569851740103`*^9, 
   3.6433774217196174`*^9},ExpressionUUID->"7cc82d8d-0322-4017-93b4-\
a5b71e77dc9f"],

Cell[TextData[{
 "A linear map of the vector space into itself is called a ",
 StyleBox["linear endomorphism",
  FontColor->RGBColor[0, 0, 1]],
 ".  It can be defined using a square matrix:"
}], "Text",
 CellChangeTimes->{{3.562327076035076*^9, 
  3.56232715897082*^9}},ExpressionUUID->"ca2763f8-bd64-4b31-bfea-\
deb9acaa721b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.5685331948360662`*^9, 
  3.568533200342876*^9}},ExpressionUUID->"a262c8f6-d28a-4c2e-9cbd-\
0665460fc51c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fa", "[", "x_List", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"matrix", "[", "a", "]"}], ".", "x"}]}]], "Input",
 CellChangeTimes->{{3.562327247977911*^9, 3.562327270255185*^9}, {
  3.5623273219041395`*^9, 
  3.562327385053751*^9}},ExpressionUUID->"26a7ab7d-223e-4bd2-9a65-\
c15ed7db55f7"],

Cell[BoxData[
 RowBox[{"fa", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.562327398420516*^9, 
  3.5623274152704797`*^9}},ExpressionUUID->"a6af1ba1-f817-4b3c-a338-\
d5c344b076c0"],

Cell["\<\
This definition can be considered as a special case of constructing linear \
maps or functions by the help of tensors. Start with the tensor\
\>", "Text",
 CellChangeTimes->{{3.5623275128430605`*^9, 3.5623275612908316`*^9}, {
  3.562327604324293*^9, 3.5623276164669876`*^9}, {3.5623276675469093`*^9, 
  3.5623277031309443`*^9}},ExpressionUUID->"da952a2a-dcd4-4c61-826b-\
2d0c9ea948d9"],

Cell[BoxData[
 RowBox[{"ta", " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "1", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5623277088662724`*^9, 3.5623277221900344`*^9}, 
   3.562335479653702*^9, 
   3.568534326976855*^9},ExpressionUUID->"4ad7927a-eb2c-4724-992b-\
149b93eaef17"],

Cell[BoxData[
 RowBox[{"type", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.5685334147964525`*^9, 
  3.5685334210676637`*^9}},ExpressionUUID->"d0e3d6d1-dc86-4518-b29c-\
a8adc083fd10"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5685341978242283`*^9, 
  3.568534226060278*^9}},ExpressionUUID->"02dec700-d554-4964-9cf7-\
10076170bb78"],

Cell["with the definition", "Text",
 CellChangeTimes->{{3.5685344373470488`*^9, 
  3.568534444913062*^9}},ExpressionUUID->"a17841a8-e82c-4300-b560-\
835b0a0dc636"],

Cell[BoxData[
 RowBox[{
  RowBox[{"b", "[", 
   RowBox[{
    RowBox[{"{", "i_", "}"}], ",", 
    RowBox[{"{", "j_", "}"}]}], "]"}], ":=", " ", 
  RowBox[{"a", "[", 
   RowBox[{"j", ",", "i"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5685342601307373`*^9, 3.5685342966660013`*^9}, {
  3.5685343507824965`*^9, 3.568534398814981*^9}, {3.5685368390136847`*^9, 
  3.5685368414198227`*^9}},ExpressionUUID->"75b82466-8ab5-404d-bd4e-\
d015ca6c9b73"],

Cell["we get", "Text",
 CellChangeTimes->{{3.568534456909483*^9, 
  3.568534458953087*^9}},ExpressionUUID->"c8387f11-78dd-4d9e-97bd-\
d43663cf65dc"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",ExpressionUUID->"cc44335f-6a2d-\
4c5d-8501-53332bdf1a3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"coords", "[", "ta", "]"}], " ", "\[Equal]", 
  RowBox[{"Transpose", "[", " ", 
   RowBox[{"matrix", "[", "a", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5685345115875793`*^9, 3.568534534348019*^9}, {
  3.5685368599498825`*^9, 
  3.5685368672502995`*^9}},ExpressionUUID->"f1d02b3f-6b38-4f18-828b-\
586027ae0b36"],

Cell["\<\
Now we define the tensor vx corresponding to the vector vec[x]\
\>", "Text",
 CellChangeTimes->{{3.562335515190564*^9, 3.562335542152921*^9}, 
   3.5685332386409435`*^9, {3.568534584611307*^9, 
   3.568534640053805*^9}},ExpressionUUID->"46ab796c-4c30-4a09-98da-\
344ace2e37b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "i_", "}"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"x", "[", "i", "]"}]}]], "Input",
 CellChangeTimes->{{3.5685346848258834`*^9, 
  3.5685347254327545`*^9}},ExpressionUUID->"3f618397-f374-4975-bb8c-\
85811901bb16"],

Cell[BoxData[
 RowBox[{"vx", " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"c", ",", "0", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56233554706693*^9, 3.5623355824633923`*^9}, 
   3.568534735510372*^9},ExpressionUUID->"0456b1c6-56c3-4ef5-9675-\
56aee1c8da6d"],

Cell[BoxData[
 RowBox[{"type", "[", "vx", "]"}]], "Input",
 CellChangeTimes->{{3.568533495323794*^9, 3.5685335014078045`*^9}, {
  3.5685336105611963`*^9, 
  3.5685336132288013`*^9}},ExpressionUUID->"f92ed386-f7d3-4e4c-9964-\
d863e72859f0"],

Cell[BoxData[
 RowBox[{"vx", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568534755384807*^9, 
  3.56853477394884*^9}},ExpressionUUID->"4ad9ee18-a176-4aba-b556-\
cd6341c0098f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"coords", "[", "vx", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"vec", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.5685347902196684`*^9, 3.568534873508215*^9}, {
  3.568534921322299*^9, 
  3.5685349356899242`*^9}},ExpressionUUID->"e200bb00-be34-4fc8-8571-\
ec29815f1f80"],

Cell["\<\
We will construct the linear endomorphism fa using the  tensors ta, vx. We \
take the tensor  product\
\>", "Text",
 CellChangeTimes->{{3.5623356138350472`*^9, 3.5623356295598745`*^9}, {
   3.56861610082672*^9, 3.5686162297453465`*^9}, 
   3.6030918248392096`*^9},ExpressionUUID->"bfb501cd-0634-4c9f-ad9f-\
e2a6b96328fa"],

Cell[BoxData[
 RowBox[{"tax", " ", ":=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "vx"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5623356352382846`*^9, 3.5623356775143585`*^9}, {
  3.562335707716012*^9, 3.562335728791649*^9}, {3.568533307062663*^9, 
  3.568533320899888*^9}, {3.568533624398421*^9, 
  3.5685336328848352`*^9}},ExpressionUUID->"42af5db9-ddfb-483e-a6d8-\
0403708c0241"],

Cell[BoxData[
 RowBox[{"type", "[", "tax", "]"}]], "Input",
 CellChangeTimes->{{3.5685334540305214`*^9, 3.568533471362152*^9}, {
  3.5685336540072727`*^9, 
  3.5685336544128733`*^9}},ExpressionUUID->"4547b8c7-2c21-42ed-90c5-\
ca15600844b3"],

Cell[BoxData[
 RowBox[{"tax", "[", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.562335747464882*^9, 3.5623357957518334`*^9}, {
  3.5685333355483136`*^9, 3.568533351163941*^9}, {3.568533676128112*^9, 
  3.5685336764713125`*^9}},ExpressionUUID->"6b95ff49-a644-4a66-b06e-\
6ad79e016006"],

Cell[TextData[{
 "Now we calculate the  so called ",
 StyleBox["contraction, ",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox["this is  a summation over all values of a covariant and a \
contravariant index:",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.562335821164278*^9, 3.562335875779974*^9}, 
   3.562335940878888*^9, {3.568533700261354*^9, 3.56853370372456*^9}, {
   3.568536460210018*^9, 3.5685365249337206`*^9}, {3.56861627141302*^9, 
   3.568616275781028*^9}},ExpressionUUID->"b9e1402c-141b-4987-9024-\
5030dcdc9206"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ty", "[", "i_", "]"}], " ", ":=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"tax", "[", 
     RowBox[{
      RowBox[{"{", "j", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "j"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562335878275978*^9, 3.562335919772051*^9}, {
   3.5623359516585073`*^9, 3.5623359803001575`*^9}, {3.5623360352027454`*^9, 
   3.562336064889597*^9}, {3.5685337315394087`*^9, 3.5685337616162615`*^9}, 
   3.5685365706503353`*^9},ExpressionUUID->"5fb6236f-a120-4cb3-ac45-\
d057199fbf37"],

Cell[BoxData[
 RowBox[{"vec", "[", "ty", "]"}]], "Input",
 CellChangeTimes->{{3.56233607771282*^9, 3.5623360979772553`*^9}, 
   3.5686164232948866`*^9},ExpressionUUID->"3b75f9eb-6bd7-4f87-9207-\
8192c1edde66"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", " ", "\[Equal]", " ", 
   RowBox[{"fa", "[", 
    RowBox[{"vec", "[", "x", "]"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5623361850612855`*^9, 3.562336207681325*^9}, {
  3.568533825935175*^9, 3.568533878210867*^9}, {3.568533979111844*^9, 
  3.5685340292035317`*^9}, {3.568536633258916*^9, 3.568536653858094*^9}, {
  3.5685367708517857`*^9, 
  3.5685367804283338`*^9}},ExpressionUUID->"a152ecbb-8ff1-40bf-a382-\
4b719a464ae9"],

Cell[TextData[{
 "Thus, with ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["a", "j"], "i"], TraditionalForm]],ExpressionUUID->
  "37536f5f-bfcf-460a-93ca-d240cc62190e"],
 " :> a[j, i] we obtain a 1-1 correspondence between the space of linear \
endomorphisms and tensors of type (1,1). One easily calculates that the so \
defined tensor coordinates  have the necessary behavior under coordinate \
transformations."
}], "Text",
 CellChangeTimes->{{3.5623364624725924`*^9, 3.5623364727530107`*^9}, {
   3.562336537514225*^9, 3.5623369189544635`*^9}, {3.568537071339973*^9, 
   3.568537109938181*^9}, {3.5685371652013416`*^9, 3.568537165558362*^9}, {
   3.5685372033125215`*^9, 3.568537205284634*^9}, 3.5685372688092675`*^9, {
   3.568615910989987*^9, 3.5686159234388084`*^9}, {3.5686165222302604`*^9, 
   3.5686165308258753`*^9}, 3.601184441768743*^9, {3.60309197538282*^9, 
   3.6030919867344694`*^9}, 
   3.6434615943386073`*^9},ExpressionUUID->"ddf61dd5-a707-409f-8697-\
4b4e944d1318"],

Cell["\<\

The endomorphisms have two invariants (in the sense: functions invariant \
under  coordinate transformations), namely the trace \
\>", "Text",
 CellChangeTimes->{{3.5623364624725924`*^9, 3.5623364727530107`*^9}, {
   3.562336537514225*^9, 3.5623369189544635`*^9}, {3.568537071339973*^9, 
   3.568537109938181*^9}, {3.5685371652013416`*^9, 3.568537165558362*^9}, {
   3.5685372033125215`*^9, 3.568537205284634*^9}, {3.5685372688092675`*^9, 
   3.5685372821840324`*^9}, {3.5686166464532785`*^9, 3.56861665284929*^9}, {
   3.5686166862021484`*^9, 3.568616694548163*^9}, {3.568616793530337*^9, 
   3.568616800175948*^9}, 
   3.5686168663727636`*^9},ExpressionUUID->"517c0d87-95c1-4843-b02a-\
ff6fa3ce0d92"],

Cell[BoxData[
 RowBox[{"?", "trace"}]], "Input",
 CellChangeTimes->{{3.5690751313255715`*^9, 
  3.5690751322306232`*^9}},ExpressionUUID->"4ccb31af-5cf8-486d-b10c-\
bbb4dd8a9772"],

Cell[BoxData[
 RowBox[{
  RowBox[{"trace", "[", 
   RowBox[{"a_", "?", "MatrixQ"}], "]"}], " ", ":=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"[", 
      RowBox[{"i", ",", "i"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.562336931106885*^9, 3.562337002887275*^9}, 
   3.5623372602848344`*^9, {3.562337290673688*^9, 3.562337320350397*^9}, 
   3.569073900357131*^9},ExpressionUUID->"b39a4751-faba-4bb9-a7b1-\
5d19b2a31b2c"],

Cell["don\[CloseCurlyQuote]t confuse with the built-in function", "Text",
 CellChangeTimes->{{3.568616890189126*^9, 
  3.5686169171966705`*^9}},ExpressionUUID->"2152ce67-5a6a-4f44-8c81-\
fa5263898cd3"],

Cell[BoxData[
 RowBox[{"?", "Trace"}]], "Input",
 CellChangeTimes->{{3.5686167585706754`*^9, 
  3.5686167611914797`*^9}},ExpressionUUID->"30e4c5ea-8f04-4753-9679-\
b7669ad88e90"],

Cell[BoxData[
 RowBox[{"trace", "[", 
  RowBox[{"matrix", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.56233701162329*^9, 3.562337017629301*^9}, {
   3.562337059099049*^9, 3.562337064496659*^9}, 3.562337094590805*^9, 
   3.562337167635625*^9, {3.5623372019868855`*^9, 3.5623372088403625`*^9}, 
   3.5686170170543823`*^9},ExpressionUUID->"3f82ee88-b78d-49e6-b823-\
768e84a87dea"],

Cell["\<\
Obviously, the corresponding tensor expression is the contraction of the \
tensor ta\
\>", "Text",
 CellChangeTimes->{{3.562337349777334*^9, 3.5623374032194195`*^9}, {
  3.568617041620787*^9, 3.568617075796742*^9}, {3.6030920739194565`*^9, 
  3.6030920789027414`*^9}},ExpressionUUID->"6391a72f-9713-4a66-b369-\
4642992d0219"],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{
     RowBox[{"{", "i", "}"}], ",", 
     RowBox[{"{", "i", "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5623372396093273`*^9, 3.5623372452721376`*^9}, {
  3.562337416515527*^9, 3.562337440336769*^9}, {3.5686170927197104`*^9, 
  3.568617101719225*^9}},ExpressionUUID->"9524e4a6-7f17-4a8e-b4fa-\
dd0909bc10f7"],

Cell["Another invariant of the endomorphism a is", "Text",
 CellChangeTimes->{{3.562337462286007*^9, 3.5623374829613247`*^9}, {
  3.568617119029215*^9, 
  3.568617120485298*^9}},ExpressionUUID->"fa799eed-db1f-4f90-ae5b-\
a52932a337b8"],

Cell[BoxData[
 RowBox[{"Det", "[", 
  RowBox[{"matrix", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.562337495051346*^9, 
  3.562337531121354*^9}},ExpressionUUID->"59252d1a-f821-4799-a3da-\
fc725c1d05cb"],

Cell[TextData[{
 StyleBox["Lemma.",
  FontColor->RGBColor[0, 0, 1]],
 " Determinant and trace of the matrix of an endomorphism of a vector space \
(or of  the coordinates of a tensor of type (1,1) ) are invariant under a \
coordinate transformation of the underlying vector space."
}], "Text",
 CellChangeTimes->{{3.5686214536051383`*^9, 
  3.5686216259089937`*^9}},ExpressionUUID->"bc83cae2-8dec-43ce-b5d2-\
35c1395e7eef"],

Cell[TextData[{
 StyleBox["Proof",
  FontColor->RGBColor[0, 0, 1]],
 ". Equation (8) in 3.4.1 specializes to"
}], "Text",
 CellChangeTimes->{{3.5686216649492264`*^9, 3.5686217183252797`*^9}, {
   3.5686217560134354`*^9, 3.5686217703092527`*^9}, {3.6030921235742965`*^9, 
   3.6030921303586845`*^9}, 
   3.6030922066870503`*^9},ExpressionUUID->"307b2ee8-2784-4a4a-800e-\
7e72d2df75f9"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   SubscriptBox[
    OverscriptBox["ta", "^"], 
    RowBox[{"{", "n", "}"}]], 
   RowBox[{
    RowBox[{"{", "m", "}"}], " "}]], " ", "=", " ", 
  RowBox[{
   SuperscriptBox[
    SubscriptBox["ta", 
     RowBox[{"{", "i", "}"}]], 
    RowBox[{
     RowBox[{"{", "j", "}"}], " "}]], 
   TemplateBox[{SubscriptBox["b", 
      RowBox[{"{", "n", "}"}]],RowBox[{"{", "i", "}"}]},
    "Superscript"], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", "j", "}"}]],RowBox[{"{", "m", "}"}]},
    "Superscript"], "                                                       ", 
   RowBox[{"(", "1", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686218506988506`*^9, 
   3.5686219418440638`*^9}},ExpressionUUID->"5d328919-f37b-4cae-b5b3-\
d7221dca9574"],

Cell["This equation can be written as a product of matrices", "Text",
 CellChangeTimes->{{3.568621994656085*^9, 
  3.5686220187974653`*^9}},ExpressionUUID->"a1bdd39d-0d7b-481d-b3ec-\
e68bdba3d30d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   SuperscriptBox[
    SubscriptBox[
     OverscriptBox["ta", "^"], 
     RowBox[{"{", "n", "}"}]], 
    RowBox[{
     RowBox[{"{", "m", "}"}], " "}]], ")"}], " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     TemplateBox[{SubscriptBox["b", 
        RowBox[{"{", "n", "}"}]],RowBox[{"{", "i", "}"}]},
      "Superscript"], ")"}], ".", 
    RowBox[{"(", " ", 
     SuperscriptBox[
      SubscriptBox["ta", 
       RowBox[{"{", "i", "}"}]], 
      RowBox[{
       RowBox[{"{", "j", "}"}], " "}]], ")"}], ".", 
    RowBox[{"(", 
     TemplateBox[{SubscriptBox["c", 
        RowBox[{"{", "j", "}"}]],RowBox[{"{", "m", "}"}]},
      "Superscript"], ")"}]}], "                                   ", 
   RowBox[{"(", "2", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686218506988506`*^9, 
   3.5686219418440638`*^9}, {3.568622058928761*^9, 3.5686221798346767`*^9}, {
   3.568622306082897*^9, 3.5686223297772527`*^9}, {3.5686225284096136`*^9, 
   3.5686225385291924`*^9}},ExpressionUUID->"31cca3c3-aef0-4258-8bd8-\
336cf2cacddb"],

Cell[TextData[{
 "By (3) of 3.4.1 the matrices ",
 Cell[BoxData[
  RowBox[{"(", 
   TemplateBox[{SubscriptBox["b", 
      RowBox[{"{", "n", "}"}]],RowBox[{"{", "i", "}"}]},
    "Superscript"], ")"}]],
  Evaluatable->False,
  CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
    3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
    3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
    3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9},
     3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686218506988506`*^9, 
    3.5686219418440638`*^9}, {3.568622058928761*^9, 3.5686221798346767`*^9}},
  ExpressionUUID->"02c9b3bf-4fd4-4d12-afb1-3a01a7fa8a66"],
 " and  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    TemplateBox[{SubscriptBox["c", 
       RowBox[{"{", "j", "}"}]],RowBox[{"{", "m", "}"}]},
     "Superscript"], ")"}], " "}]],
  Evaluatable->False,
  CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
    3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
    3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
    3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9},
     3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686218506988506`*^9, 
    3.5686219418440638`*^9}, {3.568622058928761*^9, 3.5686221798346767`*^9}, {
    3.568622306082897*^9, 3.5686223101371293`*^9}},ExpressionUUID->
  "0cb5aeb7-c60d-4104-a7c6-47ce867e5796"],
 "are inverse to each other;  the theorem about the determinant of product \
matrices yields"
}], "Text",
 CellChangeTimes->{{3.5623375594978037`*^9, 3.5623376897791543`*^9}, {
   3.5686222348938255`*^9, 3.5686222870768104`*^9}, {3.5686223238499136`*^9, 
   3.568622360132989*^9}, {3.56862239826917*^9, 3.5686224338932076`*^9}, 
   3.6030922590790467`*^9},ExpressionUUID->"1152fd6d-f151-4de0-a646-\
61e64cc7d46b"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"Det", "[", 
    RowBox[{"(", 
     SuperscriptBox[
      SubscriptBox[
       OverscriptBox["ta", "^"], 
       RowBox[{"{", "n", "}"}]], 
      RowBox[{
       RowBox[{"{", "m", "}"}], " "}]], ")"}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"Det", "[", 
     RowBox[{"(", " ", 
      SuperscriptBox[
       SubscriptBox["ta", 
        RowBox[{"{", "i", "}"}]], 
       RowBox[{
        RowBox[{"{", "j", "}"}], " "}]], ")"}], "]"}], "."}]}], 
  TraditionalForm]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568622478249745*^9, 
  3.568622512807721*^9}},ExpressionUUID->"7fc4e686-18af-4895-a851-\
3e2f257f30c4"],

Cell[TextData[{
 "Setting in (2)  n=m and summarize over m, it follows from (3) of 3.4.1\n\
trace[",
 Cell[BoxData[
  FormBox[
   OverscriptBox["ta", "~"], TraditionalForm]],ExpressionUUID->
  "b3c68226-af4d-4cac-80ab-3b2f15058e29"],
 "] =",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox[
     OverscriptBox["ta", "^"], 
     RowBox[{"{", "m", "}"}]], 
    RowBox[{
     RowBox[{"{", "m", "}"}], " "}]], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.568622478249745*^9, 3.568622512807721*^9}},
  ExpressionUUID->"66296986-d183-4729-b9e9-3cff36746ec1"],
 " = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["ta", 
     RowBox[{"{", "i", "}"}]], 
    RowBox[{
     RowBox[{"{", "i", "}"}], " "}]], TraditionalForm]],
  Evaluatable->False,
  CellChangeTimes->{{3.568622478249745*^9, 3.568622512807721*^9}},
  ExpressionUUID->"64accb29-15c2-4618-a9f8-323de3656c25"],
 " = trace[ta]. ",
 "\[FilledSmallSquare]"
}], "Text",
 CellChangeTimes->{{3.5686226240930862`*^9, 3.5686229186609344`*^9}, {
   3.5686282399332275`*^9, 3.5686282461725845`*^9}, 3.603092311175027*^9, {
   3.643377388351159*^9, 
   3.6433774029371843`*^9}},ExpressionUUID->"6323d746-5443-4d19-9185-\
b1a5c9ee2c7e"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.4.3. Contractions ", "Subsubsection",
 CellChangeTimes->{{3.562310657259398*^9, 3.5623106861150484`*^9}, 
   3.568449188769819*^9, {3.5685245789585333`*^9, 3.5685245815169373`*^9}, 
   3.568533054248619*^9, 3.5686283031098413`*^9, 3.569053423322793*^9, 
   3.570773715900404*^9, 3.643377427569628*^9, 
   3.6434366562367887`*^9},ExpressionUUID->"d6f43897-1b29-4c84-a45b-\
5399e0fbb124"],

Cell[TextData[{
 "By the tensor definition, the transformation rule for the tensor \
coordinates of a mixed tensor with coordinates  tt  with respect to the \
tensor basis corresponding to {",
 Cell[BoxData[
  SubscriptBox["stb", "i"]],
  CellChangeTimes->{{3.562312901327751*^9, 3.5623129969832225`*^9}, {
   3.562313051022313*^9, 3.562313064934109*^9}, {3.562313145184699*^9, 
   3.5623131711591845`*^9}},ExpressionUUID->
  "95274195-b658-47d8-9be0-fc231aa819cf"],
 "} and bb  with respect to the tensor basis corresponding to {",
 Cell[BoxData[
  SubscriptBox["vb", "i"]],
  CellChangeTimes->{{3.562312901327751*^9, 3.5623129969832225`*^9}, {
   3.562313051022313*^9, 3.562313064934109*^9}, {3.562313145184699*^9, 
   3.5623131711591845`*^9}},ExpressionUUID->
  "842c90a0-91ac-4c90-8bbf-9a5e5375524c"],
 "} is "
}], "Text",
 CellChangeTimes->{{3.562314645867533*^9, 3.562314769331595*^9}, {
   3.5623148082018185`*^9, 3.562314901227139*^9}, 3.562324241030924*^9, {
   3.569070681297477*^9, 3.5690707114055295`*^9}, {3.569070802119689*^9, 
   3.5690708298721375`*^9}, {3.603092411905788*^9, 3.603092412203805*^9}, 
   3.6030924646388044`*^9, 3.6030925246632376`*^9, 
   3.643461642552494*^9},ExpressionUUID->"69475d47-7319-4bf7-9e33-\
ab8d96efb6fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SubsuperscriptBox["bb", 
      RowBox[{
       RowBox[{"i", " ", "j"}], "..."}], 
      RowBox[{
       RowBox[{"k", " ", "l"}], "..."}]], " ", "\[Equal]", " ", 
     RowBox[{
      SubsuperscriptBox["tt", 
       RowBox[{
        RowBox[{"a", " ", "b"}], "..."}], 
       RowBox[{
        RowBox[{"c", " ", "d"}], "..."}]], "  ", 
      SubsuperscriptBox["b", "i", "a"], " ", 
      SubsuperscriptBox["b", "j", "b"]}]}], "..."}], 
   SubsuperscriptBox["c", "c", "k"], " ", 
   SubsuperscriptBox["c", "d", "l"]}], "..."}]], "Input",
 CellChangeTimes->{{3.5623149123067727`*^9, 3.5623150877578077`*^9}, {
  3.5623152490140314`*^9, 
  3.562315367415804*^9}},ExpressionUUID->"118a2f96-e3e7-4710-986e-\
a84e6e0e6918"],

Cell[TextData[{
 StyleBox["Definition.",
  FontColor->RGBColor[0, 0, 1]],
 " Let ta be a mixed tensor of type (h, k ), h>0, k >0. Fix a covariant \
position a, 1 \[LessEqual]a\[LessEqual]h, and a contravariant position b,1 \
\[LessEqual]b\[LessEqual]k. Then the ",
 StyleBox["contraction",
  FontColor->RGBColor[0, 0, 1]],
 "[ta, a,b] of the tensor ta is defined by the coordinates equation"
}], "Text",
 CellChangeTimes->{{3.562324352410294*^9, 3.562324441298378*^9}, 
   3.562324475346326*^9, {3.5623245146185718`*^9, 3.5623248209550934`*^9}, 
   3.5623252968053102`*^9, 3.5623253498373437`*^9, 3.569070857047385*^9, {
   3.569070890135043*^9, 3.5690709342519207`*^9}, {3.569071159656717*^9, 
   3.5690711680339317`*^9}},ExpressionUUID->"a225f0f2-883a-40f3-bbb4-\
2c3c4782bd5b"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox[
   RowBox[{"contraction", "[", 
    RowBox[{
     RowBox[{"ta_.", " ", "a_"}], ",", "b_"}], "]"}], "...", "..."], " ", ":=",
   " ", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     SubsuperscriptBox["ta", 
      RowBox[{
       RowBox[{"..", "j"}], ".."}], 
      RowBox[{
       RowBox[{"...", "j"}], "..."}]], ",", " ", 
     RowBox[{"{", 
      RowBox[{"j", ",", "dim"}], "}"}]}], "]"}], " ", "\[DotEqual]", " ", 
   SubsuperscriptBox["ta", 
    RowBox[{
     RowBox[{"..", "j"}], ".."}], 
    RowBox[{
     RowBox[{"...", "j"}], "..."}]]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5690709501327486`*^9, 3.5690709926584234`*^9}, {
   3.5690710925453987`*^9, 3.5690711103450303`*^9}, 
   3.6433775584226575`*^9},ExpressionUUID->"c230f1e9-56c6-4d19-af6a-\
3057362edb72"],

Cell["\<\
here the summation goes over the index j at the places a and b; the other \
indices, denoted by the dots, remain unchanged.
One easily proves using 3.4.1, (8)\
\>", "Text",
 CellChangeTimes->{{3.5623253796500487`*^9, 3.5623253912187104`*^9}, {
   3.562325422835519*^9, 3.562325481354866*^9}, {3.5623255522519207`*^9, 
   3.562325598978594*^9}, {3.568629114949276*^9, 3.568629150620316*^9}, 
   3.603092705678591*^9},ExpressionUUID->"9b9ac616-3750-4041-af0b-\
aafbcbf3d677"],

Cell[TextData[{
 StyleBox["Proposition. ",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox["The contraction of  a tensor of type (h, k) is a tensor of type \
(h-1, k-1); the resulting tensor doesn\[CloseCurlyQuote]t depending on the \
coordinates.",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.5623256094101906`*^9, 3.562325703442569*^9}, {
   3.5623257616028953`*^9, 3.562325771043435*^9}, 3.5686292048124156`*^9, {
   3.568629464932294*^9, 
   3.5686295033804927`*^9}},ExpressionUUID->"68bd0a02-2800-496e-bb7c-\
1f23e9277049"],

Cell[TextData[{
 StyleBox["Proof.",
  FontColor->RGBColor[0, 0, 1]],
 " Let ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox[
    OverscriptBox["t", "^"], 
    RowBox[{"i", "..."}], 
    RowBox[{"k", "..."}]], TraditionalForm]],ExpressionUUID->
  "89acb013-0b64-438a-a27a-bc913cab5258"],
 " denote the tensor coordinates with respect to {",
 Cell[BoxData[
  SubscriptBox["bt", 
   RowBox[{"i", " "}]]],
  Evaluatable->False,
  CellChangeTimes->{{3.562312091344423*^9, 3.5623123795019045`*^9}, {
   3.5623124771784916`*^9, 3.5623124896872067`*^9}, {3.5623126453751116`*^9, 
   3.5623126649102287`*^9}, {3.5623127044154882`*^9, 
   3.5623127535352983`*^9}, {3.5623130204395638`*^9, 3.562313032520255*^9}, {
   3.5623130929197097`*^9, 3.5623131246805267`*^9}},ExpressionUUID->
  "aa01d7cd-6387-4690-b263-284c6b054795"],
 "} and ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["t", 
    RowBox[{"i", "..."}], 
    RowBox[{"k", "..."}]], TraditionalForm]],ExpressionUUID->
  "67bd6835-e52d-4ac6-a900-bb75cbbdffb1"],
 " those with respect to  {",
 Cell[BoxData[
  SubscriptBox["stb", 
   RowBox[{"i", " "}]]],
  Evaluatable->False,
  CellChangeTimes->{{3.562312091344423*^9, 3.5623123795019045`*^9}, {
   3.5623124771784916`*^9, 3.5623124896872067`*^9}, {3.5623126453751116`*^9, 
   3.5623126649102287`*^9}, {3.5623127044154882`*^9, 
   3.5623127535352983`*^9}, {3.5623130204395638`*^9, 3.562313032520255*^9}, {
   3.5623130929197097`*^9, 3.5623131246805267`*^9}},ExpressionUUID->
  "574694cf-ae37-4afc-bb5c-5249e71541d0"],
 "}.  Then"
}], "Text",
 CellChangeTimes->{{3.5623258467147636`*^9, 3.5623259400181*^9}, {
   3.562325981490472*^9, 3.562326086068454*^9}, {3.5623266792983847`*^9, 
   3.5623266821865497`*^9}, {3.5686295234686418`*^9, 3.568629539155539*^9}, 
   3.643461650976509*^9},ExpressionUUID->"2a2ae37e-6d39-49fc-aadc-\
1d06cb7e54d0"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   SubscriptBox[
    OverscriptBox["ta", "^"], 
    RowBox[{"{", 
     SubscriptBox["n", 
      RowBox[{"1", ",", 
       RowBox[{".", 
        RowBox[{",", "j", ",", 
         RowBox[{".", 
          RowBox[{",", 
           SubscriptBox["n", "k"]}]}]}]}]}]], "}"}]], 
   RowBox[{
    RowBox[{"{", 
     SubscriptBox["m", 
      RowBox[{"1", ",", 
       RowBox[{".", 
        RowBox[{",", "j", ",", 
         RowBox[{".", 
          RowBox[{",", 
           SubscriptBox["m", "h"], " "}]}]}]}]}]], "}"}], " "}]], " ", "=", 
  " "}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686305843783226`*^9, 
   3.568630596858036*^9}, {3.568630630337951*^9, 3.568630668840153*^9}, {
   3.5686308058789916`*^9, 
   3.568630830191382*^9}},ExpressionUUID->"c8847e89-12d8-4745-bbf4-\
25d5e2566b63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            SubscriptBox["ta", 
             RowBox[{"{", 
              SubscriptBox["i", 
               RowBox[{"1", ",", 
                RowBox[{".", 
                 RowBox[{",", "r", ",", 
                  RowBox[{".", 
                   RowBox[{",", 
                    SubscriptBox["i", "k"]}]}]}]}]}]], "}"}]], 
            RowBox[{
             RowBox[{"{", 
              SubscriptBox["j", 
               RowBox[{"1", ",", "..", ",", "s", ",", 
                RowBox[{".", 
                 RowBox[{",", 
                  SubscriptBox["j", "h"], " "}]}]}]], "}"}], " "}]], 
           TemplateBox[{SubscriptBox["b", 
              RowBox[{"{", 
                SubscriptBox["n", "1"], "}"}]],RowBox[{"{", 
               SubscriptBox["i", "1"], "}"}]},
            "Superscript"]}], ".."}], 
         TemplateBox[{SubscriptBox["b", 
            RowBox[{"{", "j", "}"}]],RowBox[{"{", "r", "}"}]},
          "Superscript"]}], ".."}], " ", 
       TemplateBox[{SubscriptBox["b", 
          RowBox[{"{", 
            SubscriptBox["n", "k"], "}"}]],RowBox[{"{", 
           SubscriptBox["i", "k"], "}"}]},
        "Superscript"], 
       TemplateBox[{SubscriptBox["c", 
          RowBox[{"{", 
            SubscriptBox["j", "1"], "}"}]],RowBox[{"{", 
           SubscriptBox["m", "1"], "}"}]},
        "Superscript"]}], ".."}], 
     TemplateBox[{SubscriptBox["c", 
        RowBox[{"{", "s", "}"}]],RowBox[{"{", "j", "}"}]},
      "Superscript"]}], ".."}], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", 
        SubscriptBox["j", "h"], "}"}]],RowBox[{"{", 
       SubscriptBox["m", "h"], "}"}]},
    "Superscript"]}], "    ", "="}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686305843783226`*^9, 
   3.568630596858036*^9}, {3.568630630337951*^9, 3.5686307923472176`*^9}, {
   3.568630843000115*^9, 3.568630865608408*^9}, {3.568630907792821*^9, 
   3.5686309158642826`*^9}},ExpressionUUID->"0b8ca875-8a4c-4524-971f-\
59f2669fc631"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox["ta", 
         RowBox[{"{", 
          SubscriptBox["i", 
           RowBox[{"1", ",", 
            RowBox[{".", 
             RowBox[{",", "r", ",", 
              RowBox[{".", 
               RowBox[{",", 
                SubscriptBox["i", "k"]}]}]}]}]}]], "}"}]], 
        RowBox[{
         RowBox[{"{", 
          SubscriptBox["j", 
           RowBox[{"1", ",", "..", ",", "s", ",", 
            RowBox[{".", 
             RowBox[{",", 
              SubscriptBox["j", "h"], " "}]}]}]], "}"}], " "}]], 
       TemplateBox[{SubscriptBox["b", 
          RowBox[{"{", 
            SubscriptBox["n", "1"], "}"}]],RowBox[{"{", 
           SubscriptBox["i", "1"], "}"}]},
        "Superscript"]}], "..."}], " ", 
     TemplateBox[{SubscriptBox["b", 
        RowBox[{"{", 
          SubscriptBox["n", "k"], "}"}]],RowBox[{"{", 
         SubscriptBox["i", "k"], "}"}]},
      "Superscript"], 
     TemplateBox[{SubscriptBox["c", 
        RowBox[{"{", 
          SubscriptBox["j", "1"], "}"}]],RowBox[{"{", 
         SubscriptBox["m", "1"], "}"}]},
      "Superscript"]}], "..."}], 
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", 
        SubscriptBox["j", "h"], "}"}]],RowBox[{"{", 
       SubscriptBox["m", "h"], "}"}]},
    "Superscript"], " ", 
   TemplateBox[{SubscriptBox["\[Delta]", 
      RowBox[{"{", "s", "}"}]],RowBox[{"{", "r", "}"}]},
    "Superscript"]}], "   ", "="}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686305843783226`*^9, 
   3.568630596858036*^9}, {3.568630630337951*^9, 3.5686307923472176`*^9}, {
   3.568630843000115*^9, 3.568630865608408*^9}, {3.568630907792821*^9, 
   3.568631068528014*^9}},ExpressionUUID->"a11346f8-22d0-4f5d-95b9-\
dea3156df424"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox[
       SubscriptBox["ta", 
        RowBox[{"{", 
         SubscriptBox["i", 
          RowBox[{"1", ",", 
           RowBox[{".", 
            RowBox[{",", "s", ",", 
             RowBox[{".", 
              RowBox[{",", 
               SubscriptBox["i", "k"]}]}]}]}]}]], "}"}]], 
       RowBox[{
        RowBox[{"{", 
         SubscriptBox["j", 
          RowBox[{"1", ",", "..", ",", "s", ",", 
           RowBox[{".", 
            RowBox[{",", 
             SubscriptBox["j", "h"], " "}]}]}]], "}"}], " "}]], 
      TemplateBox[{SubscriptBox["b", 
         RowBox[{"{", 
           SubscriptBox["n", "1"], "}"}]],RowBox[{"{", 
          SubscriptBox["i", "1"], "}"}]},
       "Superscript"]}], "..."}], " ", 
    TemplateBox[{SubscriptBox["b", 
       RowBox[{"{", 
         SubscriptBox["n", "k"], "}"}]],RowBox[{"{", 
        SubscriptBox["i", "k"], "}"}]},
     "Superscript"], 
    TemplateBox[{SubscriptBox["c", 
       RowBox[{"{", 
         SubscriptBox["j", "1"], "}"}]],RowBox[{"{", 
        SubscriptBox["m", "1"], "}"}]},
     "Superscript"]}], "..."}], 
  RowBox[{
   TemplateBox[{SubscriptBox["c", 
      RowBox[{"{", 
        SubscriptBox["j", "h"], "}"}]],RowBox[{"{", 
       SubscriptBox["m", "h"], "}"}]},
    "Superscript"], "."}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568528050758231*^9, 3.5685280555162396`*^9}, 
   3.56852819239088*^9, {3.568529715936356*^9, 3.5685298004261045`*^9}, {
   3.5685298961478724`*^9, 3.568529946879162*^9}, {3.5685299999348545`*^9, 
   3.5685300107144737`*^9}, {3.5685300708681793`*^9, 3.5685300845182033`*^9}, 
   3.5685327912321577`*^9, 3.5686213156032453`*^9, {3.5686305843783226`*^9, 
   3.568630596858036*^9}, {3.568630630337951*^9, 3.5686307923472176`*^9}, {
   3.568630843000115*^9, 3.568630865608408*^9}, {3.568630907792821*^9, 
   3.5686311292074847`*^9}, 
   3.5686311620313625`*^9},ExpressionUUID->"6671fe58-d0a0-4c65-a918-\
2efb993e4a9d"],

Cell["\<\
The first and the last term of this equation chain give the wanted \
transformation rule for the coordinates of the contracted tensor. Thus  the \
contraction is independent of the coordinate system.
Now we are going to work out a definition of an arbitrary contraction of a \
mixed tensor over a list of appropriate slot pairs. The final definition is \
contained in tensalgv2.m.\
\>", "Text",
 CellChangeTimes->{{3.56232670527287*^9, 3.562326785466457*^9}, {
   3.562326818146326*^9, 3.5623268515142345`*^9}, {3.56232688256301*^9, 
   3.5623268923545704`*^9}, {3.568631223316868*^9, 3.5686313214844823`*^9}, 
   3.5686313730444317`*^9, {3.5690761108695984`*^9, 3.569076221604932*^9}, {
   3.5690762539167805`*^9, 3.56907629045287*^9}, 3.601184442782745*^9, 
   3.642501433909219*^9},ExpressionUUID->"fca41073-6a06-4f2b-b4c8-\
cec898886f0c"],

Cell[BoxData[
 RowBox[{"?", "contraction"}]], "Input",
 CellChangeTimes->{{3.5690762344076643`*^9, 
  3.569076239655965*^9}},ExpressionUUID->"2c4fb501-7bb2-43f7-a817-\
13c9d4ffc578"],

Cell["\<\
In the definition are contained two non exported modules, tract and \
contractio.  tract defines the coordinate function of a tensor contracted \
over a single slot pair:\
\>", "Text",
 CellChangeTimes->{{3.5690763110450478`*^9, 3.5690764380053096`*^9}, 
   3.569076964373416*^9, 3.6011837934628043`*^9, 
   3.6434616628657303`*^9},ExpressionUUID->"b9dc25aa-8135-4f29-8ed5-\
9ce62019510e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"tract", "[", 
    RowBox[{"tt_", ",", "i_", ",", "j_"}], "]"}], "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "ty", ",", "h", ",", "k", ",", "d", ",", "aa", ",", " ", "bb", ",", 
      "cov", ",", "cont", ",", "x1", ",", "y1", ",", "jj", ",", "xx", ",", 
      "yy"}], "}"}], ",", "\[IndentingNewLine]", 
    StyleBox[
     RowBox[{"(*", " ", 
      RowBox[{"Tensor", " ", "properties"}], " ", "*)"}],
     Background->RGBColor[1, 0.85, 0.85]], "\n", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "tt", "]"}], " ", "===", " ", "tensor"}], ",", 
       " ", 
       RowBox[{"ty", " ", "=", " ", 
        RowBox[{"type", "[", "tt", "]"}]}], ",", " ", 
       RowBox[{"Return", "[", 
        RowBox[{"type", "[", "tt", "]"}], "]"}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"type", "[", "tt", "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"aa", " ", "=", " ", 
      RowBox[{"ty", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"h", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", " ", 
     RowBox[{"k", "=", " ", 
      RowBox[{"ty", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", " ", 
     RowBox[{"d", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{"The", " ", "indices"}], " ", "*)"}],
      Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
     RowBox[{"cov", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"Range", "[", "d", "]"}], ",", 
        RowBox[{"h", "-", "1"}]}], "]"}]}], ";", 
     RowBox[{"cont", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"Range", "[", "d", "]"}], ",", 
        RowBox[{"k", "-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{"cov", ",", "x"}], "]"}], "&&", 
         RowBox[{"MemberQ", "[", 
          RowBox[{"cont", ",", "y"}], "]"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Incorrect Arguments!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{"The", " ", "coordinate", " ", "function"}], " ", "*)"}],
      Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"x1", "[", "jj_", "]"}], " ", ":=", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"x", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", 
           RowBox[{"i", "-", "1"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", "jj", "}"}], ",", 
        RowBox[{"x", "[", 
         RowBox[{"[", 
          RowBox[{"i", ";;", 
           RowBox[{"h", "-", "1"}]}], "]"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"y1", "[", "jj_", "]"}], " ", ":=", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"y", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", 
           RowBox[{"j", "-", "1"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", "jj", "}"}], ",", 
        RowBox[{"y", "[", 
         RowBox[{"[", 
          RowBox[{"j", ";;", 
           RowBox[{"k", "-", "1"}]}], "]"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"bb", "[", 
       RowBox[{"xx_", ",", "yy_"}], "]"}], ":=", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"aa", "[", 
         RowBox[{
          RowBox[{"x1", "[", "jj", "]"}], ",", 
          RowBox[{"y1", "[", "jj", "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"jj", ",", "1", ",", "d"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"bb", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5686326316524196`*^9, 3.568632702607478*^9}, {
   3.568632754823465*^9, 3.5686327659591017`*^9}, 3.5686329376389213`*^9, 
   3.568632975458084*^9, {3.568633050194359*^9, 3.5686331102667947`*^9}, {
   3.568633152619217*^9, 3.5686332835557065`*^9}, {3.5686333243240385`*^9, 
   3.5686334450849457`*^9}, {3.568633497005915*^9, 3.5686335035892916`*^9}, {
   3.5686335559902887`*^9, 3.5686336685977297`*^9}, 3.5686337008795757`*^9, {
   3.568633775974871*^9, 3.5686338515661945`*^9}, {3.568634052839707*^9, 
   3.5686340658224497`*^9}, {3.568634100743447*^9, 3.5686341275429797`*^9}, {
   3.568634484679407*^9, 3.568634485716466*^9}, {3.568643874339227*^9, 
   3.5686440314362125`*^9}, {3.5686440800199914`*^9, 3.568644126924674*^9}, {
   3.568644167572999*^9, 3.5686446165756807`*^9}, {3.568644647770465*^9, 
   3.568645054819747*^9}, {3.568645177892786*^9, 3.568645245660662*^9}, {
   3.5686453129735126`*^9, 3.568645345989401*^9}, {3.5686453760771217`*^9, 
   3.5686454137572765`*^9}, {3.5686454869184613`*^9, 3.568645511277855*^9}, {
   3.568646240206547*^9, 3.568646250022108*^9}, {3.5686466301658516`*^9, 
   3.5686466307088823`*^9}, {3.5686466783896093`*^9, 3.568646684876981*^9}, {
   3.568647116150648*^9, 3.5686471485585012`*^9}, {3.5686471971872835`*^9, 
   3.5686472301621695`*^9}, {3.568647266510248*^9, 3.5686472696144257`*^9}, {
   3.5686473755584855`*^9, 3.5686474739501133`*^9}, {3.568647520804793*^9, 
   3.5686475332065024`*^9}, {3.5686476760476723`*^9, 3.568647692815632*^9}, {
   3.568707124062215*^9, 3.5687071690214944`*^9}, {3.568707232061205*^9, 
   3.568707232544806*^9}, 3.568707489274457*^9, {3.5687274069394636`*^9, 
   3.5687274147550774`*^9}, {3.5687279603660355`*^9, 3.568727974858461*^9}, {
   3.568728096819475*^9, 3.5687281307495346`*^9}, {3.5687281748196125`*^9, 
   3.568728219888091*^9}, {3.5690714550588355`*^9, 3.5690714835756855`*^9}, {
   3.5690715292525663`*^9, 3.5690715313585696`*^9}, {3.5690720386402607`*^9, 
   3.5690720467678747`*^9}, {3.5690721028499737`*^9, 3.569072107264781*^9}, {
   3.569072649858935*^9, 3.569072658002149*^9}, {3.5690728265916452`*^9, 
   3.5690728318176546`*^9}, {3.569077900558963*^9, 3.569077916927899*^9}, {
   3.5690780053919587`*^9, 3.5690780760399995`*^9}, 
   3.60118403585603*^9},ExpressionUUID->"03c359c0-eb9c-441e-9dbd-\
6b1df158b1bd"],

Cell["contractio is the corresponding contracted tensor:", "Text",
 CellChangeTimes->{{3.569076992717037*^9, 
  3.569077012885191*^9}},ExpressionUUID->"befc3d00-43d8-4671-b61c-\
ed22847b925d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contractio", "[", 
   RowBox[{"tt_", ",", "i_", ",", "j_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "ty", "}"}], ",", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "tt", "]"}], " ", "===", " ", "tensor"}], ",", 
       " ", 
       RowBox[{"ty", " ", "=", " ", 
        RowBox[{"type", "[", "tt", "]"}]}], ",", " ", 
       RowBox[{"Return", "[", 
        RowBox[{"type", "[", "tt", "]"}], "]"}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"type", "[", "tt", "]"}], "]"}]}], "]"}], ";", " ", 
     RowBox[{"ca", " ", "=", " ", 
      RowBox[{"tract", "[", 
       RowBox[{"tt", ",", "i", ",", "j"}], "]"}]}], ";", " ", 
     RowBox[{"tensor", "[", 
      RowBox[{"ca", ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"type", "[", "tt", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"type", "[", "tt", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}], "-", "1"}], ",", " ", 
       RowBox[{
        RowBox[{"type", "[", "tt", "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.568728354157527*^9, 3.5687283923775945`*^9}, {
   3.5687284272124557`*^9, 3.568728670058082*^9}, {3.568728830067563*^9, 
   3.5687288725620375`*^9}, 
   3.568728912279708*^9},ExpressionUUID->"0a0c9941-cf12-4fc1-bc99-\
547b8f13907e"],

Cell["Here is the exported definition:", "Text",
 CellChangeTimes->{{3.569077062821047*^9, 
  3.569077072716613*^9}},ExpressionUUID->"bf529d12-ab86-4c56-ab0e-\
55d55f15f38a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contraction", "[", 
   RowBox[{"tt_", ",", " ", "slots_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "ty", ",", " ", "k", ",", "h", ",", "aa", ",", "d", ",", 
      "\[IndentingNewLine]", "nn", ",", " ", 
      RowBox[{"eps", " ", "=", " ", "0"}], ",", "err", ",", "vv", ",", "  ", 
      "vi", ",", "vj", ",", "i", ",", "w", ",", "m", ",", "j", ",", "ww", ",",
       "ta", ",", "sa"}], "}"}], ",", 
    StyleBox[
     RowBox[{"(*", 
      RowBox[{"Test", " ", "of", " ", "the", " ", "tensor", " ", "property"}],
       " ", "*)"}],
     FontColor->RGBColor[1, 0, 0],
     Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "tt", "]"}], "===", " ", "tensor"}], ",", " ", 
       RowBox[{"ty", " ", "=", 
        RowBox[{"type", "[", "tt", "]"}]}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<First argument must be a tensor\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"aa", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"h", " ", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"k", " ", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", 
     RowBox[{"d", " ", "=", 
      RowBox[{"ty", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", 
       RowBox[{
       "Suitability", " ", "Test", " ", "of", " ", "the", " ", "slots"}], " ",
        "*)"}],
      Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MatrixQ", "[", "slots", "]"}], ",", " ", 
       RowBox[{"nn", "=", " ", 
        RowBox[{"Length", "[", "slots", "]"}]}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"slots", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "\[Equal]", " ", "2"}],
         "]"}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vv", " ", "=", 
      RowBox[{"Reverse", "[", " ", 
       RowBox[{"Sort", "[", "slots", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vi", " ", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"vv", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
     RowBox[{"vj", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"vv", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"andtest", "[", 
         RowBox[{"Map", "[", 
          RowBox[{"IntegerQ", ",", 
           RowBox[{"Join", "[", 
            RowBox[{"vi", ",", "vj"}], "]"}]}], "]"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Min", "[", "vi", "]"}], "<", "1"}], ")"}], "||", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Min", "[", "vj", "]"}], "<", "1"}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Max", "[", "vi", "]"}], ">", "h"}], ")"}], "||", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Max", "[", "vj", "]"}], ">", "k"}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", "\n", "    ", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"Union", "[", "vi", "]"}], "]"}], "<", " ", "nn"}], ")"}], 
        "||", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"Union", "[", "vj", "]"}], "]"}], "<", " ", "nn"}], 
         ")"}]}], ",", 
       RowBox[{
        RowBox[{"eps", " ", "=", "1"}], ";", 
        RowBox[{"Goto", "[", "err", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Label", "[", "err", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"eps", "\[Equal]", " ", "1"}], ",", " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<slots:Arguments incorrect!\>\"", "]"}], 
        ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{
       "Transformation", " ", "of", " ", "the", " ", "slots", " ", 
        "sequence"}], " ", "*)"}],
      Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"w", "[", 
       RowBox[{"i_", ",", "1"}], "]"}], " ", ":=", " ", 
      RowBox[{"vv", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"w", "[", 
       RowBox[{"1", ",", "2"}], "]"}], " ", "=", " ", 
      RowBox[{"vv", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", " ", 
      RowBox[{
       RowBox[{"i", " ", "=", "2"}], ",", 
       RowBox[{"i", "\[LessEqual]", " ", "nn"}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"m", "=", "0"}], ";", 
           RowBox[{"j", "=", "1"}]}], ",", 
          RowBox[{"j", "<", "i"}], ",", 
          RowBox[{"j", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"vv", "[", 
              RowBox[{"[", 
               RowBox[{"j", ",", "2"}], "]"}], "]"}], "<", 
             RowBox[{"vv", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ",", 
            RowBox[{"m", " ", "=", 
             RowBox[{"m", "+", "1"}]}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"w", "[", 
          RowBox[{"i", ",", "2"}], "]"}], "=", 
         RowBox[{
          RowBox[{"vv", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", "m"}]}]}]}], "]"}], 
     ";", 
     RowBox[{"ww", "=", 
      RowBox[{"Array", "[", 
       RowBox[{"w", ",", 
        RowBox[{"{", 
         RowBox[{"nn", ",", "2"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{"Iteration", " ", "of", " ", "contractio"}], " ", "*)"}],
      Background->RGBColor[1, 0.85, 0.85]], "\[IndentingNewLine]", 
     RowBox[{"ta", " ", "=", " ", "tt"}], ";", 
     RowBox[{"i", " ", "=", " ", "1"}], ";", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"i", "<", 
        RowBox[{"nn", "+", "1"}]}], ",", 
       RowBox[{
        RowBox[{"sa", " ", "=", " ", 
         RowBox[{"contractio", "[", 
          RowBox[{"ta", ",", 
           RowBox[{"w", "[", 
            RowBox[{"i", ",", "1"}], "]"}], ",", 
           RowBox[{"w", "[", 
            RowBox[{"i", ",", "2"}], "]"}]}], "]"}]}], ";", " ", 
        RowBox[{"ta", " ", "=", "sa"}], ";", 
        RowBox[{"i", "++"}]}]}], "]"}], ";", "\[IndentingNewLine]", "sa"}]}], 
   "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5687235256370463`*^9, 3.568723582904747*^9}, {
   3.5687241321817117`*^9, 3.5687241884822106`*^9}, 3.568724237825097*^9, {
   3.5687242931427946`*^9, 3.5687242946091967`*^9}, {3.5687243322364635`*^9, 
   3.568724407678196*^9}, {3.5687244685807023`*^9, 3.5687249677347794`*^9}, {
   3.5687250146596613`*^9, 3.568725098463009*^9}, {3.568725141659485*^9, 
   3.568725301122965*^9}, {3.5687253407938347`*^9, 3.56872536679908*^9}, {
   3.5687254761552725`*^9, 3.568725560785421*^9}, {3.568725648691575*^9, 
   3.568725651842781*^9}, {3.5687258542531366`*^9, 3.5687259857301674`*^9}, 
   3.5687261104211864`*^9, {3.5687265230107107`*^9, 3.5687265265051174`*^9}, {
   3.568726862373707*^9, 3.5687269265054197`*^9}, {3.5687269627286835`*^9, 
   3.568726962978284*^9}, 3.568727003741155*^9, {3.568731233856185*^9, 
   3.568731242795001*^9}, 3.568792241686411*^9, {3.5687927946300373`*^9, 
   3.5687929072424784`*^9}, {3.5687929750293555`*^9, 
   3.5687930189178658`*^9}, {3.568793051926754*^9, 3.568793104471759*^9}, {
   3.5687932747134967`*^9, 3.5687932852330985`*^9}, {3.5687940793905215`*^9, 
   3.568794087533987*^9}, {3.5687942954638805`*^9, 3.568794405128153*^9}, {
   3.5687945653753185`*^9, 3.5687945655653296`*^9}, {3.5687948791402645`*^9, 
   3.568794977156871*^9}, {3.568812045871216*^9, 3.5688120526486034`*^9}, {
   3.5688120859835105`*^9, 3.568812093814958*^9}, {3.568812147904052*^9, 
   3.568812199553006*^9}, 3.5688122321138687`*^9, {3.5688122752093334`*^9, 
   3.5688122773364553`*^9}, {3.5688123391679916`*^9, 3.568812578890703*^9}, {
   3.568812765928401*^9, 3.5688127893297396`*^9}, {3.568812839281596*^9, 
   3.568812854959493*^9}, {3.568812886867318*^9, 3.5688128939387226`*^9}, {
   3.568813307064352*^9, 3.5688133171439285`*^9}, {3.5688133919922094`*^9, 
   3.568813425088103*^9}, {3.5688136244625063`*^9, 3.56881364830087*^9}, {
   3.568813869800539*^9, 3.568813941937665*^9}, {3.568813972905436*^9, 
   3.568814023234315*^9}, 3.5688140719210997`*^9, {3.568815438199246*^9, 
   3.568815566195567*^9}, {3.568815604587763*^9, 3.568815614339321*^9}, {
   3.5688156747077737`*^9, 3.568815689715632*^9}, 3.5688157203393836`*^9, 
   3.5688157512611523`*^9, {3.568815784597059*^9, 3.5688158609494257`*^9}, {
   3.5688159815753255`*^9, 3.568815999892373*^9}, 3.568816074357632*^9, {
   3.568816717206401*^9, 3.568816748085167*^9}, {3.568816780444018*^9, 
   3.5688167894755344`*^9}, {3.5688168386693487`*^9, 
   3.5688168470998306`*^9}, {3.568816886237069*^9, 3.5688169390990925`*^9}, 
   3.56896084020609*^9, 3.5689715695770845`*^9, {3.568972785661621*^9, 
   3.568972914892248*^9}, {3.56897320658156*^9, 3.5689732112147684`*^9}, {
   3.56904903122258*^9, 3.5690490436542907`*^9}, {3.569049200137241*^9, 
   3.569049200433258*^9}, 3.569049240029523*^9, {3.569049288078271*^9, 
   3.5690492929345484`*^9}, {3.5690493294696383`*^9, 3.569049331209738*^9}, 
   3.56904937670634*^9, {3.569049461539192*^9, 3.5690494786911736`*^9}, {
   3.5690495465100527`*^9, 3.569049554621516*^9}, {3.5690508377229056`*^9, 
   3.569050839427003*^9}, {3.569050932948352*^9, 3.5690509754057803`*^9}, {
   3.5690510143560085`*^9, 3.569051022484473*^9}, {3.56905106158871*^9, 
   3.56905111648485*^9}, {3.569051175132204*^9, 3.569051260923111*^9}, {
   3.569051328760991*^9, 3.5690513472810507`*^9}, {3.5690718288042917`*^9, 
   3.5690718338587008`*^9}, {3.5690718704407654`*^9, 3.569071876493576*^9}, {
   3.569071921031654*^9, 3.569071946085298*^9}, {3.569077089246558*^9, 
   3.569077113997974*^9}, {3.5690772895930176`*^9, 3.5690773334325247`*^9}, {
   3.5690773826103377`*^9, 3.5690774628419266`*^9}, 3.569077781145133*^9, {
   3.5707816819630365`*^9, 3.570781767263915*^9}, {3.5707818163067207`*^9, 
   3.5707818240311623`*^9}, {3.570782500885876*^9, 3.5707826216417828`*^9}, {
   3.570799353832363*^9, 3.570799379603609*^9}, {3.5709425840516787`*^9, 
   3.570942605626517*^9}},ExpressionUUID->"d6ef9690-4f20-4c87-99c8-\
b15d60c41c7d"],

Cell["Finally, the contraction with a single slot pair:", "Text",
 CellChangeTimes->{{3.5690774898694725`*^9, 
  3.5690775160929728`*^9}},ExpressionUUID->"21c97f9b-2e51-4949-8f35-\
d2a575d40ebd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contraction", "[", 
   RowBox[{"tt_", ",", "i_Integer", ",", "j_Integer"}], "]"}], " ", ":=", " ", 
  RowBox[{"contraction", "[", 
   RowBox[{"tt", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"i", ",", "j"}], "}"}], "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5690528917753906`*^9, 
  3.5690529887959394`*^9}},ExpressionUUID->"d5c3c8a1-9c43-412e-9b3b-\
9c3caa44362d"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3.5. Examples of Contractions", "Subsection",
 CellChangeTimes->{{3.568989063758211*^9, 3.5689890693274207`*^9}, {
   3.569079033142743*^9, 3.5690790379490175`*^9}, {3.643379840754487*^9, 
   3.643379843390891*^9}, {3.6434384444367294`*^9, 3.643438455372349*^9}, 
   3.643442650282117*^9, 
   3.6434619018503523`*^9},ExpressionUUID->"ff5c8ed2-e417-4c1b-af36-\
f2fd3bea6301"],

Cell[CellGroupData[{

Cell["3.5.1. Example  tensor[a, 3, 2, 3]", "Subsubsection",
 CellChangeTimes->{{3.5689890777826357`*^9, 3.568989085473449*^9}, {
   3.5690790508937583`*^9, 3.569079061957391*^9}, 3.5732053067607083`*^9, {
   3.603093078831934*^9, 
   3.6030930813430777`*^9}},ExpressionUUID->"9d5b19d4-f589-4fa4-a408-\
c390bcb5374d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", " ", "3", ",", "2", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.568792296292534*^9, 3.568792328225361*^9}, {
   3.568812708461114*^9, 3.5688127143174486`*^9}, 3.568816472519406*^9, {
   3.5691249574350367`*^9, 
   3.569124980821374*^9}},ExpressionUUID->"344b8d40-935d-481a-bc7b-\
615fe297664d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "tb", "]"}], ";", 
  RowBox[{"tb", " ", "=", 
   RowBox[{"contraction", "[", 
    RowBox[{"ta", ",", "1", ",", "2"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5687260086466074`*^9, 3.568726076085526*^9}, {
   3.5687265624787807`*^9, 3.568726631727302*^9}, {3.56872672760507*^9, 
   3.5687267288842726`*^9}, {3.568726832250054*^9, 3.568726845416477*^9}, {
   3.568727110367343*^9, 3.568727113378148*^9}, {3.5687931479232445`*^9, 
   3.5687931817391787`*^9}, {3.568793465331399*^9, 3.5687935301081047`*^9}, {
   3.568794113595478*^9, 3.568794145115281*^9}, {3.568812947966813*^9, 
   3.568812986646025*^9}, {3.5688137516387806`*^9, 3.568813761806362*^9}, {
   3.568973004639206*^9, 3.568973033483656*^9}, 3.5689730958057656`*^9, 
   3.568988919223957*^9, {3.5690530173235717`*^9, 3.5690530253870325`*^9}, 
   3.569125042623909*^9},ExpressionUUID->"199dcd0d-325e-4312-9281-\
2ff9c8f6c1a9"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.5690727293098745`*^9, 
  3.5690727343798833`*^9}},ExpressionUUID->"5636ad84-77a7-4fb1-8407-\
065568cef60f"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5690724237521377`*^9, 
  3.5690724562157946`*^9}},ExpressionUUID->"bd11b379-23d5-48fd-abb6-\
5b3381f9d65d"],

Cell[BoxData[
 RowBox[{"coords", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.5689729644067345`*^9, 3.568972971957148*^9}, {
  3.5690729572418747`*^9, 
  3.569072973590703*^9}},ExpressionUUID->"3c2241ef-87aa-4552-a6bc-\
f75dca30f4ae"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56881300578712*^9, 3.568813017444787*^9}, 
   3.5688138188306236`*^9, {3.5688141052460055`*^9, 3.568814105885042*^9}, {
   3.5688170597239923`*^9, 3.568817097782169*^9}, 3.568817196525817*^9, {
   3.5691251313609843`*^9, 
   3.569125138152373*^9}},ExpressionUUID->"d017feb6-c6d3-4b67-bb08-\
880b3d8e14cd"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030932486186457`*^9, 
  3.603093254751996*^9}},ExpressionUUID->"cfd83273-312f-4476-9ddf-\
824884a95bed"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56881300578712*^9, 3.568813017444787*^9}, 
   3.5688138188306236`*^9, {3.5688141052460055`*^9, 3.568814105885042*^9}, {
   3.5688170597239923`*^9, 3.568817097782169*^9}, 3.568817196525817*^9, {
   3.5691251313609843`*^9, 3.569125138152373*^9}, {3.5691251692651525`*^9, 
   3.56912517796565*^9}},ExpressionUUID->"f614da11-5e67-482a-8d7b-\
f84ec2b7d9ad"],

Cell[BoxData[
 RowBox[{"tb2", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"ta", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569125204465166*^9, 3.5691252779493685`*^9}, {
  3.5707812148373184`*^9, 3.5707812435509605`*^9}, {3.570798513692888*^9, 
  3.570798581490607*^9}},ExpressionUUID->"cebfd1a5-f573-49ad-9fca-\
4357ac85632e"],

Cell[BoxData[
 RowBox[{"type", "[", "tb2", "]"}]], "Input",
 CellChangeTimes->{{3.6030932973524327`*^9, 
  3.60309330586792*^9}},ExpressionUUID->"eb42d5e2-77e1-48a5-afd8-\
d2b3a107fa81"],

Cell[BoxData[
 RowBox[{"tb2", "[", 
  RowBox[{
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570798612409861*^9, 
  3.5707986573691397`*^9}},ExpressionUUID->"bac89a9f-e339-459f-aa8f-\
9ab7a43afb37"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569125204465166*^9, 3.569125306423998*^9}, {
   3.5707813362092605`*^9, 3.570781352761207*^9}, 
   3.5707816332042475`*^9},ExpressionUUID->"aad85e09-afb8-4398-b7b8-\
9e56e8c358e0"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5707813902113495`*^9, 3.5707814261974077`*^9}, 
   3.5707815684455433`*^9, 
   3.6030934546094275`*^9},ExpressionUUID->"687aeae3-19d5-42b6-91be-\
529ab101016c"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569125204465166*^9, 3.5691253247150435`*^9}, {
  3.5707989190127993`*^9, 
  3.5707989257520113`*^9}},ExpressionUUID->"937791d0-4f7d-456d-8136-\
35f4d7ecf7e3"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569125204465166*^9, 3.569125362083181*^9}, {
  3.57079877680295*^9, 
  3.5707988763623247`*^9}},ExpressionUUID->"4e6880d0-92b3-407a-9324-\
72ac657212d4"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.569125204465166*^9, 3.569125362083181*^9}, {
  3.57079877680295*^9, 3.5707988763623247`*^9}, {3.570799026996189*^9, 
  3.5707990477442255`*^9}},ExpressionUUID->"b5a8ca4a-a5ce-469c-9dec-\
ed8df6d8312e"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5707990599902472`*^9, 
  3.5707990897862997`*^9}},ExpressionUUID->"bd167ced-af76-4766-b81c-\
0e7ab688992f"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.5.2. Example tensor[a, 5, 8, 3]", "Subsubsection",
 CellChangeTimes->{{3.5690496134258795`*^9, 3.569049621929366*^9}, {
  3.5690790683977594`*^9, 3.5690790872128353`*^9}, {3.5732053579906387`*^9, 
  3.573205365590073*^9}, {3.60309372984717*^9, 
  3.6030937788949757`*^9}},ExpressionUUID->"5dc57d70-3a22-4f2e-807e-\
2788b34e724f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", " ", "[", 
    RowBox[{"a", ",", "5", ",", "8", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5690496267046394`*^9, 3.5690496595305166`*^9}, 
   3.5690498226438465`*^9, {3.5690757604155536`*^9, 
   3.569075768231001*^9}},ExpressionUUID->"51f7206b-71db-4439-b12a-\
00f1b1340699"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"ta", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "7"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569049682693842*^9, 3.5690497997965393`*^9}, {
   3.569051406164418*^9, 3.569051407852515*^9}, 3.5690758671126566`*^9, {
   3.569125473286542*^9, 
   3.5691255143828917`*^9}},ExpressionUUID->"ccf9e942-d42b-4408-b700-\
a23b5af74a71"],

Cell[BoxData[
 RowBox[{"type", "[", "tc", "]"}]], "Input",
 CellChangeTimes->{{3.5690514175450697`*^9, 
  3.569051438035241*^9}},ExpressionUUID->"d0cb30c1-b557-4ee3-b62d-\
841cd161ac2c"],

Cell[BoxData[
 RowBox[{"tc3", " ", "=", " ", 
  RowBox[{"tc", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "1"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.569051449274884*^9, 3.56905148241078*^9}, 
   3.569125652169773*^9},ExpressionUUID->"005206ab-8999-42ba-ade5-\
67f1099641af"],

Cell[BoxData[
 RowBox[{"tradf", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6030938319190083`*^9, 
  3.603093846792859*^9}},ExpressionUUID->"99df91fa-4755-43cf-a4b6-\
4e0fff311dee"],

Cell["\<\
Here is the same  coordinate of the contraction calculated by direct \
summation:\
\>", "Text",
 CellChangeTimes->{{3.5690786340529165`*^9, 
  3.5690787289733458`*^9}},ExpressionUUID->"3d3f814a-0433-4159-abb1-\
53906301ac14"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta3", "=", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"{", " ", 
        RowBox[{"1", ",", "i", ",", "j", ",", "k", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "j", ",", "1", ",", "2", ",", "i", " ", ",", "1", ",", " ", "2", ",", 
         "k", ",", "1"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "3"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.569050147461425*^9, 3.569050208962942*^9}, {
   3.5690502983550553`*^9, 3.5690503015392375`*^9}, {3.569050337515295*^9, 
   3.5690504341718235`*^9}, {3.569050472996044*^9, 3.5690505840523963`*^9}, 
   3.5690758332737207`*^9, {3.569125697906389*^9, 3.569125714321328*^9}, {
   3.569125748839302*^9, 3.5691257889065943`*^9}, {3.569125920260107*^9, 
   3.569125924616356*^9}},ExpressionUUID->"4311296e-3be8-4790-808b-\
d7da1d39b2ef"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"ta3", "-", "tc3"}], "]"}]], "Input",
 CellChangeTimes->{{3.56905059076978*^9, 3.569050608435791*^9}, {
   3.569051496114563*^9, 3.569051501282859*^9}, 
   3.5690759287841835`*^9},ExpressionUUID->"039e881a-19bd-44ad-85b6-\
6998dd8463a1"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"ta", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "8"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569049682693842*^9, 3.5690497997965393`*^9}, {
   3.569051406164418*^9, 3.569051407852515*^9}, 3.5690758671126566`*^9, {
   3.569125473286542*^9, 3.5691255143828917`*^9}, {3.6434377619979305`*^9, 
   3.643437782527567*^9}, {3.6434378251000414`*^9, 3.643437869216919*^9}, {
   3.6434382748800316`*^9, 
   3.643438285893651*^9}},ExpressionUUID->"2c24c595-6755-4a46-8017-\
5abc0d622611"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"ta", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"5", ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "8"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569049682693842*^9, 3.5690497997965393`*^9}, {
   3.569051406164418*^9, 3.569051407852515*^9}, 3.5690758671126566`*^9, {
   3.569125473286542*^9, 3.5691255143828917`*^9}, {3.6434377619979305`*^9, 
   3.643437782527567*^9}, {3.6434378251000414`*^9, 3.643437869216919*^9}, {
   3.6434379123977947`*^9, 3.6434379633474846`*^9}, {3.6434383135368996`*^9, 
   3.6434383317421317`*^9}},ExpressionUUID->"2d44ec32-c187-4a8f-ac62-\
bcb90ef771f9"],

Cell[BoxData[
 RowBox[{"type", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.643438116882954*^9, 3.6434381250573683`*^9}, 
   3.6434383891190324`*^9},ExpressionUUID->"79b6a0ef-e6bd-4f4e-8ee3-\
0e8c68b7bb79"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.5.3. Example tensor[a,1,1]", "Subsubsection",
 CellChangeTimes->{{3.5690737019871826`*^9, 3.569073733936039*^9}, {
  3.5690790928611584`*^9, 3.5690791013166423`*^9}, {3.5732053901984806`*^9, 
  3.5732053928236313`*^9}},ExpressionUUID->"3dfab0a6-f59f-4a4f-9c2b-\
54857b4971f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", 
  RowBox[{"dim", "=", " ", "3"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "1", ",", "1"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5687899920887413`*^9, 3.5687900048504715`*^9}, {
  3.569125994061328*^9, 3.5691260112353106`*^9}, {3.643438486572404*^9, 
  3.643438491860813*^9}},ExpressionUUID->"dc93e88e-f892-407b-922b-\
c543f65d6634"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.569073505754438*^9, 
  3.569073519186062*^9}},ExpressionUUID->"865db686-6096-43a5-a630-\
aba6bd6a28e8"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569073537703294*^9, 
  3.56907354678251*^9}},ExpressionUUID->"54936855-60d0-4a99-87be-\
8ddced3568a0"],

Cell[BoxData[
 RowBox[{"%", " ", "\[Equal]", " ", 
  RowBox[{"trace", "[", 
   RowBox[{"coords", "[", "ta", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5690735579677296`*^9, 3.569073567109346*^9}, {
  3.5690736486194887`*^9, 
  3.569073659040307*^9}},ExpressionUUID->"4ef6e114-c36d-4442-8a34-\
293b68d4445c"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.5.4. Multilinear Functions and Forms", "Subsubsection",
 CellChangeTimes->{
  3.5690794662375145`*^9, {3.569126519931406*^9, 3.5691265278858614`*^9}, 
   3.5691294637117805`*^9, 3.573206610990306*^9, {3.573206730414137*^9, 
   3.5732067507583003`*^9}, 3.6030949546092224`*^9, {3.6434426579261303`*^9, 
   3.64344266939215*^9}, 
   3.6434602656329355`*^9},ExpressionUUID->"2f41c4e0-fbfb-4029-89c1-\
fa255495d226"],

Cell[TextData[{
 "We show that the covariant tensors of type(k,0) are a vector space \
isomorphic to the space of multilinear functions in k variables with values \
in the basic field. Indeed, let f be such a function, and {",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "i"], TraditionalForm]],ExpressionUUID->
  "8d7f91d9-1f62-4ad8-926a-eeb68608548e"],
 "} a basis of the underlying vector space. Set"
}], "Text",
 CellChangeTimes->{{3.5623953160046434`*^9, 3.562395658768445*^9}, {
  3.56239572891181*^9, 3.5623957755914793`*^9}, {3.562395859602285*^9, 
  3.562395898839529*^9}},
 FontSize->16,ExpressionUUID->"48dad9b7-90af-4db8-8007-617869801ef6"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   SubscriptBox["w", 
    RowBox[{
     RowBox[{"i1", "..."}], "ik"}]], ":=", 
   RowBox[{"f", "[", 
    RowBox[{
     FormBox[
      SubscriptBox["b", "i1"],
      TraditionalForm], ",", 
     FormBox[
      SubscriptBox["b", "i2"],
      TraditionalForm], ",", "...", ",", 
     FormBox[
      SubscriptBox["b", "ik"],
      TraditionalForm]}], "]"}]}],
  FontColor->GrayLevel[0]]], "Input",
 Evaluatable->False,
 FontSize->16,ExpressionUUID->"32126bd1-378d-4a18-97fb-9f66c894ceb0"],

Cell[TextData[{
 "Since f is linear in each argument one sees that the ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["w", 
    RowBox[{
     RowBox[{"i1", "..."}], "ik"}]], " "}]],
  Evaluatable->False,
  CellChangeTimes->{{3.5623957896942863`*^9, 3.5623958348058662`*^9}, {
   3.5623959199897385`*^9, 3.562395993115921*^9}},ExpressionUUID->
  "8a43cdf9-600a-4a66-b6ce-abd247c4073c"],
 " are the ",
 "coordinate",
 "s of a covariant tensor  w of type (k,0). Furthermore, the map f \
\[RightTeeArrow] w is linear and bijective: injective, since only the \
zero-function yields the nulltensor, and surjective, since every tensor of \
type (k,0) defines the multilinear map of k variables: "
}], "Text",
 CellChangeTimes->{{3.5623960705823517`*^9, 3.5623962552389135`*^9}, {
   3.562396288718829*^9, 3.5623964551353474`*^9}, {3.5691262842119236`*^9, 
   3.569126320475998*^9}, {3.56912637663621*^9, 3.569126403486746*^9}, 
   3.6011845115788655`*^9},
 FontSize->16,ExpressionUUID->"b897f231-90c1-48fd-a51f-e375b47bdac3"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{
    SubscriptBox["f", "w"], "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", 
       RowBox[{"1", ","}]], 
      SubscriptBox["x", "2"]}], ",", "...", ",", 
     SubscriptBox["x", "k"]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["w", 
       RowBox[{
        RowBox[{"i1", "..."}], "ik"}]], 
      SubsuperscriptBox["x", "1", "i1"], 
      SubsuperscriptBox["x", "2", "i2"]}], "..."}], 
    SubsuperscriptBox["x", "k", "ik"]}]}],
  FontColor->GrayLevel[0]]], "Input",
 Evaluatable->False,
 FontSize->16,ExpressionUUID->"5c9782fe-d91e-4e63-9f2b-3db9bd5a136e"],

Cell[TextData[{
 "Here  ",
 Cell[BoxData[
  SubsuperscriptBox["x", "j", "ij"]],
  Evaluatable->False,
  CellChangeTimes->{
   3.5623964593385878`*^9, {3.56239648998534*^9, 3.562396777652794*^9}},
  ExpressionUUID->"190d76a3-1d5c-477f-a9eb-7bf52e770f6f"],
 " are the coordinates of the vector  ",
 Cell[BoxData[
  SubscriptBox["x", "j"]],
  Evaluatable->False,
  CellChangeTimes->{
   3.5623964593385878`*^9, {3.56239648998534*^9, 3.562396777652794*^9}},
  ExpressionUUID->"d255600b-6d8d-4a2b-aed5-581317e38e0b"],
 ":"
}], "Text",
 CellChangeTimes->{{3.5623968072394867`*^9, 3.5623969054561043`*^9}},
 FontSize->16,ExpressionUUID->"73b61586-1bb1-45e6-a2cf-3bfee3b37c28"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   SubscriptBox["x", "j"], "\[Equal]", 
   RowBox[{
    SubscriptBox["b", "i"], " ", 
    SubsuperscriptBox["x", "j", "i"]}]}],
  FontColor->GrayLevel[0]]], "Input",
 Evaluatable->False,
 FontSize->16,ExpressionUUID->"6588c549-eb50-4a67-b940-ef458edb3bb2"],

Cell[TextData[{
 StyleBox["Example",
  FontColor->RGBColor[0, 0, 1]],
 ". We define a multilinear function corresponding to a covariant tensor of \
type (4,0):"
}], "Text",
 CellChangeTimes->{{3.5691265755695887`*^9, 
  3.569126691743233*^9}},ExpressionUUID->"dea6e865-5d3a-4077-a9d4-\
2ead49f6f811"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"x_", ",", " ", "y_"}], "]"}], " ", ":=", " ", 
  RowBox[{"w", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.5691267875617137`*^9, 3.569126800094431*^9}, {
  3.569126839514685*^9, 
  3.5691268811220655`*^9}},ExpressionUUID->"dcf71ac3-5fc8-4bb5-b9f0-\
b8efaeabb9b6"],

Cell[BoxData[
 RowBox[{"tw", " ", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "4", ",", "0", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5691266980005913`*^9, 3.5691267422351213`*^9}, 
   3.5691268973779945`*^9},ExpressionUUID->"7f1c51d8-f042-4446-b34d-\
926589795f33"],

Cell[BoxData[
 RowBox[{"tw", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5691269051764407`*^9, 
  3.569126932326994*^9}},ExpressionUUID->"0f228f24-2ed1-4de3-a63c-\
bfcce29a43cc"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["tx", "i_"], " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{
    SubscriptBox["x", "i"], ",", "0", ",", "1", ",", "3"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.569127026410375*^9, 
  3.5691271214198093`*^9}},ExpressionUUID->"f56d7ad8-b6c6-4857-80e4-\
8738451d97bd"],

Cell[BoxData[
 SubscriptBox["tx", "1"]], "Input",
 CellChangeTimes->{{3.5691271618381214`*^9, 
  3.5691271644832726`*^9}},ExpressionUUID->"b7aa1da0-13b0-4a32-a573-\
fb2fa471a897"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["x", "i_"], "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "j_", "}"}]}], "]"}], ":=", " ", 
  RowBox[{
   SubscriptBox["x", "i"], "[", "j", "]"}]}]], "Input",
 CellChangeTimes->{{3.5691272090018187`*^9, 
  3.5691273622435837`*^9}},ExpressionUUID->"0e003933-abdb-4c14-96da-\
3a67c19d1042"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["tx", "1"], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.569127387429024*^9, 
  3.5691274126444664`*^9}},ExpressionUUID->"c250f5f0-c617-4e62-b928-\
3dcff322a172"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", ",", "i"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5691278691015744`*^9, 
  3.5691278700806303`*^9}},ExpressionUUID->"a82f50de-00ba-4d7c-ba78-\
308355b5ef55"],

Cell["\<\
In tensor terms, the corresponding multilinear form is given by\
\>", "Text",
 CellChangeTimes->{{3.5691283853791037`*^9, 
  3.569128432643807*^9}},ExpressionUUID->"d75649a4-d228-4150-aa19-\
6e6445d79de2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fw", "[", 
   RowBox[{"y1_", ",", "y2_", ",", "y3_", ",", "y4_"}], "]"}], " ", ":=", 
  RowBox[{
   RowBox[{"contraction", "[", 
    RowBox[{
     RowBox[{"tensorproduct", "[", 
      RowBox[{"tw", ",", "y1", ",", "y2", ",", "y3", ",", "y4"}], "]"}], ",", 
     
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "i"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "4"}], "}"}]}], "]"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5691275035086637`*^9, 3.569127506644843*^9}, {
   3.569127554894603*^9, 3.569127666999015*^9}, {3.569127714743746*^9, 
   3.569127764597597*^9}, {3.5691278805352283`*^9, 3.5691278811262617`*^9}, {
   3.569128185755686*^9, 3.5691281933101177`*^9}, 
   3.569128369634203*^9},ExpressionUUID->"26a97a78-3944-45eb-b182-\
1a6c7a9bc96d"],

Cell[BoxData[
 RowBox[{"fw", "[", 
  RowBox[{
   SubscriptBox["tx", "1"], ",", 
   SubscriptBox["tx", "2"], ",", 
   SubscriptBox["tx", "3"], ",", 
   SubscriptBox["tx", "4"]}], "]"}]], "Input",
 CellChangeTimes->{{3.5691277757792363`*^9, 3.5691278215048523`*^9}, 
   3.569128482512659*^9},ExpressionUUID->"f5a73087-321b-40f3-af16-\
5822f4d5844b"],

Cell["Of course, this is the same as", "Text",
 CellChangeTimes->{{3.569128586113585*^9, 
  3.5691285987263064`*^9}},ExpressionUUID->"a82425ed-8257-40fe-832c-\
57f6dffc0fea"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j", ",", "k", ",", "l"}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], "*", " ", 
     RowBox[{
      SubscriptBox["x", "1"], "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "i", "}"}]}], "]"}], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "j", "}"}]}], "]"}], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "k", "}"}]}], "]"}], " ", 
     RowBox[{
      SubscriptBox["x", "4"], "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "l", "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5691279925746365`*^9, 3.5691281572650566`*^9}, 
   3.6407614691002283`*^9, {3.640761522174522*^9, 3.6407615263553295`*^9}, {
   3.640761662206769*^9, 3.640761666091176*^9}, {3.640761710899455*^9, 
   3.640761791810198*^9}},ExpressionUUID->"5aef3a63-1b19-4c00-a2c7-\
d0882fe72c8b"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", "-", "%%"}], "]"}]], "Input",
 CellChangeTimes->{{3.640761847711096*^9, 
  3.64076186719853*^9}},ExpressionUUID->"38a9a879-9771-4d1c-8074-\
2ab5fd3b17b9"],

Cell["The corresponding 4-form is", "Text",
 CellChangeTimes->{{3.5691286158122835`*^9, 
  3.569128631559184*^9}},ExpressionUUID->"41d560e1-1dd3-49b4-b9b9-\
2bfa1bdc07c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ffw", "[", "y_", "]"}], " ", ":=", " ", 
  RowBox[{"fw", "[", 
   RowBox[{"y", ",", "y", ",", "y", ",", "y"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569128654787513*^9, 
  3.569128691438609*^9}},ExpressionUUID->"ffb6d2f0-a510-465f-bdac-\
bf1f1083ed01"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"ffw", "[", 
   SubscriptBox["tx", "1"], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5691287114557543`*^9, 
  3.569128757994416*^9}},ExpressionUUID->"66428943-b3e7-4bda-ac1a-\
50771fecc901"],

Cell["The following specialization of w:", "Text",
 CellChangeTimes->{{3.5691292157896004`*^9, 3.569129240718026*^9}, 
   3.643461686735772*^9},ExpressionUUID->"c8daa9c1-f924-4992-8464-\
57edf1ad6ede"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", "j_", ",", "k_", ",", "l_"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"\[Delta]", "[", 
     RowBox[{"i", ",", "j"}], "]"}], "*", 
    RowBox[{"\[Delta]", "[", 
     RowBox[{"i", ",", "k"}], "]"}], "*", 
    RowBox[{"\[Delta]", "[", 
     RowBox[{"i", ",", "l"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.569128860989307*^9, 3.569128934454509*^9}, {
   3.5691289694995136`*^9, 3.5691290266367817`*^9}, 3.6407619902217474`*^9, {
   3.6407620276658134`*^9, 
   3.6407620315814204`*^9}},ExpressionUUID->"d31860d1-cbe9-4434-a414-\
b4eace66b573"],

Cell["yields the polynomial", "Text",
 CellChangeTimes->{{3.5691292488504915`*^9, 
  3.56912926316031*^9}},ExpressionUUID->"cd1926aa-3b04-4160-b527-\
3a7545fe26b6"],

Cell[BoxData[
 RowBox[{"ffw", "[", 
  SubscriptBox["tx", "1"], "]"}]], "Input",
 CellChangeTimes->{{3.569129096860798*^9, 
  3.5691291331848755`*^9}},ExpressionUUID->"8f21c929-9d14-4624-8156-\
04e548657ae0"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"w", ",", "fw", ",", "ffw", ",", "x", ",", " ", "tx"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5691293054287276`*^9, 
  3.569129422804441*^9}},ExpressionUUID->"c9518746-e9d0-4d34-953a-\
b362bf0f722f"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4. Symmetry Properties of Tensors", "Section",
 CellChangeTimes->{{3.5543583608352203`*^9, 3.554358370362765*^9}, {
   3.5546250130420628`*^9, 3.5546250148672657`*^9}, 3.5554812359150333`*^9, 
   3.555650104955531*^9, 3.5558545376363*^9, 3.559030578136163*^9, 
   3.5609304005090137`*^9, {3.5623272209723663`*^9, 3.56232722662669*^9}, 
   3.562338348167384*^9, {3.564396603999541*^9, 3.5643966068457036`*^9}, {
   3.564475220790759*^9, 3.564475233473581*^9}, 3.5650794011533604`*^9, 
   3.6030993743106265`*^9, 3.603193238002977*^9, {3.6407422913897676`*^9, 
   3.640742300562584*^9}, 3.6407423540262775`*^9, 3.6434602748077517`*^9, 
   3.6435106011235495`*^9},ExpressionUUID->"4fed695f-c903-40db-8b85-\
f39505bedfcd"],

Cell[CellGroupData[{

Cell["4.1. CovariantTensors and their Coordinate Arrays", "Subsection",
 CellChangeTimes->{{3.6407425907410936`*^9, 3.640742675028042*^9}, {
   3.6407449198431845`*^9, 3.640744964974064*^9}, 
   3.6408726999282694`*^9},ExpressionUUID->"ddb654ed-8181-4b49-8f68-\
e6260dd65ee1"],

Cell["\<\
In this Subsection we consider covariant tensors, these are those of type {p, \
0}. With the function\
\>", "Text",
 CellChangeTimes->{{3.640742740126956*^9, 3.6407428330251193`*^9}, {
  3.640742872118788*^9, 
  3.6407428943644266`*^9}},ExpressionUUID->"eaffdbe6-3d4e-4a29-8c0c-\
3d08759d931b"],

Cell[BoxData[
 RowBox[{"?", "tensorToArray"}]], "Input",
 CellChangeTimes->{{3.640742905955247*^9, 
  3.6407429140360613`*^9}},ExpressionUUID->"099dac2b-786f-4d7f-b34b-\
c6c66fc9b99e"],

Cell["\<\
we obtain an Array whose elements are the coordinates of the tensor and whose \
structure reflects the tensor type.\
\>", "Text",
 CellChangeTimes->{{3.6407450198861604`*^9, 3.6407450586834283`*^9}, {
  3.6407450933778896`*^9, 3.640745123719943*^9}, {3.6407451589448047`*^9, 
  3.6407451727352285`*^9}},ExpressionUUID->"9716e2b6-8710-4524-b3f9-\
c53241905b50"],

Cell[TextData[{
 StyleBox["Example",
  FontColor->RGBColor[0, 0, 1]],
 "."
}], "Text",
 CellChangeTimes->{{3.6407429696813593`*^9, 
  3.6407429760305705`*^9}},ExpressionUUID->"e970cb61-2fde-4347-aa7f-\
c0c09016c955"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6407432648518777`*^9, 
  3.6407432721682906`*^9}},ExpressionUUID->"314dc3f3-fa60-48c1-84cf-\
7e89c8d91434"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ta", "]"}], ";", " ", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"p_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "p", ",", "0", ",", "d"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.640742991256197*^9, 3.6407430783355503`*^9}, {
  3.6407435948080573`*^9, 
  3.640743631655322*^9}},ExpressionUUID->"390e821c-b031-4098-a247-\
43511da2e3c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"array", "[", 
   RowBox[{"a_", ",", "p_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", 
  RowBox[{"tensorToArray", "[", 
   RowBox[{"ta", "[", 
    RowBox[{"p", ",", "d"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.640743096837182*^9, 3.6407431219220266`*^9}, {
  3.640743370432863*^9, 3.6407434029121203`*^9}, {3.640743653760561*^9, 
  3.640743688673422*^9}},ExpressionUUID->"bfd9f49f-2993-47b2-8fd1-\
8220cb6e229f"],

Cell[BoxData[
 RowBox[{"array", "[", 
  RowBox[{"a", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.640743096837182*^9, 3.6407431219220266`*^9}, {
  3.6407431548716846`*^9, 3.6407431622192974`*^9}, {3.640743424440158*^9, 
  3.6407434581518173`*^9}},ExpressionUUID->"73c8257a-21e1-413a-ab7b-\
e87013bdfee7"],

Cell[BoxData[
 RowBox[{"array", "[", 
  RowBox[{"a", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.640743096837182*^9, 3.6407431219220266`*^9}, {
  3.6407431548716846`*^9, 3.640743187163741*^9}, {3.6407434755770483`*^9, 
  3.640743496683885*^9}},ExpressionUUID->"814eea1a-3c97-4489-bd63-\
2d7b1c0123c8"],

Cell[BoxData[
 RowBox[{"ar42", "=", 
  RowBox[{"array", "[", 
   RowBox[{"a", ",", "4", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.640743096837182*^9, 3.6407431219220266`*^9}, {
  3.6407431548716846`*^9, 3.6407432168505936`*^9}, {3.6407435109423103`*^9, 
  3.6407435409879627`*^9}, {3.640743714631868*^9, 3.6407437164102707`*^9}, {
  3.6407437685299625`*^9, 
  3.640743771727968*^9}},ExpressionUUID->"89d9ace2-083c-4083-9a4c-\
9f553716ffd3"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", "ar42", "]"}]], "Input",
 CellChangeTimes->{{3.64074377845158*^9, 
  3.6407437941140075`*^9}},ExpressionUUID->"2d321d4c-63e6-44f0-9d6c-\
0c7f372a3828"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", "ar42", "]"}]], "Input",
 CellChangeTimes->{{3.64074377845158*^9, 
  3.640743826780465*^9}},ExpressionUUID->"e6b1d4f3-60c6-4e75-9d7e-\
44e41017f01e"],

Cell["\<\
\[FilledSquare]
\
\>", "Text",
 CellChangeTimes->{{3.6407452491129627`*^9, 
  3.6407452534185705`*^9}},ExpressionUUID->"b4058f0e-f893-4f68-80b9-\
8707ff93e21a"],

Cell[BoxData[
 RowBox[{"?", "Array"}]], "Input",
 CellChangeTimes->{{3.640743885639368*^9, 
  3.640743887870172*^9}},ExpressionUUID->"64b54d21-e254-472f-9202-\
966b48efc66b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "[", "x", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"x", ",", "dim"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6435055742748947`*^9, 
  3.6435055989229383`*^9}},ExpressionUUID->"826ebedc-4ef0-4f14-88f0-\
29c80b140909"],

Cell["\<\
The Arrays generated by tensorToArray[ta[p,d]] are all of the type\
\>", "Text",
 CellChangeTimes->{{3.640744020142804*^9, 3.6407440554768667`*^9}, {
  3.640744095615737*^9, 
  3.640744112245366*^9}},ExpressionUUID->"c5cd70b1-28b4-4825-9695-\
f2c4a10452a2"],

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"a", ",", 
   RowBox[{"Table", "[", 
    RowBox[{"d", ",", 
     RowBox[{"{", "p", "}"}]}], "]"}]}], "]"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.640744127486593*^9, 3.6407442236919622`*^9}, 
   3.643505724565559*^9},ExpressionUUID->"7d6b589c-5966-4ca8-ba1f-\
20af5c70d32e"],

Cell["In the Example we have", "Text",
 CellChangeTimes->{{3.6407453323391094`*^9, 
  3.640745353835947*^9}},ExpressionUUID->"39fd6760-1129-4550-8a78-\
8e1c412c6924"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ar42", " ", "\[Equal]", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Table", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", "4", "}"}]}], "]"}]}], "]"}]}], "/.", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"i_", ",", "j_", ",", "k_", ",", "l_"}], "]"}], "\[Rule]", " ", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "j", ",", "k", ",", "l"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6407442404619913`*^9, 3.640744369583418*^9}, 
   3.6435058784598293`*^9, {3.643506142240692*^9, 
   3.6435062181348257`*^9}},ExpressionUUID->"5586e460-0786-4805-b678-\
f10a72406b0c"],

Cell["\<\
Given an Array of the described type we may reproduce the tensor using the \
function\
\>", "Text",
 CellChangeTimes->{{3.6407444512027617`*^9, 3.640744540700119*^9}, {
  3.6407445910570073`*^9, 
  3.6407445976246185`*^9}},ExpressionUUID->"4923c7bd-e058-43df-93a3-\
881979cfb1b6"],

Cell[BoxData[
 RowBox[{"?", "ArrayTotensor"}]], "Input",
 CellChangeTimes->{{3.640744571650573*^9, 
  3.640744604738231*^9}},ExpressionUUID->"68867957-8e0f-450f-99c0-\
1fdf6901588c"],

Cell[TextData[{
 StyleBox["Example",
  FontColor->RGBColor[0, 0, 1]],
 "."
}], "Text",
 CellChangeTimes->{{3.640745380792794*^9, 
  3.6407453948016186`*^9}},ExpressionUUID->"71186507-2960-47b0-a1b0-\
8586d23546db"],

Cell[BoxData[
 RowBox[{"taa", " ", "=", " ", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"ar42", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.640744683112769*^9, 
  3.640744741472471*^9}},ExpressionUUID->"63f53820-7538-41dd-8417-\
7a8c7c03dbcd"],

Cell[TextData[{
 "The tensors are formally defined  in different ways, thus they don\
\[CloseCurlyQuote]t coincide as ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " objects:"
}], "Text",
 CellChangeTimes->{{3.640745441695301*^9, 3.6407454687613487`*^9}, {
   3.6407455000238037`*^9, 3.6407456137012033`*^9}, 
   3.6407467805676527`*^9},ExpressionUUID->"96c9056a-ec22-4187-a5f5-\
f3ab5c07ed61"],

Cell[BoxData[
 RowBox[{"TrueQ", "[", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"4", ",", "2"}], "]"}], " ", "\[Equal]", "taa"}], "]"}]], "Input",\

 CellChangeTimes->{{3.6407447693965206`*^9, 3.640744775714532*^9}, {
  3.6407448430286493`*^9, 3.640744847334257*^9}, {3.6407456241220217`*^9, 
  3.6407456589568825`*^9}},ExpressionUUID->"eba88a5c-bb36-4190-a240-\
57b0506e5d78"],

Cell["\<\
As tensors they coincide since their types and coordinate functions coincide:\
\
\>", "Text",
 CellChangeTimes->{{3.640745709656972*^9, 
  3.640745767205473*^9}},ExpressionUUID->"ecb26912-81b9-45c6-9e54-\
5197eb7a5f4d"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"ta", "[", 
    RowBox[{"4", ",", "2"}], "]"}], " ", ",", "taa"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407447853553486`*^9, 3.6407448025465784`*^9}, {
  3.640744858441477*^9, 
  3.640744863417886*^9}},ExpressionUUID->"6bff3d57-0ad6-472f-b16e-\
0468670d77ca"],

Cell[TextData[{
 "We treat the covariant tensors as their Arrays of coordinates.  This has \
the advantage that we may apply the built-in tensor functions of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", where covariant and contravariant tensors aren\[CloseCurlyQuote]t \
distinguished; tensors of mixed type (k,h) with k>0 and h>0 aren\
\[CloseCurlyQuote]t considered in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". Because of the duality all what is done for covariant tensors is valid  \
for contrariant tensors too."
}], "Text",
 CellChangeTimes->{{3.6407459388525743`*^9, 3.640746220495469*^9}, {
   3.6407462564691324`*^9, 3.6407462666715503`*^9}, {3.640746305110018*^9, 
   3.640746387946163*^9}, {3.6407467272467594`*^9, 3.640746729695964*^9}, 
   3.6407468051688957`*^9, {3.64074712007869*^9, 3.6407471380499215`*^9}, 
   3.6408727757132025`*^9},ExpressionUUID->"4f22abf6-91ce-412f-b956-\
7af93ecb481f"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2. Symmetric and Antisymmetric Tensors", "Subsection",
 CellChangeTimes->{{3.640762422579714*^9, 3.6407624517099657`*^9}, 
   3.640780498642351*^9, {3.6411331944094906`*^9, 
   3.641133206873912*^9}},ExpressionUUID->"bd8ac46c-e6a0-4158-95f5-\
eb8ae74f36c0"],

Cell["\<\
Definition. A covariant (or contravariant) tensor ta  of degree p is said to \
be symmetric iff for each permutation (j1,..., jp) of the indices (i1,..., \
ip) its coordinates satisfy\
\>", "Text",
 CellChangeTimes->{{3.6442927556181755`*^9, 3.6442927652901926`*^9}, {
  3.6442928413715262`*^9, 3.6442930320818615`*^9}, {3.644293063905917*^9, 
  3.6442931363992443`*^9}},ExpressionUUID->"39496508-7d48-41d1-926e-\
8a13247b832a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"{", 
     RowBox[{"j1", ",", "...", ",", " ", "jp"}], "}"}], "]"}], " ", 
   "\[Equal]", "  ", 
   RowBox[{"a", "[", 
    RowBox[{"{", 
     RowBox[{"i1", ",", "...", ",", " ", "ip"}], "}"}], "]"}]}], 
  ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.644293154526476*^9, 3.6442932646002693`*^9}, {
  3.6442933209631686`*^9, 
  3.6442933221799707`*^9}},ExpressionUUID->"fe543cad-5a12-499e-9074-\
67016c2a787d"],

Cell["ta is antisymmetric if for all these permutations one has", "Text",
 CellChangeTimes->{{3.6442933528028245`*^9, 
  3.6442934136897316`*^9}},ExpressionUUID->"1e0c0f7a-1392-4ebf-a9ec-\
0ec7c288fe8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"{", 
     RowBox[{"j1", ",", "...", ",", " ", "jp"}], "}"}], "]"}], " ", 
   "\[Equal]", " ", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"{", 
      RowBox[{"i1", ",", "...", ",", " ", "ip"}], "}"}], "]"}], "*", 
    RowBox[{"Signature", "[", 
     RowBox[{"{", 
      RowBox[{"i1", ",", "...", ",", " ", "ip"}], "}"}], "]"}], "*", 
    RowBox[{"Signature", "[", 
     RowBox[{"{", 
      RowBox[{"j1", ",", "...", ",", " ", "jp"}], "}"}], "]"}]}]}], 
  ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.644293154526476*^9, 3.6442932646002693`*^9}, {
  3.6442933209631686`*^9, 3.6442933221799707`*^9}, {3.6442940463956428`*^9, 
  3.644294179931877*^9}},ExpressionUUID->"557cfa94-b67a-4ea5-937e-\
6ab5a1b29d9d"],

Cell[BoxData[
 RowBox[{"?", "Signature"}]], "Input",
 CellChangeTimes->{{3.644293478429845*^9, 
  3.6442934858710585`*^9}},ExpressionUUID->"231c3b9a-239f-412f-866b-\
1887a50c9f2f"],

Cell[TextData[{
 "The signature of the permutation is ",
 Cell[BoxData[
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"-", "1"}], ")"}], 
   StyleBox["n", "TI"]]], "InlineFormula",ExpressionUUID->
  "c608c4f5-0237-4277-8233-f4f9bac42eee"],
 ", where ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula",ExpressionUUID->
  "07d8283e-418e-481f-a8eb-bbea1da824c0"],
 " is the number of transpositions of pairs of elements that must be composed \
to get the natural order of the elements of list  If any two elements of ",
 Cell[BoxData[
  StyleBox["list", "TI"]], "InlineFormula",ExpressionUUID->
  "062c5aa8-845d-4e3c-80ba-77010e8e4f0f"],
 " are the same, Signature[list] == ",
 Cell[BoxData[
 "0"], "InlineFormula",ExpressionUUID->"e8a8b839-67e0-4d41-96e0-0301d92e6e6e"],
 ". A tensor ta is antisymmetric if for any transposition of indices i, j  \
one has"
}], "Text",
 CellChangeTimes->{
  3.6442936161936874`*^9, {3.6442936641637716`*^9, 3.6442936655209737`*^9}, {
   3.644293703725441*^9, 3.6442937373122997`*^9}, {3.644294257167613*^9, 
   3.644294319240122*^9}, {3.6442943702522116`*^9, 3.644294375774621*^9}, {
   3.6442944292515154`*^9, 3.6442945038976464`*^9}, {3.644294543568516*^9, 
   3.6442945548161354`*^9}, {3.6442945892921963`*^9, 
   3.6442946074506283`*^9}},ExpressionUUID->"50d90e72-defa-4acd-bbba-\
638698388f07"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"{", 
    RowBox[{"..", ",", "i", ",", "..", ",", "j", ",", ".."}], "}"}], "]"}], 
  " ", "\[Equal]", " ", 
  RowBox[{"-", " ", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"{", 
      RowBox[{"..", ",", "j", ",", "..", ",", "i", ",", ".."}], "}"}], "]"}], 
    "."}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.644294630725869*^9, 
  3.6442947430772667`*^9}},ExpressionUUID->"3fd1dc8f-f142-4e86-8333-\
49bfa633237c"],

Cell[CellGroupData[{

Cell["4.2.1. Symmetric Tensors", "Subsubsection",
 CellChangeTimes->{{3.6411332307263536`*^9, 
  3.6411332623164096`*^9}},ExpressionUUID->"c8710614-4fc4-4b0b-86cc-\
075686b3a620"],

Cell["\<\
In this Subsection we construct functions creating symmetric covariant or \
contravariant tensors. We begin with the definition of symmetric Arrays \
appearing as coordinate Arrays of such tensors or of symmetric multilinear \
forms.\
\>", "Text",
 CellChangeTimes->{{3.6407824721270285`*^9, 3.6407826324291124`*^9}, 
   3.64078283436707*^9},ExpressionUUID->"8a92ec11-e96b-4bdb-8b6e-\
d357d576707f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"symform", "[", 
    RowBox[{"a_", ",", "p_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rr", ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{"IntegerQ", "[", "p", "]"}], "]"}], "||", 
         RowBox[{"p", "<", "0"}]}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<Wrong p = \>\"", ",", "p"}], "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"p", "\[Equal]", "0"}], ",", " ", 
        RowBox[{"Return", "[", "a", "]"}]}], "]"}], ";", " ", 
      RowBox[{"rr", "=", 
       RowBox[{"SymmetrizedArray", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "i__", "}"}], "\[Rule]", 
          RowBox[{"a", "[", "i", "]"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", "p", "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Symmetric", "[", 
           RowBox[{"Range", "[", "p", "]"}], "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Normal", "[", "rr", "]"}]}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.640672595151754*^9, 3.640672763070449*^9}, {
   3.6406728179513454`*^9, 3.640672903689096*^9}, {3.640672949989977*^9, 
   3.6406729518775806`*^9}, {3.640673010174883*^9, 3.6406730265861115`*^9}, 
   3.6406730697513876`*^9, {3.640762473331603*^9, 3.640762475297207*^9}, 
   3.640762527721299*^9, {3.6407815453097963`*^9, 3.6407815495550036`*^9}, {
   3.6407816611373997`*^9, 3.64078166683141*^9}, {3.641209488640376*^9, 
   3.64120949654959*^9}, {3.6412095577328978`*^9, 3.641209584954945*^9}, {
   3.6412096432054477`*^9, 3.6412096488370576`*^9}, 3.6445608700325193`*^9, {
   3.6445609155845995`*^9, 
   3.6445609232442126`*^9}},ExpressionUUID->"03007d06-20b4-4546-a9cb-\
0749aa0ea85c"],

Cell[BoxData[
 RowBox[{"?", "symform"}]], "Input",
 CellChangeTimes->{{3.6407805788948917`*^9, 3.640780596977324*^9}, {
   3.640780631550985*^9, 3.640780655824628*^9}, {3.640780695921698*^9, 
   3.6407807033785114`*^9}, {3.6407807433497815`*^9, 
   3.6407810445829144`*^9}, {3.640781080665777*^9, 3.6407812600664935`*^9}, 
   3.6407813189529977`*^9, {3.6407813519480553`*^9, 3.6407814341360006`*^9}, {
   3.6435071678786926`*^9, 3.6435071710766983`*^9}, {3.6445608251824403`*^9, 
   3.644560834292856*^9}},ExpressionUUID->"c98448e7-5014-4789-92a0-\
9c291ae96d22"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6406730823718095`*^9, 
  3.640673115693468*^9}},ExpressionUUID->"478e175f-fe26-46f3-aba6-\
0ab48f26860a"],

Cell[BoxData[
 RowBox[{"symform", "[", 
  RowBox[{"a", ",", "0", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, {3.641208850427655*^9, 3.641208861722075*^9}, 
   3.641209518140028*^9},ExpressionUUID->"70bdebce-18b2-431a-81b9-\
841aa0b2dc5c"],

Cell[BoxData[
 RowBox[{"symform", "[", 
  RowBox[{"a", ",", "1", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, {3.641208850427655*^9, 3.641208861722075*^9}, 
   3.641209518140028*^9, {3.6412096721122985`*^9, 
   3.6412096789607105`*^9}},ExpressionUUID->"afd8024d-41e0-4ee9-9360-\
e0137ba3dfa4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"symform", "[", 
   RowBox[{"a", ",", "2", ",", "4"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, {3.6407627146612287`*^9, 
   3.6407627345074635`*^9}},ExpressionUUID->"a62e4606-e45b-4558-987c-\
890134123b30"],

Cell[BoxData[
 RowBox[{"ta", "=", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"%", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407629452556353`*^9, 
  3.6407630181323633`*^9}},ExpressionUUID->"5f0156fb-6bad-41b5-9663-\
b7d097361863"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 
  3.6407630954082994`*^9}},ExpressionUUID->"be4069b5-6b01-4dad-8b02-\
fe089fd4b79d"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 
  3.6407631282035575`*^9}},ExpressionUUID->"b8d23fa6-fbac-496e-a8a2-\
85a843bc8209"],

Cell[BoxData[
 RowBox[{"symform", "[", 
  RowBox[{"a", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, {3.6407627146612287`*^9, 3.6407627345074635`*^9}, 
   3.6407632077494984`*^9, 3.640763506445831*^9, 
   3.641208917991374*^9},ExpressionUUID->"573d86d0-61da-467f-94fa-\
b908e99213ce"],

Cell[BoxData[
 RowBox[{"ta", "=", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"%", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407629452556353`*^9, 3.6407630181323633`*^9}, {
  3.640763238109152*^9, 
  3.6407632680018044`*^9}},ExpressionUUID->"d7e3dd4e-a98a-4709-b099-\
be360e47e479"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 3.6407630954082994`*^9}, {
   3.6407632919830465`*^9, 3.6407632936678495`*^9}, 
   3.641208968800663*^9},ExpressionUUID->"29419b35-8605-465c-b927-\
48b79d3c1363"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 3.6407631282035575`*^9}, {
   3.6407633092522774`*^9, 3.640763311358281*^9}, 
   3.641208986335094*^9},ExpressionUUID->"ff86539b-43de-4f05-b7c3-\
f4a2a0008642"],

Cell[BoxData[
 RowBox[{"?", "cosymtensor"}]], "Input",
 CellChangeTimes->{{3.6407639022733307`*^9, 3.6407640289761543`*^9}, {
   3.640764244019937*^9, 3.6407642452523394`*^9}, 3.640764305334045*^9, {
   3.6407821721925*^9, 3.6407821881045284`*^9}, {3.6412090804812593`*^9, 
   3.641209090418477*^9}, {3.6412098216385612`*^9, 3.6412098652250376`*^9}, {
   3.6412098960506916`*^9, 3.6412099894012556`*^9}, {3.6412100243297167`*^9, 
   3.641210090458233*^9}, {3.6412188060947847`*^9, 3.6412188491976604`*^9}, 
   3.641219193849066*^9, 3.6445621231877947`*^9, {3.644562204261137*^9, 
   3.644562207162742*^9}, {3.644562293524494*^9, 
   3.6445623047877135`*^9}},ExpressionUUID->"30b55294-4a1f-435e-be9c-\
1ebd4b4c0998"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"cosymtensor", "[", 
     RowBox[{"a_", ",", "p_", ",", 
      RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"p", "===", "0"}], ",", 
      RowBox[{"Return", "[", "a", "]"}], ",", 
      RowBox[{"ArrayTotensor", "[", 
       RowBox[{
        RowBox[{"symform", "[", 
         RowBox[{"a", ",", "p", ",", "d"}], "]"}], ",", "p"}], "]"}]}], 
     "]"}]}], ";"}], "\n"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6407798871650724`*^9, 3.6407800274111204`*^9}, {
   3.640780061949581*^9, 3.6407800871008253`*^9}, {3.6407801183808804`*^9, 
   3.6407801249972925`*^9}, 3.6407801740945787`*^9, {3.6407802238938665`*^9, 
   3.640780265026539*^9}, {3.6407803025798054`*^9, 3.6407803286796513`*^9}, 
   3.640780363908513*^9, 3.6445623653158197`*^9, {3.6445624144403067`*^9, 
   3.644562420524317*^9}},ExpressionUUID->"1b5f3a3f-b901-461a-9f19-\
18441b68a78a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6407822484972343`*^9, 
  3.6407822546622458`*^9}},ExpressionUUID->"ebbd56a7-8cf1-450f-9745-\
0d566a07d6df"],

Cell[BoxData[
 RowBox[{"cosymtensor", "[", 
  RowBox[{"a", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.641209346383726*^9, 
  3.641209353856139*^9}},ExpressionUUID->"1f52e565-1426-4918-b50f-\
4c8469801472"],

Cell[BoxData[
 RowBox[{"ta1", "=", 
  RowBox[{"cosymtensor", "[", 
   RowBox[{"a", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641209346383726*^9, 3.641209353856139*^9}, {
  3.6412097670384655`*^9, 3.6412097745264783`*^9}, {3.6435075777932158`*^9, 
  3.6435075938164434`*^9}},ExpressionUUID->"ef3532f7-d918-4fc8-9155-\
e552d7d8004f"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.641218912658572*^9, 
  3.64121893424901*^9}},ExpressionUUID->"3f2f9b5b-e51b-4a3f-9112-\
1f1688ce92d8"],

Cell[BoxData[
 RowBox[{"coords", "[", "ta1", "]"}]], "Input",
 CellChangeTimes->{{3.6412101285067*^9, 3.641210135121112*^9}, 
   3.6412190531680193`*^9, {3.6435076128192773`*^9, 
   3.643507613942479*^9}},ExpressionUUID->"38992e69-1daa-47cb-ad99-\
d474066801a5"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "ta1", "]"}]], "Input",
 CellChangeTimes->{{3.643507638844123*^9, 
  3.643507652899748*^9}},ExpressionUUID->"1204707f-190c-46eb-ab38-\
7adca10a3d3c"],

Cell[BoxData[
 RowBox[{"ArrayTotensor", "[", 
  RowBox[{"%", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.643507510749897*^9, 
  3.643507533810738*^9}},ExpressionUUID->"3d13d1b9-4f4c-4288-a263-\
bca13fa083fc"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", "ta1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6435076810207996`*^9, 
  3.643507690008415*^9}},ExpressionUUID->"3e93dfb8-653b-4698-b809-\
6c0e00ac1abb"],

Cell[BoxData[
 RowBox[{"ta2", " ", "=", " ", 
  RowBox[{"cosymtensor", "[", 
   RowBox[{"a", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407640692126255`*^9, 3.640764103724886*^9}, {
   3.640764254053755*^9, 3.6407642556137576`*^9}, 3.6407643153336625`*^9, 
   3.643507757628935*^9},ExpressionUUID->"501b5031-91ff-453c-8f64-\
5953710fab15"],

Cell[BoxData[
 RowBox[{"ta2", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6407822886703053`*^9, 3.640782306754737*^9}, 
   3.6435077874289875`*^9},ExpressionUUID->"4db542ec-a22b-41ca-a6f8-\
76b1a3d9354e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta2", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "+", 
  RowBox[{"ta2", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407822886703053`*^9, 3.640782306754737*^9}, {
  3.6411329446686516`*^9, 3.6411329577414746`*^9}, {3.6435078381330767`*^9, 
  3.643507843937287*^9}},ExpressionUUID->"f209c314-4fa2-4618-ad64-\
fdf90c64570d"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "ta2", "]"}]], "Input",
 CellChangeTimes->{{3.6407641178741107`*^9, 3.6407641296385317`*^9}, 
   3.6435078581041117`*^9},ExpressionUUID->"6f7c89f9-0652-45d5-94af-\
03b89cac7de0"],

Cell["\<\
The contravariant tensor with the same coordinates is obtained analogously:\
\>", "Text",
 CellChangeTimes->{{3.6407634084078574`*^9, 
  3.640763449984331*^9}},ExpressionUUID->"6caadd39-d2e0-42e2-a4d4-\
6cbed96d6603"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"contrasymtensor", "[", 
    RowBox[{"a_", ",", "p_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"p", "===", "0"}], ",", 
     RowBox[{"Return", "[", "a", "]"}], ",", 
     RowBox[{"ArrayTotensor", "[", 
      RowBox[{"symform", "[", 
       RowBox[{"a", ",", "p", ",", "d"}], "]"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6407639022733307`*^9, 3.6407640289761543`*^9}, {
   3.640764244019937*^9, 3.6407642452523394`*^9}, 3.640764305334045*^9, {
   3.6407644535357065`*^9, 3.6407644708069367`*^9}, {3.6407817035266747`*^9, 
   3.6407817446367474`*^9}, {3.640781804154852*^9, 3.6407818076960583`*^9}, {
   3.641210231607281*^9, 3.641210289108982*^9}, {3.6412192083726916`*^9, 
   3.641219216484706*^9}, 
   3.644562531456112*^9},ExpressionUUID->"96ef14a2-03ef-4ba6-a1ce-\
aad8d0a28aba"],

Cell[BoxData[
 RowBox[{"?", "contrasymtensor"}]], "Input",
 CellChangeTimes->{{3.6407798871650724`*^9, 3.6407800274111204`*^9}, {
   3.640780061949581*^9, 3.6407800871008253`*^9}, {3.6407801183808804`*^9, 
   3.6407801249972925`*^9}, 3.6407801740945787`*^9, {3.64456267283916*^9, 
   3.644562681559575*^9}},ExpressionUUID->"737a9412-54bb-486d-85a7-\
9ae1a35561c1"],

Cell[BoxData[
 RowBox[{"contrasymtensor", "[", 
  RowBox[{"a", ",", "1", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.64121032771905*^9, 
  3.6412103409790735`*^9}},ExpressionUUID->"95116fde-0c9d-498f-99a9-\
c6d786a5d1ad"],

Cell[BoxData[
 RowBox[{"coords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.641210348217486*^9, 
  3.641210354847498*^9}},ExpressionUUID->"69d9f92b-740c-49c4-b1dc-\
23d9a0d4cb5f"],

Cell[BoxData[
 RowBox[{"cta", " ", "=", " ", 
  RowBox[{"contrasymtensor", "[", 
   RowBox[{"a", ",", "5", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407644804321537`*^9, 
  3.640764543688467*^9}},ExpressionUUID->"fd323c0e-b459-4a35-90f8-\
e4d7ff36e0e7"],

Cell[BoxData[
 RowBox[{"cta", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6407645571200905`*^9, 
  3.6407645982145634`*^9}},ExpressionUUID->"17f28030-52d0-4a83-b4b9-\
24053a8c3a4e"],

Cell[BoxData[
 RowBox[{"cta", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "1", ",", "4", ",", "2"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6407645571200905`*^9, 
  3.6407646892497234`*^9}},ExpressionUUID->"f88f2766-f185-44bf-be3c-\
18a78f6b4504"],

Cell[BoxData[
 RowBox[{"contrasymtensor", "[", 
  RowBox[{"a", ",", "1", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{
  3.640781505888527*^9, 3.6407818447033234`*^9, {3.64078191099184*^9, 
   3.6407819191818542`*^9}, 
   3.6407819765365553`*^9},ExpressionUUID->"a0330af2-2d45-4ec1-8c71-\
bc53d22652fa"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6412192943600426`*^9, 
  3.6412193376189184`*^9}},ExpressionUUID->"67791ff9-a940-41d9-9191-\
81d0be53ff00"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2.2. Antisymmetric Tensors", "Subsubsection",
 CellChangeTimes->{{3.6411332307263536`*^9, 3.6411332623164096`*^9}, {
   3.6411333858062267`*^9, 3.6411334024670553`*^9}, {3.6411340998794765`*^9, 
   3.6411341017670794`*^9}, 
   3.6412694455191984`*^9},ExpressionUUID->"a08762bc-15d9-47c8-9517-\
867d554e9308"],

Cell["\<\
In this Subsection we construct functions creating antisymmetric covariant or \
contravariant tensors. We begin with the definition of antisymmetric Arrays \
appearing as coordinate Arrays of such tensors or of antisymmetric \
multilinear forms.\
\>", "Text",
 CellChangeTimes->{{3.6407824721270285`*^9, 3.6407826324291124`*^9}, 
   3.64078283436707*^9, {3.6411334122326727`*^9, 3.6411334133714747`*^9}, {
   3.641266953836022*^9, 
   3.641266974318858*^9}},ExpressionUUID->"7d4932aa-0c79-4061-a3d5-\
98eab2270ab6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"altform", "[", 
    RowBox[{"a_", ",", "p_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rr", ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{"IntegerQ", "[", "p", "]"}], "]"}], "||", 
         RowBox[{"p", "<", "0"}]}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<Wrong p = \>\"", ",", "p"}], "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"p", "\[Equal]", " ", "0"}], ",", " ", 
        RowBox[{"Return", "[", "a", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"rr", "=", 
       RowBox[{"SymmetrizedArray", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "i__", "}"}], "\[Rule]", 
          RowBox[{"a", "[", "i", "]"}]}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", "p", "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Antisymmetric", "[", 
           RowBox[{"Range", "[", "p", "]"}], "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Normal", "[", "rr", "]"}]}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.640672595151754*^9, 3.640672763070449*^9}, {
   3.6406728179513454`*^9, 3.640672903689096*^9}, {3.640672949989977*^9, 
   3.6406729518775806`*^9}, {3.640673010174883*^9, 3.6406730265861115`*^9}, 
   3.6406730697513876`*^9, {3.640762473331603*^9, 3.640762475297207*^9}, 
   3.640762527721299*^9, {3.6407815453097963`*^9, 3.6407815495550036`*^9}, {
   3.6407816611373997`*^9, 3.64078166683141*^9}, {3.641192091979355*^9, 
   3.6411920926969557`*^9}, {3.6411921711806936`*^9, 
   3.6411921779511056`*^9}, {3.641192216264773*^9, 3.6411922216935825`*^9}, {
   3.641192478332033*^9, 3.6411924809372377`*^9}, {3.6411932834338474`*^9, 
   3.6411933638051887`*^9}, {3.644562880553525*^9, 3.644562888462739*^9}, 
   3.644562960316465*^9},ExpressionUUID->"a9dd981c-78ba-47f2-8022-\
cbfd6d454c36"],

Cell[BoxData[
 RowBox[{"?", "altform"}]], "Input",
 CellChangeTimes->{{3.6407805788948917`*^9, 3.640780596977324*^9}, {
   3.640780631550985*^9, 3.640780655824628*^9}, {3.640780695921698*^9, 
   3.6407807033785114`*^9}, {3.6407807433497815`*^9, 
   3.6407810445829144`*^9}, {3.640781080665777*^9, 3.6407812600664935`*^9}, 
   3.6407813189529977`*^9, {3.6407813519480553`*^9, 3.6407814341360006`*^9}, {
   3.641192258494047*^9, 3.641192259788849*^9}, {3.6411923000213203`*^9, 
   3.6411923743086505`*^9}, {3.6412670333337617`*^9, 
   3.6412670349561644`*^9}, {3.6435082020059185`*^9, 
   3.6435082044395227`*^9}, {3.6445628489478693`*^9, 
   3.6445628559366817`*^9}},ExpressionUUID->"3978c760-d8b6-477d-82bd-\
0299a4d41473"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6406730823718095`*^9, 
  3.640673115693468*^9}},ExpressionUUID->"6eed7f86-c570-41a7-abd6-\
d9280128d2a2"],

Cell[BoxData[
 RowBox[{"altform", "[", 
  RowBox[{"a", ",", "0", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, 3.641192426599942*^9, 
   3.6412670691202245`*^9},ExpressionUUID->"7e7137ef-cb44-4b7b-bf6d-\
b77842958dce"],

Cell[BoxData[
 RowBox[{"altform", "[", 
  RowBox[{"a", ",", "1", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, 3.641192426599942*^9, {3.6412670691202245`*^9, 
   3.6412670868574553`*^9}},ExpressionUUID->"a8d2ac2a-1965-425e-97e7-\
3107008ce4e6"],

Cell["Clearly. antisymmetric forms with p>d are null forms:", "Text",
 CellChangeTimes->{{3.6412672260565*^9, 
  3.6412672658989697`*^9}},ExpressionUUID->"c7a48107-e689-4742-9268-\
09bbc4f7e21c"],

Cell[BoxData[
 RowBox[{"altform", "[", 
  RowBox[{"a", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, 3.641192426599942*^9, {3.6412670691202245`*^9, 
   3.6412670868574553`*^9}, {3.641267139086347*^9, 3.641267182906824*^9}, 
   3.6435083624732018`*^9},ExpressionUUID->"30b0fb9b-755a-4b32-8367-\
82aa83b1575c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"altform", "[", 
   RowBox[{"a", ",", "2", ",", "4"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6407626023920307`*^9, 3.640762628617677*^9}, 
   3.640762661475335*^9, {3.6407627146612287`*^9, 3.6407627345074635`*^9}, 
   3.6411924276295443`*^9},ExpressionUUID->"9b5e4300-9a46-4f96-b768-\
5198b12b24e5"],

Cell[BoxData[
 RowBox[{"ta", "=", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"%", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407629452556353`*^9, 
  3.6407630181323633`*^9}},ExpressionUUID->"ea850511-a350-41d3-9151-\
07998bbf350f"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 
  3.6407630954082994`*^9}},ExpressionUUID->"675b37e0-16e6-4e1e-80af-\
532d21939f05"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64076303293779*^9, 
  3.6407631282035575`*^9}},ExpressionUUID->"ce071b5a-79a8-4a48-8134-\
8559af9b98fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"coalttensor", "[", 
    RowBox[{"a_", ",", "p_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"p", "\[Equal]", " ", "0"}], ",", 
     RowBox[{"Return", "[", 
      RowBox[{"tensor", "[", 
       RowBox[{"a", ",", "0", ",", "0", ",", "d"}], "]"}], "]"}], ",", " ", 
     RowBox[{"ArrayTotensor", "[", 
      RowBox[{
       RowBox[{"altform", "[", 
        RowBox[{"a", ",", "p", ",", "d"}], "]"}], ",", "p"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6407639022733307`*^9, 3.6407640289761543`*^9}, {
   3.640764244019937*^9, 3.6407642452523394`*^9}, 3.640764305334045*^9, {
   3.6407821721925*^9, 3.6407821881045284`*^9}, 3.6411924340723553`*^9, {
   3.6411926810543895`*^9, 3.641192682520792*^9}, {3.641193442663327*^9, 
   3.6411935158898554`*^9}, {3.6412675502406693`*^9, 3.641267589162738*^9}, {
   3.6412678412903805`*^9, 3.641267862272417*^9}, 3.641267901756087*^9, {
   3.6412679782274213`*^9, 3.6412679944670496`*^9}, {3.641268050939149*^9, 
   3.641268065447174*^9}, 3.641268403640168*^9, 
   3.6445630237461767`*^9},ExpressionUUID->"8091c5b1-2620-410a-9bb2-\
6125a4df97ae"],

Cell[BoxData[
 RowBox[{"?", "coalttensor"}]], "Input",
 CellChangeTimes->{{3.6407798871650724`*^9, 3.6407800274111204`*^9}, {
   3.640780061949581*^9, 3.6407800871008253`*^9}, {3.6407801183808804`*^9, 
   3.6407801249972925`*^9}, 3.6407801740945787`*^9, {3.6407802238938665`*^9, 
   3.640780265026539*^9}, {3.6407803025798054`*^9, 3.6407803286796513`*^9}, 
   3.640780363908513*^9, {3.641192717730054*^9, 3.641192746449704*^9}, {
   3.6445633707843857`*^9, 
   3.6445633735611906`*^9}},ExpressionUUID->"a82cdc78-770a-40f5-a6d7-\
c2c80e6bfd7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6407822484972343`*^9, 
  3.6407822546622458`*^9}},ExpressionUUID->"949b018c-9327-4d52-85af-\
9062f9e7bddf"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", " ", 
  RowBox[{"coalttensor", "[", 
   RowBox[{"a", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407640692126255`*^9, 3.640764103724886*^9}, {
   3.640764254053755*^9, 3.6407642556137576`*^9}, 3.6407643153336625`*^9, {
   3.641192794014188*^9, 
   3.6411927950281897`*^9}},ExpressionUUID->"94428e84-bca4-4944-852a-\
32bccafc1b30"],

Cell[BoxData[
 RowBox[{"ta", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6407822886703053`*^9, 
  3.640782306754737*^9}},ExpressionUUID->"ecada9ee-354a-4387-b955-\
76bce5bb5e24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "+", 
  RowBox[{"ta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407822886703053`*^9, 3.640782306754737*^9}, {
  3.6411329446686516`*^9, 
  3.6411329577414746`*^9}},ExpressionUUID->"ab2ee3ea-d940-4e70-9edf-\
e5ef18bd249a"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.6407641178741107`*^9, 
  3.6407641296385317`*^9}},ExpressionUUID->"a077362f-394a-4282-84c4-\
c7b504bf902a"],

Cell[BoxData[
 RowBox[{"coalttensor", "[", 
  RowBox[{"a", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407640692126255`*^9, 3.640764103724886*^9}, {
   3.640764254053755*^9, 3.6407642556137576`*^9}, 3.6407643153336625`*^9, {
   3.641192794014188*^9, 3.6411927950281897`*^9}, {3.6411932285841513`*^9, 
   3.641193238895769*^9}},ExpressionUUID->"713d4626-0285-4306-9950-\
189465d00ac3"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6412674813509483`*^9, 3.641267488698561*^9}, {
  3.6435084930760317`*^9, 
  3.6435085000200443`*^9}},ExpressionUUID->"0d389861-ea47-452f-be2c-\
0c7347ed87f7"],

Cell[BoxData[
 RowBox[{"coalttensor", "[", 
  RowBox[{"a", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.6407640692126255`*^9, 3.640764103724886*^9}, {
   3.640764254053755*^9, 3.6407642556137576`*^9}, 3.6407643153336625`*^9, {
   3.641192794014188*^9, 3.6411927950281897`*^9}, {3.6411932285841513`*^9, 
   3.641193238895769*^9}, 
   3.641267695586125*^9},ExpressionUUID->"08084dd3-f57c-4939-8128-\
e54d848d0e2a"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6412677212169695`*^9, 
  3.6412677433378086`*^9}},ExpressionUUID->"be0cd762-8eab-487d-8884-\
234612b38c04"],

Cell["\<\
A contravariant antisymmetric tensor is generated analogously :\
\>", "Text",
 CellChangeTimes->{{3.6407643386139035`*^9, 3.6407644108032312`*^9}, {
  3.641192832437055*^9, 
  3.641192834012658*^9}},ExpressionUUID->"0d51c01f-a8ab-4c41-acc1-\
9aeede16adc5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contraalttensor", "[", 
   RowBox[{"a_", ",", "p_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"p", "\[Equal]", " ", "0"}], ",", 
    RowBox[{"Return", "[", 
     RowBox[{"tensor", "[", 
      RowBox[{"a", ",", "0", ",", "0", ",", "d"}], "]"}], "]"}], ",", 
    RowBox[{"ArrayTotensor", "[", 
     RowBox[{"altform", "[", 
      RowBox[{"a", ",", "p", ",", "d"}], "]"}], "]"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6407639022733307`*^9, 3.6407640289761543`*^9}, {
   3.640764244019937*^9, 3.6407642452523394`*^9}, 3.640764305334045*^9, {
   3.6407644535357065`*^9, 3.6407644708069367`*^9}, {3.6407817035266747`*^9, 
   3.6407817446367474`*^9}, {3.640781804154852*^9, 3.6407818076960583`*^9}, 
   3.6411924351331573`*^9, {3.6411928447922773`*^9, 3.6411928456814785`*^9}, {
   3.6411937050713882`*^9, 3.6411937383930464`*^9}, {3.6412683385568542`*^9, 
   3.6412683531428795`*^9}},ExpressionUUID->"363e49ad-02f1-43d4-a126-\
0c1fb4c5ec5e"],

Cell[BoxData[
 RowBox[{"?", "contraalttensor"}]], "Input",
 CellChangeTimes->{{3.6407798871650724`*^9, 3.6407800274111204`*^9}, {
   3.640780061949581*^9, 3.6407800871008253`*^9}, {3.6407801183808804`*^9, 
   3.6407801249972925`*^9}, 3.6407801740945787`*^9, {3.6411928747131295`*^9, 
   3.6411928866159506`*^9}, {3.6445632879794407`*^9, 
   3.644563291661047*^9}},ExpressionUUID->"f56e28a5-91ed-4336-a801-\
7855777150f0"],

Cell["Test the next cells for p = 0,1,2,3,4:", "Text",
 CellChangeTimes->{{3.6412689191430736`*^9, 3.641268942433915*^9}, 
   3.641269428920769*^9},ExpressionUUID->"aceb643d-e97c-4b9f-ad77-\
8347f50c7495"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "4"}], ";", 
  RowBox[{"cta", " ", "=", 
   RowBox[{"contraalttensor", "[", 
    RowBox[{"a", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.640781505888527*^9, 3.6407818447033234`*^9, {3.64078191099184*^9, 
   3.6407819191818542`*^9}, 3.6407819765365553`*^9, {3.641193041649023*^9, 
   3.6411930425538244`*^9}, {3.6412686079225273`*^9, 3.641268611838134*^9}, {
   3.641268645534193*^9, 3.641268647718197*^9}, 3.64126870053989*^9, 
   3.641268763688801*^9, 3.64126881451369*^9, 3.64126886006577*^9, {
   3.6413662048379345`*^9, 
   3.6413662089563417`*^9}},ExpressionUUID->"12f78c41-c88e-420f-a23c-\
7a2c98f2cc50"],

Cell[BoxData[
 RowBox[{"cta", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6412686588722167`*^9, 3.6412686712586384`*^9}, {
  3.6412687835476356`*^9, 3.641268799802864*^9}, {3.641268836338128*^9, 
  3.6412688374925303`*^9}, {3.6412688723117914`*^9, 
  3.641268873700194*^9}},ExpressionUUID->"90c112a0-2322-4778-aba7-\
85715b28d3d1"],

Cell["\<\
For an antisymmetric covariant or contravariant tensor of degree p all its \
coordinates are known if the coordinates a[I] for the subsets I \[Element] \
Subsets[ Range[d:dim, {p}]  of  p elements are known:\
\>", "Text",
 CellChangeTimes->{{3.6417972028881674`*^9, 3.6417975633416076`*^9}, {
  3.6417976035508785`*^9, 3.6417976426369476`*^9}, {3.641798316589939*^9, 
  3.6417983180563416`*^9}},ExpressionUUID->"91aa148a-cb1b-4fe3-a9e4-\
eda671914070"],

Cell[BoxData[
 RowBox[{"?", "Subsets"}]], "Input",
 CellChangeTimes->{{3.641797566775614*^9, 
  3.641797572017223*^9}},ExpressionUUID->"1febedd8-0aec-4bbf-bcbc-\
cd76f49cee34"],

Cell[TextData[{
 StyleBox["Lemma",
  FontColor->RGBColor[0, 0, 1]],
 ". A covariant (or contravariant) tensor ta of degree p is antisymmetric if  \
its coordinates a[j1,...,jp] satisfy\n1. In case j1,...,jp contains two equal \
numbers, a[j1,...,jp] = 0;\n2.  For any permutation {j1, ..., jp} of I = \
{i1,...,ip} with i1<i2<...<ip is"
}], "Text",
 CellChangeTimes->{{3.641797811786846*^9, 3.641797938883072*^9}, {
   3.6442923812019176`*^9, 3.6442924335244102`*^9}, {3.6442949845344906`*^9, 
   3.6442950044401255`*^9}, {3.6442951432647696`*^9, 
   3.6442951463847747`*^9}, {3.6442951804708347`*^9, 
   3.6442951941208587`*^9}, {3.6442952577533703`*^9, 
   3.6442952835558157`*^9}, {3.644295317563875*^9, 3.644295357827546*^9}, {
   3.644383447070685*^9, 3.6443834864511547`*^9}, {3.644383523224419*^9, 
   3.6443835303400316`*^9}, {3.6443835605456853`*^9, 3.644383561044886*^9}, 
   3.644587747679716*^9},ExpressionUUID->"9be851e1-d9ae-4cc6-95a3-\
8c6f7cad348c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"j1", ",", "...", ",", "jp"}], "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"Signature", "[", 
    RowBox[{"j1", 
     StyleBox[",",
      FontColor->RGBColor[0, 0, 1]], 
     StyleBox["...",
      FontColor->RGBColor[0, 0, 1]], 
     StyleBox[",",
      FontColor->RGBColor[0, 0, 1]], 
     StyleBox["jp",
      FontColor->RGBColor[0, 0, 1]]}], "]"}], "*", 
   RowBox[{"a", "[", 
    RowBox[{"i1", ",", "...", ",", "ip"}], "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6417979544110994`*^9, 3.6417980173858104`*^9}, {
  3.641798059449485*^9, 
  3.6417981417470303`*^9}},ExpressionUUID->"87067221-9da9-42b7-9dd4-\
58826f58547a"],

Cell[TextData[{
 "\[FilledSmallSquare] \nThe coordinates corresponding to the mentioned \
subsets are named the ",
 StyleBox["strict coordinates",
  FontColor->RGBColor[0, 0, 1]],
 " of the antisymmetric tensors. They are given by the function"
}], "Text",
 CellChangeTimes->{{3.641798207263546*^9, 3.641798227452982*^9}, {
  3.641798266523451*^9, 3.6417982907698936`*^9}, {3.6417983523396025`*^9, 
  3.641798391891672*^9}, {3.644295396936815*^9, 3.6442954097600374`*^9}, {
  3.6442954576365213`*^9, 3.6442954720509467`*^9}, {3.64438358597773*^9, 
  3.6443835862741303`*^9}},ExpressionUUID->"e11e7ed1-7185-471b-aadb-\
6d96668f82ba"],

Cell[BoxData[
 RowBox[{"?", "strictcoords"}]], "Input",
 CellChangeTimes->{{3.6417984035000925`*^9, 
  3.6417984100521045`*^9}},ExpressionUUID->"3e3cde9a-84c9-44e4-90c5-\
35417e28de03"],

Cell["In our example:", "Text",
 CellChangeTimes->{{3.6417984745692186`*^9, 
  3.6417984871302404`*^9}},ExpressionUUID->"4c0a040d-d772-4472-89be-\
31ec79e0b0db"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "cta", "]"}]], "Input",
 CellChangeTimes->{{3.6407818617853537`*^9, 3.6407818693825665`*^9}, {
  3.6411930584658527`*^9, 3.6411930601974554`*^9}, {3.6412687175439196`*^9, 
  3.6412687184799213`*^9}},ExpressionUUID->"43cfa284-3986-4ab5-ae6d-\
99288174cabd"],

Cell[BoxData[
 RowBox[{"cta", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6442956378872385`*^9, 
  3.6442957100061646`*^9}},ExpressionUUID->"250bf3a4-4e9f-4039-b7ae-\
ea0df35e6c1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cta", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "4", ",", "3"}], "}"}]}], "]"}], " ", "\[Equal]", " ", 
  
  RowBox[{"-", " ", 
   RowBox[{"cta", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], "]"}], " "}]}]], "Input",
 CellChangeTimes->{{3.6442956378872385`*^9, 3.644295742844222*^9}, {
  3.644295789769105*^9, 
  3.6442958202203584`*^9}},ExpressionUUID->"59272e19-5fdb-4343-a344-\
d60b7f9c49e2"],

Cell["For p>d we obtain a nulltensor:", "Text",
 CellChangeTimes->{{3.6412685644608507`*^9, 
  3.6412685932741013`*^9}},ExpressionUUID->"fb632cb2-6374-4712-af53-\
175f940abc48"],

Cell[BoxData[
 RowBox[{"cta", " ", "=", " ", 
  RowBox[{"contraalttensor", "[", 
   RowBox[{"a", ",", "5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6407644804321537`*^9, 3.640764543688467*^9}, {
   3.6411929032923794`*^9, 3.641192903916381*^9}, {3.641268957269541*^9, 
   3.6412689657403555`*^9}, 3.6417985390697317`*^9, {3.644295745168627*^9, 
   3.6442957483042316`*^9}, 
   3.644295782421492*^9},ExpressionUUID->"df9b65a3-2eed-4e49-a558-\
76a0c77eb041"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"cta", ",", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"0", ",", "5", ",", "4"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6411929616052823`*^9, 3.6411930109325686`*^9}, {
  3.6412689787039785`*^9, 3.641268981309183*^9}, {3.641798557031364*^9, 
  3.641798561492972*^9}},ExpressionUUID->"6e46cfd1-8475-4daa-b26c-\
4e5ba6f36f45"],

Cell["\<\
The function strictcoords will be evaluated for antisymmetric tensors only:\
\>", "Text",
 CellChangeTimes->{{3.6417986044478474`*^9, 3.641798695755609*^9}, 
   3.643510056427988*^9},ExpressionUUID->"3b984ee0-980a-4b8c-8710-\
7eb920d6bf1b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "5"}], ";", " ", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "3", ",", "0"}], "]"}]}], ";", " ", 
  RowBox[{"strictcoords", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.6417987514431076`*^9, 
  3.641798806084404*^9}},ExpressionUUID->"802e0796-7779-4cd0-9644-\
ad02181d497e"],

Cell[BoxData[
 RowBox[{"cta", " ", "=", " ", 
  RowBox[{"coalttensor", "[", 
   RowBox[{"a", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64179883791346*^9, 3.641798848414279*^9}, {
  3.6435103362932816`*^9, 
  3.6435103993721933`*^9}},ExpressionUUID->"aba3e3ad-ef17-42d4-a77a-\
a004f035b5ac"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "cta", "]"}]], "Input",
 CellChangeTimes->{{3.641798862768304*^9, 
  3.6417988757827272`*^9}},ExpressionUUID->"2f491129-e726-470b-9047-\
382df15b3699"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tensorToArray", "[", "cta", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6435104381164627`*^9, 3.643510450536084*^9}, {
  3.6435104992921705`*^9, 
  3.6435105058129816`*^9}},ExpressionUUID->"adbc525f-eddf-4582-8d22-\
d78ee3eccbdb"],

Cell["strictcoords evaluates for antisymmetric Arrays too:", "Text",
 CellChangeTimes->{{3.6469164880270944`*^9, 
  3.6469165215515532`*^9}},ExpressionUUID->"b2a3a5dc-51cd-4207-8a3a-\
3f1708716904"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{
  3.646916462131049*^9},ExpressionUUID->"6e3252d3-380d-4e6f-b549-\
1ab96e8e06d3"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", 
  RowBox[{"vec", "[", "a", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6417989123551917`*^9, 
  3.641798923402011*^9}},ExpressionUUID->"3ff5f20f-971e-4c69-952b-\
30e7ebe2c286"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", 
  RowBox[{"covecTotensor", "[", 
   RowBox[{"vec", "[", "a", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6417989123551917`*^9, 3.641798923402011*^9}, {
  3.641798953750065*^9, 
  3.6417989788857093`*^9}},ExpressionUUID->"64e42b7d-4e4d-4d97-86ca-\
71a8e1fb6026"],

Cell[TextData[{
 "Now we will construct a standard basis in the space of covariant \
antisymmetric tensors ta of degree p using the properties of the coordinates, \
see the Lemma above.  We start with the basis representation in the tensor \
space, see ",
 ButtonBox["3.2.3",
  BaseStyle->"Hyperlink",
  ButtonData->"bpr"],
 ", in general traditional notation"
}], "Text",
 CellChangeTimes->{{3.6442967347407646`*^9, 3.6442970404233017`*^9}, {
   3.644297078159768*^9, 3.6442970798757706`*^9}, {3.644300249909341*^9, 
   3.644300299111827*^9}, {3.6443003899507866`*^9, 3.6443004321500607`*^9}, 
   3.6443024512616067`*^9, {3.6443838208957453`*^9, 
   3.6443838251389523`*^9}},ExpressionUUID->"3314d0ce-7d2b-4d59-bb63-\
74b653be8b4d"],

Cell[BoxData[
 RowBox[{"ta", " ", "\[Equal]", " ", 
  RowBox[{
   SubscriptBox["a", 
    SubscriptBox["i", 
     RowBox[{
      RowBox[{"1", "..."}], 
      SubscriptBox["i", "p"]}]]], 
   SuperscriptBox["tstb", 
    SubscriptBox["i", 
     RowBox[{
      RowBox[{"1", "..."}], 
      SubscriptBox["i", "p"]}]]], "  ", "with", " ", 
   SuperscriptBox["tstb", 
    SubscriptBox["i", 
     RowBox[{
      RowBox[{"1", "..."}], 
      SubscriptBox["i", "p"]}]]]}], " ", "\[DotEqual]", " ", 
  RowBox[{"tstb", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["i", "1"], ",", "..", ",", 
      SubscriptBox["i", "p"]}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6443004403400745`*^9, 3.644300542957055*^9}, {
  3.644300578025917*^9, 3.644300615731183*^9}, {3.6443006512212453`*^9, 
  3.644300744525009*^9}, {3.6443023179749727`*^9, 3.6443024357083797`*^9}, {
  3.6443037097938175`*^9, 
  3.6443037980743723`*^9}},ExpressionUUID->"34b7c0ed-7922-4c5a-9760-\
239a4f829a81"],

Cell["\<\
the standard tensor basis; remember the sum convention. Applying the Lemma we \
may write this sum as follows:\
\>", "Text",
 CellChangeTimes->{{3.6443025017900953`*^9, 3.6443025313677473`*^9}, {
  3.644302756008142*^9, 
  3.644302795507412*^9}},ExpressionUUID->"92e9beef-fa50-47ce-973d-\
4843efb3eef3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", " ", "\[Equal]", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["\[CapitalSigma]",
      FontSize->18], 
     SubscriptBox["i", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "<"}], ".."}], "<", 
       SubscriptBox["i", "p"]}]]], 
    SubscriptBox["a", 
     SubscriptBox["i", 
      RowBox[{
       RowBox[{"1", "..."}], 
       SubscriptBox["i", "p"]}]]], 
    SubscriptBox[
     StyleBox["\[CapitalSigma]",
      FontSize->18], 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["j", "1"], ",", "..", ",", 
        SubscriptBox["j", "p"]}], "}"}], "\[Element]", " ", 
      RowBox[{"Perm", "[", 
       RowBox[{"{", 
        SubscriptBox["i", 
         RowBox[{"1", ",", "..", ",", 
          SubscriptBox["i", "p"]}]], "}"}], "]"}]}]], 
    RowBox[{"Signature", "[", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["j", "1"], ",", "..", ",", 
       SubscriptBox["j", "p"]}], "}"}], "]"}], "*", 
    RowBox[{"tstb", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["j", "1"], ",", "..", ",", 
        SubscriptBox["j", "p"]}], "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}]}], ","}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6443028095942364`*^9, 3.644302813915444*^9}, 
   3.6443028979059916`*^9, 3.6443030210682077`*^9, {3.644303062969881*^9, 
   3.6443031323432035`*^9}, {3.64430318163929*^9, 3.644303197208117*^9}, {
   3.644303230264575*^9, 3.6443034142980986`*^9}, {3.644303445357753*^9, 
   3.644303503062254*^9}, {3.6443035567575483`*^9, 3.644303559362753*^9}, {
   3.644303638439292*^9, 3.644303671932551*^9}, {3.6443038257488213`*^9, 
   3.6443038568240757`*^9}, {3.64430393320181*^9, 3.6443039410174236`*^9}, {
   3.6443039873339047`*^9, 3.6443040468792095`*^9}, 3.6443040890616837`*^9, {
   3.644304123132143*^9, 3.644304164441016*^9}, {3.6443054372472515`*^9, 
   3.6443054408508577`*^9}},ExpressionUUID->"46f8c071-4bdf-4baa-b8cb-\
49076ffc5a03"],

Cell[TextData[{
 "where the first sum runs over all elements of Subsets[Range[dim],{p}] and \
the second sum over all permutations of the subset ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["i", "1"], ",", "..", ",", 
    SubscriptBox["i", "p"]}], "}"}]],
  Evaluatable->False,
  CellChangeTimes->{{3.6443028095942364`*^9, 3.644302813915444*^9}, 
    3.6443028979059916`*^9, 3.6443030210682077`*^9, {3.644303062969881*^9, 
    3.6443031323432035`*^9}, {3.64430318163929*^9, 3.644303197208117*^9}, {
    3.644303230264575*^9, 3.6443034142980986`*^9}, {3.644303445357753*^9, 
    3.644303503062254*^9}, {3.6443035567575483`*^9, 3.644303559362753*^9}, {
    3.644303638439292*^9, 3.644303671932551*^9}, {3.6443038257488213`*^9, 
    3.6443038568240757`*^9}, {3.64430393320181*^9, 3.6443039410174236`*^9}, {
    3.6443039873339047`*^9, 3.6443040468792095`*^9}, 3.6443040890616837`*^9, {
    3.644304123132143*^9, 3.644304164441016*^9}},
  FontWeight->"Bold",ExpressionUUID->"8bd38ce0-2748-491b-8b29-21ef7a7986df"],
 ". The coefficients"
}], "Text",
 CellChangeTimes->{{3.6443042030822835`*^9, 3.6443042080898924`*^9}, {
   3.6443043303629074`*^9, 3.644304352889347*^9}, {3.644304416662259*^9, 
   3.6443044864255815`*^9}, {3.6443048855678825`*^9, 3.64430499222527*^9}, {
   3.6443050228637238`*^9, 3.644305030211336*^9}, {3.644305183216405*^9, 
   3.644305183216405*^9}, 
   3.6443838723662357`*^9},ExpressionUUID->"0caacf6f-8cef-4975-b211-\
b2066366fdac"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["a", 
   SubscriptBox["i", 
    RowBox[{
     RowBox[{"1", "..."}], 
     SubscriptBox["i", "p"]}]]], " ", "\[DotEqual]", " ", 
  RowBox[{"ta", "[", " ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["i", "1"], ",", "..", ",", 
      SubscriptBox["i", "p"]}], "}"}], ",", " ", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.644305055998182*^9, 3.6443051561347575`*^9}, {
  3.644305198754032*^9, 
  3.6443052236984763`*^9}},ExpressionUUID->"64893adf-5a62-4b7e-a16d-\
6ead98ab32cc"],

Cell[TextData[{
 "are the strict coordinates of the antisymmetric tensor. The second sum \
doesn\[CloseCurlyQuote]t depend on the tensor, it defines ",
 StyleBox[" the basis element of the standard basis in the space of p-forms",
  FontColor->RGBColor[0, 0, 1]],
 " corresponding to the subset ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["i", "1"], ",", "..", ",", 
     SubscriptBox["i", "p"]}], "}"}],
   FontWeight->"Bold"]],
  Evaluatable->False,
  CellChangeTimes->{{3.6443004403400745`*^9, 3.644300542957055*^9}, {
   3.644300578025917*^9, 3.644300615731183*^9}, {3.6443006512212453`*^9, 
   3.644300744525009*^9}, {3.6443023179749727`*^9, 3.6443024357083797`*^9}, {
   3.6443037097938175`*^9, 3.6443037980743723`*^9}},ExpressionUUID->
  "b6009d8a-b157-43ef-bc02-7de67d8d81bd"],
 ". We gave a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " construct for this element in tensalgv2.m:"
}], "Text",
 CellChangeTimes->{{3.644305248892521*^9, 3.6443052915273952`*^9}, {
   3.644305466715703*^9, 3.644305665865653*^9}, {3.644305712291334*^9, 
   3.6443057536158075`*^9}, 3.6443839236359262`*^9, {3.6443839992416596`*^9, 
   3.6443840201184964`*^9}, {3.64446762680863*^9, 3.644467650754672*^9}, 
   3.6445878915743694`*^9},ExpressionUUID->"002e33a3-d283-47be-9310-\
6463ec06a8f8"],

Cell[BoxData[
 RowBox[{"?", "wtstb"}]], "Input",
 CellChangeTimes->{{3.644467678351121*^9, 
  3.6444676820327272`*^9}},ExpressionUUID->"0a4095c5-8fd3-4328-9925-\
b76aad5c03bb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"wtstb", "[", 
   RowBox[{"i_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", "pp", ",", "ppi", ",", "j"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "i", "]"}], "===", "List"}], ",", 
       RowBox[{"p", " ", "=", " ", 
        RowBox[{"Length", "[", "i", "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"p", "\[Equal]", "1"}], ",", " ", 
       RowBox[{"Return", "[", 
        RowBox[{"tstb", "[", 
         RowBox[{"i", ",", 
          RowBox[{"{", "}"}], ",", "d"}], "]"}], "]"}]}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"p", "<=", "d"}], ")"}], ",", 
       RowBox[{"pp", " ", "=", " ", 
        RowBox[{"Subsets", "[", 
         RowBox[{
          RowBox[{"Range", "[", "d", "]"}], ",", 
          RowBox[{"{", "p", "}"}]}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"pp", ",", "i"}], "]"}], ",", 
       RowBox[{"ppi", " ", "=", 
        RowBox[{"Permutations", "[", 
         RowBox[{"Range", "[", "p", "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Signature", "[", 
         RowBox[{"ppi", "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}], "*", 
        RowBox[{"tstb", "[", 
         RowBox[{
          RowBox[{"Permute", "[", 
           RowBox[{"i", ",", 
            RowBox[{"ppi", "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"p", "!"}]}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6443057793246527`*^9, 3.644305799027487*^9}, {
   3.6443058339871483`*^9, 3.644305877963626*^9}, {3.6443066788222322`*^9, 
   3.6443067934824333`*^9}, {3.644306826928892*^9, 3.644306948250305*^9}, {
   3.64430697930996*^9, 3.6443070367960606`*^9}, 3.6443099345417833`*^9, {
   3.6443108264124594`*^9, 3.6443108350548744`*^9}, {3.6443108972209835`*^9, 
   3.6443111974747114`*^9}, {3.644311286847268*^9, 3.644311318608924*^9}, 
   3.6443113614309993`*^9, 3.644311400072267*^9, {3.6443114362175303`*^9, 
   3.6443114449535456`*^9}, {3.6443259893944516`*^9, 
   3.6443260325597277`*^9}, {3.6443260759590034`*^9, 
   3.6443261340067053`*^9}, {3.644326241475294*^9, 3.644326250024109*^9}, {
   3.6443263854479475`*^9, 3.6443264664900894`*^9}, 3.6443264987353463`*^9, 
   3.644326582367093*^9, 3.64432661465915*^9, {3.644327537541171*^9, 
   3.644327549241191*^9}, {3.6443275798016453`*^9, 3.644327605978491*^9}, {
   3.644327669611003*^9, 3.6443276812798233`*^9}, {3.644327715459483*^9, 
   3.644327767719575*^9}, {3.6443278626145415`*^9, 3.6443279683203273`*^9}, {
   3.6443281835383053`*^9, 3.6443281940839243`*^9}, {3.644328244721613*^9, 
   3.644328246952417*^9}, {3.644328324000952*^9, 3.6443283580246115`*^9}, 
   3.644328435494348*^9, {3.6443284978320575`*^9, 3.6443285157408886`*^9}, {
   3.6443287000864124`*^9, 3.6443287443280907`*^9}, {3.644328776089746*^9, 
   3.644328811189808*^9}, {3.6443289287252145`*^9, 3.6443289339668236`*^9}, {
   3.6443289663368807`*^9, 3.644329061387848*^9}, {3.644329091729901*^9, 
   3.644329362593177*^9}, {3.644329448237327*^9, 3.644329461887351*^9}, 
   3.6443294923230047`*^9, 3.644329540402289*^9, {3.644329670381717*^9, 
   3.6443296768089285`*^9}, {3.644329903524127*^9, 3.644329924178563*^9}, 
   3.644405861328345*^9},ExpressionUUID->"f826dc92-7892-4ec4-87fd-\
05bf2183c697"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "5"}], ";", 
  RowBox[{"wtstb", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "5"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64431147011639*^9, 3.6443114931420307`*^9}, {
  3.644325678298705*^9, 3.6443256834467144`*^9}, {3.644327412834552*^9, 
  3.6443274211649666`*^9}},ExpressionUUID->"8941cf9f-c8bd-40c9-bed4-\
dbfed0efb4d2"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6443115272280903`*^9, 3.6443115651829567`*^9}, 
   3.644325705442753*^9, {3.644329757929071*^9, 
   3.6443297606590757`*^9}},ExpressionUUID->"04560138-d2da-473e-8d06-\
632d495730c7"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", 
  RowBox[{"wtstb", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "5"}], "}"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644325719295577*^9, 3.6443257559556417`*^9}, {
  3.6443299589978237`*^9, 
  3.64432999088428*^9}},ExpressionUUID->"afd7b46b-335b-4378-aa31-\
5e1100c25dd5"],

Cell[BoxData[
 RowBox[{"wtstb", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.64431147011639*^9, 3.6443114931420307`*^9}, {
  3.6443116540719132`*^9, 
  3.644311709810811*^9}},ExpressionUUID->"044d8c7c-552f-40c6-8c5b-\
7d380d776560"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.64431172628444*^9, 
  3.6443117353012557`*^9}},ExpressionUUID->"d11f9ae4-82a3-44b4-ae7e-\
1b91cb22a217"],

Cell[BoxData[
 RowBox[{"wtstb", "[", 
  RowBox[{"{", "}"}], "]"}]], "Input",
 CellChangeTimes->{
  3.6443258462954*^9},ExpressionUUID->"d2f9027b-458c-402d-8b5f-3599822e385b"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.64431172628444*^9, 
  3.6443117353012557`*^9}},ExpressionUUID->"f8a81005-d69d-4861-b847-\
24ffa62a2141"],

Cell[BoxData[
 RowBox[{"wtstb", "[", 
  RowBox[{"{", "3", "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.64431147011639*^9, 3.6443114931420307`*^9}, {
   3.6443116540719132`*^9, 3.644311709810811*^9}, 3.6443118066557813`*^9, {
   3.644311849914657*^9, 3.644311883922717*^9}, 
   3.6443119236403866`*^9},ExpressionUUID->"812b6674-0e10-461b-9b67-\
3d4121bc2964"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6443118957319374`*^9, 3.6443119021123486`*^9}, {
  3.644326667246842*^9, 
  3.6443266692280455`*^9}},ExpressionUUID->"7ea572d8-96e5-4cd8-8652-\
a5f8280d6cca"],

Cell[BoxData[
 RowBox[{"wtstb", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.64431147011639*^9, 3.6443114931420307`*^9}, {
   3.6443116540719132`*^9, 3.644311709810811*^9}, 3.6443118066557813`*^9, {
   3.644311849914657*^9, 3.644311883922717*^9}, 3.6443119236403866`*^9, {
   3.644327256319477*^9, 
   3.644327262013487*^9}},ExpressionUUID->"7ea61950-f3a5-4fd5-b65a-\
c7497e2c2f9e"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6443118957319374`*^9, 3.6443119021123486`*^9}, {
  3.644326667246842*^9, 
  3.6443266692280455`*^9}},ExpressionUUID->"6ad5606a-8783-4bb4-8510-\
55004012404c"],

Cell[BoxData[
 RowBox[{"type", "[", "cta", "]"}]], "Input",
 CellChangeTimes->{{3.6443108425428877`*^9, 3.6443108621521225`*^9}, 
   3.644310892197775*^9, {3.6443849719267745`*^9, 3.6443849828955936`*^9}, 
   3.644385043040902*^9},ExpressionUUID->"20b5c2c0-e31e-4d0b-9114-\
a245ac8f2117"],

Cell[BoxData[
 RowBox[{"scta", "=", 
  RowBox[{"strictcoords", "[", "cta", "]"}]}]], "Input",
 CellChangeTimes->{{3.6443850106678457`*^9, 
  3.64438505299572*^9}},ExpressionUUID->"bdb3add9-b90a-42b0-96fa-\
68fb3a0c042c"],

Cell[BoxData[
 RowBox[{"scta", "[", 
  RowBox[{"[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644385354031251*^9, 
  3.6443853599456615`*^9}},ExpressionUUID->"69e2dca1-c784-49ab-a482-\
2612a5173eae"],

Cell[BoxData[
 RowBox[{"ss53", "=", 
  RowBox[{"Subsets", "[", 
   RowBox[{
    RowBox[{"Range", "[", "5", "]"}], ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64438510404501*^9, 
  3.644385161958312*^9}},ExpressionUUID->"4c0c55c0-62e9-4a9f-9777-\
497b9c67aaf2"],

Cell[BoxData[
 RowBox[{"ss53", "[", 
  RowBox[{"[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6443853928345194`*^9, 
  3.644385405815742*^9}},ExpressionUUID->"0f56f957-3eea-4068-8d52-\
dade38da2082"],

Cell[BoxData[
 RowBox[{"prcta", " ", "=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"scta", "[", 
      RowBox[{"[", "i", "]"}], "]"}], "*", 
     RowBox[{"wtstb", "[", 
      RowBox[{"ss53", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "10"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64438519484717*^9, 3.6443853063847666`*^9}, 
   3.6443854389074*^9},ExpressionUUID->"23515668-8f3d-4fc3-be40-f067d5409b32"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"prcta", ",", "cta"}], "]"}]], "Input",
 CellChangeTimes->{{3.644385459673037*^9, 
  3.644385471624658*^9}},ExpressionUUID->"3791422b-1867-4ae1-b0da-\
2834fbe41860"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"strictcoords", "[", "prcta", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644386866674919*^9, 3.644386894054968*^9}, {
  3.644386924900222*^9, 
  3.644386938942247*^9}},ExpressionUUID->"1bb83119-8ba7-4ebb-8c6e-\
998708bfb4ae"],

Cell[TextData[{
 "We summarize:",
 "\n",
 StyleBox["Proposition.",
  FontColor->RGBColor[0, 0, 1]],
 " The subset of antisymmetric covariant tensors  of degree p (shortly",
 StyleBox[" p-forms",
  FontColor->RGBColor[0, 0, 1]],
 ") is a vector  subspace of dimension Binomial[d,p], 0\[LessEqual]p\
\[LessEqual]d,  d the dimension of the underlying vector space. The tensors \
wtstb[",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["i", "1"], ",", "..", ",", 
    SubscriptBox["i", "p"]}], "}"}]],
  CellChangeTimes->{{3.644305055998182*^9, 3.6443051561347575`*^9}, {
   3.644305198754032*^9, 3.6443052236984763`*^9}},ExpressionUUID->
  "8ec44b88-297f-43ab-9779-9fd4e037f50b"],
 ", d], ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["i", "1"], ",", "..", ",", 
    SubscriptBox["i", "p"]}], "}"}]],
  CellChangeTimes->{{3.644305055998182*^9, 3.6443051561347575`*^9}, {
   3.644305198754032*^9, 3.6443052236984763`*^9}},ExpressionUUID->
  "342f0488-c6ac-49ad-867e-8561875fb752"],
 "\[Element]Subsets[Range[{d}],p] are the ",
 StyleBox["standard basis",
  FontColor->RGBColor[0, 0, 1]],
 " of this subspace; the corresponding coordinates of a p-form ta are its \
strict coordinates.  An analogous statement is true for the subspace of \
antisymmetric contravariant tensors of degree p (shortly ",
 StyleBox["p-vectors",
  FontColor->RGBColor[0, 0, 1]],
 "). ",
 "\[FilledSquare]"
}], "Text",
 CellChangeTimes->{{3.64447107677829*^9, 3.644471112549153*^9}},
 CellTags->"wtstb",ExpressionUUID->"0968eb05-ec42-4efb-bb95-48901332008c"],

Cell[TextData[{
 "The number of these basis elements is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", GridBox[{
      {"d"},
      {"p"}
     }], ")"}], TraditionalForm]],ExpressionUUID->
  "a7047050-56f4-4ad8-985e-be02e0558271"],
 ", with"
}], "Text",
 CellChangeTimes->{{3.6444711292411823`*^9, 3.6444711515648212`*^9}, {
  3.6444711984429035`*^9, 3.6444712637090178`*^9}, {3.6444713556867795`*^9, 
  3.6444713910052414`*^9}},ExpressionUUID->"09b27e36-b538-41f4-829d-\
12a60c253196"],

Cell[BoxData[
 RowBox[{"?", "Binomial"}]], "Input",
 CellChangeTimes->{{3.644470246443231*^9, 
  3.6444702504836383`*^9}},ExpressionUUID->"7bba4c1d-cf64-4242-b38a-\
b675f79ec34a"],

Cell["\<\
The standard basis vtstb in the space of the p-vectors over the underlying \
vector space of dimension d is quite analogous to the basis wtstb; it is \
given in tensalgv2.m as\
\>", "Text",
 CellChangeTimes->{{3.6444725419364634`*^9, 3.6444725431688657`*^9}, {
  3.644472578752528*^9, 3.6444726272998133`*^9}, {3.6444726626026754`*^9, 
  3.6444727381068077`*^9}},ExpressionUUID->"8ccb4669-2186-47ed-96bc-\
4187bafdbfd5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vtstb", "[", 
   RowBox[{"i_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", "pp", ",", "ppi", ",", "j"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "i", "]"}], "===", "List"}], ",", 
       RowBox[{"p", " ", "=", " ", 
        RowBox[{"Length", "[", "i", "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"p", "\[Equal]", "1"}], ",", " ", 
       RowBox[{"Return", "[", 
        RowBox[{"tstb", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "i", ",", "d"}], "]"}], "]"}]}], "]"}], 
     ";", " ", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"p", "<=", "d"}], ")"}], ",", 
       RowBox[{"pp", " ", "=", " ", 
        RowBox[{"Subsets", "[", 
         RowBox[{
          RowBox[{"Range", "[", "d", "]"}], ",", 
          RowBox[{"{", "p", "}"}]}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"pp", ",", "i"}], "]"}], ",", 
       RowBox[{"ppi", " ", "=", 
        RowBox[{"Permutations", "[", 
         RowBox[{"Range", "[", "p", "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Invalid argument!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Signature", "[", 
         RowBox[{"ppi", "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}], "*", 
        RowBox[{"tstb", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"Permute", "[", 
           RowBox[{"i", ",", 
            RowBox[{"ppi", "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", "d"}], "]"}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"p", "!"}]}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.64447180568517*^9, 3.6444718408164315`*^9}, {
  3.6444719318193913`*^9, 
  3.6444719645482492`*^9}},ExpressionUUID->"bd881aa2-abb1-4610-9623-\
6473b39db30a"],

Cell[BoxData[
 RowBox[{"?", "vtstb"}]], "Input",
 CellChangeTimes->{{3.644474078055561*^9, 
  3.6444740813003674`*^9}},ExpressionUUID->"a4686d4f-86db-4e4f-b288-\
2d5228c47644"],

Cell[BoxData[
 RowBox[{"ta", " ", "=", 
  RowBox[{"contraalttensor", "[", 
   RowBox[{"a", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6444720465731936`*^9, 3.644472079629651*^9}, {
  3.644472150672176*^9, 
  3.6444721801094275`*^9}},ExpressionUUID->"378f2dde-d94f-43ae-bc02-\
796422370349"],

Cell[BoxData[
 RowBox[{"scta", "=", 
  RowBox[{"strictcoords", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.6443850106678457`*^9, 3.64438505299572*^9}, 
   3.6444722843176107`*^9},ExpressionUUID->"05c63e02-ca9e-41da-a2c4-\
b019b04dd7e7"],

Cell[BoxData[
 RowBox[{"ss53", "=", 
  RowBox[{"Subsets", "[", 
   RowBox[{
    RowBox[{"Range", "[", "5", "]"}], ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64438510404501*^9, 
  3.644385161958312*^9}},ExpressionUUID->"7b3baca9-5d23-40f9-9ca9-\
0a418f57a49b"],

Cell[BoxData[
 RowBox[{"prcta", " ", "=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"scta", "[", 
      RowBox[{"[", "i", "]"}], "]"}], "*", 
     RowBox[{"vtstb", "[", 
      RowBox[{"ss53", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "10"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64438519484717*^9, 3.6443853063847666`*^9}, 
   3.6443854389074*^9, 
   3.644472314020063*^9},ExpressionUUID->"f17be994-11b9-4fcc-b65e-\
4f8eb8cadb76"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"ta", ",", "prcta"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644472349416525*^9, 
  3.644472376201772*^9}},ExpressionUUID->"263d5d75-a663-4514-87a5-\
d086013bba7f"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"ta", ",", "cta", ",", "prcta", ",", "scta", ",", "ss53"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.644472413595038*^9, 
  3.644472473436743*^9}},ExpressionUUID->"56a2a7a2-96d6-446a-a65e-\
96180a6b44f8"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3. Symmetrization  and Alternation of Tensors", "Subsection",
 CellChangeTimes->{{3.564475347821782*^9, 3.564475352876191*^9}, {
   3.5644782382040734`*^9, 3.564478254927303*^9}, {3.5644829390219307`*^9, 
   3.564482941159134*^9}, {3.5650734555472913`*^9, 3.565073482895856*^9}, {
   3.5650735138726273`*^9, 3.565073574328085*^9}, 3.565073697271117*^9, {
   3.565073884560829*^9, 3.5650739381678953`*^9}, {3.5650756540490384`*^9, 
   3.565075665544696*^9}, 3.5650764964402204`*^9, 3.601183832509673*^9, 
   3.6408721552533126`*^9, 3.6408722022717953`*^9, {3.640873124561015*^9, 
   3.640873163405083*^9}, {3.6417987262898626`*^9, 3.6417987480423017`*^9}, 
   3.6435106281467977`*^9, 
   3.6435193223474083`*^9},ExpressionUUID->"fd32f13b-7291-4d2c-81c2-\
cd1a0c8939e7"],

Cell["\<\
Symmetrization and alternation of tensors are operations for tensors making \
them symmetric resp. antisymmetric in their covariant or Contravariant parts. \
In this Subsection we create such operations and show their properties,\
\>", "Text",
 CellChangeTimes->{{3.641269835317083*^9, 3.64127003877264*^9}, 
   3.644587914225609*^9},ExpressionUUID->"ea05dccf-edc6-403e-82a8-\
38911c16d1ac"],

Cell[CellGroupData[{

Cell["4.3.1. Symmetrization  of Coordinate Functions", "Subsubsection",
 CellChangeTimes->{{3.564475347821782*^9, 3.564475352876191*^9}, {
   3.5644782382040734`*^9, 3.564478254927303*^9}, {3.5644829390219307`*^9, 
   3.564482941159134*^9}, {3.5650734555472913`*^9, 3.565073482895856*^9}, {
   3.5650735138726273`*^9, 3.565073574328085*^9}, 3.565073697271117*^9, {
   3.565073884560829*^9, 3.5650739381678953`*^9}, {3.5650756540490384`*^9, 
   3.565075665544696*^9}, 3.5650764964402204`*^9, 3.601183832509673*^9, 
   3.6408721552533126`*^9, 3.6408722022717953`*^9, {3.64087318458992*^9, 
   3.6408731863059235`*^9}, {3.6408736748207817`*^9, 
   3.640873700248826*^9}},ExpressionUUID->"9d687bc4-fb5d-418c-b33f-\
0e4472da1261"],

Cell["\<\
In tensalgv2.m we defined  two operators, the symmetrizations covs, contras \
which act over the covariant resp contravariant indices and transform the \
coordinate function  into a symmetric coordinate function of the same type.\
\>", "Text",
 CellChangeTimes->{{3.5649306237757645`*^9, 3.5649308997355485`*^9}, 
   3.5650757919279246`*^9, {3.565075822232658*^9, 3.5650758503602667`*^9}, {
   3.5650759212163196`*^9, 3.5650759601615467`*^9}, {3.565076007833274*^9, 
   3.5650760544569407`*^9}, {3.56507639677652*^9, 3.5650764199768467`*^9}, {
   3.5650768531936255`*^9, 3.565076866784403*^9}, {3.565076917328294*^9, 
   3.565076927112853*^9}, {3.601183835130478*^9, 3.601183838156883*^9}, {
   3.6408732049011564`*^9, 
   3.6408732443692255`*^9}},ExpressionUUID->"ffdfbd0d-fe94-42be-b333-\
7399abb95db5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.565004174440527*^9, 3.5650041811485386`*^9}, 
   3.640873276708082*^9},ExpressionUUID->"550365af-6ed0-4b98-bafa-\
10ae41606ab8"],

Cell[BoxData[
 RowBox[{"?", "covs"}]], "Input",
 CellChangeTimes->{{3.565014265565084*^9, 3.565014332250898*^9}, {
   3.5650143721221786`*^9, 3.565014435459801*^9}, {3.5650144658525395`*^9, 
   3.5650145228528*^9}, 3.565014587836517*^9, {3.5650146348772073`*^9, 
   3.5650147014610157`*^9}, 3.5650151804044094`*^9, {3.565073113116705*^9, 
   3.565073119946096*^9}},ExpressionUUID->"e539e06f-6ff1-4a3d-a924-\
4c3e9baf3683"],

Cell[BoxData[
 RowBox[{"?", "contras"}]], "Input",
 CellChangeTimes->{{3.565014265565084*^9, 3.565014332250898*^9}, {
   3.5650143721221786`*^9, 3.565014435459801*^9}, {3.5650144658525395`*^9, 
   3.5650145228528*^9}, 3.565014587836517*^9, {3.5650146348772073`*^9, 
   3.5650147014610157`*^9}, {3.565015042073498*^9, 3.5650151463084593`*^9}, {
   3.565015190308976*^9, 3.565015216092451*^9}, {3.56507315481109*^9, 
   3.565073169201913*^9}},ExpressionUUID->"aca40676-c0e0-47c3-bb09-\
abd4d59f0a52"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"covs", "[", "aa_", "]"}], "[", 
     RowBox[{"ii_", ",", "jj_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "ii", "]"}], "\[Equal]", "0"}], ")"}], ",", 
      " ", 
      RowBox[{"aa", "[", 
       RowBox[{"ii", ",", "jj"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"covpermute", "[", 
          RowBox[{"aa", ",", 
           RowBox[{
            RowBox[{"Permutations", "[", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "ii", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "l", "]"}], "]"}]}], "]"}], "[", 
         RowBox[{"ii", ",", "jj"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"l", ",", 
          RowBox[{
           RowBox[{"Length", "[", "ii", "]"}], "!"}]}], "}"}]}], "]"}]}], 
     "]"}]}], ";"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5649318800356183`*^9, 3.56493189073923*^9}, {
   3.564931933002648*^9, 3.564931958947132*^9}, {3.564932007450906*^9, 
   3.564932061844017*^9}, {3.5649321576944995`*^9, 3.564932170447229*^9}, 
   3.5649322105895247`*^9, 3.5649322784794083`*^9, 3.5649324160632772`*^9, {
   3.5649326276793814`*^9, 3.5649326755191174`*^9}, 3.5650008635183115`*^9, {
   3.5650009149828014`*^9, 3.5650009768057103`*^9}, {3.5650010079589653`*^9, 
   3.5650010176933823`*^9}, {3.5650026455318413`*^9, 
   3.5650027675396557`*^9}, {3.5650028227169523`*^9, 3.565002841343385*^9}, {
   3.565004338927216*^9, 3.5650043689260683`*^9}, {3.565004592942462*^9, 
   3.565004639882944*^9}, 3.5650152547356615`*^9, {3.5651820360382037`*^9, 
   3.565182051591431*^9}, 3.5651855001614885`*^9, 3.565189121454336*^9, {
   3.5691390638718786`*^9, 
   3.5691390897173567`*^9}},ExpressionUUID->"50458750-2b46-4e1e-b4d9-\
8a830ec714e1"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"contras", "[", "aa_", "]"}], "[", 
     RowBox[{"ii_", ",", "jj_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "jj", "]"}], "\[Equal]", "0"}], ")"}], ",", 
      " ", 
      RowBox[{"aa", "[", 
       RowBox[{"ii", ",", "jj"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"contrapermute", "[", 
          RowBox[{"aa", ",", 
           RowBox[{
            RowBox[{"Permutations", "[", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "jj", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "l", "]"}], "]"}]}], "]"}], "[", 
         RowBox[{"ii", ",", "jj"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"l", ",", 
          RowBox[{
           RowBox[{"Length", "[", "jj", "]"}], "!"}]}], "}"}]}], "]"}]}], 
     "]"}]}], ";"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5649318800356183`*^9, 3.56493189073923*^9}, {
   3.564931933002648*^9, 3.564931958947132*^9}, {3.564932007450906*^9, 
   3.564932061844017*^9}, {3.5649321576944995`*^9, 3.564932170447229*^9}, 
   3.5649322105895247`*^9, 3.5649322784794083`*^9, 3.5649324160632772`*^9, {
   3.5649326276793814`*^9, 3.5649326755191174`*^9}, 3.5650008635183115`*^9, {
   3.5650009149828014`*^9, 3.5650009768057103`*^9}, {3.5650010079589653`*^9, 
   3.5650010176933823`*^9}, {3.5650026455318413`*^9, 
   3.5650027675396557`*^9}, {3.5650028227169523`*^9, 3.565002841343385*^9}, {
   3.565004338927216*^9, 3.5650043689260683`*^9}, {3.565004592942462*^9, 
   3.565004639882944*^9}, {3.5650152547356615`*^9, 3.565015287168516*^9}, {
   3.5650153298879595`*^9, 3.5650153314090466`*^9}, {3.5650157855620227`*^9, 
   3.565015785832038*^9}, {3.5650159437690716`*^9, 3.565015943984084*^9}, {
   3.5651821389359846`*^9, 3.565182181290059*^9}, 3.565185513546312*^9, 
   3.5651865861023226`*^9, {3.5691391001449533`*^9, 
   3.5691391259324284`*^9}},ExpressionUUID->"f62bf839-ee0d-439c-9989-\
d9d4efa51987"],

Cell[TextData[StyleBox["Examples",
 FontSize->16,
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.5652507255046873`*^9, 
  3.5652507289054933`*^9}},ExpressionUUID->"576e256d-f9ab-4bd2-973a-\
97d465942ff0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covs", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "i", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565001111761547*^9, 3.565001173849656*^9}, 
   3.565076946002934*^9, 
   3.56913914589357*^9},ExpressionUUID->"7bfb343e-2d64-4314-a30c-\
629c6a0cd018"],

Cell["\<\
Now the new coordinate function covs[a] is symmetric in the covariant indices:\
\>", "Text",
 CellChangeTimes->{{3.5650770280646276`*^9, 3.5650770802326117`*^9}, {
   3.5652508095108347`*^9, 3.565250810556037*^9}, 
   3.60118386478613*^9},ExpressionUUID->"705c06a1-795b-4a94-b7af-\
50cc1c7e9830"],

Cell[BoxData[
 RowBox[{"%", "-", 
  RowBox[{
   RowBox[{"covs", "[", "a", "]"}], "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "i", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565076978261779*^9, 3.565077002531167*^9}, 
   3.56913916792283*^9},ExpressionUUID->"09c59510-2912-4227-a090-\
779ba991fa99"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contras", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "i", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j1", ",", "j2", ",", "j3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565001111761547*^9, 3.565001173849656*^9}, {
   3.5650028590806165`*^9, 3.5650028665062294`*^9}, {3.565077151475686*^9, 
   3.5650772122991652`*^9}, 
   3.5691391811935887`*^9},ExpressionUUID->"b803ac98-6d18-4779-8e09-\
7e24c0c1e173"],

Cell["\<\
Of course, permutations of order 0 or 1 don\[CloseCurlyQuote]t change the \
expression;\
\>", "Text",
 CellChangeTimes->{{3.56525092654224*^9, 
  3.5652509796603336`*^9}},ExpressionUUID->"c1e9ce71-59ec-4095-9975-\
100f834515e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covs", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "i", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565001111761547*^9, 3.565001173849656*^9}, {
   3.5650028590806165`*^9, 3.5650028665062294`*^9}, 3.565189308817053*^9, 
   3.569139192565239*^9},ExpressionUUID->"472547a3-9b2c-4530-8f0b-\
9d3615638a99"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contras", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", ",", "j"}], "}"}], ",", 
   RowBox[{"{", "k", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565001111761547*^9, 3.565001173849656*^9}, {
   3.5650028590806165`*^9, 3.5650028665062294`*^9}, {3.565077151475686*^9, 
   3.565077161580264*^9}, {3.565189327616128*^9, 3.565189357943863*^9}, 
   3.5691392111153*^9},ExpressionUUID->"645f9f94-a5fc-4189-9aba-f6b91864f069"],

Cell["\<\
If the index lists are empty or contain one index only, the symmetrized \
coordinate functions coincide with the original coordinate functions:\
\>", "Text",
 CellChangeTimes->{{3.5650773492649994`*^9, 3.5650773885362453`*^9}, {
  3.5650775950080547`*^9, 3.5650776808169627`*^9}, {3.6011838754565487`*^9, 
  3.601183879574956*^9}},ExpressionUUID->"c86e2e13-75d4-4f25-9cf0-\
b678d0d1bcc5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contras", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565001111761547*^9, 3.565001173849656*^9}, {
   3.5650028590806165`*^9, 3.5650028665062294`*^9}, {3.565077151475686*^9, 
   3.5650772122991652`*^9}, {3.5650772559806633`*^9, 3.565077272466606*^9}, 
   3.5650773130109253`*^9, 
   3.569139248116417*^9},ExpressionUUID->"a0cb08e6-e50f-4a8c-b685-\
ba8af62453c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"covs", "[", "a", "]"}], "-", "a"}], ")"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650774007349434`*^9, 3.565077482779636*^9}, {
   3.565077518188661*^9, 3.5650775226679173`*^9}, 
   3.569139266092445*^9},ExpressionUUID->"2924d3a1-e398-460a-8e17-\
6a1e8f585b57"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3.2.  Alternation of Coordinate Functions", "Subsubsection",
 CellChangeTimes->{{3.564475347821782*^9, 3.564475352876191*^9}, {
   3.5644782382040734`*^9, 3.564478254927303*^9}, {3.5644829390219307`*^9, 
   3.564482941159134*^9}, {3.5650734555472913`*^9, 3.565073482895856*^9}, {
   3.5650735138726273`*^9, 3.565073574328085*^9}, 3.565073697271117*^9, {
   3.565073884560829*^9, 3.5650739381678953`*^9}, {3.5650756540490384`*^9, 
   3.565075665544696*^9}, {3.5650765128241577`*^9, 3.565076524096802*^9}, 
   3.601183885627766*^9, {3.6408736376771164`*^9, 3.6408737144760513`*^9}, 
   3.641013241306451*^9, {3.6435193104445877`*^9, 3.643519312160591*^9}, 
   3.6436015348579454`*^9},ExpressionUUID->"3dce0f03-33a6-44af-9d96-\
7001e90437e9"],

Cell["\<\
Similarly to the symmetrizations the alternating operators of the coordinate \
functions are defined:\
\>", "Text",
 CellChangeTimes->{{3.565078549440645*^9, 3.5650786114881945`*^9}, 
   3.6011838883889713`*^9},ExpressionUUID->"3792d775-595a-43e9-a8df-\
f3a47c183670"],

Cell[BoxData[
 RowBox[{"?", "cova"}]], "Input",
 CellChangeTimes->{{3.565014265565084*^9, 3.565014332250898*^9}, {
   3.5650143721221786`*^9, 3.565014435459801*^9}, {3.5650144658525395`*^9, 
   3.5650145228528*^9}, 3.565014587836517*^9, {3.5650148174926524`*^9, 
   3.565014818588715*^9}, {3.565076556942681*^9, 3.565076564924137*^9}, 
   3.565076649361967*^9},ExpressionUUID->"ba24d80c-e48c-4767-9cc9-\
6654aaa61b53"],

Cell[BoxData[
 RowBox[{"?", "contra"}]], "Input",
 CellChangeTimes->{{3.565014265565084*^9, 3.565014332250898*^9}, {
   3.5650143721221786`*^9, 3.565014435459801*^9}, {3.5650144658525395`*^9, 
   3.5650145228528*^9}, 3.565014587836517*^9, {3.5650148174926524`*^9, 
   3.565014818588715*^9}, {3.565016592513178*^9, 3.565016694461009*^9}, {
   3.5650766650918665`*^9, 
   3.56507667301832*^9}},ExpressionUUID->"7831007b-43f5-4f71-8424-\
5beb7d4a393c"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cova", "[", 
       RowBox[{"aa_", ",", 
        RowBox[{"d_:", "dim"}]}], "]"}], "[", 
      RowBox[{"ii_", ",", "jj_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Length", "[", "ii", "]"}], "==", "0"}], ")"}], ",", " ", 
       RowBox[{"aa", "[", 
        RowBox[{"ii", ",", "jj"}], "]"}], ",", "\n", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"Subsets", "[", 
            RowBox[{
             RowBox[{"Range", "[", "d", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"Length", "[", "ii", "]"}], "}"}]}], "]"}], ",", 
           RowBox[{"Sort", "[", "ii", "]"}]}], "]"}], ",", "\n", 
         RowBox[{"Return", "[", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Signature", "[", 
              RowBox[{
               RowBox[{"Permutations", "[", 
                RowBox[{"Range", "[", 
                 RowBox[{"Length", "[", "ii", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}], "]"}], "*", 
             RowBox[{
              RowBox[{"covpermute", "[", 
               RowBox[{"aa", ",", 
                RowBox[{
                 RowBox[{"Permutations", "[", 
                  RowBox[{"Range", "[", 
                   RowBox[{"Length", "[", "ii", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "l", "]"}], "]"}]}], "]"}], "[", 
              RowBox[{"ii", ",", "jj"}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"l", ",", 
              RowBox[{
               RowBox[{"Length", "[", "ii", "]"}], "!"}]}], "}"}]}], "]"}], 
          "]"}], ",", "0"}], "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"cova", "/:", " ", 
     RowBox[{"cova", "[", 
      RowBox[{
       RowBox[{"a_", " ", "+", " ", "b_"}], ",", 
       RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"cova", "[", 
       RowBox[{"a", ",", "d"}], "]"}], " ", "+", " ", 
      RowBox[{"cova", "[", 
       RowBox[{"b", ",", "d"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"cova", "/:", " ", 
     RowBox[{"cova", "[", 
      RowBox[{
       RowBox[{"times", "[", 
        RowBox[{"c_", ",", "a_"}], "]"}], ",", 
       RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
     RowBox[{"times", "[", 
      RowBox[{"c", ",", 
       RowBox[{"cova", "[", 
        RowBox[{"a", ",", "d"}], "]"}]}], "]"}]}], ";"}], " "}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5649318800356183`*^9, 3.56493189073923*^9}, {
   3.564931933002648*^9, 3.564931958947132*^9}, {3.564932007450906*^9, 
   3.564932061844017*^9}, {3.5649321576944995`*^9, 3.564932170447229*^9}, 
   3.5649322105895247`*^9, 3.5649322784794083`*^9, 3.5649324160632772`*^9, {
   3.5649326276793814`*^9, 3.5649326755191174`*^9}, 3.5650008635183115`*^9, {
   3.5650009149828014`*^9, 3.5650009768057103`*^9}, {3.5650010079589653`*^9, 
   3.5650010176933823`*^9}, {3.5650026455318413`*^9, 
   3.5650027675396557`*^9}, {3.5650028227169523`*^9, 3.565002841343385*^9}, {
   3.565004338927216*^9, 3.5650043689260683`*^9}, {3.565004592942462*^9, 
   3.565004639882944*^9}, {3.5650113551763997`*^9, 3.5650113804077606`*^9}, {
   3.5650114380406637`*^9, 3.5650114568318768`*^9}, 3.565011491497635*^9, 
   3.565016719465439*^9, {3.5651824270684905`*^9, 3.565182437536109*^9}, {
   3.565185296612331*^9, 3.565185305878747*^9}, 3.5651858159372716`*^9, {
   3.569139430803866*^9, 3.5691394640457673`*^9}, {3.6441296107307673`*^9, 
   3.6441296336784077`*^9}, 
   3.6441297622226334`*^9},ExpressionUUID->"a3c23811-599c-49fa-b4ed-\
8c94b23587de"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"contra", "[", 
     RowBox[{"aa_", ",", 
      RowBox[{"d_:", "dim"}]}], "]"}], "[", 
    RowBox[{"ii_", ",", "jj_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "jj", "]"}], "\[Equal]", "0"}], ")"}], ",", " ", 
     RowBox[{"aa", "[", 
      RowBox[{"ii", ",", "jj"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Subsets", "[", 
          RowBox[{
           RowBox[{"Range", "[", "d", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "jj", "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"Sort", "[", "jj", "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Signature", "[", 
            RowBox[{
             RowBox[{"Permutations", "[", 
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "jj", "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", "l", "]"}], "]"}], "]"}], "*", 
           RowBox[{
            RowBox[{"contrapermute", "[", 
             RowBox[{"aa", ",", 
              RowBox[{
               RowBox[{"Permutations", "[", 
                RowBox[{"Range", "[", 
                 RowBox[{"Length", "[", "jj", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}]}], "]"}], "[", 
            RowBox[{"ii", ",", "jj"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"l", ",", 
            RowBox[{
             RowBox[{"Length", "[", "jj", "]"}], "!"}]}], "}"}]}], "]"}], 
        "]"}], ",", "0"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"contra", "/:", " ", 
   RowBox[{"contra", "[", 
    RowBox[{
     RowBox[{"a_", " ", "+", "b_"}], ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"contra", "[", 
     RowBox[{"a", ",", "d"}], "]"}], " ", "+", " ", 
    RowBox[{"contra", "[", 
     RowBox[{"b", ",", "d"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"contra", "/:", " ", 
    RowBox[{"contra", "[", 
     RowBox[{
      RowBox[{"times", "[", 
       RowBox[{"c_", ",", "a_"}], "]"}], ",", 
      RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
    RowBox[{"times", "[", 
     RowBox[{"c", ",", 
      RowBox[{"contra", "[", 
       RowBox[{"a", ",", "d"}], "]"}]}], "]"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]"}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5649318800356183`*^9, 3.56493189073923*^9}, {
   3.564931933002648*^9, 3.564931958947132*^9}, {3.564932007450906*^9, 
   3.564932061844017*^9}, {3.5649321576944995`*^9, 3.564932170447229*^9}, 
   3.5649322105895247`*^9, 3.5649322784794083`*^9, 3.5649324160632772`*^9, {
   3.5649326276793814`*^9, 3.5649326755191174`*^9}, 3.5650008635183115`*^9, {
   3.5650009149828014`*^9, 3.5650009768057103`*^9}, {3.5650010079589653`*^9, 
   3.5650010176933823`*^9}, {3.5650026455318413`*^9, 
   3.5650027675396557`*^9}, {3.5650028227169523`*^9, 3.565002841343385*^9}, {
   3.565004338927216*^9, 3.5650043689260683`*^9}, {3.565004592942462*^9, 
   3.565004639882944*^9}, {3.5650113551763997`*^9, 3.5650113804077606`*^9}, {
   3.5650114380406637`*^9, 3.5650114568318768`*^9}, 3.565011491497635*^9, 
   3.565016706305686*^9, {3.5650167740085583`*^9, 3.5650168655847964`*^9}, {
   3.565182476894978*^9, 3.5651824942266083`*^9}, 3.5651853277811856`*^9, 
   3.565185823638712*^9, 3.569139475193405*^9, 3.5691395226611195`*^9, 
   3.569139555506998*^9, {3.644129692708912*^9, 3.64412970322333*^9}, 
   3.6441297413029966`*^9, {3.6441297872606773`*^9, 3.6441298311123543`*^9}, {
   3.644129867039218*^9, 3.6441298888792562`*^9}, {3.6441299571917763`*^9, 
   3.6441299600465813`*^9}, {3.644129991371436*^9, 
   3.644130037266717*^9}},ExpressionUUID->"f38d0631-f827-49ff-83b6-\
aa323d8aa5bc"],

Cell[TextData[StyleBox["Examples",
 FontSize->16,
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.5652512241751633`*^9, 
  3.56525122787237*^9}},ExpressionUUID->"360847f2-2fdf-47af-9b96-\
4b704d60dfb4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "5"}], ";"}]], "Input",
 CellChangeTimes->{{3.640873811742222*^9, 3.640873817451832*^9}, 
   3.6440692595977592`*^9},ExpressionUUID->"d2b633e9-f4fe-49a1-8eb6-\
ce8522df8429"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565011511991949*^9, 3.5650115473392553`*^9}, 
   3.5691622915707817`*^9},ExpressionUUID->"b1c8792d-23bf-4a00-90a8-\
566540464716"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.565011511991949*^9, 3.5650115473392553`*^9}, 
   3.5691622915707817`*^9, {3.644069298597828*^9, 
   3.64406931157705*^9}},ExpressionUUID->"f772c1b9-996e-437f-9427-\
dccfaee82e62"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"-", "%%"}]}]], "Input",
 CellChangeTimes->{{3.565251357570997*^9, 
  3.5652513639514084`*^9}},ExpressionUUID->"b273a885-dd09-434c-aa0f-\
427b54af28a3"],

Cell["\<\
If the Lists contain less than two elements, the original coordinate \
functions are reproduced:\
\>", "Text",
 CellChangeTimes->{{3.5650789812963457`*^9, 3.5650790414087844`*^9}, 
   3.6011838910253754`*^9},ExpressionUUID->"7d726dda-fc4e-4427-a301-\
4c0348f1258b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", "b", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650115895089293`*^9, 3.565011622362899*^9}, 
   3.5691623452348766`*^9},ExpressionUUID->"5a57d620-a8ff-419d-b013-\
cc2d3db6ee04"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", "b", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650115895089293`*^9, 3.5650116567143507`*^9}, 
   3.5652514361951356`*^9, 3.56916236436051*^9, 
   3.6440693864883823`*^9},ExpressionUUID->"fb435771-c458-4ad3-b679-\
82c54209ce27"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"cova", "[", "b", "]"}], "-", 
    RowBox[{"contra", "[", "b", "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650115895089293`*^9, 3.5650116567143507`*^9}, {
   3.5650790697694063`*^9, 3.565079167659005*^9}, 
   3.5691623850617466`*^9},ExpressionUUID->"d85d04e0-3bb8-4952-b6e6-\
71350125aca7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{
    RowBox[{"cova", "[", "b", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"contra", "[", "b", "]"}]}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6436010098858232`*^9, 
  3.643601075062738*^9}},ExpressionUUID->"e35f3a8e-f886-49b9-8ee2-\
fb0ebaa807a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", "b", "]"}], "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650115895089293`*^9, 3.5650116567143507`*^9}, {
   3.5650790697694063`*^9, 3.565079167659005*^9}, {3.565185864582054*^9, 
   3.5651858971679173`*^9}, 
   3.5691623936573615`*^9},ExpressionUUID->"4a7e4d4c-931b-4660-97eb-\
e35b6c1956a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"cova", "[", "b", "]"}], "-", 
    RowBox[{"contra", "[", "b", "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"{", "i", "}"}], ",", 
   RowBox[{"{", "j", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5650115895089293`*^9, 3.5650116567143507`*^9}, {
   3.5650790697694063`*^9, 3.565079167659005*^9}, {3.565079203705067*^9, 
   3.565079214979712*^9}, 
   3.569162407588186*^9},ExpressionUUID->"846583a2-b088-455e-b963-\
b975193792bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{
    RowBox[{"cova", "[", "b", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"contra", "[", "b", "]"}]}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", "i", "}"}], ",", 
   RowBox[{"{", "j", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.643601179785722*^9},ExpressionUUID->"f29da37b-7239-4a5d-97ad-\
13fe239e6267"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "5"}], ";", 
  RowBox[{
   RowBox[{"contra", "[", "b", "]"}], "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "j", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5651859415194545`*^9, 3.56518595734336*^9}, 
   3.56916243832024*^9, {3.6441308586451283`*^9, 
   3.644130864354738*^9}},ExpressionUUID->"be099152-d7df-4bec-9360-\
bd0bd46210f9"],

Cell["Composing the operators yields", "Text",
 CellChangeTimes->{{3.565251557641349*^9, 
  3.5652515779057846`*^9}},ExpressionUUID->"0a0ffa92-92ad-4f83-ba28-\
989ea9340531"],

Cell[BoxData[
 RowBox[{
  RowBox[{"i1", "=", "1"}], ";", 
  RowBox[{"i2", "=", "4"}], ";", 
  RowBox[{"a", "=", "3"}], ";", 
  RowBox[{"b", "=", "2"}], ";", 
  RowBox[{"c", "=", "5"}], ";"}]], "Input",
 CellChangeTimes->{{3.6441310008361793`*^9, 
  3.644131069675501*^9}},ExpressionUUID->"f41f50fb-862b-4abf-a895-\
9fb246c7b9c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cova", "[", 
    RowBox[{"contra", "[", "x", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i1", ",", "i2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}], "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"contra", "[", 
    RowBox[{"cova", "[", "x", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i1", ",", "i2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5651826468728766`*^9, 3.5651826667317114`*^9}, 
   3.5691624726403*^9, {3.644131247970615*^9, 
   3.6441312907508907`*^9}},ExpressionUUID->"8cf8310d-6c92-454d-95bf-\
6aee05f89fe4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cova", "[", 
   RowBox[{"cova", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5651826468728766`*^9, 3.565182696075363*^9}, 
   3.569162500127548*^9},ExpressionUUID->"2699b56c-c096-4ba5-b4f8-\
01ff88766d70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contra", "[", 
   RowBox[{"contra", "[", "x", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5651826468728766`*^9, 3.5651826667317114`*^9}, {
   3.5651837657348423`*^9, 3.5651837751416583`*^9}, 
   3.5691625274587965`*^9},ExpressionUUID->"c874b2a4-41d0-49d5-92f0-\
1231af4c2595"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covs", "[", 
   RowBox[{"contra", "[", 
    RowBox[{"contra", "[", "x", "]"}], "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5652516986187963`*^9, 3.5652517272760468`*^9}, 
   3.569162542934024*^9},ExpressionUUID->"23cb0c24-7c05-402f-ad6a-\
224f3c4c5fb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plus", "[", 
   RowBox[{
    RowBox[{"cova", "[", 
     RowBox[{"contra", "[", "x", "]"}], "]"}], ",", 
    RowBox[{"-", "  ", 
     RowBox[{"contra", "[", 
      RowBox[{"cova", "[", "x", "]"}], "]"}]}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i1", ",", "i2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5652516986187963`*^9, 3.5652517272760468`*^9}, 
   3.569162542934024*^9, {3.6436012708586817`*^9, 3.6436013146167583`*^9}, 
   3.6436013652700477`*^9, {3.6436014002921095`*^9, 
   3.643601496450678*^9}},ExpressionUUID->"0355e574-53e5-4dca-b9c1-\
f036129c5d37"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"i1", ",", "i2", ",", "a", ",", "b", ",", "c"}], "]"}]], "Input",
 CellChangeTimes->{{3.6441320337544007`*^9, 
  3.6441320539408364`*^9}},ExpressionUUID->"5b2c83ab-8d1c-44a3-99d9-\
714be0e491fb"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3.3. The Definitions covsym, contrasym, covalt, contralt", \
"Subsubsection",
 CellChangeTimes->{{3.5651005188607793`*^9, 3.5651005555488777`*^9}, {
   3.565329608603458*^9, 3.565329620568679*^9}, {3.64126969134443*^9, 
   3.6412696953224373`*^9}, 3.643601541768758*^9, 
   3.643608311431819*^9},ExpressionUUID->"e01ca8fc-08cf-4ea8-912f-\
c0e02ab621fb"],

Cell[TextData[{
 "We remember some simple definitions. Let a, b with a<b be slots of  two \
covariant or two contravariant indices of a tensor ta. The tensor is said to \
be ",
 StyleBox["symmetric with respect to the indices ia, ib",
  FontColor->RGBColor[0, 0, 1]],
 ", if"
}], "Text",
 CellChangeTimes->{{3.562483236881426*^9, 3.5624834728269215`*^9}, 
   3.5624836213754177`*^9, 3.5624836659649677`*^9, 3.5624838517695956`*^9, {
   3.5644709772245054`*^9, 3.5644710188453784`*^9}, {3.6031894553646145`*^9, 
   3.6031894681878366`*^9}},ExpressionUUID->"c432cfbd-1819-4ded-abb2-\
c68203998988"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["ta", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"..", "ia"}], ".."}], "ib"}], "..."}], 
   RowBox[{"...", "..."}]], " ", "\[Equal]", " ", 
  SubsuperscriptBox["ta", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"..", "ib"}], ".."}], "ia"}], "..."}], 
   RowBox[{"...", "..."}]]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.56248363610526*^9, 
  3.562483738611123*^9}},ExpressionUUID->"a6682b5f-1477-418c-bf8b-\
9c22fda126a9"],

Cell[TextData[{
 "and it is said to be ",
 StyleBox["alternating (or antisymmetric) with respect to the indices ia, ib",
  
  FontColor->RGBColor[0, 0, 1]],
 ", if"
}], "Text",
 CellChangeTimes->{{3.5624837906841016`*^9, 3.5624838186707025`*^9}, {
   3.5624838890107255`*^9, 3.562483890066786*^9}, {3.5649229148211546`*^9, 
   3.5649229387005205`*^9}, 
   3.5650994860377054`*^9},ExpressionUUID->"8ac8cd21-216a-4512-9efd-\
13413f09d785"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["ta", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"..", "ia"}], ".."}], "ib"}], "..."}], 
   RowBox[{"...", "..."}]], " ", "\[Equal]", " ", 
  RowBox[{"-", " ", 
   SubsuperscriptBox["ta", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"..", "ib"}], ".."}], "ia"}], "..."}], 
    RowBox[{"...", "..."}]]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.56248363610526*^9, 
  3.5624837724250574`*^9}},ExpressionUUID->"67c2292e-272a-47ee-b2ab-\
2e5dfd36de17"],

Cell[TextData[{
 "for all indices 1 \[LessEqual] ia , ib \[LessEqual] dim, analogously for \
contravariant indices. This terminology can also be applied for subsets of \
index slots in the sense that they are valid for all pairs within the subset. \
 In particular, a covariant (resp. contravariant)  ",
 StyleBox["tensor is said to be symmetric resp. alternating (or \
antisymmetric) ",
  FontColor->RGBColor[0, 0, 1]],
 " if it has this property for all pairs of its index slots."
}], "Text",
 CellChangeTimes->{{3.562483915221225*^9, 3.562483927135906*^9}, {
   3.5624839799359264`*^9, 3.56248402266037*^9}, {3.562484319870369*^9, 
   3.562484361928775*^9}, {3.5624844409862967`*^9, 3.5624847360091715`*^9}, {
   3.5624870703317375`*^9, 3.5624871390916705`*^9}, {3.562487228566788*^9, 
   3.562487247100848*^9}, {3.562487357925187*^9, 3.562487388513937*^9}, 
   3.564471063945058*^9, 3.5649230144128513`*^9, 3.5649231291484137`*^9, {
   3.5649305585360327`*^9, 3.5649305737919054`*^9}, 3.565100098908759*^9, {
   3.603190301315008*^9, 3.603190302947101*^9}, {3.603190336923044*^9, 
   3.603190349713776*^9}, {3.6031903850267963`*^9, 
   3.603190410434249*^9}},ExpressionUUID->"2710d85d-1cb9-4fbf-a05a-\
c4718057b5c5"],

Cell["\<\
In tensalgv2.m are defined two operators, the symmetrization covsym and the \
alternation covalt, which act over the covariant indices and transform the \
tensor into a symmetric resp. antisymmetric tensor of the same type; the \
contravariant indices remain untouched. Furthermore we defined analogous \
operations for the contravariant indices, leaving the covariant indices \
untouched.\
\>", "Text",
 CellChangeTimes->{{3.5649306237757645`*^9, 3.5649308997355485`*^9}, {
   3.5651001527728405`*^9, 3.565100160148262*^9}, {3.565100377677704*^9, 
   3.565100419693107*^9}, {3.5651004521809654`*^9, 3.5651004709010363`*^9}, 
   3.565268568395429*^9, 3.6425014339716187`*^9, {3.6436080842216187`*^9, 
   3.643608090165229*^9}},ExpressionUUID->"b83e4b9a-8f4c-4db0-b1e6-\
8a9ececa3678"],

Cell[BoxData["dim"], "Input",
 CellChangeTimes->{{3.5651831637953844`*^9, 
  3.5651831729370003`*^9}},ExpressionUUID->"921b07a2-13ce-40f4-badf-\
533a5491252c"],

Cell[BoxData[
 RowBox[{"?", "covsym"}]], "Input",
 CellChangeTimes->{{3.5649206422845254`*^9, 3.5649207744791574`*^9}, {
  3.5650147542760363`*^9, 3.565014768282838*^9}, {3.5651001789033346`*^9, 
  3.56510019420621*^9}},ExpressionUUID->"32c30203-a3dd-47f1-a717-\
bd86463387b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covsym", "[", "tt_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ttp", ",", "k", ",", "h", ",", "dd", ",", "aa"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"Head", "[", "tt", "]"}], "===", " ", "tensor"}], "]"}], ",",
        " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Argument must be a tensor!\>\"", "]"}], 
        ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ttp", " ", "=", " ", 
      RowBox[{"type", "[", "tt", "]"}]}], ";", 
     RowBox[{"aa", "=", 
      RowBox[{"ttp", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"k", "=", 
      RowBox[{"ttp", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"h", "=", 
      RowBox[{"ttp", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", 
     RowBox[{"dd", "=", 
      RowBox[{"ttp", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"k", "\[Equal]", "0"}], ",", "tt", ",", 
       RowBox[{"tensor", "[", 
        RowBox[{
         RowBox[{"covs", "[", "aa", "]"}], ",", "k", ",", "h", ",", "dd"}], 
        "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5651656047643332`*^9, 3.565166068038347*^9}, {
   3.5651661903269615`*^9, 3.565166222587818*^9}, {3.5651663080135684`*^9, 
   3.5651664007401314`*^9}, {3.5651664503950186`*^9, 3.565166545180785*^9}, {
   3.5651838927814655`*^9, 3.5651839169303074`*^9}, {3.56518394706956*^9, 
   3.5651840544601493`*^9}, 3.565184105207038*^9, 3.565190141061654*^9, {
   3.565190192613603*^9, 3.565190218213067*^9}, 
   3.569212785431858*^9},ExpressionUUID->"d3b5ecaf-4a82-4fcb-8d2b-\
6890ad743284"],

Cell[BoxData[
 RowBox[{"?", "covs"}]], "Input",
 CellChangeTimes->{{3.565183975851611*^9, 
  3.5651839786440163`*^9}},ExpressionUUID->"07e7a4df-41e4-413e-992d-\
4fc91a760428"],

Cell[BoxData[
 RowBox[{"?", "contrasym"}]], "Input",
 CellChangeTimes->{{3.5649206422845254`*^9, 3.5649207744791574`*^9}, {
  3.5650147542760363`*^9, 3.565014768282838*^9}, {3.5650154250494027`*^9, 
  3.5650154649316835`*^9}, {3.5651002887596183`*^9, 
  3.56510029753412*^9}},ExpressionUUID->"3d3b8f74-a4a9-42ce-aa39-\
afc09c426dc0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"contrasym", "[", "tt_", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ttp", ",", " ", "k", ",", "h", ",", "dd", ",", "aa"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], " ", "===", "  ", "tensor"}], 
         "]"}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Argument must be a tensor!\>\"", "]"}], 
         ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"ttp", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"aa", " ", "=", " ", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "\[Equal]", "0"}], ")"}], ",", " ", "tt", ",", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"contras", "[", "aa", "]"}], ",", "k", ",", "h", ",", 
          "dd"}], "]"}]}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5647232160439234`*^9, 3.564723292686858*^9}, {
   3.564723329456123*^9, 3.5647233572865715`*^9}, {3.5647233908266306`*^9, 
   3.56472362958505*^9}, {3.5647236685539184`*^9, 3.564723683202344*^9}, {
   3.5647237368508387`*^9, 3.5647237954289417`*^9}, {3.5647238358174124`*^9, 
   3.5647238655354643`*^9}, {3.5647239931124887`*^9, 
   3.5647240101789184`*^9}, {3.564724072360628*^9, 3.5647240768378353`*^9}, {
   3.5647241692367983`*^9, 3.5647243689047995`*^9}, {3.5647244262037*^9, 
   3.564724504473547*^9}, {3.564724536406803*^9, 3.564724632424972*^9}, {
   3.5647247028902955`*^9, 3.5647247231547313`*^9}, 3.564724923615083*^9, {
   3.564725166839796*^9, 3.564725251442599*^9}, {3.564725287790663*^9, 
   3.56472530339069*^9}, {3.564725353248378*^9, 3.564725397837722*^9}, 
   3.564725430270179*^9, 3.5647254999867015`*^9, {3.5647256469225874`*^9, 
   3.564725713290561*^9}, {3.564726079791206*^9, 3.5647260934256296`*^9}, {
   3.564838135958783*^9, 3.564838157822033*^9}, {3.5649313709955025`*^9, 
   3.564931399164114*^9}, {3.564931437196289*^9, 3.5649314670609975`*^9}, {
   3.5649323453652334`*^9, 3.564932349723483*^9}, {3.564932381174282*^9, 
   3.5649323855535326`*^9}, {3.5649324353963833`*^9, 
   3.5649324958108387`*^9}, {3.564932582795814*^9, 3.5649325852029514`*^9}, {
   3.5650015986852026`*^9, 3.565001622444044*^9}, {3.5650016830969505`*^9, 
   3.5650019870166845`*^9}, {3.5650020345187683`*^9, 
   3.5650020565148067`*^9}, {3.565002294196824*^9, 3.565002306567646*^9}, {
   3.5650048003448267`*^9, 3.565004841076498*^9}, {3.565004871980152*^9, 
   3.5650049399494715`*^9}, 3.5650050455460567`*^9, {3.565015481193614*^9, 
   3.5650155708917446`*^9}, 3.5651003322941084`*^9, 3.565102972500707*^9, 
   3.5651030029804506`*^9},ExpressionUUID->"fc86a283-d47c-498c-8095-\
15f77017356a"],

Cell[BoxData[
 RowBox[{"?", "contras"}]], "Input",
 CellChangeTimes->{{3.5692145891382265`*^9, 
  3.569214598077042*^9}},ExpressionUUID->"42da56fa-117a-4672-8325-\
36a5ecc3eabe"],

Cell["Here are the definitions of the alternations:", "Text",
 CellChangeTimes->{{3.565100725228583*^9, 
  3.5651007593725357`*^9}},ExpressionUUID->"5ed79c40-1c8b-44ca-93ec-\
9d9ff0029b0f"],

Cell[BoxData[
 RowBox[{"?", "covalt"}]], "Input",
 CellChangeTimes->{{3.5649206422845254`*^9, 3.5649207744791574`*^9}, {
   3.5649208146556726`*^9, 3.5649208442995443`*^9}, {3.5649310085377717`*^9, 
   3.5649310298529906`*^9}, 3.5649310746005497`*^9, {3.565014920028517*^9, 
   3.565014931427169*^9}, {3.56510063164723*^9, 
   3.565100638486622*^9}},ExpressionUUID->"767bfedc-53f2-412e-bbc3-\
8aa466a65eed"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"covalt", "[", "tt_", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ttp", ",", " ", "k", ",", "h", ",", "dd", ",", "aa"}], "}"}], 
     ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], " ", "===", "  ", "tensor"}], 
         "]"}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Argument must be a tensor!\>\"", "]"}], 
         ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"ttp", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", " ", 
      RowBox[{"aa", " ", "=", " ", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"k", ">", "dd"}], ",", " ", 
        RowBox[{"Return", "[", 
         RowBox[{"nulltensor", "[", 
          RowBox[{"k", ",", "h", ",", "dd"}], "]"}], "]"}]}], "]"}], ";", 
      "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "<=", "1"}], ")"}], ",", " ", "tt", ",", 
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"cova", "[", 
           RowBox[{"aa", ",", "dd"}], "]"}], ",", "k", ",", "h", ",", "dd"}], 
         "]"}]}], "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"covalt", "/:", " ", 
   RowBox[{"covalt", "[", 
    RowBox[{"times", "[", 
     RowBox[{"c_", ",", "a_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"times", "[", 
    RowBox[{"c", ",", 
     RowBox[{"covalt", "[", "a", "]"}]}], "]"}]}], ";"}], "\n"}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5647232160439234`*^9, 3.564723292686858*^9}, {
   3.564723329456123*^9, 3.5647233572865715`*^9}, {3.5647233908266306`*^9, 
   3.56472362958505*^9}, {3.5647236685539184`*^9, 3.564723683202344*^9}, {
   3.5647237368508387`*^9, 3.5647237954289417`*^9}, {3.5647238358174124`*^9, 
   3.5647238655354643`*^9}, {3.5647239931124887`*^9, 
   3.5647240101789184`*^9}, {3.564724072360628*^9, 3.5647240768378353`*^9}, {
   3.5647241692367983`*^9, 3.5647243689047995`*^9}, {3.5647244262037*^9, 
   3.564724504473547*^9}, {3.564724536406803*^9, 3.564724632424972*^9}, {
   3.5647247028902955`*^9, 3.5647247231547313`*^9}, 3.564724923615083*^9, {
   3.564725166839796*^9, 3.564725251442599*^9}, {3.564725287790663*^9, 
   3.56472530339069*^9}, {3.564725353248378*^9, 3.564725397837722*^9}, 
   3.564725430270179*^9, 3.5647254999867015`*^9, {3.5647256469225874`*^9, 
   3.564725713290561*^9}, {3.564726079791206*^9, 3.5647260934256296`*^9}, {
   3.564838135958783*^9, 3.564838157822033*^9}, {3.5649313709955025`*^9, 
   3.564931399164114*^9}, {3.564931437196289*^9, 3.5649314670609975`*^9}, {
   3.5649323453652334`*^9, 3.564932349723483*^9}, {3.564932381174282*^9, 
   3.5649323855535326`*^9}, {3.5649324353963833`*^9, 
   3.5649324958108387`*^9}, {3.564932582795814*^9, 3.5649325852029514`*^9}, {
   3.5650015986852026`*^9, 3.565001622444044*^9}, {3.5650016830969505`*^9, 
   3.5650019870166845`*^9}, {3.5650020345187683`*^9, 
   3.5650020565148067`*^9}, {3.565002294196824*^9, 3.565002306567646*^9}, {
   3.5650048003448267`*^9, 3.565004841076498*^9}, {3.565004871980152*^9, 
   3.5650049399494715`*^9}, 3.5650050455460567`*^9, {3.5650118181798725`*^9, 
   3.565011819371734*^9}, 3.5650118753597546`*^9, 3.5650170141222925`*^9, {
   3.5650171868681726`*^9, 3.565017195812684*^9}, 3.5650692869842787`*^9, 
   3.5651861461471586`*^9, 3.5657909336679354`*^9, 
   3.64413026112711*^9},ExpressionUUID->"81bb2147-71b8-4d62-9afc-\
8914fb00aa01"],

Cell[BoxData[
 RowBox[{"?", "cova"}]], "Input",
 CellChangeTimes->{{3.5692147588665247`*^9, 
  3.569214761159728*^9}},ExpressionUUID->"69dc4e87-f0c3-4d99-9044-\
d7bcaba6967a"],

Cell[BoxData[
 RowBox[{"?", "contralt"}]], "Input",
 CellChangeTimes->{{3.5649206422845254`*^9, 3.5649207744791574`*^9}, {
   3.5649208146556726`*^9, 3.5649208442995443`*^9}, {3.5649310085377717`*^9, 
   3.5649310298529906`*^9}, 3.5649310746005497`*^9, {3.565014920028517*^9, 
   3.565014931427169*^9}, {3.5650169406170883`*^9, 3.565016984043572*^9}, {
   3.5651006489912224`*^9, 3.565100656222636*^9}, {3.565100782421854*^9, 
   3.5651007849259973`*^9}},ExpressionUUID->"e851a13a-0175-43bd-a4a0-\
19f8bc987141"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"contralt", "[", "tt_", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ttp", ",", " ", "k", ",", "h", ",", "dd", ",", "aa"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], " ", "===", "  ", "tensor"}], 
         "]"}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Argument must be a tensor!\>\"", "]"}], 
         ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"ttp", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", " ", 
      RowBox[{"aa", " ", "=", " ", 
       RowBox[{"ttp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"h", ">", "dd"}], ",", 
        RowBox[{"Return", "[", 
         RowBox[{"nulltensor", "[", 
          RowBox[{"k", ",", "h", ",", "dd"}], "]"}], "]"}]}], "]"}], ";", 
      "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "\[LessEqual]", " ", "1"}], ")"}], ",", " ", "tt", ",", 
        
        RowBox[{"tensor", "[", 
         RowBox[{
          RowBox[{"contra", "[", "aa", "]"}], ",", "k", ",", "h", ",", "dd"}],
          "]"}]}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5647232160439234`*^9, 3.564723292686858*^9}, {
   3.564723329456123*^9, 3.5647233572865715`*^9}, {3.5647233908266306`*^9, 
   3.56472362958505*^9}, {3.5647236685539184`*^9, 3.564723683202344*^9}, {
   3.5647237368508387`*^9, 3.5647237954289417`*^9}, {3.5647238358174124`*^9, 
   3.5647238655354643`*^9}, {3.5647239931124887`*^9, 
   3.5647240101789184`*^9}, {3.564724072360628*^9, 3.5647240768378353`*^9}, {
   3.5647241692367983`*^9, 3.5647243689047995`*^9}, {3.5647244262037*^9, 
   3.564724504473547*^9}, {3.564724536406803*^9, 3.564724632424972*^9}, {
   3.5647247028902955`*^9, 3.5647247231547313`*^9}, 3.564724923615083*^9, {
   3.564725166839796*^9, 3.564725251442599*^9}, {3.564725287790663*^9, 
   3.56472530339069*^9}, {3.564725353248378*^9, 3.564725397837722*^9}, 
   3.564725430270179*^9, 3.5647254999867015`*^9, {3.5647256469225874`*^9, 
   3.564725713290561*^9}, {3.564726079791206*^9, 3.5647260934256296`*^9}, {
   3.564838135958783*^9, 3.564838157822033*^9}, {3.5649313709955025`*^9, 
   3.564931399164114*^9}, {3.564931437196289*^9, 3.5649314670609975`*^9}, {
   3.5649323453652334`*^9, 3.564932349723483*^9}, {3.564932381174282*^9, 
   3.5649323855535326`*^9}, {3.5649324353963833`*^9, 
   3.5649324958108387`*^9}, {3.564932582795814*^9, 3.5649325852029514`*^9}, {
   3.5650015986852026`*^9, 3.565001622444044*^9}, {3.5650016830969505`*^9, 
   3.5650019870166845`*^9}, {3.5650020345187683`*^9, 
   3.5650020565148067`*^9}, {3.565002294196824*^9, 3.565002306567646*^9}, {
   3.5650048003448267`*^9, 3.565004841076498*^9}, {3.565004871980152*^9, 
   3.5650049399494715`*^9}, 3.5650050455460567`*^9, {3.5650118181798725`*^9, 
   3.565011819371734*^9}, 3.5650118753597546`*^9, {3.5650170141222925`*^9, 
   3.5650170938848543`*^9}, {3.565017217660934*^9, 3.565017231292714*^9}, 
   3.565069292718607*^9, 3.565186146150159*^9, 
   3.565790976692811*^9},ExpressionUUID->"28b6240e-f91b-4590-add9-\
dcd76db7a94d"],

Cell[BoxData[
 RowBox[{"?", "contra"}]], "Input",
 CellChangeTimes->{{3.569214785932572*^9, 
  3.5692147886001763`*^9}},ExpressionUUID->"26e677c9-8072-4be7-a7cf-\
4daa4117f95d"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3.4. Linearity of the Symmetry Operations", "Subsubsection",
 CellChangeTimes->{{3.565100585020563*^9, 3.565100597644285*^9}, {
   3.5692156232328424`*^9, 3.5692156306740556`*^9}, {3.569215666565477*^9, 
   3.5692156883577237`*^9}, {3.641269703715252*^9, 3.641269705556055*^9}, 
   3.6436083200626345`*^9, 
   3.64360950819493*^9},ExpressionUUID->"a0f9394b-06af-4303-8f78-\
bfe46ae0fc99"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "4"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "3", ",", "2"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.565164302988847*^9, 3.565164329368493*^9}, {
  3.6441316851317863`*^9, 
  3.644131692216199*^9}},ExpressionUUID->"4dcb6ef3-92fd-4cb9-902f-\
ef43411232ca"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "3", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565164302988847*^9, 3.565164329368493*^9}, {
  3.566369835814233*^9, 
  3.566369846157051*^9}},ExpressionUUID->"adf9ab26-9403-4952-ae71-\
14b3e53e12bd"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"ta", "+", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.6031914516738043`*^9, 
  3.6031914636664906`*^9}},ExpressionUUID->"7e7707e8-8b94-4820-b193-\
ff6d98517539"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"covsym", "[", 
    RowBox[{"ta", " ", "+", " ", "tb"}], "]"}], " ", "-", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"covsym", "[", "ta", "]"}], "+", 
     RowBox[{"covsym", "[", "tb", "]"}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5663698533642635`*^9, 3.5663698658598857`*^9}, {
  3.569215204621707*^9, 3.5692152338249583`*^9}, {3.5692152739794292`*^9, 
  3.569215277364635*^9}, {3.5692153319959307`*^9, 3.56921534856316*^9}, {
  3.603190945508854*^9, 
  3.6031909537973275`*^9}},ExpressionUUID->"6ed2c589-1ee1-4e79-a20e-\
4f25dd2082dc"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"41230f7e-521a-41f1-8a9b-\
9ce3b5901eef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contrasym", "[", "ta", "]"}], "+", 
  RowBox[{"contrasym", "[", "tb", "]"}], "-", 
  RowBox[{"contrasym", "[", 
   RowBox[{"ta", " ", "+", " ", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.569215431586506*^9, 
  3.5692154513205404`*^9}},ExpressionUUID->"16f32745-bc9b-49c0-835c-\
9781b656a915"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"acb78859-0fa8-473b-8d14-\
ef471299625e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covalt", "[", 
   RowBox[{"ta", " ", "+", " ", "tb"}], "]"}], " ", "-", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"covalt", "[", "ta", "]"}], "+", 
    RowBox[{"covalt", "[", "tb", "]"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.5663698533642635`*^9, 3.5663698658598857`*^9}, {
  3.569215204621707*^9, 3.5692152338249583`*^9}, {3.5692152739794292`*^9, 
  3.569215277364635*^9}},ExpressionUUID->"f32787c0-7ee5-4097-a68f-\
87b82e0e3e7c"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"988e8c08-f008-4a5e-9652-\
f2315ccf1568"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contralt", "[", "ta", "]"}], "+", 
  RowBox[{"contralt", "[", "tb", "]"}], "-", 
  RowBox[{"contralt", "[", 
   RowBox[{"ta", " ", "+", " ", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.566375353197524*^9, 
  3.566375387345984*^9}},ExpressionUUID->"970dcb8a-3290-4023-9d58-\
52f57dc7b106"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"b4c36b91-fa10-4370-98e3-\
70ad8ce6fb31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covsym", "[", 
   RowBox[{"c", "*", "ta"}], "]"}], " ", "-", 
  RowBox[{"c", "*", 
   RowBox[{"covsym", "[", "ta", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.566375112910302*^9, 
  3.5663751568555794`*^9}},ExpressionUUID->"248ca681-915f-454c-a23a-\
06e5ca1cf199"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"adf73d8c-41a2-4330-a4a3-\
05946d5ea51e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contrasym", "[", 
   RowBox[{"c", "*", "ta"}], "]"}], " ", "-", 
  RowBox[{"c", "*", 
   RowBox[{"contrasym", "[", "ta", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.566375112910302*^9, 3.5663751568555794`*^9}, {
  3.566375268333375*^9, 
  3.566375292185817*^9}},ExpressionUUID->"6bca3c5c-f659-4cd1-8967-\
5bdcaae1f9ad"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"a9b31b3e-da17-4aec-be84-\
21b562cd7885"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covalt", "[", 
   RowBox[{"c", "*", "ta"}], "]"}], " ", "-", " ", 
  RowBox[{"c", "*", 
   RowBox[{"covalt", "[", "ta", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5663699713316708`*^9, 3.566369980660487*^9}, {
  3.5663722717741117`*^9, 3.5663722973269567`*^9}, {3.566373576167203*^9, 
  3.5663735811280117`*^9}},ExpressionUUID->"724404a0-6ad5-42d3-a479-\
e9cd866af7b8"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"94635341-e124-42ad-ad2d-\
5f4172b73e5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contralt", "[", 
   RowBox[{"c", "*", "ta"}], "]"}], " ", "-", " ", 
  RowBox[{"c", "*", 
   RowBox[{"contralt", "[", "ta", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5663699713316708`*^9, 3.566369980660487*^9}, {
  3.5663722717741117`*^9, 3.5663722973269567`*^9}, {3.566373576167203*^9, 
  3.5663735811280117`*^9}, {3.5663753991084046`*^9, 
  3.566375415472833*^9}},ExpressionUUID->"c5a458de-f299-404e-9be9-\
8f4f2f437940"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6031908789670477`*^9, 
  3.603190921900503*^9}},ExpressionUUID->"e68646c3-dd33-4ce9-be4e-\
330043931659"],

Cell[TextData[{
 "We conclude\n",
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 ". The maps covsym, contrasym, covalt, contralt are linear maps of the \
tensor spaces of type (k,h) into themselves. "
}], "Text",
 CellChangeTimes->{{3.566375469324128*^9, 3.5663755994127564`*^9}, 
   3.6436085738134813`*^9},ExpressionUUID->"0427f931-5468-41f7-a625-\
61ac2c5bcb6d"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3.5. Iteration of the Symmetry Operations", "Subsubsection",
 CellChangeTimes->{{3.569215707893841*^9, 3.5692157507572927`*^9}, {
   3.6412697145728707`*^9, 3.641269716850475*^9}, 3.643609514606541*^9, 
   3.6436113239277325`*^9},ExpressionUUID->"4115ad96-295a-4578-bdf6-\
3a6207186fcf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.569339167905521*^9, 3.569339168562558*^9}, {
  3.569389725905221*^9, 
  3.5693897595700808`*^9}},ExpressionUUID->"6c23ed80-0d9a-4e73-834e-\
7e5a3b6eff86"],

Cell[BoxData[
 RowBox[{"ta", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "3", ",", "2", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5693348337869596`*^9, 3.569334834208161*^9}, {
   3.5693359652413473`*^9, 3.5693359834153795`*^9}, 3.5693363935056996`*^9, 
   3.56933643955698*^9, {3.569336982812335*^9, 
   3.569336987726343*^9}},ExpressionUUID->"ee7eb2ac-5c66-4b0b-8338-\
4f3022dd3023"],

Cell[BoxData[
 RowBox[{"taa", " ", "=", 
  RowBox[{"covalt", "[", 
   RowBox[{"covalt", "[", "ta", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5663999239983487`*^9, 
  3.5663999734348354`*^9}},ExpressionUUID->"0b20811a-e8b8-4c91-bd9a-\
7a4aea0989ce"],

Cell[BoxData[
 RowBox[{"taa", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5693364988526845`*^9, 3.5693365241403294`*^9}, {
  3.5693370144959908`*^9, 
  3.569337015400792*^9}},ExpressionUUID->"34389050-670a-4216-b5e8-\
48cc3bedb202"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"taa", ",", 
   RowBox[{"6", "*", 
    RowBox[{"covalt", "[", "ta", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5693349132066994`*^9, 3.569334977213612*^9}, {
  3.5693350424061265`*^9, 3.569335051781743*^9}, {3.5693355531666236`*^9, 
  3.5693355607170367`*^9}, {3.569337043808442*^9, 
  3.569337047349648*^9}},ExpressionUUID->"e1a808c0-943e-4f0d-a532-\
273d58fe54e7"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", " ", 
  RowBox[{"contralt", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{
  3.5664002979106474`*^9},ExpressionUUID->"f198e820-2c5d-470f-99f7-\
a69d70292062"],

Cell[BoxData[
 RowBox[{"tbb", " ", "=", " ", 
  RowBox[{"contralt", "[", "tb", "]"}]}]], "Input",
 CellChangeTimes->{{3.566400203202881*^9, 3.5664002212053127`*^9}, 
   3.566400313261074*^9},ExpressionUUID->"dece4f33-12d0-4631-9525-\
1b63427721d8"],

Cell[BoxData[
 RowBox[{"Simplify", "[", " ", 
  RowBox[{
   RowBox[{"tbb", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "-", 
   RowBox[{"2", 
    RowBox[{"tb", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.566400229816528*^9, 3.5664002591133795`*^9}, {
  3.5664003470507336`*^9, 
  3.5664003805751925`*^9}},ExpressionUUID->"7012318b-83ba-44ee-8b0d-\
e2a6540f584c"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tbb", ",", 
   RowBox[{"2", "*", "tb"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5693372403375874`*^9, 
  3.5693372540344114`*^9}},ExpressionUUID->"7564c02d-14ad-46ae-97b3-\
d7fd709f330a"],

Cell[TextData[{
 StyleBox["Immediately from the definitions it follows",
  FontColor->GrayLevel[0]],
 StyleBox["\nLemma.",
  FontColor->RGBColor[0, 0, 1]],
 " For the symmetrization and alternation the following formulas are valid"
}], "Text",
 CellChangeTimes->{{3.5664010243940096`*^9, 3.5664010655468817`*^9}, {
  3.566401459572564*^9, 3.5664014603369656`*^9}, {3.569211838385395*^9, 
  3.5692118414898005`*^9}, {3.569216059277939*^9, 3.5692160694455204`*^9}, {
  3.569216117117247*^9, 
  3.5692161397335405`*^9}},ExpressionUUID->"0839fef5-f100-4df4-a030-\
f8d7a9fcbd82"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covsym", "[", 
   RowBox[{"covsym", "[", "ta", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"k", "!"}], "*", 
   RowBox[{"covsym", "[", "ta", "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.566401073846096*^9, 3.5664012098987894`*^9}, 
   3.643610522156118*^9},ExpressionUUID->"852d9c8c-7fce-4a8b-8caa-\
74205c358ae4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covalt", "[", 
   RowBox[{"covalt", "[", "ta", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"k", "!"}], "*", 
   RowBox[{"covalt", "[", "ta", "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5664012203508077`*^9, 3.5664012572503386`*^9}, 
   3.64361054014495*^9, {3.6440696743088875`*^9, 
   3.6440696853069067`*^9}},ExpressionUUID->"0729f71a-9c2b-4fae-8688-\
f85ebbfa47a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contrasym", "[", 
   RowBox[{"contrasym", "[", "ta", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"h", "!"}], "*", 
   RowBox[{"contrasym", "[", "ta", "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5664012875455914`*^9, 3.566401333284872*^9}, 
   3.6436105503649673`*^9},ExpressionUUID->"e9315e7f-499e-4e15-a5df-\
7f29dfd99913"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contralt", "[", 
   RowBox[{"contralt", "[", "ta", "]"}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   RowBox[{"h", "!"}], "*", 
   RowBox[{"contralt", "[", "ta", "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5664013676829324`*^9, 3.566401395674852*^9}, {
  3.6436105622521887`*^9, 
  3.643610569303401*^9}},ExpressionUUID->"389ea15c-2e03-498c-a326-\
b9a145797c31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covsym", "[", 
   RowBox[{"covalt", "[", "ta", "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"k", ",", "h"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6436101534296675`*^9, 3.643610158140876*^9}, {
  3.6436101933385377`*^9, 
  3.64361020564036*^9}},ExpressionUUID->"dcc8279c-04e7-4260-a916-\
ee6c5f163916"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covalt", "[", 
   RowBox[{"covsym", "[", "ta", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"k", ",", "h"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.6436102446776285`*^9},ExpressionUUID->"facb2a10-ae96-48a5-8b8f-\
ee3877f1c33f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contrasym", "[", 
   RowBox[{"contralt", "[", "ta", "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"k", ",", "h"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6436101534296675`*^9, 3.643610158140876*^9}, {
  3.6436101933385377`*^9, 3.64361020564036*^9}, {3.6436106946324215`*^9, 
  3.6436107110632505`*^9}},ExpressionUUID->"026f3ff3-5b85-45bd-a7a5-\
8810607345c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contralt", "[", 
   RowBox[{"contrasym", "[", "ta", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"nulltensor", "[", 
   RowBox[{"k", ",", "h"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{
  3.6436102446776285`*^9, {3.6436106991876297`*^9, 
   3.6436107172252617`*^9}},ExpressionUUID->"3f011cd5-981c-475f-af01-\
3c7d40da42b9"],

Cell["\<\
where {k,h} =type[ta][[2]].  The sign == in these equations means that the \
tensors of both sides have the same coordinates. \[FilledSmallSquare]\
\>", "Text",
 CellChangeTimes->{{3.643610310595745*^9, 
  3.643610450840392*^9}},ExpressionUUID->"ff7a2000-05bb-4261-88fc-\
9653f1b789f5"],

Cell["\<\
We control yet the last four  identities. In the covariant case: \
\>", "Text",
 CellChangeTimes->{{3.6436107384568987`*^9, 
  3.6436108056688175`*^9}},ExpressionUUID->"53a2f6fb-d559-4dce-bcae-\
860a54f4c199"],

Cell[BoxData[
 RowBox[{"taa", "=", 
  RowBox[{"covsym", "[", 
   RowBox[{"covalt", "[", "ta", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6436097294851203`*^9, 3.64360976326318*^9}, {
  3.6436098634253564`*^9, 
  3.6436098654533596`*^9}},ExpressionUUID->"28eb8435-5d40-42d8-af44-\
a768b0dc35bd"],

Cell[BoxData[
 RowBox[{"taa", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6436097836076155`*^9, 3.6436098480105295`*^9}, {
  3.643609878058182*^9, 
  3.6436098788381834`*^9}},ExpressionUUID->"18076bfb-dfe5-4217-8ac0-\
c22eab2afbfe"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"taa", ",", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6436099001206207`*^9, 
  3.6436099292644725`*^9}},ExpressionUUID->"e93f4afc-3560-44ee-bb41-\
95c9845d1f15"],

Cell[BoxData[
 RowBox[{"taa", "=", 
  RowBox[{"covalt", "[", 
   RowBox[{"covsym", "[", "ta", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6436097294851203`*^9, 3.64360976326318*^9}, {
  3.6436098634253564`*^9, 3.6436098654533596`*^9}, {3.643610000032197*^9, 
  3.643610011217417*^9}},ExpressionUUID->"f031cd6a-2d4d-45fc-8bd2-\
c294a8149642"],

Cell[BoxData[
 RowBox[{"taa", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6436097836076155`*^9, 3.6436098480105295`*^9}, {
  3.643609878058182*^9, 
  3.6436098788381834`*^9}},ExpressionUUID->"7cad1603-2326-4a49-9125-\
a2e3fbfd3aa8"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"taa", ",", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"3", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6436099001206207`*^9, 
  3.6436099292644725`*^9}},ExpressionUUID->"ebd0443c-f558-4049-8c13-\
845cc65cefb5"],

Cell["The contravariant case gives the stated results analogously.", "Text",
 CellChangeTimes->{{3.643610839805479*^9, 3.6436108736771393`*^9}, 
   3.644588166793532*^9},ExpressionUUID->"f229f2d4-d9bb-4aff-a910-\
083204926522"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"ta", ",", "taa"}], "]"}]], "Input",
 CellChangeTimes->{{3.6436112387561827`*^9, 
  3.6436112506464033`*^9}},ExpressionUUID->"115b3f40-fc33-492b-a360-\
1d41e93ca165"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4.4. Exterior Algebra", "Subsection",
 CellChangeTimes->{{3.554617091502396*^9, 3.5546171144656363`*^9}, {
   3.5558545280387516`*^9, 3.5558545305408945`*^9}, 3.5559015238277683`*^9, {
   3.5590332480904675`*^9, 3.559033276675102*^9}, 3.5617896958568087`*^9, 
   3.5653314315134597`*^9, {3.5655939738907795`*^9, 3.5655939785863876`*^9}, {
   3.5655949568196597`*^9, 3.565594967947296*^9}, {3.565621757053866*^9, 
   3.565621776171959*^9}, 3.565850574669919*^9, 3.566313667702919*^9, 
   3.603193246588468*^9, 3.6036017246450176`*^9, 
   3.6417951084650135`*^9},ExpressionUUID->"e93c5af2-2e2b-4601-9ba2-\
c2f9979c7513"],

Cell[CellGroupData[{

Cell["4.4.1. Introduction", "Subsubsection",
 CellChangeTimes->{{3.566275206885929*^9, 3.5662752197871513`*^9}, 
   3.6417951092918143`*^9, 3.643613451617482*^9, 
   3.643809564660956*^9},ExpressionUUID->"907efa08-902a-437f-80c8-\
de3a5ac2e483"],

Cell[TextData[{
 "The antisymmetric (or the symmetric) tensors of type (p,0) and of type \
(0,p) over the same d-dimensional vector space form subspaces of the spaces \
of tensors of the same type.  In the following we discuss the antisymmetric \
covariant tensors. The concepts can be applied to the antisymmetric \
contravariant tensors as well. The components of the tensors are assumed to \
belong to a field  K of characteristic zero, mostly the field of complex, \
real or rational numbers.  Let V denote a given vector space of dimension dim \
over K, V\.b4 its dual. Then denote by ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "p"], TraditionalForm]],ExpressionUUID->
  "bb153726-8780-4e4a-8b6c-d88500998ab3"],
 " V\.b4    the subspace of alternating tensors of type (p,0) over V; its \
elements are called ",
 StyleBox["p-forms",
  FontColor->RGBColor[0, 0, 1]],
 ". Analogously   ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "p"], TraditionalForm]],ExpressionUUID->
  "9c6ae65c-8b91-4683-a4f0-66e0f89a174c"],
 " V denotes the space of alternating tensors of type (0,p) over V; its \
elements are named ",
 StyleBox["p-vectors",
  FontColor->RGBColor[0, 0, 1]],
 ". Clearly we have"
}], "Text",
 CellChangeTimes->{{3.5656225306763377`*^9, 3.565622895763211*^9}, {
   3.5656229430936937`*^9, 3.565623119608004*^9}, {3.5656231726792974`*^9, 
   3.56562319695294*^9}, {3.5656232573979173`*^9, 3.5656233608615537`*^9}, {
   3.5656234119360437`*^9, 3.5656234119516435`*^9}, {3.5656234501717105`*^9, 
   3.565623690490133*^9}, {3.565791180257569*^9, 3.565791189461585*^9}, {
   3.565791249802491*^9, 3.56579126056651*^9}, {3.565791290877363*^9, 
   3.5657914347096157`*^9}, {3.5657915199013653`*^9, 3.565791633703565*^9}, {
   3.565791671112431*^9, 3.5657916869932585`*^9}, {3.5657917956630497`*^9, 
   3.565791828204707*^9}, {3.565791917546064*^9, 3.5657919285908833`*^9}, {
   3.5657919658905487`*^9, 3.5657920468546906`*^9}, {3.565792087445962*^9, 
   3.5657921112204037`*^9}, 3.565792710386256*^9, {3.5658500294139605`*^9, 
   3.5658500325495663`*^9}, {3.6410977986826887`*^9, 3.641097801459493*^9}, {
   3.643809261692824*^9, 3.643809289086472*^9}, 
   3.644588266572041*^9},ExpressionUUID->"8bdebcef-68e8-4f1f-9cfe-\
a6c13eb3be19"],

Cell[TextData[{
 " ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "0"], TraditionalForm]],ExpressionUUID->
  "c55aec96-ce87-4c95-bdf5-ba1c16841fb2"],
 " V == ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "0"], TraditionalForm]],ExpressionUUID->
  "2df83905-21dc-411a-b523-8e45683be45f"],
 " V\.b4 == K; ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "1"], TraditionalForm]],ExpressionUUID->
  "5c4821a8-325f-44b4-8f27-fd73cff3e1dd"],
 " V == V;  ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "1"], TraditionalForm]],ExpressionUUID->
  "0358586b-ba99-4765-9929-3e44905fa2d5"],
 " V\.b4 == V\.b4; \n  ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "p"], TraditionalForm]],ExpressionUUID->
  "c4d60395-6563-49fc-ab4f-ae629a699361"],
 " V == 0  and   ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[And]", "p"], TraditionalForm]],ExpressionUUID->
  "e9cce8b7-7614-44c5-af6f-654bac941d90"],
 " V\.b4 == 0 for p > dimension[V].                                           \
 (1)"
}], "Text",
 CellChangeTimes->{{3.5656225306763377`*^9, 3.565622895763211*^9}, {
   3.5656229430936937`*^9, 3.565623119608004*^9}, {3.5656231726792974`*^9, 
   3.56562319695294*^9}, {3.5656232573979173`*^9, 3.5656233608615537`*^9}, {
   3.5656234119360437`*^9, 3.5656234119516435`*^9}, {3.5656234501717105`*^9, 
   3.565623690490133*^9}, {3.565791180257569*^9, 3.565791189461585*^9}, {
   3.565791249802491*^9, 3.56579126056651*^9}, {3.565791290877363*^9, 
   3.5657914347096157`*^9}, {3.5657915199013653`*^9, 3.565791633703565*^9}, {
   3.565791671112431*^9, 3.5657916869932585`*^9}, {3.5657917956630497`*^9, 
   3.565791828204707*^9}, {3.565791917546064*^9, 3.5657919285908833`*^9}, {
   3.5657919658905487`*^9, 3.5657920468546906`*^9}, {3.565792087445962*^9, 
   3.5657921112204037`*^9}, {3.565792710386256*^9, 3.565792763005149*^9}, 
   3.6397479925798297`*^9},ExpressionUUID->"84f49a51-eb45-4f6d-a5af-\
99c48ef1d9ff"],

Cell["\<\
Here 0 stands for the corresponding nulltensor.  Obviously, the tensor \
product of two symmetric or antisymmetric tensors needs not to have the same \
property.  Let us consider the direct sum of vector spaces \
\>", "Text",
 CellChangeTimes->{{3.5656225306763377`*^9, 3.565622895763211*^9}, {
  3.5656229430936937`*^9, 3.565623119608004*^9}, {3.5656231726792974`*^9, 
  3.56562319695294*^9}, {3.5656232573979173`*^9, 3.5656233608615537`*^9}, {
  3.5656234119360437`*^9, 3.5656234119516435`*^9}, {3.5656234501717105`*^9, 
  3.565623690490133*^9}, {3.565791180257569*^9, 3.565791189461585*^9}, {
  3.565791249802491*^9, 3.56579126056651*^9}, {3.565791290877363*^9, 
  3.5657914347096157`*^9}, {3.5657915199013653`*^9, 3.565791633703565*^9}, {
  3.565791671112431*^9, 3.5657916869932585`*^9}, {3.5657917956630497`*^9, 
  3.565791828204707*^9}, {3.565791917546064*^9, 3.5657919285908833`*^9}, {
  3.5657919658905487`*^9, 3.5657920468546906`*^9}, {3.565792087445962*^9, 
  3.5657921112204037`*^9}, {3.565792710386256*^9, 
  3.565792745564318*^9}},ExpressionUUID->"24f87eea-6f77-4dd8-861b-\
a1ac83f2fb99"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     FormBox["\[And]",
      TraditionalForm], " ", "V\.b4"}], ":=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"K", "\[CirclePlus]", "V\.b4", "\[CirclePlus]"}], " ", 
           FormBox[
            OverscriptBox["\[And]", "2"],
            TraditionalForm], 
           RowBox[{"V\.b4", "\[CirclePlus]"}]}], ".."}], "\[CirclePlus]"}], 
        " ", 
        FormBox[
         OverscriptBox["\[And]", "p"],
         TraditionalForm], 
        RowBox[{"V\.b4", "\[CirclePlus]"}]}], "..."}], "\[CirclePlus]"}], " ", 
     FormBox[
      OverscriptBox["\[And]", "d"],
      TraditionalForm], "V\.b4"}]}], ",", 
   RowBox[{"d", "=", " ", 
    RowBox[{
     RowBox[{"dimension", "[", "V", "]"}], ".", 
     "                                                                        \
                     ", 
     RowBox[{"(", "2", ")"}], "            "}]}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5657921461332655`*^9, 3.5657921767249193`*^9}, {
   3.5657922185641923`*^9, 3.5657923146759615`*^9}, {3.5657923599784408`*^9, 
   3.5657924274953594`*^9}, {3.5657927856407886`*^9, 3.565792829820066*^9}, {
   3.5657928851845636`*^9, 3.5657928864793653`*^9}, 3.5657943310053463`*^9, {
   3.6445602065009537`*^9, 
   3.644560316059946*^9}},ExpressionUUID->"2b54311a-f56b-4958-9988-\
6aaa2c1c8416"],

Cell[TextData[{
 "Termwise addition  and multiplication with elements of K gives \[And] V \
\.b4 the structure of a finite dimensional vector space over K. Using strict \
coordinates we proved in Subsection ",
 ButtonBox["4.2.2",
  BaseStyle->"Hyperlink",
  ButtonData->"wtstb"]
}], "Text",
 CellChangeTimes->{{3.565793025432672*^9, 3.565793134567914*^9}, {
   3.5657931728801055`*^9, 3.5657931938163033`*^9}, {3.565793227624237*^9, 
   3.56579324638431*^9}, 3.5662833072117596`*^9, {3.6445596084895034`*^9, 
   3.6445596272095366`*^9}, {3.6445598122102613`*^9, 3.644559831320295*^9}, {
   3.644559873471569*^9, 3.644559873471569*^9}, 
   3.644588293564089*^9},ExpressionUUID->"f65aee28-52a8-41a6-8f77-\
6363a4efd2af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dimension", "[", 
    RowBox[{
     FormBox[
      RowBox[{
       OverscriptBox["\[And]", "p"], "V"}],
      TraditionalForm], "\.b4"}], "]"}], "\[Equal]", " ", 
   RowBox[{"Binomial", "[", 
    RowBox[{"d", ",", "p"}], "]"}]}], " ", "=", 
  RowBox[{
   RowBox[{"(", GridBox[{
      {"d"},
      {"p"}
     }], ")"}], "                                          ", 
   RowBox[{"(", "3", ")"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.644559764879778*^9, 3.6445597879054184`*^9}, {
  3.6445603646540318`*^9, 
  3.644560386135269*^9}},ExpressionUUID->"428e8123-f6f6-4562-8647-\
7a17162f28e8"],

Cell["Summarizing we obtain for the ", "Text",
 CellChangeTimes->{{3.5657942782653303`*^9, 3.5657943063759375`*^9}, 
   3.565794344770134*^9, 
   3.6445599330168734`*^9},ExpressionUUID->"d1a88d79-3a3d-4795-be7e-\
d5271d59becd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dimension", "[", 
   RowBox[{"\[And]", "V\.b4"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{
   UnderoverscriptBox[
    RowBox[{" ", "\[Sum]"}], 
    RowBox[{"p", "=", "0"}], "d"], 
   RowBox[{"Binomial", "[", 
    RowBox[{"d", ",", "p"}], "]"}]}], " ", "\[Equal]", " ", 
  RowBox[{
   SuperscriptBox["2", "d"], ".", "                                 ", 
   RowBox[{"(", "4", ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5657940592918053`*^9, 3.5657941146839733`*^9}, {
  3.5657941884601936`*^9, 3.5657941952595825`*^9}, {3.5661032100658197`*^9, 
  3.5661032248234463`*^9}, {3.6445599393192844`*^9, 3.6445599604105215`*^9}, {
  3.6445599974761868`*^9, 3.644560067239509*^9}, {3.6445603407859898`*^9, 
  3.644560359318822*^9}},
 CellID->470106277,ExpressionUUID->"d64cc0a7-66c5-415c-a8e8-88e3eac92cd2"],

Cell[TextData[{
 "Our aim now is introducing the so-called wedge product for the elements of  \
\[And] VV to create the structure of an associative, non-commutative algebra, \
named the ",
 StyleBox["exterior algebra",
  FontColor->RGBColor[0, 0, 1]],
 " over VV, or the Grassmann",
 StyleBox[" algebra",
  FontColor->RGBColor[0, 0, 1]],
 " of alternating p-forms. Analogously the Grassmann algebra  \[And] V of \
p-vectors  is defined."
}], "Text",
 CellChangeTimes->{{3.5657944373764305`*^9, 3.565794553304061*^9}, {
   3.565795206952448*^9, 3.5657953994894605`*^9}, 3.5658502341414413`*^9, {
   3.566103282782666*^9, 3.5661033020955005`*^9}, {3.6413600214758177`*^9, 
   3.6413600215070176`*^9}, {3.6438094602499723`*^9, 
   3.6438094715287924`*^9}, {3.644588298400097*^9, 
   3.6445883037821064`*^9}},ExpressionUUID->"81fdbb3e-202f-4f3f-857f-\
32333da1530e"],

Cell[TextData[{
 "For the general theory and its application in this notebook see e.g. [",
 ButtonBox["OSII",
  BaseStyle->"Hyperlink",
  ButtonData->"OSII"],
 "], section 8.3."
}], "Text",
 CellChangeTimes->{{3.5657960494966383`*^9, 3.565796109328061*^9}, {
   3.565796153600593*^9, 3.565796200496275*^9}, {3.5657962308970137`*^9, 
   3.565796230907015*^9}, 
   3.643809542571317*^9},ExpressionUUID->"71208db0-1ade-4169-900b-\
8f69e60f7edb"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.2. extprod", "Subsubsection",
 CellChangeTimes->{{3.5662753751790247`*^9, 3.566275414584694*^9}, 
   3.566283126485442*^9, 3.603610118170419*^9, {3.641359771775977*^9, 
   3.641359775675984*^9}, 3.6417951110858173`*^9, 3.64380957260137*^9, 
   3.643810869028447*^9, 3.644588307325313*^9, {3.644588344162978*^9, 
   3.6445883462533817`*^9}, 
   3.644588806294595*^9},ExpressionUUID->"ef5abb46-5273-44f6-a7ad-\
1356c893d3d6"],

Cell["\<\
In this Subsection we treat the \[OpenCurlyDoubleQuote]exterior\
\[CloseCurlyDoubleQuote] or \[OpenCurlyDoubleQuote]wedge\
\[CloseCurlyDoubleQuote] product extprod  of p-forms  and p-vectors \
represented by their Arrays of coordinates. We begin with the product extprod \
 of p-forms defined as an operation over their coordinate Arrays using the \
built-in function\
\>", "Text",
 CellChangeTimes->{{3.569419927700938*^9, 3.56942006707691*^9}, 
   3.603283133481844*^9, {3.609313224511028*^9, 3.60931328591854*^9}, 
   3.609321261232564*^9, 3.6412876719614763`*^9, {3.641287775155658*^9, 
   3.6412877808184676`*^9}, {3.641359786877804*^9, 3.641359908389818*^9}, {
   3.6413599562899027`*^9, 3.6413599615325117`*^9}, 3.64136006250989*^9, {
   3.6413601142319813`*^9, 3.6413602762652674`*^9}, {3.6417953267937975`*^9, 
   3.641795363394462*^9}, 
   3.641795395174718*^9},ExpressionUUID->"f183b874-6196-488d-b5a7-\
ac73039e0844"],

Cell[BoxData[
 RowBox[{"?", "TensorWedge"}]], "Input",
 CellChangeTimes->{{3.586614301966012*^9, 3.5866143148672347`*^9}, {
  3.6089625997735806`*^9, 3.608962603891988*^9}, {3.608963615959365*^9, 
  3.6089636229637775`*^9}},ExpressionUUID->"c00db480-2810-47ec-96d7-\
7fbf81418b45"],

Cell[TextData[{
 "(Click on ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TensorWedge"]], "PrintUsage",
  CellChangeTimes->{3.6412853377761765`*^9},ExpressionUUID->
  "7e676f04-e19d-4e31-9dcb-3fab6ac1f649"],
 "  !)"
}], "Text",
 CellChangeTimes->{{3.6413603081733236`*^9, 
  3.6413603672898283`*^9}},ExpressionUUID->"28ede0cb-a639-43d7-87e6-\
71339a26dbe3"],

Cell[BoxData[
 RowBox[{"Context", "[", "TensorWedge", "]"}]], "Input",
 CellChangeTimes->{{3.586614326286455*^9, 3.5866143340708685`*^9}, {
   3.6089625399630756`*^9, 3.6089625472170877`*^9}, 
   3.609139331541246*^9},ExpressionUUID->"53e755a6-d193-4425-ac3b-\
7a64189a12cc"],

Cell["Consider the covectors", "Text",
 CellChangeTimes->{{3.6093220550939703`*^9, 3.6093220582941537`*^9}, {
  3.609322390254141*^9, 
  3.6093224299584117`*^9}},ExpressionUUID->"d6d90fd7-8ef4-493d-9aec-\
1ace8b3fb065"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "3"}], ";", 
  RowBox[{"w1", "=", 
   RowBox[{"covec", "[", "f1", "]"}]}], ";", 
  RowBox[{"w2", "=", 
   RowBox[{"covec", "[", "f2", "]"}]}], ";", 
  RowBox[{"w3", "=", 
   RowBox[{"covec", "[", "f3", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.609322120171693*^9, 3.6093221404318514`*^9}, {
  3.6093221983521643`*^9, 3.6093222718573685`*^9}, {3.609322306793367*^9, 
  3.6093223767613688`*^9}, {3.6410983953069363`*^9, 
  3.6410984031537495`*^9}},ExpressionUUID->"0daaedd1-5966-4418-abde-\
129a24da186c"],

Cell[BoxData[
 RowBox[{"TensorWedge", "[", 
  RowBox[{"w1", ",", "w2"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5866075367049265`*^9, {3.5866078946943555`*^9, 3.586607923382806*^9}, {
   3.586609053713991*^9, 3.586609060437603*^9}, {3.5866091609953794`*^9, 
   3.586609167874992*^9}, 3.5866142301590858`*^9, {3.6089625185130377`*^9, 
   3.6089625203070407`*^9}, {3.6089637807424545`*^9, 
   3.6089637866548653`*^9}, {3.608963958769967*^9, 3.608964000765241*^9}, 
   3.609139366379239*^9, {3.60932245842404*^9, 
   3.609322462384266*^9}},ExpressionUUID->"1f9fcc97-ac77-4587-b798-\
f46114a9d9bd"],

Cell["\<\
The result is an alternating bilinear form in dimension 3 with  the \
coordinates\
\>", "Text",
 CellChangeTimes->{{3.5867611712118564`*^9, 3.586761221964759*^9}, {
   3.6092151598757515`*^9, 3.609215169273289*^9}, 3.6093224981583123`*^9, {
   3.6093225496222563`*^9, 
   3.6093225686063414`*^9}},ExpressionUUID->"1b8d0619-74dc-4d48-838c-\
3da537c7fd82"],

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6089638230497293`*^9, 
  3.608963830865343*^9}},ExpressionUUID->"60bab527-9697-4f9c-8ea2-\
0a8e0db118cb"],

Cell[BoxData[
 RowBox[{"?", "Normal"}]], "Input",
 CellChangeTimes->{{3.609139383471216*^9, 
  3.6091393864273853`*^9}},ExpressionUUID->"6a5b9b4a-d7e2-444c-91d5-\
7b95104c9fee"],

Cell["In tensalgv2.m we defined", "Text",
 CellChangeTimes->{{3.6091400809761114`*^9, 3.6091400842482986`*^9}, {
  3.609321601830045*^9, 3.6093216256464076`*^9}, {3.6410981796221576`*^9, 
  3.6410981814785604`*^9}},ExpressionUUID->"016d5d26-569b-46bb-9f1d-\
76c3034419f3"],

Cell[BoxData[
 RowBox[{"?", "extprod"}]], "Input",
 CellChangeTimes->{{3.64128607406627*^9, 
  3.641286104455123*^9}},ExpressionUUID->"2271d258-fc12-43b6-bd7c-\
205637e01162"],

Cell[BoxData[
 RowBox[{
  RowBox[{"extprod", "[", "w___", "]"}], " ", ":=", " ", 
  RowBox[{"Normal", "[", 
   RowBox[{"TensorWedge", "[", "w", "]"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.609140140859536*^9, 3.6091402137787075`*^9}, 
   3.609140254443033*^9, {3.609142536672043*^9, 3.6091425573932285`*^9}, {
   3.609143273953213*^9, 3.609143278689484*^9}, 
   3.609321635712983*^9},ExpressionUUID->"b13332b3-4245-4297-8911-\
c11c1ac6271d"],

Cell[BoxData[
 RowBox[{"extprod", "[", "]"}]], "Input",
 CellChangeTimes->{
  3.609143301679799*^9},ExpressionUUID->"cfef2bba-1e1d-4d5d-8d49-\
e86905bd1b5b"],

Cell["\<\
A general symbol isn\[CloseCurlyQuote]t recognized as a 0-form, extprod is \
not evaluated:\
\>", "Text",
 CellChangeTimes->{{3.609215433394396*^9, 3.6092155061055546`*^9}, 
   3.609321691238159*^9, {3.609322625326586*^9, 
   3.6093226553583035`*^9}},ExpressionUUID->"1aa37cf0-c91e-49b3-95bb-\
0d55fbdf7537"],

Cell[BoxData[
 RowBox[{"extprod", "[", "g", "]"}]], "Input",
 CellChangeTimes->{3.6092153726999245`*^9, 
  3.609322671697238*^9},ExpressionUUID->"6581817f-ca46-45ee-8f21-\
2f584150eda5"],

Cell["A numeric argument  is treated as a 0-form, i.e. a scalar:", "Text",
 CellChangeTimes->{{3.60921561144158*^9, 3.609215640329232*^9}, {
  3.6093227159027667`*^9, 3.6093227247902746`*^9}, {3.6438100689786415`*^9, 
  3.6438100790562596`*^9}},ExpressionUUID->"8478962e-da6e-4dd3-8250-\
4a77ca44ed00"],

Cell[BoxData[
 RowBox[{"extprod", "[", "Pi", "]"}]], "Input",
 CellChangeTimes->{
  3.6092153726999245`*^9, {3.6092155294898925`*^9, 3.609215560515667*^9}, 
   3.6093227000568604`*^9, {3.64128618220566*^9, 
   3.6412861833912616`*^9}},ExpressionUUID->"74c43efb-dfaf-43d7-b88f-\
6338d45c2230"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"Cos", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6093217985252953`*^9, 3.60932181818442*^9}, {
  3.6093227375850067`*^9, 
  3.609322749088665*^9}},ExpressionUUID->"5ce37f27-b73c-4d1e-a8da-\
914af20cddce"],

Cell["Again", "Text",
 CellChangeTimes->{{3.6092156749692135`*^9, 
  3.609215677897381*^9}},ExpressionUUID->"6a151f37-21d3-4195-b9f3-\
f7424c8c92f9"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"g", ",", "w1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6091402188970003`*^9, 3.609140224441317*^9}, {
   3.609142821985362*^9, 3.6091428627446938`*^9}, 3.609142910601431*^9, {
   3.609322779521405*^9, 
   3.609322791192073*^9}},ExpressionUUID->"e54e1b79-1b67-40c7-a901-\
5ca496db10ac"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"Pi", ",", "w1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6091402188970003`*^9, 3.609140224441317*^9}, {
   3.609142821985362*^9, 3.6091428627446938`*^9}, 3.609142910601431*^9, {
   3.609143190727453*^9, 3.609143205793315*^9}, {3.609215712988388*^9, 
   3.609215713740431*^9}, {3.6093228145044065`*^9, 
   3.60932281842463*^9}},ExpressionUUID->"5e6ee0b0-a5be-4761-a3f9-\
803a27f7d864"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", 
  RowBox[{"Pi", "*", "w1"}]}]], "Input",
 CellChangeTimes->{{3.609322858713935*^9, 
  3.6093228688085127`*^9}},ExpressionUUID->"6f703431-7b10-4145-95af-\
4504b728da63"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"%%", ",", "w2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6091433804543047`*^9, 3.6091434103450146`*^9}, {
  3.609322887176563*^9, 
  3.609322897736167*^9}},ExpressionUUID->"b3dbea8a-8d31-4767-be7c-\
683b01755291"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", "\[Equal]", " ", 
   RowBox[{"Pi", "*", 
    RowBox[{"extprod", "[", 
     RowBox[{"w1", ",", "w2"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6092158552315235`*^9, 3.6092159353341055`*^9}, {
  3.6092159856369824`*^9, 3.6092159966696134`*^9}, {3.6093229137780848`*^9, 
  3.6093229324881544`*^9}},ExpressionUUID->"8537aaca-fcb8-4f8c-8bad-\
1f860db509a3"],

Cell["extprod is linear:", "Text",
 CellChangeTimes->{{3.609323156582972*^9, 
  3.6093231881827793`*^9}},ExpressionUUID->"31743274-9eb6-4396-bfa7-\
cbcb32d65a72"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"extprod", "[", 
    RowBox[{"w1", ",", " ", 
     RowBox[{"w2", "+", 
      RowBox[{"Pi", "*", "w3"}]}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{
    RowBox[{"extprod", "[", 
     RowBox[{"w1", ",", " ", "w2"}], "]"}], " ", "+", 
    RowBox[{"Pi", "*", " ", 
     RowBox[{"extprod", "[", 
      RowBox[{"w1", ",", "w3"}], "]"}]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.60932299325063*^9, 3.6093230781374855`*^9}, {
  3.6093232018735623`*^9, 3.6093232259179378`*^9}, {3.641286289845849*^9, 
  3.6412862973338623`*^9}},ExpressionUUID->"9560a09d-5579-4fd9-9bc0-\
3c89b3453430"],

Cell["The exterior product is Flat (associative). ", "Text",
 CellChangeTimes->{{3.609216249538077*^9, 3.609216334377929*^9}, {
   3.6093086665503273`*^9, 3.6093086714706087`*^9}, 
   3.609323274886739*^9},ExpressionUUID->"fac3847c-01bf-4cb3-b024-\
e65ffdf05607"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"w1", ",", 
   RowBox[{"extprod", "[", 
    RowBox[{"w2", ",", "w3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6092160822505083`*^9, 3.609216157741826*^9}, {
  3.60932325008932*^9, 3.609323250569348*^9}, {3.6093233272887363`*^9, 
  3.6093233495690103`*^9}},ExpressionUUID->"63096325-a966-42e9-beda-\
2af089529fcb"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", " ", "\[Equal]", " ", 
   RowBox[{"extprod", "[", 
    RowBox[{"w1", ",", "w2", ",", "w3"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6092160822505083`*^9, 3.609216157741826*^9}, {
  3.609216355858158*^9, 3.6092163783164425`*^9}, {3.609323384448005*^9, 
  3.6093234406802216`*^9}},ExpressionUUID->"12213517-1a8f-4928-81a9-\
b509a9ba64ed"],

Cell["\<\
Clearly, the exterior product of four1-forms of dimension 3 is zero:\
\>", "Text",
 CellChangeTimes->{{3.609216789849981*^9, 3.609216812481275*^9}, 
   3.609323307415599*^9, {3.6093234982555146`*^9, 
   3.6093235366867127`*^9}},ExpressionUUID->"0559d1c3-b40f-4904-8e90-\
c3b7a187cf6c"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"w1", ",", "w2", ",", "w3", ",", " ", 
   RowBox[{"covec", "[", "x", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6091402188970003`*^9, 3.609140224441317*^9}, {
   3.609142821985362*^9, 3.6091428627446938`*^9}, 3.609142910601431*^9, {
   3.609142950990741*^9, 3.609142964984541*^9}, {3.6091435169461117`*^9, 
   3.609143530265874*^9}, {3.6093235774570446`*^9, 
   3.6093235944960194`*^9}},ExpressionUUID->"e0bc7a02-5836-409b-aafb-\
be0d551925fd"],

Cell["Here is an antisymmetric biform:", "Text",
 CellChangeTimes->{{3.64128793020433*^9, 3.64128794730196*^9}, 
   3.6438101668556137`*^9},ExpressionUUID->"07d24d15-7660-4837-9411-\
08a28b956a96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "3"}], ";", 
  RowBox[{"a2", " ", "=", " ", 
   RowBox[{"altform", "[", 
    RowBox[{"a", ",", "2"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6412856702751603`*^9, 3.641285699182011*^9}, {
  3.6413663712756314`*^9, 
  3.6413663751444383`*^9}},ExpressionUUID->"e905b44c-640f-4520-8f79-\
1dc46e9fe7ea"],

Cell["\<\
The exterior product of a2 with a scalar and a 1-form is the antisymmetric \
3-form\
\>", "Text",
 CellChangeTimes->{{3.6412880085944676`*^9, 3.641288070308176*^9}, 
   3.641364494365914*^9, {3.6417880994559326`*^9, 
   3.6417881025915384`*^9}},ExpressionUUID->"00f11427-0bb7-44bb-abeb-\
54aaa419c520"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"3", ",", "a2", ",", "w1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6412857177148438`*^9, 3.641285772002939*^9}, {
  3.641286458466545*^9, 
  3.64128646124335*^9}},ExpressionUUID->"e8566d79-07ff-47f4-99f3-\
7bd018f81e72"],

Cell["with the only strict coordinate", "Text",
 CellChangeTimes->{{3.6412881298690805`*^9, 
  3.641288142364702*^9}},ExpressionUUID->"f09b9f62-fe30-4b54-b5de-\
2a09d8175a5d"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6412866502532816`*^9, 
  3.6412866643869066`*^9}},ExpressionUUID->"32fc7480-26b4-4196-83d5-\
42b4dddf681e"],

Cell["\<\
factors of an exterior product not being antisymmetric will be symmetrized \
during the operation:\
\>", "Text",
 CellChangeTimes->{{3.641288170834752*^9, 
  3.6412882430784793`*^9}},ExpressionUUID->"08586637-d9df-48a6-9c39-\
b6ba1bb05abb"],

Cell[BoxData[
 RowBox[{"b2", " ", "=", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"b", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6412867011249714`*^9, 
  3.6412867479874535`*^9}},ExpressionUUID->"b0c30f23-978c-4720-b58a-\
ce46209b7423"],

Cell[BoxData[
 RowBox[{"%", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.6412867606546755`*^9, 
  3.641286769546691*^9}},ExpressionUUID->"185e2bd1-ae7f-4920-885f-\
d450f3d15f70"],

Cell[BoxData[
 RowBox[{"extprod", "[", "b2", "]"}]], "Input",
 CellChangeTimes->{
  3.6438102964762416`*^9},ExpressionUUID->"d01d9ed7-0d38-4645-b818-\
7f164d370a77"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"w1", ",", "b2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6412867875803227`*^9, 
  3.6412868123375664`*^9}},ExpressionUUID->"fbb9ba87-a4c0-486b-8f1f-\
ff1fe3f6252f"],

Cell["The only strict coordinate is", "Text",
 CellChangeTimes->{{3.6412882670557213`*^9, 
  3.641288277070939*^9}},ExpressionUUID->"68586454-ccdf-46ca-bbc3-\
dcf5dcc48119"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6412866502532816`*^9, 
  3.6412866643869066`*^9}},ExpressionUUID->"c3d3bcf8-4702-487b-b2f3-\
7ee62399e5f5"],

Cell[BoxData[
 RowBox[{"b24", " ", "=", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"b", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6412869464666023`*^9, 
  3.641286966855838*^9}},ExpressionUUID->"8372f9f9-f280-4b18-ae57-\
83884e98cbe8"],

Cell["\<\
As expected, we get an error message, and the wed extprod isn\
\[CloseCurlyQuote]t evaluated.\
\>", "Text",
 CellChangeTimes->{{3.643810457218924*^9, 3.6438105096506157`*^9}, 
   3.644588844132662*^9},ExpressionUUID->"311e1d15-1302-44dd-8d4d-\
abac48c479db"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"b24", ",", "w1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6412869842186685`*^9, 
  3.641287000193096*^9}},ExpressionUUID->"e1c917cf-2fb4-4723-857f-\
16fa6a7df8c0"],

Cell[TextData[{
 "We summarize:\n",
 StyleBox["Proposition",
  FontColor->RGBColor[0, 0, 1]],
 ".  The operation extprod restricted to the alternating p-forms realizes the \
multiplication of the Gra\[SZ]mann algebra. It is a multilinear, \
anticommutative and associative operation. \[FilledSmallSquare]"
}], "Text",
 CellChangeTimes->{{3.6412883591270833`*^9, 3.6412883749299107`*^9}, 
   3.6412887863106337`*^9, {3.6412888236026993`*^9, 3.6412890639211216`*^9}, {
   3.641289127709634*^9, 3.641289127709634*^9}, 3.6412895816392307`*^9, {
   3.641788205504919*^9, 
   3.64178821149533*^9}},ExpressionUUID->"f1f916ca-d745-4fde-af62-\
1dbf5d815762"],

Cell[TextData[{
 StyleBox["anticommutative",
  FontColor->RGBColor[0, 0, 1]],
 " means: For a p-form ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "p"], TraditionalForm]],ExpressionUUID->
  "106477f4-d866-49b4-8476-4933f9822d1b"],
 " and a q-form ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "q"], TraditionalForm]],ExpressionUUID->
  "95fa63e9-2837-45ab-8eaa-560239d10654"],
 " the following rule is fulfilled:"
}], "Text",
 CellChangeTimes->{{3.6412891982841578`*^9, 3.641289331711192*^9}, {
   3.641289627924512*^9, 3.6412897254090834`*^9}, 3.6417838929865446`*^9, 
   3.6417882530382023`*^9, 
   3.6417882947214756`*^9},ExpressionUUID->"a9fb9f25-24af-407d-99e1-\
ac20bcc40188"],

Cell[BoxData[
 RowBox[{
  RowBox[{"extprod", "[", 
   RowBox[{
    SubscriptBox["a", "p"], ",", 
    FormBox[
     SubscriptBox["b", "q"],
     TraditionalForm]}], "]"}], " ", "\[Equal]", "  ", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{"p", "*", "q"}]], 
   RowBox[{"extprod", "[", 
    RowBox[{
     FormBox[
      SubscriptBox["b", "q"],
      TraditionalForm], ",", 
     SubscriptBox["a", "p"]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.641289339152405*^9, 
  3.6412895269455347`*^9}},ExpressionUUID->"7f093829-eb64-45a1-9342-\
ca828a82fae6"],

Cell[TextData[{
 "It is also an ",
 StyleBox["alternating algebra",
  FontColor->RGBColor[0, 0, 1]],
 ", see ",
 ButtonBox["Wikipedia",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["https://en.wikipedia.org/wiki/Alternating_algebra"], None},
  ButtonNote->"https://en.wikipedia.org/wiki/Alternating_algebra"],
 "."
}], "Text",
 CellChangeTimes->{{3.7015849434198847`*^9, 3.70158501649155*^9}, {
  3.701585056379998*^9, 
  3.701585056381834*^9}},ExpressionUUID->"6b7bbf57-2e17-41a6-8914-\
74c455ab1969"],

Cell["For our examples:", "Text",
 CellChangeTimes->{{3.6412898739993443`*^9, 
  3.641289884201762*^9}},ExpressionUUID->"d1d60df1-ec1a-42a9-af9a-\
1e7ad9d7d003"],

Cell[BoxData[
 RowBox[{
  RowBox[{"extprod", "[", 
   RowBox[{"w1", ",", "w2"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"-", 
   RowBox[{"extprod", "[", 
    RowBox[{"w2", ",", "w1"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.64128976905796*^9, 
  3.6412897999460144`*^9}},ExpressionUUID->"d8dd8e7a-08ec-48c5-909e-\
ceeddca4c35f"],

Cell[BoxData[
 RowBox[{"TensorSymmetry", "[", 
  RowBox[{"extprod", "[", 
   RowBox[{"w1", ",", "w2"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6412899927467527`*^9, 
  3.641290028002815*^9}},ExpressionUUID->"3383befc-18d2-4711-9574-\
2fcdb68a24ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"extprod", "[", 
   RowBox[{"w1", ",", "a2"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"extprod", "[", 
   RowBox[{"a2", ",", "w1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.64128976905796*^9, 3.6412897999460144`*^9}, {
  3.641289829960467*^9, 
  3.6412898488052998`*^9}},ExpressionUUID->"aebc3dda-b0e3-447f-a2f1-\
ab74d769698c"],

Cell["\<\
The built-in function TensorSymmetry shows that the results of extprod are \
antisymmetric  Arrays, in our case (p+q)-forms:\
\>", "Text",
 CellChangeTimes->{{3.6412901245981846`*^9, 3.641290256948817*^9}, 
   3.641290710644414*^9},ExpressionUUID->"8d030b26-1905-4498-b008-\
433a0f74a7f8"],

Cell[BoxData[
 RowBox[{"?", "TensorSymmetry"}]], "Input",
 CellChangeTimes->{{3.641289904684598*^9, 3.6412899083038044`*^9}, {
  3.641290090090924*^9, 3.641290095925334*^9}, {3.641639846571151*^9, 
  3.641639867724788*^9}, {3.641639931903301*^9, 
  3.641639997953817*^9}},ExpressionUUID->"6d6b9b73-0195-4a8e-bdca-\
92e891da6f4d"],

Cell[BoxData[
 RowBox[{"TensorSymmetry", "[", 
  RowBox[{"w1", "  ", "\[TensorWedge]", " ", "w2"}], "]"}]], "Input",
 CellChangeTimes->{{3.641289904684598*^9, 3.6412899083038044`*^9}, {
  3.641290090090924*^9, 3.641290095925334*^9}, {3.641639832375126*^9, 
  3.641639838537137*^9}, {3.641640017984252*^9, 
  3.641640077888357*^9}},ExpressionUUID->"8ad0d6c1-9ddd-44b6-8df0-\
e5d59c8c2db6"],

Cell["\<\
The  Infix symbol \[TensorWedge] may be used for TensorWedge, not for extprod:\
\>", "Text",
 CellChangeTimes->{{3.6416393595382957`*^9, 3.641639362705101*^9}, 
   3.641639509423359*^9, {3.6416395478618264`*^9, 3.6416395632278533`*^9}, {
   3.6416396014791203`*^9, 
   3.6416396813824606`*^9}},ExpressionUUID->"fc44187f-db24-4b5c-9a74-\
cae98d06aea5"],

Cell[BoxData[
 RowBox[{"w1", " ", "\[TensorWedge]", " ", "w2"}]], "Input",
 CellChangeTimes->{{3.64163968654607*^9, 
  3.64163970907251*^9}},ExpressionUUID->"e65593a9-d0dc-44e0-be96-\
1800ec044e55"],

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6416397264665403`*^9, 
  3.641639738462961*^9}},ExpressionUUID->"19965cbb-26d7-4dad-be0c-\
6e4fc8eb88b1"],

Cell["\<\
The same operations may be done for p-vectors. Consider the example\
\>", "Text",
 CellChangeTimes->{{3.6417884100368786`*^9, 3.6417884659785767`*^9}, 
   3.641790547500208*^9},ExpressionUUID->"66f199db-9e08-4c56-96cc-\
788c812314db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v1", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "1"}], "]"}]}], ";", 
  RowBox[{"v2", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "0", ",", "2"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.641788481594204*^9, 3.641788532887094*^9}, {
  3.641788861376871*^9, 
  3.6417888759004965`*^9}},ExpressionUUID->"87f258ec-ff13-4cb8-8a3b-\
14598f13fec6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vv1", " ", "=", 
   RowBox[{"tensorToArray", "[", "v1", "]"}]}], ";", 
  RowBox[{"vv2", "=", 
   RowBox[{"tensorToArray", "[", "v2", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6417885432299123`*^9, 
  3.6417886114332323`*^9}},ExpressionUUID->"f1db19e2-7032-4220-8ed0-\
9a50318bdfb4"],

Cell[BoxData[
 RowBox[{"extprod", "[", 
  RowBox[{"vv1", ",", "vv2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6417886180164433`*^9, 
  3.6417886300596647`*^9}},ExpressionUUID->"079967b0-1aee-438f-9198-\
f5c0567382ac"],

Cell["To get the corresponding tensor apply", "Text",
 CellChangeTimes->{{3.641795584563452*^9, 
  3.6417956009434805`*^9}},ExpressionUUID->"a2e31674-c8c2-4718-b700-\
2d275a159c4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v3", " ", "=", " ", 
   RowBox[{"ArrayTotensor", "[", "%", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6417886815865555`*^9, 3.6417887004313884`*^9}, 
   3.641790596076499*^9},ExpressionUUID->"e34dfcfb-b7db-4b2f-850d-\
849d4a900d5b"],

Cell["\<\
In the definition of v3 the covariant degree of the tensor has the default \
value p=0, thus it doesn\[CloseCurlyQuote]t appear in the formula. 
v3 is a 3-vector: an antisymmetric contravariant tensor of degree 3:\
\>", "Text",
 CellChangeTimes->{{3.641788996894309*^9, 3.641789064146027*^9}, {
   3.641789407939431*^9, 3.6417895087156076`*^9}, 
   3.6417954845104756`*^9},ExpressionUUID->"ac839710-fddb-49f4-8ce9-\
078b876a006d"],

Cell[BoxData[
 RowBox[{"TensorSymmetry", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.641788733378646*^9, 
  3.6417887483702726`*^9}},ExpressionUUID->"7d4779d1-9522-4313-82ab-\
d16c0289cbae"],

Cell[BoxData[
 RowBox[{"type", "[", "v3", "]"}]], "Input",
 CellChangeTimes->{{3.64178908862247*^9, 
  3.6417890996672897`*^9}},ExpressionUUID->"4b8d0842-74d6-44d2-8a69-\
9b7bf3421599"],

Cell[BoxData[
 RowBox[{"v3", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6417887725815153`*^9, 
  3.6417887928927507`*^9}},ExpressionUUID->"bfa7dd7c-733b-402f-a807-\
d1a4d81b4daa"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"v3", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}], "+", 
   RowBox[{"v3", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6417887725815153`*^9, 3.6417887928927507`*^9}, {
  3.641788892795326*^9, 
  3.641788927879788*^9}},ExpressionUUID->"0c044acf-b3ad-4272-9358-\
52dc209c6aa7"],

Cell[BoxData[
 RowBox[{"strictcoords", "[", "v3", "]"}]], "Input",
 CellChangeTimes->{{3.6417891287145405`*^9, 
  3.641789139213359*^9}},ExpressionUUID->"e0fb211a-687b-4522-b524-\
65ec3d90778b"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.6416395244773855`*^9, 
  3.641639535943405*^9}},ExpressionUUID->"ce6f286b-6766-4a86-ac3a-\
288a4ac2e027"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.3. The General  wedge Product", "Subsubsection",
 CellChangeTimes->{{3.565850597628232*^9, 3.565850663998028*^9}, 
   3.566275235433979*^9, {3.5662753333085513`*^9, 3.5662753478165765`*^9}, 
   3.5662831631923065`*^9, {3.566313376303406*^9, 3.566313379813412*^9}, 
   3.5664856113917713`*^9, 3.5694242904934754`*^9, 3.569570036816794*^9, {
   3.6036101451896667`*^9, 3.6036101483876724`*^9}, 3.603637033139916*^9, 
   3.641371729353478*^9, 3.6417226089541817`*^9, 3.6417951148298244`*^9, {
   3.6417951836797457`*^9, 3.6417952000597744`*^9}, 3.6418849722295465`*^9, 
   3.6438108764096603`*^9, 
   3.644040099073526*^9},ExpressionUUID->"130ec00f-a969-4c01-b539-\
3974217c8911"],

Cell["\<\
In this subsection we consider the exterior algebra of p-forms and \
analogously the exterior algebra of p-vectors as a part of tensor algebra. \
\>", "Text",
 CellChangeTimes->{{3.565851148533742*^9, 3.565851229189355*^9}, {
   3.566313562371495*^9, 3.566313637277995*^9}, 3.566398631582879*^9, {
   3.56662889887599*^9, 3.566628899671591*^9}, {3.5666289427744665`*^9, 
   3.566628969247713*^9}, 3.6417957023536596`*^9, {3.6417957337439146`*^9, 
   3.6417957360215187`*^9}, {3.6417958624660807`*^9, 
   3.641795875979705*^9}},ExpressionUUID->"33478009-b1b9-4170-b4f5-\
d24115b9c7bc"],

Cell["\<\
We define the alternating product using the notation wedge corresponding to \
our convention for the notation of symbols for non built-in functions: these \
symbols should start with a small letter. For the definition we follow \
formula (8.3.7), p. 100 of the German edition of [OSII]:\
\>", "Text",
 CellChangeTimes->{{3.565851463997785*^9, 3.5658515296935425`*^9}, {
   3.565851593197175*^9, 3.565851596829383*^9}, {3.565851694453967*^9, 
   3.565851786109209*^9}, {3.5658531451739435`*^9, 3.565853181958047*^9}, {
   3.5658545902945995`*^9, 3.5658546296778517`*^9}, {3.56585466129366*^9, 
   3.5658547038860965`*^9}, {3.5658550619825783`*^9, 3.565855073966264*^9}, 
   3.5658551189498367`*^9, 3.5661034435097485`*^9, {3.566629004316575*^9, 
   3.566629023863409*^9}},ExpressionUUID->"b2c48887-3d52-4edc-a814-\
703a39fc53de"],

Cell[BoxData[
 RowBox[{"?", "wedge"}]], "Input",
 CellChangeTimes->{{3.5664776532017803`*^9, 3.5664777045726705`*^9}, {
  3.566477796098031*^9, 3.566477833647297*^9}, {3.566477871695764*^9, 
  3.5664779578547153`*^9}, {3.566629051990258*^9, 
  3.566629059275471*^9}},ExpressionUUID->"b3374df1-35a5-42cb-97a4-\
36f981c193f9"],

Cell["The definition of wedge is given in tensalgv2.m as", "Text",
 CellChangeTimes->{{3.5666298009475737`*^9, 3.566629809012788*^9}, 
   3.5666303324717073`*^9, {3.641789734401204*^9, 
   3.6417897488000298`*^9}},ExpressionUUID->"c49ca96e-f3dd-4f5e-bd80-\
ba71ae717685"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "wedge", "]"}], "=", " ", 
   RowBox[{"{", 
    RowBox[{"Flat", ",", " ", "OneIdentity"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"wedge", "[", "x___", "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ii", " ", ",", "k", ",", "kk", ",", "j", ",", "ko", ",", "kc", ",", 
       "CON", ",", "num", ",", "tlist"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ii", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", "x", "}"}], "]"}]}], ";", 
      RowBox[{"k", " ", "=", " ", 
       RowBox[{"Length", "[", "ii", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"k", "\[Equal]", " ", "0"}], ",", 
        RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tlist", "=", 
          RowBox[{"{", "}"}]}], ";", 
         RowBox[{"num", "=", "1"}], ";", 
         RowBox[{"j", "=", "1"}]}], ",", 
        RowBox[{"j", "<", 
         RowBox[{"k", "+", "1"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", 
             RowBox[{"ii", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}], "||", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Head", "[", 
               RowBox[{"ii", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", " ", "tensor"}],
              ")"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<Invalid Argument \>\"", ",", " ", 
             RowBox[{"ii", "[", 
              RowBox[{"[", "j", "]"}], "]"}], ",", "\"\< !\>\""}], "]"}], ";", 
           RowBox[{"Return", "[", "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", 
             RowBox[{"ii", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}], ",", 
            RowBox[{"num", " ", "=", 
             RowBox[{"num", "*", 
              RowBox[{"ii", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"tlist", ",", 
              RowBox[{"ii", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], "]"}]}], "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", " ", 
      RowBox[{"k", " ", "=", " ", 
       RowBox[{"Length", "[", "tlist", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ko", " ", "=", " ", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"type", "[", 
           RowBox[{"tlist", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dd", "=", 
       RowBox[{
        RowBox[{"type", "[", 
         RowBox[{"tlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"kc", " ", "=", " ", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"type", "[", 
           RowBox[{"tlist", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ko", ">", "0"}], "&&", 
         RowBox[{"kc", ">", "0"}]}], ",", 
        RowBox[{
         RowBox[{
         "Print", "[", "\"\<Invalid: Mixed type arguments!\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "<", 
         RowBox[{"k", "+", "1"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"type", "[", 
              RowBox[{"tlist", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", "3", "]"}], "]"}], "===", "dd"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<Arguments have varying dimensions!\>\"", "]"}], 
           ";", 
           RowBox[{"Return", "[", "]"}]}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ko", "\[Equal]", "0"}], ",", " ", 
        RowBox[{"Goto", "[", "CON", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"kk", " ", "=", 
       RowBox[{"Product", "[", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"type", "[", 
               RowBox[{"tlist", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "1"}], "]"}], "]"}], ")"}], "!"}], ")"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ko", ">", "dd"}], ",", " ", 
        RowBox[{"Return", "[", 
         RowBox[{"nulltensor", "[", 
          RowBox[{"ko", ",", "0", ",", "dd"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"num", "*", "kk", "*", 
          RowBox[{"covalt", "[", 
           RowBox[{"tensorproduct", "[", "tlist", "]"}], "]"}]}], "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Label", "[", "CON", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"kk", " ", "=", 
       RowBox[{"Product", "[", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"type", "[", 
               RowBox[{"tlist", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}], ")"}], "!"}], ")"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"kc", ">", "dd"}], ",", " ", 
        RowBox[{"Return", "[", 
         RowBox[{"nulltensor", "[", 
          RowBox[{"0", ",", "kc", ",", "dd"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"num", "*", "kk", "*", 
         RowBox[{"contralt", "[", 
          RowBox[{"tensorproduct", "[", "tlist", "]"}], "]"}]}]}], "]"}]}]}], 
    "]"}]}], ";"}], "\n"}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.60361102376761*^9, 3.6036110373240337`*^9}, {
   3.603611143950221*^9, 3.6036111459470243`*^9}, 3.6416186125904446`*^9, {
   3.6416388487933984`*^9, 3.6416388554234104`*^9}, 3.64172227346179*^9, 
   3.6417223507251263`*^9},ExpressionUUID->"8aba6827-dcb7-4f38-adbc-\
788132d3ca6f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Wedge", "[", "x___", "]"}], " ", ":=", " ", 
   RowBox[{"wedge", "[", "x", "]"}]}], ";", 
  RowBox[{
   RowBox[{"a_", "\[Wedge]", "b_"}], " ", ":=", " ", 
   RowBox[{"wedge", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.641388142051512*^9, 3.641388188383593*^9}, {
   3.641388221642852*^9, 3.641388241938487*^9}, 3.6416389847476373`*^9, 
   3.644035080965912*^9},ExpressionUUID->"0c6fc4fd-a1c8-49a6-b922-\
d0b9db7029a8"],

Cell[BoxData[
 RowBox[{"Context", "[", "wedge", "]"}]], "Input",
 CellChangeTimes->{{3.6416047253149014`*^9, 
  3.6416047364533215`*^9}},ExpressionUUID->"2f2c67a2-ac00-4e85-989c-\
ebdf5e10a538"],

Cell[BoxData[
 RowBox[{"?", "Wedge"}]], "Input",
 CellChangeTimes->{{3.64138828323176*^9, 
  3.6413882869445667`*^9}},ExpressionUUID->"36b98f92-30de-4179-8042-\
e35d7044a10c"],

Cell["\<\
All tensor arguments of wedge must be either covariant (of type {p,0}) or \
Contravariant (of type {0,p}); tensors of different kind or  tensors mixed \
type {p.q} with p>0 and q>0 aren\[CloseCurlyQuote]t admitted.\
\>", "Text",
 CellChangeTimes->{{3.6417964015883503`*^9, 3.6417966991192756`*^9}, 
   3.6445888785543222`*^9},ExpressionUUID->"cc79a24c-2a08-496c-a968-\
82844f2195b9"],

Cell[TextData[{
 StyleBox["Examples",
  FontColor->RGBColor[0, 0, 1]],
 "."
}], "Text",
 CellChangeTimes->{{3.6417967501745663`*^9, 
  3.641796757756179*^9}},ExpressionUUID->"24ee6fee-be53-49a6-9033-\
30e697d9938d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "5"}], ";"}]], "Input",
 CellChangeTimes->{{3.6036297436099787`*^9, 3.60362974800523*^9}, 
   3.641618796935968*^9, 
   3.6416189145289745`*^9},ExpressionUUID->"e3dabad7-bc01-47be-a66a-\
96898bf5a1af"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tv", "[", "i_", "]"}], ":=", 
  RowBox[{"covecTotensor", "[", 
   RowBox[{"vec", "[", 
    RowBox[{"f", "[", "i", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641620175276389*^9, 
  3.6416202433237085`*^9}},ExpressionUUID->"85451e74-7655-4fa9-942b-\
1e898d6e263d"],

Cell[BoxData[
 RowBox[{"tv", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.6416202518725233`*^9, 
  3.6416202559285307`*^9}},ExpressionUUID->"68614de8-0305-4bc6-b127-\
cd797753bd24"],

Cell[BoxData[
 RowBox[{"coords", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.641620266583349*^9, 
  3.64162027260496*^9}},ExpressionUUID->"9af5cda1-c527-4737-a257-\
e0e38d2fdf42"],

Cell[BoxData[
 RowBox[{"wtv3", "=", 
  RowBox[{"wedge", "[", 
   RowBox[{
    RowBox[{"tv", "[", "1", "]"}], ",", 
    RowBox[{"tv", "[", "2", "]"}], ",", 
    RowBox[{"tv", "[", "3", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641620285802583*^9, 3.641620313929433*^9}, 
   3.641620653635629*^9},ExpressionUUID->"b571ae06-644a-4fcb-b3b5-\
006d6749765b"],

Cell[BoxData[
 RowBox[{"wtv3", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6416203361438713`*^9, 3.641620350043496*^9}, {
  3.641620675335267*^9, 
  3.641620677581671*^9}},ExpressionUUID->"cda19a38-c255-4d6a-8279-\
9e2c0e628ba2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tv", "[", "1", "]"}], "\[Wedge]", 
  RowBox[{"tv", "[", "2", "]"}], "\[Wedge]", 
  RowBox[{"tv", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.6416204417560573`*^9, 
  3.641620449602871*^9}},ExpressionUUID->"46a28c8a-d98c-4280-a1df-\
b9601a366d45"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", "wtv3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6416204880413384`*^9, 3.6416205317838154`*^9}, {
  3.641620702853716*^9, 
  3.641620706004921*^9}},ExpressionUUID->"9fb4054b-5734-4e62-8702-\
3738a4f0af81"],

Cell[BoxData[
 RowBox[{"wtv5", "=", 
  RowBox[{"wedge", "[", 
   RowBox[{
    RowBox[{"tv", "[", "1", "]"}], ",", 
    RowBox[{"tv", "[", "2", "]"}], ",", 
    RowBox[{"tv", "[", "3", "]"}], ",", 
    RowBox[{"tv", "[", "4", "]"}], ",", 
    RowBox[{"tv", "[", "5", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641620285802583*^9, 3.641620313929433*^9}, 
   3.641620653635629*^9, {3.641620998271435*^9, 3.6416210045114455`*^9}, 
   3.641621053635932*^9, {3.6416211259420586`*^9, 3.6416211342724733`*^9}, 
   3.641796872409182*^9},ExpressionUUID->"09086592-1e3e-4158-88c3-\
0d2986a65178"],

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64172248908117*^9, 
  3.641722509707407*^9}},ExpressionUUID->"d7def434-8c79-4bfc-944a-\
2d41b08d3bdb"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", " ", "==", " ", 
   RowBox[{"Det", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"vec", "[", 
       RowBox[{"f", "[", "i", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6416212261878347`*^9, 3.641621328633215*^9}, 
   3.641623172560694*^9, 
   3.641722533063648*^9},ExpressionUUID->"a3107b1d-4c6b-492c-8ef5-\
21f5b233592e"],

Cell[BoxData[
 RowBox[{"wedge", "[", "]"}]], "Input",
 CellChangeTimes->{{3.641803598572405*^9, 
  3.6418036035030184`*^9}},ExpressionUUID->"ced52080-a51d-4e40-957a-\
8e879f3658b0"],

Cell[BoxData[
 RowBox[{"tm", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"mx", ",", "2", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6418036189626455`*^9, 
  3.6418036549277086`*^9}},ExpressionUUID->"b291236e-d3c9-4cfb-a1d8-\
92ce79c576ac"],

Cell[BoxData[
 RowBox[{"wedge", "[", 
  RowBox[{
   RowBox[{"tv", "[", "1", "]"}], ",", "tm"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418036625153227`*^9, 
  3.641803676602147*^9}},ExpressionUUID->"78342410-bd33-4e4b-b478-\
5dc886ee26f5"],

Cell[BoxData[
 RowBox[{"wedge", "[", 
  RowBox[{"tv", "[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418036989473867`*^9, 
  3.6418037497460766`*^9}},ExpressionUUID->"f1ef58fb-9476-4f2d-ab65-\
ea1fca493d4f"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"%", ",", 
    RowBox[{"tv", "[", "1", "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418037605578957`*^9, 
  3.641803806396776*^9}},ExpressionUUID->"3da94ce5-8174-4e5e-860a-\
98a1ae00a039"],

Cell[TextData[{
 StyleBox["Lemma 1",
  FontColor->RGBColor[0, 0, 1]],
 ". wedge reproduces antisymmetric tensors tva:"
}], "Text",
 CellChangeTimes->{{3.641882270002945*^9, 3.641882334571459*^9}, {
   3.6418823824323425`*^9, 3.641882396737568*^9}, 
   3.64458890573357*^9},ExpressionUUID->"8bf70f87-e43f-428d-9df1-\
f7a22f889d5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"strictcoords", "[", "tva", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"strictcoords", "[", 
   RowBox[{"wedge", "[", "tva", "]"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.641882410059991*^9, 3.641882439497243*^9}, 
   3.641882480509715*^9},ExpressionUUID->"55e12cf5-c4df-4aa1-b9a4-\
cb08b7e966f3"],

Cell[TextData[StyleBox["In particular it follows",
 FontColor->GrayLevel[0]]], "Text",
 CellChangeTimes->{{3.641882512489771*^9, 3.6418825331130075`*^9}, {
  3.641882570771474*^9, 3.641882589304306*^9}, {3.641883067413946*^9, 
  3.641883088442783*^9}, {3.64188312121844*^9, 
  3.6418831485028887`*^9}},ExpressionUUID->"5aba9455-d119-48aa-adea-\
876061828378"],

Cell[BoxData[
 RowBox[{
  RowBox[{"strictcoords", "[", 
   RowBox[{"wedge", "[", "ta", "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"strictcoords", "[", 
   RowBox[{"wedge", "[", 
    RowBox[{"wedge", "[", "ta", "]"}], "]"}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6418831896245604`*^9, 
  3.6418832233830194`*^9}},ExpressionUUID->"bc26ee69-bf5e-445e-af1d-\
ff934faf01be"],

Cell[TextData[{
 StyleBox["\nProof",
  FontColor->RGBColor[0, 0, 1]],
 ". Check the formula for several antisymmetric tensors tva:"
}], "Text",
 CellChangeTimes->{{3.641882512489771*^9, 3.6418825331130075`*^9}, {
  3.641882570771474*^9, 3.641882589304306*^9}, {3.641883067413946*^9, 
  3.641883088442783*^9}, {3.64188312121844*^9, 
  3.6418831485028887`*^9}},ExpressionUUID->"179d10ca-171b-462b-8654-\
688cd557917e"],

Cell[BoxData[
 RowBox[{"tva", " ", "=", " ", 
  RowBox[{"coalttensor", "[", 
   RowBox[{"a", ",", "5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6418038825505104`*^9, 3.6418039223667808`*^9}, {
   3.641803963277053*^9, 3.641803988037297*^9}, {3.6418826888168807`*^9, 
   3.64188272254414*^9}, 
   3.6418827666454177`*^9},ExpressionUUID->"1156b91f-df1d-4e28-a1bc-\
a69842833a43"],

Cell[BoxData[
 RowBox[{
  RowBox[{"strictcoords", "[", "tva", "]"}], " ", "\[Equal]", " ", 
  RowBox[{"strictcoords", "[", 
   RowBox[{"wedge", "[", "tva", "]"}], "]"}]}]], "Input",ExpressionUUID->\
"74306ced-2d2d-4da1-bca5-7a56b9c6a7fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "4", ",", "0"}], "]"}]}], ";", 
  RowBox[{"Timing", "[", 
   RowBox[{"equi", "[", 
    RowBox[{
     RowBox[{"wedge", "[", 
      RowBox[{"wedge", "[", "ta", "]"}], "]"}], ",", 
     RowBox[{"wedge", "[", "ta", "]"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6418817852164936`*^9, 3.6418818688950405`*^9}, {
  3.641883285533529*^9, 
  3.641883316951984*^9}},ExpressionUUID->"b771331d-cf00-44ab-aed0-\
07c7236801af"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"strictcoords", "[", 
     RowBox[{"wedge", "[", 
      RowBox[{"wedge", "[", "ta", "]"}], "]"}], "]"}], "\[Equal]", " ", 
    RowBox[{"strictcoords", "[", 
     RowBox[{"wedge", "[", "ta", "]"}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418833468260365`*^9, 3.6418833512408447`*^9}, {
  3.641883386106906*^9, 3.6418834595050344`*^9}, {3.6418834941214952`*^9, 
  3.641883505306715*^9}},ExpressionUUID->"f577348e-60ae-4aae-b28c-\
cf84c6d2c221"],

Cell["\<\
\[FilledSquare]
Applying equi confirms the statement too, but needs much more time. Now we \
consider the function covalt:\
\>", "Text",
 CellChangeTimes->{{3.6418828608851833`*^9, 3.641882935905715*^9}, {
  3.6418829868398046`*^9, 3.641882992299814*^9}, {3.641883756435956*^9, 
  3.641883772394784*^9}, {3.641883840410904*^9, 
  3.6418838794577723`*^9}},ExpressionUUID->"f36b0045-dfcf-48b8-9bb3-\
4e0689ea4f66"],

Cell[BoxData[
 RowBox[{"?", "covalt"}]], "Input",
 CellChangeTimes->{{3.6418049937634726`*^9, 
  3.6418049977726793`*^9}},ExpressionUUID->"b968ec1e-2bf0-45f1-a587-\
80a1a9ecd4a0"],

Cell[TextData[{
 "covalt  applied to covariant, non mixed tensor gives almost the same result \
as wedge, namely\n\n",
 StyleBox["Lemma 2",
  FontColor->RGBColor[0, 0, 1]],
 ". For all purely covariant tensors ta of degree p one has the relation"
}], "Text",
 CellChangeTimes->{
  3.641883797323628*^9, {3.6418839090666237`*^9, 3.6418840653008986`*^9}, 
   3.641884112334981*^9, {3.6418841568106594`*^9, 3.6418841648602734`*^9}, 
   3.6418844773444223`*^9, {3.641890444698222*^9, 3.6418904475414276`*^9}, {
   3.641890616182125*^9, 3.64189061930213*^9}, 
   3.644588921399998*^9},ExpressionUUID->"37269c98-9867-4b61-87f5-\
e82a7fa7de75"],

Cell[BoxData[
 RowBox[{
  RowBox[{"strictcoords", "[", 
   RowBox[{"covalt", "[", "ta", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"strictcoords", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "!"}], ")"}], "*", 
    RowBox[{"wedge", "[", "ta", "]"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6418841268118067`*^9, 3.641884137217025*^9}, {
   3.6418841737990894`*^9, 3.641884189133916*^9}, 
   3.6418842366203995`*^9},ExpressionUUID->"7bff3f50-2e9b-407f-bac5-\
eb336b47a52e"],

Cell["For purely contravariant tensors one has", "Text",
 CellChangeTimes->{{3.6418905690952415`*^9, 3.641890587411674*^9}, {
  3.641890631036351*^9, 
  3.641890638851965*^9}},ExpressionUUID->"3b4591e4-1b0b-4a00-b471-\
e9b70961e2e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"strictcoords", "[", 
   RowBox[{"contralt", "[", "ta", "]"}], "]"}], "\[Equal]", " ", 
  RowBox[{"strictcoords", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "!"}], ")"}], "*", 
    RowBox[{"wedge", "[", "ta", "]"}]}], "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.6418841268118067`*^9, 3.641884137217025*^9}, {
   3.6418841737990894`*^9, 3.641884189133916*^9}, 3.6418842366203995`*^9, {
   3.641890551574411*^9, 
   3.641890553353814*^9}},ExpressionUUID->"759cd1fb-99e4-457b-b84a-\
4813a0efc724"],

Cell[TextData[{
 StyleBox["\nProof",
  FontColor->RGBColor[0, 0, 1]],
 ". Check the formula for several  tensors ta:"
}], "Text",
 CellChangeTimes->{{3.641882512489771*^9, 3.6418825331130075`*^9}, {
   3.641882570771474*^9, 3.641882589304306*^9}, {3.641883067413946*^9, 
   3.641883088442783*^9}, {3.64188312121844*^9, 3.6418831485028887`*^9}, 
   3.6418844711980114`*^9, 
   3.644035524802292*^9},ExpressionUUID->"e7c8ddd7-6c45-4cfd-a071-\
34e96777e716"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "4", ",", "0"}], "]"}]}], ";", 
  RowBox[{"Timing", "[", 
   RowBox[{"equi", "[", 
    RowBox[{
     RowBox[{"covalt", "[", "ta", "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"4", "!"}], ")"}], "*", 
      RowBox[{"wedge", "[", "ta", "]"}]}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641881979405635*^9, 3.641882013663295*^9}, {
   3.64188428805369*^9, 3.6418843228729506`*^9}, {3.641884714985488*^9, 
   3.6418847718187876`*^9}, {3.6418903356058297`*^9, 3.6418903372594323`*^9}, 
   3.6418908016572514`*^9, 
   3.6418909410448976`*^9},ExpressionUUID->"68b90d61-61d7-48c9-92b7-\
33a8f2704e27"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"strictcoords", "[", 
     RowBox[{"covalt", "[", "ta", "]"}], "]"}], "-", " ", 
    RowBox[{"strictcoords", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"4", "!"}], ")"}], "*", 
      RowBox[{"wedge", "[", "ta", "]"}]}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418843391593795`*^9, 3.641884371607436*^9}, {
   3.641884402776291*^9, 3.641884419842721*^9}, 3.641884785904617*^9, 
   3.6418902288086414`*^9, 
   3.641890949298312*^9},ExpressionUUID->"28c616b7-db65-4481-bd7d-\
9f750435b630"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ta", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "5"}], "]"}]}], ";", 
  RowBox[{"Timing", "[", 
   RowBox[{"equi", "[", 
    RowBox[{
     RowBox[{"contralt", "[", "ta", "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"5", "!"}], ")"}], "*", 
      RowBox[{"wedge", "[", "ta", "]"}]}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.641881979405635*^9, 3.641882013663295*^9}, {
  3.64188428805369*^9, 3.6418843228729506`*^9}, {3.641884714985488*^9, 
  3.6418847718187876`*^9}, {3.6418903356058297`*^9, 3.6418903372594323`*^9}, {
  3.6418906540307913`*^9, 
  3.6418906780578337`*^9}},ExpressionUUID->"5af454d9-3626-484b-a30a-\
60be7efd088e"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"strictcoords", "[", 
     RowBox[{"contralt", "[", "ta", "]"}], "]"}], "\[Equal]", "  ", 
    RowBox[{"strictcoords", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"5", "!"}], ")"}], "*", 
      RowBox[{"wedge", "[", "ta", "]"}]}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6418843391593795`*^9, 3.641884371607436*^9}, {
   3.641884402776291*^9, 3.641884419842721*^9}, 3.641884785904617*^9, 
   3.6418902288086414`*^9, 3.6418907091078887`*^9, {3.6418907656317883`*^9, 
   3.6418907661465893`*^9}, {3.644035662690934*^9, 
   3.6440356687905445`*^9}},ExpressionUUID->"0c353461-b76b-40bb-a504-\
6825a9d0be4f"],

Cell["\<\
\[FilledSmallSquare]
Now we will show\
\>", "Text",
 CellChangeTimes->{{3.641884824536285*^9, 3.641884859845147*^9}, {
  3.6419546158690577`*^9, 
  3.6419546297062817`*^9}},ExpressionUUID->"024be220-e881-4e9b-a78e-\
6cb55abd7be4"],

Cell[TextData[{
 StyleBox["Theorem",
  FontColor->RGBColor[0, 0, 1]],
 ". Restricting the definition wedge to the subspace of all antisymmetric \
forms this subspace  becomes an associative algebra over the field K, called ",
 StyleBox["the exterior algebra ",
  FontColor->RGBColor[0, 0, 1]],
 "of antisymmetric forms.  The map ",
 "covalt",
 " is a homomorphism  of the covariant tensor algebra onto this exterior \
algebra, what means, it is a linear map satisfying"
}], "Text",
 CellChangeTimes->{{3.5664766417740035`*^9, 3.5664766592616343`*^9}, {
   3.566476714906932*^9, 3.56647680471629*^9}, {3.566476858505184*^9, 
   3.566476926287304*^9}, {3.566477014240258*^9, 3.5664772006137853`*^9}, 
   3.5664773162567883`*^9, {3.566630708541568*^9, 3.5666307338136125`*^9}, 
   3.569561518250248*^9, {3.641804286326623*^9, 3.641804291006632*^9}, {
   3.6418051709523854`*^9, 3.641805191440222*^9}, {3.641806042159124*^9, 
   3.64180604571693*^9}, {3.641876728810813*^9, 3.641876731806018*^9}, 
   3.641957090958605*^9, 3.6440357516890903`*^9, 
   3.6440358220920143`*^9},ExpressionUUID->"3b2d7974-446a-4dae-b75b-\
8f86e87b51dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covalt", "[", 
   RowBox[{"ta", " ", "\[CircleTimes]", "tb"}], "]"}], " ", "\[Equal]", 
  RowBox[{
   RowBox[{"covalt", "[", "ta", "]"}], "\[Wedge]", 
   RowBox[{"covalt", "[", "tb", "]"}]}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5664772144978094`*^9, 3.566477286663536*^9}, {
   3.641805090046242*^9, 3.641805157614362*^9}, {3.6418052910063987`*^9, 
   3.6418053072510276`*^9}, {3.641806067106568*^9, 3.641806095454818*^9}, {
   3.641876803722144*^9, 3.641876821209775*^9}, 3.6419570983842173`*^9, {
   3.641957149770708*^9, 3.6419571583039227`*^9}, {3.6440358237300167`*^9, 
   3.6440358261480207`*^9}},ExpressionUUID->"4789fba7-77f4-44ed-8cd1-\
0948f125470a"],

Cell[TextData[{
 StyleBox["Proof.",
  FontColor->RGBColor[0, 0, 1]],
 "  The linearity of ",
 "covalt",
 " has been proved already in Subsection 4.3.4. Now check the last formula \
for various covariant tensors:"
}], "Text",
 CellChangeTimes->{{3.6419542180839586`*^9, 3.641954221625165*^9}, {
   3.641954294992094*^9, 3.64195442941753*^9}, {3.6419571077910337`*^9, 
   3.641957119959056*^9}, 
   3.644035829673627*^9},ExpressionUUID->"faff096b-3a73-4cb6-82e0-\
9c91e12b1618"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "6"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "0"}], "]"}]}], ";", 
  RowBox[{"tb", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "3", ",", "0"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.641804512037622*^9, 3.641804568235921*^9}, 
   3.6418048162363586`*^9, 3.6418048492832174`*^9, 3.6418052304900904`*^9, 
   3.641879497534876*^9, 3.641879584941829*^9, {3.6418796179514875`*^9, 
   3.6418796475135393`*^9}, 3.6419548802271223`*^9, 3.641955267903403*^9, 
   3.6440359358786135`*^9},ExpressionUUID->"145a2780-3553-4330-93fc-\
5a3e59d2f5d7"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"equi", "[", 
   RowBox[{
    RowBox[{"covalt", "[", 
     RowBox[{"ta", " ", "\[CircleTimes]", "tb"}], "]"}], ",", 
    RowBox[{
     RowBox[{"covalt", "[", "ta", "]"}], "\[Wedge]", 
     RowBox[{"covalt", "[", "tb", "]"}]}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.641805358313917*^9, 3.6418054003171916`*^9}, {
  3.641806118174458*^9, 3.6418061377066927`*^9}, {3.6418766697023087`*^9, 
  3.641876696081955*^9}, {3.641955140014378*^9, 
  3.6419551509187975`*^9}},ExpressionUUID->"a2949f15-cf93-4706-b18d-\
a5346b18de1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "/", "60"}]], "Input",
 CellChangeTimes->{{3.6447412810186377`*^9, 
  3.644741291223056*^9}},ExpressionUUID->"97d9cccf-7165-424c-a9bf-\
637ebdb674f3"],

Cell[BoxData[
 RowBox[{"297.3223059`", "/", "60"}]], "Input",
 CellChangeTimes->{{3.644070988504396*^9, 
  3.6440709928412037`*^9}},ExpressionUUID->"51c44c8b-2373-4d0d-b408-\
2b6effaf54c2"],

Cell["\<\
The result: {297.322,True}; the calculation needed 49.5067 min.\
\>", "Text",
 CellChangeTimes->{{3.6440387361927323`*^9, 3.6440388022900486`*^9}, 
   3.6440397604749312`*^9, {3.6441288729586716`*^9, 3.6441289006331205`*^9}, {
   3.6447413231417117`*^9, 
   3.6447413519715624`*^9}},ExpressionUUID->"c581d274-9852-43a6-9891-\
a6e113493cc4"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"strictcoords", "[", 
     RowBox[{"covalt", "[", 
      RowBox[{"ta", " ", "\[CircleTimes]", "tb"}], "]"}], "]"}], " ", 
    "\[Equal]", " ", 
    RowBox[{"strictcoords", "[", 
     RowBox[{
      RowBox[{"covalt", "[", "ta", "]"}], "\[Wedge]", 
      RowBox[{"covalt", "[", "tb", "]"}]}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.641805358313917*^9, 3.6418054003171916`*^9}, {
  3.641806118174458*^9, 3.6418061377066927`*^9}, {3.6418766697023087`*^9, 
  3.641876696081955*^9}, {3.6419549435944333`*^9, 3.6419550449946113`*^9}, {
  3.6419550963811016`*^9, 
  3.64195511271433*^9}},ExpressionUUID->"6e8e9bd4-71cc-45e8-a061-\
737d0920dcc9"],

Cell[BoxData[
 RowBox[{"114.7075353`", "/", "60"}]], "Input",
 CellChangeTimes->{{3.6440398678499203`*^9, 3.6440399007815776`*^9}, 
   3.6441290772878304`*^9, 3.6447419555034266`*^9, {3.6469178185458317`*^9, 
   3.646917827640648*^9}},ExpressionUUID->"31e240d8-8739-4c14-8af6-\
97e66ce044e1"],

Cell["\<\
The result: {119.107,True}; the calculation needed 1.91179 min.\
\>", "Text",
 CellChangeTimes->{{3.6440387361927323`*^9, 3.6440388022900486`*^9}, 
   3.6440397604749312`*^9, {3.6440398177738323`*^9, 3.644039829785853*^9}, 
   3.64403993034363*^9, 3.6441290564929943`*^9, 3.644129109174287*^9, 
   3.6447419077341423`*^9, 3.6447419871910825`*^9, 
   3.6469178790115376`*^9},ExpressionUUID->"b69182e6-743a-490c-bdb3-\
445ade42c9bf"],

Cell["\<\
\[FilledSmallSquare]
Analogously one proves\
\>", "Text",
 CellChangeTimes->{{3.641884824536285*^9, 3.641884859845147*^9}, {
  3.6419546158690577`*^9, 3.6419546297062817`*^9}, {3.6419565657476826`*^9, 
  3.641956606541754*^9}},ExpressionUUID->"7c3130c3-dc22-4525-ac0d-\
b913e06271ff"],

Cell[TextData[{
 StyleBox["Theorem",
  FontColor->RGBColor[0, 0, 1]],
 ". Restricting the definition wedge to the subspace of all antisymmetric \
contravariant tensors this subspace  becomes an associative algebra over the \
field K, called ",
 StyleBox["the contravariant exterior algebra",
  FontColor->RGBColor[0, 0, 1]],
 ". The map contralt is a homomorphism  of the contravariant tensor algebra \
onto this exterior algebra, what means, it is a linear map satisfying"
}], "Text",
 CellChangeTimes->{{3.5664766417740035`*^9, 3.5664766592616343`*^9}, {
   3.566476714906932*^9, 3.56647680471629*^9}, {3.566476858505184*^9, 
   3.566476926287304*^9}, {3.566477014240258*^9, 3.5664772006137853`*^9}, 
   3.5664773162567883`*^9, {3.566630708541568*^9, 3.5666307338136125`*^9}, 
   3.569561518250248*^9, {3.641804286326623*^9, 3.641804291006632*^9}, {
   3.6418051709523854`*^9, 3.641805191440222*^9}, {3.641806042159124*^9, 
   3.64180604571693*^9}, {3.641876728810813*^9, 3.641876731806018*^9}, {
   3.641956633420601*^9, 3.6419566403782134`*^9}, {3.6419566939331074`*^9, 
   3.6419567024975224`*^9}, 3.6419567428859935`*^9, {3.641956780185659*^9, 
   3.641956827552142*^9}, {3.641956984816018*^9, 3.6419570049712534`*^9}, 
   3.641957067106163*^9, 3.6419572645401096`*^9, 
   3.644588962701271*^9},ExpressionUUID->"e03123cc-e5e9-493a-8e08-\
60a0f99d94dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"contralt", "[", 
   RowBox[{"ta", " ", "\[CircleTimes]", "tb"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"contralt", "[", "ta", "]"}], "\[Wedge]", 
    RowBox[{"contralt", "[", "tb", "]"}]}], "    ", 
   "\[FilledSmallSquare]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5664772144978094`*^9, 3.566477286663536*^9}, {
  3.641805090046242*^9, 3.641805157614362*^9}, {3.6418052910063987`*^9, 
  3.6418053072510276`*^9}, {3.641806067106568*^9, 3.641806095454818*^9}, {
  3.641876803722144*^9, 3.641876821209775*^9}, {3.6419568721994205`*^9, 
  3.64195690037307*^9}, {3.6419571978967924`*^9, 
  3.6419572031852016`*^9}},ExpressionUUID->"9331ecf6-f6bb-4638-b3b9-\
04bede70978f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}], ";", " ", 
  RowBox[{"dim", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6440400083125668`*^9, 
  3.64404007297468*^9}},ExpressionUUID->"93d594bb-480b-4fae-8510-\
7ebcf775b325"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.4. The Epsilon Tensor", "Subsubsection",
 CellChangeTimes->{{3.565594126724248*^9, 3.5655941283310504`*^9}, {
   3.565594444478006*^9, 3.5655944653196425`*^9}, 3.5698565912536135`*^9, {
   3.570002732137289*^9, 3.570002764616546*^9}, 3.641795119182232*^9, 
   3.6440432155066*^9, {3.6445741957352657`*^9, 3.6445742028956785`*^9}, 
   3.6445890252849817`*^9},ExpressionUUID->"ec5dfa84-6736-4fa1-9375-\
6f37576d3df8"],

Cell["\<\
The epsilon tensor of order k is a tensor of type (k,k), antisymmetric in its \
covariant and its contravariant indices. 
Its coordinate function is the epsilon function eps:\
\>", "Text",
 CellChangeTimes->{{3.5700028154726353`*^9, 3.570002955810482*^9}, 
   3.570002992657747*^9, 3.6011840428916426`*^9, {3.6037803654669247`*^9, 
   3.603780388414565*^9}},ExpressionUUID->"59cc8a0f-c941-4608-a024-\
566ec95faf2e"],

Cell[BoxData[
 RowBox[{"?", "eps"}]], "Input",
 CellChangeTimes->{{3.569997938925962*^9, 3.5699979397215633`*^9}, 
   3.569998052774962*^9},ExpressionUUID->"09b80266-afe8-43eb-a74b-\
6913a8b3cc76"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eps", "[", 
   RowBox[{"a_List", ",", "b_List", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k", "=", 
       RowBox[{"Length", "[", "a", "]"}]}], ",", "rg", ",", 
      RowBox[{"ee", "=", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"k", ">", "d"}], ")"}], ",", " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<False arguments!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rg", " ", "=", " ", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"Range", "[", "d", "]"}], ",", "k"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"MemberQ", "[", 
          RowBox[{"rg", ",", 
           RowBox[{"Sort", "[", "a", "]"}]}], "]"}], "]"}], "||", 
        RowBox[{"Not", "[", 
         RowBox[{"MemberQ", "[", 
          RowBox[{"rg", ",", 
           RowBox[{"Sort", "[", "b", "]"}]}], "]"}], "]"}]}], ",", " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<False arguments!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sort", "[", "a", "]"}], " ", "\[Equal]", " ", 
        RowBox[{"Sort", "[", "b", "]"}]}], ",", 
       RowBox[{"ee", " ", "=", 
        RowBox[{
         RowBox[{"Signature", "[", "a", "]"}], "*", 
         RowBox[{"Signature", "[", "b", "]"}]}]}]}], "]"}], ";", "ee"}]}], 
   "]"}]}]], "Input",
 Evaluatable->False,
 InitializationGroup->True,
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
   3.5655942317248325`*^9, 3.565594243003652*^9}, 3.565594274297307*^9, 
   3.5699979993448677`*^9, {3.570003192353698*^9, 3.5700032665630283`*^9}, {
   3.5700033618323956`*^9, 3.57000339306365*^9}, {3.5700034488961477`*^9, 
   3.570003490439021*^9}, 3.5700035414979105`*^9, {3.5700036040072203`*^9, 
   3.5700036108712325`*^9}, {3.5700265319159875`*^9, 
   3.5700265448328104`*^9}, {3.5700265773432674`*^9, 
   3.5700265999945073`*^9}, {3.570026639602977*^9, 3.570026651552598*^9}, {
   3.57002669841508*^9, 3.570026728585533*^9}, {3.570026782249627*^9, 
   3.5700267926548457`*^9}, {3.570026877768595*^9, 3.570026901777037*^9}, {
   3.570027048370495*^9, 3.5700271118158064`*^9}, {3.57002714242306*^9, 
   3.5700271441702633`*^9}, {3.570027178037923*^9, 3.570027183887933*^9}, {
   3.6036954864621882`*^9, 
   3.603695525375414*^9}},ExpressionUUID->"8ddef2f8-2ad3-4d34-b267-\
0de910e6c1c5"],

Cell[BoxData[
 RowBox[{"Context", "[", "eps", "]"}]], "Input",
 CellChangeTimes->{{3.60377849520844*^9, 
  3.603778505738458*^9}},ExpressionUUID->"5b5e5411-c283-4539-b4d0-\
35953afbdc74"],

Cell[BoxData[
 RowBox[{"Attributes", "[", "eps", "]"}]], "Input",
 CellChangeTimes->{{3.60377849520844*^9, 
  3.603778538560916*^9}},ExpressionUUID->"a253a447-9b28-4979-adf6-\
72e31bdcff31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.6037804812815285`*^9, 3.603780482981931*^9}, {
  3.6446442650256295`*^9, 
  3.6446442679896345`*^9}},ExpressionUUID->"a4a88655-9579-4cbd-a3ab-\
c5a88d577972"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
   3.5655942317248325`*^9, 3.565594243003652*^9}, {3.565594274297307*^9, 
   3.5655943077281656`*^9}, {3.570026944411912*^9, 3.5700269724607615`*^9}, 
   3.57002721070438*^9, {3.5700272743680916`*^9, 3.570027312572559*^9}, {
   3.6037805530260544`*^9, 
   3.603780555896459*^9}},ExpressionUUID->"d7f0b0fc-bd9c-4d5e-a8cb-\
9246e2de2d45"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
  3.5655942317248325`*^9, 3.565594243003652*^9}, {3.565594274297307*^9, 
  3.5655943268849993`*^9}, {3.5699980888578253`*^9, 3.5699981500255327`*^9}, {
  3.6036955629615636`*^9, 3.6036955655047092`*^9}, {3.6037805003759613`*^9, 
  3.6037805365056252`*^9}},ExpressionUUID->"0a47cc72-f0b4-4520-abbe-\
f262b8af9059"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
   3.5655942317248325`*^9, 3.565594243003652*^9}, {3.565594274297307*^9, 
   3.5655943268849993`*^9}, {3.5699980888578253`*^9, 
   3.5699981500255327`*^9}, {3.6036955629615636`*^9, 
   3.6036955655047092`*^9}, {3.6037805003759613`*^9, 3.6037805365056252`*^9}, 
   3.644644241344788*^9, {3.6446443046028996`*^9, 
   3.6446443070209036`*^9}},ExpressionUUID->"58ca2852-c660-4a2a-94a0-\
1bf0b99d8da8"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
   3.5655942317248325`*^9, 3.565594243003652*^9}, {3.565594274297307*^9, 
   3.5655943268849993`*^9}, {3.5699980888578253`*^9, 
   3.5699981500255327`*^9}, {3.6036955629615636`*^9, 
   3.6036955655047092`*^9}, {3.6037805003759613`*^9, 3.6037805365056252`*^9}, 
   3.644644241344788*^9, {3.6446443046028996`*^9, 3.6446443070209036`*^9}, {
   3.6446443453033705`*^9, 
   3.6446443532905846`*^9}},ExpressionUUID->"b30df7eb-c5f4-4e64-b209-\
e31dd04c45f0"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5655941863287525`*^9, 3.5655941911023607`*^9}, {
   3.5655942317248325`*^9, 3.565594243003652*^9}, {3.565594274297307*^9, 
   3.5655943268849993`*^9}, {3.5699980888578253`*^9, 
   3.5699981500255327`*^9}, {3.6036955629615636`*^9, 
   3.6036955655047092`*^9}, {3.6037805003759613`*^9, 3.6037805365056252`*^9}, 
   3.644644241344788*^9, {3.6446443046028996`*^9, 3.6446443070209036`*^9}, {
   3.6446443453033705`*^9, 3.6446443532905846`*^9}, {3.6446444758444*^9, 
   3.6446444861560183`*^9}},ExpressionUUID->"292207b5-1cee-4ddb-8fbd-\
f4a0a4ecb9d3"],

Cell[BoxData[
 RowBox[{"?", "epst"}]], "Input",
 CellChangeTimes->{{3.6037805827909064`*^9, 
  3.6037805860825124`*^9}},ExpressionUUID->"40e710e7-a2b3-444a-9c47-\
2e64639950a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"epst", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"d_:", "dim"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tt", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "<", "0"}], ")"}], "||", 
        RowBox[{"Not", "[", 
         RowBox[{"IntegerQ", "[", "k", "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<incorrect arguments!\>\"", "]"}], ";", 
        RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"k", "\[LessEqual]", "d"}], ",", 
       RowBox[{"tt", "=", " ", 
        RowBox[{"tensor", "[", 
         RowBox[{"eps", ",", "k", ",", "k", ",", "d"}], "]"}]}], ",", 
       RowBox[{"tt", "=", 
        RowBox[{"nulltensor", "[", 
         RowBox[{"k", ",", "k", ",", "d"}], "]"}]}]}], "]"}], ";", "tt"}]}], 
   "]"}]}]], "Input",
 Evaluatable->False,
 InitializationCell->True,
 CellChangeTimes->{{3.56999825655812*^9, 3.5699983445266743`*^9}, {
  3.5700300382941465`*^9, 3.570030076093013*^9}, {3.5700301297571073`*^9, 
  3.5700301645139685`*^9}, {3.570030226212076*^9, 3.5700304009791837`*^9}, {
  3.570030479088521*^9, 
  3.5700304951721487`*^9}},ExpressionUUID->"1896b4c5-0f04-403a-bb43-\
1eff0f66f150"],

Cell[BoxData[
 RowBox[{"epst", "[", "4", "]"}]], "Input",
 CellChangeTimes->{{3.5699983620299053`*^9, 3.569998368082716*^9}, {
  3.570030089509036*^9, 3.57003009139664*^9}, {3.570030423599223*^9, 
  3.5700304569988823`*^9}, {3.570030548165442*^9, 
  3.5700305672130756`*^9}},ExpressionUUID->"3e6469de-a8a0-4922-bda5-\
464cd51dd39e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"epst", "[", "4", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570030503408963*^9, 3.57003051272218*^9}, {
  3.5700305938891225`*^9, 3.5700306561332316`*^9}, {3.570030691560894*^9, 
  3.5700306925280952`*^9}},ExpressionUUID->"077c75f8-5e98-4fe2-af00-\
6614986f0a4d"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"epst", "[", "4", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5699983724819236`*^9, 3.5699983790183353`*^9}, 
   3.5700306701732564`*^9},ExpressionUUID->"dcbde185-dc95-4e3e-8f5d-\
fe6329f920f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"epst", "[", "3", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5699983873799496`*^9, 3.569998418611204*^9}, {
  3.5699984825557165`*^9, 
  3.5699985017749505`*^9}},ExpressionUUID->"76ccc965-aedb-4aa4-b902-\
953b80eaa8b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"coords", "[", 
   RowBox[{"epst", "[", "3", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.5699985209941845`*^9, 3.569998535081009*^9}, 
   3.5699986328463807`*^9},ExpressionUUID->"7d893ef1-76d0-42bd-bed4-\
cb6b9c32be06"],

Cell[BoxData[
 RowBox[{"Length", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5699986036899295`*^9, 
  3.569998610834742*^9}},ExpressionUUID->"3ac2005b-ef38-40c4-a16a-\
d7bd184b21e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"outzero", "[", "%%", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.569998556843047*^9, 3.5699985695414696`*^9}, 
   3.5699986469176054`*^9, {3.603780741614785*^9, 
   3.603780745795593*^9}},ExpressionUUID->"273d4489-900c-4285-a741-\
07e99afbbd25"],

Cell[BoxData[
 RowBox[{"Length", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5699986036899295`*^9, 
  3.569998610834742*^9}},ExpressionUUID->"b3917f42-5478-4e29-a94b-\
059f32d967de"],

Cell[BoxData[
 RowBox[{"type", "[", 
  RowBox[{"epst", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5699992721667037`*^9, 
  3.5699992974699483`*^9}},ExpressionUUID->"0f0429ee-21ca-489f-8c5b-\
9061fe3c8b30"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["tx", 
   RowBox[{"i_", " "}]], ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{
    SubscriptBox["x", "i"], ",", "0", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5699988401551447`*^9, 3.5699988934604387`*^9}, {
  3.5699989322577066`*^9, 3.56999900250463*^9}, {3.569999034921487*^9, 
  3.5699991054804106`*^9}},ExpressionUUID->"ef696055-5789-4fe8-8bb1-\
aaacaa3f7b83"],

Cell[BoxData[
 SubscriptBox["tx", 
  RowBox[{"1", " "}]]], "Input",ExpressionUUID->"5d0932f1-bc6f-435a-9447-e14aeb715424"],

Cell[BoxData[
 RowBox[{"?", "contraction"}]], "Input",
 CellChangeTimes->{{3.569999134153261*^9, 
  3.569999139628871*^9}},ExpressionUUID->"49f868ee-e4bc-4c69-b4ef-\
6680a052bc9e"],

Cell[BoxData[
 RowBox[{"txalt", " ", "=", " ", 
  RowBox[{"contraction", "[", 
   RowBox[{
    RowBox[{"tensorproduct", "[", 
     RowBox[{
      RowBox[{"epst", "[", "3", "]"}], ",", 
      SubscriptBox["tx", 
       RowBox[{"1", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"2", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"3", " "}]]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "6"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5699992059757876`*^9, 3.5699992479398613`*^9}, {
  3.5699993129763756`*^9, 
  3.5699994782274656`*^9}},ExpressionUUID->"387f559c-afbe-4e2e-8612-\
83c1579cf0a0"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"strictcoords", "[", "txalt", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6445721698333073`*^9, 3.644572180753327*^9}, {
   3.6447427615144477`*^9, 3.644742765601655*^9}, 
   3.6447428055397253`*^9},ExpressionUUID->"357727c3-43b7-4ed1-a4d4-\
58bc85b06219"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Timing", "[", 
   RowBox[{"strictcoords", "[", 
    RowBox[{"wedge", "[", 
     RowBox[{
      SubscriptBox["tx", 
       RowBox[{"1", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"2", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"3", " "}]]}], "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.603697292687498*^9, {3.644572267462679*^9, 3.6445722866663127`*^9}, 
   3.644742650993853*^9, {3.644742784899889*^9, 
   3.6447428115301356`*^9}},ExpressionUUID->"eee1a313-ce37-4eef-b653-\
9d5aed600530"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"%", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "-", 
    RowBox[{"%%", "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644572505550297*^9, 3.644572516439116*^9}, 
   3.6447427913593*^9, {3.6447451573356667`*^9, 3.6447451632480774`*^9}, {
   3.6447453423639927`*^9, 3.6447453707112427`*^9}, {3.644745507829884*^9, 
   3.644745516363099*^9}, {3.6447455635571823`*^9, 3.644745586304022*^9}, {
   3.6447457086338377`*^9, 
   3.644745725497467*^9}},ExpressionUUID->"8170d4a6-10ba-4573-ac47-\
7bbcd5822bf5"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"equi", "[", 
   RowBox[{"txalt", ",", 
    RowBox[{"wedge", "[", 
     RowBox[{
      SubscriptBox["tx", 
       RowBox[{"1", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"2", " "}]], ",", 
      SubscriptBox["tx", 
       RowBox[{"3", " "}]]}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5699995402219744`*^9, 3.5699995616252117`*^9}, 
   3.5699996079728937`*^9, {3.569999638923348*^9, 3.569999672759807*^9}, 
   3.5699997389351234`*^9, 3.644645156192795*^9, 3.644742066336022*^9, {
   3.644742798192112*^9, 
   3.6447428190981493`*^9}},ExpressionUUID->"e3311be1-bb49-4ce6-9d63-\
334f33ccd077"],

Cell["\<\
The epsilon function (or the tensor epst) can be used to define the wedge \
product. For the determinant one has\
\>", "Text",
 CellChangeTimes->{{3.6446474036107426`*^9, 3.644647496930106*^9}, {
  3.64474209959628*^9, 
  3.6447421012342834`*^9}},ExpressionUUID->"3fb609d7-d189-4c4a-89fc-\
fb27003c3c44"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "4"}], ";", 
  RowBox[{"ssd", " ", "=", 
   RowBox[{"Permutations", "[", 
    RowBox[{"Range", "[", "dim", "]"}], "]"}]}], ";", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"eps", "[", 
      RowBox[{
       RowBox[{"Range", "[", "dim", "]"}], ",", 
       RowBox[{"ssd", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "*", 
     RowBox[{"x", "[", 
      RowBox[{"ssd", "[", 
       RowBox[{"[", 
        RowBox[{"j", ",", "1"}], "]"}], "]"}], "]"}], "*", 
     RowBox[{"y", "[", 
      RowBox[{"ssd", "[", 
       RowBox[{"[", 
        RowBox[{"j", ",", "2"}], "]"}], "]"}], "]"}], "*", 
     RowBox[{"z", "[", 
      RowBox[{"ssd", "[", 
       RowBox[{"[", 
        RowBox[{"j", ",", "3"}], "]"}], "]"}], "]"}], "*", 
     RowBox[{"w", "[", 
      RowBox[{"ssd", "[", 
       RowBox[{"[", 
        RowBox[{"j", ",", "4"}], "]"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"dim", "!"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6446450408929925`*^9, 3.6446451332295547`*^9}, {
   3.6446451728848243`*^9, 3.6446453020062513`*^9}, {3.644645504135806*^9, 
   3.6446455226998386`*^9}, {3.6446457320522065`*^9, 
   3.6446457974007215`*^9}, {3.644645851018015*^9, 3.6446458659316416`*^9}, {
   3.644645915305728*^9, 3.644645971762227*^9}, 3.6446460571723776`*^9, {
   3.6446461648281665`*^9, 3.6446462054038377`*^9}, 3.644646330001257*^9, {
   3.6446464638182917`*^9, 3.6446464952835464`*^9}, {3.6446465429104304`*^9, 
   3.644646573954485*^9}, 3.6446466192413645`*^9, {3.644647238983653*^9, 
   3.6446472835997314`*^9}},ExpressionUUID->"7124c3a4-34d8-4b74-82cd-\
4031d0c42d13"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"Det", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vec", "[", "x", "]"}], ",", 
     RowBox[{"vec", "[", "y", "]"}], ",", 
     RowBox[{"vec", "[", "z", "]"}], ",", 
     RowBox[{"vec", "[", "w", "]"}]}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6446463460848846`*^9, 3.6446463869413567`*^9}, {
  3.644647341257433*^9, 
  3.644647349400647*^9}},ExpressionUUID->"f1bfd562-dc67-40a8-bcf8-\
3781f4ad3f55"],

Cell["\<\
For dimensions dim > 4 the tensor operations are very time consuming:\
\>", "Text",
 CellChangeTimes->{{3.644647539752181*^9, 
  3.6446475864898634`*^9}},ExpressionUUID->"ec09a085-4e61-468e-95ea-\
928f9ad46f3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", "5"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "0"}], "]"}]}], ";", 
  RowBox[{"tb", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "2", ",", "0"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5700278834087615`*^9, 3.570027942486065*^9}, {
  3.6445821656476183`*^9, 
  3.6445821835096493`*^9}},ExpressionUUID->"bf91e222-1558-4393-9150-\
bfddc53a9426"],

Cell[BoxData[
 RowBox[{"tab", " ", "=", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{
    RowBox[{"epst", "[", "4", "]"}], ",", "ta", ",", "tb"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.5700279981625633`*^9, 
  3.570028082246711*^9}},ExpressionUUID->"36b30ff8-f5cc-4874-9fae-\
b4d3b86d1853"],

Cell[BoxData[
 RowBox[{"alt4", " ", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"tab", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"5", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8", ",", "4"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570028153148835*^9, 
  3.5700282546582136`*^9}},ExpressionUUID->"6215334d-c30a-41c7-9fb9-\
31444c7c40c4"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"strictcoords", "[", "alt4", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570028272629445*^9, 3.5700282957330856`*^9}, {
  3.644572833431673*^9, 3.6445728483920994`*^9}, {3.6445822246469216`*^9, 
  3.6445822393421474`*^9}},ExpressionUUID->"a608f611-ed03-4374-99ef-\
adba65ae1e2e"],

Cell[BoxData[
 RowBox[{"4039.1934921`", "/", "60"}]], "Input",
 CellChangeTimes->{{3.6445867912558885`*^9, 
  3.644586800263404*^9}},ExpressionUUID->"4726e8ee-b9c8-4db0-afa0-\
df38dafe5d4b"],

Cell["The program needed 67 min for this calculation.", "Text",
 CellChangeTimes->{{3.603783178619866*^9, 3.6037832059511137`*^9}, {
  3.6445871244779477`*^9, 
  3.644587176837942*^9}},ExpressionUUID->"9c6ac9e6-b365-47e1-83fe-\
dfffdf1522b0"],

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"%%", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.644586961664635*^9, 
  3.6445869804897118`*^9}},ExpressionUUID->"6d7800d9-1d2c-4e30-a834-\
055d7b8ec382"],

Cell[BoxData[
 RowBox[{"%%%", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6445870309455976`*^9, 
  3.6445870457664456`*^9}},ExpressionUUID->"c26cfdb6-703b-4972-ae9f-\
14e1fb02750a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"alt4", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "+", 
  RowBox[{"alt4", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570028652380912*^9, 3.570028667856139*^9}, 
   3.6037149412487073`*^9, {3.603714976056698*^9, 3.6037149783518295`*^9}, {
   3.6037150506649656`*^9, 
   3.6037150724482117`*^9}},ExpressionUUID->"f44a37b9-81c5-4451-b2e5-\
d7a01420fa05"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["5. Tensors in Mathematica", "Section",
 CellChangeTimes->{{3.567755243157072*^9, 3.5677552670095143`*^9}, 
   3.567837603936112*^9, {3.5678376832136464`*^9, 3.5678377096541586`*^9}, {
   3.5700307852390585`*^9, 3.570030787766263*^9}, {3.5701675033603783`*^9, 
   3.5701675120963936`*^9}, 3.5702025346333437`*^9, 3.603695144088606*^9, 
   3.6037205024467897`*^9},
 CellTags->"S5",ExpressionUUID->"816e6119-d58b-4742-b7bd-19e91ef7e3de"],

Cell[CellGroupData[{

Cell["5.1. The Built-in Tensor Functions", "Subsection",
 CellChangeTimes->{{3.5678392849112587`*^9, 
  3.5678393122538223`*^9}},ExpressionUUID->"81c59322-12d3-42eb-b992-\
5a58c9159822"],

Cell[TextData[{
 " In ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " the word Tensor is used for Arrays in contexts of specific applications, \
e.g. operations and concepts of tensor algebra, Tensor itself remains \
undefined:"
}], "Text",
 CellChangeTimes->{{3.563804277570985*^9, 3.563804485020149*^9}, {
   3.56380452534622*^9, 3.5638045319762316`*^9}, 3.5638046349301395`*^9, 
   3.5638048226018744`*^9},ExpressionUUID->"b66bd48f-5d19-4990-a610-\
a0f075786cc8"],

Cell[BoxData[
 RowBox[{"?", "Tensor"}]], "Input",
 CellChangeTimes->{{3.563608412907118*^9, 
  3.5636084179324055`*^9}},ExpressionUUID->"e8b37c23-f7d6-479c-991c-\
2ca19068dc7f"],

Cell["\<\
On the other hand, there are some built-in functions using the word Tensor. \
e.g.\
\>", "Text",
 CellChangeTimes->{{3.563804651258074*^9, 3.563804697801736*^9}, {
  3.5675748938153195`*^9, 
  3.5675748953285217`*^9}},ExpressionUUID->"2b0aa53d-5458-4397-872f-\
a3bffceb95ea"],

Cell[BoxData[
 RowBox[{"?", "*Tensor*"}]], "Input",
 CellChangeTimes->{{3.5677548691064157`*^9, 3.5677548821324387`*^9}, 
   3.5700871064284267`*^9},ExpressionUUID->"0d445829-c750-42ab-9d7a-\
d6150d4fe9a7"],

Cell["\<\
LeviCivitaTensor - is a special case of the epsilon tensor 
TensorContract corresponds to contraction, acts on Arrays.
TensorExpand acts symbolically on all kind of distributive products.
TensorDimensions acts on Arrays.
TensorProduct acts on Arrays of tensor coordinates.
TensorQ is not explained.
TensorRank acts on Arrays.
TensorReduce acts on Arrays, symmetry properties may be added as Options or \
Assumptions.
TensorSymmetry yields the symmetry properties of explicit or symbolic Arrays.
TensorTranspose acts on Arrays of tensor coordinates.
TensorWedge acts on Arrays of tensor coordinates\
\>", "Text",
 CellChangeTimes->{{3.567760608108644*^9, 3.5677607662366886`*^9}, {
   3.5677610479248*^9, 3.567761147140475*^9}, {3.567764576940648*^9, 
   3.567764606532341*^9}, {3.5677651470282555`*^9, 3.5677651700205708`*^9}, {
   3.567765610212748*^9, 3.5677656709482217`*^9}, {3.5677658318044224`*^9, 
   3.567765896516124*^9}, 3.5677663820048923`*^9, {3.567767237196806*^9, 
   3.5677672507725825`*^9}, {3.5678391620872335`*^9, 3.5678392401837*^9}, {
   3.5685222421292295`*^9, 3.568522247714039*^9}, {3.568522279054494*^9, 
   3.568522392700694*^9}, {3.5700874727950706`*^9, 3.5700874783330803`*^9}, {
   3.570107043156208*^9, 3.570107078883251*^9}, 3.5701678431133747`*^9, {
   3.5701678981346717`*^9, 3.570167956369574*^9}, {3.5701699036293583`*^9, 
   3.570170005725198*^9}, 3.5701702151251745`*^9, {3.5701702500131702`*^9, 
   3.5701702749095945`*^9}, 3.570605848157755*^9, {3.6011845506569347`*^9, 
   3.6011845529033384`*^9}, 
   3.644757568463842*^9},ExpressionUUID->"69f48dce-65f9-452d-8387-\
a764cd2ff4ab"],

Cell[TextData[{
 "The concepts of Tensors in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " are considered in the tutorial ",
 ButtonBox["Symbolic Tensors",
  BaseStyle->"Link",
  ButtonData->"paclet:tutorial/SymbolicTensors"],
 "."
}], "Text",
 CellChangeTimes->{{3.570168296200571*^9, 3.570168355621075*^9}, 
   3.5701684177659845`*^9, {3.5701684782316904`*^9, 3.5701685373801937`*^9}, {
   3.570168590248687*^9, 
   3.570168590248687*^9}},ExpressionUUID->"2063b079-7780-476c-866b-\
7eb655269372"],

Cell[BoxData[""],
 CellChangeTimes->{
  3.570168635613567*^9},ExpressionUUID->"bc46a97b-ff81-48f8-bb23-\
5e6c2724a5ef"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2. Tensors and Arrays ", "Subsection",
 CellChangeTimes->{{3.57019680079795*^9, 3.570196814635174*^9}, {
   3.570196850125236*^9, 3.570196853604042*^9}, {3.5701969038985305`*^9, 
   3.570196936642988*^9}, {3.570281898000814*^9, 3.570281903304823*^9}, {
   3.6035524498167067`*^9, 3.6035524681467385`*^9}, 
   3.6037169266302643`*^9},ExpressionUUID->"1283d220-81dc-4258-999e-\
16dad1daa44e"],

Cell[CellGroupData[{

Cell["5.2.1 TensorQ and ArrayQ", "Subsubsection",
 CellChangeTimes->{{3.5702819984649906`*^9, 
  3.5702820184954257`*^9}},ExpressionUUID->"b27a1fcf-f7f3-4ee9-b4f7-\
9ec533101a53"],

Cell[TextData[{
 "Reading the first passage in the tutorial Symbolic Tensors one supposes \
that Tensor and Array are synonyms in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". On the other hand, there exists a function"
}], "Text",
 CellChangeTimes->{{3.570196985642674*^9, 3.5701970143935246`*^9}, 
   3.5701970605228057`*^9, {3.5701971200549107`*^9, 3.570197160115781*^9}, {
   3.5701972557844105`*^9, 3.5701972903523874`*^9}, {3.570197370361964*^9, 
   3.5701973923132195`*^9}, 3.5703363925218077`*^9, 
   3.6447576869515505`*^9},ExpressionUUID->"895355cf-bda0-4ee6-a85f-\
31834569f2af"],

Cell[BoxData[
 RowBox[{"?", "TensorQ"}]], "Input",
 CellChangeTimes->{{3.570112272200292*^9, 3.570112275987509*^9}, 
   3.570197409773218*^9},ExpressionUUID->"712748b4-e513-4f14-a83d-\
246cf45b5bcd"],

Cell[TextData[{
 "without any explanation.  Thus, the situation is a bit strange: this \
function is expected to test whether a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " object is a tensor, but Tensor is not defined in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". Further we have the function"
}], "Text",
 CellChangeTimes->{{3.5701974360737224`*^9, 3.5701975981289916`*^9}, {
   3.5701977093933554`*^9, 3.57019771996096*^9}, 
   3.6447577407998123`*^9},ExpressionUUID->"6e75e414-503e-4d1d-99b8-\
16a93ab3f307"],

Cell[BoxData[
 RowBox[{"?", "ArrayQ"}]], "Input",
 CellChangeTimes->{{3.5701977243172092`*^9, 
  3.5701977392830653`*^9}},ExpressionUUID->"b054dac1-0bb4-43bf-b8fd-\
e50abe81650b"],

Cell[TextData[{
 "very detailed explained. We could not find objects for which the values of \
both functions differ. Thus our hypothesis that Array and Tensor mean the \
same in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " is confirmed."
}], "Text",
 CellChangeTimes->{{3.570197757532109*^9, 3.5701977918250704`*^9}, 
   3.570197831753354*^9, {3.570197865585289*^9, 3.570198001009035*^9}, {
   3.5703364441734986`*^9, 3.5703364458583016`*^9}, 
   3.6447577644854555`*^9},ExpressionUUID->"53f57534-46b4-40cc-a8a9-\
2b412bdf440e"],

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "4", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellID->43782948,ExpressionUUID->"4aa982e6-7614-435c-86ef-aa6c576483be"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%", "]"}]], "Input",
 CellID->64680695,ExpressionUUID->"508ac18a-2ac1-400b-95d7-dc32003880da"],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.6446738361780863`*^9, 
  3.6446738439937*^9}},ExpressionUUID->"d24f6fba-2a83-45c4-b552-cea81bcbba62"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", "%%%", "]"}]], "Input",
 CellChangeTimes->{{3.6446738685637436`*^9, 
  3.6446738963161917`*^9}},ExpressionUUID->"b8a8bfe5-0e79-48d0-a079-\
818ac5ac43f3"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5701980450575542`*^9, 3.5701980565072093`*^9}},
 CellID->89477187,ExpressionUUID->"2e3ab514-0b4f-44ec-a4a8-12a32e40675f"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5701980629885798`*^9, 
  3.5701980823276863`*^9}},ExpressionUUID->"6a8297de-d942-44b7-993a-\
b29453119102"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gr1", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"Line", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.570113102524784*^9, 3.5701132031015368`*^9}, {
  3.570113311406731*^9, 3.570113331958907*^9}, {3.5701146352624516`*^9, 
  3.570114647190134*^9}},ExpressionUUID->"91e94272-117c-4e8b-bcc9-\
5cb469af61aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"Line", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}]}], "}"}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.570113102524784*^9, 3.5701132031015368`*^9}, {
   3.570113311406731*^9, 3.570113331958907*^9}, {3.5701133752393827`*^9, 
   3.570113377806529*^9}, {3.5701138992943563`*^9, 3.5701139317422123`*^9}, 
   3.570198115891606*^9},ExpressionUUID->"0511059a-1ae0-499d-b4c1-\
6bc4af3200c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"agr", " ", "=", " ", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5701139456070056`*^9, 3.570113975445712*^9}, 
   3.5701146780779004`*^9},ExpressionUUID->"f6bff126-d006-4a92-98ec-\
9581fe5923d7"],

Cell[BoxData[
 RowBox[{"a", "[", 
  RowBox[{"1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.570198143254171*^9, 
  3.5701981479464393`*^9}},ExpressionUUID->"b190b692-e168-46bf-a54c-\
22f020ca2ab0"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "agr", "]"}]], "Input",
 CellChangeTimes->{{3.5701139986680403`*^9, 
  3.5701140068305073`*^9}},ExpressionUUID->"c7866b7b-c22f-46d8-8d32-\
2ad49094ba72"],

Cell[BoxData[
 RowBox[{"agr", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "2"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5701147096727076`*^9, 
  3.570114716939123*^9}},ExpressionUUID->"f715678a-2d75-475d-a095-\
11e44432bf33"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "b", "]"}], ";", 
  RowBox[{
   RowBox[{"b", "[", 
    RowBox[{"i_", ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"i", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"i", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.570114025896598*^9, 3.570114136877946*^9}, 
   3.570114167254683*^9, {3.5701142160864763`*^9, 
   3.57011428923866*^9}},ExpressionUUID->"835d7069-d89f-4bb5-b4e2-\
f80ab5bee511"],

Cell[BoxData[
 RowBox[{"tbb", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "3", ",", "0", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5701143429497323`*^9, 
  3.570114376181633*^9}},ExpressionUUID->"43e3dc8a-1559-4721-a04f-\
b6b74930fe8b"],

Cell[BoxData[
 RowBox[{"coords", "[", "tbb", "]"}]], "Input",
 CellChangeTimes->{{3.5701143874762793`*^9, 3.5701143984789085`*^9}, 
   3.5701147514700985`*^9, 
   3.5701982777708645`*^9},ExpressionUUID->"c3b51c4d-b6bb-4c60-9ce5-\
e1fa814da10a"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5701983130638833`*^9, 
  3.570198320434305*^9}},ExpressionUUID->"6bcfde06-34c0-4923-9f4e-\
0b9e16fedcb5"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.570198325815613*^9, 
  3.5701983343941035`*^9}},ExpressionUUID->"d5694132-904f-4e39-84c2-\
0dacaaf0ad8c"],

Cell["\<\
We see that both objects, Array and our tensor, may have unusual coordinates.\
\
\>", "Text",
 CellChangeTimes->{{3.570198367184979*^9, 
  3.570198431144637*^9}},ExpressionUUID->"4eb11601-f6c6-4ebc-81f7-\
bf02575632e5"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", 
  RowBox[{"Range", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570113422705097*^9, 
  3.570113466893625*^9}},ExpressionUUID->"8a758c56-e7a3-477c-a21e-\
60ec778cd6fe"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", 
  RowBox[{"Range", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570113422705097*^9, 3.570113466893625*^9}, {
  3.5701984905610356`*^9, 
  3.57019852700212*^9}},ExpressionUUID->"5d901dd9-17e9-4597-bcda-\
56de01a7bc5b"],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Head", "[", "aa", "]"}], " ", "==", "  ", "List"}], ",", " ", 
   RowBox[{"TensorQ", "[", "aa", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5701134895299196`*^9, 3.5701135487253056`*^9}, {
  3.5701135819822073`*^9, 
  3.570113594389917*^9}},ExpressionUUID->"c2fbc072-9803-4ff2-a78a-\
b2ad03801204"],

Cell[BoxData[
 RowBox[{"Assuming", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Head", "[", "aa", "]"}], " ", "==", "  ", "List"}], ",", " ", 
   RowBox[{"ArrayQ", "[", "aa", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5701134895299196`*^9, 3.5701135487253056`*^9}, {
  3.5701135819822073`*^9, 3.570113594389917*^9}, {3.570198574888859*^9, 
  3.570198582152274*^9}},ExpressionUUID->"a3784e33-6c9b-48e0-902a-\
d689a59b615d"],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Assuming", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Head", "[", "aa", "]"}], " ", "==", "  ", "List"}], ",", " ", 
    RowBox[{"ArrayQ", "[", "aa", "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5701986053195996`*^9, 
  3.5701986359873533`*^9}},ExpressionUUID->"ba919f5e-e8c8-4976-8cc3-\
63f9a1fc240f"],

Cell["Here is a List not being an Array nor a Tensor:", "Text",
 CellChangeTimes->{{3.5701987788895273`*^9, 
  3.5701988059290733`*^9}},ExpressionUUID->"71fa0263-283b-4d69-be56-\
96e8116c5b83"],

Cell[BoxData[
 RowBox[{"anti", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{"aa", ",", 
    RowBox[{"{", 
     RowBox[{"aa", ",", "bb"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", "cc", "}"}], "}"}], ",", "dd"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5701986557394834`*^9, 
  3.5701986951147356`*^9}},ExpressionUUID->"09766b05-6b60-40a5-8187-\
3bd3876059a4"],

Cell[BoxData[
 RowBox[{"Head", "[", "anti", "]"}]], "Input",
 CellChangeTimes->{{3.570198708859522*^9, 3.570198715801919*^9}, 
   3.5701987621395693`*^9},ExpressionUUID->"b3a7e8ac-e34e-42e6-bc8a-\
c2dd41b23700"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"TensorQ", "[", 
   RowBox[{"{", "anti", "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5701134895299196`*^9, 3.5701135487253056`*^9}, {
  3.5701135819822073`*^9, 3.5701136329491224`*^9}, {3.57019872823563*^9, 
  3.570198728987673*^9}},ExpressionUUID->"525fd9af-dfd6-4b1b-a60d-\
391d6eb01ba9"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", "anti", "]"}]], "Input",
 CellChangeTimes->{{3.5701987346039944`*^9, 
  3.5701987451645985`*^9}},ExpressionUUID->"b585a300-8feb-42bb-97e8-\
5f32a69c7c2a"],

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"f", ",", "5", ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5701996119011726`*^9, 3.570199634770481*^9}, 
   3.570199700003212*^9},ExpressionUUID->"755bd59b-bb10-4c24-92de-\
f48e00bbb4ee"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", 
  RowBox[{"Array", "[", 
   RowBox[{"f", ",", "5", ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "20"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570199557393055*^9, 3.570199581155414*^9}, {
  3.5701996430999575`*^9, 
  3.570199664779197*^9}},ExpressionUUID->"1f2aa66d-f71b-4d44-8e78-\
c2d9db9c140e"],

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"f", ",", " ", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "/", "2"}], ",", 
       RowBox[{"1", "/", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570199803555135*^9, 
  3.570199806587308*^9}},ExpressionUUID->"dd13752c-0ed8-4613-91fa-\
93abc7ac9edf"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5701998107745476`*^9, 
  3.570199822115196*^9}},ExpressionUUID->"d424ee00-a04a-4bad-ab18-\
32cdf4514224"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "a", "]"}], ";", 
  RowBox[{"Array", "[", 
   RowBox[{"a", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", "1", ",", "Plus"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5701999434671373`*^9, 
  3.5701999509395647`*^9}},ExpressionUUID->"ba9c7009-3868-4241-b668-\
de615e0cfd84"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.570199883938732*^9, 
  3.570199893546282*^9}},ExpressionUUID->"62ad10aa-b846-4968-9ac2-\
4021aad8aa0d"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.570199883938732*^9, 
  3.57019992428304*^9}},ExpressionUUID->"cc0f0f24-f462-4d1a-8cbc-\
a68f7abdeff2"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.2. tensorToArray", "Subsubsection",
 CellChangeTimes->{{3.570282982940561*^9, 3.5702830266430607`*^9}, 
   3.570451962158984*^9, {3.6035275901374674`*^9, 3.603527592742672*^9}},
 CellTags->"arr",ExpressionUUID->"47ad86af-4360-4bbb-8ceb-3a2b871ce037"],

Cell[TextData[{
 "In the following we consider Arrays as Tensors in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". To compare these  Tensors with the tensor concept in",
 " tensalgv2.m",
 " we define a function tensorToArray[ta] returning an Array with the \
coordinates of ta as elements:"
}], "Text",
 CellChangeTimes->{{3.5702008961206255`*^9, 3.5702010635051994`*^9}, 
   3.570269328971366*^9, {3.570269369609437*^9, 3.570269444583169*^9}, {
   3.570282640050949*^9, 3.57028270598772*^9}, {3.570282748004123*^9, 
   3.5702827573956604`*^9}, {3.5702827999160924`*^9, 
   3.5702828603555493`*^9}, {3.5708043080108614`*^9, 3.570804312370111*^9}, 
   3.642501434002819*^9},ExpressionUUID->"194e33da-c3cd-4467-b646-\
a71c2056c52d"],

Cell[BoxData[
 RowBox[{"?", "tensorToArray"}]], "Input",
 CellChangeTimes->{{3.5702845885653973`*^9, 
  3.570284597068884*^9}},ExpressionUUID->"d15c63f5-5183-4a9e-bd4d-\
85a38cc8c590"],

Cell["The definition contained in tensalgv2.m is", "Text",
 CellChangeTimes->{{3.603527118392639*^9, 3.6035271353810687`*^9}, 
   3.642501434034019*^9},ExpressionUUID->"154f0296-6ec0-4398-bf88-\
4e3979aeef80"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"tensorToArray", ",", "Listable"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"tensorToArray", "[", "tt_", "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ti", ",", "aa", ",", "k", ",", "h", ",", "dd", ",", "bb", ",", "i"}], 
      "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"Head", "[", "tt", "]"}], "===", " ", "tensor"}], "]"}], 
        ",", 
        RowBox[{
         RowBox[{
         "Print", "[", "\"\<The argument must be a tensor!\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"ti", " ", "=", " ", 
       RowBox[{"type", "[", "tt", "]"}]}], ";", 
      RowBox[{"aa", " ", "=", " ", 
       RowBox[{"ti", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
      RowBox[{"k", " ", "=", " ", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"h", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"dd", " ", "=", 
       RowBox[{"ti", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"Off", "[", 
       RowBox[{"Part", "::", "take"}], "]"}], ";", "\n", " ", 
      RowBox[{
       RowBox[{"bb", "[", "i___", "]"}], ":=", " ", 
       RowBox[{"aa", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "i", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", "k"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", "i", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"k", "+", "1"}], ";;", 
            RowBox[{"k", "+", "h"}]}], "]"}], "]"}]}], "]"}]}], ";", "\n", 
      RowBox[{"Array", "[", 
       RowBox[{"bb", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"dd", ",", 
          RowBox[{"{", 
           RowBox[{"k", "+", "h"}], "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\n"}], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.570269539103735*^9, 3.570269541537339*^9}, 
   3.5702700651366587`*^9, {3.57028258254766*^9, 3.5702826072440724`*^9}, {
   3.5703368345485845`*^9, 3.5703368586038265`*^9}, {3.570337115083877*^9, 
   3.5703371342563105`*^9}, {3.570337474651309*^9, 3.5703374771785135`*^9}, {
   3.5703382703931065`*^9, 3.5703383212959957`*^9}, {3.5703390243736305`*^9, 
   3.570339031222043*^9}, 3.570339062718498*^9, {3.570417545743101*^9, 
   3.5704175917631817`*^9}, 3.5704348068624716`*^9, 
   3.603525567515915*^9},ExpressionUUID->"2dcbfd0c-87cf-42c7-87c4-\
afc767db1bbb"],

Cell[TextData[{
 StyleBox["Example",
  FontColor->RGBColor[0, 0, 1]],
 "s\nEnter the  parameters in tensor arbitrarily and control the results in \
the following cells:"
}], "Text",
 CellChangeTimes->{{3.603527148095091*^9, 3.6035272341604424`*^9}, 
   3.6035275331973677`*^9},ExpressionUUID->"4d66bd9b-7d49-4ea2-955e-\
e33c6e75088b"],

Cell[BoxData[
 RowBox[{"ta", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "2", ",", "4", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5702010672254124`*^9, 3.5702010847234135`*^9}, 
   3.5702696919372034`*^9, 3.570285491895065*^9, {3.5703365595981016`*^9, 
   3.570336565697712*^9}, 3.60352650977317*^9, {3.6035267573300047`*^9, 
   3.603526761900813*^9}},ExpressionUUID->"97fe91cc-367f-40a4-967e-\
ea616410f3e7"],

Cell[BoxData[
 RowBox[{"type", "[", "ta", "]"}]], "Input",
 CellChangeTimes->{{3.5703370727610025`*^9, 
  3.570337078579813*^9}},ExpressionUUID->"b46f0158-33c6-44df-9363-\
bcc87525b502"],

Cell[BoxData[
 RowBox[{"taa", " ", "=", " ", 
  RowBox[{"tensorToArray", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.570268919267846*^9, 3.570268942465087*^9}, {
   3.5702696623595514`*^9, 3.570269666743159*^9}, {3.5702841943898516`*^9, 
   3.5702842054474845`*^9}, 
   3.5703369666340165`*^9},ExpressionUUID->"7aaac2ff-5841-4f38-8d4f-\
f72459854469"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", "taa", "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, {
   3.5702692375708055`*^9, 3.5702692470244217`*^9}, 3.5702699245180116`*^9, 
   3.57028540631717*^9, 3.5702855137683163`*^9, {3.570418010499117*^9, 
   3.570418018392731*^9}},ExpressionUUID->"2c9f7364-e26d-4ee7-8318-\
6c799055dedf"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", "taa", "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, 
   3.5702698451294723`*^9, {3.5704179707502475`*^9, 
   3.5704179809526653`*^9}},ExpressionUUID->"118272e9-5e10-4580-99c5-\
a65da1a202a0"],

Cell[BoxData[
 RowBox[{"taa", "[", 
  RowBox[{"[", 
   RowBox[{"3", ",", "1", ",", "2", ",", "3", ",", "1", ",", "2"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5704520428423257`*^9, 3.570452085882801*^9}, {
  3.6035265541552477`*^9, 3.603526588724909*^9}, {3.6035268357981424`*^9, 
  3.603526848153364*^9}},ExpressionUUID->"1e6fe6f9-92ca-4350-8f75-\
3423828fd4fa"],

Cell[BoxData[
 RowBox[{"tac", "=", 
  RowBox[{"coords", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.570201090830763*^9, 3.5702011062106423`*^9}, {
   3.570269793836582*^9, 3.570269797767789*^9}, {3.570269865113107*^9, 
   3.5702698793247323`*^9}, 
   3.5703369532491927`*^9},ExpressionUUID->"784ffd70-60ff-45c3-b3ae-\
121277eb9b17"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", "tac", "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, {
   3.5702692375708055`*^9, 3.5702692470244217`*^9}, 3.5702699245180116`*^9, 
   3.57028540631717*^9, 
   3.5702855137683163`*^9},ExpressionUUID->"afb44aee-a5ec-4192-bdd5-\
128c000b2b73"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", "tac", "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, 
   3.5702698451294723`*^9},ExpressionUUID->"171e9ecc-d2a5-4da5-b4e1-\
2b6f3f5b3b15"],

Cell["\<\
tac and taa differ as Arrays, but the sorted Lists of all their elements \
coincide:\
\>", "Text",
 CellChangeTimes->{{3.603527405152343*^9, 
  3.603527460080039*^9}},ExpressionUUID->"386c48b5-fd02-4f3a-bc3c-\
e3518b4e8f04"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sort", "[", 
   RowBox[{"Flatten", "[", "tac", "]"}], " ", "]"}], "\[Equal]", 
  RowBox[{"Sort", "[", " ", 
   RowBox[{"Flatten", "[", "taa", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6035270112360506`*^9, 
  3.603527068659752*^9}},ExpressionUUID->"bcc7cb65-4615-4360-829f-\
03f2ba675276"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", 
  RowBox[{"coords", "[", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, {
   3.5702692375708055`*^9, 3.5702692470244217`*^9}, 3.5702699245180116`*^9, 
   3.57028540631717*^9, 3.5702855137683163`*^9, {3.570418010499117*^9, 
   3.570418018392731*^9}, {3.6035170952346344`*^9, 3.603517156636342*^9}, {
   3.603517324227436*^9, 
   3.60351732642704*^9}},ExpressionUUID->"e9669d4e-332e-4ac8-ae54-\
ec85b1ecba73"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "3", ",", "0", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6035173681727133`*^9, 3.6035174110259886`*^9}, {
  3.603525802920328*^9, 
  3.6035258143863487`*^9}},ExpressionUUID->"bd170ab5-9baf-4b87-b1ad-\
6de905008770"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", 
  RowBox[{"tensorToArray", "[", 
   RowBox[{"nulltensor", "[", 
    RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5702689486582975`*^9, 3.5702689587515154`*^9}, {
   3.5702692375708055`*^9, 3.5702692470244217`*^9}, 3.5702699245180116`*^9, 
   3.57028540631717*^9, 3.5702855137683163`*^9, {3.570418010499117*^9, 
   3.570418018392731*^9}, {3.6035170952346344`*^9, 3.603517187274796*^9}, {
   3.6035172290984697`*^9, 
   3.6035172372884836`*^9}},ExpressionUUID->"9337294f-077f-4bbe-a7a1-\
cf6ef73ddf9f"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "0", ",", "0"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.603517466296886*^9, 
  3.6035174980741415`*^9}},ExpressionUUID->"43008d96-66d9-4417-a7cd-\
4fc800bc5061"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "1", ",", "0"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.603517466296886*^9, 3.6035174980741415`*^9}, {
  3.603517534484606*^9, 
  3.603517541535818*^9}},ExpressionUUID->"bae68ca8-cb5b-4644-bb14-\
56a12b342ec5"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "0", ",", "1"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.603517466296886*^9, 3.6035174980741415`*^9}, {
  3.603517534484606*^9, 3.603517541535818*^9}, {3.6035175902547035`*^9, 
  3.6035175994119196`*^9}},ExpressionUUID->"d8eb1f80-0130-4a97-9b33-\
b0eefd2360eb"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.3. ArrayTotensor", "Subsubsection",
 CellChangeTimes->{{3.603347495046262*^9, 3.6033475076354837`*^9}, {
   3.603527619605919*^9, 3.6035276260955305`*^9}, {3.6035306062424593`*^9, 
   3.603530607911662*^9}, 
   3.6035510986983333`*^9},ExpressionUUID->"3aeee520-16bb-4f84-9b4c-\
fa011460c978"],

Cell[BoxData[
 RowBox[{"?", "ArrayTotensor"}]], "Input",
 CellChangeTimes->{{3.5704357366865044`*^9, 
  3.5704357376537066`*^9}},ExpressionUUID->"1d02e17d-297a-4ea4-bbee-\
c100bcc9d2bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ArrayTotensor", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"k_:", "0"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "rg", ",", "dd", " ", ",", "tt", ",", "ii", ",", "jj", ",", "b"}], 
      "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ArrayQ", "[", "a", "]"}], ",", 
        RowBox[{"rg", " ", "=", " ", 
         RowBox[{"TensorRank", "[", "a", "]"}]}], ",", "\n", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Argument must be an Array!\>\"", "]"}], 
         ";", " ", 
         RowBox[{"Return", "[", "]"}]}], ",", "\n", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Argument must be an Array!\>\"", "]"}], 
         ";", " ", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"k", "<", "0"}], ")"}], "||", 
         RowBox[{"(", 
          RowBox[{"k", ">", "rg"}], ")"}], "||", 
         RowBox[{"Not", "[", 
          RowBox[{"IntegerQ", "[", "k", "]"}], "]"}]}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"k", " ", ",", "\"\< bad argument!\>\""}], "]"}], ";", " ", 
         
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VectorQ", "[", "a", "]"}], "&&", 
         RowBox[{"(", 
          RowBox[{"k", "==", " ", "0"}], ")"}]}], ",", 
        RowBox[{"Return", "[", 
         RowBox[{"covecTotensor", "[", "a", "]"}], "]"}]}], "]"}], ";", "\n", 
      
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VectorQ", "[", "a", "]"}], "&&", 
         RowBox[{"(", 
          RowBox[{"k", "==", " ", "1"}], ")"}]}], ",", 
        RowBox[{"Return", "[", 
         RowBox[{"vecTotensor", "[", "a", "]"}], "]"}]}], "]"}], ";", "\n", 
      RowBox[{"dd", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"a", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"TensorDimensions", "[", "a", "]"}], " ", "==", 
          RowBox[{"Table", "[", 
           RowBox[{"dd", ",", 
            RowBox[{"{", "rg", "}"}]}], "]"}]}], "]"}], ",", " ", "\n", 
        RowBox[{
         RowBox[{"Print", "[", "\"\<Array does't fit!\>\"", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"k", ">", "rg"}], ",", " ", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "k", " ", ",", "\"\<>\>\"", ",", " ", "rg", ",", " ", 
           "\"\<; k too large!\>\""}], "]"}], ";", " ", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"tt", " ", "=", " ", 
       RowBox[{"tensor", "[", 
        RowBox[{"b", ",", "k", ",", 
         RowBox[{"rg", "-", "k"}], ",", "dd"}], "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{"ii_", ",", "jj_"}], "]"}], " ", ":=", " ", 
       RowBox[{"a", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{"ii", ",", "jj"}], "]"}], "/.", 
          RowBox[{"List", "->", " ", "Sequence"}]}], "]"}], "]"}]}], ";", 
      "\n", "tt"}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.570284768710701*^9, 3.57028484754121*^9}, {
   3.5702849017013073`*^9, 3.570284995509673*^9}, {3.5702852009104214`*^9, 
   3.5702853342770495`*^9}, {3.5702856057595778`*^9, 
   3.5702856140080495`*^9}, {3.570288709104079*^9, 3.5702891546585627`*^9}, {
   3.5702891972820005`*^9, 3.5702892423865805`*^9}, {3.5702892807957773`*^9, 
   3.57028943293948*^9}, 3.570289748763544*^9, {3.5702897803963532`*^9, 
   3.570289815187343*^9}, {3.5702898900756264`*^9, 3.570289994251585*^9}, {
   3.5702900553480797`*^9, 3.5702900583812532`*^9}, {3.5702900885849805`*^9, 
   3.57029021637729*^9}, {3.5702902920216165`*^9, 3.5702903084455557`*^9}, {
   3.570290431150574*^9, 3.5702904316936054`*^9}, {3.5702905125772314`*^9, 
   3.5702905373346477`*^9}, {3.5702906844220605`*^9, 3.57029069018139*^9}, {
   3.570290763885606*^9, 3.570290768141849*^9}, {3.570290821413896*^9, 
   3.570290854059763*^9}, {3.570426956253539*^9, 3.570426998326813*^9}, 
   3.5704326564298944`*^9, 
   3.6035277671665783`*^9},ExpressionUUID->"bc686e5c-3510-47cf-a7f2-\
d626aedb3ecf"],

Cell[TextData[StyleBox["Example vec[x]",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.603348582042971*^9, 
  3.603348593352991*^9}},ExpressionUUID->"a0df3b80-9e38-417a-94df-\
388b1f2dde0d"],

Cell[BoxData[
 RowBox[{"vec", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.6033486937547674`*^9, 
  3.6033486974051733`*^9}},ExpressionUUID->"29914d08-c557-479d-9eea-\
052187e6a528"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.603346782733411*^9, 
  3.6033468111098604`*^9}},ExpressionUUID->"0393e02b-1bc3-4b87-b46a-\
f780a48d739b"],

Cell[BoxData[
 RowBox[{"TensorRank", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.603346909452433*^9, 
  3.6033469216360545`*^9}},ExpressionUUID->"2cba4110-1a7d-4029-a27a-\
a7582c100472"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.6033470400246625`*^9},ExpressionUUID->"5695585e-a979-4bb7-a06c-\
786b032b4d20"],

Cell[BoxData[
 RowBox[{"ArrayTotensor", "[", 
  RowBox[{"vec", "[", "x", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6033510341939783`*^9, 
  3.6033510392332664`*^9}},ExpressionUUID->"1130b047-b004-4f1e-ac65-\
e0bba2d7a5c4"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.6035502694320765`*^9, 3.6035503001953306`*^9}, {
  3.6035503340161905`*^9, 
  3.603550344078208*^9}},ExpressionUUID->"ca2a0991-b93e-4888-a276-\
85527a305b26"],

Cell["Try the next cells with various parameters of tensor:", "Text",
 CellChangeTimes->{{3.6035509378308506`*^9, 
  3.6035509719325104`*^9}},ExpressionUUID->"0fd989cb-d44b-473f-b17c-\
ff2ff77dcec1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "a", "]"}], ";", 
  RowBox[{"tensorToArray", "[", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "1", ",", "2"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.603550433747165*^9, 
  3.603550541699355*^9}},ExpressionUUID->"70b95835-2901-4bae-a552-\
b6136b65ef88"],

Cell[BoxData[
 RowBox[{"ArrayTotensor", "[", 
  RowBox[{"%", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.570290233654278*^9, 3.570290253605419*^9}, {
   3.57041826814917*^9, 3.5704182720335765`*^9}, 3.5704184164742303`*^9, {
   3.603550571261407*^9, 
   3.6035505797322216`*^9}},ExpressionUUID->"f9a044d5-1a6a-4c6b-850a-\
c13b0d21c3c7"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"%", ",", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "1", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6035506325383143`*^9, 
  3.60355066440917*^9}},ExpressionUUID->"b2e3507c-3292-4ce5-a82c-\
f4214337a954"],

Cell[BoxData[
 RowBox[{"%%", "[", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5704182861204014`*^9, 3.570418289302807*^9}, {
  3.570418333918885*^9, 3.5704183795645657`*^9}, {3.570418432589059*^9, 
  3.570418463789113*^9}, {3.6035506954220247`*^9, 
  3.6035506956248255`*^9}},ExpressionUUID->"69716fa9-e7da-4af0-a241-\
f5c4736eb004"],

Cell[BoxData[
 RowBox[{"t3", "=", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "h", ",", "i"}], "}"}]}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.570426856007763*^9, {3.570433697950124*^9, 3.570433728338977*^9}, {
   3.570433875010435*^9, 3.570433889970861*^9}, {3.570434083364401*^9, 
   3.5704340862504053`*^9}},ExpressionUUID->"dc51a454-0bf0-428c-b3b7-\
27d23da1be57"],

Cell[BoxData[
 RowBox[{"type", "[", "t3", "]"}]], "Input",
 CellChangeTimes->{{3.6035507823609776`*^9, 
  3.6035507923449955`*^9}},ExpressionUUID->"9f84cdba-e893-4e85-bf97-\
4faf15eb7345"],

Cell[BoxData[
 RowBox[{"t3", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570433822781543*^9, 3.570433847788387*^9}, {
  3.5704340934732184`*^9, 
  3.5704340941128197`*^9}},ExpressionUUID->"1476ac1e-9a12-46f8-8fad-\
99a57654b7a8"],

Cell[BoxData[
 RowBox[{"coords", "[", "t3", "]"}]], "Input",
 CellChangeTimes->{{3.5704339612005863`*^9, 3.570433998781052*^9}, {
  3.5704340370947194`*^9, 3.570434069230776*^9}, {3.570434101632033*^9, 
  3.5704341024432344`*^9}},ExpressionUUID->"19d1ea5a-a9c3-4c46-b739-\
ab229a208a7b"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "t3", "]"}]], "Input",
 CellChangeTimes->{{3.570434148338515*^9, 
  3.5704341588217335`*^9}},ExpressionUUID->"f9b88531-18d5-4ac8-8d1e-\
00acb0f61bdc"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.4. Tensor as Generalization of Array", "Subsubsection",
 CellChangeTimes->{{3.5643265800477214`*^9, 3.5643266686397886`*^9}, 
   3.601117201628237*^9, {3.603551110039553*^9, 
   3.603551120709972*^9}},ExpressionUUID->"cef0f896-1030-44c0-99d1-\
3474764d4898"],

Cell[TextData[{
 "As a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function, tensor is a kind of   \[OpenCurlyDoubleQuote]superarray\
\[CloseCurlyDoubleQuote].  "
}], "Text",
 CellChangeTimes->{{3.561124769789219*^9, 3.561124952029642*^9}, {
   3.5611250345733633`*^9, 3.561125065005104*^9}, 3.561438407023548*^9, {
   3.5626773264448442`*^9, 3.5626773790481367`*^9}, {3.562677502912354*^9, 
   3.562677584890498*^9}, {3.562677625232169*^9, 3.562677701812703*^9}, {
   3.5637785287196536`*^9, 3.563778564303316*^9}, {3.5643246162239404`*^9, 
   3.5643246323855686`*^9}, 3.564324663304823*^9, {3.5670864675432386`*^9, 
   3.567086480822998*^9}},ExpressionUUID->"911023cd-1f4f-45cc-917e-\
22e59e00bf60"],

Cell["\<\
A tensor of type (0,0) is  a scalar represented by its symbol\
\>", "Text",
 CellChangeTimes->{{3.5587547586384*^9, 3.5587548099936905`*^9}, {
   3.55875487287298*^9, 3.558754890488988*^9}, 
   3.558943125356022*^9},ExpressionUUID->"12c3fb44-a852-475a-870a-\
221bca0f4b2a"],

Cell[BoxData[
 RowBox[{"t0", " ", ":=", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "0", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.556104797402735*^9, 3.5561048400688105`*^9}, {
   3.556105014180716*^9, 3.556105029749543*^9}, {3.5586038608417597`*^9, 
   3.558603864663767*^9}, {3.5587549078619814`*^9, 3.5587549148363805`*^9}, {
   3.558873027849856*^9, 3.5588730647595205`*^9}, {3.558874106591751*^9, 
   3.5588741120205603`*^9}, 3.5589409581222153`*^9, 3.558941015124716*^9, {
   3.558941054608385*^9, 3.5589410691164103`*^9}, {3.558941774081649*^9, 
   3.5589417784652567`*^9}, {3.558942305855383*^9, 3.5589423112373924`*^9}, 
   3.558943176695712*^9, {3.5590186199991226`*^9, 3.559018632120344*^9}, {
   3.5590219251474495`*^9, 3.5590219371471357`*^9}, 3.562678107257416*^9, 
   3.562683756062457*^9},ExpressionUUID->"ea4ec0da-a4de-4677-8345-\
ea3bc08e6b6a"],

Cell[BoxData[
 RowBox[{"t0", "[", "]"}]], "Input",
 CellChangeTimes->{{3.558873960903095*^9, 3.5588739610590954`*^9}, 
   3.5588741202885747`*^9, {3.558940970103037*^9, 3.5589409847046623`*^9}, {
   3.5589417887924747`*^9, 3.5589417977000904`*^9}, {3.5589423205506086`*^9, 
   3.5589423257922177`*^9}, 3.5590186397955575`*^9, 3.559021945337604*^9, 
   3.5626781275842514`*^9},ExpressionUUID->"4f8cd8e6-1b24-4743-831c-\
ff30b741b8b4"],

Cell[BoxData[
 RowBox[{"t0", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", " ", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.558873960903095*^9, 3.5588739610590954`*^9}, 
   3.5588741202885747`*^9, {3.558940970103037*^9, 3.5589409847046623`*^9}, {
   3.5589417887924747`*^9, 3.5589417977000904`*^9}, {3.5589423205506086`*^9, 
   3.5589423257922177`*^9}, 3.5590186397955575`*^9, 3.559021945337604*^9, 
   3.5626781275842514`*^9, {3.5637788548562264`*^9, 
   3.563778869473452*^9}},ExpressionUUID->"fd6d372a-9911-4486-b620-\
717211f335e6"],

Cell["\<\
Formally, tensors of type (0, 0)  may be arbitrary objects, e.g. numbers:\
\>", "Text",
 CellChangeTimes->{{3.5627663995956697`*^9, 3.56276647904661*^9}, {
  3.563778825088974*^9, 3.5637788265553765`*^9}, {3.6035512496597986`*^9, 
  3.6035512632786226`*^9}},ExpressionUUID->"09e5e6d6-e9a1-401d-9bb0-\
f99722c5d668"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5612686621163588`*^9, 3.561268683176396*^9}, {
   3.5626781443386803`*^9, 3.562678169095924*^9}, 3.562683756062457*^9, 
   3.56276606377388*^9, {3.5627677970897245`*^9, 3.5627677976045256`*^9}, 
   3.5627678405046015`*^9},ExpressionUUID->"c63ef6e8-00ea-492b-9f1a-\
f18db406bd40"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.562678155991901*^9, 
  3.5626781795791426`*^9}},ExpressionUUID->"87d220bc-d4aa-4985-9c65-\
5fd40f5c843f"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", " ", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561269330671133*^9, 3.5612693347427406`*^9}, {
   3.5626781928391657`*^9, 3.5626782109975977`*^9}, 
   3.563778906211517*^9},ExpressionUUID->"0fd52130-3c74-4076-ab2a-\
6fcc544b9a1a"],

Cell[BoxData[
 RowBox[{"Head", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.5627659522648845`*^9, 
  3.5627659590976963`*^9}},ExpressionUUID->"9e16150e-2e94-4ca3-bbda-\
72b4d8c44d2c"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "i", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5627665131170692`*^9, 3.5627665613679543`*^9}, 
   3.562766624173664*^9, {3.5627677069995666`*^9, 
   3.5627677285744047`*^9}},ExpressionUUID->"d3118bfb-73e3-4c17-be2f-\
c0f1bd178cd1"],

Cell["or functions", "Text",
 CellChangeTimes->{{3.5627679337147646`*^9, 
  3.562767939439975*^9}},ExpressionUUID->"5ae802f3-6b10-41c8-87ff-\
84be763bfc43"],

Cell[BoxData[
 RowBox[{"tb", " ", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], ",", "0", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5612686621163588`*^9, 3.561268683176396*^9}, {
   3.5626781443386803`*^9, 3.562678169095924*^9}, 3.562683756062457*^9, 
   3.56276606377388*^9, {3.5627677970897245`*^9, 3.5627677976045256`*^9}, 
   3.5627678405046015`*^9, {3.56276797076483*^9, 
   3.562767975632038*^9}},ExpressionUUID->"6821c89b-531e-46a6-aeae-\
a1329f1c03ba"],

Cell[BoxData[
 RowBox[{"type", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.562678155991901*^9, 
  3.5626781795791426`*^9}},ExpressionUUID->"2ca9cda0-4449-4329-8ab7-\
3745420168e8"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", " ", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561269330671133*^9, 3.5612693347427406`*^9}, {
   3.5626781928391657`*^9, 3.5626782109975977`*^9}, 
   3.563779003134487*^9},ExpressionUUID->"3cb7b79b-a180-4ec1-b499-\
e9a578b77d26"],

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"x", "\[Rule]", " ", "1."}]}]], "Input",
 CellChangeTimes->{{3.5627680359885445`*^9, 
  3.5627680526025734`*^9}},ExpressionUUID->"76a63c76-0df7-46ef-bcc3-\
a73b5a4c4ce6"],

Cell[BoxData[
 RowBox[{"Head", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.5627659522648845`*^9, 3.5627659590976963`*^9}, 
   3.5637791356879196`*^9},ExpressionUUID->"3dadccd0-1eb4-4844-9c9d-\
62cfce7b6863"],

Cell["but not  Arrays or Lists:", "Text",
 CellChangeTimes->{{3.567087246959819*^9, 3.5670872559033303`*^9}, {
  3.64467481746661*^9, 
  3.644674836810644*^9}},ExpressionUUID->"cc48affe-8e00-4755-8f32-\
b70a2aba131c"],

Cell[BoxData[
 RowBox[{"b", " ", "=", " ", 
  RowBox[{"Array", "[", 
   RowBox[{"a", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5670868788257627`*^9, 
  3.567086980337569*^9}},ExpressionUUID->"e596c85a-e285-462b-852f-\
e35e326328bd"],

Cell[BoxData[
 RowBox[{"tb", "=", 
  RowBox[{"tensor", "[", 
   RowBox[{"b", ",", "0", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5670870073331127`*^9, 3.5670870482334523`*^9}, {
  3.567087087649707*^9, 3.567087090432866*^9}, {3.567087189265519*^9, 
  3.567087191049621*^9}},ExpressionUUID->"fbd6218e-0dad-45c3-9f90-\
c7f63d47d6fe"],

Cell[BoxData[
 RowBox[{"tb", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.567087099055359*^9, 3.567087116361349*^9}, {
  3.5670872022822638`*^9, 
  3.567087205217431*^9}},ExpressionUUID->"f78a49fd-4b85-41fc-99bb-\
4ef1fb59573a"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", "tb", "]"}]], "Input",
 CellChangeTimes->{{3.603551386019638*^9, 3.6035514010580645`*^9}, {
  3.603551445315342*^9, 
  3.6035514464385443`*^9}},ExpressionUUID->"0e767d05-e084-4a8e-acc5-\
13aaa3fbeb3f"],

Cell["This function may not work here, since", "Text",
 CellChangeTimes->{{3.603551696803384*^9, 
  3.603551716287818*^9}},ExpressionUUID->"6f113ffc-ea47-4efc-b50e-\
711b885a6782"],

Cell[BoxData[
 RowBox[{"ArrayQ", "[", "%%", "]"}]], "Input",
 CellChangeTimes->{{3.603551588788794*^9, 
  3.603551605824024*^9}},ExpressionUUID->"9e11cb4c-c6de-43ed-828d-\
af9113b38265"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"b", ",", "tb"}], "]"}]], "Input",
 CellChangeTimes->{{3.5670886124659214`*^9, 
  3.5670886214894376`*^9}},ExpressionUUID->"eb892a7f-f0ba-49d1-b7b7-\
7f469c7b7fcb"],

Cell["\<\
tensor is a general structure generalizing the built-in function Array :\
\>", "Text",
 CellChangeTimes->{{3.558764585671228*^9, 3.5587646362821226`*^9}, {
  3.5611265094307203`*^9, 3.561126530493925*^9}, {3.562681558767398*^9, 
  3.562681561154202*^9}},ExpressionUUID->"e83717ca-6616-41d5-b792-\
60a40553fd3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b3"}], "]"}], ";", 
  RowBox[{"b3", "=", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"dim", ",", "dim", ",", "dim"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.558764665885816*^9, 3.558764668626973*^9}, {
  3.55876471857883*^9, 3.558764761732298*^9}, {3.5643259780742903`*^9, 
  3.564326013306306*^9}},ExpressionUUID->"9a8c48be-314e-4ba8-a528-\
9ddc72901f4f"],

Cell[BoxData[
 RowBox[{"t3", " ", ":=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"a", ",", "3", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.558764797872365*^9, 3.558764829876196*^9}, 
   3.5587665776291614`*^9, {3.5590224461862507`*^9, 3.559022454994755*^9}, {
   3.5611265592885723`*^9, 3.561126562960782*^9}, 3.5626763668715587`*^9, 
   3.5626766520712595`*^9, 
   3.5626837561248574`*^9},ExpressionUUID->"3828dca4-06bb-4ade-90fb-\
279af143c57c"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"t3", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "j", ",", "k"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "dim"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "dim"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "1", ",", "dim"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5587648575127764`*^9, 3.5587649826779356`*^9}, {
  3.5626815946318607`*^9, 3.562681628842721*^9}, {3.5637804524862328`*^9, 
  3.5637804555594378`*^9}},ExpressionUUID->"d4328551-abaf-47ff-a482-\
085f5b2f8251"],

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], "\[Rule]", " ", 
   RowBox[{"a", "[", 
    RowBox[{"i", ",", "j", ",", "k"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.55876500146801*^9, 3.5587650576152215`*^9}, {
   3.55876519203191*^9, 3.558765206685748*^9}, {3.5611267388648434`*^9, 
   3.5611268021684637`*^9}, {3.562681643194746*^9, 3.5626816581551723`*^9}, {
   3.5637804756210732`*^9, 3.563780479053079*^9}, 
   3.56708800489017*^9},ExpressionUUID->"b096f51b-d31b-4bb6-b306-\
1f7d20d53fa3"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", " ", "b3"}]], "Input",
 CellChangeTimes->{{3.5587652543194723`*^9, 
  3.5587652719784822`*^9}},ExpressionUUID->"f15d9823-d827-40d9-8397-\
d574f2fd682e"],

Cell["\<\
The coordinates of a mixed tensor form an indexed table of Arrays,  for \
example\
\>", "Text",
 CellChangeTimes->{{3.5587666351694527`*^9, 3.558766685513332*^9}, 
   3.601184557692547*^9},ExpressionUUID->"815529ff-fcce-446f-b9f1-\
e4e0bb592416"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "tt"}], "]"}], ";", 
  RowBox[{"tt", ":=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "2"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5561022421494474`*^9, 3.5561022907123327`*^9}, {
   3.558603888625409*^9, 3.5586038955206213`*^9}, {3.5586039311822834`*^9, 
   3.5586039345674896`*^9}, {3.5586040450312834`*^9, 
   3.5586040496176915`*^9}, {3.5587653206522665`*^9, 3.558765325876565*^9}, 
   3.5587800005951457`*^9, {3.5587802450031247`*^9, 3.558780262700137*^9}, {
   3.5590245565837502`*^9, 3.5590245745117755`*^9}, 3.5626816933020344`*^9, 
   3.5626837561248574`*^9, {3.5627693818341084`*^9, 
   3.562769401739743*^9}},ExpressionUUID->"b4a45b70-1f3c-4cc5-9d53-\
1792213200e5"],

Cell[BoxData[
 RowBox[{"type", "[", "tt", "]"}]], "Input",
 CellChangeTimes->{{3.562769472392267*^9, 
  3.562769479037879*^9}},ExpressionUUID->"b67cfe19-7dda-486d-96eb-\
a8b6adf91434"],

Cell[BoxData[
 RowBox[{"tt", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.562769488351095*^9, 
  3.5627695110647354`*^9}},ExpressionUUID->"082a7363-db8b-450d-8b68-\
6877c87069d8"],

Cell["Here is the List of all its coordinates:", "Text",
 CellChangeTimes->{{3.55902462791083*^9, 3.5590246505101223`*^9}, 
   3.601184559174549*^9},ExpressionUUID->"e748f933-01bb-48cd-afcf-\
ee0fc4112faa"],

Cell[BoxData[
 RowBox[{"ttt", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"tt", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "h"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "k"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"h", ",", "1", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "dim"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", "dim"}], "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5587653417284718`*^9, 3.5587653836208677`*^9}, {
   3.558779710462551*^9, 3.558779720294113*^9}, {3.5587800168470755`*^9, 
   3.5587800184951696`*^9}, {3.558780064158781*^9, 3.558780080015688*^9}, 
   3.5587801477375617`*^9, 3.5587802767679415`*^9, 3.5590245880335493`*^9, {
   3.562681713238869*^9, 3.5626817314753013`*^9}, {3.5626821619736576`*^9, 
   3.5626821637364607`*^9}},ExpressionUUID->"e7f423dd-fc23-431a-84b9-\
1078eb070182"],

Cell["Now we flatten the table of Arrays", "Text",
 CellChangeTimes->{{3.55902467494252*^9, 3.559024694558642*^9}, 
   3.5592742900713124`*^9},ExpressionUUID->"65cfb6b9-8358-4772-aeb8-\
56452174abf5"],

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Array", "[", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"i", ",", "j"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "dim"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", "dim"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5587654603582573`*^9, 3.5587655004925528`*^9}, {
  3.55876564153362*^9, 3.5587656455878515`*^9}, {3.558765680028822*^9, 
  3.558765748452735*^9}, {3.5587658477904167`*^9, 3.558765900324422*^9}, {
  3.5587797613974643`*^9, 3.558779768564874*^9}, {3.55878030068631*^9, 
  3.5587803322831173`*^9}},ExpressionUUID->"2c5aa1da-ba89-474e-9a90-\
f9efee23d4a6"],

Cell["and got the same, up to a minor change of notation", "Text",
 CellChangeTimes->{{3.5590247286105895`*^9, 3.5590247458225737`*^9}, {
  3.5626821084499636`*^9, 
  3.5626821296192007`*^9}},ExpressionUUID->"4ac994d3-a2a0-472f-b3c7-\
04db6c5aaa19"],

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "\[Equal]", "ttt"}], "/.", " ", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", "j_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r_", ",", "s_"}], "}"}]}], "]"}], "\[Rule]", " ", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"i", ",", "j"}], "]"}], "[", 
    RowBox[{"r", ",", "s"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.558765796375476*^9, 3.558765798970625*^9}, {
   3.5626817867461987`*^9, 3.5626818928419847`*^9}, {3.56268199839177*^9, 
   3.562681998953371*^9}, {3.5626820337570324`*^9, 3.5626820395134425`*^9}, {
   3.5626820816647167`*^9, 3.5626820857831235`*^9}, {3.5626821473096313`*^9, 
   3.562682147496832*^9}, {3.562682196574518*^9, 3.5626821970113187`*^9}, 
   3.5670881420190134`*^9},ExpressionUUID->"0132321a-9493-4fe6-8b3c-\
6a87aad219e8"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["5.3. The LeviCivitaTensor", "Subsection",
 CellChangeTimes->{{3.5707744642062044`*^9, 
  3.5707745008012977`*^9}},ExpressionUUID->"acbea2f6-0800-48b1-b3a5-\
2b26f53c247b"],

Cell[TextData[StyleBox["LeviCivitaTensor  as special case of an epsilon \
tensor:",
 FontColor->RGBColor[0, 0, 1]]], "Text",
 CellChangeTimes->{{3.570107113115209*^9, 3.5701071501873293`*^9}, 
   3.5702005648176765`*^9},ExpressionUUID->"6554ec1e-367b-403f-a1ea-\
88a4a3f0f9be"],

Cell[BoxData[
 StyleBox[
  RowBox[{"?", "LeviCivitaTensor"}],
  FontColor->GrayLevel[0]]], "Input",
 CellChangeTimes->{{3.570200578408454*^9, 
  3.5702005824196835`*^9}},ExpressionUUID->"30ecc843-1edb-4a17-a25f-\
7e5f950fbf32"],

Cell[BoxData[
 RowBox[{"LCT3", "=", 
  RowBox[{"Normal", "[", 
   RowBox[{"LeviCivitaTensor", "[", "3", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5700874876306963`*^9, 3.570087515648346*^9}, {
   3.570087555537616*^9, 3.570087576129652*^9}, 3.570087920796657*^9, 
   3.5700883711382484`*^9, {3.57008856008578*^9, 3.570088572004201*^9}, 
   3.5700886820467944`*^9, {3.5700892118089237`*^9, 
   3.5700892165825324`*^9}},ExpressionUUID->"2a52fb3b-3676-4b79-9e23-\
5437df4402ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", " ", 
  RowBox[{"LCT3", "[", 
   RowBox[{"[", 
    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570089578721568*^9, 
  3.5700896687493267`*^9}},ExpressionUUID->"e62d24ca-907e-46e5-8f57-\
799a45d32604"],

Cell[BoxData[
 RowBox[{"tensLCT3", " ", "=", " ", 
  RowBox[{"tensor", "[", 
   RowBox[{"sig", ",", "3", ",", "0", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570089707936595*^9, 
  3.570089734581442*^9}},ExpressionUUID->"aae35400-4072-48a1-a048-\
bcc11b3a0464"],

Cell[BoxData[
 RowBox[{"lct3", " ", "=", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"LCT3", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.570435929861644*^9, 3.570435962980502*^9}, {
  3.57043608703192*^9, 
  3.570436088186322*^9}},ExpressionUUID->"21345bab-3df4-42a1-81ee-\
83143f8610ab"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tensLCT3", ",", "lct3"}], "]"}]], "Input",
 CellChangeTimes->{{3.570435986130943*^9, 
  3.570436006894579*^9}},ExpressionUUID->"ccd02f8d-55f5-492d-8d40-\
2df6596abb70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensLCT3", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "j", ",", "k"}], "}"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], "-", 
      RowBox[{"LCT3", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "3"}], "}"}]}], "]"}], "]"}], " ", "\[Equal]", " ", 
  RowBox[{"null", "[", "27", "]"}]}]], "Input",
 CellChangeTimes->{{3.570090668917983*^9, 
  3.5700908621110334`*^9}},ExpressionUUID->"2a8ef76f-c2ad-481d-b617-\
93877f38c6ab"],

Cell["\<\
Here is a definition of the epsilon tensors containing the LeviCivitaTensor \
as a special case\
\>", "Text",
 CellChangeTimes->{{3.5702007875374155`*^9, 
  3.57020083762528*^9}},ExpressionUUID->"172bb8d6-8be6-44fd-a9bc-\
258a092306f4"],

Cell[BoxData[
 RowBox[{"?", "eps"}]], "Input",
 CellChangeTimes->{{3.5701067308113427`*^9, 
  3.5701067323984337`*^9}},ExpressionUUID->"82d1df50-92ad-4846-ba11-\
7a5173ca4fd3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"signature", "[", "k_", "]"}], "[", 
   RowBox[{"a_", ",", 
    RowBox[{"{", "}"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"eps", "[", 
   RowBox[{
    RowBox[{"Range", "[", "k", "]"}], ",", "a"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5700909418255925`*^9, 3.570090969479174*^9}, {
  3.5700966498800483`*^9, 3.5700966730473733`*^9}, {3.5700967093674507`*^9, 
  3.570096733399825*^9}, {3.5701067842453995`*^9, 3.570106829525989*^9}, {
  3.5702014159083557`*^9, 
  3.5702014248518677`*^9}},ExpressionUUID->"e5186c47-4209-41c7-82b0-\
2f6d20552846"],

Cell["Remark: The definition makes sense for k \[LessEqual] dim only.", "Text",
 CellChangeTimes->{{3.570201842025728*^9, 3.5702018927056274`*^9}, 
   3.644757833780178*^9},ExpressionUUID->"3477e99d-620f-47cf-8f91-\
f3e2a43150b5"],

Cell[BoxData[
 RowBox[{"eps", "[", 
  RowBox[{
   RowBox[{"Range", "[", "3", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5702011888153667`*^9, 3.570201304763999*^9}, {
   3.5702013532917747`*^9, 3.5702013587230854`*^9}, {3.5702013898118634`*^9, 
   3.5702013975963087`*^9}, {3.57020143154825*^9, 3.570201459123828*^9}, 
   3.5704362053425274`*^9},ExpressionUUID->"df388819-b467-46f4-ac8c-\
a47940131992"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "epsilon", "]"}], ";", 
  RowBox[{
   RowBox[{"epsilon", "[", 
    RowBox[{"k_", ",", 
     RowBox[{"d_:", "dim"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"k", ">", "d"}], ",", 
     RowBox[{
      RowBox[{"Print", "[", "\"\<Argument k too large!\>\"", "]"}], ";", 
      RowBox[{"Return", "[", "]"}]}], ",", 
     RowBox[{"tensor", "[", 
      RowBox[{
       RowBox[{"signature", "[", "k", "]"}], ",", "k", ",", "0", ",", "d"}], 
      "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5700909874392014`*^9, 3.5700910767273083`*^9}, {
  3.570096454063848*^9, 3.570096456630995*^9}, {3.5701068703503237`*^9, 
  3.5701068731494837`*^9}, {3.570436815397199*^9, 3.5704368194688063`*^9}, {
  3.5704385571090584`*^9, 3.5704386465596156`*^9}, {3.570438731049364*^9, 
  3.57043874015978*^9}},ExpressionUUID->"1e21214b-0a0b-4069-a36a-\
00b2d5ea2eaa"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"epsilon", "[", 
   RowBox[{"3", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.57045306445692*^9, 3.570453108152597*^9}, 
   3.570453184920332*^9, {3.5704533088469496`*^9, 3.570453341591407*^9}, 
   3.570453573829015*^9, {3.570453618413893*^9, 
   3.570453622766301*^9}},ExpressionUUID->"8949836d-46a8-4bed-a242-\
914566b50a7f"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "LCT3"}]], "Input",
 CellChangeTimes->{{3.5704536629207716`*^9, 
  3.570453672171588*^9}},ExpressionUUID->"04d59182-4712-408c-8dad-\
96af9f27db79"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LCT4", "=", 
   RowBox[{"Normal", "[", 
    RowBox[{"LeviCivitaTensor", "[", "4", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5700874876306963`*^9, 3.570087515648346*^9}, {
   3.570087555537616*^9, 3.570087576129652*^9}, 3.570087920796657*^9, 
   3.5700883711382484`*^9, {3.57008856008578*^9, 3.570088572004201*^9}, 
   3.5700886820467944`*^9, {3.5700892118089237`*^9, 3.5700892165825324`*^9}, {
   3.5700912396636276`*^9, 3.5700912443668966`*^9}, 3.5700964696717405`*^9, {
   3.5701118333181896`*^9, 
   3.570111841126636*^9}},ExpressionUUID->"617e6e54-a8bc-4df1-9223-\
5e808785f997"],

Cell[BoxData[
 RowBox[{"TensorQ", "[", "LCT4", "]"}]], "Input",
 CellChangeTimes->{{3.570111845148866*^9, 
  3.570111855668468*^9}},ExpressionUUID->"0395cbbe-6108-4550-b611-\
65deb7df0940"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "5"}], ";", 
  RowBox[{
   RowBox[{
    RowBox[{"epsilon", "[", 
     RowBox[{"4", ",", "4"}], "]"}], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], " ", "\[Equal]", " ", 
   RowBox[{"LCT4", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.570091142388064*^9, 3.5700911920709057`*^9}, {
  3.5700962473910275`*^9, 3.5700962593977137`*^9}, {3.570096317272024*^9, 
  3.5700963213112555`*^9}, {3.6446753944492235`*^9, 3.644675420392069*^9}, {
  3.6446754674573517`*^9, 3.6446754690485544`*^9}, {3.644675504148616*^9, 
  3.6446755179546404`*^9}},ExpressionUUID->"b2b904a8-b9d3-4621-bff5-\
b10dfd420568"],

Cell[BoxData[
 RowBox[{"tensorToArray", "[", 
  RowBox[{"epsilon", "[", 
   RowBox[{"4", ",", "4"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6037180948740845`*^9, 3.6037181024315166`*^9}, {
  3.603718138440576*^9, 
  3.6037181618409147`*^9}},ExpressionUUID->"c94d9440-0f23-49bf-9baa-\
bfa637156597"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", "LCT4"}]], "Input",
 CellChangeTimes->{{3.603718185593273*^9, 
  3.603718191870632*^9}},ExpressionUUID->"caba59f7-620a-46ba-8117-\
5f5fd549daeb"],

Cell["Also we have with", "Text",
 CellChangeTimes->{{3.5702021691294374`*^9, 3.5702022347311897`*^9}, {
  3.5704364823990145`*^9, 3.570436499652645*^9}, {3.5704539403828588`*^9, 
  3.5704539427540627`*^9}},ExpressionUUID->"b2d6e3aa-9377-4e16-9a30-\
5e3d5e944016"],

Cell[BoxData[
 RowBox[{"lct4", " ", "=", " ", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"LCT4", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5704537949906034`*^9, 3.570453829591464*^9}, {
  3.5704539586348906`*^9, 
  3.570453960491294*^9}},ExpressionUUID->"c5052a9a-2496-4e49-830a-\
b79da30d95c1"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{
   RowBox[{"epsilon", "[", 
    RowBox[{"4", ",", "4"}], "]"}], ",", "lct4"}], "]"}]], "Input",
 CellChangeTimes->{{3.570453843194688*^9, 3.5704538742387424`*^9}, {
  3.603718310560421*^9, 
  3.6037183121045094`*^9}},ExpressionUUID->"ecefd6b6-bb82-4074-b86b-\
046c8a54050b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.6446499609401026`*^9, 3.6446499682409153`*^9}, {
   3.64465004482145*^9, 3.644650052605864*^9}, {3.644650103820754*^9, 
   3.644650250788612*^9}, {3.6446505114182696`*^9, 3.6446505765171843`*^9}, 
   3.644650712814624*^9},ExpressionUUID->"8962efbb-b0aa-4be2-a369-\
ba58e70e996c"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"eps", "[", 
    RowBox[{
     RowBox[{"Range", "[", "3", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.644650600525626*^9, 
  3.6446506005568266`*^9}},ExpressionUUID->"3cc9a7be-4e23-4087-a731-\
03b77da40684"],

Cell[BoxData[
 RowBox[{"%", "\[Equal]", 
  RowBox[{"Normal", "[", 
   RowBox[{"LeviCivitaTensor", "[", "3", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.644650622474865*^9, 
  3.644650664563739*^9}},ExpressionUUID->"a20578c3-819d-4095-983c-\
824eaedd6dc7"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4. TensorProduct", "Subsection",
 CellChangeTimes->{{3.56783982395109*^9, 3.5678398686296453`*^9}, 
   3.567840039622425*^9, {3.5704542021045184`*^9, 3.570454210232133*^9}, 
   3.570460986370432*^9, {3.6446756192144184`*^9, 3.6446756217260227`*^9}, 
   3.644727698336995*^9},
 CellTags->"TP",ExpressionUUID->"0f53f926-4f9b-42a5-a686-91d43886e082"],

Cell["\<\
TensorProduct is useful for the description of tensors on two vector spaces \
V, W over the same field. It does not reflect the covariant and contravariant \
tensor structures for tensors on a fixed vector space V forming the tensor \
algebra. This is done by the tensor functions defined in tensalgv2.m.\
\>", "Text",
 CellChangeTimes->{{3.570776095968536*^9, 3.5707764575172153`*^9}, 
   3.642501434065219*^9},ExpressionUUID->"4cd7a1f6-32db-48b5-88cf-\
f0817e541dad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";", " ", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "1", ",", "3"}], "]"}]}], ";", 
  RowBox[{"tb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "1", ",", "1", ",", "3"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.567755648414584*^9, 
  3.567755735025936*^9}},ExpressionUUID->"97e5515f-59a7-4c98-bea1-\
a668c3470723"],

Cell[TextData[{
 "The corresponding Tensors in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " are"
}], "Text",
 CellChangeTimes->{{3.5677568583103666`*^9, 3.567756944342287*^9}, {
   3.567757170502223*^9, 3.567757171758295*^9}, {3.5704559845792494`*^9, 
   3.5704559983852735`*^9}, 
   3.644757838475786*^9},ExpressionUUID->"7eebd6da-408e-4bf9-898e-\
5598eaa09ea9"],

Cell[BoxData[
 RowBox[{"compta", " ", "=", " ", 
  RowBox[{"tensorToArray", "[", "ta", "]"}]}]], "Input",
 CellChangeTimes->{{3.56775598220837*^9, 3.567756077649338*^9}, 
   3.570456025638521*^9},ExpressionUUID->"44e99be3-92f5-43ac-a03c-\
991a2736a417"],

Cell[BoxData[
 RowBox[{"comptb", " ", "=", " ", 
  RowBox[{"tensorToArray", "[", "tb", "]"}]}]], "Input",
 CellChangeTimes->{{3.56775598220837*^9, 3.567756077649338*^9}, {
  3.567760815380499*^9, 3.567760852527624*^9}, {3.5704560556217737`*^9, 
  3.570456065995792*^9}},ExpressionUUID->"b8550cb5-fb52-47d7-807b-\
671932b716c5"],

Cell["\<\
If the tensors ta, tb are represented by their Arrays of components compta, \
comptb, the TensorProduct of them is\
\>", "Text",
 CellChangeTimes->{{3.56776913474934*^9, 
  3.5677692196771975`*^9}},ExpressionUUID->"e316ab2c-d235-4c28-942d-\
02e760753849"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TP", "=", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{"compta", ",", "comptb"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5677659151741905`*^9, 3.567765953886405*^9}, {
   3.5677661001277695`*^9, 3.5677661074071856`*^9}, 3.567766293759845*^9, {
   3.567766458671277*^9, 3.5677664749682093`*^9}, {3.567766637815523*^9, 
   3.567766662910959*^9}, {3.567766953647588*^9, 3.5677669591669035`*^9}, {
   3.5677670288948917`*^9, 3.567767039966525*^9}, {3.5677674104237137`*^9, 
   3.5677674140319204`*^9}, {3.567767447695846*^9, 3.5677674512720504`*^9}, {
   3.5677692413274355`*^9, 3.5677692424474998`*^9}, 3.5677698413587556`*^9, {
   3.5678360504012547`*^9, 
   3.5678360512723045`*^9}},ExpressionUUID->"a36db503-bb9d-4619-9c87-\
8647b6d7afe8"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", "TP", "]"}]], "Input",
 CellChangeTimes->{{3.567767482133816*^9, 3.567767533599759*^9}, {
  3.5677692659508443`*^9, 3.567769273030249*^9}, {3.567836062431943*^9, 
  3.5678360647760773`*^9}},ExpressionUUID->"77e1b010-c4b1-453e-900c-\
1d9e26c28d53"],

Cell[BoxData[
 RowBox[{"TP", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2", ",", "3", ",", "2", ",", "1"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.567769864526081*^9, 3.567769876804783*^9}, {
  3.5678360757117023`*^9, 
  3.567836076455745*^9}},ExpressionUUID->"4a7b885e-3c39-49b5-b2ff-\
fde85faa1a71"],

Cell["The corresponding tensor of type (3,2) is", "Text",
 CellChangeTimes->{{3.5704595095458403`*^9, 
  3.570459548608309*^9}},ExpressionUUID->"57d9d3f3-fb3b-4dfb-a26c-\
8c9d4ae4a013"],

Cell[BoxData[
 RowBox[{"tTP", "=", " ", 
  RowBox[{"ArrayTotensor", "[", 
   RowBox[{"TP", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5704564430172544`*^9, 3.5704564756993113`*^9}, {
  3.570456539160223*^9, 
  3.5704565495654416`*^9}},ExpressionUUID->"b0886ee4-bdab-4f3e-8012-\
a0ba013df491"],

Cell["The tensorproduct[ta,tb] is", "Text",
 CellChangeTimes->{{3.567769288477133*^9, 
  3.567769303500992*^9}},ExpressionUUID->"28ef4e28-94c4-434e-b0fc-\
0095f32394f5"],

Cell[BoxData[
 RowBox[{"tc", " ", "=", " ", 
  RowBox[{"tensorproduct", "[", 
   RowBox[{"ta", ",", "tb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677675541369343`*^9, 
  3.567767574607105*^9}},ExpressionUUID->"f0941cae-6fae-4f8b-88e3-\
47fc7b9b1184"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570456253258521*^9, 
  3.5704563155962305`*^9}},ExpressionUUID->"fe77b9f8-00f5-41a0-8a85-\
30ea05ce2574"],

Cell["This differs from ", "Text",
 CellChangeTimes->{{3.570459601405602*^9, 
  3.570459608784415*^9}},ExpressionUUID->"521c6c5c-f06f-41a6-8e7b-\
dce6d91b78de"],

Cell[BoxData[
 RowBox[{"tTP", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.570456571982681*^9, 
  3.5704565855235043`*^9}},ExpressionUUID->"bc1f14b4-aaee-46a2-b637-\
0600e8e195c1"],

Cell["tc and  tTP differ.", "Text",
 CellChangeTimes->{{3.5704596845225477`*^9, 3.570459711791396*^9}, 
   3.5704598976913195`*^9, 
   3.5704599313249784`*^9},ExpressionUUID->"af14d802-1437-4b67-bbf4-\
941a46237c17"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tc", ",", "tTP"}], "]"}]], "Input",
 CellChangeTimes->{{3.5704597444678507`*^9, 
  3.5704597548574686`*^9}},ExpressionUUID->"fb907e36-7287-4bec-83c8-\
fe87a25c27bc"],

Cell["tc is represented by the Array comptc:", "Text",
 CellChangeTimes->{{3.5677693360048513`*^9, 3.5677693659485636`*^9}, {
  3.5704598572716484`*^9, 
  3.570459865726863*^9}},ExpressionUUID->"42ecce35-9831-4dd3-8938-\
988407c91aa2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"comptc", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "tc", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.567766506423008*^9, 3.5677665158545475`*^9}, {
  3.5677675982224555`*^9, 3.567767747192976*^9}, {3.570456822737521*^9, 
  3.570456848134366*^9}},ExpressionUUID->"bf2c1299-5a7c-4d65-973e-\
8cbfc9845c02"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", "comptc", "]"}]], "Input",
 CellChangeTimes->{{3.5677693914020195`*^9, 
  3.5677694636081495`*^9}},ExpressionUUID->"8279ca96-a7fa-45a2-b0ca-\
463e4abda175"],

Cell[BoxData[
 RowBox[{"diffc", " ", ":=", " ", 
  RowBox[{"TP", " ", "-", "comptc"}]}]], "Input",
 CellChangeTimes->{{3.5677694793950524`*^9, 3.5677694906716976`*^9}, {
  3.567836120352256*^9, 
  3.567836121279309*^9}},ExpressionUUID->"57185404-c503-4727-8cfc-\
dd7fdf938957"],

Cell[BoxData[
 RowBox[{"diffc", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "3", ",", "2", ",", "1", ",", "3"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.567769498982173*^9, 
  3.5677695615677524`*^9}},ExpressionUUID->"5cfbc259-22e9-4a8c-a60d-\
2e7ac0eef275"],

Cell["The difference  TP - comptc is not the null Array:", "Text",
 CellChangeTimes->{{3.567769600748994*^9, 3.5677696575172405`*^9}, {
  3.56783614017439*^9, 
  3.5678361409664345`*^9}},ExpressionUUID->"ae21114a-a0a4-4697-a599-\
b3326023f874"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", "diffc", "]"}], "\[Equal]", " ", 
  RowBox[{"null", "[", "315", "]"}]}]], "Input",
 CellChangeTimes->{{3.570460051117589*^9, 
  3.5704600736440287`*^9}},ExpressionUUID->"dc0e87e1-4f06-4999-9241-\
049b719cd078"],

Cell["The sorted flatten lists of the coordinates coincide:", "Text",
 CellChangeTimes->{{3.5677696931642795`*^9, 3.567769722252943*^9}, 
   3.570460265415165*^9, 
   3.601184580983388*^9},ExpressionUUID->"839d8568-4b83-4ef4-bafe-\
b744c509bb41"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sort", "[", 
    RowBox[{"Flatten", "[", "TP", "]"}], "]"}], "-", 
   RowBox[{"Sort", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"coords", "[", "tc", "]"}], "]"}], "]"}]}], "==", 
  RowBox[{"null", "[", 
   RowBox[{"3", "^", "5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.567767762225836*^9, 3.567767774327528*^9}, {
  3.5677678541220922`*^9, 3.5677679532067595`*^9}, {3.5677680416398177`*^9, 
  3.5677680694394073`*^9}, {3.567768121008357*^9, 3.5677681631677685`*^9}, {
  3.5678361505209813`*^9, 3.5678361513450284`*^9}, {3.5704601214269123`*^9, 
  3.570460138992543*^9}},ExpressionUUID->"9224bdd6-7a43-4731-b250-\
34e2e0c800dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sort", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{"TensorProduct", "[", 
     RowBox[{
      RowBox[{"coords", "[", "ta", "]"}], ",", 
      RowBox[{"coords", "[", "tb", "]"}]}], "]"}], "]"}], "]"}], "\[Equal]", 
  " ", 
  RowBox[{"Sort", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{"coords", "[", "tc", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677670999749575`*^9, 3.567767124718373*^9}, {
  3.567768242551309*^9, 3.567768270398902*^9}, {3.567768312184292*^9, 
  3.5677684338152485`*^9}, {3.56776851986417*^9, 3.5677685231273575`*^9}, {
  3.567768675055047*^9, 3.5677687662632637`*^9}, {3.5704601850750237`*^9, 
  3.5704601955894423`*^9}},ExpressionUUID->"4930c605-10a8-4e95-9a65-\
e9076624263f"],

Cell["\<\
The Tensorproduct does not take into account the subdivision of the indices \
into covariant and contravariant types. 
For contravariant tensors both product gives the same result:\
\>", "Text",
 CellChangeTimes->{{3.5704603092668424`*^9, 3.570460466281118*^9}, 
   3.5704609636099916`*^9},ExpressionUUID->"cfa1bb1e-3778-4964-992e-\
47c5a918f898"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "3"}], ";", 
  RowBox[{"ta", " ", "=", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "0", ",", "3"}], "]"}]}], ";", " ", 
  RowBox[{"tb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "0", ",", "2"}], "]"}]}], ";", " ", 
  RowBox[{"tc", " ", "=", 
   RowBox[{"tensorproduct", "[", 
    RowBox[{"ta", ",", "tb"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.570460468823922*^9, 
  3.5704605720961037`*^9}},ExpressionUUID->"75d78898-24cb-48dc-8ef9-\
cb5a1aae1906"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TA", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "ta", "]"}]}], ";", 
  RowBox[{"TB", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "tb", "]"}]}], ";", 
  RowBox[{"TC", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "tc", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.570460595542945*^9, 
  3.5704606811870956`*^9}},ExpressionUUID->"7e1516fc-6691-4285-8874-\
42d333589bf2"],

Cell[BoxData[
 RowBox[{"TC", "\[Equal]", " ", 
  RowBox[{"TensorProduct", "[", 
   RowBox[{"TA", ",", "TB"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5704607286267786`*^9, 
  3.570460750903618*^9}},ExpressionUUID->"3cfe2e23-e0bf-4553-b8f6-\
1aa288a2b829"],

Cell[BoxData[
 RowBox[{"tc", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "3", ",", "2"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5704607735860577`*^9, 
  3.5704608073133173`*^9}},ExpressionUUID->"e8c0d8bd-ede1-4d86-8aa8-\
079c6a76f8f0"],

Cell[BoxData[
 RowBox[{"TC", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2", ",", "2", ",", "3", ",", "2"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5704608201833396`*^9, 
  3.5704608491525908`*^9}},ExpressionUUID->"aa424142-3055-4348-8a16-\
00f3794711e1"],

Cell[BoxData[
 RowBox[{"tcc", " ", "=", " ", 
  RowBox[{"ArrayTotensor", "[", "TC", "]"}]}]], "Input",
 CellChangeTimes->{{3.5704608768270392`*^9, 
  3.570460895219472*^9}},ExpressionUUID->"a4cf9e61-18e0-4f1c-9202-\
f36c404e7998"],

Cell[BoxData[
 RowBox[{"equi", "[", 
  RowBox[{"tc", ",", "tcc"}], "]"}]], "Input",
 CellChangeTimes->{{3.5704609059834905`*^9, 
  3.5704609270279274`*^9}},ExpressionUUID->"bf665538-41ae-47de-8853-\
12aa11000add"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.5. TensorContract", "Subsection",
 CellChangeTimes->{{3.567839921406664*^9, 3.5678399350784454`*^9}, 
   3.5704542152709417`*^9, 3.5704609921736417`*^9, 3.570611917631471*^9, 
   3.644727705637808*^9, 3.6447554976253824`*^9},
 CellTags->"TC",ExpressionUUID->"53514b10-1a0e-42e7-8e65-92a779b00cd5"],

Cell[TextData[{
 "Unfortunately, the concepts of covariant, contravariant, and mixed tensors \
are missing also in the ",
 ButtonBox["Tutorial",
  BaseStyle->"Hyperlink",
  ButtonData->"Tensors"],
 "  \[OpenCurlyDoubleQuote]Symbolic Tensors\[CloseCurlyDoubleQuote], where \
detailed information about the built-in tensor functions can be found."
}], "Text",
 CellChangeTimes->{{3.5638047257193327`*^9, 3.5638047580101795`*^9}, {
   3.5638048771139917`*^9, 3.5638049450098753`*^9}, {3.563804975089596*^9, 
   3.563805000546052*^9}, {3.5638050480097666`*^9, 3.5638050524020176`*^9}, {
   3.563805204409712*^9, 3.5638052115251193`*^9}, {3.5638052463151093`*^9, 
   3.5638052463201094`*^9}, {3.5638052764018297`*^9, 
   3.5638053002261925`*^9}, {3.5638055166495714`*^9, 3.563805595042055*^9}, 
   3.564036159662373*^9, 3.567574917979762*^9, {3.5706075438537436`*^9, 
   3.5706075584065757`*^9}, {3.5706076412903166`*^9, 
   3.570607641298317*^9}},ExpressionUUID->"86bc60b5-96cb-400e-bee6-\
6d9be4f5cd24"],

Cell["\<\
TensorContract doesn\[CloseCurlyQuote]t act on the list coords[ta] of the \
components\
\>", "Text",
 CellChangeTimes->{{3.567756978086217*^9, 
  3.5677570658462367`*^9}},ExpressionUUID->"2a19f147-6c7c-4701-84e3-\
dc57631b2e5f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"ta", ",", "a"}], "]"}], ";", 
  RowBox[{"ta", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "3", ",", "2", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.570607806500766*^9, 3.5706078217046356`*^9}, {
  3.5706078571526628`*^9, 3.5706078614799104`*^9}, {3.570611961810749*^9, 
  3.5706119820127845`*^9}},ExpressionUUID->"d2c1d9c4-05ef-4ceb-a15e-\
a5630eabe1ad"],

Cell[BoxData[
 RowBox[{"TensorContract", "[", 
  RowBox[{
   RowBox[{"coords", "[", "ta", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5677557691587963`*^9, 3.567755840388521*^9}, 
   3.570608030504578*^9, 
   3.5706120265820627`*^9},ExpressionUUID->"c172697a-daca-4ba5-bbcf-\
3c461429d6b3"],

Cell["It acts on the corresponding Array:", "Text",
 CellChangeTimes->{{3.5677570984951043`*^9, 3.567757125006621*^9}, 
   3.570607922103378*^9},ExpressionUUID->"a83cc845-1ac7-4aa7-8d9c-\
e3e9dda2eb02"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compta", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "ta", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.570607972111238*^9, 3.570607990360282*^9}, 
   3.5706081201697063`*^9},ExpressionUUID->"e8eaa82d-b5f5-4f79-b1b1-\
2fcd9687597f"],

Cell[BoxData[
 RowBox[{"TensorContract", "[", 
  RowBox[{"compta", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5677557691587963`*^9, 3.567755840388521*^9}, {
   3.5677561183186097`*^9, 3.567756128755028*^9}, {3.5706081320883884`*^9, 
   3.5706081355765877`*^9}, 
   3.5706081663053455`*^9},ExpressionUUID->"524b07fa-8962-4e29-b4d0-\
ec9a2e7e3757"],

Cell["The result of the next double contraction is a 3-covector:", "Text",
 CellChangeTimes->{{3.570608737101993*^9, 3.5706087617264013`*^9}, {
  3.5706088300303087`*^9, 3.5706088306783457`*^9}, {3.570612095674584*^9, 
  3.5706121124602137`*^9}},ExpressionUUID->"6cd029d6-3728-4fc5-b491-\
3a8fd9cc527f"],

Cell[BoxData[
 RowBox[{"tac2", "=", 
  RowBox[{"TensorContract", "[", 
   RowBox[{"compta", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "5"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677557691587963`*^9, 3.567755840388521*^9}, {
  3.5677561183186097`*^9, 3.567756128755028*^9}, {3.567757188674262*^9, 
  3.567757196352701*^9}, {3.5706082253997254`*^9, 3.5706082699282722`*^9}, {
  3.5706083034731913`*^9, 
  3.570608309064511*^9}},ExpressionUUID->"a369888b-cb0d-41ad-9c6b-\
4c441e53843a"],

Cell["\<\
The corresponding contraction with tensor Output is (consider the change in \
the numbering of the slots!):\
\>", "Text",
 CellChangeTimes->{{3.5706090023821664`*^9, 
  3.5706090924623184`*^9}},ExpressionUUID->"8e6cedea-6a3a-4f06-be2e-\
fb142ec83e41"],

Cell[BoxData[
 RowBox[{"taa", "=", 
  RowBox[{"contraction", "[", 
   RowBox[{"ta", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5706083429234476`*^9, 3.5706083698169856`*^9}, {
  3.5706084062800713`*^9, 
  3.570608447488428*^9}},ExpressionUUID->"c6b9e58f-0063-4e24-b2c2-\
dc6aafb01f23"],

Cell[BoxData[
 RowBox[{"taac2", " ", "=", " ", 
  RowBox[{"tensorToArray", "[", "taa", "]"}]}]], "Input",
 CellChangeTimes->{{3.570608531919257*^9, 
  3.570608550202303*^9}},ExpressionUUID->"38b8fc5a-ec3f-456e-b3e1-\
10a230e8646b"],

Cell[BoxData[
 RowBox[{"taac2", " ", "\[Equal]", " ", "tac2"}]], "Input",
 CellChangeTimes->{{3.570608578263908*^9, 
  3.570608585383315*^9}},ExpressionUUID->"5616cf04-159d-4394-bec4-\
f66345b9429a"],

Cell["\<\
For contraction only slot pairs of type{covariant,contravariant) is possible; \
the command \
\>", "Text",
 CellChangeTimes->{{3.570609107406173*^9, 
  3.5706092028146305`*^9}},ExpressionUUID->"5bc4f9e0-c282-4893-8d30-\
13af259039a4"],

Cell[BoxData[
 RowBox[{"contraction", "[", 
  RowBox[{"ta", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5706092474321823`*^9, 
  3.5706092652562017`*^9}},ExpressionUUID->"6fffe628-d7e0-400c-be02-\
7ec09b591b96"],

Cell["\<\
is refused. For Tensors this command is possible, since all slots are not \
distinguished:\
\>", "Text",
 CellChangeTimes->{{3.5706092910696783`*^9, 3.570609356126399*^9}, {
  3.5706094902780724`*^9, 
  3.570609545814249*^9}},ExpressionUUID->"61e365b6-c401-44a2-84ef-\
86a3f9b2c073"],

Cell[BoxData[
 RowBox[{"TensorContract", "[", 
  RowBox[{"compta", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5706095801122103`*^9, 
  3.5706095826803575`*^9}},ExpressionUUID->"2d4722a6-24c6-49a6-9cd8-\
1dbd22c8d18b"],

Cell["\<\
The result is not invariant under basis transformations, it would depend on \
the coordinate system.\
\>", "Text",
 CellChangeTimes->{{3.570609607958803*^9, 3.570609682894089*^9}, {
  3.5706118887558203`*^9, 
  3.570611902047044*^9}},ExpressionUUID->"761d9914-2924-4f52-875e-\
4bb06d235715"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6. TensorWedge", "Subsection",
 CellChangeTimes->{{3.5678399828631787`*^9, 3.567840000454185*^9}, 
   3.570454221791753*^9, {3.5706122245776105`*^9, 3.570612226668014*^9}, 
   3.5706889490939817`*^9},
 CellTags->"TW",ExpressionUUID->"02637169-1f5b-43d7-b7b5-76bed1189f1d"],

Cell[BoxData[
 RowBox[{"?", "TensorWedge"}]], "Input",
 CellChangeTimes->{{3.570684723206494*^9, 
  3.5706847296649055`*^9}},ExpressionUUID->"38714505-e7fc-435c-9270-\
76800a6b2a8a"],

Cell["\<\
TensorWedge yields an  structured Array object (calculation below)\
\>", "Text",
 CellChangeTimes->{{3.567780615923629*^9, 3.567780673623929*^9}, 
   3.5678362587741733`*^9, {3.570685110024773*^9, 3.570685114798382*^9}, {
   3.570685145702036*^9, 3.5706851666060724`*^9}, {3.5706852131253543`*^9, 
   3.570685225792577*^9}, 
   3.6447560139394894`*^9},ExpressionUUID->"ec5fa88f-8610-4c25-953d-\
4ce93d1f8250"],

Cell[BoxData[
 RowBox[{"?", "StructuredArray"}]], "Input",
 CellChangeTimes->{
  3.64475569573013*^9},ExpressionUUID->"68ad1b89-9d97-4c11-bf6a-4d956f822ace"],

Cell["\<\
The tensor coordinates are obtained applying Normal to this object. As an \
example consider\
\>", "Text",
 CellChangeTimes->{{3.570685326911954*^9, 
  3.570685396269676*^9}},ExpressionUUID->"4afbdcbb-85a9-4725-b927-\
292387521765"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "4"}], ";", 
  RowBox[{"twa", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "0"}], "]"}]}], ";", " ", 
  RowBox[{"twb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "2", ",", "0"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5677806821644173`*^9, 3.567780723248768*^9}, {
  3.5677807698174314`*^9, 3.567780807401581*^9}, {3.567784202850789*^9, 
  3.567784246138265*^9}, {3.570634912898571*^9, 
  3.5706349264081945`*^9}},ExpressionUUID->"5ceba812-41d8-4954-a162-\
6f71cc331659"],

Cell["The wedge product as defined in tensalgv2. m is", "Text",
 CellChangeTimes->{{3.5706854333353415`*^9, 3.5706854598553877`*^9}, {
  3.644756067665984*^9, 
  3.644756068835986*^9}},ExpressionUUID->"35a957ff-e41d-4079-9482-\
d2d0b7a3a143"],

Cell[BoxData[
 RowBox[{"twc", " ", "=", 
  RowBox[{"wedge", "[", 
   RowBox[{"twa", ",", "twb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677812258535147`*^9, 
  3.567781269793028*^9}},ExpressionUUID->"c960d7ff-ceae-4965-b360-\
c05f414d843d"],

Cell["We consider the corresponding Arrays", "Text",
 CellChangeTimes->{{3.5706854836298294`*^9, 
  3.570685497295453*^9}},ExpressionUUID->"d5dcf5bf-fba8-4e5e-abed-\
1484ed59c31c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compwa", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "twa", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.56778083169497*^9, 3.567780931626686*^9}, {
  3.567784415970979*^9, 3.567784434827058*^9}, {3.570630577217355*^9, 
  3.570630605796605*^9}},ExpressionUUID->"fb5a0ed2-7476-4d61-932d-\
e9d55b066962"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compwb", " ", "=", "  ", 
   RowBox[{"tensorToArray", "[", "twb", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.56778083169497*^9, 3.5677809802744684`*^9}, {
  3.5677844202042212`*^9, 3.567784444243596*^9}, {3.570630623284236*^9, 
  3.570630643486271*^9}},ExpressionUUID->"84e89565-9e53-4a7c-ab50-\
f8d8b02c5799"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compwc", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "twc", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.570635005749934*^9, 
  3.5706350327223816`*^9}},ExpressionUUID->"af4bee89-4d6b-4af5-a474-\
6039db71923c"],

Cell["Applying TensorWedge to the Arrays compwa, compwb yields", "Text",
 CellChangeTimes->{{3.5706855378087244`*^9, 3.570685549493145*^9}, {
   3.5706856365185137`*^9, 3.570685681086063*^9}, 
   3.6037193642146864`*^9},ExpressionUUID->"2eada8a3-e4ce-49da-80ba-\
a4818ddc5ba1"],

Cell[BoxData[
 RowBox[{"twab", "=", 
  RowBox[{"TensorWedge", "[", 
   RowBox[{"compwa", ",", "compwb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677809910820866`*^9, 3.567781037073717*^9}, 
   3.5706852349341927`*^9},ExpressionUUID->"dcd75e9c-0f1d-4514-913c-\
1514b39e106a"],

Cell["\<\
The tensor coordinates fill a large Array already for the considered low \
dimensions :\
\>", "Text",
 CellChangeTimes->{{3.5706857696131263`*^9, 3.570685827582442*^9}, {
  3.570775481794407*^9, 
  3.5707754841655426`*^9}},ExpressionUUID->"8d4bd985-cb5c-44c2-a51a-\
16dd1fc9e8aa"],

Cell[BoxData[
 RowBox[{"Normal", "[", "twab", "]"}]], "Input",
 CellChangeTimes->{{3.5706849245560474`*^9, 
  3.570684952932497*^9}},ExpressionUUID->"f33e9da6-b9d5-4c63-bcfd-\
c9bbe31cbc1f"],

Cell["\<\
This Array coincides with the coordinate Array compwc of the  wedge product \
twc\
\>", "Text",
 CellChangeTimes->{{3.5706858664776664`*^9, 
  3.5706859610220737`*^9}},ExpressionUUID->"f88f5d65-de2b-46bd-97ff-\
7a3f51ab0703"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"compwc", " ", "==", 
   RowBox[{"Normal", "[", "twab", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5677810517075543`*^9, 3.5677810609210815`*^9}, {
   3.567784479569617*^9, 3.5677844824337807`*^9}, 3.56778507109945*^9, {
   3.56778512878675*^9, 3.5677851548102384`*^9}, {3.567785227154376*^9, 
   3.5677852335627427`*^9}, {3.5677854230755825`*^9, 3.567785449347085*^9}, {
   3.567785520219138*^9, 3.5677856068670945`*^9}, {3.5706306854971447`*^9, 
   3.5706307434044466`*^9}, 3.570630863072257*^9, {3.570634597466017*^9, 
   3.5706346269500685`*^9}, {3.5706346983981943`*^9, 3.570634715823425*^9}, {
   3.570635072408851*^9, 
   3.570635075060856*^9}},ExpressionUUID->"0058b91d-c684-4d74-82c4-\
fd7c65477f8b"],

Cell["\<\
If the  sum of the ranks of the factors is greater than the dimension, we \
obtain the nulltensor\
\>", "Text",
 CellChangeTimes->{{3.56778563004042*^9, 3.5677856453282948`*^9}, {
  3.567836503422166*^9, 3.567836540110265*^9}, {3.5678367755977335`*^9, 
  3.56783684250156*^9}, {3.570685998342209*^9, 
  3.570686006813693*^9}},ExpressionUUID->"b285c586-9b66-4749-b7cd-\
31b71bd9b953"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dim", " ", "=", " ", "2"}], ";", 
  RowBox[{"twa", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"a", ",", "2", ",", "0"}], "]"}]}], ";", " ", 
  RowBox[{"twb", " ", "=", " ", 
   RowBox[{"tensor", "[", 
    RowBox[{"b", ",", "1", ",", "0"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5678365749012547`*^9, 3.567836579751532*^9}, 
   3.567836615512577*^9, {3.5706860218325524`*^9, 
   3.5706860306490564`*^9}},ExpressionUUID->"c669d1e9-f5b0-4183-9234-\
47671baf463f"],

Cell[BoxData[
 RowBox[{"twc", " ", "=", " ", 
  RowBox[{"wedge", "[", 
   RowBox[{"twa", ",", "twb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.567836650818597*^9, 
  3.567836667528552*^9}},ExpressionUUID->"273e7d79-8c3c-491e-882f-\
043f3975f4f4"],

Cell["\<\
For TensorWedge applied to the coordinates arrays we get the nulltensor too, \
of course:\
\>", "Text",
 CellChangeTimes->{{3.5678371687982235`*^9, 3.5678372448145714`*^9}, 
   3.6011843059081044`*^9},ExpressionUUID->"11bc2805-6e67-4cb9-bc6e-\
70af0dd811ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compwa", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "twa", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.56778083169497*^9, 3.567780931626686*^9}, {
  3.567784415970979*^9, 3.567784434827058*^9}, {3.567836944753409*^9, 
  3.5678369472095494`*^9}, {3.5706352785788136`*^9, 
  3.570635306924063*^9}},ExpressionUUID->"b971912e-ccf8-48ee-8e67-\
bb2151d48686"],

Cell[BoxData[
 RowBox[{
  RowBox[{"compwb", " ", "=", " ", 
   RowBox[{"tensorToArray", "[", "twb", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.56778083169497*^9, 3.567780931626686*^9}, {
  3.567784415970979*^9, 3.567784434827058*^9}, {3.567836944753409*^9, 
  3.5678369472095494`*^9}, {3.5706352785788136`*^9, 
  3.5706353425701256`*^9}},ExpressionUUID->"ea235cc2-3ce6-44f8-9260-\
d23cbed27051"],

Cell["", "Text",
 CellChangeTimes->{{3.5706355602217083`*^9, 3.5706355911877623`*^9}, 
   3.570686135934078*^9, {3.5706861736142335`*^9, 3.5706861961655235`*^9}, {
   3.570686328302081*^9, 
   3.5706863461261005`*^9}},ExpressionUUID->"b74a2f48-5d9d-41c4-8625-\
32f1b342a695"],

Cell[BoxData[
 RowBox[{"twab", "=", 
  RowBox[{"TensorWedge", "[", 
   RowBox[{"compwa", ",", "compwb"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5677809910820866`*^9, 3.567781037073717*^9}, 
   3.567836976032198*^9},ExpressionUUID->"e30cbcba-50f9-4899-83e8-\
331a277e852f"],

Cell[BoxData[
 RowBox[{"ntwab", " ", "=", " ", 
  RowBox[{"Normal", "[", "twab", "]"}]}]], "Input",
 CellChangeTimes->{{3.570686100869073*^9, 
  3.570686114648861*^9}},ExpressionUUID->"b7ee11f0-4b07-4db5-a972-\
b1830a40af91"],

Cell[BoxData[
 RowBox[{"ntwab", " ", "\[Equal]", " ", 
  RowBox[{"tensorToArray", "[", "twc", "]"}]}]], "Input",
 CellChangeTimes->{{3.570686255321907*^9, 3.570686272047864*^9}, {
  3.570686382384175*^9, 
  3.570686392568757*^9}},ExpressionUUID->"18fadbef-36da-401f-8995-\
7772426b8d18"],

Cell[BoxData[
 RowBox[{"TensorDimensions", "[", 
  RowBox[{"Normal", "[", "twab", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.570635656286677*^9, 
  3.570635679109517*^9}},ExpressionUUID->"49c7dcbf-88c8-4f9f-aefa-\
e8ad064e5945"],

Cell["\<\
We recommend the user to test arbitrary examples, inserting  types and \
dimension in the definitions of twa, twb above.\
\>", "Text",
 CellChangeTimes->{{3.5706868040502925`*^9, 3.5706868866470165`*^9}, {
  3.644756323350433*^9, 3.6447563620853004`*^9}, {3.644756761960803*^9, 
  3.644756773738824*^9}, {3.64475684549895*^9, 
  3.644756854734166*^9}},ExpressionUUID->"ec261930-d393-4719-9f58-\
f960d7710baa"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["References", "Subsubtitle",
 CellChangeTimes->{{3.5544745369306817`*^9, 3.554474559500721*^9}, {
  3.554527079991947*^9, 3.55452712145682*^9}, {3.554528488699799*^9, 
  3.5545285128486414`*^9}, {3.554531186249479*^9, 3.554531220616339*^9}, {
  3.554617243384263*^9, 3.554617271261512*^9}},
 FontFamily->"Times",ExpressionUUID->"dcff7141-3fda-43e7-816a-feea669bfee8"],

Cell[TextData[{
 "Tutorial ",
 ButtonBox["Symbolic Tensors",
  BaseStyle->"Link",
  ButtonData->"paclet:tutorial/SymbolicTensors"]
}], "Text",
 CellChangeTimes->{{3.5701704833495164`*^9, 3.5701705055327854`*^9}},
 CellTags->"Tensors",ExpressionUUID->"07158bbf-7514-4ffc-8d5d-a36c400a51d5"],

Cell["\<\
[Mal] A. I. Maltzev. Grundlagen der linearen Algebra (Russ.) , Moskau 1956.\
\>", "Text",
 CellTags->"Mal",ExpressionUUID->"0c2dfd39-3e7b-46d9-a412-2b495483af4e"],

Cell["\<\
[OSI] A.L.Onishchik, Sulanke, R.  Algebra und Geometrie, \
Einf\[UDoubleDot]hrung. VEB Deutscher Verlag der Wissenschaften,Berlin 1977. \
(2. Aufl.Berlin 1986, Russ. Moscow 2004)\
\>", "Text",
 CellChangeTimes->{
  3.558420210558278*^9, {3.5584202541427712`*^9, 3.55842026933464*^9}, {
   3.558420425654581*^9, 3.5584204384943156`*^9}, {3.558420483111868*^9, 
   3.5584204900312634`*^9}, 3.6029190720390673`*^9},
 CellTags->"OSI",ExpressionUUID->"c8a58e2b-e7b2-491a-8445-e4d669bf6b0a"],

Cell["\<\
[OSII] A.L.Onishchik, Sulanke,R. Algebra und Geometrie, 2. Moduln und \
Algebren. VEB Deutscher Verlag der Wissenschaften, Berlin 1988, (Russ. Moscow \
2008). \
\>", "Text",
 CellChangeTimes->{{3.5584202018147783`*^9, 3.5584202427751207`*^9}, {
   3.5584202745509386`*^9, 3.5584203272139506`*^9}, {3.55842050308601*^9, 
   3.5584205424142594`*^9}, 3.558420596694364*^9},
 CellTags->"OSII",ExpressionUUID->"a046d2e2-47b8-481f-a44e-5bdf15f33753"],

Cell[TextData[{
 "[OSIII] A.L. Onishchik,  Sulanke, R. Projektive and Cayley-Klein \
Geometries, ( Springer Monographs in Mathematics, Berlin Heidelberg 2006, see \
also my ",
 ButtonBox["homepage",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www-irm.mathematik.hu-berlin.de/~sulanke/geo_alg.html#PCKG"], 
    None},
  ButtonNote->
   "http://www-irm.mathematik.hu-berlin.de/~sulanke/geo_alg.html#PCKG"],
 ".  "
}], "Text",
 CellChangeTimes->{
  3.558420632032385*^9, {3.5584206638472047`*^9, 3.558420707766717*^9}, {
   3.5584207826470003`*^9, 3.5584208113106394`*^9}, {3.558420924839133*^9, 
   3.5584209540868053`*^9}, {3.558421144135676*^9, 3.5584211873778887`*^9}, 
   3.644757937343561*^9},
 CellTags->"OSIII",ExpressionUUID->"40bd1656-b30a-4685-a8c2-6afb306fc0ad"],

Cell[TextData[{
 "[Soleng]  Harald H. Soleng. Tensors in Physics: CARTAN 1.8. December 28, \
2011\n    Copyright \[Copyright] 2002-2011 by Ad Infinitum\n   ",
 ButtonBox[" http://www.adinfinitum.no/cartan",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.adinfinitum.no/cartan/"], None},
  ButtonNote->"http://www.adinfinitum.no/cartan/"]
}], "Text",
 CellChangeTimes->{{3.564386869358122*^9, 3.5643869116525407`*^9}, {
  3.5643869469485598`*^9, 3.564386981804553*^9}, {3.5684478444059258`*^9, 
  3.5684478444099255`*^9}},
 CellTags->"Soleng",ExpressionUUID->"0d5387f7-184a-4480-a7b3-e51cbd402d23"],

Cell[TextData[{
 "Steven. M. Christensen & Associates. ",
 StyleBox[ButtonBox["MathTensor",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://smc.vnet.net/MathTensor.html"], None},
  ButtonNote->"http://smc.vnet.net/MathTensor.html"],
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.568446200711132*^9, 3.568446259272482*^9}, {
   3.5684465141440597`*^9, 3.5684465276968346`*^9}, {3.5684467203818555`*^9, 
   3.568446726824224*^9}, 3.6029191105032673`*^9},
 CellTags->"Christ",ExpressionUUID->"e80158ec-1981-4f66-bb90-ad87c56a276e"],

Cell[TextData[{
 "[OpF] R. Sulanke. Operations with Functions. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notebook. 2013. On my homepage.  ",
 ButtonBox["Download",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www-irm.mathematik.hu-berlin.de/~sulanke/Notebooks/\
OpFunctions.nb"], None},
  ButtonNote->
   "http://www-irm.mathematik.hu-berlin.de/~sulanke/Notebooks/OpFunctions.nb"],
 "."
}], "Text",
 CellChangeTimes->{{3.5670748195237203`*^9, 3.567074930112314*^9}, {
  3.567075045206005*^9, 3.5670750452216053`*^9}},
 CellTags->"OpF",ExpressionUUID->"f719c968-f876-47ad-9a77-6afb722b1749"]
}, Closed]],

Cell[CellGroupData[{

Cell["H\.08omepage", "Subsubtitle",
 CellChangeTimes->{{3.726291391894116*^9, 3.7262914017002573`*^9}},
 FontFamily->"Times",ExpressionUUID->"903d8800-2412-4d58-97db-47697786a03d"],

Cell[TextData[{
 " ",
 ButtonBox["http://www-irm.mathematik.hu-berlin.de/~sulanke",
  BaseStyle->"Hyperlink",
  ButtonData:>{
    URL["http://www-irm.mathematik.hu-berlin.de/~sulanke"], None}]
}], "Text",
 CellChangeTimes->{3.726291424972438*^9},
 FontFamily->"Times",
 CellTags->"hp",ExpressionUUID->"d5cd6b6a-3420-4f7e-80ab-7f2bc2e58319"],

Cell["sulanke@mathematik.hu-berlin.de", "Text",
 FontFamily->"Times",
 CellTags->"address",ExpressionUUID->"a27a87a2-20e4-464b-b1d5-93a121feb72d"]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->"EditBar",
WindowSize->{1032, 631},
WindowMargins->{{26, Automatic}, {39, Automatic}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperOrientation"->"Portrait",
"PaperSize"->{594.75, 842.25},
"PostScriptOutputFile"->"",
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->{{54.000000585, 54.000000585}, {72.00000078000001, \
72.00000078000001}}},
PrivateNotebookOptions->{"NoteStyle"->"Automatic",
"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
Magnification:>1.5 Inherited,
FrontEndVersion->"11.2 for Linux x86 (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "copyrigt"->{
  Cell[11803, 270, 109, 1, 55, "Subsection",ExpressionUUID->"d9995966-16d3-4b32-9aa3-2ebe9dfb5607",
   CellTags->"copyrigt"]},
 "duba"->{
  Cell[221884, 5944, 783, 16, 2147483647, "Text",ExpressionUUID->"3630d718-c07f-467b-8265-91551360476e",
   CellTags->"duba"]},
 "trdb"->{
  Cell[232258, 6203, 692, 10, 2147483647, "Text",ExpressionUUID->"3dfb509c-b8ba-4ccc-afaf-9b702dcf7cfe",
   CellTags->"trdb"]},
 "bpr"->{
  Cell[293960, 7894, 1684, 36, 11070, "Input",ExpressionUUID->"38b2354f-8f91-4f36-95fd-eafc0167c064",
   CellTags->"bpr"]},
 "1stein"->{
  Cell[340684, 9119, 832, 15, 6792, "Text",ExpressionUUID->"0a01cff6-900a-44a9-b35b-1ca4f024d8dd",
   CellTags->"1stein"]},
 "tensbas"->{
  Cell[401358, 10784, 564, 13, 10998, "Text",ExpressionUUID->"a30aaf79-656c-460e-952b-f179c07be5d2",
   CellTags->"tensbas"]},
 "wtstb"->{
  Cell[613130, 16494, 1558, 40, 4983, "Text",ExpressionUUID->"0968eb05-ec42-4efb-bb95-48901332008c",
   CellTags->"wtstb"]},
 "S5"->{
  Cell[780741, 20965, 440, 6, 101, "Section",ExpressionUUID->"816e6119-d58b-4742-b7bd-19e91ef7e3de",
   CellTags->"S5"]},
 "arr"->{
  Cell[797711, 21452, 260, 3, 54, "Subsubsection",ExpressionUUID->"47ad86af-4360-4bbb-8ceb-3a2b871ce037",
   CellTags->"arr"]},
 "TP"->{
  Cell[844894, 22723, 355, 5, 55, "Subsection",ExpressionUUID->"0f53f926-4f9b-42a5-a686-91d43886e082",
   CellTags->"TP"]},
 "TC"->{
  Cell[857173, 23064, 305, 4, 55, "Subsection",ExpressionUUID->"53514b10-1a0e-42e7-8e65-92a779b00cd5",
   CellTags->"TC"]},
 "TW"->{
  Cell[863929, 23251, 280, 4, 55, "Subsection",ExpressionUUID->"02637169-1f5b-43d7-b7b5-76bed1189f1d",
   CellTags->"TW"]},
 "Tensors"->{
  Cell[873881, 23516, 289, 7, 54, "Text",ExpressionUUID->"07158bbf-7514-4ffc-8d5d-a36c400a51d5",
   CellTags->"Tensors"]},
 "Mal"->{
  Cell[874173, 23525, 172, 3, 54, "Text",ExpressionUUID->"0c2dfd39-3e7b-46d9-a412-2b495483af4e",
   CellTags->"Mal"]},
 "OSI"->{
  Cell[874348, 23530, 495, 9, 90, "Text",ExpressionUUID->"c8a58e2b-e7b2-491a-8445-e4d669bf6b0a",
   CellTags->"OSI"]},
 "OSII"->{
  Cell[874846, 23541, 454, 8, 90, "Text",ExpressionUUID->"a046d2e2-47b8-481f-a44e-5bdf15f33753",
   CellTags->"OSII"]},
 "OSIII"->{
  Cell[875303, 23551, 785, 18, 90, "Text",ExpressionUUID->"40bd1656-b30a-4685-a8c2-6afb306fc0ad",
   CellTags->"OSIII"]},
 "Soleng"->{
  Cell[876091, 23571, 612, 12, 125, "Text",ExpressionUUID->"0d5387f7-184a-4480-a7b3-e51cbd402d23",
   CellTags->"Soleng"]},
 "Christ"->{
  Cell[876706, 23585, 555, 13, 54, "Text",ExpressionUUID->"e80158ec-1981-4f66-bb90-ad87c56a276e",
   CellTags->"Christ"]},
 "OpF"->{
  Cell[877264, 23600, 616, 16, 90, "Text",ExpressionUUID->"f719c968-f876-47ad-9a77-6afb722b1749",
   CellTags->"OpF"]},
 "hp"->{
  Cell[878100, 23625, 340, 9, 51, "Text",ExpressionUUID->"d5cd6b6a-3420-4f7e-80ab-7f2bc2e58319",
   CellTags->"hp"]},
 "address"->{
  Cell[878443, 23636, 146, 2, 51, "Text",ExpressionUUID->"a27a87a2-20e4-464b-b1d5-93a121feb72d",
   CellTags->"address"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"copyrigt", 879482, 23668},
 {"duba", 879620, 23671},
 {"trdb", 879759, 23674},
 {"bpr", 879897, 23677},
 {"1stein", 880034, 23680},
 {"tensbas", 880172, 23683},
 {"wtstb", 880311, 23686},
 {"S5", 880445, 23689},
 {"arr", 880577, 23692},
 {"TP", 880714, 23695},
 {"TC", 880847, 23698},
 {"TW", 880980, 23701},
 {"Tensors", 881118, 23704},
 {"Mal", 881251, 23707},
 {"OSI", 881380, 23710},
 {"OSII", 881510, 23713},
 {"OSIII", 881642, 23716},
 {"Soleng", 881777, 23719},
 {"Christ", 881914, 23722},
 {"OpF", 882047, 23725},
 {"hp", 882176, 23728},
 {"address", 882308, 23731}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 191, 2, 147, "Title",ExpressionUUID->"7a3cb9c1-fbd8-4cef-a882-4d48fed85a74"],
Cell[761, 26, 274, 9, 41, "Subsubtitle",ExpressionUUID->"9d7f4dc2-c5a8-4185-ab99-98657cf078b1",
 Evaluatable->False],
Cell[1038, 37, 176, 4, 69, "Text",ExpressionUUID->"a1ff6cb3-d013-4986-a8ba-ad202b9a8b70",
 Evaluatable->False],
Cell[1217, 43, 1197, 22, 149, "Text",ExpressionUUID->"f23c755f-87fc-48c1-8b91-3ffbc94f9f7f",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[2439, 69, 207, 4, 101, "Section",ExpressionUUID->"c6bf7fdf-6fa8-4d2f-a6df-4e7fbf42d1c6"],
Cell[2649, 75, 2900, 48, 551, "Text",ExpressionUUID->"584f472a-9774-4eab-af29-4033def96335"],
Cell[5552, 125, 2320, 43, 303, "Text",ExpressionUUID->"ae4c4844-789c-480e-af08-28cc0440ce3c"],
Cell[7875, 170, 775, 16, 125, "Text",ExpressionUUID->"b3d00bc6-4770-4252-b13e-def52d24b8e3"],
Cell[CellGroupData[{
Cell[8675, 190, 85, 0, 81, "Subsection",ExpressionUUID->"e0029f8f-a176-4c6b-bb8c-7182f2cfefb9"],
Cell[8763, 192, 916, 14, 196, "Text",ExpressionUUID->"e2f041e7-3e84-4589-b71a-744adcbec5ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9716, 211, 82, 0, 81, "Subsection",ExpressionUUID->"3a616cd7-2ed9-4988-be74-503cc954fe7f"],
Cell[9801, 213, 277, 5, 124, "Text",ExpressionUUID->"630460a9-65ba-42b6-bfa9-755038eec217"],
Cell[10081, 220, 731, 16, 172, "Text",ExpressionUUID->"628bcc96-d3b6-4f6f-b555-b1877d2468cc"],
Cell[10815, 238, 211, 4, 75, "Text",ExpressionUUID->"0cb6d1b4-1b55-479d-976e-7ba6f0b3f10a"],
Cell[11029, 244, 256, 7, 75, "Text",ExpressionUUID->"4a015890-a465-4471-afa7-e0909e6077c8"],
Cell[11288, 253, 478, 12, 124, "Text",ExpressionUUID->"f5f95a54-842b-4912-8b5d-3c5b1bc53803"]
}, Closed]],
Cell[CellGroupData[{
Cell[11803, 270, 109, 1, 55, "Subsection",ExpressionUUID->"d9995966-16d3-4b32-9aa3-2ebe9dfb5607",
 CellTags->"copyrigt"],
Cell[11915, 273, 613, 8, 267, "Text",ExpressionUUID->"ab65e885-a2fa-4ce7-a829-9bd7bff18708"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12577, 287, 138, 3, 101, "Section",ExpressionUUID->"b8220ee8-69d5-4891-82d8-45fa6a0bdb59"],
Cell[CellGroupData[{
Cell[12740, 294, 189, 3, 81, "Subsection",ExpressionUUID->"b2ed37fb-c22f-4ebe-8982-5b2b6b9f8ee4"],
Cell[12932, 299, 676, 12, 125, "Text",ExpressionUUID->"93e8246f-3e75-4d8f-800c-4a10529f444e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13645, 316, 192, 3, 81, "Subsection",ExpressionUUID->"5c59c3f8-e23d-4936-a5d5-87a1a352405f"],
Cell[13840, 321, 642, 11, 125, "Text",ExpressionUUID->"5afebb0b-cf51-42b6-90b2-374ba495b2aa"],
Cell[14485, 334, 221, 4, 90, "Text",ExpressionUUID->"0a4b15d6-0ca2-4d98-9f6c-04c192a2688b"],
Cell[14709, 340, 110, 0, 54, "Text",ExpressionUUID->"9b811685-72c3-417b-a270-ca7ecddeabeb"],
Cell[14822, 342, 134, 2, 46, "Input",ExpressionUUID->"4065e14c-0e9d-400f-a301-5660b31d3932"],
Cell[14959, 346, 416, 8, 161, "Text",ExpressionUUID->"1a2e2e1c-fe07-4537-afc3-498b481972d5"],
Cell[15378, 356, 149, 2, 59, "Text",ExpressionUUID->"e0d0ad97-e2f6-4285-8b53-c847b1c974f6"],
Cell[15530, 360, 1179, 18, 46, "Input",ExpressionUUID->"2d5526e8-878a-44f8-af7c-7f731f59d617",
 Evaluatable->False,
 InitializationCell->True],
Cell[16712, 380, 161, 3, 47, "Input",ExpressionUUID->"2d72d54b-241a-49a9-b359-4af3f62722ce"],
Cell[16876, 385, 147, 2, 59, "Text",ExpressionUUID->"aa8fc821-b67d-4231-ba8a-8cb3ec27bbcc"],
Cell[CellGroupData[{
Cell[17048, 391, 275, 5, 70, "Input",ExpressionUUID->"d0f08dd3-fe76-406d-8def-b1c3d6a1764a",
 InitializationCell->True],
Cell[17326, 398, 367, 9, 33, "Message",ExpressionUUID->"61840f20-4b1b-46af-98fd-c5828f976d16"],
Cell[17696, 409, 136, 3, 53, "Output",ExpressionUUID->"d3737406-a808-42c8-b4bf-f93fc841cad1"]
}, Open  ]],
Cell[17847, 415, 193, 3, 47, "Input",ExpressionUUID->"0a3b7508-0bef-413d-a97f-3f25614d0574"],
Cell[18043, 420, 514, 9, 196, "Text",ExpressionUUID->"f7ec43d0-55c0-4228-8056-2b9793602032"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18594, 434, 91, 0, 81, "Subsection",ExpressionUUID->"fe372fbd-799b-428c-a373-5c0c6f61f252"],
Cell[18688, 436, 151, 4, 130, "Text",ExpressionUUID->"fb076f96-9fe0-413b-95d8-add0a98d0b74"],
Cell[18842, 442, 269, 6, 112, "Text",ExpressionUUID->"51153376-9fa3-4e9f-b276-41cfc213195c"],
Cell[19114, 450, 333, 9, 121, "Text",ExpressionUUID->"b853e6cd-3401-4f7b-b3df-62009c60cb84",
 Evaluatable->False],
Cell[19450, 461, 305, 6, 175, "Input",ExpressionUUID->"773bcb6c-6811-4976-ad17-0fe9792c172e",
 InitializationCell->True],
Cell[19758, 469, 481, 12, 121, "Text",ExpressionUUID->"6855cf15-f613-4c97-8ab4-ae8b7d0077af",
 Evaluatable->False],
Cell[20242, 483, 246, 6, 112, "Text",ExpressionUUID->"a2f0ea75-968d-4739-b46a-b77476921ed0"],
Cell[20491, 491, 202, 4, 127, "Text",ExpressionUUID->"d40829f9-654c-486f-b786-412baba5ba74"],
Cell[20696, 497, 530, 9, 186, "Text",ExpressionUUID->"40d86e48-99d3-4f5b-9b94-d025a60b87b9"],
Cell[CellGroupData[{
Cell[21251, 510, 192, 5, 163, "Input",ExpressionUUID->"b6bbc1cf-9200-4008-a078-4ced2c8afa78",
 InitializationCell->True],
Cell[21446, 517, 199, 4, 109, "Output",ExpressionUUID->"0303cbc5-160b-4430-88a0-bac495742186"]
}, Open  ]],
Cell[21660, 524, 739, 14, 559, "Text",ExpressionUUID->"103256ad-ac0f-437f-a569-1fb59269b765"],
Cell[CellGroupData[{
Cell[22424, 542, 89, 0, 118, "Subsubsection",ExpressionUUID->"6ca11b69-3e0b-4d52-95ba-6b3e032f7990"],
Cell[22516, 544, 101, 1, 2147483647, "Input",ExpressionUUID->"28e2ff33-5709-4f3c-a735-c44437e968ac"],
Cell[22620, 547, 117, 1, 2147483647, "Input",ExpressionUUID->"9f1510b1-e4dd-4ce0-8ef9-748efe10083f"],
Cell[22740, 550, 111, 1, 2147483647, "Input",ExpressionUUID->"b12c6e7f-d8b9-42a5-9f0d-439be3566a1c"],
Cell[22854, 553, 116, 1, 2147483647, "Input",ExpressionUUID->"fd1d6458-615a-482d-a6b7-719b4cedb327"],
Cell[22973, 556, 176, 4, 2147483647, "Input",ExpressionUUID->"6f15352d-09f6-44e2-b685-82a0173e1402"],
Cell[23152, 562, 110, 1, 2147483647, "Input",ExpressionUUID->"aabb718e-7f86-444a-868e-0e0b8db5afa1"],
Cell[23265, 565, 169, 3, 2147483647, "Text",ExpressionUUID->"7a86c35e-afc0-41b3-ab55-9ece487dced8"],
Cell[23437, 570, 165, 4, 2147483647, "Input",ExpressionUUID->"b64b2f1e-361d-445b-93e5-ac9aa0b6df8c"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23663, 581, 181, 3, 101, "Section",ExpressionUUID->"076ec018-b557-4135-b673-898e146969ee"],
Cell[23847, 586, 714, 16, 162, "Text",ExpressionUUID->"63bb9b42-e478-4595-ab1d-ee0e586ff56f"],
Cell[CellGroupData[{
Cell[24586, 606, 443, 6, 81, "Subsection",ExpressionUUID->"69d3cc24-4270-4bad-86da-2a079c0b56ff"],
Cell[CellGroupData[{
Cell[25054, 616, 283, 4, 79, "Subsubsection",ExpressionUUID->"d91a70bb-400f-4a2d-b6e8-559f4ce353e4"],
Cell[25340, 622, 299, 7, 124, "Text",ExpressionUUID->"35997699-af44-4535-a0ac-12317f71e64a"],
Cell[25642, 631, 322, 7, 73, "Input",ExpressionUUID->"4dddc099-7c85-4faa-a15a-3f752a138126"],
Cell[25967, 640, 209, 4, 73, "Input",ExpressionUUID->"b1230c31-d48b-44e2-924b-ec8461ad9a51"],
Cell[26179, 646, 213, 5, 73, "Input",ExpressionUUID->"41446a46-d984-4997-b3bc-ceadf3c66eda"],
Cell[26395, 653, 281, 6, 124, "Text",ExpressionUUID->"2660d817-cf71-4fda-b8f7-fbd13c0724e5"],
Cell[26679, 661, 580, 14, 73, "Input",ExpressionUUID->"b9dd1ca7-8e85-4a27-b15d-3dfd633ae28b"],
Cell[27262, 677, 1007, 18, 172, "Text",ExpressionUUID->"9daf1114-b743-4d2f-b95d-ab768644bbdb"],
Cell[28272, 697, 228, 5, 73, "Input",ExpressionUUID->"0d8e290d-6dda-4309-b62f-358ec0f04d35"],
Cell[28503, 704, 525, 9, 73, "Input",ExpressionUUID->"65732ff2-8480-4593-9a56-536ac58128a9"],
Cell[29031, 715, 5676, 102, 322, "Input",ExpressionUUID->"f59bba3d-0a03-448b-99d8-75a8b34e37c6",
 Evaluatable->False],
Cell[34710, 819, 232, 4, 75, "Text",ExpressionUUID->"b5ca4239-e698-4788-b926-3279807ab1de"],
Cell[34945, 825, 219, 4, 73, "Input",ExpressionUUID->"d880de32-fed9-420b-905d-3f921192c8b3"],
Cell[35167, 831, 192, 4, 73, "Input",ExpressionUUID->"1566462c-5a56-4da9-a717-0d062b4c4458"],
Cell[35362, 837, 3686, 51, 73, "Input",ExpressionUUID->"408dddc6-9e2f-4b68-910c-527f24f37a9e",
 Evaluatable->False],
Cell[39051, 890, 769, 13, 222, "Text",ExpressionUUID->"8bbd0f4e-d9be-42d3-b61a-a10fe2c30412"],
Cell[39823, 905, 477, 12, 124, "Text",ExpressionUUID->"a5541907-bbcd-4c3e-93c8-1e54d777239b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40337, 922, 189, 3, 79, "Subsubsection",ExpressionUUID->"2865f7b0-0eb1-46d7-a05f-a15fce31fe53"],
Cell[40529, 927, 388, 9, 2147483647, "Input",ExpressionUUID->"e936cfc2-af5f-407e-8333-9a93a1cb0420"],
Cell[40920, 938, 461, 10, 2147483647, "Input",ExpressionUUID->"40e70472-acef-4710-8f23-12567d1b6652"],
Cell[41384, 950, 273, 7, 2147483647, "Input",ExpressionUUID->"89483b6c-96f4-41f3-8b69-956f5e4d85ad"],
Cell[41660, 959, 443, 9, 2147483647, "Input",ExpressionUUID->"a00b8e56-120b-41fc-b9bb-74919ec1c485"],
Cell[42106, 970, 494, 10, 2147483647, "Input",ExpressionUUID->"45c49b30-b967-4c6f-a939-1b5236b5581a"],
Cell[42603, 982, 429, 10, 2147483647, "Input",ExpressionUUID->"c277ff4b-1ffc-42da-8b58-b46e5b96bd5e"],
Cell[43035, 994, 494, 12, 2147483647, "Input",ExpressionUUID->"9e7476f1-67ad-4c60-a6f3-9e620816360a"],
Cell[43532, 1008, 495, 12, 2147483647, "Input",ExpressionUUID->"0b65c47f-0fed-49fe-94d4-b17b9778bf7b"],
Cell[44030, 1022, 497, 12, 2147483647, "Input",ExpressionUUID->"9ef5912f-b005-40f2-9194-73fa1724f3d2"],
Cell[44530, 1036, 391, 10, 2147483647, "Input",ExpressionUUID->"6ea1f0b6-f54e-4541-9477-c383d552fb23"],
Cell[44924, 1048, 527, 12, 2147483647, "Input",ExpressionUUID->"6576b586-ed64-4bf7-9398-4d3e53324cf6"],
Cell[45454, 1062, 432, 10, 2147483647, "Input",ExpressionUUID->"6aa6bcaa-a7da-4ece-8aa2-ba99a9e86bd1"]
}, Closed]],
Cell[CellGroupData[{
Cell[45923, 1077, 179, 3, 63, "Subsubsection",ExpressionUUID->"8e0e3fab-203f-4f05-a1d3-4b3daa3f70f6"],
Cell[46105, 1082, 250, 6, 2147483647, "Text",ExpressionUUID->"8a4cb506-bef1-4fe2-aa71-7c6b5dce6008"],
Cell[46358, 1090, 852, 18, 2147483647, "Input",ExpressionUUID->"61f61c86-8242-4e17-bacb-3dae43507840"],
Cell[47213, 1110, 174, 4, 2147483647, "Input",ExpressionUUID->"51b8af4b-5ca5-4eff-a7a3-76b54f78bec7"],
Cell[47390, 1116, 259, 7, 2147483647, "Input",ExpressionUUID->"52d31c79-4709-4a96-aa78-ea8943a715a2"],
Cell[47652, 1125, 308, 8, 2147483647, "Input",ExpressionUUID->"6d4bb4e3-d374-4f6e-8ec3-66804860eb97"],
Cell[47963, 1135, 233, 4, 2147483647, "Text",ExpressionUUID->"57aaacff-1c6a-453b-8cca-17e0b76cc039"],
Cell[48199, 1141, 773, 16, 2147483647, "Input",ExpressionUUID->"a0b5f5c7-15d7-4756-a9f4-086a49ea5c0e"],
Cell[48975, 1159, 375, 8, 2147483647, "Input",ExpressionUUID->"7bc6cb61-07e5-4d69-86f7-c322308097ac"],
Cell[49353, 1169, 234, 4, 2147483647, "Text",ExpressionUUID->"917a736d-e016-4170-880c-49f133201176"],
Cell[49590, 1175, 306, 8, 2147483647, "Input",ExpressionUUID->"797966e5-5770-4faa-b719-80376d5d464a"],
Cell[49899, 1185, 291, 4, 2147483647, "Text",ExpressionUUID->"440c874b-7d5b-445a-be59-751fae45e35a"],
Cell[50193, 1191, 667, 17, 2147483647, "Input",ExpressionUUID->"2360dbad-e987-4722-87c9-2e3dce9c63ef"],
Cell[50863, 1210, 368, 7, 2147483647, "Text",ExpressionUUID->"d36db242-2425-4c50-941f-457184847ae5"],
Cell[51234, 1219, 952, 24, 2147483647, "Input",ExpressionUUID->"eafa67a7-88a0-49fc-84f2-daa04e587f97"]
}, Closed]],
Cell[CellGroupData[{
Cell[52223, 1248, 286, 5, 63, "Subsubsection",ExpressionUUID->"3c77c791-9896-423c-8869-9ab0e4db67de"],
Cell[52512, 1255, 283, 4, 75, "Text",ExpressionUUID->"ac979669-d1ca-4048-b751-9e816a17823d"],
Cell[52798, 1261, 764, 19, 174, "Input",ExpressionUUID->"35ea307c-83f6-4586-9312-f41342e19258",
 Evaluatable->False],
Cell[53565, 1282, 567, 10, 172, "Text",ExpressionUUID->"838e0837-af0a-4973-9fa6-10146762cddf"],
Cell[54135, 1294, 173, 4, 73, "Input",ExpressionUUID->"5845367c-af86-46ba-8a90-d008af2d1c20"],
Cell[54311, 1300, 253, 4, 75, "Text",ExpressionUUID->"127bc2a2-c11f-4e38-bd0f-adc176bbb011"],
Cell[54567, 1306, 246, 6, 73, "Input",ExpressionUUID->"58948a0d-c88b-415a-8b0a-bc7bcfaf6867"],
Cell[54816, 1314, 322, 6, 124, "Input",ExpressionUUID->"474b7cda-161a-42bd-bebf-d00682f09849"],
Cell[55141, 1322, 396, 8, 130, "Input",ExpressionUUID->"93ef863d-436b-478a-a199-da3cdd1aef6a"],
Cell[55540, 1332, 203, 3, 75, "Text",ExpressionUUID->"9dfa15d0-ecd0-4def-b66b-2cecef278564"],
Cell[55746, 1337, 360, 8, 73, "Input",ExpressionUUID->"34172d2f-2a2e-4cc2-9ce8-156a1361c793"],
Cell[56109, 1347, 261, 6, 81, "Input",ExpressionUUID->"76f90c8f-5e83-4a32-8f1a-36e1c65173c9"],
Cell[56373, 1355, 353, 7, 73, "Input",ExpressionUUID->"66639ec2-df2f-4289-a88d-3bdeed515b57"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56763, 1367, 166, 3, 79, "Subsubsection",ExpressionUUID->"2b47e938-e55a-417d-ba75-a40b5d745f6a"],
Cell[56932, 1372, 743, 15, 2147483647, "Text",ExpressionUUID->"23361e49-1407-4734-8247-a54fe1c4950e"],
Cell[57678, 1389, 577, 13, 2147483647, "Input",ExpressionUUID->"37fe1b13-0b6e-43b9-9c75-491d4dcc53bf",
 Evaluatable->True],
Cell[58258, 1404, 447, 9, 2147483647, "Input",ExpressionUUID->"f6797cad-f720-4f5a-8b6c-1c8549e78403",
 Evaluatable->True],
Cell[58708, 1415, 1030, 31, 2147483647, "Input",ExpressionUUID->"368a2a6f-dc6b-44cb-8d86-fa25ddf3ea79"],
Cell[59741, 1448, 216, 5, 2147483647, "Input",ExpressionUUID->"72d211e8-23bb-43f4-b634-1abb3450025e"],
Cell[59960, 1455, 242, 6, 2147483647, "Input",ExpressionUUID->"e4ac707d-1271-49aa-be57-9d522824f730"],
Cell[60205, 1463, 173, 3, 2147483647, "Text",ExpressionUUID->"7e1738f4-51ba-40fe-8e64-868237b37463"],
Cell[60381, 1468, 263, 7, 2147483647, "Input",ExpressionUUID->"62475ebe-eef1-4825-a05c-df50bd00ae61"],
Cell[60647, 1477, 153, 3, 2147483647, "Text",ExpressionUUID->"79952a18-ebec-4e2b-8bd9-4c3f96ae512c"],
Cell[60803, 1482, 241, 6, 2147483647, "Input",ExpressionUUID->"da1932e9-b885-48fd-a052-9fd18bf3de05"],
Cell[61047, 1490, 268, 6, 2147483647, "Input",ExpressionUUID->"c91ffefb-a277-4d98-984f-25806bed12b7"],
Cell[61318, 1498, 198, 3, 2147483647, "Text",ExpressionUUID->"edf263bd-a8bf-4fbe-8b23-5fd4cb914584"],
Cell[61519, 1503, 440, 11, 2147483647, "Input",ExpressionUUID->"419ddc1b-50fc-4f23-b4f0-768908dab5c7",
 Evaluatable->True],
Cell[61962, 1516, 354, 9, 2147483647, "Input",ExpressionUUID->"38dde32a-e04e-4e37-b18a-0515c3bccd18",
 Evaluatable->True],
Cell[62319, 1527, 241, 5, 2147483647, "Input",ExpressionUUID->"bb12a45e-152a-4937-bc94-07ac54242f4d"]
}, Closed]],
Cell[CellGroupData[{
Cell[62597, 1537, 424, 6, 63, "Subsubsection",ExpressionUUID->"a7e9782a-c547-485e-808f-42609e7b36d4"],
Cell[63024, 1545, 175, 4, 73, "Input",ExpressionUUID->"c9ce5f5b-5531-451f-a6f9-6b20504108d9"],
Cell[63202, 1551, 588, 10, 124, "Text",ExpressionUUID->"e6ce0626-bbcd-4d2c-a419-e89686db1c33"],
Cell[63793, 1563, 345, 9, 73, "Input",ExpressionUUID->"6e0e9ec8-0aa0-49d4-a4e9-0a16abc55231",
 Evaluatable->False],
Cell[64141, 1574, 237, 6, 73, "Input",ExpressionUUID->"036a6afc-ee02-4468-b651-4d2156350004"],
Cell[64381, 1582, 192, 4, 73, "Input",ExpressionUUID->"ee975b17-f2f8-4075-bf88-cb488842af94"],
Cell[64576, 1588, 223, 5, 73, "Input",ExpressionUUID->"55de6458-10f0-4a82-a335-5b503f2e2c05"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[64848, 1599, 313, 5, 55, "Subsection",ExpressionUUID->"0fa43257-e927-4f01-bdf3-30a9e2b86004"],
Cell[65164, 1606, 180, 3, 75, "Text",ExpressionUUID->"8c9bfbc9-1e67-4238-9334-ee58963262ca"],
Cell[CellGroupData[{
Cell[65369, 1613, 338, 7, 109, "Input",ExpressionUUID->"56f8b7fe-0a85-4cdd-9940-cc9de6da9171",
 InitializationCell->True],
Cell[65710, 1622, 17045, 429, 1227, "Print",ExpressionUUID->"ecda513b-78cb-4062-b582-092d210f4474"]
}, Open  ]],
Cell[82770, 2054, 316, 8, 124, "Text",ExpressionUUID->"a0ce3342-cdfc-4467-8333-786dea1c5fe3"],
Cell[83089, 2064, 177, 4, 73, "Input",ExpressionUUID->"7fd23495-e699-4c40-9468-600fa4f3eade"],
Cell[83269, 2070, 195, 4, 73, "Input",ExpressionUUID->"ebbb6bde-ec89-45c0-9501-75703b830f84"],
Cell[83467, 2076, 194, 4, 73, "Input",ExpressionUUID->"c8281aee-545d-4238-8073-a80bfe7a9d99"],
Cell[83664, 2082, 176, 4, 73, "Input",ExpressionUUID->"04c1de12-c89c-40be-b489-f2a238b1c1a7"],
Cell[83843, 2088, 278, 4, 75, "Text",ExpressionUUID->"3ede3122-962f-44bc-87ee-af3de461c4e0"],
Cell[84124, 2094, 205, 4, 73, "Input",ExpressionUUID->"63e4f156-aad7-4041-a88f-432006e6e3e7"],
Cell[84332, 2100, 323, 9, 124, "Text",ExpressionUUID->"216cf1fd-1b8b-44f5-9339-072d45b86194"],
Cell[CellGroupData[{
Cell[84680, 2113, 174, 3, 79, "Subsubsection",ExpressionUUID->"edca438c-df94-4f08-a9fc-e22c849f7a1c"],
Cell[84857, 2118, 332, 8, 75, "Text",ExpressionUUID->"dab99923-92c6-4f44-b4a6-1e71523e6668"],
Cell[85192, 2128, 199, 4, 73, "Input",ExpressionUUID->"96257e21-724c-421f-a5d8-d3498ccc613e"],
Cell[85394, 2134, 325, 6, 73, "Input",ExpressionUUID->"1fe46e91-b34b-4927-a2ed-748d8ded1aaa"],
Cell[85722, 2142, 466, 10, 75, "Text",ExpressionUUID->"7e051f09-af77-4800-8044-cd06293cd9d7"],
Cell[86191, 2154, 178, 4, 73, "Input",ExpressionUUID->"4688bbc9-caed-40d6-95ed-b46666865f06"],
Cell[86372, 2160, 320, 6, 73, "Input",ExpressionUUID->"1caa435e-25da-4912-9741-6f0179c3f9a6"],
Cell[86695, 2168, 197, 4, 73, "Input",ExpressionUUID->"95194825-46a9-40dd-9b37-a87431debfbe"],
Cell[86895, 2174, 373, 7, 75, "Text",ExpressionUUID->"ea00cb8b-b263-4a30-9ef3-621067c1d284"],
Cell[CellGroupData[{
Cell[87293, 2185, 505, 11, 109, "Input",ExpressionUUID->"e9c3f355-8def-46bb-9d70-23921cb26dfe",
 InitializationCell->True],
Cell[87801, 2198, 248, 5, 73, "Output",ExpressionUUID->"92c73b3f-5c18-4580-985c-b3a5572ddd30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88086, 2208, 281, 7, 109, "Input",ExpressionUUID->"02fd4b65-6499-48ac-af7a-3ce75160ec81",
 InitializationCell->True],
Cell[88370, 2217, 423, 9, 51, "Message",ExpressionUUID->"d468f792-49de-4d96-91a4-ac80ff72ab62"],
Cell[88796, 2228, 181, 3, 73, "Output",ExpressionUUID->"b33d6420-4d08-4886-9eb4-af92b2772f24"]
}, Open  ]],
Cell[88992, 2234, 196, 3, 75, "Text",ExpressionUUID->"bc969a9a-9717-4e6c-a974-d5c675ea3d00"],
Cell[89191, 2239, 192, 4, 73, "Input",ExpressionUUID->"7ac62197-9b9e-44c0-8d1d-4a57481f125d"],
Cell[89386, 2245, 122, 1, 73, "Input",ExpressionUUID->"55bbca8b-19ca-422c-b2df-54c264a77cc6"],
Cell[89511, 2248, 191, 4, 73, "Input",ExpressionUUID->"db932a91-12ea-4a3a-a2d3-a2116194b12f"],
Cell[89705, 2254, 581, 18, 73, "Input",ExpressionUUID->"490ff0ba-1cba-4274-8bfc-db00cfbe1dc2"],
Cell[90289, 2274, 187, 4, 73, "Input",ExpressionUUID->"7cbcac0c-4e4c-4fb8-83c6-ff9da51aca22"],
Cell[90479, 2280, 218, 5, 75, "Text",ExpressionUUID->"c939bf6f-2a00-4f04-a802-afd818f1e5fb"],
Cell[90700, 2287, 616, 19, 73, "Input",ExpressionUUID->"6921a9b7-5949-4fcf-82ab-722b43c43539"],
Cell[91319, 2308, 576, 18, 73, "Input",ExpressionUUID->"7bc4b4c5-b3ac-4f58-8b6d-bd8934975ba8"],
Cell[91898, 2328, 434, 8, 172, "Text",ExpressionUUID->"9c530048-3ba9-48b3-a3eb-eed06e8e53c3"],
Cell[92335, 2338, 184, 4, 73, "Input",ExpressionUUID->"bdf99a3b-702e-457e-9a6f-398d474aba5a"],
Cell[92522, 2344, 199, 4, 73, "Input",ExpressionUUID->"d6eae6c2-24f3-43e8-99c2-efc5f3ca1cb6"],
Cell[92724, 2350, 233, 6, 75, "Text",ExpressionUUID->"ce05b1e9-c625-45cc-8d56-3de0ab63c1c1"],
Cell[92960, 2358, 295, 6, 73, "Input",ExpressionUUID->"fc523fb5-a0bf-41a9-b1c7-5ff28f28b561"],
Cell[93258, 2366, 185, 4, 73, "Input",ExpressionUUID->"f1bf8a92-e286-424f-bd43-c41ad5d0207d"],
Cell[93446, 2372, 225, 5, 75, "Text",ExpressionUUID->"78823f86-f85f-423b-8f6d-e661a5dbaff9"],
Cell[93674, 2379, 128, 1, 73, "Input",ExpressionUUID->"5b8a0cde-1b10-41b9-b168-0ce40150398d"],
Cell[93805, 2382, 371, 9, 73, "Input",ExpressionUUID->"c00323c4-3e4f-4e3b-b1c0-a59557c8767c"],
Cell[94179, 2393, 187, 4, 73, "Input",ExpressionUUID->"89150f2e-0f2b-4aab-8d5b-b03b2ea945f3"],
Cell[94369, 2399, 239, 6, 73, "Input",ExpressionUUID->"8b2c6f49-1004-4664-bcd0-80a3094aee36"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94645, 2410, 308, 5, 79, "Subsubsection",ExpressionUUID->"e869ba47-61fa-47ac-ae1d-3a805e7c5b48"],
Cell[94956, 2417, 190, 3, 2147483647, "Text",ExpressionUUID->"2d0afa3d-504b-4986-9696-d23ac8006818"],
Cell[95149, 2422, 238, 5, 2147483647, "Input",ExpressionUUID->"53c51078-e46c-4f7c-a822-537ae4708c47"],
Cell[95390, 2429, 387, 11, 2147483647, "Input",ExpressionUUID->"dd079e65-9b11-4cdb-94c4-f866b2d5eb13"],
Cell[95780, 2442, 259, 5, 2147483647, "Input",ExpressionUUID->"7ef2ccb7-4758-4030-aa32-74ce760875a2"],
Cell[96042, 2449, 225, 5, 2147483647, "Input",ExpressionUUID->"73b8ff74-183d-4c4e-9271-4142aa2d58f7"],
Cell[96270, 2456, 193, 3, 2147483647, "Text",ExpressionUUID->"a6cf4a3c-72ec-40f3-b659-0dda9b2a7e70"],
Cell[96466, 2461, 245, 6, 2147483647, "Input",ExpressionUUID->"4ab82750-c986-4ab6-9909-d0f0d4bd7d93"],
Cell[96714, 2469, 347, 10, 2147483647, "Input",ExpressionUUID->"ee1b2ff4-cc8a-414e-855c-bbb71516eec6"],
Cell[97064, 2481, 344, 10, 2147483647, "Input",ExpressionUUID->"34c689c1-b54d-44e6-94d6-f4f82e5f619a"],
Cell[97411, 2493, 153, 3, 2147483647, "Text",ExpressionUUID->"26735296-390f-465c-9d71-772b1d3751a3"],
Cell[97567, 2498, 256, 7, 2147483647, "Input",ExpressionUUID->"e6fc1424-e927-4e8f-8e56-8f364beaff47"],
Cell[97826, 2507, 535, 14, 2147483647, "Input",ExpressionUUID->"0e39a20d-c839-40d2-a751-7b3a5b7e9dcd"],
Cell[98364, 2523, 186, 4, 2147483647, "Input",ExpressionUUID->"a4c545ac-109f-4ce9-a61c-a4b91408ba4a"],
Cell[98553, 2529, 518, 13, 2147483647, "Input",ExpressionUUID->"02a99e0a-787b-4eaf-9342-92e9d6913819"],
Cell[99074, 2544, 189, 4, 2147483647, "Input",ExpressionUUID->"8feb5375-e018-421b-b1b9-72e929a30e1b"],
Cell[99266, 2550, 187, 4, 2147483647, "Input",ExpressionUUID->"6ae6829a-23b2-4002-8cd8-6299cc183546"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[99502, 2560, 161, 3, 55, "Subsection",ExpressionUUID->"a04d6ea6-3ad0-4051-a5fd-e4e2a3f1957c"],
Cell[99666, 2565, 431, 8, 186, "Text",ExpressionUUID->"827070e3-1abb-4d27-adf1-3e50de051cdf"],
Cell[CellGroupData[{
Cell[100122, 2577, 106, 1, 109, "Input",ExpressionUUID->"ead8097c-2e80-44ec-af31-204efb2b057a"],
Cell[100231, 2580, 2148, 56, 175, "Print",ExpressionUUID->"c543f945-3a82-4e94-8060-b3ebbe533e4e"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[102440, 2643, 327, 5, 101, "Section",ExpressionUUID->"6bc49477-dc52-409d-923a-1f70c0e85579"],
Cell[CellGroupData[{
Cell[102792, 2652, 233, 4, 81, "Subsection",ExpressionUUID->"f7b383df-f687-4b97-8eab-884b3d87387a"],
Cell[103028, 2658, 716, 14, 125, "Text",ExpressionUUID->"5529cd72-fc3d-4a1e-94bc-4a5bfcdd43fa"],
Cell[CellGroupData[{
Cell[103769, 2676, 648, 10, 68, "Subsubsection",ExpressionUUID->"adc8241f-7caf-455e-adb6-acfa79bccf4e"],
Cell[104420, 2688, 485, 10, 2147483647, "Text",ExpressionUUID->"6630100c-70b9-4558-8cd3-0f1f44cf9fcc"],
Cell[104908, 2700, 207, 5, 2147483647, "Input",ExpressionUUID->"c9f4f98b-3069-4591-9fa2-52bc96b60131"],
Cell[105118, 2707, 326, 7, 2147483647, "Text",ExpressionUUID->"d224d689-c5a6-44fa-ab89-8d5d4b7cf46a"],
Cell[105447, 2716, 333, 11, 2147483647, "Input",ExpressionUUID->"b55b1459-1047-4bf6-8b51-078b9dba1161",
 Evaluatable->False],
Cell[105783, 2729, 172, 4, 2147483647, "Input",ExpressionUUID->"07699850-2be2-4e8c-90ce-6bfd431fac84"],
Cell[105958, 2735, 184, 4, 2147483647, "Input",ExpressionUUID->"def1be80-eac3-453e-9c23-950a6be16d8f"],
Cell[106145, 2741, 1008, 20, 2147483647, "Text",ExpressionUUID->"6ba9bf87-4ccd-41ef-805e-7991822c4d5e"],
Cell[107156, 2763, 264, 6, 2147483647, "Input",ExpressionUUID->"3cd4a3a8-7bc5-4c90-93bb-f7e5c8136764"],
Cell[107423, 2771, 224, 5, 2147483647, "Text",ExpressionUUID->"6ae53fe3-950c-4767-b077-f0018b2096c2"],
Cell[107650, 2778, 170, 3, 2147483647, "Input",ExpressionUUID->"c0c8fcdf-c8e2-4b7c-bdcb-efcee07d710d"],
Cell[107823, 2783, 367, 9, 2147483647, "Input",ExpressionUUID->"76eb8d46-4cd7-45dc-9a11-dbbebe885cba"],
Cell[108193, 2794, 494, 9, 2147483647, "Text",ExpressionUUID->"3cf27cdc-9754-4972-94f1-ae1188976a50"],
Cell[108690, 2805, 338, 9, 2147483647, "Input",ExpressionUUID->"47fb547c-4422-4a40-8b7a-d8248a8d8175"],
Cell[109031, 2816, 229, 4, 2147483647, "Text",ExpressionUUID->"58e3f1e9-cee7-497d-84c4-a63b768d608f"],
Cell[109263, 2822, 657, 14, 2147483647, "Input",ExpressionUUID->"18ba1956-a053-49aa-86c2-bf5b353b6172"],
Cell[109923, 2838, 577, 10, 2147483647, "Text",ExpressionUUID->"a6a67497-46ee-4a7f-93e7-bc05cdf143f6"],
Cell[110503, 2850, 509, 9, 2147483647, "Text",ExpressionUUID->"f6aecdea-23a4-4451-8e9a-8c4141eed182"],
Cell[111015, 2861, 207, 5, 2147483647, "Input",ExpressionUUID->"64b54b6d-8651-430e-b36d-7b4d134bffd8"],
Cell[111225, 2868, 190, 3, 2147483647, "Text",ExpressionUUID->"896eefbc-e96e-4943-ace4-5a3dd644cff3"],
Cell[111418, 2873, 262, 6, 2147483647, "Input",ExpressionUUID->"49699d79-aef6-4e7f-a699-de06eaea85df"],
Cell[111683, 2881, 273, 7, 2147483647, "Text",ExpressionUUID->"3839da26-b80f-4ff9-a691-70338d0695fc"],
Cell[111959, 2890, 377, 10, 2147483647, "Input",ExpressionUUID->"95fde917-b6b1-4c27-97ad-57a511314665"],
Cell[112339, 2902, 267, 7, 2147483647, "Text",ExpressionUUID->"31c6a920-292e-4d21-9407-7d0163830f84"],
Cell[112609, 2911, 175, 4, 2147483647, "Input",ExpressionUUID->"4adfa374-145e-4f82-a73e-d78753f96f6a"],
Cell[112787, 2917, 180, 4, 2147483647, "Input",ExpressionUUID->"7dddd2b0-1792-4d19-a6ab-d096faff490b"],
Cell[112970, 2923, 335, 9, 2147483647, "Input",ExpressionUUID->"afcbafc3-5b4d-4ad3-b43a-03ceb1d719ee"],
Cell[113308, 2934, 184, 4, 2147483647, "Input",ExpressionUUID->"df2cc59b-fa2e-4433-8f3f-39af2e8c469a"],
Cell[113495, 2940, 232, 6, 2147483647, "Text",ExpressionUUID->"d512c18f-e4bf-425e-9f39-97150f32b464"],
Cell[113730, 2948, 340, 9, 2147483647, "Input",ExpressionUUID->"bf4b4927-da86-4ad7-9fdd-99cfa31f97ae"],
Cell[114073, 2959, 678, 18, 2147483647, "Text",ExpressionUUID->"d6e401c5-b125-474d-b73d-3dd2e192ae8f"],
Cell[114754, 2979, 235, 4, 2147483647, "Text",ExpressionUUID->"51784b06-4c2d-4ca1-9f01-3849332ae509"],
Cell[114992, 2985, 444, 10, 2147483647, "Input",ExpressionUUID->"5eaf9632-05cd-4e4d-9df5-23be6df8a9b8"],
Cell[115439, 2997, 480, 11, 2147483647, "Input",ExpressionUUID->"c9a3873f-31df-4371-9500-a646b58800d2"],
Cell[115922, 3010, 297, 5, 2147483647, "Text",ExpressionUUID->"79724e69-0d1e-4730-8dd2-7c3b7860ac03"],
Cell[116222, 3017, 237, 5, 2147483647, "Input",ExpressionUUID->"583a1062-5bcd-4879-98ac-734bf9cb37ad"],
Cell[116462, 3024, 339, 9, 2147483647, "Input",ExpressionUUID->"7bbe5794-6e97-4c49-ae87-dc0dc1c0211e"],
Cell[116804, 3035, 336, 9, 2147483647, "Text",ExpressionUUID->"1e1aa6fb-d5d7-4853-8596-3741d22d83f0"],
Cell[117143, 3046, 103, 1, 2147483647, "Input",ExpressionUUID->"d4ecfef5-5dd7-4d58-8986-d0462f0ee69f"],
Cell[117249, 3049, 421, 10, 2147483647, "Input",ExpressionUUID->"2971cc55-b4de-4ff7-9e10-77cd5db8d05e"],
Cell[117673, 3061, 472, 11, 2147483647, "Input",ExpressionUUID->"46a687f5-9293-41b8-97c9-edfa0ef6aa3b"],
Cell[118148, 3074, 169, 3, 2147483647, "Text",ExpressionUUID->"54d5ec4f-a8a0-4750-8b88-ceacd2cb53ca"],
Cell[118320, 3079, 197, 4, 2147483647, "Input",ExpressionUUID->"04ea8db1-29ac-439d-bed1-f672ebf79f5b"],
Cell[118520, 3085, 197, 4, 2147483647, "Input",ExpressionUUID->"46c7d63d-9fd8-4723-b7e1-73fb1a62b6fa"]
}, Closed]],
Cell[CellGroupData[{
Cell[118754, 3094, 423, 6, 54, "Subsubsection",ExpressionUUID->"bca147d7-1653-407f-8cbe-aa4527e1cc4b"],
Cell[119180, 3102, 297, 7, 2147483647, "Text",ExpressionUUID->"d9bd89b6-152f-4c1d-9bec-21d7dd39d542"],
Cell[119480, 3111, 154, 3, 2147483647, "Text",ExpressionUUID->"3f85f9ca-c344-4b9a-84be-52e31589c6e9"],
Cell[119637, 3116, 271, 7, 2147483647, "Input",ExpressionUUID->"f2f6e022-7d1f-4a46-b46e-2ef0502d71fb"],
Cell[119911, 3125, 203, 4, 2147483647, "Text",ExpressionUUID->"54d3a152-59b0-4767-aa82-3ba2d73c0065"],
Cell[120117, 3131, 207, 5, 2147483647, "Input",ExpressionUUID->"0913ba18-d2af-4f84-9769-17ddf88500c7"],
Cell[120327, 3138, 219, 5, 2147483647, "Text",ExpressionUUID->"cf580d62-d016-43e2-9d7c-32171efd42e6"],
Cell[120549, 3145, 295, 7, 2147483647, "Input",ExpressionUUID->"8b606fc2-ce90-4842-acd2-623c572e9a30"],
Cell[120847, 3154, 319, 9, 2147483647, "Text",ExpressionUUID->"a81457a4-135d-4887-b8e1-e4ecbe13f748"],
Cell[121169, 3165, 397, 9, 2147483647, "Input",ExpressionUUID->"d11dc95b-6de3-446d-9d59-6bf8fb2e5fc1"],
Cell[121569, 3176, 218, 5, 2147483647, "Text",ExpressionUUID->"4f3c835e-54df-4ade-9d85-5726ff55c908"],
Cell[121790, 3183, 303, 8, 2147483647, "Input",ExpressionUUID->"bfa7a881-a75d-42d1-9369-555f00633a11"],
Cell[122096, 3193, 447, 10, 2147483647, "Input",ExpressionUUID->"fc28be37-2460-41c6-93d3-f574b10dc278"],
Cell[122546, 3205, 206, 4, 2147483647, "Input",ExpressionUUID->"1530b790-6671-4058-8c72-9ef15d42f566"],
Cell[122755, 3211, 184, 4, 2147483647, "Input",ExpressionUUID->"2ef910a2-3d9a-4635-bba5-4bdba5be248e"],
Cell[122942, 3217, 255, 5, 2147483647, "Input",ExpressionUUID->"01e37817-4b8f-4c86-9b56-e8fa1e3caa86"],
Cell[123200, 3224, 182, 3, 2147483647, "Text",ExpressionUUID->"ef40d2f0-54d5-4ed9-8f26-631049806ff9"],
Cell[123385, 3229, 179, 4, 2147483647, "Input",ExpressionUUID->"3ad1cf53-197f-46cb-a30d-205ab633d732"],
Cell[123567, 3235, 289, 7, 2147483647, "Input",ExpressionUUID->"b86b4b95-bf6c-46df-85de-6fd092bd2b3a"],
Cell[123859, 3244, 456, 12, 2147483647, "Input",ExpressionUUID->"a4b2e594-f7f5-40f7-ae5f-5bcd2158f83c"],
Cell[124318, 3258, 299, 6, 2147483647, "Text",ExpressionUUID->"846c8873-7003-4c6d-a86d-fef76fea801f"],
Cell[124620, 3266, 624, 17, 2147483647, "Input",ExpressionUUID->"a273b57f-0fd5-404e-b1bd-b642b3636dd1"],
Cell[125247, 3285, 527, 15, 2147483647, "Input",ExpressionUUID->"44579c21-3f31-46df-adcf-d9bdf97c600e"],
Cell[125777, 3302, 542, 15, 2147483647, "Input",ExpressionUUID->"50d7b2bd-0016-4624-a67d-23f0a00822bf"],
Cell[126322, 3319, 331, 8, 2147483647, "Input",ExpressionUUID->"bd1aa92f-6fe2-42ff-81b7-5b59559de3c6"],
Cell[126656, 3329, 608, 12, 2147483647, "Text",ExpressionUUID->"19358331-3a47-4b13-bc88-2a03919c9dcf"],
Cell[CellGroupData[{
Cell[127289, 3345, 676, 15, 2147483647, "Input",ExpressionUUID->"9ce0d99d-6f0b-4cbb-9445-713527b1f474"],
Cell[127968, 3362, 687, 14, 2147483647, "Message",ExpressionUUID->"17c3cb44-5cdd-4021-8db1-729f0ba37094"]
}, Closed]],
Cell[128670, 3379, 372, 9, 2147483647, "Text",ExpressionUUID->"fd22a000-bd46-49d5-9313-0d62e08607c3"],
Cell[129045, 3390, 463, 11, 2147483647, "Input",ExpressionUUID->"223ae093-15fa-459c-8988-a900d05d64c1"],
Cell[129511, 3403, 455, 11, 2147483647, "Input",ExpressionUUID->"9a8f3f50-c42d-434d-82bc-3cc7485e26d4"],
Cell[129969, 3416, 446, 10, 2147483647, "Input",ExpressionUUID->"0d6a4ee2-dedf-45bc-a413-bc9ff89a7a98"]
}, Closed]],
Cell[CellGroupData[{
Cell[130452, 3431, 230, 4, 54, "Subsubsection",ExpressionUUID->"1f7b20c7-28fa-4e6e-b7fd-fffb75853a23"],
Cell[130685, 3437, 519, 9, 3343, "Text",ExpressionUUID->"c82e9a31-fbb2-42d9-a123-7308b2cd6024"],
Cell[131207, 3448, 174, 4, 2047, "Input",ExpressionUUID->"0de3f937-6c3e-44d9-8748-b56a780e4e1c"],
Cell[131384, 3454, 186, 4, 2047, "Input",ExpressionUUID->"fcbe95ff-55d8-4326-b62b-d7ea2a1ff679"],
Cell[131573, 3460, 290, 6, 3343, "Text",ExpressionUUID->"f73b3db4-3d47-42d4-bdd1-5e094ff60e1d"],
Cell[131866, 3468, 497, 13, 2047, "Input",ExpressionUUID->"938e4736-2f6e-4624-913b-dc33fb5728c5"],
Cell[132366, 3483, 171, 3, 2047, "Text",ExpressionUUID->"8e40dbdd-9b97-458c-a813-fadd9ef2931a"],
Cell[132540, 3488, 558, 15, 2047, "Input",ExpressionUUID->"0643937d-bcba-44a2-ad16-4078f3f2f727"],
Cell[133101, 3505, 176, 4, 2047, "Input",ExpressionUUID->"8605180e-42f3-4b9e-a0bf-d805594a821e"],
Cell[133280, 3511, 242, 5, 2047, "Input",ExpressionUUID->"1a347685-6e68-42b2-9a50-d35c1de7d448"],
Cell[133525, 3518, 158, 3, 2047, "Input",ExpressionUUID->"d6e3c8d8-b311-416a-8583-bb7a1ebf4222"],
Cell[133686, 3523, 337, 9, 2047, "Input",ExpressionUUID->"ae4c2924-4845-406e-afe0-4b0ef9e71f84"],
Cell[134026, 3534, 537, 11, 4645, "Text",ExpressionUUID->"9832a0ca-d8de-4d69-867f-2744438d102b"],
Cell[134566, 3547, 180, 4, 2047, "Input",ExpressionUUID->"325f1aa2-2cb1-4b0e-9a10-e09f223650ae"],
Cell[134749, 3553, 660, 17, 2047, "Input",ExpressionUUID->"09a76d27-6a5b-4e08-8349-6f6599660386"],
Cell[135412, 3572, 189, 4, 2047, "Input",ExpressionUUID->"f470bdc7-f9d8-476d-b38b-9be9d6b0eaf7"],
Cell[135604, 3578, 314, 7, 3343, "Text",ExpressionUUID->"594e5f92-4e2b-4e15-8756-7b8ac4b394bd"],
Cell[135921, 3587, 270, 6, 2047, "Input",ExpressionUUID->"fe2acea7-7372-4350-bdb4-7f139ca041c7"],
Cell[136194, 3595, 540, 10, 5941, "Text",ExpressionUUID->"e8bc1852-9c3f-487c-b82f-2d8e64d49daa"],
Cell[136737, 3607, 511, 16, 2047, "Input",ExpressionUUID->"7991b552-03cc-4484-b554-50dd1b2a5615"],
Cell[137251, 3625, 164, 3, 2047, "Text",ExpressionUUID->"13199836-56fb-4c82-bff8-eb72735cc247"],
Cell[137418, 3630, 208, 4, 2047, "Input",ExpressionUUID->"f632ed59-0644-4b38-940c-ca3e729233d5"],
Cell[137629, 3636, 485, 9, 3343, "Text",ExpressionUUID->"b4b2614d-68ae-449a-9421-0e3fb50008a0"],
Cell[138117, 3647, 754, 18, 2047, "Input",ExpressionUUID->"9940eac2-a195-43a6-9973-33fc30318fde"],
Cell[138874, 3667, 834, 19, 2047, "Input",ExpressionUUID->"44371ed1-aafa-472d-b9b0-a27983c927d0"],
Cell[139711, 3688, 801, 19, 2047, "Input",ExpressionUUID->"57ecb4ad-36fd-4d2f-8dcd-ec21f89b8139"],
Cell[140515, 3709, 347, 7, 2047, "Text",ExpressionUUID->"dab819e5-6dd2-42bf-8472-cd496672cd9c"],
Cell[140865, 3718, 180, 4, 2047, "Input",ExpressionUUID->"4397e512-49ac-48d5-9a98-0ccc5391db0c"],
Cell[141048, 3724, 321, 6, 2047, "Input",ExpressionUUID->"7d7a237f-107a-4270-b35d-40329e65cc2d"],
Cell[141372, 3732, 245, 6, 2047, "Input",ExpressionUUID->"1091ee92-03f5-4e2a-80fa-8743a1e38d5c"],
Cell[141620, 3740, 347, 7, 3343, "Text",ExpressionUUID->"e5ddd38a-9b81-4d71-979f-bb7763c79f9a"],
Cell[141970, 3749, 217, 5, 2047, "Input",ExpressionUUID->"d3f927a5-8115-428f-9be8-2a5bf9951f61"],
Cell[142190, 3756, 784, 24, 3375, "Input",ExpressionUUID->"83b5f7f8-dc5c-48b8-9c7c-cee5431c5b6a"],
Cell[142977, 3782, 601, 10, 3343, "Text",ExpressionUUID->"8d553dcc-0f10-4aec-8523-ca28751e5196"],
Cell[143581, 3794, 539, 14, 2047, "Input",ExpressionUUID->"15feab42-a4e3-4a65-bede-d10779a86954"],
Cell[144123, 3810, 309, 6, 3343, "Text",ExpressionUUID->"7f0d650f-d53e-490a-8206-20509336c159"],
Cell[144435, 3818, 847, 20, 2047, "Input",ExpressionUUID->"0bea8242-2a46-4a9d-99e1-eb622cace2d7"],
Cell[145285, 3840, 348, 8, 2047, "Input",ExpressionUUID->"f890d5e2-0dd1-4df7-b277-c430323ed244"],
Cell[145636, 3850, 403, 8, 3343, "Text",ExpressionUUID->"bc3cb0d7-79ab-4b4f-b32a-cb9b706f1855"],
Cell[146042, 3860, 726, 19, 2047, "Input",ExpressionUUID->"95a2ff60-70ef-4f4b-9b3d-b25ce0b6f8ea",
 Evaluatable->False],
Cell[146771, 3881, 135, 3, 2047, "Text",ExpressionUUID->"db6cef00-5b37-48de-bc86-bd5060b679f1"],
Cell[146909, 3886, 1080, 31, 3375, "Input",ExpressionUUID->"f3124ed3-9f0c-4741-b2b7-44f5eb6b4bbf",
 Evaluatable->False],
Cell[147992, 3919, 298, 7, 2047, "Text",ExpressionUUID->"3640bff5-1fc9-477e-8b16-52f041c270f8"],
Cell[148293, 3928, 898, 23, 2047, "Input",ExpressionUUID->"3765272e-8d15-44e8-8be6-39cf0b8eaa94"],
Cell[149194, 3953, 219, 5, 2047, "Text",ExpressionUUID->"0e08dc95-d32f-4a86-b4ce-79f12d0610c0"],
Cell[149416, 3960, 568, 16, 2047, "Input",ExpressionUUID->"a8e267e7-e32b-41ed-b294-2523a5cb0c76",
 Evaluatable->False],
Cell[149987, 3978, 202, 3, 2047, "Text",ExpressionUUID->"d4b3e546-b32b-4daf-9b13-8f0c7402dcbc"],
Cell[150192, 3983, 1266, 35, 4677, "Input",ExpressionUUID->"c27cff37-d4c8-49dd-9970-9fcfa5aece79"],
Cell[151461, 4020, 434, 8, 3343, "Text",ExpressionUUID->"0827cf7c-9337-4279-8f2c-850f2e19a2af"],
Cell[151898, 4030, 317, 7, 2047, "Input",ExpressionUUID->"c487f3de-3c2f-45ad-9d77-e780b508216f"],
Cell[152218, 4039, 251, 6, 3343, "Text",ExpressionUUID->"bb2059d5-a00c-4eee-b028-5dfb871bc4aa"],
Cell[152472, 4047, 524, 11, 2047, "Input",ExpressionUUID->"e99e22d4-0f41-4a17-a062-68705a9d0086"],
Cell[152999, 4060, 306, 7, 3343, "Text",ExpressionUUID->"221dcb0e-d04d-4e54-8b4b-67e1792bf290"],
Cell[153308, 4069, 448, 13, 2047, "Input",ExpressionUUID->"76c2f98b-c0b1-413c-bd0c-fa0292c5985e",
 Evaluatable->False],
Cell[153759, 4084, 485, 15, 2047, "Input",ExpressionUUID->"f83aa0bb-67a2-49fe-a6a4-1b573de30cf3",
 Evaluatable->False],
Cell[154247, 4101, 1001, 20, 9841, "Text",ExpressionUUID->"3cbff529-d1c0-4aa9-9c70-c15a98110186"],
Cell[155251, 4123, 674, 19, 2047, "Input",ExpressionUUID->"f944bd1e-93d2-4431-be98-7bb641561ebc"],
Cell[155928, 4144, 195, 3, 2047, "Text",ExpressionUUID->"1ee1bfbe-4e53-4a4c-82d8-f95600971542"],
Cell[156126, 4149, 488, 11, 2047, "Input",ExpressionUUID->"f37d878c-aa99-4810-8666-54722513bec5"],
Cell[156617, 4162, 324, 7, 2047, "Input",ExpressionUUID->"5544863d-b2f7-4564-8edd-e1852b9fb272"]
}, Closed]],
Cell[156956, 4172, 342, 5, 54, "Subsubsection",ExpressionUUID->"10462728-d931-4f76-9708-cced3395b20f"],
Cell[CellGroupData[{
Cell[157323, 4181, 234, 4, 54, "Subsubsection",ExpressionUUID->"1fe14ea5-edf5-46f6-baa6-584fb5ab6304"],
Cell[157560, 4187, 178, 3, 75, "Text",ExpressionUUID->"62527a4c-6f93-41ed-8ce0-4a14e09c47a3"],
Cell[157741, 4192, 230, 5, 73, "Input",ExpressionUUID->"d13950bf-2d70-4d12-b102-df7cf1359f83"],
Cell[157974, 4199, 298, 7, 75, "Text",ExpressionUUID->"b077ae38-d0d5-4820-bf0e-f9452d85e221",
 Evaluatable->False],
Cell[158275, 4208, 174, 4, 73, "Input",ExpressionUUID->"b074b4d8-345d-41eb-80a9-1d5ec1007408"],
Cell[158452, 4214, 314, 7, 75, "Text",ExpressionUUID->"a9138594-4527-429a-8948-f702ff44a333"],
Cell[158769, 4223, 297, 7, 73, "Input",ExpressionUUID->"571058fe-b7a4-4974-ad89-77c67b34752a"],
Cell[159069, 4232, 587, 15, 73, "Input",ExpressionUUID->"24e6c883-889b-4064-9865-06d6ae7ccd2c"],
Cell[159659, 4249, 224, 3, 75, "Text",ExpressionUUID->"08db3611-04f3-47c9-a6fa-d95740185d29"],
Cell[159886, 4254, 374, 10, 73, "Input",ExpressionUUID->"ff2d5b2e-1e87-4c31-871c-3a402c4cac0a"],
Cell[160263, 4266, 206, 5, 73, "Input",ExpressionUUID->"8d868dd2-11c9-4ce3-a21c-a7e636024ea3"],
Cell[160472, 4273, 248, 4, 75, "Text",ExpressionUUID->"a84b01d1-ff15-49f6-af6a-7c1ead73c200"],
Cell[160723, 4279, 386, 11, 73, "Input",ExpressionUUID->"ef378339-037e-43ca-9624-1e24ddb14745"],
Cell[161112, 4292, 363, 10, 73, "Input",ExpressionUUID->"c399a236-b794-44b1-96f8-572875ceaee8"],
Cell[161478, 4304, 185, 4, 73, "Input",ExpressionUUID->"c9029af1-f33e-46f7-9fbd-8ebab6016051"]
}, Closed]],
Cell[CellGroupData[{
Cell[161700, 4313, 257, 4, 54, "Subsubsection",ExpressionUUID->"1979fea6-03d1-4a44-9ad0-0ee5accc84e0"],
Cell[161960, 4319, 332, 7, 2147483647, "Text",ExpressionUUID->"a51662de-0667-4508-b536-d0e5e6f872ab"],
Cell[162295, 4328, 895, 18, 2147483647, "Input",ExpressionUUID->"1ad9523f-9b43-4711-9c08-bac00d88e538"],
Cell[163193, 4348, 186, 4, 2147483647, "Input",ExpressionUUID->"3db96b5d-01be-41a2-bfb1-91341b660aaa"],
Cell[163382, 4354, 242, 5, 2147483647, "Input",ExpressionUUID->"820a5992-220f-4713-8b3c-fdee0039d2cf"],
Cell[163627, 4361, 195, 5, 2147483647, "Input",ExpressionUUID->"0101e4d9-e3c0-484d-9dac-9e7e9315deac"],
Cell[163825, 4368, 280, 6, 2147483647, "Text",ExpressionUUID->"8c733b9c-f2fb-4e2d-8c97-1492d555b3e6"],
Cell[164108, 4376, 223, 5, 2147483647, "Input",ExpressionUUID->"7211830b-5581-4772-aeac-cafde1866314"],
Cell[164334, 4383, 275, 6, 2147483647, "Input",ExpressionUUID->"762bb9d1-5e1c-4000-b400-632d73c14e37"],
Cell[164612, 4391, 339, 8, 2147483647, "Input",ExpressionUUID->"f442bab7-b104-4170-bf1b-2678bd695782"],
Cell[164954, 4401, 228, 5, 2147483647, "Input",ExpressionUUID->"dc4cf3e5-72d2-496c-a741-55d27c15642b"],
Cell[165185, 4408, 367, 8, 2147483647, "Input",ExpressionUUID->"98c30450-6ada-4f37-86b4-e62eed696592"],
Cell[165555, 4418, 488, 12, 2147483647, "Input",ExpressionUUID->"aab529af-30fb-42d8-b733-b1a6ec586aba"],
Cell[166046, 4432, 188, 4, 2147483647, "Input",ExpressionUUID->"b507faa6-acd3-4764-adfa-da226b047802"],
Cell[166237, 4438, 360, 9, 2147483647, "Input",ExpressionUUID->"c8cbbde1-60b4-47af-bbf8-c11b2110b8e4"],
Cell[166600, 4449, 496, 12, 2147483647, "Input",ExpressionUUID->"54d67a59-f493-449d-9ddc-1417bb61b2b4"],
Cell[167099, 4463, 176, 4, 2147483647, "Input",ExpressionUUID->"37d4008d-b2f0-43af-98af-91885ecc45ae"],
Cell[167278, 4469, 281, 7, 2147483647, "Input",ExpressionUUID->"7a0148af-1b7c-47a1-ae47-8868602b2c1c"],
Cell[167562, 4478, 202, 3, 2147483647, "Text",ExpressionUUID->"22de1a70-3bca-42ea-aa58-0e14374f2800"],
Cell[167767, 4483, 376, 8, 2147483647, "Input",ExpressionUUID->"13912130-e62a-4fb9-8d20-48f1d56d229c"],
Cell[168146, 4493, 196, 3, 2147483647, "Text",ExpressionUUID->"9c014235-8606-44bb-9605-b205b153e684"],
Cell[168345, 4498, 546, 13, 2147483647, "Input",ExpressionUUID->"b8821200-ff7a-47d3-9952-774002de88f9"],
Cell[168894, 4513, 388, 10, 2147483647, "Input",ExpressionUUID->"58e3b75a-5d6d-441e-8060-696b7c281b01"],
Cell[169285, 4525, 401, 10, 2147483647, "Input",ExpressionUUID->"a686d98b-1255-494a-b7a9-97d132c8649c"],
Cell[169689, 4537, 403, 10, 2147483647, "Input",ExpressionUUID->"dcea3c7b-f219-41b2-9ec6-9a57998cb069"],
Cell[170095, 4549, 471, 8, 2147483647, "Text",ExpressionUUID->"1ac514c9-d684-416f-afb1-94a7aae6970c"]
}, Closed]],
Cell[CellGroupData[{
Cell[170603, 4562, 173, 3, 54, "Subsubsection",ExpressionUUID->"0b03cde2-e3fd-4de1-875c-56d1afbcf673"],
Cell[170779, 4567, 528, 9, 2147483647, "Input",ExpressionUUID->"a54ddfe9-fac4-47ba-ab83-86ace637b8bd"],
Cell[171310, 4578, 597, 12, 2147483647, "Text",ExpressionUUID->"28dfc634-ea45-43c8-a22c-d08523101604"],
Cell[171910, 4592, 157, 3, 2147483647, "Input",ExpressionUUID->"7316ffd4-7a80-40c3-9dd6-10f2a5fc2747"],
Cell[172070, 4597, 262, 6, 2147483647, "Input",ExpressionUUID->"76487026-d7ac-491b-9226-dfb7771b28bb"],
Cell[172335, 4605, 216, 5, 2147483647, "Text",ExpressionUUID->"91b0fd14-be0d-4100-ada8-36d1c7c871f0"],
Cell[172554, 4612, 556, 13, 2147483647, "Input",ExpressionUUID->"b58bca73-b254-4786-b368-360b4c59f98b"],
Cell[173113, 4627, 350, 8, 2147483647, "Input",ExpressionUUID->"64937c49-4154-48be-9322-be016aaf8225"],
Cell[173466, 4637, 666, 18, 2147483647, "Input",ExpressionUUID->"4a72d5a3-c702-44fd-86e0-99ea67122c58"],
Cell[174135, 4657, 252, 5, 2147483647, "Text",ExpressionUUID->"283f194d-5fe5-4a0c-a272-e4d5f8c2285b"],
Cell[174390, 4664, 249, 6, 2147483647, "Input",ExpressionUUID->"1fca5a26-945f-4ddc-8fd3-36e426f6b7f0"],
Cell[174642, 4672, 333, 9, 2147483647, "Input",ExpressionUUID->"543727b4-6d2b-42e1-9e58-00a0f2f85371"],
Cell[174978, 4683, 385, 8, 2147483647, "Text",ExpressionUUID->"aeda34c0-ac62-4f23-bfc7-306f331a54cf"],
Cell[175366, 4693, 214, 5, 2147483647, "Input",ExpressionUUID->"a01bd17f-d1bb-4587-ae26-54082bbb3f70"],
Cell[175583, 4700, 738, 17, 2147483647, "Input",ExpressionUUID->"4539909e-51d1-4b7f-a93a-5ea3a52bf218"],
Cell[176324, 4719, 435, 10, 2147483647, "Text",ExpressionUUID->"b1bc528e-485f-4fc7-84d0-1a006d6a3966"],
Cell[176762, 4731, 193, 4, 2147483647, "Input",ExpressionUUID->"b8547af3-1b6d-40dc-89a6-6510afe2d960"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[177004, 4741, 543, 8, 81, "Subsection",ExpressionUUID->"0e0cef3c-83a8-4924-9d86-c34aadb71afe"],
Cell[CellGroupData[{
Cell[177572, 4753, 352, 5, 68, "Subsubsection",ExpressionUUID->"3898e447-7cdc-4b50-92c0-e4bf3624ee09"],
Cell[177927, 4760, 205, 5, 73, "Input",ExpressionUUID->"758eb07a-5783-4ecc-a35d-b5a5bf2d2b05"],
Cell[178135, 4767, 928, 16, 222, "Text",ExpressionUUID->"f53b3e91-4c1e-46d5-a39d-7a575d579ce6"],
Cell[179066, 4785, 784, 21, 124, "Input",ExpressionUUID->"74b512bd-ef63-4877-84a1-b09e2b6f5fd1",
 Evaluatable->False],
Cell[179853, 4808, 1765, 32, 367, "Text",ExpressionUUID->"f782c9f8-fb72-4f73-834a-42da424b2095"],
Cell[181621, 4842, 180, 4, 73, "Input",ExpressionUUID->"af9d8efc-67c4-4724-bc46-091b000c8a32"],
Cell[181804, 4848, 175, 4, 73, "Input",ExpressionUUID->"94f3782b-603b-4ecc-bbc5-f6961aceae41"],
Cell[181982, 4854, 178, 3, 75, "Text",ExpressionUUID->"17f654f9-a0d0-4299-ad2e-44da048a3790"],
Cell[182163, 4859, 177, 4, 73, "Input",ExpressionUUID->"ca7e767f-6fdf-4304-adac-4b33942ddc9f"],
Cell[182343, 4865, 248, 6, 73, "Input",ExpressionUUID->"ca908c72-9ff7-4906-9976-af821194a83d"],
Cell[182594, 4873, 194, 3, 75, "Text",ExpressionUUID->"b89f10ef-3859-4d6f-8398-70231d8f3901"],
Cell[182791, 4878, 423, 11, 73, "Input",ExpressionUUID->"c8e19b31-f07d-4615-a437-0b8467f25d90"],
Cell[183217, 4891, 392, 9, 172, "Text",ExpressionUUID->"cc1345f7-d588-4c77-8376-d2dddd2e67fe"],
Cell[183612, 4902, 221, 3, 75, "Text",ExpressionUUID->"28e5e9bd-2ff9-492d-96ff-f929b1b97a7a"],
Cell[183836, 4907, 455, 12, 73, "Input",ExpressionUUID->"30b16764-60aa-44a9-afa4-be82f86f6168"],
Cell[184294, 4921, 214, 5, 73, "Input",ExpressionUUID->"fcfb6ae9-4833-420e-acd0-a6e93738ed6d"],
Cell[184511, 4928, 520, 14, 73, "Input",ExpressionUUID->"d40251ad-1b88-4298-bd4d-9dc68aeb2734"],
Cell[185034, 4944, 419, 11, 73, "Input",ExpressionUUID->"e307592f-fca7-410d-b244-7c56cb507fde"],
Cell[185456, 4957, 269, 6, 75, "Text",ExpressionUUID->"eed41599-98ec-49fc-a40f-434cc07124d2"],
Cell[185728, 4965, 409, 11, 73, "Input",ExpressionUUID->"26882764-ce50-486e-a8f5-250d53d9c81b"],
Cell[186140, 4978, 538, 14, 73, "Input",ExpressionUUID->"4369d04b-71c8-4ca5-9a2a-2b8000d46dfb"],
Cell[186681, 4994, 466, 12, 73, "Input",ExpressionUUID->"10513978-f2f2-4b40-bc6c-ad4fbe96c014"],
Cell[187150, 5008, 316, 7, 75, "Text",ExpressionUUID->"11fba2d3-ed31-470a-b33d-af50765defb7"],
Cell[187469, 5017, 837, 17, 172, "Text",ExpressionUUID->"3e938314-f77c-4231-85a9-30ec17e77944"],
Cell[188309, 5036, 751, 19, 87, "Input",ExpressionUUID->"ffbae288-8690-4e5f-ac13-f145b6d76920",
 Evaluatable->False],
Cell[189063, 5057, 216, 5, 75, "Text",ExpressionUUID->"5642c070-ed65-4b54-a158-61b58af74d9d"],
Cell[189282, 5064, 969, 27, 124, "Input",ExpressionUUID->"b544f8ef-daa6-4274-b9bd-92959458013b"],
Cell[190254, 5093, 558, 15, 73, "Input",ExpressionUUID->"f057e9f7-4996-4b5a-aaee-90e733f6f831"],
Cell[190815, 5110, 461, 8, 124, "Text",ExpressionUUID->"57f5c0af-b65b-49ea-bd0d-d017a1295222"],
Cell[191279, 5120, 381, 10, 73, "Input",ExpressionUUID->"27db1041-75f4-42c3-9f13-5c7cc485760b"],
Cell[191663, 5132, 219, 5, 73, "Input",ExpressionUUID->"6f51aa7c-16c7-4e23-b33b-7fceaf3e5e3d"],
Cell[191885, 5139, 448, 8, 124, "Text",ExpressionUUID->"ce2accaa-4ad1-4381-9d69-5262f1d4dc0b"],
Cell[192336, 5149, 259, 7, 73, "Input",ExpressionUUID->"6fbed608-763f-4393-8718-b901d0630044"],
Cell[192598, 5158, 584, 15, 73, "Input",ExpressionUUID->"5a50c16b-d1b1-41ac-9c39-043829263baa"],
Cell[193185, 5175, 648, 11, 222, "Text",ExpressionUUID->"b69ba50e-c997-4b64-9f9a-ee8e7b595a2f"],
Cell[193836, 5188, 576, 14, 73, "Input",ExpressionUUID->"23e181b1-30a7-4c20-bb56-d45bea5eea4e"],
Cell[194415, 5204, 222, 5, 73, "Input",ExpressionUUID->"6e8aa4bc-b8b3-43da-893c-0d047bd68925"],
Cell[194640, 5211, 271, 4, 75, "Text",ExpressionUUID->"5947a383-d259-4f09-b48d-a3b39881b0c3"],
Cell[194914, 5217, 476, 14, 73, "Input",ExpressionUUID->"4c5aac84-d8ff-47d3-a0cb-932e968f3c76"],
Cell[195393, 5233, 210, 5, 73, "Input",ExpressionUUID->"82e08c95-ef21-4f5d-ac5c-45d64c283fc3"],
Cell[195606, 5240, 602, 11, 172, "Text",ExpressionUUID->"f29df10c-580a-4207-ac9b-d73cf8d09cb3"]
}, Closed]],
Cell[CellGroupData[{
Cell[196245, 5256, 407, 6, 54, "Subsubsection",ExpressionUUID->"8aa3e990-87a6-46f6-b128-123acbe695cb"],
Cell[196655, 5264, 1069, 20, 2147483647, "Text",ExpressionUUID->"d3bce376-2dad-4cfc-bbdc-99c0f9b8280c"],
Cell[197727, 5286, 906, 16, 2147483647, "Text",ExpressionUUID->"8cdf8a4a-7c1f-48af-b8f4-9a6794b5efe5"],
Cell[198636, 5304, 246, 6, 2147483647, "Input",ExpressionUUID->"f61bd461-882e-4678-a6d1-44a77034c150"],
Cell[198885, 5312, 250, 5, 2147483647, "Input",ExpressionUUID->"026bd251-d3e0-414d-bb41-32ba164d4e1b"],
Cell[199138, 5319, 326, 7, 2147483647, "Text",ExpressionUUID->"8a4be422-5d8a-4de8-974c-f2f19e381066"],
Cell[199467, 5328, 280, 7, 2147483647, "Input",ExpressionUUID->"d00fef60-810b-436b-a694-91e84034c2c9"],
Cell[199750, 5337, 491, 12, 2147483647, "Input",ExpressionUUID->"1ebd1ff9-6c58-4f81-a91e-4955f5eb3cba"],
Cell[200244, 5351, 237, 4, 2147483647, "Text",ExpressionUUID->"faa1da51-de61-469a-a56a-b5d457604b26"],
Cell[200484, 5357, 277, 6, 2147483647, "Input",ExpressionUUID->"96890f3a-4a65-4d59-b623-3ce7a595a5d6"],
Cell[200764, 5365, 432, 8, 2147483647, "Text",ExpressionUUID->"a313dd74-0283-4374-9522-320836c687ec"],
Cell[201199, 5375, 343, 7, 2147483647, "Input",ExpressionUUID->"d5715e87-7da5-4b05-b2ce-1514159cc13b"],
Cell[201545, 5384, 1184, 26, 2147483647, "Input",ExpressionUUID->"92169d42-0db3-4099-87da-e2b1cb0b893b"],
Cell[202732, 5412, 244, 5, 2147483647, "Input",ExpressionUUID->"88340c34-b751-4fb5-96ea-79f925fc2433"],
Cell[202979, 5419, 272, 7, 2147483647, "Text",ExpressionUUID->"ce5886ae-e334-4100-85cb-f24657b830ac"],
Cell[203254, 5428, 895, 21, 2147483647, "Input",ExpressionUUID->"3df66013-d63b-4c43-a73d-f132b7dbc934"],
Cell[204152, 5451, 245, 4, 2147483647, "Text",ExpressionUUID->"9a5bfa7b-15ae-4288-ba2d-f540e6c6ba0f"],
Cell[204400, 5457, 696, 18, 2147483647, "Input",ExpressionUUID->"f0583e86-fcf0-4e52-96b7-ccab6c9b367f"],
Cell[205099, 5477, 282, 4, 2147483647, "Text",ExpressionUUID->"71198c59-8c80-4897-bc78-85e803d56c22"],
Cell[205384, 5483, 913, 23, 2147483647, "Input",ExpressionUUID->"1355ee06-444e-4175-b2ad-a0740caa3f6d",
 Evaluatable->False],
Cell[206300, 5508, 239, 6, 2147483647, "Input",ExpressionUUID->"69e72d71-2b7b-40e9-9965-89f282d1e027"],
Cell[206542, 5516, 537, 9, 2147483647, "Text",ExpressionUUID->"ffa599c5-2b8f-4e64-879a-a6eb87c40116"],
Cell[207082, 5527, 1010, 25, 2147483647, "Input",ExpressionUUID->"115bdc46-a4d8-4b49-819e-7b296b6c0e17",
 Evaluatable->False],
Cell[208095, 5554, 187, 3, 2147483647, "Text",ExpressionUUID->"d98f51cf-76ed-42fe-aca7-21adb6f44df5"],
Cell[208285, 5559, 878, 23, 2147483647, "Input",ExpressionUUID->"6747a924-e525-4b55-b0ab-0e9b6cb53f62",
 Evaluatable->False],
Cell[209166, 5584, 328, 7, 2147483647, "Text",ExpressionUUID->"15beb553-4a39-4673-b6dc-9fedbc8467fd"],
Cell[209497, 5593, 536, 14, 2147483647, "Input",ExpressionUUID->"1d1c3f68-01aa-4af5-94a5-bef9dfcea40d"],
Cell[210036, 5609, 378, 8, 2147483647, "Input",ExpressionUUID->"491eb07d-3b71-44a9-97d9-95c43710f745"],
Cell[210417, 5619, 401, 8, 2147483647, "Text",ExpressionUUID->"d4297808-3bcd-4bd5-8013-ae4e20f9da79"],
Cell[210821, 5629, 271, 6, 2147483647, "Input",ExpressionUUID->"8d5b3e23-255c-41dd-8a56-5373d26819a2"],
Cell[211095, 5637, 693, 19, 2147483647, "Input",ExpressionUUID->"effa1211-a52f-41f0-99a7-a3605315c94e"],
Cell[211791, 5658, 240, 5, 2147483647, "Text",ExpressionUUID->"bd07abcd-feaa-4a5f-b179-98eb541d07a5"],
Cell[212034, 5665, 667, 16, 2147483647, "Input",ExpressionUUID->"25b25e56-8f4c-406a-8c63-7736a15d502e"],
Cell[212704, 5683, 743, 19, 2147483647, "Input",ExpressionUUID->"5212eee5-820b-4101-b000-fd0103d551e8"],
Cell[213450, 5704, 182, 3, 2147483647, "Text",ExpressionUUID->"749f3ca8-b93f-42bd-8d38-5bef0fb3fc4e"],
Cell[213635, 5709, 308, 5, 2147483647, "Text",ExpressionUUID->"f02dfd04-93a6-44a5-9751-121b06dc29aa"],
Cell[213946, 5716, 389, 9, 2147483647, "Input",ExpressionUUID->"028d1956-2396-420d-9258-afa2ed09e87c"],
Cell[214338, 5727, 290, 6, 2147483647, "Text",ExpressionUUID->"14e7a322-b4f0-4a2a-8932-5dc7579b7791"],
Cell[214631, 5735, 314, 8, 2147483647, "Text",ExpressionUUID->"7d170d9d-33aa-4720-8950-cce3b5582c44"],
Cell[214948, 5745, 420, 8, 2147483647, "Input",ExpressionUUID->"1c996c81-86ea-4b12-8312-56e3a8807d15"],
Cell[215371, 5755, 453, 10, 2147483647, "Text",ExpressionUUID->"ee6c47eb-e885-4a13-a72e-e14fcf1c754c"],
Cell[215827, 5767, 397, 8, 2147483647, "Input",ExpressionUUID->"8c079905-76a5-49b7-908c-39ca06f913ef"],
Cell[216227, 5777, 399, 10, 2147483647, "Text",ExpressionUUID->"f13b94ef-73ee-4981-8117-7c1c7c8ca6d5"],
Cell[216629, 5789, 345, 7, 2147483647, "Text",ExpressionUUID->"e48e70c1-2d4b-4ba1-917f-3845be6948d5"],
Cell[216977, 5798, 192, 4, 2147483647, "Input",ExpressionUUID->"cf22c63e-2cef-4b78-b8c2-c22f73c6fb6a"],
Cell[217172, 5804, 215, 5, 2147483647, "Text",ExpressionUUID->"b2230e0e-ce71-43ac-ab9b-5772b17c7dbe"],
Cell[217390, 5811, 442, 10, 2147483647, "Input",ExpressionUUID->"a5172773-c580-4264-8e6c-7b5bc7435f85",
 InitializationCell->True],
Cell[217835, 5823, 153, 3, 2147483647, "Text",ExpressionUUID->"c2100639-6953-4cb4-b323-ff3dfee04aa9"],
Cell[217991, 5828, 212, 5, 2147483647, "Input",ExpressionUUID->"e089af95-633c-4f17-a710-13addea17814"],
Cell[218206, 5835, 210, 5, 2147483647, "Input",ExpressionUUID->"f7c630c7-2c90-43a8-89dd-b5d404534260"],
Cell[218419, 5842, 329, 6, 2147483647, "Input",ExpressionUUID->"25dd8d41-1ed7-4b80-a05a-5d6ef037ec64"],
Cell[218751, 5850, 263, 6, 2147483647, "Input",ExpressionUUID->"b5993add-e009-40a5-b904-c3554248122b"],
Cell[219017, 5858, 153, 3, 2147483647, "Text",ExpressionUUID->"36d21c3c-6da2-487c-adec-a612f7fb30d4"],
Cell[219173, 5863, 506, 14, 2147483647, "Input",ExpressionUUID->"95a689ab-4042-49f6-9e19-0532a349e6c6"],
Cell[219682, 5879, 183, 4, 2147483647, "Input",ExpressionUUID->"b3bc2c07-dd29-40d2-baa1-7977b9d18d45"],
Cell[219868, 5885, 805, 21, 2147483647, "Input",ExpressionUUID->"98065998-2868-41f6-b35d-156a7900082b"],
Cell[220676, 5908, 187, 4, 2147483647, "Input",ExpressionUUID->"ee89d66b-1c63-473a-970c-d73836cc7334"],
Cell[220866, 5914, 267, 6, 2147483647, "Text",ExpressionUUID->"8d47e34b-13fa-4c28-8b59-0e9a994b46d7"],
Cell[221136, 5922, 301, 6, 2147483647, "Text",ExpressionUUID->"57aba73d-f2cc-4ee4-ac22-c9001168416d"],
Cell[221440, 5930, 441, 12, 2147483647, "Input",ExpressionUUID->"ca768d36-8581-4508-956b-e49990f12edd"],
Cell[221884, 5944, 783, 16, 2147483647, "Text",ExpressionUUID->"3630d718-c07f-467b-8265-91551360476e",
 CellTags->"duba"],
Cell[222670, 5962, 559, 13, 2147483647, "Input",ExpressionUUID->"df094126-872b-4f80-8cb8-858c501604c1",
 Evaluatable->False],
Cell[223232, 5977, 687, 12, 2147483647, "Text",ExpressionUUID->"d6a2d3e1-74f1-4e43-9aa3-9bf4ff6395d6"],
Cell[223922, 5991, 609, 17, 2147483647, "Input",ExpressionUUID->"1aec57dd-9b8e-41eb-b6f3-386f4b4c702c",
 Evaluatable->False],
Cell[224534, 6010, 720, 12, 2147483647, "Text",ExpressionUUID->"60c38283-4f0e-42e1-ab7b-8d30d4e0f5c0"],
Cell[225257, 6024, 1226, 30, 2147483647, "Text",ExpressionUUID->"79d644cd-c141-4b5b-9df4-e8eebe3793ed"],
Cell[226486, 6056, 555, 15, 2147483647, "Input",ExpressionUUID->"8ea32d8c-390a-4f5c-9530-aab41baecc7c"],
Cell[227044, 6073, 409, 7, 2147483647, "Text",ExpressionUUID->"975a8805-9792-4846-910e-abf43febcc7f"],
Cell[227456, 6082, 766, 12, 2147483647, "Text",ExpressionUUID->"12e92b9b-934b-4851-88ce-6b16bb6a56e0"],
Cell[228225, 6096, 448, 13, 2147483647, "Input",ExpressionUUID->"46a9ddca-9862-41ba-bd88-73159bf43ed8"],
Cell[228676, 6111, 513, 15, 2147483647, "Input",ExpressionUUID->"40261ff2-4d7b-48af-ba25-57eddab34ac8"],
Cell[229192, 6128, 185, 4, 2147483647, "Input",ExpressionUUID->"c581b579-71ce-4356-8b17-174ab54f809d"],
Cell[229380, 6134, 723, 15, 2147483647, "Text",ExpressionUUID->"59b812f5-9d4f-4eac-ae4d-b5fe8a6d6ea2"],
Cell[230106, 6151, 387, 11, 2147483647, "Input",ExpressionUUID->"31df21dd-c9aa-43c3-98cd-a163c8ba2fe5",
 Evaluatable->False],
Cell[230496, 6164, 692, 18, 2147483647, "Input",ExpressionUUID->"ddae4e2c-d0a7-4aa4-b2cb-d3b9edf330ca"],
Cell[231191, 6184, 1064, 17, 2147483647, "Text",ExpressionUUID->"8187822a-97bb-4ed8-be94-cdfac02fd1c0"],
Cell[232258, 6203, 692, 10, 2147483647, "Text",ExpressionUUID->"3dfb509c-b8ba-4ccc-afaf-9b702dcf7cfe",
 CellTags->"trdb"],
Cell[232953, 6215, 1051, 22, 2147483647, "Text",ExpressionUUID->"6ebc746c-2b74-449c-97e7-e93e0668554a"],
Cell[234007, 6239, 347, 8, 2147483647, "Input",ExpressionUUID->"87b08842-c036-4582-ad0a-f4963e27a4c4"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[234415, 6254, 433, 7, 101, "Section",ExpressionUUID->"2a796df6-86d4-418c-93f8-de6d96649815"],
Cell[234851, 6263, 1874, 32, 338, "Text",ExpressionUUID->"39c19b4f-de3b-40e3-ad90-ed16b31394af"],
Cell[CellGroupData[{
Cell[236750, 6299, 444, 6, 81, "Subsection",ExpressionUUID->"e818787f-f4c8-4ee1-ac9f-a635438a3fa1"],
Cell[237197, 6307, 1019, 18, 1851, "Text",ExpressionUUID->"1ba9c695-d5e2-494f-b7c7-e64e398bd5e3"],
Cell[238219, 6327, 1043, 28, 567, "Input",ExpressionUUID->"bd123ef1-e352-48da-ac4f-7aee43c4a9e4",
 Evaluatable->False],
Cell[239265, 6357, 527, 10, 621, "Text",ExpressionUUID->"bb5dd096-64cb-46f8-ac9f-ec39e6574486"],
Cell[239795, 6369, 315, 9, 73, "Input",ExpressionUUID->"1444bb6a-d700-48f1-a458-aaec08eb75c4"],
Cell[240113, 6380, 677, 19, 105, "Input",ExpressionUUID->"55709d3a-658a-4ecf-89fe-b947835b1251",
 Evaluatable->False],
Cell[240793, 6401, 216, 7, 75, "Text",ExpressionUUID->"cca1d2c2-563d-4051-8199-58d866feaa8a"],
Cell[241012, 6410, 312, 8, 73, "Input",ExpressionUUID->"d15adb02-7449-4cd3-b2f6-e2b64c211c66"],
Cell[241327, 6420, 316, 9, 73, "Input",ExpressionUUID->"5bfd5926-32cc-4a4e-99c2-6c63dd61ae7d"],
Cell[241646, 6431, 186, 4, 73, "Input",ExpressionUUID->"6f43bbf4-a2b5-47f0-bf28-e72e1c99ec5b"],
Cell[241835, 6437, 186, 4, 73, "Input",ExpressionUUID->"58b33426-963c-4f5b-a890-177c67ee5d65"],
Cell[242024, 6443, 243, 6, 75, "Text",ExpressionUUID->"ce62afbc-f6f0-406c-b623-5ffab5c0c0d6"],
Cell[242270, 6451, 277, 6, 73, "Input",ExpressionUUID->"4684e665-16b6-4d56-9739-a000f0680586"],
Cell[242550, 6459, 255, 6, 75, "Text",ExpressionUUID->"ab0adcf0-34db-44b4-b9bd-ae2e909e7f0c"],
Cell[CellGroupData[{
Cell[242830, 6469, 174, 3, 79, "Subsubsection",ExpressionUUID->"bb37aa7f-c695-451b-a9b1-bfb0304468a7"],
Cell[243007, 6474, 426, 7, 73, "Input",ExpressionUUID->"6e68165d-f709-4afd-b3ea-281fba5929c8"],
Cell[243436, 6483, 420, 8, 75, "Text",ExpressionUUID->"b55f560c-1caf-4217-a2d2-cf0f837fa06a"],
Cell[243859, 6493, 2601, 68, 619, "Input",ExpressionUUID->"ab1e1553-9224-40a2-8fe6-58ab1e679199",
 Evaluatable->False],
Cell[246463, 6563, 412, 8, 124, "Text",ExpressionUUID->"0f833d6a-f45a-4959-9203-152cb13c7214"],
Cell[246878, 6573, 2459, 72, 570, "Input",ExpressionUUID->"209d3d95-55cf-4b98-8a34-1efd1e97f3b3",
 Evaluatable->False],
Cell[249340, 6647, 1410, 37, 319, "Text",ExpressionUUID->"4bcec5fd-894b-4eb2-a76e-120c133176d9"],
Cell[250753, 6686, 173, 4, 73, "Input",ExpressionUUID->"740b7c62-bf37-4b27-8252-186fdb3b55f1"],
Cell[250929, 6692, 1669, 45, 372, "Input",ExpressionUUID->"8a74b31c-ecf7-4380-86bb-1caf9a758afd",
 Evaluatable->False],
Cell[252601, 6739, 408, 10, 75, "Text",ExpressionUUID->"c3ccbe0a-4d7c-4388-9b9a-b56755407cab"],
Cell[253012, 6751, 179, 4, 73, "Input",ExpressionUUID->"2d7b92c4-d1bc-441b-bf3d-dbb3ca7d5342"],
Cell[253194, 6757, 2101, 60, 322, "Input",ExpressionUUID->"7e55fa23-75d3-45b9-b4fc-47ea3606f2cf",
 Evaluatable->False],
Cell[255298, 6819, 190, 4, 2047, "Input",ExpressionUUID->"7324ecf3-5423-4784-943a-c08be2aadcc4"],
Cell[255491, 6825, 301, 6, 3343, "Text",ExpressionUUID->"f2cf98dd-19d0-4264-87b5-d128efebd137"],
Cell[255795, 6833, 184, 4, 2047, "Input",ExpressionUUID->"3ffbc0b2-e1eb-43a3-9684-c8d4e34cb78f"],
Cell[255982, 6839, 178, 3, 2047, "Text",ExpressionUUID->"d249e579-9cf6-427e-807e-22f2c31f4bd2"],
Cell[256163, 6844, 2618, 75, 13762, "Input",ExpressionUUID->"35ffc467-7e51-49c7-8644-826dbe29c794",
 Evaluatable->False],
Cell[258784, 6921, 276, 6, 2047, "Input",ExpressionUUID->"747bdaee-d295-4659-930c-2a20cbe7fc5c"],
Cell[259063, 6929, 317, 6, 3343, "Text",ExpressionUUID->"2d88e969-6750-44f0-8f85-edf1d8224d54"],
Cell[259383, 6937, 186, 4, 2047, "Input",ExpressionUUID->"da4af52b-1546-4fb1-927b-c00ae4d2599f"],
Cell[259572, 6943, 247, 4, 2047, "Text",ExpressionUUID->"f57661d5-69ab-422b-be9f-5205f19675d3"],
Cell[259822, 6949, 176, 4, 2047, "Input",ExpressionUUID->"77de84c3-8d59-4cc1-88c3-3c455b75cdf5"],
Cell[260001, 6955, 191, 3, 2047, "Text",ExpressionUUID->"eaf00254-7b90-42df-a3f7-8f0b3ff6776e"],
Cell[260195, 6960, 179, 4, 2047, "Input",ExpressionUUID->"f45fbd7b-a3a2-4c99-905f-d1cf8db1e884"],
Cell[260377, 6966, 227, 5, 2047, "Text",ExpressionUUID->"1b0ecb08-285e-4cf3-ad52-c9643db0b033"],
Cell[260607, 6973, 182, 4, 2047, "Input",ExpressionUUID->"d1081431-1a72-44e9-875e-632d9acf41ae"],
Cell[260792, 6979, 338, 7, 2047, "Text",ExpressionUUID->"3a7c84eb-9929-4baa-9c3e-ea74c2b8a3a4"],
Cell[261133, 6988, 227, 5, 2047, "Input",ExpressionUUID->"14765a5c-349a-42e2-b6b5-64a59966ca6b"],
Cell[261363, 6995, 226, 3, 2047, "Text",ExpressionUUID->"7ae07cb1-9949-41cc-af5e-d6d072f1d277"],
Cell[261592, 7000, 186, 4, 2047, "Input",ExpressionUUID->"e3028bae-0cd6-4903-9488-3179c73def41"],
Cell[261781, 7006, 189, 3, 2047, "Text",ExpressionUUID->"eb2496a3-ef21-4114-aa69-93f0213da33d"],
Cell[261973, 7011, 280, 6, 2047, "Input",ExpressionUUID->"a94dde0e-60d0-4eb6-80ab-893c6ebf92f2"],
Cell[262256, 7019, 293, 6, 3343, "Text",ExpressionUUID->"e2a2d2cf-c91b-4b6f-ae52-5104f00c308a"],
Cell[262552, 7027, 227, 5, 2047, "Input",ExpressionUUID->"4406fade-fc50-49ec-8742-0d9e3a72b0ec"],
Cell[262782, 7034, 270, 6, 2047, "Text",ExpressionUUID->"49831805-d143-4870-adaa-bcd0623ef371"],
Cell[263055, 7042, 177, 4, 2047, "Input",ExpressionUUID->"0514aff6-6c0b-46d8-833f-7bace47f4122"],
Cell[263235, 7048, 165, 3, 2047, "Text",ExpressionUUID->"0000e2eb-96db-491d-a1b2-93056a5efcf5"],
Cell[263403, 7053, 352, 7, 2047, "Input",ExpressionUUID->"f7cb7024-4125-4a46-ae78-2413e0b3ec6e"],
Cell[263758, 7062, 160, 3, 2047, "Text",ExpressionUUID->"5482d61b-abd9-4e26-b801-410462d3e68d"],
Cell[263921, 7067, 311, 6, 2047, "Input",ExpressionUUID->"b540eb03-0a63-4495-9c7b-ad97c903dcc0"],
Cell[264235, 7075, 149, 3, 2047, "Text",ExpressionUUID->"7acaaa96-7159-46f9-9311-3b2935cc9fc5"],
Cell[264387, 7080, 208, 4, 2047, "Input",ExpressionUUID->"4a2f35f0-0ec8-45c1-8c11-4c49a7c6a109"],
Cell[264598, 7086, 158, 3, 2047, "Text",ExpressionUUID->"782a3091-b8df-4587-9d07-843b4205f961"],
Cell[264759, 7091, 209, 4, 2047, "Input",ExpressionUUID->"f2f0c9ac-fff2-42d0-96f0-d97509e3eff2"],
Cell[264971, 7097, 224, 5, 2047, "Text",ExpressionUUID->"95271619-5203-471c-94f4-40c6d2d73fdf"],
Cell[265198, 7104, 274, 6, 2047, "Input",ExpressionUUID->"3a094e06-d2b3-4b31-9e30-42e0f955d80d"],
Cell[265475, 7112, 221, 5, 2047, "Input",ExpressionUUID->"54f31d50-02b3-40a7-a46f-2d3cb7c166c9"],
Cell[265699, 7119, 250, 6, 2047, "Input",ExpressionUUID->"9d051e8d-b01b-4ee5-9511-3a9cc791c983"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[265998, 7131, 608, 8, 55, "Subsection",ExpressionUUID->"4cfbf4b9-4082-491a-9c6b-6a604e765e5c"],
Cell[CellGroupData[{
Cell[266631, 7143, 379, 6, 68, "Subsubsection",ExpressionUUID->"6b8db047-3f81-4252-a5ff-9324f2ec5ed2"],
Cell[267013, 7151, 286, 6, 6696, "Text",ExpressionUUID->"4e02c9cc-9b59-44a0-85db-1ec7c678b969"],
Cell[267302, 7159, 197, 5, 4099, "Input",ExpressionUUID->"07b9caa6-173d-40e5-820c-cc5ff79b0a14"],
Cell[267502, 7166, 253, 6, 4099, "Input",ExpressionUUID->"0c46118e-534b-4271-ac7d-169370ebaf04"],
Cell[267758, 7174, 541, 10, 4099, "Input",ExpressionUUID->"86cffdbc-9121-40da-bba8-b6562ff4c52c"],
Cell[268302, 7186, 297, 7, 4099, "Text",ExpressionUUID->"8102740b-1b05-4960-8bc9-eb6f2d980544"],
Cell[268602, 7195, 173, 4, 4099, "Input",ExpressionUUID->"5590bb67-4e01-4c61-ba6a-0eeff9a42413"],
Cell[268778, 7201, 213, 5, 4099, "Input",ExpressionUUID->"37072676-2980-4076-8710-bf6a0b6d1554"],
Cell[268994, 7208, 653, 15, 4099, "Input",ExpressionUUID->"a6a41572-f9ba-4670-adcb-59364b80a803"],
Cell[269650, 7225, 340, 8, 4099, "Input",ExpressionUUID->"0645d36b-83b6-4500-95a5-093bcedf2e0a"],
Cell[269993, 7235, 182, 4, 4099, "Input",ExpressionUUID->"4c8c3ab0-089a-43ea-bd5b-2966215f6189"],
Cell[270178, 7241, 257, 6, 4099, "Input",ExpressionUUID->"7230622e-622c-4bcd-a9c4-3d30263f8884"],
Cell[270438, 7249, 359, 9, 4099, "Input",ExpressionUUID->"2d15ad99-f7da-419a-afe6-2c317b8945a3"],
Cell[270800, 7260, 219, 6, 4099, "Input",ExpressionUUID->"13526949-6934-44fc-a267-c28d3dcc146b"],
Cell[271022, 7268, 397, 10, 4099, "Input",ExpressionUUID->"cae5ec70-68ac-4ace-a4c0-b46d6a796bed"],
Cell[271422, 7280, 372, 10, 4099, "Input",ExpressionUUID->"9a0bdd96-5e54-48b0-a02e-eb510ca9da99"],
Cell[271797, 7292, 261, 6, 4099, "Input",ExpressionUUID->"62b37d22-15df-47fd-9ddc-c6614eb1abf3"],
Cell[272061, 7300, 395, 8, 4099, "Input",ExpressionUUID->"995e47ab-0a0e-4207-aef5-b48ea9d055c9"],
Cell[272459, 7310, 235, 6, 4099, "Input",ExpressionUUID->"90388af8-15a3-4080-92e3-47986f9244a2"],
Cell[272697, 7318, 365, 7, 9294, "Text",ExpressionUUID->"8450770d-f7a3-46f8-a51e-72cf6aaebb7f"],
Cell[273065, 7327, 210, 5, 4099, "Input",ExpressionUUID->"e3f3bf77-876e-4dfc-b877-fb077b24ee37"],
Cell[273278, 7334, 289, 7, 4099, "Text",ExpressionUUID->"a9730c89-f639-445f-9e9e-fd917ec32d55"],
Cell[273570, 7343, 338, 7, 4099, "Input",ExpressionUUID->"2b20e400-2429-416c-ad82-0706ad3eb613"],
Cell[273911, 7352, 315, 8, 4099, "Input",ExpressionUUID->"af8f99fb-f86c-4575-92ac-6092903b3983"],
Cell[274229, 7362, 357, 9, 4099, "Input",ExpressionUUID->"cc20085b-4529-4f54-aed8-9448770239cb"],
Cell[274589, 7373, 1275, 30, 17221, "Text",ExpressionUUID->"7c792f96-2125-4f3d-a2f0-a03264ddb9e4"]
}, Closed]],
Cell[CellGroupData[{
Cell[275901, 7408, 390, 6, 54, "Subsubsection",ExpressionUUID->"2186cd58-dc01-4479-af8b-17262aad5948"],
Cell[276294, 7416, 723, 12, 11889, "Text",ExpressionUUID->"5def4532-1d97-4822-af15-b4d01cae91f5"],
Cell[277020, 7430, 1009, 29, 14553, "Input",ExpressionUUID->"dbc11c4a-1b87-4e1a-8992-4204f5be79f6",
 Evaluatable->False],
Cell[278032, 7461, 277, 6, 4099, "Text",ExpressionUUID->"d2c9dad0-789f-496c-9cf9-f615f2c892c2"],
Cell[278312, 7469, 329, 8, 4099, "Input",ExpressionUUID->"750d2a2c-c861-470e-bb0f-9a53f6d06876"],
Cell[278644, 7479, 804, 16, 4099, "Input",ExpressionUUID->"8368b70f-37f7-48ec-a5c2-a9584e690590"],
Cell[279451, 7497, 240, 5, 4099, "Input",ExpressionUUID->"a5b8303f-c122-4182-aac1-c31f84eebf2b"],
Cell[279694, 7504, 370, 10, 4099, "Input",ExpressionUUID->"6c134893-a359-4f7e-824e-95e5d1fbd262"],
Cell[280067, 7516, 593, 13, 4099, "Input",ExpressionUUID->"9b706cf5-c19f-413c-bd77-0efd38560da1"],
Cell[280663, 7531, 342, 8, 4099, "Input",ExpressionUUID->"44e7033b-2458-47b7-ba46-12028835fe85"],
Cell[281008, 7541, 318, 8, 4099, "Input",ExpressionUUID->"69a6f3a1-8921-492d-a87d-7cc963eedda2"],
Cell[281329, 7551, 502, 11, 4099, "Input",ExpressionUUID->"24c6cea7-4c35-422f-b4e0-05bf84f734ff"],
Cell[281834, 7564, 387, 10, 4099, "Input",ExpressionUUID->"f2c39648-d9b2-4d11-a350-a1811ca8036a"],
Cell[282224, 7576, 911, 21, 6763, "Input",ExpressionUUID->"29b058f1-497b-4c55-bae6-7f3aad1a9fac"],
Cell[283138, 7599, 1450, 33, 25150, "Text",ExpressionUUID->"d7501b7b-b940-475e-aabd-295fde748679"],
Cell[284591, 7634, 418, 11, 4099, "Input",ExpressionUUID->"9f0a0f72-277a-4196-94e5-1e0d5f0e5afd"],
Cell[285012, 7647, 153, 4, 4099, "Input",ExpressionUUID->"4e6e6285-0fbf-4554-83ff-99edf358a478"],
Cell[285168, 7653, 162, 3, 4099, "Text",ExpressionUUID->"9188a903-8ec5-4547-8abd-55107655a9f3"]
}, Closed]],
Cell[CellGroupData[{
Cell[285367, 7661, 593, 9, 54, "Subsubsection",ExpressionUUID->"78c6c37d-864f-4ec5-91a8-cb90ac6f23d8"],
Cell[285963, 7672, 699, 13, 9294, "Text",ExpressionUUID->"37203bee-7962-4740-aef1-9f7bd2729bb3"],
Cell[286665, 7687, 224, 5, 4099, "Input",ExpressionUUID->"a8f7ee08-adda-4ded-b777-a879ae861ed2"],
Cell[286892, 7694, 639, 18, 4099, "Input",ExpressionUUID->"102d0915-d745-4700-ab13-0941dba654c9",
 Evaluatable->False],
Cell[287534, 7714, 635, 17, 4099, "Input",ExpressionUUID->"775bef45-0a0f-497b-85f9-194a6f5bf12c"],
Cell[288172, 7733, 632, 17, 4099, "Input",ExpressionUUID->"0bcaea44-7a00-48cf-bcbb-cf443318c603"],
Cell[288807, 7752, 191, 3, 4099, "Text",ExpressionUUID->"22d7a354-4f3c-4f23-be06-f8fbfd436e95"],
Cell[289001, 7757, 248, 5, 4099, "Input",ExpressionUUID->"07cab35a-5654-45c0-9b98-97ab5405c174"],
Cell[289252, 7764, 890, 19, 4099, "Input",ExpressionUUID->"9aa95b6d-5fc4-4a6e-aa0b-9a6dac970a4d",
 Evaluatable->False],
Cell[290145, 7785, 321, 6, 4099, "Text",ExpressionUUID->"528ffaa8-4719-47c6-9aea-e3cbbc8f43a9"],
Cell[290469, 7793, 209, 5, 4099, "Input",ExpressionUUID->"e800c84a-3f8f-485b-98ea-8788a0c41f09"],
Cell[290681, 7800, 394, 11, 4099, "Input",ExpressionUUID->"247dc143-2f71-441e-9727-b8d7635c8f07"],
Cell[291078, 7813, 188, 4, 4099, "Input",ExpressionUUID->"d35159d9-14db-4860-9fe9-1711cb7f15a3"],
Cell[291269, 7819, 248, 5, 4099, "Input",ExpressionUUID->"274bc9fc-ba97-44ad-8095-b33e34dccee8"],
Cell[291520, 7826, 485, 11, 4099, "Input",ExpressionUUID->"e9a8b219-6042-4cd1-9d96-c1736a9dbe06"],
Cell[292008, 7839, 537, 12, 4099, "Input",ExpressionUUID->"09d1c4cc-ea8c-43fe-b768-e9409ecbda88"],
Cell[292548, 7853, 535, 12, 4099, "Input",ExpressionUUID->"fd8d9cdc-75e1-4e34-80a4-193e41d6c9e1"],
Cell[293086, 7867, 303, 7, 4099, "Input",ExpressionUUID->"786f5a30-3865-439d-980a-8370aad7bc58"],
Cell[293392, 7876, 304, 8, 4099, "Input",ExpressionUUID->"426d9e49-71c4-405d-b8e9-1a0cbe7d1496"],
Cell[293699, 7886, 258, 6, 6696, "Text",ExpressionUUID->"3b0cc5dc-5647-4594-b3b9-87e1fc2fafd2"],
Cell[293960, 7894, 1684, 36, 11070, "Input",ExpressionUUID->"38b2354f-8f91-4f36-95fd-eafc0167c064",
 CellTags->"bpr"],
Cell[295647, 7932, 332, 5, 4099, "Input",ExpressionUUID->"64956dbe-cff8-4dce-ae74-99792ecdb3c5"],
Cell[295982, 7939, 301, 6, 4099, "Text",ExpressionUUID->"6a2abd14-1c16-42ba-8cfa-5c915741c645"],
Cell[296286, 7947, 309, 6, 4099, "Input",ExpressionUUID->"45fb3260-aea0-4bd4-b808-22794a7d187d"],
Cell[296598, 7955, 198, 3, 4099, "Text",ExpressionUUID->"9ac1134f-93f2-4067-8468-6c75e789d7a4"],
Cell[296799, 7960, 231, 5, 4099, "Input",ExpressionUUID->"f7c5a274-d2ff-4c70-9e9c-ab6deeb7651f"],
Cell[297033, 7967, 219, 5, 4099, "Text",ExpressionUUID->"dd495b39-cb6f-4aa4-ad39-97a7153374f2"],
Cell[297255, 7974, 211, 5, 4099, "Input",ExpressionUUID->"dcd2ad26-482e-4a13-9732-dde02749bc5f"],
Cell[297469, 7981, 223, 5, 4099, "Text",ExpressionUUID->"97f5c71a-b26c-4e57-b0f8-92ad88b718c3"],
Cell[297695, 7988, 211, 5, 4099, "Input",ExpressionUUID->"d9a87bb4-c633-4b76-ac88-f4e5cf119d0f"],
Cell[297909, 7995, 182, 4, 4099, "Input",ExpressionUUID->"97070e36-18bd-45d1-9efa-79467989c3a4"],
Cell[298094, 8001, 1879, 45, 9357, "Input",ExpressionUUID->"414983b6-9777-4f10-9fc5-7e1a14c12400",
 Evaluatable->False],
Cell[299976, 8048, 509, 9, 4099, "Input",ExpressionUUID->"322fc245-e1fa-455c-bb99-6d0181057488"],
Cell[300488, 8059, 402, 8, 4099, "Input",ExpressionUUID->"62f07f9f-53df-43f0-85e1-7ade907b09ea"],
Cell[300893, 8069, 186, 4, 4099, "Input",ExpressionUUID->"55e4d82d-df20-40f8-a578-b3c7de2acefe"],
Cell[301082, 8075, 328, 7, 6763, "Input",ExpressionUUID->"1be04785-7bc6-458f-a0dc-3789f0bc1f72"],
Cell[301413, 8084, 191, 4, 4099, "Input",ExpressionUUID->"518481f1-8ae7-45e1-82d1-ec9131dc7035"],
Cell[301607, 8090, 233, 4, 4099, "Text",ExpressionUUID->"b967945c-2a47-43be-81a1-be5718e35aeb"],
Cell[301843, 8096, 650, 13, 6763, "Input",ExpressionUUID->"a2f6a858-87b2-4192-926e-72e78dc8cc22"],
Cell[302496, 8111, 270, 4, 4099, "Text",ExpressionUUID->"4828280c-66b8-4b38-a281-4784d9e13a6e"],
Cell[302769, 8117, 312, 9, 4099, "Input",ExpressionUUID->"5badf96a-fb53-4609-84e2-ca069323641e"],
Cell[303084, 8128, 282, 8, 4099, "Input",ExpressionUUID->"dfaadb2d-6b3f-4026-9cde-e50b0319d583"]
}, Closed]],
Cell[CellGroupData[{
Cell[303403, 8141, 756, 11, 54, "Subsubsection",ExpressionUUID->"5f327f55-bbfa-4083-89fd-d1a7542547b1"],
Cell[304162, 8154, 730, 12, 4645, "Text",ExpressionUUID->"4001036d-109b-43dd-a716-a39225041e53"],
Cell[304895, 8168, 689, 16, 2187, "Text",ExpressionUUID->"dbff3435-225b-4658-ac32-7f5da061aa2d"],
Cell[305587, 8186, 187, 4, 2047, "Input",ExpressionUUID->"b7b0239d-86b6-4297-9ddc-5e32a70e7152"],
Cell[305777, 8192, 230, 4, 2047, "Text",ExpressionUUID->"edf6ee35-2d96-4e01-b8d4-c87f82da08aa"],
Cell[306010, 8198, 224, 4, 2047, "Text",ExpressionUUID->"d835274c-12ab-4d0b-8404-533b3a550284"],
Cell[306237, 8204, 157, 3, 2047, "Input",ExpressionUUID->"97048213-7b26-46a5-8136-8c0371fcc4bf"],
Cell[306397, 8209, 255, 6, 2047, "Input",ExpressionUUID->"3ccd3bc0-6203-44a2-81c4-f4bfcec13ebc"],
Cell[306655, 8217, 281, 8, 2047, "Input",ExpressionUUID->"2edf89b0-0b24-4b4b-a521-f94fc97b0b03"],
Cell[306939, 8227, 189, 3, 2047, "Text",ExpressionUUID->"05867481-dc13-4bb6-879c-d02921aa90c5"],
Cell[307131, 8232, 701, 20, 2047, "Input",ExpressionUUID->"6768af3e-d319-4f69-841e-4af98168d522"],
Cell[307835, 8254, 353, 8, 2047, "Input",ExpressionUUID->"9e424965-a33f-4c18-8605-3dad01936037"],
Cell[308191, 8264, 188, 3, 2047, "Text",ExpressionUUID->"9baaea62-5bbe-4d81-9d34-7575bd60e576"],
Cell[308382, 8269, 635, 16, 2047, "Input",ExpressionUUID->"ecb7391a-81f0-44ea-81f2-d5d9ae964137"],
Cell[309020, 8287, 355, 5, 2047, "Text",ExpressionUUID->"f37fc9f9-2f80-429b-8fb8-9744841f2018"],
Cell[309378, 8294, 1551, 30, 9801, "Text",ExpressionUUID->"706ed78d-93a0-4a23-a689-99dc4ab6612c"],
Cell[310932, 8326, 377, 9, 3309, "Text",ExpressionUUID->"40da75cc-2717-4f01-a4c8-4d86fac6df36"],
Cell[CellGroupData[{
Cell[311334, 8339, 191, 4, 2047, "Input",ExpressionUUID->"9603f165-bc15-41e2-8990-310b7b0e500c",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[311550, 8347, 138, 3, 770383872, "Print",ExpressionUUID->"3d956798-99f4-4501-94e0-937c4555f845"],
Cell[311691, 8352, 492, 13, 824131584, "Print",ExpressionUUID->"8958507c-c5ad-4d72-94d2-434f39feff58"]
}, Closed]]
}, Closed]],
Cell[312210, 8369, 517, 14, 1702, "Input",ExpressionUUID->"4186bd63-136a-4754-95ec-3cdc3cd2158e"],
Cell[312730, 8385, 564, 9, 2007, "Text",ExpressionUUID->"6c8653be-ac37-441d-9dea-d830b60790c1"],
Cell[313297, 8396, 1663, 29, 9841, "Text",ExpressionUUID->"e352d629-f1d2-456c-ab92-6e2c60dd2a77"],
Cell[314963, 8427, 229, 5, 2047, "Input",ExpressionUUID->"40bca598-f9db-4506-bcc3-d8b1f2a40f45"],
Cell[315195, 8434, 335, 9, 2047, "Input",ExpressionUUID->"4aa35f3e-fabc-4c94-b770-2ba57940e9c1"],
Cell[315533, 8445, 3103, 69, 11166, "Input",ExpressionUUID->"f0d79da7-b871-4686-90c8-f32fe5ec1c6e",
 Evaluatable->False],
Cell[318639, 8516, 1072, 31, 7272, "Input",ExpressionUUID->"82b809fb-eca0-4a44-9e7c-e5b929436711",
 Evaluatable->False],
Cell[319714, 8549, 240, 5, 2047, "Text",ExpressionUUID->"e3d7dc83-1df3-4056-8336-35b274ddbd77"],
Cell[319957, 8556, 151, 4, 2047, "Input",ExpressionUUID->"c47fd1a0-7435-4ea1-9f86-e74901d552ad"],
Cell[320111, 8562, 1038, 28, 4677, "Input",ExpressionUUID->"a7866021-42f7-4db5-8569-08264d91c4a7",
 Evaluatable->False],
Cell[321152, 8592, 200, 4, 2047, "Input",ExpressionUUID->"0d3d2cf6-2b6b-4251-9968-dbdc02c49152"],
Cell[321355, 8598, 1604, 46, 7272, "Input",ExpressionUUID->"5aae0e28-c078-4698-ae9a-6355767f2b10",
 Evaluatable->False],
Cell[322962, 8646, 1150, 34, 5973, "Input",ExpressionUUID->"dfcfee08-6ad4-4b24-b164-96a754f0b510",
 Evaluatable->False],
Cell[324115, 8682, 319, 6, 2047, "Text",ExpressionUUID->"8da3e3cf-1374-4649-a585-06db3cfa2da0"],
Cell[324437, 8690, 178, 4, 2047, "Input",ExpressionUUID->"14c9cac8-d74f-49dd-88d9-f04d755491c7"],
Cell[324618, 8696, 715, 22, 5973, "Input",ExpressionUUID->"4ea478bd-5b49-4704-bd3b-b0e1c5e0271d",
 Evaluatable->False],
Cell[325336, 8720, 201, 4, 2047, "Text",ExpressionUUID->"94008738-4697-4f1a-af57-0ff60bdde9a0"],
Cell[325540, 8726, 555, 13, 2047, "Input",ExpressionUUID->"03625da7-dacf-4ede-9b5e-2de506e8fc79"],
Cell[326098, 8741, 189, 4, 2047, "Input",ExpressionUUID->"096a9a87-75e3-456e-96e0-076e465161c6"],
Cell[326290, 8747, 159, 3, 2047, "Input",ExpressionUUID->"4a57d73d-34d5-4fba-9832-0e8f55b5994e"],
Cell[326452, 8752, 289, 5, 2047, "Input",ExpressionUUID->"4f3102ac-d751-4b88-9273-3a4ebba8ff08"],
Cell[326744, 8759, 339, 6, 2047, "Input",ExpressionUUID->"c0163b29-464f-47c8-8ab2-2a9aaca86fb6"],
Cell[327086, 8767, 179, 4, 2047, "Input",ExpressionUUID->"333f6831-8893-47d1-8d52-3b2f42483d96"],
Cell[327268, 8773, 209, 4, 2047, "Input",ExpressionUUID->"f62f619a-bb8f-4f75-8690-de4c199af498"],
Cell[327480, 8779, 235, 5, 2047, "Input",ExpressionUUID->"8cebbb2b-2c2a-4bcc-9956-e7b085cb15b2"],
Cell[327718, 8786, 572, 10, 2047, "Input",ExpressionUUID->"049a8d4f-3921-458b-a5c4-076b1178f349"],
Cell[328293, 8798, 624, 12, 2047, "Input",ExpressionUUID->"1b61e484-221c-4a4c-99c1-074841ef063f"],
Cell[328920, 8812, 318, 7, 2047, "Input",ExpressionUUID->"47e2dfe0-e01b-441f-a724-06de61dd2539"],
Cell[329241, 8821, 653, 11, 2047, "Input",ExpressionUUID->"7d42ae44-40bd-4336-939f-741c253524fb"],
Cell[329897, 8834, 187, 4, 2047, "Input",ExpressionUUID->"1056d195-1b86-4dd8-bc59-c0efc62c3162"],
Cell[330087, 8840, 336, 7, 2047, "Input",ExpressionUUID->"8235d115-f1e4-4ee8-bbef-90b067f97ece"],
Cell[330426, 8849, 413, 8, 2047, "Input",ExpressionUUID->"db569258-3f63-4cbd-8ae7-5ec036e30912"],
Cell[330842, 8859, 182, 4, 2047, "Input",ExpressionUUID->"1009a5e8-9267-43e8-aa50-8e0a83a83a6a"],
Cell[331027, 8865, 188, 4, 2047, "Input",ExpressionUUID->"4876def7-010e-4e63-9eac-df1886be0ef4"],
Cell[331218, 8871, 738, 22, 2047, "Input",ExpressionUUID->"5f120a83-99b5-44c2-a5fe-f0812a11fff7"],
Cell[331959, 8895, 209, 4, 2047, "Input",ExpressionUUID->"b3116ae9-4d96-43e3-8264-d13be7d6daca"],
Cell[332171, 8901, 669, 18, 2047, "Input",ExpressionUUID->"66b57169-4c8d-4041-b361-61e8921b5c06"],
Cell[332843, 8921, 212, 4, 2047, "Input",ExpressionUUID->"9f5febed-7356-453a-afa5-f351879cda25"],
Cell[333058, 8927, 387, 8, 2047, "Text",ExpressionUUID->"bf0beb1f-8078-4151-bea5-c0c7b30a2f23"],
Cell[333448, 8937, 1140, 26, 2047, "Input",ExpressionUUID->"4e6af67a-88f4-477d-bf2d-4fa92642a562"],
Cell[334591, 8965, 156, 3, 2047, "Text",ExpressionUUID->"3d74f8c9-b5a9-44c4-9df0-8bd09661908c"],
Cell[334750, 8970, 773, 15, 2047, "Input",ExpressionUUID->"48b2579d-4ecb-4509-b497-be7c86da0169"],
Cell[335526, 8987, 287, 7, 2047, "Input",ExpressionUUID->"cc09c549-7902-4e0a-b64d-bc771e5e4a6f"],
Cell[335816, 8996, 173, 4, 2047, "Input",ExpressionUUID->"315b51bf-cc26-4a32-b9a7-1b50f98c87e2"],
Cell[335992, 9002, 191, 3, 2047, "Text",ExpressionUUID->"a21f09c5-be2e-4a72-83ed-cb77755f820d"],
Cell[336186, 9007, 354, 7, 2047, "Input",ExpressionUUID->"7cd802c9-7a5d-4c4c-ab9c-62002d90581a"],
Cell[336543, 9016, 212, 4, 2047, "Input",ExpressionUUID->"f0d20cf0-de18-48f7-ae39-358ec69ac771"],
Cell[336758, 9022, 174, 3, 2047, "Text",ExpressionUUID->"a8fa50d7-538a-40de-b26c-90ec6ffe26b8"],
Cell[336935, 9027, 781, 13, 2047, "Input",ExpressionUUID->"fee19c06-d4b7-4800-b52c-bdbe8b7cbe3b"],
Cell[337719, 9042, 402, 7, 3343, "Text",ExpressionUUID->"980fc010-5ae6-445e-887b-f9788da438bc"],
Cell[338124, 9051, 273, 5, 2047, "Input",ExpressionUUID->"6a615397-b267-4c66-b214-1d27cf477dd5"],
Cell[338400, 9058, 509, 12, 2250, "Input",ExpressionUUID->"10d07c15-0f73-4c3f-9a36-c75413756a80",
 Evaluatable->False],
Cell[338912, 9072, 329, 8, 2250, "Input",ExpressionUUID->"93d5bb4b-52dc-4fad-956e-803d1e107d3a"],
Cell[339244, 9082, 268, 4, 2047, "Text",ExpressionUUID->"d8f7d26b-22ab-458d-a253-ceb644f8f254"],
Cell[339515, 9088, 190, 4, 2047, "Input",ExpressionUUID->"c37863b8-9c59-4380-a226-a58542949959"],
Cell[339708, 9094, 200, 3, 2047, "Text",ExpressionUUID->"cd7b277e-d873-4358-a153-521904adbe78"],
Cell[339911, 9099, 209, 5, 2047, "Input",ExpressionUUID->"251cb98d-16d6-499c-bd8b-112202252f26"],
Cell[340123, 9106, 288, 4, 2047, "Text",ExpressionUUID->"42837a59-3c01-4b0e-b434-2069f100b5a8"],
Cell[340414, 9112, 267, 5, 2047, "Input",ExpressionUUID->"91ce4238-290d-4174-aac2-89fe212e7cf3"],
Cell[340684, 9119, 832, 15, 6792, "Text",ExpressionUUID->"0a01cff6-900a-44a9-b35b-1ca4f024d8dd",
 CellTags->"1stein"],
Cell[341519, 9136, 1275, 34, 3343, "Input",ExpressionUUID->"cb3d21d7-666a-4337-92c5-a346654d9567",
 Evaluatable->False],
Cell[342797, 9172, 1337, 31, 2047, "Input",ExpressionUUID->"0a69e32b-f6cc-474d-9b56-285767f85c60",
 Evaluatable->False],
Cell[344137, 9205, 735, 23, 2047, "Input",ExpressionUUID->"91e45af4-6791-4d07-8d13-d40d6fcf40df"],
Cell[344875, 9230, 186, 4, 2047, "Input",ExpressionUUID->"6bc94a41-2719-4fcc-85ba-fd7106b1f130"],
Cell[345064, 9236, 320, 5, 2047, "Text",ExpressionUUID->"2f456c67-1904-4508-92a8-196703574c31"],
Cell[345387, 9243, 1476, 33, 2047, "Input",ExpressionUUID->"f5ed4388-1049-4c9f-87a8-db854bffb170"],
Cell[346866, 9278, 186, 3, 2047, "Text",ExpressionUUID->"67586c51-c2bf-41d5-b0d4-b7b51999ea47"],
Cell[347055, 9283, 765, 23, 2047, "Input",ExpressionUUID->"68b21c80-0c22-47e5-bda4-e63551f9b0f0"],
Cell[347823, 9308, 226, 3, 2047, "Text",ExpressionUUID->"794c4887-1597-42d9-9cb7-e9b0afc52051"],
Cell[348052, 9313, 209, 5, 2047, "Input",ExpressionUUID->"dc7b0841-6754-4c2a-b9a7-99a66ebea0b6"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[348310, 9324, 769, 11, 81, "Subsection",ExpressionUUID->"caa5dade-ccd5-47af-86d0-36da1db0d524"],
Cell[349082, 9337, 387, 9, 54, "Text",ExpressionUUID->"5838cc8f-fc3b-4388-a5f7-562a41e4f9b7"],
Cell[349472, 9348, 1241, 40, 49, "Input",ExpressionUUID->"bb4b1fc0-ade3-4459-a860-9d6bf167fb8e"],
Cell[350716, 9390, 279, 6, 90, "Text",ExpressionUUID->"7bc37e51-fb9d-4afa-826e-d2552e4aede9"],
Cell[CellGroupData[{
Cell[351020, 9400, 225, 4, 68, "Subsubsection",ExpressionUUID->"73126ec9-0c95-4da6-8ab1-209268ce1d5a"],
Cell[351248, 9406, 240, 5, 1074954240, "Text",ExpressionUUID->"b4dbd21c-4915-4b47-8352-644cd3f4c09f"],
Cell[351491, 9413, 428, 7, 1074954240, "Input",ExpressionUUID->"8ef01913-44ad-49f3-9b64-5f2731732464"],
Cell[351922, 9422, 735, 18, 1755758592, "Text",ExpressionUUID->"66179016-8f26-47f5-b1c0-ec2dd0735810"],
Cell[352660, 9442, 184, 4, 1074954240, "Input",ExpressionUUID->"4f8f0101-9d8f-4c84-a9ba-4b9bad8fba54"],
Cell[352847, 9448, 318, 6, 1074954240, "Text",ExpressionUUID->"90f0f9a0-583b-410c-b52c-40e5082a1913"],
Cell[353168, 9456, 425, 8, 1755758592, "Text",ExpressionUUID->"63b6653d-46e8-47fc-9a9c-4abfedb613cf"],
Cell[353596, 9466, 297, 6, 1074954240, "Input",ExpressionUUID->"a5a1853b-1e2d-453e-b219-ab9114e9a583"],
Cell[353896, 9474, 1852, 54, 2147483647, "Input",ExpressionUUID->"597b2aef-925b-4e05-8e8b-cffe5d744705",
 Evaluatable->False],
Cell[355751, 9530, 310, 6, 1755758592, "Text",ExpressionUUID->"d5d84459-d5b5-47fd-81eb-ab835b1bafe3"],
Cell[356064, 9538, 4078, 110, 2147483647, "Input",ExpressionUUID->"70ab4757-f18b-41fa-a522-72ed0cb820c6",
 Evaluatable->False],
Cell[360145, 9650, 480, 8, 2147483647, "Text",ExpressionUUID->"c6d44d6c-9b50-4fba-b9c3-005f7d15b51b"],
Cell[360628, 9660, 2136, 57, 2147483647, "Input",ExpressionUUID->"b9ed731f-dab7-4f9a-8370-8dbaac63108a",
 Evaluatable->False],
Cell[362767, 9719, 203, 4, 1074954240, "Input",ExpressionUUID->"97c2742f-af1c-4c5e-b059-325a1b1f58a5"]
}, Closed]],
Cell[CellGroupData[{
Cell[363007, 9728, 332, 5, 54, "Subsubsection",ExpressionUUID->"1b24c48d-5ae7-4bfe-a650-07d5ece1659a"],
Cell[363342, 9735, 351, 7, 2047, "Input",ExpressionUUID->"b2b0e240-4d10-400a-9f29-9b94414c6926"],
Cell[363696, 9744, 520, 14, 2047, "Input",ExpressionUUID->"8aeedd3f-3499-43a7-b9e6-ea3e93567d1a"],
Cell[364219, 9760, 327, 7, 2047, "Input",ExpressionUUID->"c60fd4c3-01cb-41df-bf55-7335166e5567"],
Cell[364549, 9769, 363, 10, 2047, "Input",ExpressionUUID->"ecfb3b3f-87fd-4a3c-b1c4-9c7d85ca1b8e"],
Cell[364915, 9781, 186, 4, 2047, "Input",ExpressionUUID->"8e01e644-6042-43e4-a778-7e779141bdaf"],
Cell[365104, 9787, 231, 6, 2047, "Text",ExpressionUUID->"f84cbd4c-1305-4f37-869a-a1f37188ae18"],
Cell[365338, 9795, 227, 5, 2047, "Input",ExpressionUUID->"d9668817-c34f-4ece-a2fc-08c34c014b7d"],
Cell[365568, 9802, 190, 3, 2047, "Text",ExpressionUUID->"0d9e6b98-8493-4a72-a9b3-2e09fe9c31e8"],
Cell[365761, 9807, 193, 4, 2047, "Input",ExpressionUUID->"840847cc-bafa-488b-b86d-99882ff8445d"],
Cell[365957, 9813, 185, 4, 2047, "Input",ExpressionUUID->"79a2436f-478e-4ed1-a33d-d4d4f1446627"],
Cell[366145, 9819, 173, 3, 2047, "Text",ExpressionUUID->"1e33ad14-b9fb-4052-8abb-dd13755ff947"],
Cell[366321, 9824, 285, 8, 2047, "Input",ExpressionUUID->"b7867aa3-bfcd-4218-8ed2-3cbece151b7f"],
Cell[366609, 9834, 269, 6, 2047, "Input",ExpressionUUID->"6651e445-0cf1-48c1-ab92-7e4fdb3d2aa0"],
Cell[366881, 9842, 470, 8, 2047, "Text",ExpressionUUID->"7a50efa4-a8ae-490c-921f-77c460d20e88"],
Cell[367354, 9852, 358, 9, 2047, "Input",ExpressionUUID->"e89f1c18-fa83-49ed-a77f-62c2c6825c2c"],
Cell[367715, 9863, 187, 4, 2047, "Input",ExpressionUUID->"04c8273e-237b-41fd-9dcd-da2082095641"],
Cell[367905, 9869, 366, 7, 2047, "Text",ExpressionUUID->"d61c301f-ce1e-439f-836e-30a5bceb2e02"],
Cell[368274, 9878, 263, 6, 2047, "Input",ExpressionUUID->"0592e206-6a93-448c-aad2-47975a09b41a"],
Cell[368540, 9886, 314, 7, 3343, "Text",ExpressionUUID->"eead7c71-360a-47d8-84d9-109e8cca1402"],
Cell[368857, 9895, 193, 5, 2047, "Input",ExpressionUUID->"6f280478-4785-47e0-91b4-3e2408e29ffb"],
Cell[369053, 9902, 178, 3, 2047, "Input",ExpressionUUID->"3ab848b0-33ac-4721-b4b3-6a15da096565"],
Cell[369234, 9907, 447, 9, 2047, "Text",ExpressionUUID->"9f49c5bd-f25f-442d-bf5b-df29f4293bcb"],
Cell[369684, 9918, 415, 8, 2047, "Input",ExpressionUUID->"afc88e36-fc46-4e94-b4cf-6f83e1082ac3"],
Cell[370102, 9928, 881, 15, 2047, "Input",ExpressionUUID->"2d530b64-0f90-4b0b-9077-a6bc244c36aa"],
Cell[370986, 9945, 242, 5, 2047, "Input",ExpressionUUID->"5ff1cadc-fd6e-4eea-85f2-b3f2e261a57c"],
Cell[371231, 9952, 448, 10, 2047, "Input",ExpressionUUID->"765504d7-5fdb-4d21-8b13-cab55d97d0de"],
Cell[371682, 9964, 188, 4, 2047, "Input",ExpressionUUID->"d592f54e-2f51-4bed-9393-b7f63aabf776"],
Cell[371873, 9970, 214, 4, 2047, "Input",ExpressionUUID->"97e7a8df-d9dd-4f1e-a4a7-1bf84a524b3b"],
Cell[372090, 9976, 474, 11, 2047, "Input",ExpressionUUID->"3fdfec0a-c25a-4f8a-bde0-ec262cc3026d"],
Cell[372567, 9989, 533, 14, 2047, "Input",ExpressionUUID->"48ae67f3-d511-408c-a957-cbacd2f92f42"],
Cell[373103, 10005, 188, 4, 2047, "Input",ExpressionUUID->"33a4314f-af88-4bc8-a67d-800fc104312d"],
Cell[373294, 10011, 214, 4, 2047, "Input",ExpressionUUID->"ba0f1bb8-3ddb-4f60-88ad-01fc21516116"],
Cell[373511, 10017, 294, 6, 2047, "Input",ExpressionUUID->"8986f79f-0d12-4068-a0ff-bcf1c5fea902"],
Cell[373808, 10025, 188, 4, 2047, "Input",ExpressionUUID->"c51301f8-6a87-4e35-962d-a1d23fc376bb"],
Cell[373999, 10031, 244, 5, 2047, "Input",ExpressionUUID->"3c27c397-e456-47d7-a0d0-13fb99730a43"],
Cell[374246, 10038, 298, 6, 2047, "Text",ExpressionUUID->"43943f70-5ca2-4b06-9c36-4db696991643"],
Cell[374547, 10046, 379, 9, 2047, "Input",ExpressionUUID->"9e77c030-4c45-454e-bde6-d697c589684d"],
Cell[374929, 10057, 384, 9, 2047, "Input",ExpressionUUID->"e40c2099-1e36-4ad7-852b-956252c35ddb"],
Cell[375316, 10068, 423, 9, 3343, "Text",ExpressionUUID->"df3bd242-bcf2-4be4-b136-64287cbffad1"],
Cell[375742, 10079, 250, 5, 2047, "Input",ExpressionUUID->"571e1547-187a-4ab6-9dda-c1f803bc4230"],
Cell[375995, 10086, 183, 3, 2047, "Text",ExpressionUUID->"20342846-e022-462c-9991-03d6861e71d2"],
Cell[376181, 10091, 417, 9, 2047, "Input",ExpressionUUID->"1625fa87-07fd-446f-8d2e-94f96095be01"],
Cell[376601, 10102, 208, 3, 2047, "Text",ExpressionUUID->"3b2edc80-5d6f-48f5-9e39-d2ffb2b0fc87"],
Cell[376812, 10107, 371, 9, 2047, "Input",ExpressionUUID->"ea9b274a-d1e2-46e3-bb25-10cc45d7d5e4"],
Cell[377186, 10118, 594, 12, 4645, "Text",ExpressionUUID->"2411fe9d-9f38-44b4-b8a1-c681a13f23f2"]
}, Closed]],
Cell[CellGroupData[{
Cell[377817, 10135, 444, 6, 54, "Subsubsection",ExpressionUUID->"055c35ee-0fd8-4515-a514-738eda30a706"],
Cell[378264, 10143, 189, 3, 4099, "Text",ExpressionUUID->"43232dc7-6f60-4277-bc9e-f25c1ecfb33f"],
Cell[378456, 10148, 772, 15, 4099, "Input",ExpressionUUID->"ef39e72d-be88-4639-953c-1f85e1fc18f3"],
Cell[379231, 10165, 373, 9, 4099, "Input",ExpressionUUID->"27ca07d7-8c80-4761-88b7-c5d14cbb8f63"],
Cell[379607, 10176, 245, 6, 4099, "Input",ExpressionUUID->"8db4df41-dc7f-4bb1-b4a1-e8025521104b"],
Cell[379855, 10184, 652, 11, 4099, "Input",ExpressionUUID->"ba238018-79f3-477c-b209-65df2cb6eb80"],
Cell[380510, 10197, 586, 12, 4099, "Input",ExpressionUUID->"4620f933-a90a-4469-9ce7-a5dc70c69ec2"],
Cell[381099, 10211, 491, 12, 4099, "Input",ExpressionUUID->"0700052a-bb59-4fdb-b474-b933cb4107f5"],
Cell[381593, 10225, 187, 4, 4099, "Input",ExpressionUUID->"87357814-7375-4f58-9574-757df50f1d95"],
Cell[381783, 10231, 388, 9, 4099, "Input",ExpressionUUID->"82569444-348b-40ff-9d9a-d6ce5b86ab07"],
Cell[382174, 10242, 346, 7, 4099, "Input",ExpressionUUID->"1df7b29e-faca-4bf2-9e78-3ab519d6c104"],
Cell[382523, 10251, 297, 8, 4099, "Input",ExpressionUUID->"591b2efa-f178-4cc8-a1f6-fb4da91060c7"],
Cell[382823, 10261, 188, 4, 4099, "Input",ExpressionUUID->"22c01619-2fda-4488-8f5d-4f32904bfddf"],
Cell[383014, 10267, 184, 4, 4099, "Input",ExpressionUUID->"65a8da64-d83d-4b44-9e9f-aa7c7097f92f"],
Cell[383201, 10273, 257, 6, 4099, "Text",ExpressionUUID->"560fca78-a25b-4f4a-aef8-9b93835d91ea"],
Cell[383461, 10281, 181, 4, 4099, "Input",ExpressionUUID->"aaeda8d4-ce15-41c2-b08a-8be327d7795b"],
Cell[383645, 10287, 216, 5, 4099, "Input",ExpressionUUID->"0eb4e90a-630d-4ec6-9e1c-40d8e76c2066"],
Cell[383864, 10294, 241, 7, 4099, "Input",ExpressionUUID->"f6e07b3c-969e-4b53-ad1c-8d4fe7eeebed"],
Cell[384108, 10303, 252, 6, 4099, "Input",ExpressionUUID->"9daf0e23-8910-405d-9586-0e244195d58f"],
Cell[384363, 10311, 319, 8, 4099, "Input",ExpressionUUID->"8d6253c9-f3f1-471b-97a7-1bccb83575a2"],
Cell[384685, 10321, 354, 10, 4099, "Input",ExpressionUUID->"f3cfbc5f-4a94-469b-9b8c-ccde938c43ef"],
Cell[385042, 10333, 297, 7, 5805, "Input",ExpressionUUID->"a58493c4-de83-4d1d-a1b2-9c1557cab851"],
Cell[385342, 10342, 189, 4, 5805, "Input",ExpressionUUID->"20985f82-3e86-4c0d-bca5-95e844a8194c"],
Cell[385534, 10348, 280, 6, 5805, "Input",ExpressionUUID->"42643a54-19ab-41c4-ab18-6b38d8da77b7"],
Cell[385817, 10356, 399, 9, 5805, "Input",ExpressionUUID->"8efeb5db-bf83-4e19-8c7b-2fc5e96d45b9"],
Cell[386219, 10367, 247, 6, 5805, "Input",ExpressionUUID->"490b3080-551f-4fd0-b77e-5ee8398c56a7"],
Cell[386469, 10375, 446, 10, 5805, "Input",ExpressionUUID->"804871bf-0406-459a-8fd3-232b87e322e7"],
Cell[386918, 10387, 189, 4, 5805, "Input",ExpressionUUID->"b6b86058-fd06-4dd3-af82-ca46cfc1297a"],
Cell[387110, 10393, 244, 6, 5805, "Input",ExpressionUUID->"e55a8252-94f4-4beb-b78e-c89819156ec7"],
Cell[387357, 10401, 288, 8, 5805, "Input",ExpressionUUID->"3e8a44d1-8732-4761-bae4-6b65c16a2a2b"],
Cell[387648, 10411, 285, 7, 5805, "Input",ExpressionUUID->"dc65a4a4-0702-4dd6-9118-23e0bd0dd7e5"],
Cell[387936, 10420, 269, 4, 4099, "Text",ExpressionUUID->"a57baa05-6904-4fd7-9d9a-58502618b1fa"],
Cell[388208, 10426, 834, 19, 8473, "Input",ExpressionUUID->"ae0686a3-b1bd-4ca4-8e3c-d67dcb798ef8"],
Cell[389045, 10447, 268, 6, 5805, "Input",ExpressionUUID->"a7604056-98be-4d1e-ac7e-c03cd7029f26"],
Cell[389316, 10455, 603, 11, 5805, "Input",ExpressionUUID->"9565f7b8-a0f5-4536-b310-d3172ab1c8e7"],
Cell[389922, 10468, 621, 12, 8473, "Input",ExpressionUUID->"8def0e61-1a29-4c2f-a3a6-05c0538827da"],
Cell[390546, 10482, 186, 4, 5805, "Input",ExpressionUUID->"6e4487be-fe65-46e3-8a74-4a1463dab667"],
Cell[390735, 10488, 385, 10, 5805, "Input",ExpressionUUID->"0f7707f1-34c3-4726-93dc-d0d22f7bced2"],
Cell[391123, 10500, 253, 6, 5805, "Input",ExpressionUUID->"5fb9456d-a888-4e89-bb14-223dd09dd259"],
Cell[391379, 10508, 302, 7, 5805, "Input",ExpressionUUID->"3d046aa4-1c9a-49a3-aa04-9341c91bc2ea"],
Cell[391684, 10517, 364, 7, 4099, "Text",ExpressionUUID->"8ddc1bfd-b4d2-44b8-86b5-19e966812800"],
Cell[392051, 10526, 241, 5, 5805, "Input",ExpressionUUID->"75004cb1-0895-4591-80da-c2efc1517a61"],
Cell[392295, 10533, 268, 5, 5805, "Input",ExpressionUUID->"d33d832a-d827-42e4-a1e0-18b7cf0756d7"],
Cell[392566, 10540, 217, 5, 5805, "Input",ExpressionUUID->"1b1fc843-d7a9-4fc9-a699-93b8f88e1e96"],
Cell[392786, 10547, 244, 5, 4099, "Text",ExpressionUUID->"db01e468-6223-449b-911e-e60d79b77c0f"],
Cell[393033, 10554, 210, 5, 5805, "Input",ExpressionUUID->"14f039b4-2f5a-4a42-b2fa-b967d64567a5"],
Cell[393246, 10561, 200, 3, 4099, "Text",ExpressionUUID->"f873fb00-c885-45d3-8691-78b7d52413de"],
Cell[393449, 10566, 268, 6, 4099, "Input",ExpressionUUID->"45a3a9e4-d37d-4643-b81b-90a9107615ce"],
Cell[393720, 10574, 373, 8, 5805, "Input",ExpressionUUID->"1a3f9c9d-91ce-4746-a980-eaa251421769"],
Cell[394096, 10584, 353, 7, 6696, "Text",ExpressionUUID->"c6c22675-335e-4678-8215-b519b018548b"],
Cell[394452, 10593, 181, 4, 4099, "Input",ExpressionUUID->"8650ef27-41d0-4bbc-b07f-882490c09a9e"],
Cell[394636, 10599, 348, 7, 5805, "Input",ExpressionUUID->"4eac88b5-ff81-465d-a653-b603ddd88c78"],
Cell[394987, 10608, 577, 14, 6763, "Input",ExpressionUUID->"70b5293b-dbd3-4b52-9c18-8b80c1dc3b9a"],
Cell[395567, 10624, 583, 13, 6763, "Input",ExpressionUUID->"2058575c-7656-465f-a393-62f54c4bc1b3"],
Cell[396153, 10639, 240, 4, 4099, "Text",ExpressionUUID->"4e9b1395-d200-4565-bf90-385173c0f83f"],
Cell[396396, 10645, 247, 6, 5805, "Input",ExpressionUUID->"aaa3a16c-ea1c-4fdc-8a9a-a1f955012e8b"],
Cell[396646, 10653, 213, 5, 5805, "Input",ExpressionUUID->"5719e275-f46f-4ac1-a197-0eb57546e7b6"],
Cell[396862, 10660, 388, 10, 5805, "Input",ExpressionUUID->"28cb56b5-ae1a-4fbd-a45a-1c6df218412b"],
Cell[397253, 10672, 184, 4, 5805, "Input",ExpressionUUID->"ead8512e-c06d-4586-9f02-1fab34201ed3"],
Cell[397440, 10678, 1050, 23, 8473, "Input",ExpressionUUID->"4ca7da3d-593d-4ae9-a4a6-a8d4e8fb9c29"],
Cell[398493, 10703, 323, 9, 5805, "Input",ExpressionUUID->"c28878c5-31a2-41b7-9f16-e64b0da1237d"],
Cell[398819, 10714, 188, 4, 5805, "Input",ExpressionUUID->"35b2619b-8b4a-423d-a217-c568b0c330e8"],
Cell[399010, 10720, 745, 20, 5805, "Input",ExpressionUUID->"7d5dcb23-9990-4936-86c3-258256d4ad53"],
Cell[399758, 10742, 472, 9, 6696, "Text",ExpressionUUID->"00a10406-9a69-4837-930a-959d3c4ce1eb"],
Cell[400233, 10753, 934, 23, 5805, "Input",ExpressionUUID->"5e912347-5c68-439d-bfea-7d59f098f8a8"],
Cell[401170, 10778, 185, 4, 5805, "Input",ExpressionUUID->"4f0d2ff8-f8a7-436a-a4d5-13f51ad1c8b2"],
Cell[401358, 10784, 564, 13, 10998, "Text",ExpressionUUID->"a30aaf79-656c-460e-952b-f179c07be5d2",
 CellTags->"tensbas"],
Cell[401925, 10799, 175, 4, 4099, "Input",ExpressionUUID->"4db1803f-94c3-4772-9d63-cfa01a67e892"],
Cell[402103, 10805, 922, 28, 6898, "Input",ExpressionUUID->"df249cb7-f49d-4185-8ae6-8f0a91f06db8",
 Evaluatable->False],
Cell[403028, 10835, 998, 23, 4234, "Text",ExpressionUUID->"19763435-184f-4366-8998-df41637668d1"],
Cell[404029, 10860, 182, 4, 4099, "Input",ExpressionUUID->"e2a33a7d-c83c-4a11-80dc-882918899f91"],
Cell[404214, 10866, 207, 5, 5805, "Input",ExpressionUUID->"08845bf8-5b7d-4027-9b41-19a5e17a5a6f"],
Cell[404424, 10873, 574, 17, 5805, "Input",ExpressionUUID->"17020d7a-f6ad-4640-8068-2031f15baa5d"],
Cell[405001, 10892, 585, 18, 5805, "Input",ExpressionUUID->"8fd81dc4-410a-418f-af9d-b21374799410"],
Cell[405589, 10912, 246, 4, 4099, "Text",ExpressionUUID->"3d94678d-732b-4662-a884-77bc4e6445af"]
}, Closed]],
Cell[CellGroupData[{
Cell[405872, 10921, 305, 5, 54, "Subsubsection",ExpressionUUID->"7fa06f8f-a0a5-42c4-93ab-3359b73e274e"],
Cell[406180, 10928, 543, 10, 3343, "Text",ExpressionUUID->"6d853fcb-e2cb-4c94-b63b-e4e0dde95a45"],
Cell[406726, 10940, 265, 7, 2047, "Text",ExpressionUUID->"67d542f7-138a-454e-8eb4-7fd5758b026a"],
Cell[406994, 10949, 286, 6, 2047, "Input",ExpressionUUID->"e48097df-ac45-480f-830d-7e5c9074977a"],
Cell[407283, 10957, 169, 3, 2047, "Text",ExpressionUUID->"b037b2df-765d-418c-be7f-9d36d1896f0b"],
Cell[407455, 10962, 184, 4, 2047, "Input",ExpressionUUID->"1cb5abb6-7952-4de2-8fe8-071430b6ea86"],
Cell[407642, 10968, 196, 3, 2047, "Text",ExpressionUUID->"e2986bd7-6907-4f08-a417-a0181addc7e0"],
Cell[407841, 10973, 388, 11, 2047, "Input",ExpressionUUID->"ea42176f-ef26-4e6b-b95e-6fa70cfe8050"],
Cell[408232, 10986, 386, 11, 2047, "Input",ExpressionUUID->"1cd0b8a9-1a83-4136-9037-43a7a285ec95"],
Cell[408621, 10999, 388, 11, 2047, "Input",ExpressionUUID->"c032c9e9-d527-47fe-ac35-70a28de3f373"],
Cell[409012, 11012, 485, 13, 2047, "Input",ExpressionUUID->"081f77a7-e1df-46f5-9cb3-b65394d138ce"],
Cell[409500, 11027, 190, 4, 2047, "Input",ExpressionUUID->"82d9d9df-7972-4a99-a496-06173096c181"],
Cell[409693, 11033, 231, 6, 2047, "Text",ExpressionUUID->"03acb277-dbb3-4cc6-85c5-10d47f88e054"],
Cell[409927, 11041, 293, 6, 2047, "Input",ExpressionUUID->"d4c0f4de-8185-4c92-afb4-64271749e93d"],
Cell[410223, 11049, 188, 4, 2047, "Input",ExpressionUUID->"3d004225-319d-4808-a589-1f317a0f72c9"],
Cell[410414, 11055, 184, 3, 2047, "Text",ExpressionUUID->"8d874fda-bdbd-48c3-abe8-5e80ed47328a"],
Cell[410601, 11060, 414, 11, 2047, "Input",ExpressionUUID->"bb844e17-1f45-49e6-a4e8-052ebb815e2f"],
Cell[411018, 11073, 412, 11, 2047, "Input",ExpressionUUID->"b770890e-ae00-424f-907a-eb0766be62a3"],
Cell[411433, 11086, 461, 12, 2047, "Input",ExpressionUUID->"08cf1922-0d1b-469d-ad6d-0008cf27afd7"],
Cell[411897, 11100, 480, 12, 2047, "Input",ExpressionUUID->"92daa414-3485-4c96-83a4-4b5e719b9753"],
Cell[412380, 11114, 167, 3, 2047, "Text",ExpressionUUID->"82eb2885-27a7-40f1-94aa-082eafd78626"],
Cell[412550, 11119, 510, 11, 2047, "Input",ExpressionUUID->"140e037c-d2d7-41d5-b641-f681318ac608"],
Cell[413063, 11132, 215, 5, 2047, "Input",ExpressionUUID->"067fa764-8f62-4a07-8e24-64b70fad8d3a"],
Cell[413281, 11139, 222, 5, 2047, "Text",ExpressionUUID->"a851d8de-3ce3-4d66-bdcf-c8dbe09b2ebc"],
Cell[413506, 11146, 274, 6, 2047, "Input",ExpressionUUID->"dc313e33-64b3-466f-8306-3034d3ec853d"],
Cell[413783, 11154, 304, 7, 2047, "Text",ExpressionUUID->"6be6ae34-0462-421a-aefb-756a17fc1fa3"],
Cell[414090, 11163, 334, 9, 2047, "Input",ExpressionUUID->"30299522-cf00-4db7-accd-bc73758698e6"],
Cell[414427, 11174, 203, 6, 2047, "Input",ExpressionUUID->"159335ce-d43c-4151-bffa-ddb74485750f"],
Cell[414633, 11182, 360, 10, 2047, "Input",ExpressionUUID->"d05e232d-7c27-4a3a-abed-0a92ba0fb974"],
Cell[414996, 11194, 394, 11, 2047, "Input",ExpressionUUID->"41082c37-31f6-4fe7-aaaf-0a0d0c8b8882"],
Cell[415393, 11207, 245, 5, 2047, "Input",ExpressionUUID->"d5dff26b-811e-4d47-89da-2c87f4485791"],
Cell[415641, 11214, 1226, 25, 4677, "Input",ExpressionUUID->"b6171b14-26f6-4bd9-ac3a-6de04c50819d"],
Cell[416870, 11241, 188, 4, 2047, "Input",ExpressionUUID->"41cdbee6-7d2d-45e3-b895-46ed89f90d03"],
Cell[417061, 11247, 403, 10, 2047, "Input",ExpressionUUID->"41324e5e-0d70-4a13-8b5a-b700391501b3"],
Cell[417467, 11259, 331, 7, 2047, "Input",ExpressionUUID->"93dfff11-58d9-4136-a87b-cc1de3e87c58"],
Cell[417801, 11268, 186, 4, 2047, "Input",ExpressionUUID->"a5787cdc-953e-4025-aa25-e76f686de170"],
Cell[417990, 11274, 1071, 23, 8538, "Text",ExpressionUUID->"9ef7f9ae-15b6-4517-b519-07f2589d89ac"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[419110, 11303, 816, 11, 81, "Subsection",ExpressionUUID->"c8e675b9-5679-438f-a4ee-02ab2bb2499d"],
Cell[CellGroupData[{
Cell[419951, 11318, 349, 5, 68, "Subsubsection",ExpressionUUID->"7b61557b-d373-4003-9c8f-d1b91372f764"],
Cell[420303, 11325, 447, 8, 1755758592, "Text",ExpressionUUID->"e81330cb-374e-4700-aad3-9ed905ed52c5"],
Cell[420753, 11335, 207, 5, 1074954240, "Input",ExpressionUUID->"cd66826e-c240-4755-b678-e8094ad66056"],
Cell[420963, 11342, 1039, 24, 1773674496, "Input",ExpressionUUID->"c07c7a60-d478-42f3-b9ea-24ff67b38f92"],
Cell[422005, 11368, 186, 4, 1074954240, "Input",ExpressionUUID->"e8468b5b-f757-4a9e-9886-c6fcf8824288"],
Cell[422194, 11374, 498, 9, 1755758592, "Text",ExpressionUUID->"af88515a-b369-4bd6-8a72-f7a34b3db883"],
Cell[422695, 11385, 1255, 25, 1074954240, "Input",ExpressionUUID->"8a16baae-f823-468b-a7cc-6b4e4a63d7b1"],
Cell[423953, 11412, 234, 5, 1074954240, "Input",ExpressionUUID->"ec360b9a-60ec-4521-b77d-42ca52aabac0"],
Cell[424190, 11419, 246, 6, 1074954240, "Text",ExpressionUUID->"7ec8d0ee-30de-43d2-9164-be7269b5ed23"],
Cell[424439, 11427, 834, 22, 1074954240, "Input",ExpressionUUID->"6dfa21ad-42a8-409c-8de7-ee2a5c14c21a"],
Cell[425276, 11451, 296, 8, 1074954240, "Text",ExpressionUUID->"d7ed59bd-721b-4b3b-9ccb-5e0ff1bce056"],
Cell[425575, 11461, 192, 4, 1074954240, "Input",ExpressionUUID->"79b21028-fb65-4697-b199-f3dd890c548c"],
Cell[425770, 11467, 643, 13, 1074954240, "Text",ExpressionUUID->"f7710b2a-ce53-4bee-88c1-9f4f9e38e19c"],
Cell[426416, 11482, 1023, 25, 1074954240, "Input",ExpressionUUID->"7fe24a3a-121d-4d60-ac53-5730e7cae92e",
 Evaluatable->False],
Cell[427442, 11509, 164, 3, 1074954240, "Text",ExpressionUUID->"cfb93983-52f1-43f5-884a-7ed7fd311ef6"],
Cell[427609, 11514, 1185, 29, 1110786048, "Input",ExpressionUUID->"2dad2e54-ebf5-4019-804e-f41291358001",
 Evaluatable->False],
Cell[428797, 11545, 440, 8, 1755758592, "Text",ExpressionUUID->"561d4037-f5ca-4630-bbe4-afd1a075907b"],
Cell[429240, 11555, 457, 14, 1074954240, "Input",ExpressionUUID->"40a2e3d4-3308-4133-8810-b4e98fc3f1b9",
 Evaluatable->False],
Cell[429700, 11571, 164, 3, 1074954240, "Text",ExpressionUUID->"c4136ad2-ca78-4b09-85da-79658a5809a6"],
Cell[429867, 11576, 604, 16, 1074954240, "Input",ExpressionUUID->"1b6b6942-aaef-4b43-a321-825fb10a2373",
 Evaluatable->False],
Cell[430474, 11594, 501, 13, 1146617856, "Text",ExpressionUUID->"ec26a586-3671-43bb-b68a-ad70e7cc2594"],
Cell[430978, 11609, 548, 10, 1074954240, "Input",ExpressionUUID->"a7b97435-9116-43b7-ab1c-b02e4039bf64"],
Cell[431529, 11621, 318, 9, 1074954240, "Input",ExpressionUUID->"245edeb2-df9a-40b7-b8fb-ee0257e00ff5"],
Cell[431850, 11632, 207, 5, 1074954240, "Input",ExpressionUUID->"759631ce-d63f-4250-b2c8-dd9dd91625cc"],
Cell[432060, 11639, 186, 4, 1074954240, "Input",ExpressionUUID->"f0771008-0eba-43e1-8fc2-e957a8410609"],
Cell[432249, 11645, 301, 7, 1074954240, "Input",ExpressionUUID->"399f692d-8ab4-4b6e-8237-b2ede6d6cac6"],
Cell[432553, 11654, 182, 3, 1074954240, "Text",ExpressionUUID->"d3e21b3b-509c-41da-9368-3d133241a02d"],
Cell[432738, 11659, 743, 20, 1074954240, "Input",ExpressionUUID->"f78ebc0e-0c0b-47d1-8ead-6335a59328c9",
 Evaluatable->False],
Cell[433484, 11681, 1628, 37, 1970749440, "Text",ExpressionUUID->"c833f876-5552-44d3-9133-b14383dcb00e"],
Cell[435115, 11720, 834, 24, 1074954240, "Input",ExpressionUUID->"4ebe651b-ec4c-4899-bd3d-f5d1e9d1755d",
 Evaluatable->False],
Cell[435952, 11746, 960, 25, 2147483647, "Text",ExpressionUUID->"e7dccb1d-b934-4837-b76e-cdbadfd98edc"],
Cell[436915, 11773, 775, 20, 1128701952, "Input",ExpressionUUID->"ae70e959-da24-443d-86ba-913ce5c2c7a7",
 Evaluatable->False],
Cell[437693, 11795, 742, 20, 1200365568, "Text",ExpressionUUID->"5f63b091-f0a5-4a33-9a9f-ed55391b8957"],
Cell[438438, 11817, 430, 12, 1074954240, "Input",ExpressionUUID->"e6f8eddb-f2da-4679-9594-cb69efdabdb9",
 Evaluatable->False],
Cell[438871, 11831, 754, 15, 1074954240, "Text",ExpressionUUID->"a79ed3b2-ae27-4b10-a12f-f5dc88f69f14"],
Cell[439628, 11848, 739, 17, 1110786048, "Input",ExpressionUUID->"031f8566-10ce-4674-b3d9-214f98155fb5",
 Evaluatable->False],
Cell[440370, 11867, 2968, 69, 2147483647, "Text",ExpressionUUID->"29a59f27-b381-4d99-ba47-e8e9230948c2"],
Cell[443341, 11938, 689, 16, 1128701952, "Input",ExpressionUUID->"0061cc20-8813-4c9a-8bb7-d575d937ea76",
 Evaluatable->False],
Cell[444033, 11956, 457, 10, 1755758592, "Text",ExpressionUUID->"ed12697e-2db2-4ddc-af93-b5488b8c0492"],
Cell[444493, 11968, 1959, 42, 2147483647, "Text",ExpressionUUID->"fbe2767d-545e-47ec-8b3a-a188dcc4b40d"],
Cell[446455, 12012, 1044, 20, 2147483647, "Text",ExpressionUUID->"63b8f963-f410-4c93-bd44-cbe2ccf78286"],
Cell[447502, 12034, 1956, 50, 1540767744, "Input",ExpressionUUID->"e911e5df-fbb1-48c1-8b01-2c5ee4d7793b",
 Evaluatable->False],
Cell[449461, 12086, 239, 6, 1074954240, "Text",ExpressionUUID->"ba8d5e85-b50e-4795-9d44-771ebd581f79"],
Cell[449703, 12094, 2039, 51, 1540767744, "Input",ExpressionUUID->"81d7b3ff-b043-493d-91b9-6cc7e352d242",
 Evaluatable->False],
Cell[451745, 12147, 1645, 34, 2078244864, "Text",ExpressionUUID->"8093d98f-7cee-410b-8a7e-91245b3787ac"],
Cell[453393, 12183, 1269, 31, 1128701952, "Input",ExpressionUUID->"9f422bfd-838e-4b15-8ff8-3c74857a10c4",
 Evaluatable->False],
Cell[454665, 12216, 739, 14, 1755758592, "Text",ExpressionUUID->"b9a8e14c-bd2c-4df9-97b0-f3eaf4cda70c"],
Cell[455407, 12232, 2069, 59, 2147483647, "Input",ExpressionUUID->"6ff88047-38ff-432a-bb95-e290eaae480a",
 Evaluatable->False],
Cell[457479, 12293, 1000, 22, 2147483647, "Text",ExpressionUUID->"2ead16c6-b2dc-477d-8b13-e8bb564e436f"],
Cell[458482, 12317, 558, 13, 1755758592, "Text",ExpressionUUID->"fae6a6f7-596e-4f5d-a9e9-8cc07dea644a"]
}, Closed]],
Cell[CellGroupData[{
Cell[459077, 12335, 338, 5, 54, "Subsubsection",ExpressionUUID->"7cc82d8d-0322-4017-93b4-a5b71e77dc9f"],
Cell[459418, 12342, 327, 8, 1755758592, "Text",ExpressionUUID->"ca2763f8-bd64-4b31-bfea-deb9acaa721b"],
Cell[459748, 12352, 207, 5, 1074954240, "Input",ExpressionUUID->"a262c8f6-d28a-4c2e-9cbd-0665460fc51c"],
Cell[459958, 12359, 323, 8, 1074954240, "Input",ExpressionUUID->"26a7ab7d-223e-4bd2-9a65-c15ed7db55f7"],
Cell[460284, 12369, 213, 5, 1074954240, "Input",ExpressionUUID->"a6af1ba1-f817-4b3c-a338-d5c344b076c0"],
Cell[460500, 12376, 395, 7, 1755758592, "Text",ExpressionUUID->"da952a2a-dcd4-4c61-826b-2d0c9ea948d9"],
Cell[460898, 12385, 307, 7, 1074954240, "Input",ExpressionUUID->"4ad7927a-eb2c-4724-992b-149b93eaef17"],
Cell[461208, 12394, 188, 4, 1074954240, "Input",ExpressionUUID->"d0e3d6d1-dc86-4518-b29c-a8adc083fd10"],
Cell[461399, 12400, 254, 7, 1074954240, "Input",ExpressionUUID->"02dec700-d554-4964-9cf7-10076170bb78"],
Cell[461656, 12409, 163, 3, 1074954240, "Text",ExpressionUUID->"a17841a8-e82c-4300-b560-835b0a0dc636"],
Cell[461822, 12414, 442, 11, 1074954240, "Input",ExpressionUUID->"75b82466-8ab5-404d-bd4e-d015ca6c9b73"],
Cell[462267, 12427, 148, 3, 1074954240, "Text",ExpressionUUID->"c8387f11-78dd-4d9e-97bd-d43663cf65dc"],
Cell[462418, 12432, 183, 5, 1074954240, "Input",ExpressionUUID->"cc44335f-6a2d-4c5d-8501-53332bdf1a3c"],
Cell[462604, 12439, 351, 8, 1074954240, "Input",ExpressionUUID->"f1d02b3f-6b38-4f18-828b-586027ae0b36"],
Cell[462958, 12449, 287, 6, 1074954240, "Text",ExpressionUUID->"46ab796c-4c30-4a09-98da-344ace2e37b7"],
Cell[463248, 12457, 316, 9, 1074954240, "Input",ExpressionUUID->"3f618397-f374-4975-bb8c-85811901bb16"],
Cell[463567, 12468, 278, 6, 1074954240, "Input",ExpressionUUID->"0456b1c6-56c3-4ef5-9675-56aee1c8da6d"],
Cell[463848, 12476, 239, 5, 1074954240, "Input",ExpressionUUID->"f92ed386-f7d3-4e4c-9964-d863e72859f0"],
Cell[464090, 12483, 246, 7, 1074954240, "Input",ExpressionUUID->"4ad9ee18-a176-4aba-b556-cd6341c0098f"],
Cell[464339, 12492, 339, 8, 1074954240, "Input",ExpressionUUID->"e200bb00-be34-4fc8-8571-ec29815f1f80"],
Cell[464681, 12502, 331, 7, 1074954240, "Text",ExpressionUUID->"bfb501cd-0634-4c9f-ad9f-e2a6b96328fa"],
Cell[465015, 12511, 399, 8, 1074954240, "Input",ExpressionUUID->"42af5db9-ddfb-483e-a6d8-0403708c0241"],
Cell[465417, 12521, 240, 5, 1074954240, "Input",ExpressionUUID->"4547b8c7-2c21-42ed-90c5-ca15600844b3"],
Cell[465660, 12528, 379, 9, 1074954240, "Input",ExpressionUUID->"6b95ff49-a644-4a66-b06e-6ad79e016006"],
Cell[466042, 12539, 540, 12, 1755758592, "Text",ExpressionUUID->"b9e1402c-141b-4987-9024-5030dcdc9206"],
Cell[466585, 12553, 644, 16, 1074954240, "Input",ExpressionUUID->"5fb6236f-a120-4cb3-ac45-d057199fbf37"],
Cell[467232, 12571, 209, 4, 1074954240, "Input",ExpressionUUID->"3b75f9eb-6bd7-4f87-9207-8192c1edde66"],
Cell[467444, 12577, 490, 10, 1074954240, "Input",ExpressionUUID->"a152ecbb-8ff1-40bf-a382-4b719a464ae9"],
Cell[467937, 12589, 1005, 20, 2147483647, "Text",ExpressionUUID->"ddf61dd5-a707-409f-8697-4b4e944d1318"],
Cell[468945, 12611, 713, 13, 2147483647, "Text",ExpressionUUID->"517c0d87-95c1-4843-b02a-ff6fa3ce0d92"],
Cell[469661, 12626, 178, 4, 1074954240, "Input",ExpressionUUID->"4ccb31af-5cf8-486d-b10c-bbb4dd8a9772"],
Cell[469842, 12632, 557, 15, 1074954240, "Input",ExpressionUUID->"b39a4751-faba-4bb9-a7b1-5d19b2a31b2c",
 Evaluatable->False],
Cell[470402, 12649, 201, 3, 1074954240, "Text",ExpressionUUID->"2152ce67-5a6a-4f44-8c81-fa5263898cd3"],
Cell[470606, 12654, 178, 4, 1074954240, "Input",ExpressionUUID->"30e4c5ea-8f04-4753-9679-b7669ad88e90"],
Cell[470787, 12660, 389, 7, 1074954240, "Input",ExpressionUUID->"3f82ee88-b78d-49e6-b823-768e84a87dea"],
Cell[471179, 12669, 335, 7, 1074954240, "Text",ExpressionUUID->"6391a72f-9713-4a66-b369-4642992d0219"],
Cell[471517, 12678, 464, 12, 1074954240, "Input",ExpressionUUID->"9524e4a6-7f17-4a8e-b4fa-dd0909bc10f7"],
Cell[471984, 12692, 235, 4, 1074954240, "Text",ExpressionUUID->"fa799eed-db1f-4f90-ae5b-a52932a337b8"],
Cell[472222, 12698, 215, 5, 1074954240, "Input",ExpressionUUID->"59252d1a-f821-4799-a3da-fc725c1d05cb"],
Cell[472440, 12705, 423, 9, 2147483647, "Text",ExpressionUUID->"bc83cae2-8dec-43ce-b5d2-35c1395e7eef"],
Cell[472866, 12716, 384, 9, 1074954240, "Text",ExpressionUUID->"307b2ee8-2784-4a4a-800e-7e72d2df75f9"],
Cell[473253, 12727, 1131, 28, 1128701952, "Input",ExpressionUUID->"5d328919-f37b-4cae-b5b3-d7221dca9574",
 Evaluatable->False],
Cell[474387, 12757, 197, 3, 1074954240, "Text",ExpressionUUID->"a1bdd39d-0d7b-481d-b3ec-e68bdba3d30d"],
Cell[474587, 12762, 1415, 35, 1200365568, "Input",ExpressionUUID->"31cca3c3-aef0-4258-8bd8-336cf2cacddb",
 Evaluatable->False],
Cell[476005, 12799, 1927, 38, 1881169920, "Text",ExpressionUUID->"1152fd6d-f151-4de0-a646-61e64cc7d46b"],
Cell[477935, 12839, 680, 23, 1236197376, "Input",ExpressionUUID->"7fc4e686-18af-4895-a851-3e2f257f30c4",
 Evaluatable->False],
Cell[478618, 12864, 1227, 37, 1952833536, "Text",ExpressionUUID->"6323d746-5443-4d19-9185-b1a5c9ee2c7e"]
}, Closed]],
Cell[CellGroupData[{
Cell[479882, 12906, 394, 6, 54, "Subsubsection",ExpressionUUID->"d6f43897-1b29-4c84-a45b-5399e0fbb124"],
Cell[480279, 12914, 1251, 25, 2147483647, "Text",ExpressionUUID->"69475d47-7319-4bf7-9e33-ab8d96efb6fd"],
Cell[481533, 12941, 778, 23, 1110786048, "Input",ExpressionUUID->"118a2f96-e3e7-4710-986e-a84e6e0e6918"],
Cell[482314, 12966, 780, 15, 2147483647, "Text",ExpressionUUID->"a225f0f2-883a-40f3-bbb4-2c3c4782bd5b"],
Cell[483097, 12983, 837, 26, 1200365568, "Input",ExpressionUUID->"c230f1e9-56c6-4d19-af6a-3057362edb72",
 Evaluatable->False],
Cell[483937, 13011, 483, 9, 2147483647, "Text",ExpressionUUID->"9b9ac616-3750-4041-af0b-aafbcbf3d677"],
Cell[484423, 13022, 540, 12, 1755758592, "Text",ExpressionUUID->"68bd0a02-2800-496e-bb7c-1f23e9277049"],
Cell[484966, 13036, 1845, 46, 2024497152, "Text",ExpressionUUID->"2a2ae37e-6d39-49fc-aadc-1d06cb7e54d0"],
Cell[486814, 13084, 1167, 32, 1540767744, "Input",ExpressionUUID->"c8847e89-12d8-4745-bbf4-25d5e2566b63",
 Evaluatable->False],
Cell[487984, 13118, 2480, 63, 1540767744, "Input",ExpressionUUID->"0b8ca875-8a4c-4524-971f-59f2669fc631",
 Evaluatable->False],
Cell[490467, 13183, 2156, 56, 1540767744, "Input",ExpressionUUID->"a11346f8-22d0-4f5d-95b9-dea3156df424",
 Evaluatable->False],
Cell[492626, 13241, 2018, 54, 1540767744, "Input",ExpressionUUID->"6671fe58-d0a0-4c65-a918-2efb993e4a9d",
 Evaluatable->False],
Cell[494647, 13297, 852, 14, 2147483647, "Text",ExpressionUUID->"fca41073-6a06-4f2b-b4c8-cec898886f0c"],
Cell[495502, 13313, 182, 4, 1074954240, "Input",ExpressionUUID->"2c4fb501-7bb2-43f7-a817-13c9d4ffc578"],
Cell[495687, 13319, 399, 8, 1755758592, "Text",ExpressionUUID->"b9dc25aa-8135-4f29-8ed5-9ce62019510e"],
Cell[496089, 13329, 6471, 147, 2147483647, "Input",ExpressionUUID->"03c359c0-eb9c-441e-9dbd-6b1df158b1bd",
 Evaluatable->False],
Cell[502563, 13478, 192, 3, 1074954240, "Text",ExpressionUUID->"befc3d00-43d8-4671-b61c-ed22847b925d"],
Cell[502758, 13483, 1578, 42, 2147483647, "Input",ExpressionUUID->"0a0c9941-cf12-4fc1-bc99-547b8f13907e",
 Evaluatable->False],
Cell[504339, 13527, 174, 3, 1074954240, "Text",ExpressionUUID->"bf529d12-ab86-4c56-ab0e-55d55f15f38a"],
Cell[504516, 13532, 12226, 286, 2147483647, "Input",ExpressionUUID->"d6ef9690-4f20-4c87-99c8-b15d60c41c7d",
 Evaluatable->False],
Cell[516745, 13820, 195, 3, 1074954240, "Text",ExpressionUUID->"21c97f9b-2e51-4949-8f35-d2a575d40ebd"],
Cell[516943, 13825, 442, 12, 1074954240, "Input",ExpressionUUID->"d5c3c8a1-9c43-412e-9b3b-9c3caa44362d",
 Evaluatable->False]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[517434, 13843, 380, 6, 81, "Subsection",ExpressionUUID->"ff5c8ed2-e417-4c1b-af36-f2fd3bea6301"],
Cell[CellGroupData[{
Cell[517839, 13853, 316, 5, 68, "Subsubsection",ExpressionUUID->"9d5b19d4-f589-4fa4-a408-c390bcb5374d"],
Cell[518158, 13860, 453, 10, 1074954240, "Input",ExpressionUUID->"344b8d40-935d-481a-bc7b-615fe297664d"],
Cell[518614, 13872, 936, 16, 1074954240, "Input",ExpressionUUID->"199dcd0d-325e-4312-9281-2ff9c8f6c1a9"],
Cell[519553, 13890, 188, 4, 1074954240, "Input",ExpressionUUID->"5636ad84-77a7-4fb1-8407-065568cef60f"],
Cell[519744, 13896, 281, 8, 1074954240, "Input",ExpressionUUID->"bd11b379-23d5-48fd-abb6-5b3381f9d65d"],
Cell[520028, 13906, 239, 5, 1074954240, "Input",ExpressionUUID->"3c2241ef-87aa-4552-a6bc-f75dca30f4ae"],
Cell[520270, 13913, 479, 11, 1074954240, "Input",ExpressionUUID->"d017feb6-c6d3-4b67-bb08-880b3d8e14cd"],
Cell[520752, 13926, 186, 4, 1074954240, "Input",ExpressionUUID->"cfd83273-312f-4476-9ddf-824884a95bed"],
Cell[520941, 13932, 526, 11, 1074954240, "Input",ExpressionUUID->"f614da11-5e67-482a-8d7b-f84ec2b7d9ad"],
Cell[521470, 13945, 502, 13, 1074954240, "Input",ExpressionUUID->"cebfd1a5-f573-49ad-9fca-4357ac85632e"],
Cell[521975, 13960, 186, 4, 1074954240, "Input",ExpressionUUID->"eb42d5e2-77e1-48a5-afd8-d2b3a107fa81"],
Cell[522164, 13966, 250, 7, 1074954240, "Input",ExpressionUUID->"bac89a9f-e339-459f-aa8f-9ab7a43afb37"],
Cell[522417, 13975, 446, 12, 1074954240, "Input",ExpressionUUID->"aad85e09-afb8-4398-b7b8-9e56e8c358e0"],
Cell[522866, 13989, 303, 8, 1074954240, "Input",ExpressionUUID->"687aeae3-19d5-42b6-91be-529ab101016c"],
Cell[523172, 13999, 447, 13, 1074954240, "Input",ExpressionUUID->"937791d0-4f7d-456d-8136-35f4d7ecf7e3"],
Cell[523622, 14014, 419, 12, 1074954240, "Input",ExpressionUUID->"4e6880d0-92b3-407a-9324-72ac657212d4"],
Cell[524044, 14028, 322, 6, 1074954240, "Input",ExpressionUUID->"b5a8ca4a-a5ce-469c-9dec-ed8df6d8312e"],
Cell[524369, 14036, 280, 8, 1074954240, "Input",ExpressionUUID->"bd167ced-af76-4766-b81c-0e7ab688992f"]
}, Closed]],
Cell[CellGroupData[{
Cell[524686, 14049, 337, 5, 54, "Subsubsection",ExpressionUUID->"5dc57d70-3a22-4f2e-807e-2788b34e724f"],
Cell[525026, 14056, 407, 9, 1074954240, "Input",ExpressionUUID->"51f7206b-71db-4439-b12a-00f1b1340699"],
Cell[525436, 14067, 604, 16, 1074954240, "Input",ExpressionUUID->"ccf9e942-d42b-4408-b700-a23b5af74a71"],
Cell[526043, 14085, 186, 4, 1074954240, "Input",ExpressionUUID->"d0cb30c1-b557-4ee3-b62d-841cd161ac2c"],
Cell[526232, 14091, 398, 11, 1074954240, "Input",ExpressionUUID->"005206ab-8999-42ba-ade5-67f1099641af"],
Cell[526633, 14104, 186, 4, 1074954240, "Input",ExpressionUUID->"99df91fa-4755-43cf-a4b6-4e0fff311dee"],
Cell[526822, 14110, 235, 6, 1074954240, "Text",ExpressionUUID->"3d3f814a-0433-4159-abb1-53906301ac14"],
Cell[527060, 14118, 1058, 25, 1074954240, "Input",ExpressionUUID->"4311296e-3be8-4790-808b-d7da1d39b2ef"],
Cell[528121, 14145, 288, 6, 1074954240, "Input",ExpressionUUID->"039e881a-19bd-44ad-85b6-6998dd8463a1"],
Cell[528412, 14153, 756, 18, 1074954240, "Input",ExpressionUUID->"2c24c595-6755-4a46-8017-5abc0d622611"],
Cell[529171, 14173, 808, 18, 1074954240, "Input",ExpressionUUID->"2d44ec32-c187-4a8f-ac62-bcb90ef771f9"],
Cell[529982, 14193, 210, 4, 1074954240, "Input",ExpressionUUID->"79b6a0ef-e6bd-4f4e-8ee3-0e8c68b7bb79"]
}, Closed]],
Cell[CellGroupData[{
Cell[530229, 14202, 284, 4, 54, "Subsubsection",ExpressionUUID->"3dfab0a6-f59f-4a4f-9c2b-54857b4971f2"],
Cell[530516, 14208, 452, 10, 1074954240, "Input",ExpressionUUID->"dc93e88e-f892-407b-922b-c543f65d6634"],
Cell[530971, 14220, 224, 5, 1074954240, "Input",ExpressionUUID->"865db686-6096-43a5-a630-aba6bd6a28e8"],
Cell[531198, 14227, 240, 7, 1074954240, "Input",ExpressionUUID->"54936855-60d0-4a99-87be-8ddced3568a0"],
Cell[531441, 14236, 312, 7, 1074954240, "Input",ExpressionUUID->"4ef6e114-c36d-4442-8a34-293b68d4445c"]
}, Closed]],
Cell[CellGroupData[{
Cell[531790, 14248, 420, 7, 54, "Subsubsection",ExpressionUUID->"2f41c4e0-fbfb-4029-89c1-fa255495d226"],
Cell[532213, 14257, 655, 13, 2147483647, "Text",ExpressionUUID->"48dad9b7-90af-4db8-8007-617869801ef6"],
Cell[532871, 14272, 520, 19, 1182449664, "Input",ExpressionUUID->"32126bd1-378d-4a18-97fb-9f66c894ceb0",
 Evaluatable->False],
Cell[533394, 14293, 1016, 22, 2147483647, "Text",ExpressionUUID->"b897f231-90c1-48fd-a51f-e375b47bdac3"],
Cell[534413, 14317, 645, 22, 1236197376, "Input",ExpressionUUID->"5c9782fe-d91e-4e63-9f2b-3db9bd5a136e",
 Evaluatable->False],
Cell[535061, 14341, 669, 18, 1272029184, "Text",ExpressionUUID->"73b61586-1bb1-45e6-a2cf-3bfee3b37c28"],
Cell[535733, 14361, 292, 9, 1272029184, "Input",ExpressionUUID->"6588c549-eb50-4a67-b940-ef458edb3bb2",
 Evaluatable->False],
Cell[536028, 14372, 300, 8, 1074954240, "Text",ExpressionUUID->"dea6e865-5d3a-4077-a9d4-2ead49f6f811"],
Cell[536331, 14382, 326, 8, 1074954240, "Input",ExpressionUUID->"dcf71ac3-5fc8-4bb5-b9f0-b8efaeabb9b6"],
Cell[536660, 14392, 287, 6, 1074954240, "Input",ExpressionUUID->"7f1c51d8-f042-4446-b34d-926589795f33"],
Cell[536950, 14400, 294, 8, 1074954240, "Input",ExpressionUUID->"0f228f24-2ed1-4de3-a63c-bfcce29a43cc"],
Cell[537247, 14410, 315, 9, 1074954240, "Input",ExpressionUUID->"f56d7ad8-b6c6-4857-80e4-8738451d97bd"],
Cell[537565, 14421, 179, 4, 1074954240, "Input",ExpressionUUID->"b7aa1da0-13b0-4a32-a573-fb2fa471a897"],
Cell[537747, 14427, 358, 11, 1074954240, "Input",ExpressionUUID->"0e003933-abdb-4c14-96da-3a67c19d1042"],
Cell[538108, 14440, 271, 8, 1074954240, "Input",ExpressionUUID->"c250f5f0-c617-4e62-b928-3dcff322a172"],
Cell[538382, 14450, 309, 9, 1074954240, "Input",ExpressionUUID->"a82f50de-00ba-4d7c-ba78-308355b5ef55"],
Cell[538694, 14461, 215, 5, 1074954240, "Text",ExpressionUUID->"d75649a4-d228-4150-aa19-6e6445d79de2"],
Cell[538912, 14468, 932, 24, 1773674496, "Input",ExpressionUUID->"26a97a78-3944-45eb-b182-1a6c7a9bc96d"],
Cell[539847, 14494, 347, 9, 1074954240, "Input",ExpressionUUID->"f5a73087-321b-40f3-af16-5822f4d5844b"],
Cell[540197, 14505, 174, 3, 1074954240, "Text",ExpressionUUID->"a82425ed-8257-40fe-832c-57f6dffc0fea"],
Cell[540374, 14510, 1393, 42, 1773674496, "Input",ExpressionUUID->"5aef3a63-1b19-4c00-a2c7-d0882fe72c8b"],
Cell[541770, 14554, 210, 5, 1074954240, "Input",ExpressionUUID->"38a9a879-9771-4d1c-8074-2ab5fd3b17b9"],
Cell[541983, 14561, 171, 3, 1074954240, "Text",ExpressionUUID->"41d560e1-1dd3-49b4-b9b9-2bfa1bdc07c0"],
Cell[542157, 14566, 290, 7, 1074954240, "Input",ExpressionUUID->"ffb6d2f0-a510-465f-bdac-bf1f1083ed01"],
Cell[542450, 14575, 243, 6, 1074954240, "Input",ExpressionUUID->"66428943-b3e7-4bda-ac1a-50771fecc901"],
Cell[542696, 14583, 201, 3, 1074954240, "Text",ExpressionUUID->"c8daa9c1-f924-4992-8464-57edf1ad6ede"],
Cell[542900, 14588, 707, 19, 1074954240, "Input",ExpressionUUID->"d31860d1-cbe9-4434-a414-b4eace66b573"],
Cell[543610, 14609, 164, 3, 1074954240, "Text",ExpressionUUID->"cd1926aa-3b04-4160-b527-3a7545fe26b6"],
Cell[543777, 14614, 207, 5, 1074954240, "Input",ExpressionUUID->"8f21c929-9d14-4624-8156-04e548657ae0"],
Cell[543987, 14621, 251, 6, 1074954240, "Input",ExpressionUUID->"c9518746-e9d0-4d34-953a-b362bf0f722f"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[544299, 14634, 724, 10, 101, "Section",ExpressionUUID->"4fed695f-c903-40db-8b85-f39505bedfcd"],
Cell[CellGroupData[{
Cell[545048, 14648, 276, 4, 81, "Subsection",ExpressionUUID->"ddb654ed-8181-4b49-8f68-e6260dd65ee1"],
Cell[545327, 14654, 304, 7, 124, "Text",ExpressionUUID->"eaffdbe6-3d4e-4a29-8c0c-3d08759d931b"],
Cell[545634, 14663, 184, 4, 73, "Input",ExpressionUUID->"099dac2b-786f-4d7f-b34b-c6c66fc9b99e"],
Cell[545821, 14669, 370, 7, 124, "Text",ExpressionUUID->"9716e2b6-8710-4524-b3f9-c53241905b50"],
Cell[546194, 14678, 216, 7, 75, "Text",ExpressionUUID->"e970cb61-2fde-4347-aa7f-c0c09016c955"],
Cell[546413, 14687, 209, 5, 73, "Input",ExpressionUUID->"314dc3f3-fa60-48c1-84cf-7e89c8d91434"],
Cell[546625, 14694, 460, 12, 73, "Input",ExpressionUUID->"390e821c-b031-4098-a247-43511da2e3c5"],
Cell[547088, 14708, 467, 11, 73, "Input",ExpressionUUID->"bfd9f49f-2993-47b2-8fd1-8220cb6e229f"],
Cell[547558, 14721, 310, 6, 73, "Input",ExpressionUUID->"73c8257a-21e1-413a-ab7b-e87013bdfee7"],
Cell[547871, 14729, 308, 6, 337, "Input",ExpressionUUID->"814eea1a-3c97-4489-bd63-2d7b1c0123c8"],
Cell[548182, 14737, 451, 9, 337, "Input",ExpressionUUID->"89d9ace2-083c-4083-9a4c-9f553716ffd3"],
Cell[548636, 14748, 193, 4, 337, "Input",ExpressionUUID->"2d321d4c-63e6-44f0-9d6c-0c7f372a3828"],
Cell[548832, 14754, 197, 4, 337, "Input",ExpressionUUID->"e6b1d4f3-60c6-4e75-9d7e-44e41017f01e"],
Cell[549032, 14760, 170, 6, 3343, "Text",ExpressionUUID->"b4058f0e-f893-4f68-80b9-8707ff93e21a"],
Cell[549205, 14768, 174, 4, 2047, "Input",ExpressionUUID->"64b54d21-e254-472f-9202-966b48efc66b"],
Cell[549382, 14774, 284, 7, 2047, "Input",ExpressionUUID->"826ebedc-4ef0-4f14-88f0-29c80b140909"],
Cell[549669, 14783, 267, 6, 2047, "Text",ExpressionUUID->"c5cd70b1-28b4-4825-9695-f2c4a10452a2"],
Cell[549939, 14791, 337, 9, 337, "Input",ExpressionUUID->"7d6b589c-5966-4ca8-ba1f-20af5c70d32e",
 Evaluatable->False],
Cell[550279, 14802, 166, 3, 366, "Text",ExpressionUUID->"39fd6760-1129-4550-8a78-8e1c412c6924"],
Cell[550448, 14807, 701, 19, 567, "Input",ExpressionUUID->"5586e460-0786-4805-b678-f10a72406b0c"],
Cell[551152, 14828, 290, 7, 366, "Text",ExpressionUUID->"4923c7bd-e058-43df-93a3-881979cfb1b6"],
Cell[551445, 14837, 182, 4, 337, "Input",ExpressionUUID->"68867957-8e0f-450f-99c0-1fdf6901588c"],
Cell[551630, 14843, 214, 7, 366, "Text",ExpressionUUID->"71186507-2960-47b0-a1b0-8586d23546db"],
Cell[551847, 14852, 254, 6, 337, "Input",ExpressionUUID->"63f53820-7538-41dd-8417-7a8c7c03dbcd"],
Cell[552104, 14860, 401, 10, 621, "Text",ExpressionUUID->"96c9056a-ec22-4187-a5f5-f3ab5c07ed61"],
Cell[552508, 14872, 381, 9, 337, "Input",ExpressionUUID->"eba88a5c-bb36-4190-a240-57b0506e5d78"],
Cell[552892, 14883, 229, 6, 366, "Text",ExpressionUUID->"ecb26912-81b9-45c6-9e54-5197eb7a5f4d"],
Cell[553124, 14891, 321, 8, 337, "Input",ExpressionUUID->"6bff3d57-0ad6-472f-b16e-0468670d77ca"],
Cell[553448, 14901, 933, 18, 1356, "Text",ExpressionUUID->"4f22abf6-91ce-412f-b956-7af93ecb481f"]
}, Closed]],
Cell[CellGroupData[{
Cell[554418, 14924, 265, 4, 55, "Subsection",ExpressionUUID->"bd8ac46c-e6a0-4158-95f5-eb8ae74f36c0"],
Cell[554686, 14930, 438, 8, 124, "Text",ExpressionUUID->"39496508-7d48-41d1-926e-8a13247b832a"],
Cell[555127, 14940, 492, 15, 73, "Input",ExpressionUUID->"fe543cad-5a12-499e-9074-67016c2a787d",
 Evaluatable->False],
Cell[555622, 14957, 203, 3, 75, "Text",ExpressionUUID->"1e0c0f7a-1392-4ebf-a9ec-0ec7c288fe8e"],
Cell[555828, 14962, 796, 22, 124, "Input",ExpressionUUID->"557cfa94-b67a-4ea5-937e-6ab5a1b29d9d",
 Evaluatable->False],
Cell[556627, 14986, 180, 4, 73, "Input",ExpressionUUID->"231c3b9a-239f-412f-866b-1887a50c9f2f"],
Cell[556810, 14992, 1338, 30, 231, "Text",ExpressionUUID->"50d90e72-defa-4acd-bbba-638698388f07"],
Cell[558151, 15024, 491, 15, 337, "Input",ExpressionUUID->"3fd1dc8f-f142-4e86-8333-49bfa633237c",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[558667, 15043, 179, 3, 397, "Subsubsection",ExpressionUUID->"c8710614-4fc4-4b0b-86cc-075686b3a620"],
Cell[558849, 15048, 409, 8, 37179, "Text",ExpressionUUID->"8a92ec11-e96b-4bdb-8b6e-d357d576707f"],
Cell[559261, 15058, 2110, 51, 68616, "Input",ExpressionUUID->"03007d06-20b4-4546-a9cb-0749aa0ea85c",
 Evaluatable->False],
Cell[561374, 15111, 563, 9, 16402, "Input",ExpressionUUID->"c98448e7-5014-4789-92a0-9c291ae96d22"],
Cell[561940, 15122, 207, 5, 16402, "Input",ExpressionUUID->"478e175f-fe26-46f3-aba6-0ab48f26860a"],
Cell[562150, 15129, 316, 6, 16402, "Input",ExpressionUUID->"70bdebce-18b2-431a-81b9-841aa0b2dc5c"],
Cell[562469, 15137, 370, 7, 16402, "Input",ExpressionUUID->"afd8024d-41e0-4ee9-9360-e0137ba3dfa4"],
Cell[562842, 15146, 332, 7, 16402, "Input",ExpressionUUID->"a62e4606-e45b-4558-987c-890134123b30"],
Cell[563177, 15155, 244, 6, 4099, "Input",ExpressionUUID->"5f0156fb-6bad-41b5-9663-b7d097361863"],
Cell[563424, 15163, 273, 8, 4099, "Input",ExpressionUUID->"be4069b5-6b01-4dad-8b02-fe089fd4b79d"],
Cell[563700, 15173, 273, 8, 4099, "Input",ExpressionUUID->"b8d23fa6-fbac-496e-a8a2-85a843bc8209"],
Cell[563976, 15183, 360, 7, 4099, "Input",ExpressionUUID->"573d86d0-61da-467f-94fa-b908e99213ce"],
Cell[564339, 15192, 295, 7, 4099, "Input",ExpressionUUID->"d7e3dd4e-a98a-4709-b099-be360e47e479"],
Cell[564637, 15201, 360, 9, 4099, "Input",ExpressionUUID->"29419b35-8605-465c-b927-48b79d3c1363"],
Cell[565000, 15212, 358, 9, 4099, "Input",ExpressionUUID->"ff86539b-43de-4f05-b7c3-f4a2a0008642"],
Cell[565361, 15223, 715, 11, 4099, "Input",ExpressionUUID->"30b55294-4a1f-435e-be9c-1ebd4b4c0998"],
Cell[566079, 15236, 970, 23, 9357, "Input",ExpressionUUID->"1b5f3a3f-b901-461a-9f19-18441b68a78a",
 Evaluatable->False],
Cell[567052, 15261, 209, 5, 4099, "Input",ExpressionUUID->"ebbd56a7-8cf1-450f-9745-0d566a07d6df"],
Cell[567264, 15268, 213, 5, 4099, "Input",ExpressionUUID->"1f52e565-1426-4918-b50f-4c8469801472"],
Cell[567480, 15275, 342, 7, 5805, "Input",ExpressionUUID->"ef3532f7-d918-4fc8-9155-e552d7d8004f"],
Cell[567825, 15284, 245, 7, 4099, "Input",ExpressionUUID->"3f2f9b5b-e51b-4a3f-9112-1f1688ce92d8"],
Cell[568073, 15293, 262, 5, 4099, "Input",ExpressionUUID->"38992e69-1daa-47cb-ad99-d474066801a5"],
Cell[568338, 15300, 194, 4, 5805, "Input",ExpressionUUID->"1204707f-190c-46eb-ab38-7adca10a3d3c"],
Cell[568535, 15306, 215, 5, 5805, "Input",ExpressionUUID->"3d13d1b9-4f4c-4288-a263-bca13fa083fc"],
Cell[568753, 15313, 210, 5, 5805, "Input",ExpressionUUID->"3e93dfb8-653b-4698-b809-6c0e00ac1abb"],
Cell[568966, 15320, 350, 7, 4099, "Input",ExpressionUUID->"501b5031-91ff-453c-8f64-5953710fab15"],
Cell[569319, 15329, 300, 8, 4099, "Input",ExpressionUUID->"4db542ec-a22b-41ca-a6f8-76b1a3d9354e"],
Cell[569622, 15339, 528, 15, 4099, "Input",ExpressionUUID->"f209c314-4fa2-4618-ad64-fdf90c64570d"],
Cell[570153, 15356, 223, 4, 4099, "Input",ExpressionUUID->"6f7c89f9-0652-45d5-94af-03b89cac7de0"],
Cell[570379, 15362, 227, 5, 4099, "Text",ExpressionUUID->"6caadd39-d2e0-42e2-a4d4-6cbed96d6603"],
Cell[570609, 15369, 940, 22, 6763, "Input",ExpressionUUID->"96ef14a2-03ef-4ba6-a1ce-aad8d0a28aba",
 Evaluatable->False],
Cell[571552, 15393, 364, 6, 4099, "Input",ExpressionUUID->"737a9412-54bb-486d-85a7-9ae1a35561c1"],
Cell[571919, 15401, 228, 5, 4099, "Input",ExpressionUUID->"95116fde-0c9d-498f-99a9-c6d786a5d1ad"],
Cell[572150, 15408, 185, 4, 4099, "Input",ExpressionUUID->"69d9f92b-740c-49c4-b1dc-23d9a0d4cb5f"],
Cell[572338, 15414, 265, 6, 4099, "Input",ExpressionUUID->"fd323c0e-b459-4a35-90f8-e4d7ff36e0e7"],
Cell[572606, 15422, 310, 9, 4099, "Input",ExpressionUUID->"17f28030-52d0-4a83-b4b9-24053a8c3a4e"],
Cell[572919, 15433, 310, 9, 4099, "Input",ExpressionUUID->"f88f2766-f185-44bf-be3c-18a78f6b4504"],
Cell[573232, 15444, 306, 7, 4099, "Input",ExpressionUUID->"a0330af2-2d45-4ec1-8c71-bc53d22652fa"],
Cell[573541, 15453, 250, 7, 4099, "Input",ExpressionUUID->"67791ff9-a940-41d9-9191-81d0be53ff00"]
}, Closed]],
Cell[CellGroupData[{
Cell[573828, 15465, 316, 5, 316, "Subsubsection",ExpressionUUID->"a08762bc-15d9-47c8-9517-867d554e9308"],
Cell[574147, 15472, 525, 10, 37179, "Text",ExpressionUUID->"7d4932aa-0c79-4061-a3d5-98eab2270ab6"],
Cell[574675, 15484, 2243, 53, 68616, "Input",ExpressionUUID->"a9dd981c-78ba-47f2-8022-cbfd6d454c36",
 Evaluatable->False],
Cell[576921, 15539, 723, 12, 16402, "Input",ExpressionUUID->"3978c760-d8b6-477d-82bd-0299a4d41473"],
Cell[577647, 15553, 207, 5, 16402, "Input",ExpressionUUID->"6eed7f86-c570-41a7-abd6-d9280128d2a2"],
Cell[577857, 15560, 294, 6, 16402, "Input",ExpressionUUID->"7e7137ef-cb44-4b7b-bf6d-b77842958dce"],
Cell[578154, 15568, 320, 6, 16402, "Input",ExpressionUUID->"a8d2ac2a-1965-425e-97e7-3107008ce4e6"],
Cell[578477, 15576, 195, 3, 16402, "Text",ExpressionUUID->"c7a48107-e689-4742-9268-09bbc4f7e21c"],
Cell[578675, 15581, 384, 7, 16402, "Input",ExpressionUUID->"30b0fb9b-755a-4b32-8367-82aa83b1575c"],
Cell[579062, 15590, 356, 7, 16402, "Input",ExpressionUUID->"9b5e4300-9a46-4f96-b768-5198b12b24e5"],
Cell[579421, 15599, 244, 6, 16402, "Input",ExpressionUUID->"ea850511-a350-41d3-9151-07998bbf350f"],
Cell[579668, 15607, 273, 8, 16402, "Input",ExpressionUUID->"675b37e0-16e6-4e1e-80af-532d21939f05"],
Cell[579944, 15617, 273, 8, 16402, "Input",ExpressionUUID->"ce071b5a-79a8-4a48-8134-8559af9b98fa"],
Cell[580220, 15627, 1232, 27, 37450, "Input",ExpressionUUID->"8091c5b1-2620-410a-9bb2-6125a4df97ae",
 Evaluatable->False],
Cell[581455, 15656, 543, 9, 16402, "Input",ExpressionUUID->"a82cdc78-770a-40f5-a6d7-c2c80e6bfd7a"],
Cell[582001, 15667, 209, 5, 16402, "Input",ExpressionUUID->"949b018c-9327-4d52-85af-9062f9e7bddf"],
Cell[582213, 15674, 379, 8, 16402, "Input",ExpressionUUID->"94428e84-bca4-4944-852a-32bccafc1b30"],
Cell[582595, 15684, 274, 8, 16402, "Input",ExpressionUUID->"ecada9ee-354a-4387-b955-76bce5bb5e24"],
Cell[582872, 15694, 478, 15, 16402, "Input",ExpressionUUID->"ab2ee3ea-d940-4e70-9edf-e5ef18bd249a"],
Cell[583353, 15711, 197, 4, 16402, "Input",ExpressionUUID->"a077362f-394a-4282-84c4-c7b504bf902a"],
Cell[583553, 15717, 392, 7, 16402, "Input",ExpressionUUID->"713d4626-0285-4306-9950-189465d00ac3"],
Cell[583948, 15726, 247, 5, 16402, "Input",ExpressionUUID->"0d389861-ea47-452f-be2c-0c7347ed87f7"],
Cell[584198, 15733, 418, 8, 16402, "Input",ExpressionUUID->"08084dd3-f57c-4939-8128-e54d848d0e2a"],
Cell[584619, 15743, 245, 7, 4099, "Input",ExpressionUUID->"be0cd762-8eab-487d-8884-234612b38c04"],
Cell[584867, 15752, 266, 6, 1021, "Text",ExpressionUUID->"0d51c01f-a8ab-4c41-acc1-9aeede16adc5"],
Cell[585136, 15760, 1060, 22, 1683, "Input",ExpressionUUID->"363e49ad-02f1-43d4-a126-0c1fb4c5ec5e",
 Evaluatable->False],
Cell[586199, 15784, 421, 7, 1021, "Input",ExpressionUUID->"f56e28a5-91ed-4336-a801-7855777150f0"],
Cell[586623, 15793, 205, 3, 1021, "Text",ExpressionUUID->"aceb643d-e97c-4b9f-ad77-8347f50c7495"],
Cell[586831, 15798, 680, 14, 1021, "Input",ExpressionUUID->"12f78c41-c88e-420f-a23c-7a2c98f2cc50"],
Cell[587514, 15814, 437, 10, 1021, "Input",ExpressionUUID->"90c112a0-2322-4778-aba7-85715b28d3d1"],
Cell[587954, 15826, 462, 8, 2322, "Text",ExpressionUUID->"91aa148a-cb1b-4fe3-a9e4-eda671914070"],
Cell[588419, 15836, 176, 4, 1021, "Input",ExpressionUUID->"1febedd8-0aec-4bbf-bcbc-cd76f49cee34"],
Cell[588598, 15842, 965, 17, 2965, "Text",ExpressionUUID->"9be851e1-d9ae-4cc6-95a3-8c6f7cad348c"],
Cell[589566, 15861, 702, 21, 1021, "Input",ExpressionUUID->"87067221-9da9-42b7-9dd4-58826f58547a",
 Evaluatable->False],
Cell[590271, 15884, 632, 12, 2322, "Text",ExpressionUUID->"e11e7ed1-7185-471b-aadb-6d96668f82ba"],
Cell[590906, 15898, 185, 4, 1021, "Input",ExpressionUUID->"3e3cde9a-84c9-44e4-90c5-35417e28de03"],
Cell[591094, 15904, 161, 3, 1021, "Text",ExpressionUUID->"4c0a040d-d772-4472-89be-31ec79e0b0db"],
Cell[591258, 15909, 300, 5, 1021, "Input",ExpressionUUID->"43cfa284-3986-4ab5-ae6d-99288174cabd"],
Cell[591561, 15916, 287, 8, 1021, "Input",ExpressionUUID->"250bf3a4-4e9f-4039-b7ae-ea0df35e6c1e"],
Cell[591851, 15926, 551, 17, 1021, "Input",ExpressionUUID->"59272e19-5fdb-4343-a344-d60b7f9c49e2"],
Cell[592405, 15945, 177, 3, 1021, "Text",ExpressionUUID->"fb632cb2-6374-4712-af53-175f940abc48"],
Cell[592585, 15950, 458, 9, 1021, "Input",ExpressionUUID->"df9b65a3-2eed-4e49-a558-76a0c77eb041"],
Cell[593046, 15961, 382, 8, 1021, "Input",ExpressionUUID->"6e46cfd1-8475-4daa-b26c-4e5ba6f36f45"],
Cell[593431, 15971, 250, 5, 1021, "Text",ExpressionUUID->"3b984ee0-980a-4b8c-8710-7eb920d6bf1b"],
Cell[593684, 15978, 375, 9, 1021, "Input",ExpressionUUID->"802e0796-7779-4cd0-9644-ad02181d497e"],
Cell[594062, 15989, 301, 7, 1021, "Input",ExpressionUUID->"aba3e3ad-ef17-42d4-a77a-a004f035b5ac"],
Cell[594366, 15998, 195, 4, 1021, "Input",ExpressionUUID->"2f491129-e726-470b-9047-382df15b3699"],
Cell[594564, 16004, 282, 6, 1021, "Input",ExpressionUUID->"adbc525f-eddf-4582-8d22-d78ee3eccbdb"],
Cell[594849, 16012, 198, 3, 1021, "Text",ExpressionUUID->"b2a3a5dc-51cd-4207-8a3a-3f1708716904"],
Cell[595050, 16017, 167, 4, 1021, "Input",ExpressionUUID->"6e3252d3-380d-4e6f-b549-1ab96e8e06d3"],
Cell[595220, 16023, 223, 5, 1021, "Input",ExpressionUUID->"3ff5f20f-971e-4c69-952b-30e7ebe2c286"],
Cell[595446, 16030, 315, 7, 1021, "Input",ExpressionUUID->"64e42b7d-4e4d-4d97-86ca-71a8e1fb6026"],
Cell[595764, 16039, 733, 15, 2322, "Text",ExpressionUUID->"3314d0ce-7d2b-4d59-bb63-74b653be8b4d"],
Cell[596500, 16056, 1044, 31, 1296, "Input",ExpressionUUID->"34b7c0ed-7922-4c5a-9760-239a4f829a81",
 Evaluatable->False],
Cell[597547, 16089, 313, 7, 1669, "Text",ExpressionUUID->"92e9beef-fa50-47ce-973d-4843efb3eef3"],
Cell[597863, 16098, 1983, 53, 1977, "Input",ExpressionUUID->"46f8c071-4bdf-4baa-b8cb-49076ffc5a03",
 Evaluatable->False],
Cell[599849, 16153, 1470, 27, 1734, "Text",ExpressionUUID->"0caacf6f-8cef-4975-b211-b2066366fdac"],
Cell[601322, 16182, 558, 17, 1188, "Input",ExpressionUUID->"64893adf-5a62-4b7e-a16d-6ead98ab32cc"],
Cell[601883, 16201, 1321, 29, 3037, "Text",ExpressionUUID->"002e33a3-d283-47be-9310-6463ec06a8f8"],
Cell[603207, 16232, 176, 4, 1021, "Input",ExpressionUUID->"0a4095c5-8fd3-4328-9925-b76aad5c03bb"],
Cell[603386, 16238, 4230, 92, 6225, "Input",ExpressionUUID->"f826dc92-7892-4ec4-87fd-05bf2183c697",
 Evaluatable->False],
Cell[607619, 16332, 396, 9, 1021, "Input",ExpressionUUID->"8941cf9f-c8bd-40c9-bed4-dbfed0efb4d2"],
Cell[608018, 16343, 360, 9, 1021, "Input",ExpressionUUID->"04560138-d2da-473e-8d06-632d495730c7"],
Cell[608381, 16354, 334, 8, 1021, "Input",ExpressionUUID->"afd7b46b-335b-4378-aa31-5e1100c25dd5"],
Cell[608718, 16364, 316, 8, 1021, "Input",ExpressionUUID->"044d8c7c-552f-40c6-8c5b-7d380d776560"],
Cell[609037, 16374, 192, 4, 1021, "Input",ExpressionUUID->"d11f9ae4-82a3-44b4-ae7e-1b91cb22a217"],
Cell[609232, 16380, 174, 4, 1021, "Input",ExpressionUUID->"d2f9027b-458c-402d-8b5f-3599822e385b"],
Cell[609409, 16386, 192, 4, 1021, "Input",ExpressionUUID->"f8a81005-d69d-4861-b847-24ffa62a2141"],
Cell[609604, 16392, 359, 7, 1021, "Input",ExpressionUUID->"812b6674-0e10-461b-9b67-3d4121bc2964"],
Cell[609966, 16401, 246, 5, 1021, "Input",ExpressionUUID->"7ea572d8-96e5-4cd8-8652-a5f8280d6cca"],
Cell[610215, 16408, 433, 9, 1021, "Input",ExpressionUUID->"7ea61950-f3a5-4fd5-b65a-c7497e2c2f9e"],
Cell[610651, 16419, 246, 5, 1021, "Input",ExpressionUUID->"6ad5606a-8783-4bb4-8510-55004012404c"],
Cell[610900, 16426, 288, 5, 1021, "Input",ExpressionUUID->"20b5c2c0-e31e-4d0b-9114-a245ac8f2117"],
Cell[611191, 16433, 220, 5, 1021, "Input",ExpressionUUID->"bdb3add9-b90a-42b0-96fa-68fb3a0c042c"],
Cell[611414, 16440, 208, 5, 1021, "Input",ExpressionUUID->"69e2dca1-c784-49ab-a482-2612a5173eae"],
Cell[611625, 16447, 294, 8, 1021, "Input",ExpressionUUID->"4c0c55c0-62e9-4a9f-9777-497b9c67aaf2"],
Cell[611922, 16457, 208, 5, 1021, "Input",ExpressionUUID->"0f56f957-3eea-4068-8d52-dade38da2082"],
Cell[612133, 16464, 499, 13, 1021, "Input",ExpressionUUID->"23515668-8f3d-4fc3-be40-f067d5409b32"],
Cell[612635, 16479, 212, 5, 1021, "Input",ExpressionUUID->"3791422b-1867-4ae1-b0da-2834fbe41860"],
Cell[612850, 16486, 277, 6, 1021, "Input",ExpressionUUID->"1bb83119-8ba7-4ebb-8c6e-998708bfb4ae"],
Cell[613130, 16494, 1558, 40, 4983, "Text",ExpressionUUID->"0968eb05-ec42-4efb-bb95-48901332008c",
 CellTags->"wtstb"],
Cell[614691, 16536, 484, 14, 1579, "Text",ExpressionUUID->"09b27e36-b538-41f4-829d-12a60c253196"],
Cell[615178, 16552, 179, 4, 1021, "Input",ExpressionUUID->"7bba4c1d-cf64-4242-b38a-b675f79ec34a"],
Cell[615360, 16558, 430, 8, 1669, "Text",ExpressionUUID->"8ccb4669-2186-47ed-96bc-4187bafdbfd5"],
Cell[615793, 16568, 2585, 71, 6225, "Input",ExpressionUUID->"bd881aa2-abb1-4610-9623-6473b39db30a",
 Evaluatable->False],
Cell[618381, 16641, 176, 4, 1021, "Input",ExpressionUUID->"a4686d4f-86db-4e4f-b288-2d5228c47644"],
Cell[618560, 16647, 300, 7, 1021, "Input",ExpressionUUID->"378f2dde-d94f-43ae-bc02-796422370349"],
Cell[618863, 16656, 244, 5, 1021, "Input",ExpressionUUID->"05c63e02-ca9e-41da-a2c4-b019b04dd7e7"],
Cell[619110, 16663, 294, 8, 1021, "Input",ExpressionUUID->"7b3baca9-5d23-40f9-9ca9-0a418f57a49b"],
Cell[619407, 16673, 527, 15, 1021, "Input",ExpressionUUID->"f17be994-11b9-4fcc-b65e-4f8eb8cadb76"],
Cell[619937, 16690, 245, 6, 1021, "Input",ExpressionUUID->"263d5d75-a663-4514-87a5-d086013bba7f"],
Cell[620185, 16698, 253, 6, 1579, "Input",ExpressionUUID->"56a2a7a2-96d6-446a-a65e-96180a6b44f8"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[620487, 16710, 776, 11, 55, "Subsection",ExpressionUUID->"fd32f13b-7291-4d2c-81c2-cd1a0c8939e7"],
Cell[621266, 16723, 401, 7, 125, "Text",ExpressionUUID->"ea05dccf-edc6-403e-82a8-38911c16d1ac"],
Cell[CellGroupData[{
Cell[621692, 16734, 725, 10, 68, "Subsubsection",ExpressionUUID->"9d687bc4-fb5d-418c-b33f-0e4472da1261"],
Cell[622420, 16746, 815, 13, 37179, "Text",ExpressionUUID->"ffdfbd0d-fe94-42be-b333-7399abb95db5"],
Cell[623238, 16761, 230, 5, 16402, "Input",ExpressionUUID->"550365af-6ed0-4b98-bafa-10ae41606ab8"],
Cell[623471, 16768, 422, 7, 16402, "Input",ExpressionUUID->"e539e06f-6ff1-4a3d-a924-4c3e9baf3683"],
Cell[623896, 16777, 498, 8, 16402, "Input",ExpressionUUID->"aca40676-c0e0-47c3-bb09-abd4d59f0a52"],
Cell[624397, 16787, 1953, 45, 47839, "Input",ExpressionUUID->"50458750-2b46-4e1e-b4d9-8a830ec714e1",
 Evaluatable->False],
Cell[626353, 16834, 2137, 47, 47839, "Input",ExpressionUUID->"f62bf839-ee0d-439c-9989-d9d4efa51987",
 Evaluatable->False],
Cell[628493, 16883, 220, 5, 17496, "Text",ExpressionUUID->"576e256d-f9ab-4bd2-973a-97d465942ff0"],
Cell[628716, 16890, 365, 10, 16402, "Input",ExpressionUUID->"7bfb343e-2d64-4314-a30c-629c6a0cd018"],
Cell[629084, 16902, 306, 6, 16402, "Text",ExpressionUUID->"705c06a1-795b-4a94-b7af-50cc1c7e9830"],
Cell[629393, 16910, 367, 10, 16402, "Input",ExpressionUUID->"09c59510-2912-4227-a090-779ba991fa99"],
Cell[629763, 16922, 454, 11, 16402, "Input",ExpressionUUID->"b803ac98-6d18-4779-8e09-7e24c0c1e173"],
Cell[630220, 16935, 238, 6, 16402, "Text",ExpressionUUID->"c1e9ce71-59ec-4095-9975-100f834515e8"],
Cell[630461, 16943, 376, 9, 16402, "Input",ExpressionUUID->"472547a3-9b2c-4530-8f0b-9d3615638a99"],
Cell[630840, 16954, 479, 10, 16402, "Input",ExpressionUUID->"645f9f94-a5fc-4189-9aba-f6b91864f069"],
Cell[631322, 16966, 398, 7, 26790, "Text",ExpressionUUID->"c86e2e13-75d4-4f25-9cf0-b678d0d1bcc5"],
Cell[631723, 16975, 512, 12, 16402, "Input",ExpressionUUID->"a0cb08e6-e50f-4a8c-b685-ba8af62453c1"],
Cell[632238, 16989, 441, 12, 16402, "Input",ExpressionUUID->"2924d3a1-e398-460a-8e17-6a1e8f585b57"]
}, Closed]],
Cell[CellGroupData[{
Cell[632716, 17006, 747, 10, 54, "Subsubsection",ExpressionUUID->"3dce0f03-33a6-44af-9d96-7001e90437e9"],
Cell[633466, 17018, 278, 6, 26790, "Text",ExpressionUUID->"3792d775-595a-43e9-a8df-f3a47c183670"],
Cell[633747, 17026, 418, 7, 16402, "Input",ExpressionUUID->"ba24d80c-e48c-4767-9cc9-6654aaa61b53"],
Cell[634168, 17035, 449, 8, 16402, "Input",ExpressionUUID->"7831007b-43f5-4f71-8424-5beb7d4a393c"],
Cell[634620, 17045, 3788, 90, 89392, "Input",ExpressionUUID->"a3c23811-599c-49fa-b4ed-8c94b23587de",
 Evaluatable->False],
Cell[638411, 17137, 3978, 94, 99780, "Input",ExpressionUUID->"f38d0631-f827-49ff-83b6-aa323d8aa5bc",
 Evaluatable->False],
Cell[642392, 17233, 217, 5, 17496, "Text",ExpressionUUID->"360847f2-2fdf-47af-9b96-4b704d60dfb4"],
Cell[642612, 17240, 220, 5, 16402, "Input",ExpressionUUID->"d2b633e9-f4fe-49a1-8eb6-ce8522df8429"],
Cell[642835, 17247, 354, 9, 16402, "Input",ExpressionUUID->"b1c8792d-23bf-4a00-90a8-566540464716"],
Cell[643192, 17258, 403, 10, 16402, "Input",ExpressionUUID->"f772c1b9-996e-437f-9427-dccfaee82e62"],
Cell[643598, 17270, 203, 5, 16402, "Input",ExpressionUUID->"b273a885-dd09-434c-aa0f-427b54af28a3"],
Cell[643804, 17277, 275, 6, 16402, "Text",ExpressionUUID->"7d726dda-fc4e-4427-a301-4c0348f1258b"],
Cell[644082, 17285, 329, 9, 16402, "Input",ExpressionUUID->"5a57d620-a8ff-419d-b013-cc2d3db6ee04"],
Cell[644414, 17296, 355, 9, 16402, "Input",ExpressionUUID->"fb435771-c458-4ad3-b679-82c54209ce27"],
Cell[644772, 17307, 437, 12, 16402, "Input",ExpressionUUID->"d85d04e0-3bb8-4952-b6e6-71350125aca7"],
Cell[645212, 17321, 387, 12, 16402, "Input",ExpressionUUID->"e35f3a8e-f886-49b9-8ee2-fb0ebaa807a9"],
Cell[645602, 17335, 405, 10, 16402, "Input",ExpressionUUID->"4a7e4d4c-931b-4660-97eb-e35b6c1956a6"],
Cell[646010, 17347, 495, 13, 16402, "Input",ExpressionUUID->"846583a2-b088-455e-b963-b975193792bf"],
Cell[646508, 17362, 371, 12, 16402, "Input",ExpressionUUID->"f29da37b-7239-4a5d-97ad-13fe239e6267"],
Cell[646882, 17376, 406, 11, 16402, "Input",ExpressionUUID->"be099152-d7df-4bec-9360-bd0bd46210f9"],
Cell[647291, 17389, 174, 3, 16402, "Text",ExpressionUUID->"0a0ffa92-92ad-4f83-ba28-989ea9340531"],
Cell[647468, 17394, 329, 9, 16402, "Input",ExpressionUUID->"f41f50fb-862b-4abf-a895-9fb246c7b9c6"],
Cell[647800, 17405, 731, 21, 27063, "Input",ExpressionUUID->"8cf8310d-6c92-454d-95bf-6aee05f89fe4"],
Cell[648534, 17428, 401, 11, 16402, "Input",ExpressionUUID->"2699b56c-c096-4ba5-b4f8-01ff88766d70"],
Cell[648938, 17441, 463, 12, 16402, "Input",ExpressionUUID->"c874b2a4-41d0-49d5-92f0-1231af4c2595"],
Cell[649404, 17455, 440, 12, 16402, "Input",ExpressionUUID->"23cb0c24-7c05-402f-ad6a-224f3c4c5fb7"],
Cell[649847, 17469, 691, 18, 16402, "Input",ExpressionUUID->"0355e574-53e5-4dca-b9c1-f036129c5d37"],
Cell[650541, 17489, 243, 5, 16402, "Input",ExpressionUUID->"5b2c83ab-8d1c-44a3-99d9-714be0e491fb"]
}, Closed]],
Cell[CellGroupData[{
Cell[650821, 17499, 361, 6, 54, "Subsubsection",ExpressionUUID->"e01ca8fc-08cf-4ea8-912f-c0e02ab621fb"],
Cell[651185, 17507, 596, 12, 37179, "Text",ExpressionUUID->"c432cfbd-1819-4ded-abb2-c68203998988"],
Cell[651784, 17521, 500, 17, 16402, "Input",ExpressionUUID->"a6682b5f-1477-418c-bf8b-9c22fda126a9",
 Evaluatable->False],
Cell[652287, 17540, 437, 11, 16402, "Text",ExpressionUUID->"8ac8cd21-216a-4512-9efd-13413f09d785"],
Cell[652727, 17553, 531, 18, 16402, "Input",ExpressionUUID->"67c2292e-272a-47ee-b2ab-2e5dfd36de17",
 Evaluatable->False],
Cell[653261, 17573, 1220, 20, 47566, "Text",ExpressionUUID->"2710d85d-1cb9-4fbf-a05a-c4718057b5c5"],
Cell[654484, 17595, 794, 13, 57955, "Text",ExpressionUUID->"b83e4b9a-8f4c-4db0-b1e6-8a9ececa3678"],
Cell[655281, 17610, 159, 3, 16402, "Input",ExpressionUUID->"921b07a2-13ce-40f4-badf-533a5491252c"],
Cell[655443, 17615, 277, 5, 16402, "Input",ExpressionUUID->"32c30203-a3dd-47f1-a717-bd86463387b7"],
Cell[655723, 17622, 1962, 50, 99780, "Input",ExpressionUUID->"d3b5ecaf-4a82-4fcb-8d2b-6890ad743284",
 Evaluatable->False],
Cell[657688, 17674, 175, 4, 16402, "Input",ExpressionUUID->"07e7a4df-41e4-413e-992d-4fc91a760428"],
Cell[657866, 17680, 333, 6, 16402, "Input",ExpressionUUID->"3d3b8f74-a4a9-42ce-aa39-afc09c426dc0"],
Cell[658202, 17688, 3451, 71, 89392, "Input",ExpressionUUID->"fc86a283-d47c-498c-8095-15f77017356a",
 Evaluatable->False],
Cell[661656, 17761, 178, 4, 16402, "Input",ExpressionUUID->"42da56fa-117a-4672-8325-36a5ecc3eabe"],
Cell[661837, 17767, 189, 3, 16402, "Text",ExpressionUUID->"5ed79c40-1c8b-44ca-93ec-9d9ff0029b0f"],
Cell[662029, 17772, 407, 7, 16402, "Input",ExpressionUUID->"767bfedc-53f2-412e-bbc3-8aa466a65eed"],
Cell[662439, 17781, 4058, 88, 110169, "Input",ExpressionUUID->"81bb2147-71b8-4d62-9afc-8914fb00aa01",
 Evaluatable->False],
Cell[666500, 17871, 175, 4, 16402, "Input",ExpressionUUID->"69dc4e87-f0c3-4d99-9044-d7bcaba6967a"],
Cell[666678, 17877, 512, 8, 16402, "Input",ExpressionUUID->"e851a13a-0175-43bd-a4a0-19f8bc987141"],
Cell[667193, 17887, 3834, 81, 99780, "Input",ExpressionUUID->"28b6240e-f91b-4590-add9-dcd76db7a94d",
 Evaluatable->False],
Cell[671030, 17970, 177, 4, 16402, "Input",ExpressionUUID->"26e677c9-8072-4be7-a7cf-4daa4117f95d"]
}, Closed]],
Cell[CellGroupData[{
Cell[671244, 17979, 396, 6, 54, "Subsubsection",ExpressionUUID->"a0f9394b-06af-4303-8f78-bfe46ae0fc99"],
Cell[671643, 17987, 359, 9, 4099, "Input",ExpressionUUID->"4dcb6ef3-92fd-4cb9-902f-ef43411232ca"],
Cell[672005, 17998, 302, 7, 4099, "Input",ExpressionUUID->"adf9ab26-9403-4952-ae71-14b3e53e12bd"],
Cell[672310, 18007, 212, 5, 4099, "Input",ExpressionUUID->"7e7707e8-8b94-4820-b193-ff6d98517539"],
Cell[672525, 18014, 618, 14, 4099, "Input",ExpressionUUID->"6ed2c589-1ee1-4e79-a20e-4f25dd2082dc"],
Cell[673146, 18030, 276, 7, 4099, "Input",ExpressionUUID->"41230f7e-521a-41f1-8a9b-9ce3b5901eef"],
Cell[673425, 18039, 333, 8, 4099, "Input",ExpressionUUID->"16f32745-bc9b-49c0-835c-9781b656a915"],
Cell[673761, 18049, 276, 7, 4099, "Input",ExpressionUUID->"acb78859-0fa8-473b-8d14-ef471299625e"],
Cell[674040, 18058, 476, 11, 4099, "Input",ExpressionUUID->"f32787c0-7ee5-4097-a68f-87b82e0e3e7c"],
Cell[674519, 18071, 276, 7, 4099, "Input",ExpressionUUID->"988e8c08-f008-4a5e-9652-f2315ccf1568"],
Cell[674798, 18080, 328, 8, 4099, "Input",ExpressionUUID->"970dcb8a-3290-4023-9d58-52f57dc7b106"],
Cell[675129, 18090, 276, 7, 4099, "Input",ExpressionUUID->"b4c36b91-fa10-4370-98e3-70ad8ce6fb31"],
Cell[675408, 18099, 298, 8, 4099, "Input",ExpressionUUID->"248ca681-915f-454c-a23a-06e5ca1cf199"],
Cell[675709, 18109, 276, 7, 4099, "Input",ExpressionUUID->"adf73d8c-41a2-4330-a4a3-05946d5ea51e"],
Cell[675988, 18118, 353, 9, 4099, "Input",ExpressionUUID->"6bca3c5c-f659-4cd1-8967-5bdcaae1f9ad"],
Cell[676344, 18129, 276, 7, 4099, "Input",ExpressionUUID->"a9b31b3e-da17-4aec-be84-21b562cd7885"],
Cell[676623, 18138, 404, 9, 4099, "Input",ExpressionUUID->"724404a0-6ad5-42d3-a479-e9cd866af7b8"],
Cell[677030, 18149, 276, 7, 4099, "Input",ExpressionUUID->"94635341-e124-42ad-ad2d-5f4172b73e5d"],
Cell[677309, 18158, 459, 10, 4099, "Input",ExpressionUUID->"c5a458de-f299-404e-9be9-8f4f2f437940"],
Cell[677771, 18170, 276, 7, 4099, "Input",ExpressionUUID->"e68646c3-dd33-4ce9-be4e-330043931659"],
Cell[678050, 18179, 377, 9, 9294, "Text",ExpressionUUID->"0427f931-5468-41f7-a625-61ac2c5bcb6d"]
}, Closed]],
Cell[CellGroupData[{
Cell[678464, 18193, 295, 4, 54, "Subsubsection",ExpressionUUID->"4115ad96-295a-4578-bdf6-3a6207186fcf"],
Cell[678762, 18199, 246, 6, 4099, "Input",ExpressionUUID->"6c23ed80-0d9a-4e73-834e-7e5a3b6eff86"],
Cell[679011, 18207, 405, 8, 4099, "Input",ExpressionUUID->"ee7eb2ac-5c66-4b0b-8338-4f3022dd3023"],
Cell[679419, 18217, 254, 6, 4099, "Input",ExpressionUUID->"0b20811a-e8b8-4c91-bd9a-7a4aea0989ce"],
Cell[679676, 18225, 368, 10, 4099, "Input",ExpressionUUID->"34389050-670a-4216-b5e8-48cc3bedb202"],
Cell[680047, 18237, 420, 9, 4099, "Input",ExpressionUUID->"e1a808c0-943e-4f0d-a532-273d58fe54e7"],
Cell[680470, 18248, 200, 5, 4099, "Input",ExpressionUUID->"f198e820-2c5d-470f-99f7-a69d70292062"],
Cell[680673, 18255, 248, 5, 4099, "Input",ExpressionUUID->"dece4f33-12d0-4631-9525-1b63427721d8"],
Cell[680924, 18262, 638, 19, 4099, "Input",ExpressionUUID->"7012318b-83ba-44ee-8b0d-e2a6540f584c"],
Cell[681565, 18283, 237, 6, 4099, "Input",ExpressionUUID->"7564c02d-14ad-46ae-97b3-d7fd709f330a"],
Cell[681805, 18291, 574, 12, 6696, "Text",ExpressionUUID->"0839fef5-f100-4df4-a030-f8d7a9fcbd82"],
Cell[682382, 18305, 384, 10, 4099, "Input",ExpressionUUID->"852d9c8c-7fce-4a8b-8caa-74205c358ae4",
 Evaluatable->False],
Cell[682769, 18317, 439, 11, 4099, "Input",ExpressionUUID->"0729f71a-9c2b-4fae-8688-f85ebbfa47a5",
 Evaluatable->False],
Cell[683211, 18330, 395, 10, 4099, "Input",ExpressionUUID->"e9315e7f-499e-4e15-a5df-7f29dfd99913",
 Evaluatable->False],
Cell[683609, 18342, 418, 11, 4099, "Input",ExpressionUUID->"389ea15c-2e03-498c-a326-b9a145797c31",
 Evaluatable->False],
Cell[684030, 18355, 394, 10, 4099, "Input",ExpressionUUID->"dcc8279c-04e7-4260-a916-ee6c5f163916",
 Evaluatable->False],
Cell[684427, 18367, 315, 9, 4099, "Input",ExpressionUUID->"facb2a10-ae96-48a5-8b8f-ee3877f1c33f",
 Evaluatable->False],
Cell[684745, 18378, 449, 10, 4099, "Input",ExpressionUUID->"026f3ff3-5b85-45bd-a7a5-8810607345c9",
 Evaluatable->False],
Cell[685197, 18390, 374, 10, 4099, "Input",ExpressionUUID->"3f011cd5-981c-475f-af01-3c7d40da42b9",
 Evaluatable->False],
Cell[685574, 18402, 296, 6, 6696, "Text",ExpressionUUID->"ff7a2000-05bb-4261-88fc-9653f1b789f5"],
Cell[685873, 18410, 219, 5, 4099, "Text",ExpressionUUID->"53a2f6fb-d559-4dce-bcae-860a54f4c199"],
Cell[686095, 18417, 299, 7, 4099, "Input",ExpressionUUID->"28eb8435-5d40-42d8-af44-a768b0dc35bd"],
Cell[686397, 18426, 368, 10, 4099, "Input",ExpressionUUID->"18076bfb-dfe5-4217-8ac0-c22eab2afbfe"],
Cell[686768, 18438, 275, 7, 4099, "Input",ExpressionUUID->"e93f4afc-3560-44ee-bb41-95c9845d1f15"],
Cell[687046, 18447, 345, 7, 4099, "Input",ExpressionUUID->"f031cd6a-2d4d-45fc-8bd2-c294a8149642"],
Cell[687394, 18456, 368, 10, 4099, "Input",ExpressionUUID->"7cad1603-2326-4a49-9125-a2e3fbfd3aa8"],
Cell[687765, 18468, 275, 7, 4099, "Input",ExpressionUUID->"ebd0443c-f558-4049-8c13-845cc65cefb5"],
Cell[688043, 18477, 227, 3, 4099, "Text",ExpressionUUID->"f229f2d4-d9bb-4aff-a910-083204926522"],
Cell[688273, 18482, 214, 5, 4099, "Input",ExpressionUUID->"115b3f40-fc33-492b-a360-1d41e93ca165"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[688536, 18493, 624, 9, 81, "Subsection",ExpressionUUID->"e93c5af2-2e2b-4601-9ba2-c2f9979c7513"],
Cell[CellGroupData[{
Cell[689185, 18506, 245, 4, 68, "Subsubsection",ExpressionUUID->"907efa08-902a-437f-80c8-de3a5ac2e483"],
Cell[689433, 18512, 2262, 42, 13185, "Text",ExpressionUUID->"8bdebcef-68e8-4f1f-9cfe-a6c13eb3be19"],
Cell[691698, 18556, 1942, 46, 4194, "Text",ExpressionUUID->"84f49a51-eb45-4f6d-a5af-99c48ef1d9ff"],
Cell[693643, 18604, 1111, 17, 4645, "Text",ExpressionUUID->"24f87eea-6f77-4dd8-861b-a1ac83f2fb99"],
Cell[694757, 18623, 1463, 40, 3856, "Input",ExpressionUUID->"2b54311a-f56b-4958-9988-6aaa2c1c8416",
 Evaluatable->False],
Cell[696223, 18665, 718, 14, 3343, "Text",ExpressionUUID->"f65aee28-52a8-41a6-8f77-6363a4efd2af"],
Cell[696944, 18681, 654, 21, 2868, "Input",ExpressionUUID->"428e8123-f6f6-4562-8647-7a17162f28e8",
 Evaluatable->False],
Cell[697601, 18704, 227, 4, 2047, "Text",ExpressionUUID->"d1a88d79-3a3d-4795-be7e-d5271d59becd"],
Cell[697831, 18710, 832, 18, 3856, "Input",ExpressionUUID->"d64cc0a7-66c5-415c-a8e8-88e3eac92cd2",
 CellID->470106277],
Cell[698666, 18730, 862, 18, 5941, "Text",ExpressionUUID->"81fdbb3e-202f-4f3f-857f-32333da1530e"],
Cell[699531, 18750, 442, 11, 2047, "Text",ExpressionUUID->"71208db0-1ade-4169-900b-8f69e60f7edb"]
}, Closed]],
Cell[CellGroupData[{
Cell[700010, 18766, 433, 7, 54, "Subsubsection",ExpressionUUID->"ef5abb46-5273-44f6-a7ad-1356c893d3d6"],
Cell[700446, 18775, 939, 16, 258, "Text",ExpressionUUID->"f183b874-6196-488d-b5a7-ac73039e0844"],
Cell[701388, 18793, 281, 5, 109, "Input",ExpressionUUID->"c00db480-2810-47ec-96d7-7fbf81418b45"],
Cell[701672, 18800, 447, 14, 150, "Text",ExpressionUUID->"28ede0cb-a639-43d7-87e6-71339a26dbe3"],
Cell[702122, 18816, 275, 5, 109, "Input",ExpressionUUID->"53e755a6-d193-4425-ac3b-7a64189a12cc"],
Cell[702400, 18823, 219, 4, 112, "Text",ExpressionUUID->"d6d90fd7-8ef4-493d-9aec-1ace8b3fb065"],
Cell[702622, 18829, 550, 13, 109, "Input",ExpressionUUID->"0daaedd1-5966-4418-abde-129a24da186c"],
Cell[703175, 18844, 596, 11, 109, "Input",ExpressionUUID->"1f9fcc97-ac77-4587-b798-f46114a9d9bd"],
Cell[703774, 18857, 364, 8, 112, "Text",ExpressionUUID->"1b8d0619-74dc-4d48-838c-3da537c7fd82"],
Cell[704141, 18867, 187, 4, 109, "Input",ExpressionUUID->"60bab527-9697-4f9c-8ea2-0a8e0db118cb"],
Cell[704331, 18873, 177, 4, 109, "Input",ExpressionUUID->"6a5b9b4a-d7e2-444c-91d5-7b95104c9fee"],
Cell[704511, 18879, 272, 4, 112, "Text",ExpressionUUID->"016d5d26-569b-46bb-9f1d-76c3034419f3"],
Cell[704786, 18885, 175, 4, 109, "Input",ExpressionUUID->"2271d258-fc12-43b6-bd7c-205637e01162"],
Cell[704964, 18891, 465, 10, 109, "Input",ExpressionUUID->"b13332b3-4245-4297-8911-c11c1ac6271d",
 Evaluatable->False],
Cell[705432, 18903, 157, 4, 109, "Input",ExpressionUUID->"cfef2bba-1e1d-4d5d-8d49-e86905bd1b5b"],
Cell[705592, 18909, 318, 7, 112, "Text",ExpressionUUID->"1aa37cf0-c91e-49b3-95bb-0d55fbdf7537"],
Cell[705913, 18918, 186, 4, 109, "Input",ExpressionUUID->"6581817f-ca46-45ee-8f21-2f584150eda5"],
Cell[706102, 18924, 302, 4, 112, "Text",ExpressionUUID->"8478962e-da6e-4dd3-8250-4a77ca44ed00"],
Cell[706407, 18930, 292, 6, 109, "Input",ExpressionUUID->"74c43efb-dfaf-43d7-b88f-6338d45c2230"],
Cell[706702, 18938, 268, 6, 109, "Input",ExpressionUUID->"5ce37f27-b73c-4d1e-a8da-914af20cddce"],
Cell[706973, 18946, 149, 3, 112, "Text",ExpressionUUID->"6a151f37-21d3-4195-b9f3-f7424c8c92f9"],
Cell[707125, 18951, 337, 7, 109, "Input",ExpressionUUID->"e54e1b79-1b67-40c7-a901-5ca496db10ac"],
Cell[707465, 18960, 435, 8, 109, "Input",ExpressionUUID->"5e6ee0b0-a5be-4761-a3f9-803a27f7d864"],
Cell[707903, 18970, 214, 5, 109, "Input",ExpressionUUID->"6f703431-7b10-4145-95af-4504b728da63"],
Cell[708120, 18977, 264, 6, 109, "Input",ExpressionUUID->"b3dbea8a-8d31-4767-be7c-683b01755291"],
Cell[708387, 18985, 418, 9, 109, "Input",ExpressionUUID->"8537aaca-fcb8-4f8c-8bad-1f860db509a3"],
Cell[708808, 18996, 162, 3, 112, "Text",ExpressionUUID->"31743274-9eb6-4396-bfa7-cbcb32d65a72"],
Cell[708973, 19001, 646, 16, 186, "Input",ExpressionUUID->"9560a09d-5579-4fd9-9bc0-3c89b3453430"],
Cell[709622, 19019, 263, 4, 112, "Text",ExpressionUUID->"fac3847c-01bf-4cb3-b024-e65ffdf05607"],
Cell[709888, 19025, 372, 8, 109, "Input",ExpressionUUID->"63096325-a966-42e9-beda-2af089529fcb"],
Cell[710263, 19035, 401, 8, 109, "Input",ExpressionUUID->"12213517-1a8f-4928-81a9-b509a9ba64ed"],
Cell[710667, 19045, 295, 6, 112, "Text",ExpressionUUID->"0559d1c3-b40f-4904-8e90-c3b7a187cf6c"],
Cell[710965, 19053, 499, 9, 109, "Input",ExpressionUUID->"e0bc7a02-5836-409b-aafb-be0d551925fd"],
Cell[711467, 19064, 197, 3, 112, "Text",ExpressionUUID->"07d24d15-7660-4837-9411-08a28b956a96"],
Cell[711667, 19069, 354, 9, 109, "Input",ExpressionUUID->"e905b44c-640f-4520-8f79-1dc46e9fe7ea"],
Cell[712024, 19080, 312, 7, 112, "Text",ExpressionUUID->"00f11427-0bb7-44bb-abeb-54aaa419c520"],
Cell[712339, 19089, 271, 6, 109, "Input",ExpressionUUID->"e8566d79-07ff-47f4-99f3-7bd018f81e72"],
Cell[712613, 19097, 175, 3, 112, "Text",ExpressionUUID->"f09b9f62-fe30-4b54-b5de-2a09d8175a5d"],
Cell[712791, 19102, 195, 4, 109, "Input",ExpressionUUID->"32fc7480-26b4-4196-83d5-42b4dddf681e"],
Cell[712989, 19108, 250, 6, 186, "Text",ExpressionUUID->"08586637-d9df-48a6-9c39-b6ba1bb05abb"],
Cell[713242, 19116, 297, 8, 109, "Input",ExpressionUUID->"b0c30f23-978c-4720-b58a-ce46209b7423"],
Cell[713542, 19126, 187, 4, 109, "Input",ExpressionUUID->"185e2bd1-ae7f-4920-885f-d450f3d15f70"],
Cell[713732, 19132, 165, 4, 109, "Input",ExpressionUUID->"d01d9ed7-0d38-4645-b818-7f164d370a77"],
Cell[713900, 19138, 215, 5, 109, "Input",ExpressionUUID->"fbb9ba87-a4c0-486b-8f1f-ff1fe3f6252f"],
Cell[714118, 19145, 173, 3, 112, "Text",ExpressionUUID->"68586454-ccdf-46ca-bbc3-dcf5dcc48119"],
Cell[714294, 19150, 195, 4, 109, "Input",ExpressionUUID->"c3d3bcf8-4702-487b-b2f3-7ee62399e5f5"],
Cell[714492, 19156, 296, 8, 109, "Input",ExpressionUUID->"8372f9f9-f280-4b18-ae57-83884e98cbe8"],
Cell[714791, 19166, 268, 6, 112, "Text",ExpressionUUID->"311e1d15-1302-44dd-8d4d-abac48c479db"],
Cell[715062, 19174, 214, 5, 109, "Input",ExpressionUUID->"e1c917cf-2fb4-4723-857f-16fa6a7df8c0"],
Cell[715279, 19181, 649, 13, 333, "Text",ExpressionUUID->"f1f916ca-d745-4fde-af62-1dbf5d815762"],
Cell[715931, 19196, 690, 19, 121, "Text",ExpressionUUID->"a9fb9f25-24af-407d-99e1-ac20bcc40188"],
Cell[716624, 19217, 601, 21, 117, "Input",ExpressionUUID->"7f093829-eb64-45a1-9342-ca828a82fae6"],
Cell[717228, 19240, 507, 15, 112, "Text",ExpressionUUID->"6b7bbf57-2e17-41a6-8914-74c455ab1969"],
Cell[717738, 19257, 161, 3, 112, "Text",ExpressionUUID->"d1d60df1-ec1a-42a9-af9a-1e7ad9d7d003"],
Cell[717902, 19262, 333, 9, 109, "Input",ExpressionUUID->"d8dd8e7a-08ec-48c5-909e-ceeddca4c35f"],
Cell[718238, 19273, 255, 6, 109, "Input",ExpressionUUID->"3383befc-18d2-4711-9574-2fcdb68a24ab"],
Cell[718496, 19281, 364, 9, 109, "Input",ExpressionUUID->"aebc3dda-b0e3-447f-a2f1-ab74d769698c"],
Cell[718863, 19292, 299, 6, 186, "Text",ExpressionUUID->"8d030b26-1905-4498-b008-433a0f74a7f8"],
Cell[719165, 19300, 329, 6, 109, "Input",ExpressionUUID->"6d6b9b73-0195-4a8e-bdca-92e891da6f4d"],
Cell[719497, 19308, 388, 7, 109, "Input",ExpressionUUID->"8ad0d6c1-9ddd-44b6-8df0-e5d59c8c2db6"],
Cell[719888, 19317, 361, 7, 112, "Text",ExpressionUUID->"fc44187f-db24-4b5c-9a74-cae98d06aea5"],
Cell[720252, 19326, 198, 4, 109, "Input",ExpressionUUID->"e65593a9-d0dc-44e0-be96-1800ec044e55"],
Cell[720453, 19332, 187, 4, 109, "Input",ExpressionUUID->"19965cbb-26d7-4dad-be0c-6e4fc8eb88b1"],
Cell[720643, 19338, 244, 5, 112, "Text",ExpressionUUID->"66f199db-9e08-4c56-96cc-788c812314db"],
Cell[720890, 19345, 427, 11, 109, "Input",ExpressionUUID->"87f258ec-ff13-4cb8-8a3b-14598f13fec6"],
Cell[721320, 19358, 323, 8, 109, "Input",ExpressionUUID->"f1db19e2-7032-4220-8ed0-9a50318bdfb4"],
Cell[721646, 19368, 217, 5, 109, "Input",ExpressionUUID->"079967b0-1aee-438f-9198-f5c0567382ac"],
Cell[721866, 19375, 181, 3, 112, "Text",ExpressionUUID->"a2e31674-c8c2-4718-b700-2d275a159c4b"],
Cell[722050, 19380, 272, 6, 109, "Input",ExpressionUUID->"e34dfcfb-b7db-4b2f-850d-849d4a900d5b"],
Cell[722325, 19388, 440, 8, 258, "Text",ExpressionUUID->"ac839710-fddb-49f4-8ce9-078b876a006d"],
Cell[722768, 19398, 196, 4, 109, "Input",ExpressionUUID->"7d4779d1-9522-4313-82ab-d16c0289cbae"],
Cell[722967, 19404, 185, 4, 109, "Input",ExpressionUUID->"4b8d0842-74d6-44d2-8a69-9b7bf3421599"],
Cell[723155, 19410, 286, 8, 109, "Input",ExpressionUUID->"bfa7dd7c-733b-402f-a807-d1a4d81b4daa"],
Cell[723444, 19420, 541, 16, 109, "Input",ExpressionUUID->"0c044acf-b3ad-4272-9358-52dc209c6aa7"],
Cell[723988, 19438, 194, 4, 109, "Input",ExpressionUUID->"e0fb211a-687b-4522-b524-65ec3d90778b"],
Cell[724185, 19444, 154, 3, 109, "Input",ExpressionUUID->"ce6f286b-6766-4a86-ac3a-288a4ac2e027"]
}, Closed]],
Cell[CellGroupData[{
Cell[724376, 19452, 687, 10, 54, "Subsubsection",ExpressionUUID->"130ec00f-a969-4c01-b539-3974217c8911"],
Cell[725066, 19464, 594, 10, 1669, "Text",ExpressionUUID->"33478009-b1b9-4170-b4f5-d24115b9c7bc"],
Cell[725663, 19476, 838, 13, 2965, "Text",ExpressionUUID->"b2c48887-3d52-4edc-a814-703a39fc53de"],
Cell[726504, 19491, 324, 6, 1021, "Input",ExpressionUUID->"b3374df1-35a5-42cb-97a4-36f981c193f9"],
Cell[726831, 19499, 271, 4, 1021, "Text",ExpressionUUID->"c49ca96e-f3dd-4f5e-bd80-ba71ae717685"],
Cell[727105, 19505, 7568, 202, 17266, "Input",ExpressionUUID->"8aba6827-dcb7-4f38-adbc-788132d3ca6f",
 Evaluatable->False],
Cell[734676, 19709, 521, 13, 1021, "Input",ExpressionUUID->"0c6fc4fd-a1c8-49a6-b922-d0b9db7029a8",
 Evaluatable->False],
Cell[735200, 19724, 194, 4, 1021, "Input",ExpressionUUID->"2f2c67a2-ac00-4e85-989c-ebdf5e10a538"],
Cell[735397, 19730, 175, 4, 1021, "Input",ExpressionUUID->"36b98f92-30de-4179-8042-e35d7044a10c"],
Cell[735575, 19736, 393, 7, 2322, "Text",ExpressionUUID->"cc79a24c-2a08-496c-a968-82844f2195b9"],
Cell[735971, 19745, 215, 7, 1021, "Text",ExpressionUUID->"24ee6fee-be53-49a6-9033-30e697d9938d"],
Cell[736189, 19754, 257, 6, 1021, "Input",ExpressionUUID->"e3dabad7-bc01-47be-a66a-96898bf5a1af"],
Cell[736449, 19762, 309, 8, 1021, "Input",ExpressionUUID->"85451e74-7655-4fa9-942b-1e898d6e263d"],
Cell[736761, 19772, 185, 4, 1021, "Input",ExpressionUUID->"68614de8-0305-4bc6-b127-cd797753bd24"],
Cell[736949, 19778, 184, 4, 1021, "Input",ExpressionUUID->"9af5cda1-c527-4737-a257-e0e38d2fdf42"],
Cell[737136, 19784, 360, 9, 1021, "Input",ExpressionUUID->"b571ae06-644a-4fcb-b3b5-006d6749765b"],
Cell[737499, 19795, 335, 9, 1021, "Input",ExpressionUUID->"cda19a38-c255-4d6a-8279-9e2c0e628ba2"],
Cell[737837, 19806, 288, 7, 1021, "Input",ExpressionUUID->"46a28c8a-d98c-4280-a1df-b9601a366d45"],
Cell[738128, 19815, 262, 6, 1021, "Input",ExpressionUUID->"9fb4054b-5734-4e62-8702-3738a4f0af81"],
Cell[738393, 19823, 592, 13, 1021, "Input",ExpressionUUID->"09086592-1e3e-4158-88c3-0d2986a65178"],
Cell[738988, 19838, 300, 8, 1021, "Input",ExpressionUUID->"d7def434-8c79-4bfc-944a-2d41b08d3bdb"],
Cell[739291, 19848, 485, 13, 1021, "Input",ExpressionUUID->"a3107b1d-4c6b-492c-8ef5-21f5b233592e"],
Cell[739779, 19863, 181, 4, 1021, "Input",ExpressionUUID->"ced52080-a51d-4e40-957a-8e879f3658b0"],
Cell[739963, 19869, 258, 6, 1021, "Input",ExpressionUUID->"b291236e-d3c9-4cfb-a1d8-92ce79c576ac"],
Cell[740224, 19877, 240, 6, 1021, "Input",ExpressionUUID->"78342410-bd33-4e4b-b478-5dc886ee26f5"],
Cell[740467, 19885, 217, 5, 1021, "Input",ExpressionUUID->"f1ef58fb-9476-4f2d-ab65-ea1fca493d4f"],
Cell[740687, 19892, 275, 7, 1021, "Input",ExpressionUUID->"3da94ce5-8174-4e5e-860a-98a1ae00a039"],
Cell[740965, 19901, 330, 8, 1021, "Text",ExpressionUUID->"8bf70f87-e43f-428d-9df1-f7a22f889d5d"],
Cell[741298, 19911, 351, 8, 1021, "Input",ExpressionUUID->"55e12cf5-c4df-4aa1-b9a4-cb08b7e966f3",
 Evaluatable->False],
Cell[741652, 19921, 359, 6, 1021, "Text",ExpressionUUID->"5aba9455-d119-48aa-adea-876061828378"],
Cell[742014, 19929, 397, 10, 1021, "Input",ExpressionUUID->"bc26ee69-bf5e-445e-af1d-ff934faf01be",
 Evaluatable->False],
Cell[742414, 19941, 416, 9, 1669, "Text",ExpressionUUID->"179d10ca-171b-462b-8654-688cd557917e"],
Cell[742833, 19952, 379, 8, 1021, "Input",ExpressionUUID->"1156b91f-df1d-4e28-a1bc-a69842833a43"],
Cell[743215, 19962, 238, 5, 1021, "Input",ExpressionUUID->"74306ced-2d2d-4da1-bca5-7a56b9c6a7fa"],
Cell[743456, 19969, 519, 14, 1021, "Input",ExpressionUUID->"b771331d-cf00-44ab-aed0-07c7236801af"],
Cell[743978, 19985, 549, 12, 1683, "Input",ExpressionUUID->"f577348e-60ae-4aae-b28c-cf84c6d2c221"],
Cell[744530, 19999, 422, 9, 2322, "Text",ExpressionUUID->"f36b0045-dfcf-48b8-9bb3-4e0689ea4f66"],
Cell[744955, 20010, 179, 4, 1021, "Input",ExpressionUUID->"b968ec1e-2bf0-45f1-a587-80a1a9ecd4a0"],
Cell[745137, 20016, 637, 13, 2965, "Text",ExpressionUUID->"37269c98-9867-4b61-87f5-e82a7fa7de75"],
Cell[745777, 20031, 505, 13, 1021, "Input",ExpressionUUID->"7bff3f50-2e9b-407f-bac5-eb336b47a52e",
 Evaluatable->False],
Cell[746285, 20046, 233, 4, 1021, "Text",ExpressionUUID->"3b4591e4-1b0b-4a00-b471-e9b70961e2e6"],
Cell[746521, 20052, 557, 14, 1021, "Input",ExpressionUUID->"759cd1fb-99e4-457b-b84a-4813a0efc724",
 Evaluatable->False],
Cell[747081, 20068, 455, 10, 1669, "Text",ExpressionUUID->"e7c8ddd7-6c45-4cfd-a071-34e96777e716"],
Cell[747539, 20080, 714, 18, 1021, "Input",ExpressionUUID->"68b90d61-61d7-48c9-92b7-33a8f2704e27"],
Cell[748256, 20100, 606, 15, 1683, "Input",ExpressionUUID->"28c616b7-db65-4481-bd7d-9f750435b630"],
Cell[748865, 20117, 714, 18, 1021, "Input",ExpressionUUID->"5af454d9-3626-484b-a30a-60be7efd088e"],
Cell[749582, 20137, 720, 16, 1683, "Input",ExpressionUUID->"0c353461-b76b-40bb-a504-6825a9d0be4f"],
Cell[750305, 20155, 240, 7, 1669, "Text",ExpressionUUID->"024be220-e881-4e9b-a78e-6cb55abd7be4"],
Cell[750548, 20164, 1128, 21, 2965, "Text",ExpressionUUID->"3b2d7974-446a-4dae-b75b-8f86e87b51dd"],
Cell[751679, 20187, 714, 14, 1021, "Input",ExpressionUUID->"4789fba7-77f4-44ed-8cd1-0948f125470a",
 Evaluatable->False],
Cell[752396, 20203, 476, 12, 1669, "Text",ExpressionUUID->"faff096b-3a73-4cb6-82e0-9c91e12b1618"],
Cell[752875, 20217, 660, 14, 1021, "Input",ExpressionUUID->"145a2780-3553-4330-93fc-5a3e59d2f5d7"],
Cell[753538, 20233, 579, 13, 1021, "Input",ExpressionUUID->"a2949f15-cf93-4706-b18d-a5346b18de1c"],
Cell[754120, 20248, 230, 6, 1021, "Input",ExpressionUUID->"97d9cccf-7165-424c-a9bf-637ebdb674f3"],
Cell[754353, 20256, 189, 4, 1021, "Input",ExpressionUUID->"51c44c8b-2373-4d0d-b408-2b6effaf54c2"],
Cell[754545, 20262, 350, 7, 1021, "Text",ExpressionUUID->"c581d274-9852-43a6-9891-a6e113493cc4"],
Cell[754898, 20271, 744, 17, 2328, "Input",ExpressionUUID->"6e8e9bd4-71cc-45e8-a061-737d0920dcc9"],
Cell[755645, 20290, 292, 5, 1021, "Input",ExpressionUUID->"31e240d8-8739-4c14-8af6-97e66ce044e1"],
Cell[755940, 20297, 441, 8, 1021, "Text",ExpressionUUID->"b69182e6-743a-490c-bdb3-445ade42c9bf"],
Cell[756384, 20307, 294, 7, 1669, "Text",ExpressionUUID->"7c3130c3-dc22-4525-ac0d-b913e06271ff"],
Cell[756681, 20316, 1358, 23, 3618, "Text",ExpressionUUID->"e03123cc-e5e9-493a-8e08-60a0f99d94dd"],
Cell[758042, 20341, 747, 16, 1021, "Input",ExpressionUUID->"9331ecf6-f6bb-4638-b3b9-04bede70978f",
 Evaluatable->False],
Cell[758792, 20359, 274, 7, 1021, "Input",ExpressionUUID->"93d594bb-480b-4fae-8510-7ebcf775b325"]
}, Closed]],
Cell[CellGroupData[{
Cell[759103, 20371, 425, 6, 54, "Subsubsection",ExpressionUUID->"ec5dfa84-6736-4fa1-9375-6f37576d3df8"],
Cell[759531, 20379, 425, 8, 2322, "Text",ExpressionUUID->"59cc8a0f-c941-4608-a024-566ec95faf2e"],
Cell[759959, 20389, 197, 4, 1021, "Input",ExpressionUUID->"09b80266-afe8-43eb-a74b-6913a8b3cc76"],
Cell[760159, 20395, 2761, 65, 4923, "Input",ExpressionUUID->"8ddef2f8-2ad3-4d34-b267-0de910e6c1c5",
 Evaluatable->False,
 InitializationGroup->True],
Cell[762923, 20462, 187, 4, 1021, "Input",ExpressionUUID->"5b5e5411-c283-4539-b4d0-35953afbdc74"],
Cell[763113, 20468, 190, 4, 1021, "Input",ExpressionUUID->"a253a447-9b28-4979-adf6-72e31bdcff31"],
Cell[763306, 20474, 250, 6, 2418, "Input",ExpressionUUID->"a4a88655-9579-4cbd-a3ab-c5a88d577972"],
Cell[763559, 20482, 605, 13, 1021, "Input",ExpressionUUID->"d7f0b0fc-bd9c-4d5e-a8cb-9246e2de2d45"],
Cell[764167, 20497, 582, 12, 1021, "Input",ExpressionUUID->"0a47cc72-f0b4-4520-abbe-f262b8af9059"],
Cell[764752, 20511, 666, 14, 1021, "Input",ExpressionUUID->"58ca2852-c660-4a2a-94a0-1bf0b99d8da8"],
Cell[765421, 20527, 720, 15, 1021, "Input",ExpressionUUID->"b30df7eb-c5f4-4e64-b209-e31dd04c45f0"],
Cell[766144, 20544, 766, 15, 1021, "Input",ExpressionUUID->"292207b5-1cee-4ddb-8fbd-f4a0a4ecb9d3"],
Cell[766913, 20561, 177, 4, 1021, "Input",ExpressionUUID->"40e710e7-a2b3-444a-9c47-2e64639950a0"],
Cell[767093, 20567, 1374, 36, 3627, "Input",ExpressionUUID->"1896b4c5-0f04-403a-bb43-1eff0f66f150",
 Evaluatable->False,
 InitializationCell->True],
Cell[768470, 20605, 332, 6, 1021, "Input",ExpressionUUID->"3e6469de-a8a0-4922-bda5-464cd51dd39e"],
Cell[768805, 20613, 472, 11, 1021, "Input",ExpressionUUID->"077c75f8-5e98-4fe2-af00-6614986f0a4d"],
Cell[769280, 20626, 243, 5, 1021, "Input",ExpressionUUID->"dcbde185-dc95-4e3e-8f5d-fe6329f920f3"],
Cell[769526, 20633, 407, 11, 1021, "Input",ExpressionUUID->"76ccc965-aedb-4aa4-b902-953b80eaa8b8"],
Cell[769936, 20646, 262, 6, 1021, "Input",ExpressionUUID->"7d893ef1-76d0-42bd-bed4-cb6b9c32be06"],
Cell[770201, 20654, 187, 4, 1021, "Input",ExpressionUUID->"3ac2005b-ef38-40c4-a16a-d7bd184b21e0"],
Cell[770391, 20660, 282, 6, 1021, "Input",ExpressionUUID->"273d4489-900c-4285-a741-07e99afbbd25"],
Cell[770676, 20668, 187, 4, 1021, "Input",ExpressionUUID->"b3917f42-5478-4e29-a94b-059f32d967de"],
Cell[770866, 20674, 218, 5, 1021, "Input",ExpressionUUID->"0f0429ee-21ca-489f-8c5b-9061fe3c8b30"],
Cell[771087, 20681, 417, 10, 1440, "Input",ExpressionUUID->"ef696055-5789-4fe8-8bb1-aaacaa3f7b83"],
Cell[771507, 20693, 122, 2, 1021, "Input",ExpressionUUID->"5d0932f1-bc6f-435a-9447-e14aeb715424"],
Cell[771632, 20697, 180, 4, 1021, "Input",ExpressionUUID->"49f868ee-e4bc-4c69-b4ef-6680a052bc9e"],
Cell[771815, 20703, 807, 24, 2115, "Input",ExpressionUUID->"387f559c-afbe-4e2e-8612-83c1579cf0a0"],
Cell[772625, 20729, 307, 6, 1440, "Input",ExpressionUUID->"357727c3-43b7-4ed1-a4d4-58bc85b06219"],
Cell[772935, 20737, 565, 16, 1440, "Input",ExpressionUUID->"eee1a313-ce37-4eef-b653-9d5aed600530"],
Cell[773503, 20755, 636, 14, 1440, "Input",ExpressionUUID->"8170d4a6-10ba-4573-ac47-7bbcd5822bf5"],
Cell[774142, 20771, 667, 17, 1440, "Input",ExpressionUUID->"e3311be1-bb49-4ce6-9d63-334f33ccd077"],
Cell[774812, 20790, 314, 7, 1669, "Text",ExpressionUUID->"3fb609d7-d189-4c4a-89fc-fb27003c3c44"],
Cell[775129, 20799, 1692, 42, 2328, "Input",ExpressionUUID->"7124c3a4-34d8-4b74-82cd-4031d0c42d13"],
Cell[776824, 20843, 466, 12, 1021, "Input",ExpressionUUID->"f1bfd562-dc67-40a8-bcf8-3781f4ad3f55"],
Cell[777293, 20857, 221, 5, 1021, "Text",ExpressionUUID->"ec09a085-4e61-468e-95ea-928f9ad46f3d"],
Cell[777517, 20864, 471, 12, 1021, "Input",ExpressionUUID->"bf91e222-1558-4393-9150-bfddc53a9426"],
Cell[777991, 20878, 295, 8, 1440, "Input",ExpressionUUID->"36b30ff8-f5cc-4874-9fae-b4d3b86d1853"],
Cell[778289, 20888, 540, 16, 1440, "Input",ExpressionUUID->"6215334d-c30a-41c7-9fb9-31444c7c40c4"],
Cell[778832, 20906, 330, 6, 1440, "Input",ExpressionUUID->"a608f611-ed03-4374-99ef-adba65ae1e2e"],
Cell[779165, 20914, 190, 4, 1021, "Input",ExpressionUUID->"4726e8ee-b9c8-4db0-afa0-df38dafe5d4b"],
Cell[779358, 20920, 242, 4, 1021, "Text",ExpressionUUID->"9c6ac9e6-b365-47e1-83fe-dfffdf1522b0"],
Cell[779603, 20926, 240, 6, 1021, "Input",ExpressionUUID->"6d7800d9-1d2c-4e30-a834-055d7b8ec382"],
Cell[779846, 20934, 233, 6, 1021, "Input",ExpressionUUID->"c26cfdb6-703b-4972-ae9f-14e1fb02750a"],
Cell[780082, 20942, 598, 16, 1021, "Input",ExpressionUUID->"f44a37b9-81c5-4451-b2e5-d7a01420fa05"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[780741, 20965, 440, 6, 101, "Section",ExpressionUUID->"816e6119-d58b-4742-b7bd-19e91ef7e3de",
 CellTags->"S5"],
Cell[CellGroupData[{
Cell[781206, 20975, 186, 3, 81, "Subsection",ExpressionUUID->"81c59322-12d3-42eb-b992-5a58c9159822"],
Cell[781395, 20980, 473, 11, 124, "Text",ExpressionUUID->"b66bd48f-5d19-4990-a610-a0f075786cc8"],
Cell[781871, 20993, 177, 4, 73, "Input",ExpressionUUID->"e8b37c23-f7d6-479c-991c-2ca19068dc7f"],
Cell[782051, 20999, 285, 7, 75, "Text",ExpressionUUID->"2b0aa53d-5458-4397-872f-a3bffceb95ea"],
Cell[782339, 21008, 206, 4, 73, "Input",ExpressionUUID->"0d445829-c750-42ab-9d7a-d6150d4fe9a7"],
Cell[782548, 21014, 1630, 28, 612, "Text",ExpressionUUID->"69f48dce-65f9-452d-8387-a764cd2ff4ab"],
Cell[784181, 21044, 507, 14, 621, "Text",ExpressionUUID->"2063b079-7780-476c-866b-7eb655269372"],
Cell[784691, 21060, 119, 3, 256, InheritFromParent,ExpressionUUID->"bc46a97b-ff81-48f8-bb23-5e6c2724a5ef"]
}, Closed]],
Cell[CellGroupData[{
Cell[784847, 21068, 398, 6, 55, "Subsection",ExpressionUUID->"1283d220-81dc-4258-999e-16dad1daa44e"],
Cell[CellGroupData[{
Cell[785270, 21078, 179, 3, 68, "Subsubsection",ExpressionUUID->"b27a1fcf-f7f3-4ee9-b4f7-9ec533101a53"],
Cell[785452, 21083, 600, 12, 3343, "Text",ExpressionUUID->"895355cf-bda0-4ee6-a85f-31834569f2af"],
Cell[786055, 21097, 199, 4, 2047, "Input",ExpressionUUID->"712748b4-e513-4f14-a83d-246cf45b5bcd"],
Cell[786257, 21103, 535, 13, 4645, "Text",ExpressionUUID->"6e75e414-503e-4d1d-99b8-16a93ab3f307"],
Cell[786795, 21118, 179, 4, 2047, "Input",ExpressionUUID->"b054dac1-0bb4-43bf-b8fd-e50abe81650b"],
Cell[786977, 21124, 539, 12, 4645, "Text",ExpressionUUID->"53f57534-46b4-40cc-a8a9-2b412bdf440e"],
Cell[787519, 21138, 224, 5, 2047, "Input",ExpressionUUID->"4aa982e6-7614-435c-86ef-aa6c576483be",
 CellID->43782948],
Cell[787746, 21145, 134, 2, 2047, "Input",ExpressionUUID->"508ac18a-2ac1-400b-95d7-dc32003880da",
 CellID->64680695],
Cell[787883, 21149, 188, 3, 2047, "Input",ExpressionUUID->"d24f6fba-2a83-45c4-b552-cea81bcbba62"],
Cell[788074, 21154, 191, 4, 2047, "Input",ExpressionUUID->"b8a8bfe5-0e79-48d0-a079-818ac5ac43f3"],
Cell[788268, 21160, 234, 4, 2047, "Input",ExpressionUUID->"2e3ab514-0b4f-44ec-a4a8-12a32e40675f",
 CellID->89477187],
Cell[788505, 21166, 219, 5, 2047, "Input",ExpressionUUID->"6a8297de-d942-44b7-993a-b29453119102"],
Cell[788727, 21173, 533, 15, 2047, "Input",ExpressionUUID->"91e94272-117c-4e8b-bcc9-5cb469af61aa"],
Cell[789263, 21190, 671, 18, 2047, "Input",ExpressionUUID->"0511059a-1ae0-499d-b4c1-6bc4af3200c5"],
Cell[789937, 21210, 343, 9, 2047, "Input",ExpressionUUID->"f6bff126-d006-4a92-98ec-9581fe5923d7"],
Cell[790283, 21221, 205, 5, 2047, "Input",ExpressionUUID->"b190b692-e168-46bf-a54c-22f020ca2ab0"],
Cell[790491, 21228, 192, 4, 2047, "Input",ExpressionUUID->"c7866b7b-c22f-46d8-8d32-2ad49094ba72"],
Cell[790686, 21234, 231, 6, 2047, "Input",ExpressionUUID->"f715678a-2d75-475d-a095-11e44432bf33"],
Cell[790920, 21242, 561, 16, 2047, "Input",ExpressionUUID->"835d7069-d89f-4bb5-b4e2-f80ab5bee511"],
Cell[791484, 21260, 266, 6, 2047, "Input",ExpressionUUID->"43e3dc8a-1559-4721-a04f-b6b74930fe8b"],
Cell[791753, 21268, 244, 5, 2047, "Input",ExpressionUUID->"c3b51c4d-b6bb-4c60-9ce5-e1fa814da10a"],
Cell[792000, 21275, 187, 4, 2047, "Input",ExpressionUUID->"6bcfde06-34c0-4923-9f4e-0b9e16fedcb5"],
Cell[792190, 21281, 189, 4, 2047, "Input",ExpressionUUID->"d5694132-904f-4e39-84c2-0dacaaf0ad8c"],
Cell[792382, 21287, 229, 6, 2047, "Text",ExpressionUUID->"4eb11601-f6c6-4ebc-81f7-bf02575632e5"],
Cell[792614, 21295, 218, 5, 2047, "Input",ExpressionUUID->"8a758c56-e7a3-477c-a21e-60ec778cd6fe"],
Cell[792835, 21302, 267, 6, 2047, "Input",ExpressionUUID->"5d901dd9-17e9-4597-bcda-56de01a7bc5b"],
Cell[793105, 21310, 379, 9, 2047, "Input",ExpressionUUID->"c2fbc072-9803-4ff2-a78a-b2ad03801204"],
Cell[793487, 21321, 424, 9, 2047, "Input",ExpressionUUID->"a3784e33-6c9b-48e0-902a-d689a59b615d"],
Cell[793914, 21332, 370, 9, 2047, "Input",ExpressionUUID->"ba919f5e-e8c8-4976-8cc3-63f9a1fc240f"],
Cell[794287, 21343, 193, 3, 2047, "Text",ExpressionUUID->"71fa0263-283b-4d69-be56-96e8116c5b83"],
Cell[794483, 21348, 366, 10, 2047, "Input",ExpressionUUID->"09766b05-6b60-40a5-8187-3bd3876059a4"],
Cell[794852, 21360, 211, 4, 2047, "Input",ExpressionUUID->"b3a7e8ac-e34e-42e6-bc8a-c2dd41b23700"],
Cell[795066, 21366, 333, 7, 2047, "Input",ExpressionUUID->"525fd9af-dfd6-4b1b-a60d-391d6eb01ba9"],
Cell[795402, 21375, 192, 4, 2047, "Input",ExpressionUUID->"b585a300-8feb-42bb-97e8-5f32a69c7c2a"],
Cell[795597, 21381, 293, 7, 2047, "Input",ExpressionUUID->"755bd59b-bb10-4c24-92de-f48e00bbb4ee"],
Cell[795893, 21390, 356, 9, 2047, "Input",ExpressionUUID->"1f2aa66d-f71b-4d44-8e78-c2d9db9c140e"],
Cell[796252, 21401, 506, 16, 2047, "Input",ExpressionUUID->"dd13752c-0ed8-4613-91fa-93abc7ac9edf"],
Cell[796761, 21419, 188, 4, 2047, "Input",ExpressionUUID->"d424ee00-a04a-4bad-ab18-32cdf4514224"],
Cell[796952, 21425, 345, 10, 2047, "Input",ExpressionUUID->"ba9c7009-3868-4241-b668-de615e0cfd84"],
Cell[797300, 21437, 185, 4, 2047, "Input",ExpressionUUID->"62ad10aa-b846-4968-9ac2-4021aad8aa0d"],
Cell[797488, 21443, 186, 4, 2047, "Input",ExpressionUUID->"cc0f0f24-f462-4d1a-8cbc-a68f7abdeff2"]
}, Closed]],
Cell[CellGroupData[{
Cell[797711, 21452, 260, 3, 54, "Subsubsection",ExpressionUUID->"47ad86af-4360-4bbb-8ceb-3a2b871ce037",
 CellTags->"arr"],
Cell[797974, 21457, 739, 15, 4645, "Text",ExpressionUUID->"194e33da-c3cd-4467-b646-a71c2056c52d"],
Cell[798716, 21474, 184, 4, 2047, "Input",ExpressionUUID->"d15c63f5-5183-4a9e-bd4d-85a38cc8c590"],
Cell[798903, 21480, 209, 3, 2047, "Text",ExpressionUUID->"154f0296-6ec0-4398-bf88-4e3979aeef80"],
Cell[799115, 21485, 2757, 72, 13762, "Input",ExpressionUUID->"2dcbfd0c-87cf-42c7-87c4-afc767db1bbb",
 Evaluatable->False],
Cell[801875, 21559, 334, 8, 3343, "Text",ExpressionUUID->"4d66bd9b-7d49-4ea2-955e-e33c6e75088b"],
Cell[802212, 21569, 434, 8, 2047, "Input",ExpressionUUID->"97fe91cc-367f-40a4-967e-ea616410f3e7"],
Cell[802649, 21579, 186, 4, 2047, "Input",ExpressionUUID->"b46f0158-33c6-44df-9363-bcc87525b502"],
Cell[802838, 21585, 359, 7, 2047, "Input",ExpressionUUID->"7aaac2ff-5841-4f38-8d4f-f72459854469"],
Cell[803200, 21594, 369, 6, 2047, "Input",ExpressionUUID->"2c9f7364-e26d-4ee7-8318-6c799055dedf"],
Cell[803572, 21602, 280, 5, 2047, "Input",ExpressionUUID->"118272e9-5e10-4580-99c5-a65da1a202a0"],
Cell[803855, 21609, 373, 8, 2047, "Input",ExpressionUUID->"1e6fe6f9-92ca-4350-8f75-3423828fd4fa"],
Cell[804231, 21619, 340, 7, 2047, "Input",ExpressionUUID->"784ffd70-60ff-45c3-b3ae-121277eb9b17"],
Cell[804574, 21628, 323, 6, 2047, "Input",ExpressionUUID->"afb44aee-a5ec-4192-bdd5-128c000b2b73"],
Cell[804900, 21636, 226, 4, 2047, "Input",ExpressionUUID->"171e9ecc-d2a5-4da5-b4e1-2b6f3f5b3b15"],
Cell[805129, 21642, 234, 6, 2047, "Text",ExpressionUUID->"386c48b5-fd02-4f3a-bc3c-e3518b4e8f04"],
Cell[805366, 21650, 330, 8, 2047, "Input",ExpressionUUID->"bcc7cb65-4615-4360-829f-03f2ba675276"],
Cell[805699, 21660, 574, 11, 2047, "Input",ExpressionUUID->"e9669d4e-332e-4ac8-ae54-ec85b1ecba73"],
Cell[806276, 21673, 324, 7, 2047, "Input",ExpressionUUID->"bd170ab5-9baf-4b87-b1ad-6de905008770"],
Cell[806603, 21682, 586, 11, 2047, "Input",ExpressionUUID->"9337294f-077f-4bbe-a7a1-cf6ef73ddf9f"],
Cell[807192, 21695, 261, 6, 2047, "Input",ExpressionUUID->"43008d96-66d9-4417-a7cd-4fc800bc5061"],
Cell[807456, 21703, 310, 7, 2047, "Input",ExpressionUUID->"bae68ca8-cb5b-4644-bb14-56a12b342ec5"],
Cell[807769, 21712, 360, 7, 2047, "Input",ExpressionUUID->"d8eb1f80-0130-4a97-9b33-b0eefd2360eb"]
}, Closed]],
Cell[CellGroupData[{
Cell[808166, 21724, 302, 5, 54, "Subsubsection",ExpressionUUID->"3aeee520-16bb-4f84-9b4c-fa011460c978"],
Cell[808471, 21731, 186, 4, 2047, "Input",ExpressionUUID->"1d02e17d-297a-4ea4-bbee-c100bcc9d2bf"],
Cell[808660, 21737, 4540, 111, 20259, "Input",ExpressionUUID->"bc686e5c-3510-47cf-a7f2-d626aedb3ecf",
 Evaluatable->False],
Cell[813203, 21850, 207, 4, 2047, "Text",ExpressionUUID->"a0df3b80-9e38-417a-94df-388b1f2dde0d"],
Cell[813413, 21856, 186, 4, 2047, "Input",ExpressionUUID->"29914d08-c557-479d-9eea-052187e6a528"],
Cell[813602, 21862, 217, 5, 2047, "Input",ExpressionUUID->"0393e02b-1bc3-4b87-b46a-f780a48d739b"],
Cell[813822, 21869, 221, 5, 2047, "Input",ExpressionUUID->"2cba4110-1a7d-4029-a27a-a7582c100472"],
Cell[814046, 21876, 203, 5, 2047, "Input",ExpressionUUID->"5695585e-a979-4bb7-a06c-786b032b4d20"],
Cell[814252, 21883, 226, 5, 2047, "Input",ExpressionUUID->"1130b047-b004-4f1e-ac65-e0bba2d7a5c4"],
Cell[814481, 21890, 247, 5, 2047, "Input",ExpressionUUID->"ca2a0991-b93e-4888-a276-85527a305b26"],
Cell[814731, 21897, 199, 3, 2047, "Text",ExpressionUUID->"0fd989cb-d44b-473f-b17c-ff2ff77dcec1"],
Cell[814933, 21902, 316, 8, 2047, "Input",ExpressionUUID->"70b95835-2901-4bae-a552-b6136b65ef88"],
Cell[815252, 21912, 343, 7, 2047, "Input",ExpressionUUID->"f9a044d5-1a6a-4c6b-850a-c13b0d21c3c7"],
Cell[815598, 21921, 276, 7, 2047, "Input",ExpressionUUID->"b2e3507c-3292-4ce5-a82c-f4214337a954"],
Cell[815877, 21930, 429, 10, 2047, "Input",ExpressionUUID->"69716fa9-e7da-4af0-a241-f5c4736eb004"],
Cell[816309, 21942, 588, 15, 2047, "Input",ExpressionUUID->"dc51a454-0bf0-428c-b3b7-27d23da1be57"],
Cell[816900, 21959, 188, 4, 2047, "Input",ExpressionUUID->"9f84cdba-e893-4e85-bf97-4faf15eb7345"],
Cell[817091, 21965, 325, 9, 2047, "Input",ExpressionUUID->"1476ac1e-9a12-46f8-8fad-99a57654b7a8"],
Cell[817419, 21976, 287, 5, 2047, "Input",ExpressionUUID->"19d1ea5a-a9c3-4c46-b739-ab229a208a7b"],
Cell[817709, 21983, 195, 4, 2047, "Input",ExpressionUUID->"f9b88531-18d5-4ac8-8d1e-00acb0f61bdc"]
}, Closed]],
Cell[CellGroupData[{
Cell[817941, 21992, 268, 4, 54, "Subsubsection",ExpressionUUID->"cef0f896-1030-44c0-99d1-3474764d4898"],
Cell[818212, 21998, 712, 14, 2047, "Text",ExpressionUUID->"911023cd-1f4f-45cc-917e-22e59e00bf60"],
Cell[818927, 22014, 283, 6, 2047, "Text",ExpressionUUID->"12c3fb44-a852-475a-870a-221bca0f4b2a"],
Cell[819213, 22022, 878, 14, 2047, "Input",ExpressionUUID->"ea4ec0da-a4de-4677-8345-ea3bc08e6b6a"],
Cell[820094, 22038, 433, 7, 2047, "Input",ExpressionUUID->"4f8cd8e6-1b24-4743-831c-ff30b741b8b4"],
Cell[820530, 22047, 556, 11, 2047, "Input",ExpressionUUID->"fd6d372a-9911-4486-b620-717211f335e6"],
Cell[821089, 22060, 325, 6, 2047, "Text",ExpressionUUID->"09e5e6d6-e9a1-401d-9bb0-f99722c5d668"],
Cell[821417, 22068, 424, 8, 2047, "Input",ExpressionUUID->"c63ef6e8-00ea-492b-9f1a-f18db406bd40"],
Cell[821844, 22078, 186, 4, 2047, "Input",ExpressionUUID->"87d220bc-d4aa-4985-9c65-5fd40f5c843f"],
Cell[822033, 22084, 326, 8, 2047, "Input",ExpressionUUID->"0fd52130-3c74-4076-ab2a-6fcc544b9a1a"],
Cell[822362, 22094, 187, 4, 2047, "Input",ExpressionUUID->"9e16150e-2e94-4ca3-bbda-72b4d8c44d2c"],
Cell[822552, 22100, 328, 8, 2047, "Input",ExpressionUUID->"d3118bfb-73e3-4c17-be2f-c0f1bd178cd1"],
Cell[822883, 22110, 156, 3, 2047, "Text",ExpressionUUID->"5ae802f3-6b10-41c8-87ff-84be763bfc43"],
Cell[823042, 22115, 505, 10, 2047, "Input",ExpressionUUID->"6821c89b-531e-46a6-aeae-a1329f1c03ba"],
Cell[823550, 22127, 186, 4, 2047, "Input",ExpressionUUID->"2ca9cda0-4449-4329-8ab7-3745420168e8"],
Cell[823739, 22133, 326, 8, 2047, "Input",ExpressionUUID->"3cb7b79b-a180-4ec1-b499-e9a578b77d26"],
Cell[824068, 22143, 215, 5, 2047, "Input",ExpressionUUID->"76a63c76-0df7-46ef-bcc3-a73b5a4c4ce6"],
Cell[824286, 22150, 213, 4, 2047, "Input",ExpressionUUID->"3dadccd0-1eb4-4844-9c9d-62cfce7b6863"],
Cell[824502, 22156, 217, 4, 2047, "Text",ExpressionUUID->"cc48affe-8e00-4755-8f32-b70a2aba131c"],
Cell[824722, 22162, 294, 8, 2047, "Input",ExpressionUUID->"e596c85a-e285-462b-852f-e35e326328bd"],
Cell[825019, 22172, 342, 7, 2047, "Input",ExpressionUUID->"fbd6218e-0dad-45c3-9f90-c7f63d47d6fe"],
Cell[825364, 22181, 293, 8, 2047, "Input",ExpressionUUID->"f78a49fd-4b85-41fc-99bb-4ef1fb59573a"],
Cell[825660, 22191, 246, 5, 11616, "Input",ExpressionUUID->"0e767d05-e084-4a8e-acc5-13aaa3fbeb3f"],
Cell[825909, 22198, 180, 3, 2047, "Text",ExpressionUUID->"6f113ffc-ea47-4efc-b50e-711b885a6782"],
Cell[826092, 22203, 186, 4, 2047, "Input",ExpressionUUID->"9e11cb4c-c6de-43ed-828d-af9113b38265"],
Cell[826281, 22209, 212, 5, 2047, "Input",ExpressionUUID->"eb892a7f-f0ba-49d1-b7b7-7f469c7b7fcb"],
Cell[826496, 22216, 321, 6, 2047, "Text",ExpressionUUID->"e83717ca-6616-41d5-b792-60a40553fd3d"],
Cell[826820, 22224, 479, 12, 2047, "Input",ExpressionUUID->"9a8c48be-314e-4ba8-a528-9ddc72901f4f"],
Cell[827302, 22238, 459, 9, 2047, "Input",ExpressionUUID->"3828dca4-06bb-4ade-90fb-279af143c57c"],
Cell[827764, 22249, 654, 17, 2047, "Input",ExpressionUUID->"d4328551-abaf-47ff-a482-085f5b2f8251"],
Cell[828421, 22268, 641, 15, 2047, "Input",ExpressionUUID->"b096f51b-d31b-4bb6-b306-1f7d20d53fa3"],
Cell[829065, 22285, 192, 4, 2047, "Input",ExpressionUUID->"f15d9823-d827-40d9-8397-d574f2fd682e"],
Cell[829260, 22291, 256, 6, 2047, "Text",ExpressionUUID->"815529ff-fcce-446f-b9f1-e4e0bb592416"],
Cell[829519, 22299, 769, 15, 2047, "Input",ExpressionUUID->"b4a45b70-1f3c-4cc5-9d53-1792213200e5"],
Cell[830291, 22316, 184, 4, 2047, "Input",ExpressionUUID->"b67cfe19-7dda-486d-96eb-a8b6adf91434"],
Cell[830478, 22322, 304, 9, 2047, "Input",ExpressionUUID->"082a7363-db8b-450d-8b68-6877c87069d8"],
Cell[830785, 22333, 206, 3, 2047, "Text",ExpressionUUID->"e748f933-01bb-48cd-afcf-ee0fc4112faa"],
Cell[830994, 22338, 1065, 25, 3375, "Input",ExpressionUUID->"e7f423dd-fc23-431a-84b9-1078eb070182"],
Cell[832062, 22365, 200, 3, 2047, "Text",ExpressionUUID->"65cfb6b9-8358-4772-aeb8-56452174abf5"],
Cell[832265, 22370, 796, 19, 2047, "Input",ExpressionUUID->"2c5aa1da-ba89-474e-9a90-f9efee23d4a6"],
Cell[833064, 22391, 249, 4, 2047, "Text",ExpressionUUID->"4ac994d3-a2a0-472f-b3c7-04db6c5aaa19"],
Cell[833316, 22397, 853, 20, 2047, "Input",ExpressionUUID->"0132321a-9493-4fe6-8b3c-6a87aad219e8"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[834218, 22423, 177, 3, 81, "Subsection",ExpressionUUID->"acbea2f6-0800-48b1-b3a5-2b26f53c247b"],
Cell[834398, 22428, 277, 5, 75, "Text",ExpressionUUID->"6554ec1e-367b-403f-a1ea-88a4a3f0f9be"],
Cell[834678, 22435, 227, 6, 73, "Input",ExpressionUUID->"30ecc843-1edb-4a17-a25f-7e5f950fbf32"],
Cell[834908, 22443, 481, 9, 73, "Input",ExpressionUUID->"2a52fb3b-3676-4b79-9e23-5437df4402ac"],
Cell[835392, 22454, 411, 12, 73, "Input",ExpressionUUID->"e62d24ca-907e-46e5-8f57-799a45d32604"],
Cell[835806, 22468, 271, 6, 73, "Input",ExpressionUUID->"aae35400-4072-48a1-a048-bcc11b3a0464"],
Cell[836080, 22476, 298, 7, 337, "Input",ExpressionUUID->"21345bab-3df4-42a1-81ee-83143f8610ab"],
Cell[836381, 22485, 216, 5, 337, "Input",ExpressionUUID->"ccd02f8d-55f5-492d-8d40-2df6596abb70"],
Cell[836600, 22492, 785, 23, 567, "Input",ExpressionUUID->"2a8ef76f-c2ad-481d-b617-93877f38c6ab"],
Cell[837388, 22517, 246, 6, 621, "Text",ExpressionUUID->"172bb8d6-8be6-44fd-a9bc-258a092306f4"],
Cell[837637, 22525, 176, 4, 337, "Input",ExpressionUUID->"82d1df50-92ad-4846-ba11-7a5173ca4fd3"],
Cell[837816, 22531, 592, 14, 2047, "Input",ExpressionUUID->"e5186c47-4209-41c7-82b0-2f6d20552846"],
Cell[838411, 22547, 230, 3, 2047, "Text",ExpressionUUID->"3477e99d-620f-47cf-8f91-f3e2a43150b5"],
Cell[838644, 22552, 477, 10, 2047, "Input",ExpressionUUID->"df388819-b467-46f4-ac8c-a47940131992"],
Cell[839124, 22564, 929, 22, 789, "Input",ExpressionUUID->"1e21214b-0a0b-4069-a36a-00b2d5ea2eaa"],
Cell[840056, 22588, 396, 8, 337, "Input",ExpressionUUID->"8949836d-46a8-4bed-a242-914566b50a7f"],
Cell[840455, 22598, 187, 4, 337, "Input",ExpressionUUID->"04d59182-4712-408c-8dad-96af9f27db79"],
Cell[840645, 22604, 631, 12, 337, "Input",ExpressionUUID->"617e6e54-a8bc-4df1-9223-5e808785f997"],
Cell[841279, 22618, 189, 4, 337, "Input",ExpressionUUID->"0395cbbe-6108-4550-b611-65deb7df0940"],
Cell[841471, 22624, 813, 19, 337, "Input",ExpressionUUID->"b2b904a8-b9d3-4621-bff5-b10dfd420568"],
Cell[842287, 22645, 305, 7, 337, "Input",ExpressionUUID->"c94d9440-0f23-49bf-9baa-bfa637156597"],
Cell[842595, 22654, 185, 4, 337, "Input",ExpressionUUID->"caba59f7-620a-46ba-8117-5f5fd549daeb"],
Cell[842783, 22660, 264, 4, 366, "Text",ExpressionUUID->"b2d6e3aa-9377-4e16-9a30-5e3d5e944016"],
Cell[843050, 22666, 308, 7, 337, "Input",ExpressionUUID->"c5052a9a-2496-4e49-830a-b79da30d95c1"],
Cell[843361, 22675, 322, 8, 337, "Input",ExpressionUUID->"ecefd6b6-bb82-4074-b86b-046c8a54050b"],
Cell[843686, 22685, 376, 7, 337, "Input",ExpressionUUID->"8962efbb-b0aa-4be2-a369-ba58e70e996c"],
Cell[844065, 22694, 530, 16, 337, "Input",ExpressionUUID->"3cc9a7be-4e23-4087-a731-03b77da40684"],
Cell[844598, 22712, 259, 6, 337, "Input",ExpressionUUID->"a20578c3-819d-4095-983c-824eaedd6dc7"]
}, Closed]],
Cell[CellGroupData[{
Cell[844894, 22723, 355, 5, 55, "Subsection",ExpressionUUID->"0f53f926-4f9b-42a5-a686-91d43886e082",
 CellTags->"TP"],
Cell[845252, 22730, 479, 8, 222, "Text",ExpressionUUID->"4cd7a1f6-32db-48b5-88cf-f0817e541dad"],
Cell[845734, 22740, 456, 11, 73, "Input",ExpressionUUID->"97e5515f-59a7-4c98-bea1-a668c3470723"],
Cell[846193, 22753, 373, 10, 366, "Text",ExpressionUUID->"7eebd6da-408e-4bf9-898e-5598eaa09ea9"],
Cell[846569, 22765, 253, 5, 337, "Input",ExpressionUUID->"44e99be3-92f5-43ac-a03c-991a2736a417"],
Cell[846825, 22772, 327, 6, 337, "Input",ExpressionUUID->"b8550cb5-fb52-47d7-807b-671932b716c5"],
Cell[847155, 22780, 265, 6, 621, "Text",ExpressionUUID->"e316ab2c-d235-4c28-942d-02e760753849"],
Cell[847423, 22788, 785, 14, 337, "Input",ExpressionUUID->"a36db503-bb9d-4619-9c87-8647b6d7afe8"],
Cell[848211, 22804, 295, 5, 337, "Input",ExpressionUUID->"77e1b010-c4b1-453e-900c-1d9e26c28d53"],
Cell[848509, 22811, 312, 8, 337, "Input",ExpressionUUID->"4a7b885e-3c39-49b5-b2ff-fde85faa1a71"],
Cell[848824, 22821, 185, 3, 2047, "Text",ExpressionUUID->"57d9d3f3-fb3b-4dfb-a26c-8c9d4ae4a013"],
Cell[849012, 22826, 302, 7, 2047, "Input",ExpressionUUID->"b0886ee4-bdab-4f3e-8012-a0ba013df491"],
Cell[849317, 22835, 169, 3, 2047, "Text",ExpressionUUID->"28ef4e28-94c4-434e-b0fc-0095f32394f5"],
Cell[849489, 22840, 254, 6, 2047, "Input",ExpressionUUID->"f0941cae-6fae-4f8b-88e3-47fc7b9b1184"],
Cell[849746, 22848, 314, 9, 2047, "Input",ExpressionUUID->"fe77b9f8-00f5-41a0-8a85-30ea05ce2574"],
Cell[850063, 22859, 160, 3, 2047, "Text",ExpressionUUID->"521c6c5c-f06f-41a6-8e7b-dce6d91b78de"],
Cell[850226, 22864, 315, 9, 2047, "Input",ExpressionUUID->"bc1f14b4-aaee-46a2-b637-0600e8e195c1"],
Cell[850544, 22875, 216, 4, 2047, "Text",ExpressionUUID->"af14d802-1437-4b67-bbf4-941a46237c17"],
Cell[850763, 22881, 213, 5, 2047, "Input",ExpressionUUID->"fb907e36-7287-4bec-83c8-fe87a25c27bc"],
Cell[850979, 22888, 235, 4, 2047, "Text",ExpressionUUID->"42ecce35-9831-4dd3-8938-988407c91aa2"],
Cell[851217, 22894, 349, 7, 2047, "Input",ExpressionUUID->"bf2c1299-5a7c-4d65-973e-8cbfc9845c02"],
Cell[851569, 22903, 204, 4, 2047, "Input",ExpressionUUID->"8279ca96-a7fa-45a2-b0ca-463e4abda175"],
Cell[851776, 22909, 277, 6, 2047, "Input",ExpressionUUID->"57185404-c503-4727-8cfc-dd7fdf938957"],
Cell[852056, 22917, 266, 7, 2047, "Input",ExpressionUUID->"5cfbc259-22e9-4a8c-a60d-2e7ac0eef275"],
Cell[852325, 22926, 244, 4, 2047, "Text",ExpressionUUID->"ae21114a-a0a4-4697-a599-b3326023f874"],
Cell[852572, 22932, 260, 6, 2047, "Input",ExpressionUUID->"dc0e87e1-4f06-4999-9241-049b719cd078"],
Cell[852835, 22940, 246, 4, 2047, "Text",ExpressionUUID->"839d8568-4b83-4ef4-bafe-b744c509bb41"],
Cell[853084, 22946, 683, 15, 337, "Input",ExpressionUUID->"9224bdd6-7a43-4731-b250-34e2e0c800dd"],
Cell[853770, 22963, 752, 17, 567, "Input",ExpressionUUID->"4930c605-10a8-4e95-9a65-e9076624263f"],
Cell[854525, 22982, 357, 7, 864, "Text",ExpressionUUID->"cfa1bb1e-3778-4964-992e-47c5a918f898"],
Cell[854885, 22991, 540, 14, 567, "Input",ExpressionUUID->"75d78898-24cb-48dc-8ef9-cb5a1aae1906"],
Cell[855428, 23007, 420, 10, 567, "Input",ExpressionUUID->"7e1516fc-6691-4285-8874-42d333589bf2"],
Cell[855851, 23019, 256, 6, 337, "Input",ExpressionUUID->"3cfe2e23-e0bf-4553-b8f6-1aa288a2b829"],
Cell[856110, 23027, 309, 9, 337, "Input",ExpressionUUID->"e8c0d8bd-ede1-4d86-8aa8-079c6a76f8f0"],
Cell[856422, 23038, 265, 7, 337, "Input",ExpressionUUID->"aa424142-3055-4348-8a16-00f3794711e1"],
Cell[856690, 23047, 230, 5, 337, "Input",ExpressionUUID->"a4cf9e61-18e0-4f1c-9202-f36c404e7998"],
Cell[856923, 23054, 213, 5, 337, "Input",ExpressionUUID->"bf665538-41ae-47de-8853-12aa11000add"]
}, Closed]],
Cell[CellGroupData[{
Cell[857173, 23064, 305, 4, 55, "Subsection",ExpressionUUID->"53514b10-1a0e-42e7-8e65-92a779b00cd5",
 CellTags->"TC"],
Cell[857481, 23070, 1000, 18, 4645, "Text",ExpressionUUID->"86bc60b5-96cb-400e-bee6-6d9be4f5cd24"],
Cell[858484, 23090, 238, 6, 2047, "Text",ExpressionUUID->"2a19f147-6c7c-4701-84e3-dc57631b2e5f"],
Cell[858725, 23098, 448, 10, 2047, "Input",ExpressionUUID->"d2c1d9c4-05ef-4ceb-a15e-a5630eabe1ad"],
Cell[859176, 23110, 353, 9, 2047, "Input",ExpressionUUID->"c172697a-daca-4ba5-bbcf-3c461429d6b3"],
Cell[859532, 23121, 202, 3, 2047, "Text",ExpressionUUID->"a83cc845-1ac7-4aa7-8d9c-e3e9dda2eb02"],
Cell[859737, 23126, 275, 6, 2047, "Input",ExpressionUUID->"e8eaa82d-b5f5-4f79-b1b1-2fcd9687597f"],
Cell[860015, 23134, 403, 9, 2047, "Input",ExpressionUUID->"524b07fa-8962-4e29-b4d0-ec9a2e7e3757"],
Cell[860421, 23145, 303, 4, 2047, "Text",ExpressionUUID->"6cd029d6-3728-4fc5-b491-3a8fd9cc527f"],
Cell[860727, 23151, 612, 15, 2047, "Input",ExpressionUUID->"a369888b-cb0d-41ad-9c6b-4c441e53843a"],
Cell[861342, 23168, 261, 6, 3343, "Text",ExpressionUUID->"8e6cedea-6a3a-4f06-be2e-fb142ec83e41"],
Cell[861606, 23176, 456, 13, 2047, "Input",ExpressionUUID->"c6b9e58f-0063-4e24-b2c2-dc6aafb01f23"],
Cell[862065, 23191, 231, 5, 2047, "Input",ExpressionUUID->"38b8fc5a-ec3f-456e-b3e1-10a230e8646b"],
Cell[862299, 23198, 199, 4, 2047, "Input",ExpressionUUID->"5616cf04-159d-4394-bec4-f66345b9429a"],
Cell[862501, 23204, 244, 6, 2047, "Text",ExpressionUUID->"5bc4f9e0-c282-4893-8d30-13af259039a4"],
Cell[862748, 23212, 267, 7, 2047, "Input",ExpressionUUID->"6fffe628-d7e0-400c-be02-7ec09b591b96"],
Cell[863018, 23221, 293, 7, 2047, "Text",ExpressionUUID->"61e365b6-c401-44a2-84ef-86a3f9b2c073"],
Cell[863314, 23230, 274, 7, 2047, "Input",ExpressionUUID->"2d4722a6-24c6-49a6-9cd8-1dbd22c8d18b"],
Cell[863591, 23239, 301, 7, 3343, "Text",ExpressionUUID->"761d9914-2924-4f52-875e-4bb06d235715"]
}, Closed]],
Cell[CellGroupData[{
Cell[863929, 23251, 280, 4, 55, "Subsection",ExpressionUUID->"02637169-1f5b-43d7-b7b5-76bed1189f1d",
 CellTags->"TW"],
Cell[864212, 23257, 182, 4, 47, "Input",ExpressionUUID->"38714505-e7fc-435c-9270-76800a6b2a8a"],
Cell[864397, 23263, 419, 8, 54, "Text",ExpressionUUID->"ec5fa88f-8610-4c25-953d-4ce93d1f8250"],
Cell[864819, 23273, 157, 3, 47, "Input",ExpressionUUID->"68ad1b89-9d97-4c11-bf6a-4d956f822ace"],
Cell[864979, 23278, 242, 6, 90, "Text",ExpressionUUID->"4afbdcbb-85a9-4725-b927-292387521765"],
Cell[865224, 23286, 583, 13, 47, "Input",ExpressionUUID->"5ceba812-41d8-4954-a162-6f71cc331659"],
Cell[865810, 23301, 242, 4, 54, "Text",ExpressionUUID->"35a957ff-e41d-4079-9482-d2d0b7a3a143"],
Cell[866055, 23307, 244, 6, 47, "Input",ExpressionUUID->"c960d7ff-ceae-4965-b360-c05f414d843d"],
Cell[866302, 23315, 180, 3, 54, "Text",ExpressionUUID->"d5dcf5bf-fba8-4e5e-abed-1484ed59c31c"],
Cell[866485, 23320, 345, 7, 47, "Input",ExpressionUUID->"fb5a0ed2-7476-4d61-932d-e9d55b066962"],
Cell[866833, 23329, 350, 7, 47, "Input",ExpressionUUID->"84e89565-9e53-4a7c-ab50-f8d8b02c5799"],
Cell[867186, 23338, 253, 6, 337, "Input",ExpressionUUID->"af4bee89-4d6b-4af5-a474-6039db71923c"],
Cell[867442, 23346, 277, 4, 2047, "Text",ExpressionUUID->"2eada8a3-e4ce-49da-80ba-a4818ddc5ba1"],
Cell[867722, 23352, 277, 6, 2047, "Input",ExpressionUUID->"dcd75e9c-0f1d-4514-913c-1514b39e106a"],
Cell[868002, 23360, 290, 7, 2047, "Text",ExpressionUUID->"8d4bd985-cb5c-44c2-a51a-16dd1fc9e8aa"],
Cell[868295, 23369, 190, 4, 2047, "Input",ExpressionUUID->"f33e9da6-b9d5-4c63-bcfd-c9bbe31cbc1f"],
Cell[868488, 23375, 235, 6, 2047, "Text",ExpressionUUID->"f88f5d65-de2b-46bd-97ff-7a3f51ab0703"],
Cell[868726, 23383, 765, 13, 337, "Input",ExpressionUUID->"0058b91d-c684-4d74-82c4-fd7c65477f8b"],
Cell[869494, 23398, 393, 8, 621, "Text",ExpressionUUID->"b285c586-9b66-4749-b7cd-31b71bd9b953"],
Cell[869890, 23408, 512, 12, 47, "Input",ExpressionUUID->"c669d1e9-f5b0-4183-9234-47671baf463f"],
Cell[870405, 23422, 247, 6, 47, "Input",ExpressionUUID->"273e7d79-8c3c-491e-882f-043f3975f4f4"],
Cell[870655, 23430, 268, 6, 90, "Text",ExpressionUUID->"11bc2805-6e67-4cb9-bc6e-70af0dd811ca"],
Cell[870926, 23438, 398, 8, 47, "Input",ExpressionUUID->"b971912e-ccf8-48ee-8e67-bb2151d48686"],
Cell[871327, 23448, 400, 8, 47, "Input",ExpressionUUID->"ea235cc2-3ce6-44f8-9260-d23cbed27051"],
Cell[871730, 23458, 275, 5, 54, "Text",ExpressionUUID->"b74a2f48-5d9d-41c4-8625-32f1b342a695"],
Cell[872008, 23465, 275, 6, 47, "Input",ExpressionUUID->"e30cbcba-50f9-4899-83e8-331a277e852f"],
Cell[872286, 23473, 225, 5, 47, "Input",ExpressionUUID->"b7ee11f0-4b07-4db5-a972-b1830a40af91"],
Cell[872514, 23480, 287, 6, 47, "Input",ExpressionUUID->"18fadbef-36da-401f-8995-7772426b8d18"],
Cell[872804, 23488, 231, 5, 47, "Input",ExpressionUUID->"49c7dcbf-88c8-4f9f-aefa-e8ad064e5945"],
Cell[873038, 23495, 419, 8, 90, "Text",ExpressionUUID->"ec261930-d393-4719-9f58-f960d7710baa"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[873506, 23509, 372, 5, 45, "Subsubtitle",ExpressionUUID->"dcff7141-3fda-43e7-816a-feea669bfee8"],
Cell[873881, 23516, 289, 7, 54, "Text",ExpressionUUID->"07158bbf-7514-4ffc-8d5d-a36c400a51d5",
 CellTags->"Tensors"],
Cell[874173, 23525, 172, 3, 54, "Text",ExpressionUUID->"0c2dfd39-3e7b-46d9-a412-2b495483af4e",
 CellTags->"Mal"],
Cell[874348, 23530, 495, 9, 90, "Text",ExpressionUUID->"c8a58e2b-e7b2-491a-8445-e4d669bf6b0a",
 CellTags->"OSI"],
Cell[874846, 23541, 454, 8, 90, "Text",ExpressionUUID->"a046d2e2-47b8-481f-a44e-5bdf15f33753",
 CellTags->"OSII"],
Cell[875303, 23551, 785, 18, 90, "Text",ExpressionUUID->"40bd1656-b30a-4685-a8c2-6afb306fc0ad",
 CellTags->"OSIII"],
Cell[876091, 23571, 612, 12, 125, "Text",ExpressionUUID->"0d5387f7-184a-4480-a7b3-e51cbd402d23",
 CellTags->"Soleng"],
Cell[876706, 23585, 555, 13, 54, "Text",ExpressionUUID->"e80158ec-1981-4f66-bb90-ad87c56a276e",
 CellTags->"Christ"],
Cell[877264, 23600, 616, 16, 90, "Text",ExpressionUUID->"f719c968-f876-47ad-9a77-6afb722b1749",
 CellTags->"OpF"]
}, Closed]],
Cell[CellGroupData[{
Cell[877917, 23621, 180, 2, 45, "Subsubtitle",ExpressionUUID->"903d8800-2412-4d58-97db-47697786a03d"],
Cell[878100, 23625, 340, 9, 51, "Text",ExpressionUUID->"d5cd6b6a-3420-4f7e-80ab-7f2bc2e58319",
 CellTags->"hp"],
Cell[878443, 23636, 146, 2, 51, "Text",ExpressionUUID->"a27a87a2-20e4-464b-b1d5-93a121feb72d",
 CellTags->"address"]
}, Open  ]]
}, Open  ]]
}
]
*)

